a:2:{s:4:"file";a:0:{}s:5:"class";a:9:{s:4:"name";s:9:"AmazonELB";s:4:"file";s:22:"services/elb.class.php";s:3:"url";s:23:"../amazonelb/index.html";s:11:"description";s:1546:"<p>Elastic Load Balancing is a cost-effective and easy to use web service to help you improve
availability and scalability of your application. It makes it easy for you to distribute
application loads between two or more EC2 instances. Elastic Load Balancing enables
availability through redundancy and supports traffic growth of your application.</p>

<p>This guide provides detailed information about Elastic Load Balancing actions, data types,
parameters, and errors.</p>

<p>Query requests are HTTP or HTTPS requests that use the HTTP verb GET or POST and a Query
parameter named Action or Operation. Action is used throughout this documentation, although
Operation is supported for backward compatibility with other AWS Query APIs.</p>

<p>This reference guide is based on the current WSDL, which is available at: <a href=
"elasticloadbalancing.amazonaws.com/doc/2012-06-01/ElasticLoadBalancing.wsdl"></p>

<p>For detailed information on constructing a query request using the actions, data types, and
parameters mentioned in this guide, go to<a href=
"http://docs.amazonwebservices.com/ElasticLoadBalancing/latest/DeveloperGuide/using-query-api.html">Using
the Query API</a> in the <em>Elastic Load Balancing Developer Guide</em>.</p>

<p>For detailed information about Elastic Load Balancing features and their associated API calls,
go to <a href=
"http://docs.amazonwebservices.com/ElasticLoadBalancing/latest/DeveloperGuide/UserScenarios.html">
Using Elastic Load Balancing</a> in the <em>Elastic Load Balancing Developer Guide</em>.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2013.01.14";s:7:"license";s:57:"See the included NOTICE.md file for complete information.";s:9:"copyright";s:57:"See the included NOTICE.md file for complete information.";s:4:"link";a:2:{i:0;s:66:"http://aws.amazon.com/elasticloadbalancing/ Elastic Load Balancing";i:1;s:94:"http://aws.amazon.com/elasticloadbalancing/documentation/ Elastic Load Balancing documentation";}}s:11:"inheritance";a:1:{s:5:"class";a:3:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";s:3:"url";s:23:"../cfruntime/index.html";}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"53";}s:6:"method";a:49:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:132:"<p>Constructs a new instance of <a href="../amazonelb/index.html" rel="../../index.html#i=amazonelb"><code>AmazonELB</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1569:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonelb/set_cache_config.html" rel="../../index.html#m=amazonelb/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:228:"public function __construct(array $options = array())
{
    $this-&gt;api_version = '2012-06-01';
    $this-&gt;hostname = self::DEFAULT_URL;
    $this-&gt;auth_class = 'AuthV4Query';

    return parent::__construct($options);
}";}i:1;a:8:{s:4:"name";s:23:"allow_hostname_override";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:170:"<p>Disables any subsequent use of the <a href="../amazonelb/set_hostname.html" rel="../../index.html#m=amazonelb/set_hostname"><code>set_hostname()</code></a> method.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"override";s:4:"type";s:7:"boolean";s:11:"description";s:398:"<p>Whether or not subsequent calls to <a href="../amazonelb/set_hostname.html" rel="../../index.html#m=amazonelb/set_hostname"><code>set_hostname()</code></a> should be obeyed. A <code>false</code> value disables the further effectiveness of <a href="../amazonelb/set_hostname.html" rel="../../index.html#m=amazonelb/set_hostname"><code>set_hostname()</code></a>. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:124:"public function allow_hostname_override($override = true)
{
    $this-&gt;override_hostname = $override;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:2;a:6:{s:4:"name";s:38:"apply_security_groups_to_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:161:"<p>Associates one or more security groups with your LoadBalancer in VPC. The provided security
group IDs will override any currently applied security groups.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"security_groups";s:4:"type";s:12:"string|array";s:11:"description";s:260:"<p>A list of security group IDs to associate with your LoadBalancer in VPC. The security group IDs must be provided as the ID and not the security group name (For example, sg-1234). Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:487:"public function apply_security_groups_to_load_balancer($load_balancer_name, $security_groups, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'SecurityGroups' =&gt; (is_array($security_groups) ? $security_groups : array($security_groups))
    ), 'member'));

    return $this-&gt;authenticate('ApplySecurityGroupsToLoadBalancer', $opt);
}";}i:3;a:6:{s:4:"name";s:31:"attach_load_balancer_to_subnets";s:8:"modifier";s:6:"public";s:11:"description";s:188:"<p>Adds one or more subnets to the set of configured subnets in the VPC for the LoadBalancer.</p>

<p>The Loadbalancers evenly distribute requests across all of the registered subnets.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"subnets";s:4:"type";s:12:"string|array";s:11:"description";s:131:"<p>A list of subnet IDs to add for the LoadBalancer. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:435:"public function attach_load_balancer_to_subnets($load_balancer_name, $subnets, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'Subnets' =&gt; (is_array($subnets) ? $subnets : array($subnets))
    ), 'member'));

    return $this-&gt;authenticate('AttachLoadBalancerToSubnets', $opt);
}";}i:4;a:7:{s:4:"name";s:12:"authenticate";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:69:"<p>Default, shared method for authenticating a connection to AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"operation";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>Indicates the operation to perform.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"payload";s:4:"type";s:5:"array";s:11:"description";s:106:"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.</p>";}}}s:11:"returnvalue";s:48:"<p>Object containing a parsed HTTP response.</p>";s:6:"source";s:6988:"public function authenticate($operation, $payload)
{
    $original_payload = $payload;
    $method_arguments = func_get_args();
    $curlopts = array();
    $return_curl_handle = false;

    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)
    {
        $operation = $this-&gt;operation_prefix . $operation;
    }

    // Extract the custom CURLOPT settings from the payload
    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))
    {
        $curlopts = $payload['curlopts'];
        unset($payload['curlopts']);
    }

    // Determine whether the response or curl handle should be returned
    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))
    {
        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;
        unset($payload['returnCurlHandle']);
    }

    // Use the caching flow to determine if we need to do a round-trip to the server.
    if ($this-&gt;use_cache_flow)
    {
        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);

        // Parse the XML body
        $data = $this-&gt;parse_callback($data);

        // End!
        return $data;
    }

    /*%******************************************************************************************%*/

    // Signer
    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);
    $signer-&gt;key = $this-&gt;key;
    $signer-&gt;secret_key = $this-&gt;secret_key;
    $signer-&gt;auth_token = $this-&gt;auth_token;
    $signer-&gt;api_version = $this-&gt;api_version;
    $signer-&gt;utilities_class = $this-&gt;utilities_class;
    $signer-&gt;request_class = $this-&gt;request_class;
    $signer-&gt;response_class = $this-&gt;response_class;
    $signer-&gt;use_ssl = $this-&gt;use_ssl;
    $signer-&gt;proxy = $this-&gt;proxy;
    $signer-&gt;util = $this-&gt;util;
    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;
    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;
    $request = $signer-&gt;authenticate();

    // Update RequestCore settings
    $request-&gt;request_class = $this-&gt;request_class;
    $request-&gt;response_class = $this-&gt;response_class;
    $request-&gt;ssl_verification = $this-&gt;ssl_verification;

    /*%******************************************************************************************%*/

    // Debug mode
    if ($this-&gt;debug_mode)
    {
        $request-&gt;debug_mode = $this-&gt;debug_mode;
    }

    // Set custom CURLOPT settings
    if (count($curlopts))
    {
        $request-&gt;set_curlopts($curlopts);
    }

    // Manage the (newer) batch request API or the (older) returnCurlHandle setting.
    if ($this-&gt;use_batch_flow)
    {
        $handle = $request-&gt;prep_request();
        $this-&gt;batch_object-&gt;add($handle);
        $this-&gt;use_batch_flow = false;

        return $handle;
    }
    elseif ($return_curl_handle)
    {
        return $request-&gt;prep_request();
    }

    // Send!
    $request-&gt;send_request();

    // Prepare the response.
    $headers = $request-&gt;get_response_header();
    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;

    if (isset($signer-&gt;canonical_request))
    {
        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;
    }

    $headers['x-aws-request-headers'] = $request-&gt;request_headers;
    $headers['x-aws-body'] = $signer-&gt;querystring;

    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());

    $response_body = (string) $request-&gt;get_response_body();

    // Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.
    if (
        (integer) $request-&gt;get_response_code() === 500 || // Internal Error (presumably transient)
        (integer) $request-&gt;get_response_code() === 503)   // Service Unavailable (presumably transient)
    {
        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)
        {
            // Exponential backoff
            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);
            usleep($delay);
            $this-&gt;redirects++;
            $data = $this-&gt;authenticate($operation, $original_payload);
        }
    }

    // DynamoDB has additional, custom logic for retrying requests
    else
    {
        // If the request to DynamoDB was throttled, we need to retry
        $need_to_retry_dynamodb_request = (
            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;
            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;
            stripos($response_body, 'ProvisionedThroughputExceededException') !== false
        );

        // If the CRC32 of the response does not match the expected value, we need to retry
        $response_headers = $request-&gt;get_response_header();
        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))
        {
            $crc32_expected = $response_headers['x-amz-crc32'];
            $crc32_actual = hexdec(hash('crc32b', $response_body));
            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);
        }

        // Perform retry if necessary using a more aggressive exponential backoff
        if ($need_to_retry_dynamodb_request)
        {
            if ($this-&gt;redirects === 0)
            {
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))
            {
                // Exponential backoff
                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);
                usleep($delay);
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
        }
    }

    $this-&gt;redirects = 0;
    return $data;
}";}i:5;a:8:{s:4:"name";s:5:"batch";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:86:"<p>Specifies that the intended request should be queued for a later batch request.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"queue";s:4:"type";s:14:"CFBatchRequest";s:11:"description";s:327:"<p>The <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a> instance to use for managing batch requests. If not available, it generates a new instance of <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:477:"public function batch(CFBatchRequest &amp;$queue = null)
{
    if ($queue)
    {
        $this-&gt;batch_object = $queue;
    }
    elseif ($this-&gt;internal_batch_object)
    {
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }
    else
    {
        $this-&gt;internal_batch_object = new $this-&gt;batch_class();
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }

    $this-&gt;use_batch_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:6;a:8:{s:4:"name";s:5:"cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:323:"<p>Specifies that the resulting <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object should be cached according to the settings from
<a href="../amazonelb/set_cache_config.html" rel="../../index.html#m=amazonelb/set_cache_config"><code>set_cache_config()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"expires";s:4:"type";s:14:"string|integer";s:11:"description";s:232:"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href="http://php.net/strtotime"><code>strtotime()</code></a> (e.g. &#8220;1 hour&#8221;).</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:501:"public function cache($expires)
{
    // Die if they haven't used set_cache_config().
    if (!$this-&gt;cache_class)
    {
        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');
    }

    if (is_string($expires))
    {
        $expires = strtotime($expires);
        $this-&gt;cache_expires = $expires - time();
    }
    elseif (is_int($expires))
    {
        $this-&gt;cache_expires = $expires;
    }

    $this-&gt;use_cache_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:5:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:2;a:4:{s:5:"title";s:70:"<p>Fire a single request, and then cache the response to Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:338:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:3;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:4;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:7;a:7:{s:4:"name";s:34:"cache_instance_profile_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:139:"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to
be manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:2563:"public function cache_instance_profile_credentials($cache, $options)
{
    $instance_profile_url = 'http://169.254.169.254/latest/meta-data/iam/security-credentials/';
    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;

    try
    {
        // Make a call to the EC2 Metadata Service to find the available instance profile
        $request = new RequestCore($instance_profile_url);
        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
        $response = $request-&gt;send_request(true);

        if ($response-&gt;isOK())
        {
            // Get the instance profile name
            $profile = (string) $response-&gt;body;

            // Make a call to the EC2 Metadata Service to get the instance profile credentials
            $request = new RequestCore($instance_profile_url . $profile);
            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
            $response = $request-&gt;send_request(true);

            if ($response-&gt;isOK())
            {
                // Get the credentials
                $credentials = json_decode($response-&gt;body, true);

                if ($credentials['Code'] === 'Success')
                {
                    // Determine the expiration time
                    $expiration_time = strtotime((string) $credentials['Expiration']);
                    $expiration_duration = round(($expiration_time - time()) * 0.85);
                    $cache-&gt;expire_in($expiration_duration);

                    // Return the credential information
                    return array(
                        'key'     =&gt; $credentials['AccessKeyId'],
                        'secret'  =&gt; $credentials['SecretAccessKey'],
                        'token'   =&gt; $credentials['Token'],
                        'expires' =&gt; $credentials['Expiration'],
                    );
                }
            }
        }
    }
    catch (cURL_Exception $e)
    {
        // The EC2 Metadata Service does not exist or had timed out.
        // An exception will be thrown on the next line.
    }

    // @codeCoverageIgnoreStart
    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '
        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '
        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');
    // @codeCoverageIgnoreEnd
}";}i:8;a:7:{s:4:"name";s:21:"cache_sts_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:122:"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be
manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:1226:"public function cache_sts_credentials($cache, $options)
{
    $token = new AmazonSTS($options);
    $response = $token-&gt;get_session_token();

    if ($response-&gt;isOK())
    {
        // Update the expiration
        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);
        $expiration_duration = round(($expiration_time - time()) * 0.85);
        $cache-&gt;expire_in($expiration_duration);

        // Return the important data
        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;

        return array(
            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,
            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,
            'token'   =&gt; (string) $credentials-&gt;SessionToken,
            'expires' =&gt; (string) $credentials-&gt;Expiration,
        );
    }

    // @codeCoverageIgnoreStart
    throw new STS_Exception('Temporary credentials from the AWS Security '
        . 'Token Service could not be retrieved using the provided long '
        . 'term credentials. It\'s possible that the provided long term '
        . 'credentials were invalid.');
    // @codeCoverageIgnoreEnd
}";}i:9;a:8:{s:4:"name";s:22:"configure_health_check";s:8:"modifier";s:6:"public";s:11:"description";s:81:"<p>Enables the client to define an application healthcheck for the instances.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:114:"<p>The mnemonic name associated with the LoadBalancer. This name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"health_check";s:4:"type";s:5:"array";s:11:"description";s:2049:"<p>A structure containing the configuration information for the new healthcheck.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Target</code> - <code>string</code> - Required - Specifies the instance being checked. The protocol is either TCP, HTTP, HTTPS, or SSL. The range of valid ports is one (1) through 65535. <p class="note">TCP is the default, specified as a TCP: port pair, for example &#8220;TCP:5000&#8221;. In this case a healthcheck simply attempts to open a TCP connection to the instance on the specified port. Failure to connect within the configured timeout is considered unhealthy. SSL is also specified as SSL: port pair, for example, SSL:5000. For HTTP or HTTPS protocol, the situation is different. You have to include a ping path in the string. HTTP is specified as a HTTP:port;/;PathToPing; grouping, for example &#8220;HTTP:80/weather/us/wa/seattle&#8221;. In this case, a HTTP GET request is issued to the instance on the given port and path. Any answer other than &#8220;200 OK&#8221; within the timeout period is considered unhealthy. The total length of the HTTP ping target needs to be 1024 16-bit Unicode characters or less.</p></li><li><code>Interval</code> - <code>integer</code> - Required - Specifies the approximate interval, in seconds, between health checks of an individual instance.</li><li><code>Timeout</code> - <code>integer</code> - Required - Specifies the amount of time, in seconds, during which no response means a failed health probe. <p class="note">This value must be less than the <em>Interval</em> value.</p></li><li><code>UnhealthyThreshold</code> - <code>integer</code> - Required - Specifies the number of consecutive health probe failures required before moving the instance to the <em>Unhealthy</em> state.</li><li><code>HealthyThreshold</code> - <code>integer</code> - Required - Specifies the number of consecutive health probe successes required before moving the instance to the <em>Healthy</em> state.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:443:"public function configure_health_check($load_balancer_name, $health_check, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required map (non-list)
    $opt = array_merge($opt, CFComplexType::map(array(
        'HealthCheck' =&gt; (is_array($health_check) ? $health_check : array($health_check))
    ), 'member'));

    return $this-&gt;authenticate('ConfigureHealthCheck', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:62:"<p>Configure how the health of a load balancer is defined.</p>";s:4:"code";s:307:"$elb = new AmazonELB();

$response = $elb-&gt;configure_health_check('my-load-balancer', array(
	array( // Healthcheck #1
		'HealthyThreshold' =&gt; 3,
		'Interval' =&gt; 30,
		'Target' =&gt; 'TCP:5000',
		'Timeout' =&gt; 5,
		'UnhealthyThreshold' =&gt; 5
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:156:"<a href="../amazonelb/describe_instance_health.html" rel="../../index.html#m=amazonelb/describe_instance_health"><code>describe_instance_health()</code></a>";}}i:10;a:8:{s:4:"name";s:35:"create_app_cookie_stickiness_policy";s:8:"modifier";s:6:"public";s:11:"description";s:940:"<p>Generates a stickiness policy with sticky session lifetimes that follow that of an
application-generated cookie. This policy can be associated only with HTTP/HTTPS listeners.</p>

<p>This policy is similar to the policy created by CreateLBCookieStickinessPolicy, except that the
lifetime of the special Elastic Load Balancing cookie follows the lifetime of the
application-generated cookie specified in the policy configuration. The LoadBalancer only
inserts a new stickiness cookie when the application response includes a new application
cookie.</p>

<p>If the application cookie is explicitly removed or expires, the session stops being sticky
until a new application cookie is issued.</p>

<p class="note">
An application client must receive and send two cookies: the application-generated cookie and
the special Elastic Load Balancing cookie named <code>AWSELB</code>. This is the default
behavior for many common web browsers.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"policy_name";s:4:"type";s:6:"string";s:11:"description";s:118:"<p>The name of the policy being created. The name must be unique within the set of policies for this LoadBalancer.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"cookie_name";s:4:"type";s:6:"string";s:11:"description";s:58:"<p>Name of the application cookie used for stickiness.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:359:"public function create_app_cookie_stickiness_policy($load_balancer_name, $policy_name, $cookie_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['PolicyName'] = $policy_name;
    $opt['CookieName'] = $cookie_name;
    
    return $this-&gt;authenticate('CreateAppCookieStickinessPolicy', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:56:"<p>Create a new cookie stickiness policy for an app.</p>";s:11:"description";s:388:"<p>To assign a policy to a load balancer, you must:</p>

<ol>
<li>Create a policy using either <code>create_app_cookie_stickiness_policy()</code> or <code>create_lb_cookie_stickiness_policy()</code>.</li>
<li>Assign the policy to the load balancer with <code>set_load_balancer_policies_of_listener()</code>.</li>
<li>Remove them with <code>delete_load_balancer_policy()</code>.</li>
</ol>";s:4:"code";s:182:"$elb = new AmazonELB();

$response = $elb-&gt;create_app_cookie_stickiness_policy('my-load-balancer', 'app-cookie-policy', 'app-cookie');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:186:"<a href="../amazonelb/create_lb_cookie_stickiness_policy.html" rel="../../index.html#m=amazonelb/create_lb_cookie_stickiness_policy"><code>create_lb_cookie_stickiness_policy()</code></a>";i:1;s:165:"<a href="../amazonelb/delete_load_balancer_policy.html" rel="../../index.html#m=amazonelb/delete_load_balancer_policy"><code>delete_load_balancer_policy()</code></a>";}}}i:11;a:8:{s:4:"name";s:34:"create_lb_cookie_stickiness_policy";s:8:"modifier";s:6:"public";s:11:"description";s:910:"<p>Generates a stickiness policy with sticky session lifetimes controlled by the lifetime of the
browser (user-agent) or a specified expiration period. This policy can be associated only with
HTTP/HTTPS listeners.</p>

<p>When a LoadBalancer implements this policy, the LoadBalancer uses a special cookie to track the
backend server instance for each request. When the LoadBalancer receives a request, it first
checks to see if this cookie is present in the request. If so, the LoadBalancer sends the
request to the application server specified in the cookie. If not, the LoadBalancer sends the
request to a server that is chosen based on the existing load balancing algorithm.</p>

<p>A cookie is inserted into the response for binding subsequent requests from the same user to
that server. The validity of the cookie is based on the cookie expiration time, which is
specified in the policy configuration.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"policy_name";s:4:"type";s:6:"string";s:11:"description";s:118:"<p>The name of the policy being created. The name must be unique within the set of policies for this LoadBalancer.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:789:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>CookieExpirationPeriod</code> - <code>long</code> - Optional - The time period in seconds after which the cookie should be considered stale. Not specifying this parameter indicates that the sticky session will last for the duration of the browser session.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:304:"public function create_lb_cookie_stickiness_policy($load_balancer_name, $policy_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['PolicyName'] = $policy_name;
    
    return $this-&gt;authenticate('CreateLBCookieStickinessPolicy', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:59:"<p>Create a new load balancer cookie stickiness policy.</p>";s:11:"description";s:388:"<p>To assign a policy to a load balancer, you must:</p>

<ol>
<li>Create a policy using either <code>create_app_cookie_stickiness_policy()</code> or <code>create_lb_cookie_stickiness_policy()</code>.</li>
<li>Assign the policy to the load balancer with <code>set_load_balancer_policies_of_listener()</code>.</li>
<li>Remove them with <code>delete_load_balancer_policy()</code>.</li>
</ol>";s:4:"code";s:166:"$elb = new AmazonELB();

$response = $elb-&gt;create_lb_cookie_stickiness_policy('my-load-balancer', 'lb-cookie-policy');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:189:"<a href="../amazonelb/create_app_cookie_stickiness_policy.html" rel="../../index.html#m=amazonelb/create_app_cookie_stickiness_policy"><code>create_app_cookie_stickiness_policy()</code></a>";i:1;s:165:"<a href="../amazonelb/delete_load_balancer_policy.html" rel="../../index.html#m=amazonelb/delete_load_balancer_policy"><code>delete_load_balancer_policy()</code></a>";}}}i:12;a:9:{s:4:"name";s:20:"create_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:1011:"<p>Creates a new LoadBalancer.</p>

<p>After the call has completed successfully, a new LoadBalancer is created; however, it will not
be usable until at least one instance has been registered. When the LoadBalancer creation is
completed, the client can check whether or not it is usable by using the DescribeInstanceHealth
API. The LoadBalancer is usable as soon as any registered instance is <em>InService</em>.</p>

<p class="note">
Currently, the client&#8217;s quota of LoadBalancers is limited to ten per Region.
</p>

<p class="note"></p>

<p>LoadBalancer DNS names vary depending on the Region they&#8217;re created in. For LoadBalancers
created in the United States, the DNS name ends with:</p>

<ul><li><em>us-east-1.elb.amazonaws.com</em> (for the US Standard Region)</li><li><em>us-west-1.elb.amazonaws.com</em> (for the Northern California Region)</li></ul>

<p>For LoadBalancers created in the EU (Ireland) Region, the DNS name ends with:</p>

<ul><li><em>eu-west-1.elb.amazonaws.com</em></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:107:"<p>The name associated with the LoadBalancer. The name must be unique within your set of LoadBalancers.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"listeners";s:4:"type";s:5:"array";s:11:"description";s:2091:"<p>A list of the following tuples: LoadBalancerPort, InstancePort, and Protocol.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Protocol</code> - <code>string</code> - Required - Specifies the LoadBalancer transport protocol to use for routing - HTTP, HTTPS, TCP or SSL. This property cannot be modified for the life of the LoadBalancer.</li><li><code>LoadBalancerPort</code> - <code>integer</code> - Required - Specifies the external LoadBalancer port number. This property cannot be modified for the life of the LoadBalancer.</li><li><code>InstanceProtocol</code> - <code>string</code> - Optional - Specifies the protocol to use for routing traffic to back-end instances - HTTP, HTTPS, TCP, or SSL. This property cannot be modified for the life of the LoadBalancer. <p class="note">If the front-end protocol is HTTP or HTTPS, <code>InstanceProtocol</code> has to be at the same protocol layer, i.e., HTTP or HTTPS. Likewise, if the front-end protocol is TCP or SSL, InstanceProtocol has to be TCP or SSL.</p> <p class="note">If there is another listener with the same <code>InstancePort</code> whose <code>InstanceProtocol</code> is secure, i.e., HTTPS or SSL, the listener&#8217;s <code>InstanceProtocol</code> has to be secure, i.e., HTTPS or SSL. If there is another listener with the same <code>InstancePort</code> whose <code>InstanceProtocol</code> is HTTP or TCP, the listener&#8217;s <code>InstanceProtocol</code> must be either HTTP or TCP.</p></li><li><code>InstancePort</code> - <code>integer</code> - Required - Specifies the TCP port on which the instance server is listening. This property cannot be modified for the life of the LoadBalancer.</li><li><code>SSLCertificateId</code> - <code>string</code> - Optional - The ARN string of the server certificate. To get the ARN of the server certificate, call the AWS Identity and Access Management <a href="http://docs.amazonwebservices.com/IAM/latest/APIReference/index.html?API_UploadServerCertificate.html">UploadServerCertificate</a> API.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1839:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AvailabilityZones</code> - <code>string|array</code> - Optional - A list of Availability Zones. At least one Availability Zone must be specified. Specified Availability Zones must be in the same EC2 Region as the LoadBalancer. Traffic will be equally distributed across all zones. This list can be modified after the creation of the LoadBalancer. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Subnets</code> - <code>string|array</code> - Optional - A list of subnet IDs in your VPC to attach to your LoadBalancer. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>SecurityGroups</code> - <code>string|array</code> - Optional - The security groups assigned to your LoadBalancer within your VPC. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Scheme</code> - <code>string</code> - Optional - The type of a LoadBalancer. This option is only available for LoadBalancers attached to a Amazon VPC. By default, Elastic Load Balancer creates an internet-facing load balancer with publicly resolvable DNS name that resolves to public IP addresses. Specify the value <em>internal</em> for this option to create an internal load balancer with a DNS name that resolves to private IP addresses.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1398:"public function create_load_balancer($load_balancer_name, $listeners, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'Listeners' =&gt; (is_array($listeners) ? $listeners : array($listeners))
    ), 'member'));

    // Optional list (non-map)
    if (isset($opt['AvailabilityZones']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'AvailabilityZones' =&gt; (is_array($opt['AvailabilityZones']) ? $opt['AvailabilityZones'] : array($opt['AvailabilityZones']))
        ), 'member'));
        unset($opt['AvailabilityZones']);
    }
    
    // Optional list (non-map)
    if (isset($opt['Subnets']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Subnets' =&gt; (is_array($opt['Subnets']) ? $opt['Subnets'] : array($opt['Subnets']))
        ), 'member'));
        unset($opt['Subnets']);
    }
    
    // Optional list (non-map)
    if (isset($opt['SecurityGroups']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SecurityGroups' =&gt; (is_array($opt['SecurityGroups']) ? $opt['SecurityGroups'] : array($opt['SecurityGroups']))
        ), 'member'));
        unset($opt['SecurityGroups']);
    }

    return $this-&gt;authenticate('CreateLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:57:"<p>Create a new load balancer and attach to a subnet.</p>";s:11:"description";s:293:"<p>To set up a new load balancer for one or more instances, you need to:</p>

<ol>
<li>Create a new load balancer with <code>create_load_balancer()</code>.</li>
<li>Register one or more EC2 instances with the load balancer using <code>register_instances_with_load_balancer()</code>.</li>
</ol>";s:4:"code";s:287:"$elb = new AmazonELB();

$response = $elb-&gt;create_load_balancer('my-load-balancer', array(
	array(
		'Protocol' =&gt; 'HTTP',
		'InstancePort' =&gt; 80,
		'LoadBalancerPort' =&gt; 80
	)
), array(
	'AvailabilityZones' =&gt; 'us-east-1a'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:4:{s:5:"title";s:57:"<p>Create a new load balancer and attach to a subnet.</p>";s:11:"description";s:293:"<p>To set up a new load balancer for one or more instances, you need to:</p>

<ol>
<li>Create a new load balancer with <code>create_load_balancer()</code>.</li>
<li>Register one or more EC2 instances with the load balancer using <code>register_instances_with_load_balancer()</code>.</li>
</ol>";s:4:"code";s:586:"$elb = new AmazonELB();
$ec2 = new AmazonEC2();

// Lookup the ID for the &quot;default&quot; security group
$response = $ec2-&gt;describe_security_groups(array(
	'GroupName' =&gt; 'default'
));

$security_group = (string) $response-&gt;body-&gt;securityGroupInfo-&gt;item-&gt;groupId;

$response = $elb-&gt;create_load_balancer('my-load-balancer2', array(
	array(
		'Protocol' =&gt; 'HTTP',
		'InstancePort' =&gt; 80,
		'LoadBalancerPort' =&gt; 80
	)
), array(
	'Subnets' =&gt; 'subnet-2d78d544',
	'SecurityGroups' =&gt; $security_group
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:144:"<a href="../amazonelb/delete_load_balancer.html" rel="../../index.html#m=amazonelb/delete_load_balancer"><code>delete_load_balancer()</code></a>";i:1;s:153:"<a href="../amazonelb/describe_load_balancers.html" rel="../../index.html#m=amazonelb/describe_load_balancers"><code>describe_load_balancers()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:303:"<p>The <a href="http://docs.aws.amazon.com/ElasticLoadBalancing/latest/APIReference/API_CreateLoadBalancer.html">CreateLoadBalancer</a> operation introduced backwards-incompatible changes in the <code>2011-11-15</code> API release. The <code>AvailabilityZones</code> parameter is no longer required.</p>";}}i:13;a:8:{s:4:"name";s:30:"create_load_balancer_listeners";s:8:"modifier";s:6:"public";s:11:"description";s:254:"<p>Creates one or more listeners on a LoadBalancer for the specified port. If a listener with the
given port does not already exist, it will be created; otherwise, the properties of the new
listener must match the properties of the existing listener.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:89:"<p>The name of the new LoadBalancer. The name must be unique within your AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"listeners";s:4:"type";s:5:"array";s:11:"description";s:2145:"<p>A list of <code>LoadBalancerPort</code>, <code>InstancePort</code>, <code>Protocol</code>, and <code>SSLCertificateId</code> items.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Protocol</code> - <code>string</code> - Required - Specifies the LoadBalancer transport protocol to use for routing - HTTP, HTTPS, TCP or SSL. This property cannot be modified for the life of the LoadBalancer.</li><li><code>LoadBalancerPort</code> - <code>integer</code> - Required - Specifies the external LoadBalancer port number. This property cannot be modified for the life of the LoadBalancer.</li><li><code>InstanceProtocol</code> - <code>string</code> - Optional - Specifies the protocol to use for routing traffic to back-end instances - HTTP, HTTPS, TCP, or SSL. This property cannot be modified for the life of the LoadBalancer. <p class="note">If the front-end protocol is HTTP or HTTPS, <code>InstanceProtocol</code> has to be at the same protocol layer, i.e., HTTP or HTTPS. Likewise, if the front-end protocol is TCP or SSL, InstanceProtocol has to be TCP or SSL.</p> <p class="note">If there is another listener with the same <code>InstancePort</code> whose <code>InstanceProtocol</code> is secure, i.e., HTTPS or SSL, the listener&#8217;s <code>InstanceProtocol</code> has to be secure, i.e., HTTPS or SSL. If there is another listener with the same <code>InstancePort</code> whose <code>InstanceProtocol</code> is HTTP or TCP, the listener&#8217;s <code>InstanceProtocol</code> must be either HTTP or TCP.</p></li><li><code>InstancePort</code> - <code>integer</code> - Required - Specifies the TCP port on which the instance server is listening. This property cannot be modified for the life of the LoadBalancer.</li><li><code>SSLCertificateId</code> - <code>string</code> - Optional - The ARN string of the server certificate. To get the ARN of the server certificate, call the AWS Identity and Access Management <a href="http://docs.amazonwebservices.com/IAM/latest/APIReference/index.html?API_UploadServerCertificate.html">UploadServerCertificate</a> API.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:440:"public function create_load_balancer_listeners($load_balancer_name, $listeners, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'Listeners' =&gt; (is_array($listeners) ? $listeners : array($listeners))
    ), 'member'));

    return $this-&gt;authenticate('CreateLoadBalancerListeners', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Create a new load balancer listener.</p>";s:4:"code";s:252:"$elb = new AmazonELB();

$response = $elb-&gt;create_load_balancer_listeners('my-load-balancer', array(
	array(
		'Protocol' =&gt; 'HTTP',
		'LoadBalancerPort' =&gt; 1024,
		'InstancePort' =&gt; 65533
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:174:"<a href="../amazonelb/delete_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/delete_load_balancer_listeners"><code>delete_load_balancer_listeners()</code></a>";i:1;s:210:"<a href="../amazonelb/set_load_balancer_listener_ssl_certificate.html" rel="../../index.html#m=amazonelb/set_load_balancer_listener_ssl_certificate"><code>set_load_balancer_listener_ssl_certificate()</code></a>";i:2;s:198:"<a href="../amazonelb/set_load_balancer_policies_of_listener.html" rel="../../index.html#m=amazonelb/set_load_balancer_policies_of_listener"><code>set_load_balancer_policies_of_listener()</code></a>";}}}i:14;a:6:{s:4:"name";s:27:"create_load_balancer_policy";s:8:"modifier";s:6:"public";s:11:"description";s:281:"<p>Creates a new policy that contains the necessary attributes depending on the policy type.
Policies are settings that are saved for your Elastic LoadBalancer and that can be applied to
the front-end listener, or the back-end application server, depending on your policy type.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:143:"<p>The name associated with the LoadBalancer for which the policy is being created. This name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"policy_name";s:4:"type";s:6:"string";s:11:"description";s:131:"<p>The name of the LoadBalancer policy being created. The name must be unique within the set of policies for this LoadBalancer.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"policy_type_name";s:4:"type";s:6:"string";s:11:"description";s:167:"<p>The name of the base policy type being used to create this policy. To get the list of policy types, use the <code>DescribeLoadBalancerPolicyTypes</code> action.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1019:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PolicyAttributes</code> - <code>array</code> - Optional - A list of attributes associated with the policy being created. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>AttributeName</code> - <code>string</code> - Optional - The name of the attribute associated with the policy.</li><li><code>AttributeValue</code> - <code>string</code> - Optional - The value of the attribute associated with the policy.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:624:"public function create_load_balancer_policy($load_balancer_name, $policy_name, $policy_type_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['PolicyName'] = $policy_name;
    $opt['PolicyTypeName'] = $policy_type_name;
    
    // Optional list + map
    if (isset($opt['PolicyAttributes']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PolicyAttributes' =&gt; $opt['PolicyAttributes']
        ), 'member'));
        unset($opt['PolicyAttributes']);
    }

    return $this-&gt;authenticate('CreateLoadBalancerPolicy', $opt);
}";}i:15;a:7:{s:4:"name";s:12:"delete_cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:169:"<p>Deletes a cached <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object using the specified cache storage type.</p>";s:11:"returnvalue";s:118:"<p>A value of <code>true</code> if cached object exists and is successfully deleted, otherwise <code>false</code>.</p>";s:6:"source";s:125:"public function delete_cache()
{
    $this-&gt;use_cache_flow = true;
    $this-&gt;delete_cache = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:4:{s:5:"title";s:41:"<p>Delete a cached response from APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:169:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:11:"bool(false)";}i:1;a:4:{s:5:"title";s:53:"<p>Delete a cached response from the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:173:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}i:2;a:4:{s:5:"title";s:46:"<p>Delete a cached response from Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:205:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}}}}i:16;a:8:{s:4:"name";s:20:"delete_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:774:"<p>Deletes the specified LoadBalancer.</p>

<p>If attempting to recreate the LoadBalancer, the client must reconfigure all the settings. The
DNS name associated with a deleted LoadBalancer will no longer be usable. Once deleted, the
name and associated DNS record of the LoadBalancer no longer exist and traffic sent to any of
its IP addresses will no longer be delivered to client instances. The client will not receive
the same DNS name even if a new LoadBalancer with same LoadBalancerName is created.</p>

<p>To successfully call this API, the client must provide the same account credentials as were
used to create the LoadBalancer.</p>

<p class="note">
By design, if the LoadBalancer does not exist or has already been deleted, DeleteLoadBalancer
still succeeds.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:225:"public function delete_load_balancer($load_balancer_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    return $this-&gt;authenticate('DeleteLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:30:"<p>Delete a load balancer.</p>";s:4:"code";s:196:"$elb = new AmazonELB();

$response = $elb-&gt;delete_load_balancer('my-load-balancer');
$response = $elb-&gt;delete_load_balancer('my-load-balancer2');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:144:"<a href="../amazonelb/create_load_balancer.html" rel="../../index.html#m=amazonelb/create_load_balancer"><code>create_load_balancer()</code></a>";i:1;s:153:"<a href="../amazonelb/describe_load_balancers.html" rel="../../index.html#m=amazonelb/describe_load_balancers"><code>describe_load_balancers()</code></a>";}}}i:17;a:8:{s:4:"name";s:30:"delete_load_balancer_listeners";s:8:"modifier";s:6:"public";s:11:"description";s:70:"<p>Deletes listeners from the LoadBalancer for the specified port.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:58:"<p>The mnemonic name associated with the LoadBalancer.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"load_balancer_ports";s:4:"type";s:7:"integer";s:11:"description";s:78:"<p>The client port number(s) of the LoadBalancerListener(s) to be removed.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:492:"public function delete_load_balancer_listeners($load_balancer_name, $load_balancer_ports, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'LoadBalancerPorts' =&gt; (is_array($load_balancer_ports) ? $load_balancer_ports : array($load_balancer_ports))
    ), 'member'));

    return $this-&gt;authenticate('DeleteLoadBalancerListeners', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Delete a load balancer listener.</p>";s:4:"code";s:160:"$elb = new AmazonELB();

$response = $elb-&gt;delete_load_balancer_listeners('my-load-balancer', array(80, 65533));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:174:"<a href="../amazonelb/create_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/create_load_balancer_listeners"><code>create_load_balancer_listeners()</code></a>";i:1;s:210:"<a href="../amazonelb/set_load_balancer_listener_ssl_certificate.html" rel="../../index.html#m=amazonelb/set_load_balancer_listener_ssl_certificate"><code>set_load_balancer_listener_ssl_certificate()</code></a>";i:2;s:198:"<a href="../amazonelb/set_load_balancer_policies_of_listener.html" rel="../../index.html#m=amazonelb/set_load_balancer_policies_of_listener"><code>set_load_balancer_policies_of_listener()</code></a>";}}}i:18;a:8:{s:4:"name";s:27:"delete_load_balancer_policy";s:8:"modifier";s:6:"public";s:11:"description";s:106:"<p>Deletes a policy from the LoadBalancer. The specified policy must not be enabled for any
listeners.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:107:"<p>The mnemonic name associated with the LoadBalancer. The name must be unique within your AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"policy_name";s:4:"type";s:6:"string";s:11:"description";s:54:"<p>The mnemonic name for the policy being deleted.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:291:"public function delete_load_balancer_policy($load_balancer_name, $policy_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['PolicyName'] = $policy_name;
    
    return $this-&gt;authenticate('DeleteLoadBalancerPolicy', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:54:"<p>Delete a stickiness policy for a load balancer.</p>";s:11:"description";s:388:"<p>To assign a policy to a load balancer, you must:</p>

<ol>
<li>Create a policy using either <code>create_app_cookie_stickiness_policy()</code> or <code>create_lb_cookie_stickiness_policy()</code>.</li>
<li>Assign the policy to the load balancer with <code>set_load_balancer_policies_of_listener()</code>.</li>
<li>Remove them with <code>delete_load_balancer_policy()</code>.</li>
</ol>";s:4:"code";s:160:"$elb = new AmazonELB();

$response = $elb-&gt;delete_load_balancer_policy('my-load-balancer', 'app-cookie-policy');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:189:"<a href="../amazonelb/create_app_cookie_stickiness_policy.html" rel="../../index.html#m=amazonelb/create_app_cookie_stickiness_policy"><code>create_app_cookie_stickiness_policy()</code></a>";i:1;s:186:"<a href="../amazonelb/create_lb_cookie_stickiness_policy.html" rel="../../index.html#m=amazonelb/create_lb_cookie_stickiness_policy"><code>create_lb_cookie_stickiness_policy()</code></a>";}}}i:19;a:8:{s:4:"name";s:39:"deregister_instances_from_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:276:"<p>Deregisters instances from the LoadBalancer. Once the instance is deregistered, it will stop
receiving traffic from the LoadBalancer.</p>

<p>In order to successfully call this API, the same account credentials as those used to create
the LoadBalancer must be provided.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"instances";s:4:"type";s:5:"array";s:11:"description";s:293:"<p>A list of EC2 instance IDs consisting of all instances to be deregistered.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>InstanceId</code> - <code>string</code> - Optional - Provides an EC2 instance ID.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:457:"public function deregister_instances_from_load_balancer($load_balancer_name, $instances, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'Instances' =&gt; (is_array($instances) ? $instances : array($instances))
    ), 'member'));

    return $this-&gt;authenticate('DeregisterInstancesFromLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:65:"<p>Deregister one or more EC2 instances from a load balancer.</p>";s:4:"code";s:242:"$elb = new AmazonELB();

$response = $elb-&gt;deregister_instances_from_load_balancer('my-load-balancer', array(
	array('InstanceId' =&gt; 'i-7e8d2913'),
	array('InstanceId' =&gt; 'i-8f9e4217')
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:195:"<a href="../amazonelb/register_instances_with_load_balancer.html" rel="../../index.html#m=amazonelb/register_instances_with_load_balancer"><code>register_instances_with_load_balancer()</code></a>";}}i:20;a:8:{s:4:"name";s:24:"describe_instance_health";s:8:"modifier";s:6:"public";s:11:"description";s:405:"<p>Returns the current state of the instances of the specified LoadBalancer. If no instances are
specified, the state of all the instances for the LoadBalancer is returned.</p>

<p class="note">
The client must have created the specified input LoadBalancer in order to retrieve this
information; the client must provide the same account credentials as those that were used to
create the LoadBalancer.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:850:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Instances</code> - <code>array</code> - Optional - A list of instance IDs whose states are being queried. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>InstanceId</code> - <code>string</code> - Optional - Provides an EC2 instance ID.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:471:"public function describe_instance_health($load_balancer_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Optional list + map
    if (isset($opt['Instances']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Instances' =&gt; $opt['Instances']
        ), 'member'));
        unset($opt['Instances']);
    }

    return $this-&gt;authenticate('DescribeInstanceHealth', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:42:"<p>Describe the health of an instance.</p>";s:4:"code";s:136:"$elb = new AmazonELB();

$response = $elb-&gt;describe_instance_health('my-load-balancer');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:58:"<p>Describe the health of a specific set of instances.</p>";s:4:"code";s:257:"$elb = new AmazonELB();

$response = $elb-&gt;describe_instance_health('my-load-balancer', array(
	'Instances' =&gt; array(
		array('InstanceId' =&gt; 'i-7e8d2913')
		array('InstanceId' =&gt; 'i-8f9e4217')
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";s:150:"<a href="../amazonelb/configure_health_check.html" rel="../../index.html#m=amazonelb/configure_health_check"><code>configure_health_check()</code></a>";}}i:21;a:7:{s:4:"name";s:31:"describe_load_balancer_policies";s:8:"modifier";s:6:"public";s:11:"description";s:463:"<p>Returns detailed descriptions of the policies. If you specify a LoadBalancer name, the
operation returns either the descriptions of the specified policies, or descriptions of all the
policies created for the LoadBalancer. If you don&#8217;t specify a LoadBalancer name, the operation
returns descriptions of the specified sample policies, or descriptions of all the sample
policies. The names of the sample policies have the <code>ELBSample-</code> prefix.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1063:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>LoadBalancerName</code> - <code>string</code> - Optional - The mnemonic name associated with the LoadBalancer. If no name is specified, the operation returns the attributes of either all the sample policies pre-defined by Elastic Load Balancing or the specified sample polices.</li><li><code>PolicyNames</code> - <code>string|array</code> - Optional - The names of LoadBalancer policies you&#8217;ve created or Elastic Load Balancing sample policy names. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:494:"public function describe_load_balancer_policies($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['PolicyNames']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PolicyNames' =&gt; (is_array($opt['PolicyNames']) ? $opt['PolicyNames'] : array($opt['PolicyNames']))
        ), 'member'));
        unset($opt['PolicyNames']);
    }

    return $this-&gt;authenticate('DescribeLoadBalancerPolicies', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Describe load balancer policies.</p>";s:4:"code";s:125:"$elb = new AmazonELB();

$response = $elb-&gt;describe_load_balancer_policies();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:22;a:6:{s:4:"name";s:35:"describe_load_balancer_policy_types";s:8:"modifier";s:6:"public";s:11:"description";s:326:"<p>Returns meta-information on the specified LoadBalancer policies defined by the Elastic Load
Balancing service. The policy types that are returned from this action can be used in a
<code>CreateLoadBalancerPolicy</code> action to instantiate specific policy configurations that
will be applied to an Elastic LoadBalancer.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:830:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PolicyTypeNames</code> - <code>string|array</code> - Optional - Specifies the name of the policy types. If no names are specified, returns the description of all the policy types defined by Elastic Load Balancing service. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:525:"public function describe_load_balancer_policy_types($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['PolicyTypeNames']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PolicyTypeNames' =&gt; (is_array($opt['PolicyTypeNames']) ? $opt['PolicyTypeNames'] : array($opt['PolicyTypeNames']))
        ), 'member'));
        unset($opt['PolicyTypeNames']);
    }

    return $this-&gt;authenticate('DescribeLoadBalancerPolicyTypes', $opt);
}";}i:23;a:8:{s:4:"name";s:23:"describe_load_balancers";s:8:"modifier";s:6:"public";s:11:"description";s:440:"<p>Returns detailed configuration information for the specified LoadBalancers. If no LoadBalancers
are specified, the operation returns configuration information for all LoadBalancers created by
the caller.</p>

<p class="note">
The client must have created the specified input LoadBalancers in order to retrieve this
information; the client must provide the same account credentials as those that were used to
create the LoadBalancer.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:852:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>LoadBalancerNames</code> - <code>string|array</code> - Optional - A list of names associated with the LoadBalancers at creation time. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Marker</code> - <code>string</code> - Optional - An optional parameter reserved for future use.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:515:"public function describe_load_balancers($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['LoadBalancerNames']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LoadBalancerNames' =&gt; (is_array($opt['LoadBalancerNames']) ? $opt['LoadBalancerNames'] : array($opt['LoadBalancerNames']))
        ), 'member'));
        unset($opt['LoadBalancerNames']);
    }

    return $this-&gt;authenticate('DescribeLoadBalancers', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:31:"<p>Describe load balancers.</p>";s:4:"code";s:117:"$elb = new AmazonELB();

$response = $elb-&gt;describe_load_balancers();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:41:"<p>Describe a specific load balancer.</p>";s:4:"code";s:171:"$elb = new AmazonELB();

$response = $elb-&gt;describe_load_balancers(array(
	'LoadBalancerNames' =&gt; 'my-load-balancer'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:144:"<a href="../amazonelb/create_load_balancer.html" rel="../../index.html#m=amazonelb/create_load_balancer"><code>create_load_balancer()</code></a>";i:1;s:144:"<a href="../amazonelb/delete_load_balancer.html" rel="../../index.html#m=amazonelb/delete_load_balancer"><code>delete_load_balancer()</code></a>";}}}i:24;a:6:{s:4:"name";s:33:"detach_load_balancer_from_subnets";s:8:"modifier";s:6:"public";s:11:"description";s:382:"<p>Removes subnets from the set of configured subnets in the VPC for the LoadBalancer.</p>

<p>After a subnet is removed all of the EndPoints registered with the LoadBalancer that are in the
removed subnet will go into the <em>OutOfService</em> state. When a subnet is removed, the
LoadBalancer will balance the traffic among the remaining routable subnets for the
LoadBalancer.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:119:"<p>The name associated with the LoadBalancer to be detached. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"subnets";s:4:"type";s:12:"string|array";s:11:"description";s:169:"<p>A list of subnet IDs to remove from the set of configured subnets for the LoadBalancer. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:439:"public function detach_load_balancer_from_subnets($load_balancer_name, $subnets, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'Subnets' =&gt; (is_array($subnets) ? $subnets : array($subnets))
    ), 'member'));

    return $this-&gt;authenticate('DetachLoadBalancerFromSubnets', $opt);
}";}i:25;a:8:{s:4:"name";s:44:"disable_availability_zones_for_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:901:"<p>Removes the specified EC2 Availability Zones from the set of configured Availability Zones for
the LoadBalancer.</p>

<p>There must be at least one Availability Zone registered with a LoadBalancer at all times. A
client cannot remove all the Availability Zones from a LoadBalancer. Once an Availability Zone
is removed, all the instances registered with the LoadBalancer that are in the removed
Availability Zone go into the OutOfService state. Upon Availability Zone removal, the
LoadBalancer attempts to equally balance the traffic among its remaining usable Availability
Zones. Trying to remove an Availability Zone that was not associated with the LoadBalancer does
nothing.</p>

<p class="note">
In order for this call to be successful, the client must have created the LoadBalancer. The
client must provide the same account credentials as those that were used to create the
LoadBalancer.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"availability_zones";s:4:"type";s:12:"string|array";s:11:"description";s:396:"<p>A list of Availability Zones to be removed from the LoadBalancer.</p>

<p class="note">There must be at least one Availability Zone registered with a LoadBalancer at all times. The client cannot remove all the Availability Zones from a LoadBalancer. Specified Availability Zones must be in the same Region.</p>

<p>Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:514:"public function disable_availability_zones_for_load_balancer($load_balancer_name, $availability_zones, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'AvailabilityZones' =&gt; (is_array($availability_zones) ? $availability_zones : array($availability_zones))
    ), 'member'));

    return $this-&gt;authenticate('DisableAvailabilityZonesForLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:54:"<p>Disable availability zones for a load balancer.</p>";s:4:"code";s:170:"$elb = new AmazonELB();

$response = $elb-&gt;disable_availability_zones_for_load_balancer('my-load-balancer', 'us-east-1b');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:213:"<a href="../amazonelb/enable_availability_zones_for_load_balancer.html" rel="../../index.html#m=amazonelb/enable_availability_zones_for_load_balancer"><code>enable_availability_zones_for_load_balancer()</code></a>";}}i:26;a:7:{s:4:"name";s:11:"disable_ssl";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:312:"<p>Disables SSL/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still
require SSL support.</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:192:"public function disable_ssl()
{
    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;use_ssl = false;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:35:"<p>Disable SSL for the service.</p>";s:11:"description";s:170:"<ul>
<li><strong>Note:</strong> It is not recommended to disable SSL.</li>
<li><strong>Note:</strong> This method is inherited by all service-specific classes.</li>
</ul>";s:4:"code";s:175:"// Disable SSL (Using @ to suppress the warning from the output)
$sdb = new AmazonSDB();
@$sdb-&gt;disable_ssl(true);

// Test if the value was set
var_dump($sdb-&gt;use_ssl);";s:6:"result";s:11:"bool(false)";}}}i:27;a:7:{s:4:"name";s:24:"disable_ssl_verification";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:402:"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry
out a man-in-the-middle attack.</p>

<p>https://secure.wikimedia.org/wikipedia/en/wiki/Man-in-the-middle_attack</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"ssl_verification";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:314:"public function disable_ssl_verification($ssl_verification = false)
{
    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;ssl_verification = $ssl_verification;
    return $this;
}";}i:28;a:8:{s:4:"name";s:43:"enable_availability_zones_for_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:473:"<p>Adds one or more EC2 Availability Zones to the LoadBalancer.</p>

<p>The LoadBalancer evenly distributes requests across all its registered Availability Zones that
contain instances. As a result, the client must ensure that its LoadBalancer is appropriately
scaled for each registered Availability Zone.</p>

<p class="note">
The new EC2 Availability Zones to be added must be in the same EC2 Region as the Availability
Zones for which the LoadBalancer was created.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"availability_zones";s:4:"type";s:12:"string|array";s:11:"description";s:207:"<p>A list of new Availability Zones for the LoadBalancer. Each Availability Zone must be in the same Region as the LoadBalancer. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:512:"public function enable_availability_zones_for_load_balancer($load_balancer_name, $availability_zones, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'AvailabilityZones' =&gt; (is_array($availability_zones) ? $availability_zones : array($availability_zones))
    ), 'member'));

    return $this-&gt;authenticate('EnableAvailabilityZonesForLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:53:"<p>Enable availability zones for a load balancer.</p>";s:4:"code";s:169:"$elb = new AmazonELB();

$response = $elb-&gt;enable_availability_zones_for_load_balancer('my-load-balancer', 'us-east-1b');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:216:"<a href="../amazonelb/disable_availability_zones_for_load_balancer.html" rel="../../index.html#m=amazonelb/disable_availability_zones_for_load_balancer"><code>disable_availability_zones_for_load_balancer()</code></a>";}}i:29;a:8:{s:4:"name";s:17:"enable_debug_mode";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:75:"<p>Enables HTTP request/response header logging to <code>STDERR</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"enabled";s:4:"type";s:7:"boolean";s:11:"description";s:74:"<p>Whether or not to enable debug mode. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:109:"public function enable_debug_mode($enabled = true)
{
    $this-&gt;debug_mode = $enabled;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:82:"<p>Enable the logging of HTTP request/response headers to <code>STDERR</code>.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;enable_debug_mode();

// Test if the value was set
var_dump($sdb-&gt;debug_mode);";s:6:"result";s:10:"bool(true)";}}}i:30;a:7:{s:4:"name";s:7:"factory";s:8:"modifier";s:13:"public static";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:76:"<p>Alternate approach to constructing a new instance. Supports chaining.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1569:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonelb/set_cache_config.html" rel="../../index.html#m=amazonelb/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:303:"public static function factory(array $options = array())
{
    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))
    {
        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');
    }

    $self = get_called_class();
    return new $self($options);
}";}i:31;a:8:{s:4:"name";s:37:"register_instances_with_load_balancer";s:8:"modifier";s:6:"public";s:11:"description";s:795:"<p>Adds new instances to the LoadBalancer.</p>

<p>Once the instance is registered, it starts receiving traffic and requests from the
LoadBalancer. Any instance that is not in any of the Availability Zones registered for the
LoadBalancer will be moved to the <em>OutOfService</em> state. It will move to the
<em>InService</em> state when the Availability Zone is added to the LoadBalancer.</p>

<p class="note">
In order for this call to be successful, the client must have created the LoadBalancer. The
client must provide the same account credentials as those that were used to create the
LoadBalancer.
</p>

<p class="note">
Completion of this API does not guarantee that operation has completed. Rather, it means that
the request has been registered and the changes will happen shortly.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"instances";s:4:"type";s:5:"array";s:11:"description";s:844:"<p>A list of instance IDs that should be registered with the LoadBalancer.</p>

<p class="note">When the instance is stopped and then restarted, the IP addresses associated with your instance changes. Elastic Load Balancing cannot recognize the new IP address, which prevents it from routing traffic to your instances. We recommend that you de-register your Amazon EC2 instances from your load balancer after you stop your instance, and then register the load balancer with your instance after you&#8217;ve restarted. To de-register your instances from load balancer, use <code>DeregisterInstancesFromLoadBalancer</code> action.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>InstanceId</code> - <code>string</code> - Optional - Provides an EC2 instance ID.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:453:"public function register_instances_with_load_balancer($load_balancer_name, $instances, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'Instances' =&gt; (is_array($instances) ? $instances : array($instances))
    ), 'member'));

    return $this-&gt;authenticate('RegisterInstancesWithLoadBalancer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:63:"<p>Register one or more EC2 instances with a load balancer.</p>";s:11:"description";s:293:"<p>To set up a new load balancer for one or more instances, you need to:</p>

<ol>
<li>Create a new load balancer with <code>create_load_balancer()</code>.</li>
<li>Register one or more EC2 instances with the load balancer using <code>register_instances_with_load_balancer()</code>.</li>
</ol>";s:4:"code";s:240:"$elb = new AmazonELB();

$response = $elb-&gt;register_instances_with_load_balancer('my-load-balancer', array(
	array('InstanceId' =&gt; 'i-7e8d2913'),
	array('InstanceId' =&gt; 'i-8f9e4217')
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:201:"<a href="../amazonelb/deregister_instances_from_load_balancer.html" rel="../../index.html#m=amazonelb/deregister_instances_from_load_balancer"><code>deregister_instances_from_load_balancer()</code></a>";}}i:32;a:8:{s:4:"name";s:32:"register_streaming_read_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:753:"<p>Register a callback function to execute whenever a data stream is read from using
<a href="../cfrequest/streaming_read_callback.html" rel="../../index.html#m=cfrequest/streaming_read_callback"><code>CFRequest::streaming_read_callback()</code></a>.</p>

<p>The user-defined callback function should accept three arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$file_handle</code> - <code>resource</code> - Required - The file handle resource that represents the file on the local file system.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:143:"public function register_streaming_read_callback($callback)
{
    $this-&gt;registered_streaming_read_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:85:"<p>Register a callback function to execute when data is read from an open stream.</p>";s:4:"code";s:694:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $file_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is read locally.
$s3-&gt;register_streaming_read_callback('callback');

// Download a public object.
$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(
	'fileUpload' =&gt; './uploads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:33;a:8:{s:4:"name";s:33:"register_streaming_write_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:608:"<p>Register a callback function to execute whenever a data stream is written to using
<a href="../cfrequest/streaming_write_callback.html" rel="../../index.html#m=cfrequest/streaming_write_callback"><code>CFRequest::streaming_write_callback()</code></a>.</p>

<p>The user-defined callback function should accept two arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:145:"public function register_streaming_write_callback($callback)
{
    $this-&gt;registered_streaming_write_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:86:"<p>Register a callback function to execute when data is written to an open stream.</p>";s:4:"code";s:685:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is written locally.
$s3-&gt;register_streaming_write_callback('callback');

// Download a public object.
$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(
	'fileDownload' =&gt; './downloads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:34;a:7:{s:4:"name";s:4:"send";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:71:"<p>Executes the batch request queue by sending all queued requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"clear_after_send";s:4:"type";s:7:"boolean";s:11:"description";s:204:"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true</code>. Set this to <code>false</code> if you are caching batch responses and want to retrieve results later.</p>";}}s:11:"returnvalue";s:126:"<p>An array of <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> objects.</p>";s:6:"source";s:2018:"public function send($clear_after_send = true)
{
    if ($this-&gt;use_batch_flow)
    {
        // When we send the request, disable batch flow.
        $this-&gt;use_batch_flow = false;

        // If we're not caching, simply send the request.
        if (!$this-&gt;use_cache_flow)
        {
            $response = $this-&gt;batch_object-&gt;send();
            $parsed_data = array_map(array($this, 'parse_callback'), $response);
            $parsed_data = new CFArray($parsed_data);

            // Clear the queue
            if ($clear_after_send)
            {
                $this-&gt;batch_object-&gt;queue = array();
            }

            return $parsed_data;
        }

        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));
        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);
        $parsed_data = new CFArray($parsed_data);

        // Clear the queue
        if ($clear_after_send)
        {
            $this-&gt;batch_object-&gt;queue = array();
        }

        // End!
        return $parsed_data;
    }

    // Load the class
    $null = new CFBatchRequest();
    unset($null);

    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');
}";}i:35;a:7:{s:4:"name";s:15:"set_batch_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:291:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:116:"public function set_batch_class($class = 'CFBatchRequest')
{
    $this-&gt;batch_class = $class;
    return $this;
}";}i:36;a:8:{s:4:"name";s:16:"set_cache_config";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Set the caching configuration to use for response caching.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:1095:"<p>The location to store the cache object in. This may vary by cache method.</p><ul><li>File - The local file system paths such as <code>./cache</code> (relative) or <code>/tmp/cache/</code> (absolute). The location must be server-writable.</li><li>APC - Pass in <code>apc</code> to use this lightweight cache. You must have the <a href="http://php.net/apc">APC extension</a> installed.</li><li>XCache - Pass in <code>xcache</code> to use this lightweight cache. You must have the <a href="http://xcache.lighttpd.net">XCache</a> extension installed.</li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host</code> and a <code>port</code> value representing a <a href="http://php.net/memcached">Memcached</a> server to connect to.</li><li>PDO - A URL-style string (e.g. <code>pdo.mysql://user:pass@localhost/cache</code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:/sqlite/cache.db</code>). MUST be prefixed with <code>pdo.</code>. See <code>CachePDO</code> and <a href="http://php.net/pdo">PDO</a> for more details.</li></ul>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:241:"<p>Whether or not data should be gzipped before being stored. A value of <code>true</code> will compress the contents before caching them. A value of <code>false</code> will leave the contents uncompressed. Defaults to <code>true</code>.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:1210:"public function set_cache_config($location, $gzip = true)
{
    // If location is empty, don't do anything.
    if (empty($location))
    {
        return $this;
    }

    // If we have an array, we're probably passing in Memcached servers and ports.
    if (is_array($location))
    {
        $this-&gt;cache_class = 'CacheMC';
    }
    else
    {
        // I would expect locations like `/tmp/cache`, `pdo.mysql://user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.
        $type = strtolower(substr($location, 0, 3));
        switch ($type)
        {
            case 'apc':
                $this-&gt;cache_class = 'CacheAPC';
                break;

            case 'xca': // First three letters of `xcache`
                $this-&gt;cache_class = 'CacheXCache';
                break;

            case 'pdo':
                $this-&gt;cache_class = 'CachePDO';
                $location = substr($location, 4);
                break;

            default:
                $this-&gt;cache_class = 'CacheFile';
                break;
        }
    }

    // Set the remaining cache information.
    $this-&gt;cache_location = $location;
    $this-&gt;cache_compress = $gzip;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}}}}i:37;a:8:{s:4:"name";s:12:"set_hostname";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:145:"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with
AWS, but run from a different hostname.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"hostname";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"port_number";s:4:"type";s:7:"integer";s:11:"description";s:139:"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:341:"public function set_hostname($hostname, $port_number = null)
{
    if ($this-&gt;override_hostname)
    {
        $this-&gt;hostname = $hostname;

        if ($port_number)
        {
            $this-&gt;port_number = $port_number;
            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;
        }
    }

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:38;a:7:{s:4:"name";s:42:"set_load_balancer_listener_ssl_certificate";s:8:"modifier";s:6:"public";s:11:"description";s:197:"<p>Sets the certificate that terminates the specified listener&#8217;s SSL connections. The specified
certificate replaces any prior certificate that was used on the same LoadBalancer and port.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:40:"<p>The name of the the LoadBalancer.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_port";s:4:"type";s:7:"integer";s:11:"description";s:56:"<p>The port that uses the specified SSL certificate.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"ssl_certificate_id";s:4:"type";s:6:"string";s:11:"description";s:276:"<p>The ID of the SSL certificate chain to use. For more information on SSL certificates, see <a href="http://docs.amazonwebservices.com/IAM/latest/UserGuide/ManagingServerCerts.html">Managing Server Certificates</a> in the AWS Identity and Access Management documentation.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:412:"public function set_load_balancer_listener_ssl_certificate($load_balancer_name, $load_balancer_port, $ssl_certificate_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['LoadBalancerPort'] = $load_balancer_port;
    $opt['SSLCertificateId'] = $ssl_certificate_id;
    
    return $this-&gt;authenticate('SetLoadBalancerListenerSSLCertificate', $opt);
}";s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:174:"<a href="../amazonelb/create_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/create_load_balancer_listeners"><code>create_load_balancer_listeners()</code></a>";i:1;s:174:"<a href="../amazonelb/delete_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/delete_load_balancer_listeners"><code>delete_load_balancer_listeners()</code></a>";i:2;s:198:"<a href="../amazonelb/set_load_balancer_policies_of_listener.html" rel="../../index.html#m=amazonelb/set_load_balancer_policies_of_listener"><code>set_load_balancer_policies_of_listener()</code></a>";}}}i:39;a:6:{s:4:"name";s:45:"set_load_balancer_policies_for_backend_server";s:8:"modifier";s:6:"public";s:11:"description";s:420:"<p>Replaces the current set of policies associated with a port on which the back-end server is
listening with a new set of policies. After the policies have been created using
<code>CreateLoadBalancerPolicy</code>, they can be applied here as a list. At this time, only
the back-end server authentication policy type can be applied to the back-end ports; this
policy type is composed of multiple public key policies.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:114:"<p>The mnemonic name associated with the LoadBalancer. This name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"instance_port";s:4:"type";s:7:"integer";s:11:"description";s:59:"<p>The port number associated with the back-end server.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"policy_names";s:4:"type";s:12:"string|array";s:11:"description";s:198:"<p>List of policy names to be set. If the list is empty, then all current polices are removed from the back-end server. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:544:"public function set_load_balancer_policies_for_backend_server($load_balancer_name, $instance_port, $policy_names, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['InstancePort'] = $instance_port;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'PolicyNames' =&gt; (is_array($policy_names) ? $policy_names : array($policy_names))
    ), 'member'));

    return $this-&gt;authenticate('SetLoadBalancerPoliciesForBackendServer', $opt);
}";}i:40;a:8:{s:4:"name";s:38:"set_load_balancer_policies_of_listener";s:8:"modifier";s:6:"public";s:11:"description";s:138:"<p>Associates, updates, or disables a policy with a listener on the LoadBalancer. You can
associate multiple policies with a listener.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_name";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>The name associated with the LoadBalancer. The name must be unique within the client AWS account.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"load_balancer_port";s:4:"type";s:7:"integer";s:11:"description";s:79:"<p>The external port of the LoadBalancer with which this policy applies to.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"policy_names";s:4:"type";s:12:"string|array";s:11:"description";s:254:"<p>List of policies to be associated with the listener. Currently this list can have at most one policy. If the list is empty, the current policy is removed from the listener. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:545:"public function set_load_balancer_policies_of_listener($load_balancer_name, $load_balancer_port, $policy_names, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LoadBalancerName'] = $load_balancer_name;
    $opt['LoadBalancerPort'] = $load_balancer_port;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'PolicyNames' =&gt; (is_array($policy_names) ? $policy_names : array($policy_names))
    ), 'member'));

    return $this-&gt;authenticate('SetLoadBalancerPoliciesOfListener', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Assign a policy to a load balancer listener.</p>";s:11:"description";s:388:"<p>To assign a policy to a load balancer, you must:</p>

<ol>
<li>Create a policy using either <code>create_app_cookie_stickiness_policy()</code> or <code>create_lb_cookie_stickiness_policy()</code>.</li>
<li>Assign the policy to the load balancer with <code>set_load_balancer_policies_of_listener()</code>.</li>
<li>Remove them with <code>delete_load_balancer_policy()</code>.</li>
</ol>";s:4:"code";s:174:"$elb = new AmazonELB();

$response = $elb-&gt;set_load_balancer_policies_of_listener('my-load-balancer', 80, 'lb-cookie-policy');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:174:"<a href="../amazonelb/create_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/create_load_balancer_listeners"><code>create_load_balancer_listeners()</code></a>";i:1;s:174:"<a href="../amazonelb/delete_load_balancer_listeners.html" rel="../../index.html#m=amazonelb/delete_load_balancer_listeners"><code>delete_load_balancer_listeners()</code></a>";i:2;s:210:"<a href="../amazonelb/set_load_balancer_listener_ssl_certificate.html" rel="../../index.html#m=amazonelb/set_load_balancer_listener_ssl_certificate"><code>set_load_balancer_listener_ssl_certificate()</code></a>";}}}i:41;a:8:{s:4:"name";s:15:"set_max_retries";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"retries";s:4:"type";s:7:"integer";s:11:"description";s:88:"<p>The maximum number of times to retry failed requests. Defaults to <code>3</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:105:"public function set_max_retries($retries = 3)
{
    $this-&gt;max_retries = $retries;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_max_retries(3);

// Test if the value was set
var_dump($sdb-&gt;max_retries);";s:6:"result";s:6:"int(3)";}}}i:42;a:7:{s:4:"name";s:16:"set_parser_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:115:"public function set_parser_class($class = 'CFSimpleXML')
{
    $this-&gt;parser_class = $class;
    return $this;
}";}i:43;a:8:{s:4:"name";s:9:"set_proxy";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:37:"<p>Set the proxy settings to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"proxy";s:4:"type";s:6:"string";s:11:"description";s:102:"<p>Accepts proxy credentials in the following format: <code>proxy://user:pass@hostname:port</code></p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:85:"public function set_proxy($proxy)
{
    $this-&gt;proxy = $proxy;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>Set the proxy server to use for requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:151:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_proxy('proxy://user:pass@hostname:port');

// Test if the value was set
var_dump($sdb-&gt;proxy);";s:6:"result";s:44:"string(31) "proxy://user:pass@hostname:port"";}}}i:44;a:7:{s:4:"name";s:10:"set_region";s:8:"modifier";s:6:"public";s:11:"description";s:76:"<p>This allows you to explicitly sets the region for the service to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"region";s:4:"type";s:6:"string";s:11:"description";s:1261:"<p>The region to explicitly set. Available options are <a href="../amazonelb/constants.html#region_us_e1" rel="../../index.html#c=amazonelb/region_us_e1"><code>REGION_US_E1</code></a>, <a href="../amazonelb/constants.html#region_us_w1" rel="../../index.html#c=amazonelb/region_us_w1"><code>REGION_US_W1</code></a>, <a href="../amazonelb/constants.html#region_us_w2" rel="../../index.html#c=amazonelb/region_us_w2"><code>REGION_US_W2</code></a>, <a href="../amazonelb/constants.html#region_eu_w1" rel="../../index.html#c=amazonelb/region_eu_w1"><code>REGION_EU_W1</code></a>, <a href="../amazonelb/constants.html#region_apac_se1" rel="../../index.html#c=amazonelb/region_apac_se1"><code>REGION_APAC_SE1</code></a>, <a href="../amazonelb/constants.html#region_apac_se2" rel="../../index.html#c=amazonelb/region_apac_se2"><code>REGION_APAC_SE2</code></a>, <a href="../amazonelb/constants.html#region_apac_ne1" rel="../../index.html#c=amazonelb/region_apac_ne1"><code>REGION_APAC_NE1</code></a>, <a href="../amazonelb/constants.html#region_sa_e1" rel="../../index.html#c=amazonelb/region_sa_e1"><code>REGION_SA_E1</code></a>, <a href="../amazonelb/constants.html#region_us_gov1" rel="../../index.html#c=amazonelb/region_us_gov1"><code>REGION_US_GOV1</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:156:"public function set_region($region)
{
    // @codeCoverageIgnoreStart
    $this-&gt;set_hostname($region);
    return $this;
    // @codeCoverageIgnoreEnd
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Set the region to use.</p>";s:4:"code";s:250:"$elb = new AmazonELB();

// Set the region to US-East (Northern Virginia)
$elb-&gt;set_region(AmazonELB::REGION_US_E1);

// Describe database engine versions
$response = $elb-&gt;describe_load_balancers();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:45;a:8:{s:4:"name";s:17:"set_request_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:276:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";a:0:{}s:6:"source";s:115:"public function set_request_class($class = 'CFRequest')
{
    $this-&gt;request_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Set the request class to use in the toolkit.</p>";s:11:"description";s:158:"<p>The new request class must extend from <code>CFRequest</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:310:"// Custom class to extend RequestCore
class TestRequestCore extends RequestCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_request_class('TestRequestCore');

// Test if the value was set
var_dump($sdb-&gt;request_class);";s:6:"result";s:28:"string(15) "TestRequestCore"";}}}i:46;a:8:{s:4:"name";s:19:"set_resource_prefix";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:117:"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible
with AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"prefix";s:4:"type";s:6:"string";s:11:"description";s:97:"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:107:"public function set_resource_prefix($prefix)
{
    $this-&gt;resource_prefix = $prefix;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:47;a:8:{s:4:"name";s:18:"set_response_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:279:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:118:"public function set_response_class($class = 'CFResponse')
{
    $this-&gt;response_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:52:"<p>Set the response class to use in the toolkit.</p>";s:11:"description";s:160:"<p>The new response class must extend from <code>CFResponse</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:316:"// Custom class to extend ResponseCore
class TestResponseCore extends ResponseCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_response_class('TestResponseCore');

// Test if the value was set
var_dump($sdb-&gt;response_class);";s:6:"result";s:29:"string(16) "TestResponseCore"";}}}i:48;a:8:{s:4:"name";s:19:"set_utilities_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:175:"public function set_utilities_class($class = 'CFUtilities')
{
    $this-&gt;utilities_class = $class;
    $this-&gt;util = new $this-&gt;utilities_class();
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:53:"<p>Set the utilities class to use in the toolkit.</p>";s:11:"description";s:162:"<p>The new utilities class must extend from <code>CFUtilities</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:317:"// Custom class to extend CFUtilities
class TestUtilities extends CFUtilities
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_utilities_class('TestUtilities');

// Test if the value was set
var_dump($sdb-&gt;util-&gt;test_method());";s:6:"result";s:10:"bool(true)";}}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"22";}s:8:"constant";a:22:{i:0;a:2:{s:4:"name";s:5:"BUILD";s:5:"value";s:14:"20130314130000";}i:1;a:2:{s:4:"name";s:11:"DEFAULT_URL";s:5:"value";s:44:"elasticloadbalancing.us-east-1.amazonaws.com";}i:2;a:2:{s:4:"name";s:4:"NAME";s:5:"value";s:11:"aws-sdk-php";}i:3;a:2:{s:4:"name";s:15:"REGION_APAC_NE1";s:5:"value";s:49:"elasticloadbalancing.ap-northeast-1.amazonaws.com";}i:4;a:2:{s:4:"name";s:15:"REGION_APAC_SE1";s:5:"value";s:49:"elasticloadbalancing.ap-southeast-1.amazonaws.com";}i:5;a:2:{s:4:"name";s:15:"REGION_APAC_SE2";s:5:"value";s:49:"elasticloadbalancing.ap-southeast-2.amazonaws.com";}i:6;a:2:{s:4:"name";s:17:"REGION_CALIFORNIA";s:5:"value";s:44:"elasticloadbalancing.us-west-1.amazonaws.com";}i:7;a:2:{s:4:"name";s:12:"REGION_EU_W1";s:5:"value";s:44:"elasticloadbalancing.eu-west-1.amazonaws.com";}i:8;a:2:{s:4:"name";s:14:"REGION_IRELAND";s:5:"value";s:44:"elasticloadbalancing.eu-west-1.amazonaws.com";}i:9;a:2:{s:4:"name";s:13:"REGION_OREGON";s:5:"value";s:44:"elasticloadbalancing.us-west-2.amazonaws.com";}i:10;a:2:{s:4:"name";s:16:"REGION_SAO_PAULO";s:5:"value";s:44:"elasticloadbalancing.sa-east-1.amazonaws.com";}i:11;a:2:{s:4:"name";s:12:"REGION_SA_E1";s:5:"value";s:44:"elasticloadbalancing.sa-east-1.amazonaws.com";}i:12;a:2:{s:4:"name";s:16:"REGION_SINGAPORE";s:5:"value";s:49:"elasticloadbalancing.ap-southeast-1.amazonaws.com";}i:13;a:2:{s:4:"name";s:13:"REGION_SYDNEY";s:5:"value";s:49:"elasticloadbalancing.ap-southeast-2.amazonaws.com";}i:14;a:2:{s:4:"name";s:12:"REGION_TOKYO";s:5:"value";s:49:"elasticloadbalancing.ap-northeast-1.amazonaws.com";}i:15;a:2:{s:4:"name";s:12:"REGION_US_E1";s:5:"value";s:44:"elasticloadbalancing.us-east-1.amazonaws.com";}i:16;a:2:{s:4:"name";s:14:"REGION_US_GOV1";s:5:"value";s:48:"elasticloadbalancing.us-gov-west-1.amazonaws.com";}i:17;a:2:{s:4:"name";s:12:"REGION_US_W1";s:5:"value";s:44:"elasticloadbalancing.us-west-1.amazonaws.com";}i:18;a:2:{s:4:"name";s:12:"REGION_US_W2";s:5:"value";s:44:"elasticloadbalancing.us-west-2.amazonaws.com";}i:19;a:2:{s:4:"name";s:15:"REGION_VIRGINIA";s:5:"value";s:44:"elasticloadbalancing.us-east-1.amazonaws.com";}i:20;a:2:{s:4:"name";s:9:"USERAGENT";s:5:"value";s:65:"aws-sdk-php/1.6.2 PHP/5.4.9 curl/7.15.5 openssl/0.9.8e-fips-rhel5";}i:21;a:2:{s:4:"name";s:7:"VERSION";s:5:"value";s:5:"1.6.2";}}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"40";}s:8:"property";a:40:{i:0;a:4:{s:4:"name";s:11:"api_version";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The supported API version.</p>";}i:1;a:4:{s:4:"name";s:10:"auth_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The authentication class to use.</p>";}i:2;a:4:{s:4:"name";s:10:"auth_token";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The Amazon Authentication Token.</p>";}i:3;a:5:{s:4:"name";s:11:"batch_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:14:"CFBatchRequest";}}s:11:"description";s:185:"<p>The default class to use for handling batch requests (defaults to <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>).</p>";}i:4;a:4:{s:4:"name";s:12:"batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:53:"<p>The current instantiated batch request object.</p>";}i:5;a:4:{s:4:"name";s:11:"cache_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The caching class to use.</p>";}i:6;a:4:{s:4:"name";s:14:"cache_compress";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:38:"<p>The state of cache compression.</p>";}i:7;a:4:{s:4:"name";s:13:"cache_expires";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>When the cache should be considered stale.</p>";}i:8;a:4:{s:4:"name";s:14:"cache_location";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:35:"<p>The caching location to use.</p>";}i:9;a:4:{s:4:"name";s:12:"cache_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The current instantiated cache object.</p>";}i:10;a:4:{s:4:"name";s:11:"credentials";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>The credentials to use for authentication.</p>";}i:11;a:4:{s:4:"name";s:10:"debug_mode";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:43:"<p>The state of the debug mode setting.</p>";}i:12;a:4:{s:4:"name";s:12:"delete_cache";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>The state of the cache deletion setting.</p>";}i:13;a:4:{s:4:"name";s:8:"hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The alternate hostname to use, if any.</p>";}i:14;a:4:{s:4:"name";s:21:"internal_batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:56:"<p>The internally instantiated batch request object.</p>";}i:15;a:4:{s:4:"name";s:3:"key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:26:"<p>The Amazon API Key.</p>";}i:16;a:5:{s:4:"name";s:11:"max_retries";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:1:"3";}}s:11:"description";s:52:"<p>The number of times to retry failed requests.</p>";}i:17;a:4:{s:4:"name";s:9:"operation";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The operation to execute.</p>";}i:18;a:4:{s:4:"name";s:16:"operation_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>The string prefix to prepend to the operation name.</p>";}i:19;a:5:{s:4:"name";s:17:"override_hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:186:"<p>The state of the capability to override the hostname with <a href="../amazonelb/set_hostname.html" rel="../../index.html#m=amazonelb/set_hostname"><code>set_hostname()</code></a>.</p>";}i:20;a:5:{s:4:"name";s:18:"parse_the_response";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:65:"<p>The state of whether the response should be parsed or not.</p>";}i:21;a:5:{s:4:"name";s:12:"parser_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFSimpleXML";}}s:11:"description";s:164:"<p>The default class to use for parsing XML (defaults to <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>).</p>";}i:22;a:4:{s:4:"name";s:7:"payload";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:27:"<p>The payload to send.</p>";}i:23;a:4:{s:4:"name";s:11:"port_number";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:48:"<p>The alternate port number to use, if any.</p>";}i:24;a:4:{s:4:"name";s:5:"proxy";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The proxy to use for connecting.</p>";}i:25;a:4:{s:4:"name";s:9:"redirects";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>The number of times a request has been retried.</p>";}i:26;a:4:{s:4:"name";s:34:"registered_streaming_read_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:77:"<p>The user-defined callback function to call when a stream is read from.</p>";}i:27;a:4:{s:4:"name";s:35:"registered_streaming_write_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:78:"<p>The user-defined callback function to call when a stream is written to.</p>";}i:28;a:5:{s:4:"name";s:13:"request_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:9:"CFRequest";}}s:11:"description";s:160:"<p>The default class to use for HTTP requests (defaults to <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>).</p>";}i:29;a:4:{s:4:"name";s:15:"resource_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:52:"<p>The alternate resource prefix to use, if any.</p>";}i:30;a:5:{s:4:"name";s:14:"response_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:10:"CFResponse";}}s:11:"description";s:164:"<p>The default class to use for HTTP responses (defaults to <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>).</p>";}i:31;a:4:{s:4:"name";s:10:"secret_key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The Amazon API Secret Key.</p>";}i:32;a:4:{s:4:"name";s:7:"service";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>An identifier for the current AWS service.</p>";}i:33;a:5:{s:4:"name";s:16:"ssl_verification";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:49:"<p>The state of SSL certificate verification.</p>";}i:34;a:5:{s:4:"name";s:13:"use_aws_query";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:64:"<p>The state of whether auth should be handled as AWS Query.</p>";}i:35;a:4:{s:4:"name";s:14:"use_batch_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of batch flow usage.</p>";}i:36;a:4:{s:4:"name";s:14:"use_cache_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of cache flow usage.</p>";}i:37;a:5:{s:4:"name";s:7:"use_ssl";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:34:"<p>The state of SSL/HTTPS use.</p>";}i:38;a:4:{s:4:"name";s:4:"util";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Handle for the utility functions.</p>";}i:39;a:5:{s:4:"name";s:15:"utilities_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFUtilities";}}s:11:"description";s:162:"<p>The default class to use for utilities (defaults to <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>).</p>";}}}}}