a:2:{s:4:"file";a:0:{}s:5:"class";a:10:{s:4:"name";s:11:"AuthV2Query";s:4:"file";s:42:"authentication/signature_v2query.class.php";s:3:"url";s:25:"../authv2query/index.html";s:11:"description";s:55:"<p>Implements support for Signature v2 (AWS Query).</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2011.11.22";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:11:"inheritance";a:1:{s:5:"class";a:3:{s:4:"name";s:6:"Signer";s:4:"file";s:34:"authentication/signer.abstract.php";s:3:"url";s:20:"../signer/index.html";}}s:10:"implements";a:1:{s:9:"interface";a:2:{s:4:"name";s:8:"Signable";s:4:"file";s:37:"authentication/signable.interface.php";}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"2";}s:6:"method";a:2:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:148:"<p>Constructs a new instance of the <a href="../authv2query/index.html" rel="../../index.html#i=authv2query"><code>AuthV2Query</code></a> class.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"endpoint";s:4:"type";s:6:"string";s:11:"description";s:45:"<p>The endpoint to direct the request to.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"operation";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>The operation to execute as a result of this request.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"payload";s:4:"type";s:5:"array";s:11:"description";s:64:"<p>The options to use as part of the payload in the request.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"credentials";s:4:"type";s:12:"CFCredential";s:11:"description";s:62:"<p>The credentials to use for signing and making requests.</p>";}}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:163:"public function __construct($endpoint, $operation, $payload, CFCredential $credentials)
{
    parent::__construct($endpoint, $operation, $payload, $credentials);
}";}i:1;a:5:{s:4:"name";s:12:"authenticate";s:8:"modifier";s:6:"public";s:11:"description";s:80:"<p>Generates a cURL handle with all of the required authentication bits set.</p>";s:11:"returnvalue";s:41:"<p>A cURL handle ready for executing.</p>";s:6:"source";s:3970:"public function authenticate()
{
    // Determine signing values
    $current_time = time();
    $date = gmdate(CFUtilities::DATE_FORMAT_RFC2616, $current_time);
    $timestamp = gmdate(CFUtilities::DATE_FORMAT_ISO8601, $current_time);
    $query = array();

    // Do we have an authentication token?
    if ($this-&gt;auth_token)
    {
        $headers['X-Amz-Security-Token'] = $this-&gt;auth_token;
        $query['SecurityToken'] = $this-&gt;auth_token;
    }

    // Only add it if it exists.
    if ($this-&gt;api_version)
    {
        $query['Version'] = $this-&gt;api_version;
    }

    $query['Action'] = $this-&gt;operation;
    $query['AWSAccessKeyId'] = $this-&gt;key;
    $query['SignatureMethod'] = 'HmacSHA256';
    $query['SignatureVersion'] = 2;
    $query['Timestamp'] = $timestamp;

    // Merge in any options that were passed in
    if (is_array($this-&gt;payload))
    {
        $query = array_merge($query, $this-&gt;payload);
    }

    // Do a case-sensitive, natural order sort on the array keys.
    uksort($query, 'strcmp');

    // Create the string that needs to be hashed.
    $canonical_query_string = $this-&gt;util-&gt;to_signable_string($query);

    // Remove the default scheme from the domain.
    $domain = str_replace(array('http://', 'https://'), '', $this-&gt;endpoint);

    // Parse our request.
    $parsed_url = parse_url('http://' . $domain);

    // Set the proper host header.
    if (isset($parsed_url['port']) &amp;&amp; (integer) $parsed_url['port'] !== 80 &amp;&amp; (integer) $parsed_url['port'] !== 443)
    {
        $host_header = strtolower($parsed_url['host']) . ':' . $parsed_url['port'];
    }
    else
    {
        $host_header = strtolower($parsed_url['host']);
    }

    // Set the proper request URI.
    $request_uri = isset($parsed_url['path']) ? $parsed_url['path'] : '/';

    // Prepare the string to sign
    $this-&gt;string_to_sign = &quot;POST\n$host_header\n$request_uri\n$canonical_query_string&quot;;

    // Hash the AWS secret key and generate a signature for the request.
    $query['Signature'] = base64_encode(hash_hmac('sha256', $this-&gt;string_to_sign, $this-&gt;secret_key, true));

    // Generate the querystring from $query
    $this-&gt;querystring = $this-&gt;util-&gt;to_query_string($query);

    // Gather information to pass along to other classes.
    $helpers = array(
        'utilities' =&gt; $this-&gt;utilities_class,
        'request' =&gt; $this-&gt;request_class,
        'response' =&gt; $this-&gt;response_class,
    );

    // Compose the request.
    $request_url = ($this-&gt;use_ssl ? 'https://' : 'http://') . $domain;
    $request_url .= !isset($parsed_url['path']) ? '/' : '';

    // Instantiate the request class
    $request = new $this-&gt;request_class($request_url, $this-&gt;proxy, $helpers, $this-&gt;credentials);
    $request-&gt;set_method('POST');
    $request-&gt;set_body($this-&gt;querystring);
    $headers['Content-Type'] = 'application/x-www-form-urlencoded; charset=utf-8';

    // Pass along registered stream callbacks
    if ($this-&gt;registered_streaming_read_callback)
    {
        $request-&gt;register_streaming_read_callback($this-&gt;registered_streaming_read_callback);
    }

    if ($this-&gt;registered_streaming_write_callback)
    {
        $request-&gt;register_streaming_write_callback($this-&gt;registered_streaming_write_callback);
    }

    // Sort headers
    uksort($headers, 'strnatcasecmp');

    // Add headers to request and compute the string to sign
    foreach ($headers as $header_key =&gt; $header_value)
    {
        // Strip linebreaks from header values as they're illegal and can allow for security issues
        $header_value = str_replace(array(&quot;\r&quot;, &quot;\n&quot;), '', $header_value);

        // Add the header if it has a value
        if ($header_value !== '')
        {
            $request-&gt;add_header($header_key, $header_value);
        }
    }

    return $request;
}";}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"4";}s:8:"property";a:4:{i:0;a:4:{s:4:"name";s:11:"credentials";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:6:"Signer";s:4:"file";s:34:"authentication/signer.abstract.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:62:"<p>The credentials to use for signing and making requests.</p>";}i:1;a:4:{s:4:"name";s:8:"endpoint";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:6:"Signer";s:4:"file";s:34:"authentication/signer.abstract.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The endpoint to direct the request to.</p>";}i:2;a:4:{s:4:"name";s:9:"operation";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:6:"Signer";s:4:"file";s:34:"authentication/signer.abstract.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:60:"<p>The operation to execute as a result of this request.</p>";}i:3;a:4:{s:4:"name";s:7:"payload";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:6:"Signer";s:4:"file";s:34:"authentication/signer.abstract.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:64:"<p>The options to use as part of the payload in the request.</p>";}}}}}