a:2:{s:4:"file";a:0:{}s:5:"class";a:10:{s:4:"name";s:7:"CFArray";s:4:"file";s:25:"utilities/array.class.php";s:3:"url";s:21:"../cfarray/index.html";s:11:"description";s:602:"<p>The <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object extends PHP&#8217;s built-in <a href="http://php.net/arrayobject"><code>ArrayObject</code></a> object by providing convenience methods for
rapidly manipulating array data. Specifically, the <code>CFArray</code> object is intended for working with
<a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> and <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a> objects that are returned by AWS services.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2012.01.17";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";a:2:{i:0;s:47:"http://aws.amazon.com/php/ PHP Developer Center";i:1;s:38:"http://php.net/ArrayObject ArrayObject";}}s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:11:"ArrayObject";s:3:"url";s:26:"http://php.net/arrayobject";}}s:10:"implements";a:1:{s:9:"interface";a:5:{i:0;a:2:{s:4:"name";s:9:"Countable";s:3:"url";s:24:"http://php.net/countable";}i:1;a:2:{s:4:"name";s:12:"Serializable";s:3:"url";s:27:"http://php.net/serializable";}i:2;a:2:{s:4:"name";s:11:"ArrayAccess";s:3:"url";s:26:"http://php.net/arrayaccess";}i:3;a:2:{s:4:"name";s:11:"Traversable";s:3:"url";s:26:"http://php.net/traversable";}i:4;a:2:{s:4:"name";s:17:"IteratorAggregate";s:3:"url";s:32:"http://php.net/iteratoraggregate";}}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"37";}s:6:"method";a:37:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:126:"<p>Constructs a new instance of <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"input";s:4:"type";s:5:"mixed";s:11:"description";s:94:"<p>The input parameter accepts an array or an Object. The default value is an empty array.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"flags";s:4:"type";s:7:"integer";s:11:"description";s:204:"<p>Flags to control the behavior of the ArrayObject object. Defaults to <a href="../cfarray/constants.html#std_prop_list" rel="../../index.html#c=cfarray/std_prop_list"><code>STD_PROP_LIST</code></a>.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:14:"iterator_class";s:4:"type";s:6:"string";s:11:"description";s:234:"<p>Specify the class that will be used for iteration of the <a href="http://php.net/arrayobject"><code>ArrayObject</code></a> object. <a href="http://php.net/arrayiterator"><code>ArrayIterator</code></a> is the default class used.</p>";}}}s:11:"returnvalue";s:157:"<p>Either an array of matches, or a single <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a> element.</p>";s:6:"source";s:381:"public function __construct($input = array(), $flags = self::STD_PROP_LIST, $iterator_class = 'ArrayIterator')
{
    // Provide a default value
    $input = $input ? $input : array();

    try {
        return parent::__construct($input, $flags, $iterator_class);
    }
    catch (InvalidArgumentException $e)
    {
        throw new CFArray_Exception($e-&gt;getMessage());
    }
}";}i:1;a:5:{s:4:"name";s:10:"__toString";s:8:"modifier";s:6:"public";s:11:"description";s:64:"<p>Handles how the object is rendered when cast as a string.</p>";s:11:"returnvalue";s:36:"<p>The word &#8220;Array&#8221;.</p>";s:6:"source";s:52:"public function __toString()
{
    return 'Array';
}";}i:2;a:7:{s:4:"name";s:6:"append";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:47:"<p>Appends a new value as the last element.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"value";s:4:"type";s:5:"mixed";s:11:"description";s:32:"<p>The value being appended.</p>";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:158:"$arrayobj = new ArrayObject(array('first','second','third'));
$arrayobj-&gt;append('fourth');
$arrayobj-&gt;append(array('five', 'six'));
var_dump($arrayobj);";s:6:"result";s:310:"object(ArrayObject)#1 (5) {
  [0]=&gt;
  string(5) &quot;first&quot;
  [1]=&gt;
  string(6) &quot;second&quot;
  [2]=&gt;
  string(5) &quot;third&quot;
  [3]=&gt;
  string(6) &quot;fourth&quot;
  [4]=&gt;
  array(2) {
    [0]=&gt;
    string(4) &quot;five&quot;
    [1]=&gt;
    string(3) &quot;six&quot;
  }
}";}}}i:3;a:5:{s:4:"name";s:5:"areOK";s:8:"modifier";s:6:"public";s:11:"description";s:370:"<p>Verifies that <em>all</em> responses were successful. A single failed request will cause <a href="../cfarray/areok.html" rel="../../index.html#m=cfarray/areok"><code>areOK()</code></a> to return false. Equivalent to <a href="../cfresponse/isok.html" rel="../../index.html#m=cfresponse/isok"><code>CFResponse::isOK()</code></a>, except it applies to all responses.</p>";s:11:"returnvalue";s:60:"<p>Whether <em>all</em> requests were successful or not.</p>";s:6:"source";s:317:"public function areOK()
{
    $dlist = array();
    $list = $this-&gt;getArrayCopy();

    foreach ($list as $response)
    {
        if ($response instanceof CFResponse)
        {
            $dlist[] = $response-&gt;isOK();
        }
    }

    return (array_search(false, $dlist, true) !== false) ? false : true;
}";}i:4;a:6:{s:4:"name";s:5:"asort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:212:"<p>Sorts the entries such that the keys maintain their correlation with the entries they are associated with. This is used mainly when sorting associative arrays where the actual element order is significant.</p>";s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:339:"$fruits = array(&quot;d&quot; =&gt; &quot;lemon&quot;, &quot;a&quot; =&gt; &quot;orange&quot;, &quot;b&quot; =&gt; &quot;banana&quot;, &quot;c&quot; =&gt; &quot;apple&quot;);
$fruitArrayObject = new ArrayObject($fruits);
$fruitArrayObject-&gt;asort();

foreach ($fruitArrayObject as $key =&gt; $val) {
    echo &quot;$key = $val\n&quot;;
}";s:6:"result";s:41:"c = apple
b = banana
d = lemon
a = orange";}}}i:5;a:5:{s:4:"name";s:8:"compress";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>Removes all <code>null</code> values from an array.</p>";s:11:"returnvalue";s:141:"<p>A new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object containing the non-null values.</p>";s:6:"source";s:94:"public function compress()
{
    return new CFArray(array_filter($this-&gt;getArrayCopy()));
}";}i:6;a:6:{s:4:"name";s:5:"count";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:116:"<p>Get the number of public properties in the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:11:"returnvalue";s:112:"<p>The number of public properties in the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:303:"class Example {
    public $public = 'prop:public';
    private $prv   = 'prop:private';
    protected $prt = 'prop:protected';
}

$arrayobj = new ArrayObject(new Example());
var_dump($arrayobj-&gt;count());

$arrayobj = new ArrayObject(array('first','second','third'));
var_dump($arrayobj-&gt;count());";s:6:"result";s:13:"int(1)
int(3)";}}}i:7;a:7:{s:4:"name";s:4:"each";s:8:"modifier";s:6:"public";s:11:"description";s:534:"<p>Iterates over a <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object, and executes a function for each matched element.</p>

<p>The callback function takes three parameters:</p>

<ul><li><code>$item</code> - <code>mixed</code> - Optional - The individual node in the array.</li><li><code>$key</code> - <code>mixed</code> - Optional - The key for the array node.</li><li><code>$bind</code> - <code>mixed</code> - Optional - The variable that was passed into the $bind parameter.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:15:"string|function";s:11:"description";s:88:"<p>The callback function to execute. PHP 5.3 or newer can use an anonymous function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"bind";s:4:"type";s:5:"mixed";s:11:"description";s:108:"<p>A variable from the calling scope to pass-by-reference into the local scope of the callback function.</p>";}}}s:11:"returnvalue";s:117:"<p>The original <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object.</p>";s:6:"source";s:210:"public function each($callback, &amp;$bind = null)
{
    $items = $this-&gt;getArrayCopy();

    foreach ($items as $key =&gt; &amp;$item)
    {
        $callback($item, $key, $bind);
    }

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>New additions in CFArray and CFSimpleXML.</p>";s:11:"description";s:260:"<p>A fairly contrived example showing how to use new additions in CFArray and CFSimpleXML.</p>

<p>This example uses anonymous functions, so it will only work as-is with PHP 5.3+. PHP 5.2.x users can refactor this example to use standard functions instead.</p>";s:4:"code";s:992:"$ec2 = new AmazonEC2();
$response = $ec2-&gt;describe_images();

// Use an XPath query to find a matching set of nodes.
$list = $response-&gt;body-&gt;query('descendant-or-self::item[imageId[contains(., &quot;aki-&quot;)] and architecture = &quot;x86_64&quot; and imageOwnerAlias = &quot;amazon&quot;]/imageLocation');

// CFArray::map() works similarly to array_map().
$results = $list-&gt;map(function($node)
{
	return $node-&gt;parent();
});

// Manually instantiate CFArray.
$image_locations = new CFArray(array());

/*
	For each entry in the $results array, pass it to the anonymous function.
	You can bind a variable (e.g., $image_locations) to the inner scope by
	using pass-by-reference.
*/
$results-&gt;each(function($node, $i, &amp;$image_locations)
{
	$image_locations[] = (string) $node-&gt;imageLocation;

}, $image_locations);

// Display the first and last entries in the resulting array.
echo $image_locations-&gt;first() . PHP_EOL;
echo $image_locations-&gt;last() . PHP_EOL;";s:6:"result";s:141:"ec2-paid-ibm-images-ids/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml
ec2-paid-ibm-images-db2/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml";}}}i:8;a:7:{s:4:"name";s:13:"exchangeArray";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:208:"<p>Exchange the current <a href="http://php.net/array"><code>array</code></a> with another <a href="http://php.net/array"><code>array</code></a> or <a href="http://php.net/object"><code>object</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"array";}}s:11:"returnvalue";s:77:"<p>Returns the old <a href="http://php.net/array"><code>array</code></a>.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:431:"// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);
// Array of locations in Europe
$locations = array('Amsterdam', 'Paris', 'London');

$fruitsArrayObject = new ArrayObject($fruits);

// Now exchange fruits for locations
$old = $fruitsArrayObject-&gt;exchangeArray($locations);
print_r($old);
print_r($fruitsArrayObject);";s:6:"result";s:184:"Array
(
    [lemons] =&gt; 1
    [oranges] =&gt; 4
    [bananas] =&gt; 5
    [apples] =&gt; 10
)
ArrayObject Object
(
    [0] =&gt; Amsterdam
    [1] =&gt; Paris
    [2] =&gt; London
)";}}}i:9;a:6:{s:4:"name";s:6:"filter";s:8:"modifier";s:6:"public";s:11:"description";s:619:"<p>Filters the list of nodes by passing each value in the current <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object through a function. The node will be removed if the function returns <code>false</code>.</p>

<p>The callback function takes three parameters:</p>

<ul><li><code>$item</code> - <code>mixed</code> - Optional - The individual node in the array.</li><li><code>$key</code> - <code>mixed</code> - Optional - The key for the array node.</li><li><code>$bind</code> - <code>mixed</code> - Optional - The variable that was passed into the $bind parameter.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:15:"string|function";s:11:"description";s:88:"<p>The callback function to execute. PHP 5.3 or newer can use an anonymous function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"bind";s:4:"type";s:5:"mixed";s:11:"description";s:108:"<p>A variable from the calling scope to pass-by-reference into the local scope of the callback function.</p>";}}}s:11:"returnvalue";s:139:"<p>A new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object containing the return values.</p>";s:6:"source";s:318:"public function filter($callback, &amp;$bind = null)
{
    $items = $this-&gt;getArrayCopy();
    $collect = array();

    foreach ($items as $key =&gt; &amp;$item)
    {
        if ($callback($item, $key, $bind) !== false)
        {
            $collect[] = $item;
        }
    }

    return new CFArray($collect);
}";}i:10;a:6:{s:4:"name";s:5:"first";s:8:"modifier";s:6:"public";s:11:"description";s:42:"<p>Gets the first result in the array.</p>";s:11:"returnvalue";s:191:"<p>The first result in the <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object. Returns <code>false</code> if there are no items in the array.</p>";s:6:"source";s:112:"public function first()
{
    $items = $this-&gt;getArrayCopy();
    return count($items) ? $items[0] : false;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>New additions in CFArray and CFSimpleXML.</p>";s:11:"description";s:260:"<p>A fairly contrived example showing how to use new additions in CFArray and CFSimpleXML.</p>

<p>This example uses anonymous functions, so it will only work as-is with PHP 5.3+. PHP 5.2.x users can refactor this example to use standard functions instead.</p>";s:4:"code";s:992:"$ec2 = new AmazonEC2();
$response = $ec2-&gt;describe_images();

// Use an XPath query to find a matching set of nodes.
$list = $response-&gt;body-&gt;query('descendant-or-self::item[imageId[contains(., &quot;aki-&quot;)] and architecture = &quot;x86_64&quot; and imageOwnerAlias = &quot;amazon&quot;]/imageLocation');

// CFArray::map() works similarly to array_map().
$results = $list-&gt;map(function($node)
{
	return $node-&gt;parent();
});

// Manually instantiate CFArray.
$image_locations = new CFArray(array());

/*
	For each entry in the $results array, pass it to the anonymous function.
	You can bind a variable (e.g., $image_locations) to the inner scope by
	using pass-by-reference.
*/
$results-&gt;each(function($node, $i, &amp;$image_locations)
{
	$image_locations[] = (string) $node-&gt;imageLocation;

}, $image_locations);

// Display the first and last entries in the resulting array.
echo $image_locations-&gt;first() . PHP_EOL;
echo $image_locations-&gt;last() . PHP_EOL;";s:6:"result";s:141:"ec2-paid-ibm-images-ids/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml
ec2-paid-ibm-images-db2/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml";}}}i:11;a:6:{s:4:"name";s:12:"getArrayCopy";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:97:"<p>Exports the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a> to an array.</p>";s:11:"returnvalue";s:197:"<p>Returns a copy of the array. When the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a> refers to an object an array of the public properties of that object will be returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:335:"// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);

$fruitsArrayObject = new ArrayObject($fruits);
$fruitsArrayObject['pears'] = 4;

// create a copy of the array
$copy = $fruitsArrayObject-&gt;getArrayCopy();
print_r($copy);";s:6:"result";s:116:"Array
(
    [lemons] =&gt; 1
    [oranges] =&gt; 4
    [bananas] =&gt; 5
    [apples] =&gt; 10
    [pears] =&gt; 4
)";}}}i:12;a:6:{s:4:"name";s:8:"getFlags";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:239:"<p>Gets the behavior flags of the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>. See the <a href="http://php.net/arrayobject.setflags"><code>ArrayObject::setFlags</code></a> method for a list of the available flags.</p>";s:11:"returnvalue";s:53:"<p>Returns the behavior flags of the ArrayObject.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:460:"// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);

$fruitsArrayObject = new ArrayObject($fruits);

// Get the current flags
$flags = $fruitsArrayObject-&gt;getFlags();
var_dump($flags);

// Set new flags
$fruitsArrayObject-&gt;setFlags(ArrayObject::ARRAY_AS_PROPS);

// Get the new flags
$flags = $fruitsArrayObject-&gt;getFlags();
var_dump($flags);";s:6:"result";s:13:"int(0)
int(2)";}}}i:13;a:6:{s:4:"name";s:11:"getIterator";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:112:"<p>Create a new iterator from an <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a> instance.</p>";s:11:"returnvalue";s:93:"<p>An iterator from an <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:330:"$array = array('1' =&gt; 'one',
               '2' =&gt; 'two',
               '3' =&gt; 'three');

$arrayobject = new ArrayObject($array);

$iterator = $arrayobject-&gt;getIterator();

while($iterator-&gt;valid()) {
    echo $iterator-&gt;key() . ' =&gt; ' . $iterator-&gt;current() . &quot;\n&quot;;

    $iterator-&gt;next();
}";s:6:"result";s:37:"1 =&gt; one
2 =&gt; two
3 =&gt; three";}}}i:14;a:6:{s:4:"name";s:16:"getIteratorClass";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:158:"<p>Gets the class name of the array iterator that is used by <a href="http://php.net/arrayobject.getiterator"><code>ArrayObject::getIterator()</code></a>.</p>";s:11:"returnvalue";s:80:"<p>Returns the iterator class name that is used to iterate over this object.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:644:"// Custom ArrayIterator (inherits from ArrayIterator)
class MyArrayIterator extends ArrayIterator {
    // custom implementation
}

// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);

$fruitsArrayObject = new ArrayObject($fruits);

// Get the current class name
$className = $fruitsArrayObject-&gt;getIteratorClass();
var_dump($className);

// Set new classname
$fruitsArrayObject-&gt;setIteratorClass('MyArrayIterator');

// Get the new iterator classname
$className = $fruitsArrayObject-&gt;getIteratorClass();
var_dump($className);";s:6:"result";s:75:"string(13) &quot;ArrayIterator&quot;
string(15) &quot;MyArrayIterator&quot;";}}}i:15;a:6:{s:4:"name";s:4:"init";s:8:"modifier";s:13:"public static";s:11:"description";s:76:"<p>Alternate approach to constructing a new instance. Supports chaining.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"input";s:4:"type";s:5:"mixed";s:11:"description";s:94:"<p>The input parameter accepts an array or an Object. The default value is an empty array.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"flags";s:4:"type";s:7:"integer";s:11:"description";s:204:"<p>Flags to control the behavior of the ArrayObject object. Defaults to <a href="../cfarray/constants.html#std_prop_list" rel="../../index.html#c=cfarray/std_prop_list"><code>STD_PROP_LIST</code></a>.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:14:"iterator_class";s:4:"type";s:6:"string";s:11:"description";s:234:"<p>Specify the class that will be used for iteration of the <a href="http://php.net/arrayobject"><code>ArrayObject</code></a> object. <a href="http://php.net/arrayiterator"><code>ArrayIterator</code></a> is the default class used.</p>";}}}s:11:"returnvalue";s:157:"<p>Either an array of matches, or a single <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a> element.</p>";s:6:"source";s:377:"public static function init($input = array(), $flags = self::STD_PROP_LIST, $iterator_class = 'ArrayIterator')
{
    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))
    {
        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::init().');
    }

    $self = get_called_class();
    return new $self($input, $flags, $iterator_class);
}";}i:16;a:6:{s:4:"name";s:5:"ksort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:117:"<p>Sorts the entries by key, maintaining key to entry correlations. This is useful mainly for associative arrays.</p>";s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:339:"$fruits = array(&quot;d&quot; =&gt; &quot;lemon&quot;, &quot;a&quot; =&gt; &quot;orange&quot;, &quot;b&quot; =&gt; &quot;banana&quot;, &quot;c&quot; =&gt; &quot;apple&quot;);
$fruitArrayObject = new ArrayObject($fruits);
$fruitArrayObject-&gt;ksort();

foreach ($fruitArrayObject as $key =&gt; $val) {
    echo &quot;$key = $val\n&quot;;
}";s:6:"result";s:41:"a = orange
b = banana
c = apple
d = lemon";}}}i:17;a:6:{s:4:"name";s:4:"last";s:8:"modifier";s:6:"public";s:11:"description";s:41:"<p>Gets the last result in the array.</p>";s:11:"returnvalue";s:190:"<p>The last result in the <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object. Returns <code>false</code> if there are no items in the array.</p>";s:6:"source";s:113:"public function last()
{
    $items = $this-&gt;getArrayCopy();
    return count($items) ? end($items) : false;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>New additions in CFArray and CFSimpleXML.</p>";s:11:"description";s:260:"<p>A fairly contrived example showing how to use new additions in CFArray and CFSimpleXML.</p>

<p>This example uses anonymous functions, so it will only work as-is with PHP 5.3+. PHP 5.2.x users can refactor this example to use standard functions instead.</p>";s:4:"code";s:992:"$ec2 = new AmazonEC2();
$response = $ec2-&gt;describe_images();

// Use an XPath query to find a matching set of nodes.
$list = $response-&gt;body-&gt;query('descendant-or-self::item[imageId[contains(., &quot;aki-&quot;)] and architecture = &quot;x86_64&quot; and imageOwnerAlias = &quot;amazon&quot;]/imageLocation');

// CFArray::map() works similarly to array_map().
$results = $list-&gt;map(function($node)
{
	return $node-&gt;parent();
});

// Manually instantiate CFArray.
$image_locations = new CFArray(array());

/*
	For each entry in the $results array, pass it to the anonymous function.
	You can bind a variable (e.g., $image_locations) to the inner scope by
	using pass-by-reference.
*/
$results-&gt;each(function($node, $i, &amp;$image_locations)
{
	$image_locations[] = (string) $node-&gt;imageLocation;

}, $image_locations);

// Display the first and last entries in the resulting array.
echo $image_locations-&gt;first() . PHP_EOL;
echo $image_locations-&gt;last() . PHP_EOL;";s:6:"result";s:141:"ec2-paid-ibm-images-ids/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml
ec2-paid-ibm-images-db2/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml";}}}i:18;a:7:{s:4:"name";s:3:"map";s:8:"modifier";s:6:"public";s:11:"description";s:668:"<p>Passes each element in the current <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object through a function, and produces a new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object containing the return values.</p>

<p>The callback function takes three parameters:</p>

<ul><li><code>$item</code> - <code>mixed</code> - Optional - The individual node in the array.</li><li><code>$key</code> - <code>mixed</code> - Optional - The key for the array node.</li><li><code>$bind</code> - <code>mixed</code> - Optional - The variable that was passed into the $bind parameter.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:15:"string|function";s:11:"description";s:88:"<p>The callback function to execute. PHP 5.3 or newer can use an anonymous function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"bind";s:4:"type";s:5:"mixed";s:11:"description";s:108:"<p>A variable from the calling scope to pass-by-reference into the local scope of the callback function.</p>";}}}s:11:"returnvalue";s:139:"<p>A new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object containing the return values.</p>";s:6:"source";s:262:"public function map($callback, &amp;$bind = null)
{
    $items = $this-&gt;getArrayCopy();
    $collect = array();

    foreach ($items as $key =&gt; &amp;$item)
    {
        $collect[] = $callback($item, $key, $bind);
    }

    return new CFArray($collect);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>New additions in CFArray and CFSimpleXML.</p>";s:11:"description";s:260:"<p>A fairly contrived example showing how to use new additions in CFArray and CFSimpleXML.</p>

<p>This example uses anonymous functions, so it will only work as-is with PHP 5.3+. PHP 5.2.x users can refactor this example to use standard functions instead.</p>";s:4:"code";s:992:"$ec2 = new AmazonEC2();
$response = $ec2-&gt;describe_images();

// Use an XPath query to find a matching set of nodes.
$list = $response-&gt;body-&gt;query('descendant-or-self::item[imageId[contains(., &quot;aki-&quot;)] and architecture = &quot;x86_64&quot; and imageOwnerAlias = &quot;amazon&quot;]/imageLocation');

// CFArray::map() works similarly to array_map().
$results = $list-&gt;map(function($node)
{
	return $node-&gt;parent();
});

// Manually instantiate CFArray.
$image_locations = new CFArray(array());

/*
	For each entry in the $results array, pass it to the anonymous function.
	You can bind a variable (e.g., $image_locations) to the inner scope by
	using pass-by-reference.
*/
$results-&gt;each(function($node, $i, &amp;$image_locations)
{
	$image_locations[] = (string) $node-&gt;imageLocation;

}, $image_locations);

// Display the first and last entries in the resulting array.
echo $image_locations-&gt;first() . PHP_EOL;
echo $image_locations-&gt;last() . PHP_EOL;";s:6:"result";s:141:"ec2-paid-ibm-images-ids/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml
ec2-paid-ibm-images-db2/vmlinuz-2.6.16.60-0.30-xen.x86_64.manifest.xml";}}}i:19;a:5:{s:4:"name";s:11:"map_integer";s:8:"modifier";s:6:"public";s:11:"description";s:143:"<p>Maps each element in the <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object as an integer.</p>";s:11:"returnvalue";s:143:"<p>The contents of the <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object mapped as integers.</p>";s:6:"source";s:91:"public function map_integer()
{
    return array_map('intval', $this-&gt;getArrayCopy());
}";}i:20;a:6:{s:4:"name";s:10:"map_string";s:8:"modifier";s:6:"public";s:11:"description";s:59:"<p>Maps each element in the CFArray object as a string.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"pcre";s:4:"type";s:6:"string";s:11:"description";s:79:"<p>A Perl-Compatible Regular Expression (PCRE) to filter the names against.</p>";}}s:11:"returnvalue";s:206:"<p>The contents of the <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object mapped as strings. If there are no results, the method will return an empty array.</p>";s:6:"source";s:342:"public function map_string($pcre = null)
{
    $list = array_map('strval', $this-&gt;getArrayCopy());
    $dlist = array();

    if ($pcre)
    {
        foreach ($list as $item)
        {
            $dlist[] = preg_match($pcre, $item) ? $item : null;
        }

        $list = array_values(array_filter($dlist));
    }

    return $list;
}";}i:21;a:6:{s:4:"name";s:11:"natcasesort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:343:"<p>This method is a case insensitive version of <a href="http://php.net/arrayobject.natsort"><code>ArrayObject::natsort</code></a>.</p>
<p>This method implements a sort algorithm that orders alphanumeric strings in the way a human being would while maintaining key/value associations. This is described as a &#8220;natural ordering&#8221;.</p>";s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:322:"$array = array('IMG0.png', 'img12.png', 'img10.png', 'img2.png', 'img1.png', 'IMG3.png');

$arr1 = new ArrayObject($array);
$arr2 = clone $arr1;

$arr1-&gt;asort();
echo &quot;Standard sorting\n&quot;;
print_r($arr1);

$arr2-&gt;natcasesort();
echo &quot;\nNatural order sorting (case-insensitive)\n&quot;;
print_r($arr2);";s:6:"result";s:384:"Standard sorting
ArrayObject Object
(
    [0] =&gt; IMG0.png
    [5] =&gt; IMG3.png
    [4] =&gt; img1.png
    [2] =&gt; img10.png
    [1] =&gt; img12.png
    [3] =&gt; img2.png
)

Natural order sorting (case-insensitive)
ArrayObject Object
(
    [0] =&gt; IMG0.png
    [4] =&gt; img1.png
    [3] =&gt; img2.png
    [5] =&gt; IMG3.png
    [2] =&gt; img10.png
    [1] =&gt; img12.png
)";}}}i:22;a:6:{s:4:"name";s:7:"natsort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:440:"<p>This method implements a sort algorithm that orders alphanumeric strings in the way a human being would while maintaining key/value associations. This is described as a &#8220;natural ordering&#8221;. An example of the difference between this algorithm and the regular computer string sorting algorithms (used in <a href="http://php.net/arrayobject.asort"><code>ArrayObject::asort</code></a>) method can be seen in the example below.</p>";s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:315:"$array = array(&quot;img12.png&quot;, &quot;img10.png&quot;, &quot;img2.png&quot;, &quot;img1.png&quot;);

$arr1 = new ArrayObject($array);
$arr2 = clone $arr1;

$arr1-&gt;asort();
echo &quot;Standard sorting\n&quot;;
print_r($arr1);

$arr2-&gt;natsort();
echo &quot;\nNatural order sorting\n&quot;;
print_r($arr2);";s:6:"result";s:273:"Standard sorting
ArrayObject Object
(
    [3] =&gt; img1.png
    [1] =&gt; img10.png
    [0] =&gt; img12.png
    [2] =&gt; img2.png
)

Natural order sorting
ArrayObject Object
(
    [3] =&gt; img1.png
    [2] =&gt; img2.png
    [1] =&gt; img10.png
    [0] =&gt; img12.png
)";}}}i:23;a:6:{s:4:"name";s:12:"offsetExists";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"index";s:4:"type";s:5:"mixed";s:11:"description";s:31:"<p>The index being checked.</p>";}}s:11:"returnvalue";s:84:"<p><code>TRUE</code> if the requested index exists, otherwise <code>FALSE</code></p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:212:"$arrayobj = new ArrayObject(array('zero', 'one', 'example'=&gt;'e.g.'));
var_dump($arrayobj-&gt;offsetExists(1));
var_dump($arrayobj-&gt;offsetExists('example'));
var_dump($arrayobj-&gt;offsetExists('notfound'));";s:6:"result";s:33:"bool(true)
bool(true)
bool(false)";}}}i:24;a:6:{s:4:"name";s:9:"offsetGet";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"index";s:4:"type";s:5:"mixed";s:11:"description";s:32:"<p>The index with the value.</p>";}}s:11:"returnvalue";s:62:"<p>The value at the specified index or <code>FALSE</code>.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:202:"$arrayobj = new ArrayObject(array('zero', 7, 'example'=&gt;'e.g.'));
var_dump($arrayobj-&gt;offsetGet(1));
var_dump($arrayobj-&gt;offsetGet('example'));
var_dump($arrayobj-&gt;offsetExists('notfound'));";s:6:"result";s:45:"int(7)
string(4) &quot;e.g.&quot;
bool(false)";}}}i:25;a:7:{s:4:"name";s:9:"offsetSet";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:55:"<p>Sets the value at the specified index to newval.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"index";s:4:"type";s:5:"mixed";s:11:"description";s:27:"<p>The index being set.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"newval";s:4:"type";s:5:"mixed";s:11:"description";s:49:"<p>The new value for the <code>index</code> .</p>";}}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:320:"class Example {
    public $property = 'prop:public';
}
$arrayobj = new ArrayObject(new Example());
$arrayobj-&gt;offsetSet(4, 'four');
$arrayobj-&gt;offsetSet('group', array('g1', 'g2'));
var_dump($arrayobj);

$arrayobj = new ArrayObject(array('zero','one'));
$arrayobj-&gt;offsetSet(null, 'last');
var_dump($arrayobj);";s:6:"result";s:413:"object(ArrayObject)#1 (3) {
  [&quot;property&quot;]=&gt;
  string(11) &quot;prop:public&quot;
  [4]=&gt;
  string(4) &quot;four&quot;
  [&quot;group&quot;]=&gt;
  array(2) {
    [0]=&gt;
    string(2) &quot;g1&quot;
    [1]=&gt;
    string(2) &quot;g2&quot;
  }
}
object(ArrayObject)#3 (3) {
  [0]=&gt;
  string(4) &quot;zero&quot;
  [1]=&gt;
  string(3) &quot;one&quot;
  [2]=&gt;
  string(4) &quot;last&quot;
}";}}}i:26;a:7:{s:4:"name";s:11:"offsetUnset";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:47:"<p>Unsets the value at the specified index.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"index";s:4:"type";s:5:"mixed";s:11:"description";s:29:"<p>The index being unset.</p>";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:112:"$arrayobj = new ArrayObject(array(0=&gt;'zero',2=&gt;'two'));
$arrayobj-&gt;offsetUnset(2);
var_dump($arrayobj);";s:6:"result";s:69:"object(ArrayObject)#1 (1) {
  [0]=&gt;
  string(4) &quot;zero&quot;
}";}}}i:27;a:6:{s:4:"name";s:6:"reduce";s:8:"modifier";s:6:"public";s:11:"description";s:205:"<p>Alias for <a href="../cfarray/filter.html" rel="../../index.html#m=cfarray/filter"><code>filter()</code></a>. This functionality was incorrectly named <em>reduce</em> in earlier versions of the SDK.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:15:"string|function";s:11:"description";s:88:"<p>The callback function to execute. PHP 5.3 or newer can use an anonymous function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"bind";s:4:"type";s:5:"mixed";s:11:"description";s:108:"<p>A variable from the calling scope to pass-by-reference into the local scope of the callback function.</p>";}}}s:11:"returnvalue";s:139:"<p>A new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object containing the return values.</p>";s:6:"source";s:103:"public function reduce($callback, &amp;$bind = null)
{
    return $this-&gt;filter($callback, $bind);
}";}i:28;a:5:{s:4:"name";s:7:"reindex";s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>Reindexes the array, starting from zero.</p>";s:11:"returnvalue";s:140:"<p>A new <a href="../cfarray/index.html" rel="../../index.html#i=cfarray"><code>CFArray</code></a> object with indexes starting at zero.</p>";s:6:"source";s:93:"public function reindex()
{
    return new CFArray(array_values($this-&gt;getArrayCopy()));
}";}i:29;a:7:{s:4:"name";s:9:"serialize";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:87:"<p>Serializes an <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:11:"returnvalue";s:110:"<p>The serialized representation of the <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:102:"$o = new ArrayObject();

$s1 = serialize($o);
$s2 = $o-&gt;serialize();

var_dump($s1);
var_dump($s2);";s:6:"result";s:123:"string(45) &quot;C:11:&quot;ArrayObject&quot;:21:{x:i:0;a:0:{};m:a:0:{}}&quot;
string(21) &quot;x:i:0;a:0:{};m:a:0:{}&quot;";}}s:7:"related";a:1:{s:6:"method";s:61:"<a href="http://php.net/serialize"><code>serialize</code></a>";}}i:30;a:7:{s:4:"name";s:8:"setFlags";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:65:"<p>Set the flags that change the behavior of the ArrayObject.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"flags";s:4:"type";s:7:"integer";s:11:"description";s:814:"<p>The new ArrayObject behavior. It takes on either a bitmask, or named constants. Using named constants is strongly encouraged to ensure compatibility for future versions.</p><p>The available behavior flags are listed below. The actual meanings of these flags are described in the <a href="http://php.net/arrayobject.constants"><code>predefined constants</code></a>. <table> <title>ArrayObject behavior flags</title> <tgroup cols="2"> <thead> <tr> <td>value</td> <td>constant</td> </tr> </thead> <tbody> <tr> <td>1</td> <td> <a href="http://php.net/arrayobject.constants.std-prop-list"><code>ArrayObject::STD_PROP_LIST</code></a> </td> </tr> <tr> <td>2</td> <td> <a href="http://php.net/arrayobject.constants.array-as-props"><code>ArrayObject::ARRAY_AS_PROPS</code></a> </td> </tr> </tbody> </tgroup> </table></p>";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:489:"// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);

$fruitsArrayObject = new ArrayObject($fruits);

// Try to use array key as property
var_dump($fruitsArrayObject-&gt;lemons);
// Set the flag so that the array keys can be used as properties of the ArrayObject
$fruitsArrayObject-&gt;setFlags(ArrayObject::ARRAY_AS_PROPS);
// Try it again
var_dump($fruitsArrayObject-&gt;lemons);";s:6:"result";s:11:"NULL
int(1)";}}}i:31;a:7:{s:4:"name";s:16:"setIteratorClass";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:157:"<p>Sets the classname of the array iterator that is used by <a href="http://php.net/arrayobject.getiterator"><code>ArrayObject::getIterator()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"iteratorClass";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:491:"// Custom ArrayIterator (inherits from ArrayIterator)
class MyArrayIterator extends ArrayIterator {
    // custom implementation
}

// Array of available fruits
$fruits = array(&quot;lemons&quot; =&gt; 1, &quot;oranges&quot; =&gt; 4, &quot;bananas&quot; =&gt; 5, &quot;apples&quot; =&gt; 10);

$fruitsArrayObject = new ArrayObject($fruits);

// Set the iterator classname to the newly
$fruitsArrayObject-&gt;setIteratorClass('MyArrayIterator');
print_r($fruitsArrayObject-&gt;getIterator());";s:6:"result";s:113:"MyArrayIterator Object
(
    [lemons] =&gt; 1
    [oranges] =&gt; 4
    [bananas] =&gt; 5
    [apples] =&gt; 10
)";}}}i:32;a:5:{s:4:"name";s:7:"to_json";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Gets the current XML node as a JSON string.</p>";s:11:"returnvalue";s:45:"<p>The current XML node as a JSON string.</p>";s:6:"source";s:79:"public function to_json()
{
    return json_encode($this-&gt;getArrayCopy());
}";}i:33;a:5:{s:4:"name";s:7:"to_yaml";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Gets the current XML node as a YAML string.</p>";s:11:"returnvalue";s:45:"<p>The current XML node as a YAML string.</p>";s:6:"source";s:83:"public function to_yaml()
{
    return sfYaml::dump($this-&gt;getArrayCopy(), 5);
}";}i:34;a:7:{s:4:"name";s:6:"uasort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:274:"<p>This function sorts the entries such that keys maintain their correlation with the entry that they are associated with, using a user-defined comparison function.</p>
<p>This is used mainly when sorting associative arrays where the actual element order is significant.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"cmp_function";s:4:"type";s:8:"callable";s:11:"description";s:305:"<p>Function <code>cmp_function</code> should accept two parameters which will be filled by pairs of entries. The comparison function must return an integer less than, equal to, or greater than zero if the first argument is considered to be respectively less than, equal to, or greater than the second.</p>";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:428:"// Comparison function
function cmp($a, $b) {
    if ($a == $b) {
        return 0;
    }
    return ($a &lt; $b) ? -1 : 1;
}

// Array to be sorted
$array = array('a' =&gt; 4, 'b' =&gt; 8, 'c' =&gt; -1, 'd' =&gt; -9, 'e' =&gt; 2, 'f' =&gt; 5, 'g' =&gt; 3, 'h' =&gt; -4);
$arrayObject = new ArrayObject($array);
print_r($arrayObject);

// Sort and print the resulting array
$arrayObject-&gt;uasort('cmp');
print_r($arrayObject);";s:6:"result";s:281:"Array
(
    [a] =&gt; 4
    [b] =&gt; 8
    [c] =&gt; -1
    [d] =&gt; -9
    [e] =&gt; 2
    [f] =&gt; 5
    [g] =&gt; 3
    [h] =&gt; -4
)
Array
(
    [d] =&gt; -9
    [h] =&gt; -4
    [c] =&gt; -1
    [e] =&gt; 2
    [g] =&gt; 3
    [a] =&gt; 4
    [f] =&gt; 5
    [b] =&gt; 8
)";}}}i:35;a:7:{s:4:"name";s:6:"uksort";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:143:"<p>This function sorts the keys of the entries using a user-supplied comparison function. The key to entry correlations will be maintained.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"cmp_function";s:4:"type";s:8:"callable";s:11:"description";s:348:"<p>The callback comparison function.</p><p>Function <code>cmp_function</code> should accept two parameters which will be filled by pairs of entry keys. The comparison function must return an integer less than, equal to, or greater than zero if the first argument is considered to be respectively less than, equal to, or greater than the second.</p>";}}s:11:"returnvalue";s:28:"<p>No value is returned.</p>";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:14:"<p>example</p>";s:4:"code";s:445:"function cmp($a, $b) {
    $a = preg_replace('@^(a|an|the) @', '', $a);
    $b = preg_replace('@^(a|an|the) @', '', $b);
    return strcasecmp($a, $b);
}

$array = array(&quot;John&quot; =&gt; 1, &quot;the Earth&quot; =&gt; 2, &quot;an apple&quot; =&gt; 3, &quot;a banana&quot; =&gt; 4);
$arrayObject = new ArrayObject($array);
$arrayObject-&gt;uksort('cmp');

foreach ($arrayObject as $key =&gt; $value) {
    echo &quot;$key: $value\n&quot;;
}";s:6:"result";s:44:"an apple: 3
a banana: 4
the Earth: 2
John: 1";}}}i:36;a:8:{s:4:"name";s:11:"unserialize";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:11:"ArrayObject";}}s:11:"description";s:99:"<p>Unserializes a serialized <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"serialized";s:4:"type";s:6:"string";s:11:"description";s:88:"<p>The serialized <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";}}s:11:"returnvalue";s:90:"<p>The unserialized <a href="http://php.net/ArrayObject"><code>ArrayObject</code></a>.</p>";s:8:"examples";a:0:{}s:7:"related";a:1:{s:6:"method";s:65:"<a href="http://php.net/unserialize"><code>unserialize</code></a>";}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"2";}s:8:"constant";a:2:{i:0;a:2:{s:4:"name";s:14:"ARRAY_AS_PROPS";s:5:"value";s:1:"2";}i:1;a:2:{s:4:"name";s:13:"STD_PROP_LIST";s:5:"value";s:1:"1";}}}s:10:"properties";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}}}