a:2:{s:4:"file";a:0:{}s:5:"class";a:8:{s:4:"name";s:13:"CFComplexType";s:4:"file";s:31:"utilities/complextype.class.php";s:3:"url";s:27:"../cfcomplextype/index.html";s:11:"description";s:108:"<p>Contains utility methods used for converting array, JSON, and YAML data types into query string keys.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2010.11.11";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"4";}s:6:"method";a:4:{i:0;a:7:{s:4:"name";s:4:"json";s:8:"modifier";s:13:"public static";s:11:"description";s:73:"<p>Takes a JSON object, as a string, to convert to query string keys.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"json";s:4:"type";s:6:"string";s:11:"description";s:207:"<p>A JSON object. The JSON string should use canonical rules (e.g., double quotes, quoted keys) as is required by PHP&#8217;s <a href="http://php.net/json_encode"><code>json_encode()</code></a> function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:6:"member";s:4:"type";s:6:"string";s:11:"description";s:126:"<p>The name of the &#8220;member&#8221; property that AWS uses for lists in certain services. Defaults to an empty string.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"default_key";s:4:"type";s:6:"string";s:11:"description";s:109:"<p>The default key to use when the value for <code>$data</code> is a string. Defaults to an empty string.</p>";}}}s:11:"returnvalue";s:100:"<p>The option group parameters to merge into another method&#8217;s <code>$opt</code> parameter.</p>";s:6:"source";s:151:"public static function json($json, $member = '', $default_key = '')
{
    return self::option_group(json_decode($json, true), $member, $default_key);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:51:"<p>Convert a JSON object into a parameter list.</p>";s:4:"code";s:1046:"// Test data
$json = '{
	&quot;IpPermissions&quot;: [
		{
			&quot;IpProtocol&quot;: &quot;tcp&quot;,
			&quot;FromPort&quot;: 3023,
			&quot;ToPort&quot;: 3024,
			&quot;Groups&quot;: [
				{ &quot;UserId&quot;: &quot;user1&quot;, &quot;GroupName&quot;: &quot;group1&quot; },
				{ &quot;UserId&quot;: &quot;user2&quot;, &quot;GroupName&quot;: &quot;group2&quot; }
			],
			&quot;IpRanges&quot;: [
				{ &quot;CidrIp&quot;: &quot;192.168.0.1&quot; },
				{ &quot;CidrIp&quot;: &quot;192.168.0.2&quot; }
			]
		},
		{
			&quot;IpProtocol&quot;: &quot;tcp&quot;,
			&quot;FromPort&quot;: 3023,
			&quot;ToPort&quot;: 3024,
			&quot;Groups&quot;: [
				{ &quot;UserId&quot;: &quot;user1&quot;, &quot;GroupName&quot;: &quot;group1&quot; },
				{ &quot;UserId&quot;: &quot;user2&quot;, &quot;GroupName&quot;: &quot;group2&quot; }
			],
			&quot;IpRanges&quot;: [
				{ &quot;CidrIp&quot;: &quot;192.168.0.1&quot; },
				{ &quot;CidrIp&quot;: &quot;192.168.0.2&quot; }
			]
		}
	]
}';

$data = CFComplexType::json($json);

// Success?
var_dump($data);";s:6:"result";s:1121:"array(18) {
  ["IpPermissions.1.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.1.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.1.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.1.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.1.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.1.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.1.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.1.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.1.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
  ["IpPermissions.2.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.2.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.2.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.2.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.2.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.2.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.2.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.2.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.2.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
}";}}}i:1;a:7:{s:4:"name";s:3:"map";s:8:"modifier";s:13:"public static";s:11:"description";s:66:"<p>Takes an associative array to convert to query string keys.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:3:"map";s:4:"type";s:5:"array";s:11:"description";s:28:"<p>An associative array.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:6:"member";s:4:"type";s:6:"string";s:11:"description";s:126:"<p>The name of the &#8220;member&#8221; property that AWS uses for lists in certain services. Defaults to an empty string.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"default_key";s:4:"type";s:6:"string";s:11:"description";s:109:"<p>The default key to use when the value for <code>$data</code> is a string. Defaults to an empty string.</p>";}}}s:11:"returnvalue";s:100:"<p>The option group parameters to merge into another method&#8217;s <code>$opt</code> parameter.</p>";s:6:"source";s:129:"public static function map($map, $member = '', $default_key = '')
{
    return self::option_group($map, $member, $default_key);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:68:"<p>Convert a native PHP associative array into a parameter list.</p>";s:4:"code";s:1248:"// Test data
$map = array(
	&quot;IpPermissions&quot; =&gt; array(
		array(
			&quot;IpProtocol&quot; =&gt; &quot;tcp&quot;,
			&quot;FromPort&quot;   =&gt; 3023,
			&quot;ToPort&quot;     =&gt; 3024,
			&quot;Groups&quot;     =&gt; array(
				array( &quot;UserId&quot; =&gt; &quot;user1&quot;, &quot;GroupName&quot; =&gt; &quot;group1&quot; ),
				array( &quot;UserId&quot; =&gt; &quot;user2&quot;, &quot;GroupName&quot; =&gt; &quot;group2&quot; )
			),
			&quot;IpRanges&quot; =&gt; array(
				array(&quot;CidrIp&quot; =&gt; &quot;192.168.0.1&quot;),
				array(&quot;CidrIp&quot; =&gt; &quot;192.168.0.2&quot;)
			)
		),
		array(
			&quot;IpProtocol&quot; =&gt; &quot;tcp&quot;,
			&quot;FromPort&quot;   =&gt; 3023,
			&quot;ToPort&quot;     =&gt; 3024,
			&quot;Groups&quot;     =&gt; array(
				array( &quot;UserId&quot; =&gt; &quot;user1&quot;, &quot;GroupName&quot; =&gt; &quot;group1&quot; ),
				array( &quot;UserId&quot; =&gt; &quot;user2&quot;, &quot;GroupName&quot; =&gt; &quot;group2&quot; )
			),
			&quot;IpRanges&quot; =&gt; array(
				array(&quot;CidrIp&quot; =&gt; &quot;192.168.0.1&quot;),
				array(&quot;CidrIp&quot; =&gt; &quot;192.168.0.2&quot;)
			)
		)
	)
);

$data = CFComplexType::map($map);

// Success?
var_dump($data);";s:6:"result";s:1121:"array(18) {
  ["IpPermissions.1.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.1.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.1.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.1.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.1.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.1.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.1.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.1.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.1.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
  ["IpPermissions.2.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.2.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.2.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.2.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.2.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.2.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.2.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.2.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.2.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
}";}}}i:2;a:6:{s:4:"name";s:12:"option_group";s:8:"modifier";s:13:"public static";s:11:"description";s:359:"<p>A protected method that is used by <a href="../cfcomplextype/json.html" rel="../../index.html#m=cfcomplextype/json"><code>json()</code></a>, <a href="../cfcomplextype/yaml.html" rel="../../index.html#m=cfcomplextype/yaml"><code>yaml()</code></a> and <a href="../cfcomplextype/map.html" rel="../../index.html#m=cfcomplextype/map"><code>map()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"data";s:4:"type";s:12:"string|array";s:11:"description";s:32:"<p>The data to iterate over.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:6:"member";s:4:"type";s:6:"string";s:11:"description";s:126:"<p>The name of the &#8220;member&#8221; property that AWS uses for lists in certain services. Defaults to an empty string.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"key";s:4:"type";s:6:"string";s:11:"description";s:109:"<p>The default key to use when the value for <code>$data</code> is a string. Defaults to an empty string.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"out";s:4:"type";s:5:"array";s:11:"description";s:85:"<p>INTERNAL ONLY. The array that contains the calculated values up to this point.</p>";}}}s:11:"returnvalue";s:100:"<p>The option group parameters to merge into another method&#8217;s <code>$opt</code> parameter.</p>";s:6:"source";s:946:"public static function option_group($data, $member = '', $key = '', &amp;$out = array())
{
    $reset = $key;

    if (is_array($data))
    {
        foreach ($data as $k =&gt; $v)
        {
            // Avoid 0-based indexes.
            if (is_int($k))
            {
                $k = $k + 1;

                if ($member !== '')
                {
                    $key .= '.' . $member;
                }
            }

            $key .= ($key === '' ? $k : '.' . $k);

            if (is_array($v))
            {
                self::option_group($v, $member, $key, $out);
            }
            elseif ($v instanceof CFStepConfig)
            {
                self::option_group($v-&gt;get_config(), $member, $key, $out);
            }
            else
            {
                $out[$key] = $v;
            }

            $key = $reset;
        }
    }
    else
    {
        $out[$key] = $data;
    }

    return $out;
}";}i:3;a:7:{s:4:"name";s:4:"yaml";s:8:"modifier";s:13:"public static";s:11:"description";s:73:"<p>Takes a YAML object, as a string, to convert to query string keys.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"yaml";s:4:"type";s:6:"string";s:11:"description";s:21:"<p>A YAML object.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:6:"member";s:4:"type";s:6:"string";s:11:"description";s:126:"<p>The name of the &#8220;member&#8221; property that AWS uses for lists in certain services. Defaults to an empty string.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"default_key";s:4:"type";s:6:"string";s:11:"description";s:109:"<p>The default key to use when the value for <code>$data</code> is a string. Defaults to an empty string.</p>";}}}s:11:"returnvalue";s:100:"<p>The option group parameters to merge into another method&#8217;s <code>$opt</code> parameter.</p>";s:6:"source";s:146:"public static function yaml($yaml, $member = '', $default_key = '')
{
    return self::option_group(sfYaml::load($yaml), $member, $default_key);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:62:"<p>Convert a short-form YAML object into a parameter list.</p>";s:4:"code";s:511:"// Test data
$yaml = '
IpPermissions:
  - { IpProtocol: tcp, FromPort: 3023, ToPort: 3024, Groups: [{ UserId: user1, GroupName: group1 }, { UserId: user2, GroupName: group2 }], IpRanges: [{ CidrIp: 192.168.0.1 }, { CidrIp: 192.168.0.2 }] }
  - { IpProtocol: tcp, FromPort: 3023, ToPort: 3024, Groups: [{ UserId: user1, GroupName: group1 }, { UserId: user2, GroupName: group2 }], IpRanges: [{ CidrIp: 192.168.0.1 }, { CidrIp: 192.168.0.2 }] }
';

$data = CFComplexType::yaml($yaml);

// Success?
var_dump($data);";s:6:"result";s:1121:"array(18) {
  ["IpPermissions.1.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.1.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.1.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.1.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.1.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.1.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.1.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.1.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.1.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
  ["IpPermissions.2.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.2.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.2.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.2.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.2.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.2.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.2.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.2.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.2.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
}";}i:1;a:3:{s:5:"title";s:61:"<p>Convert a long-form YAML object into a parameter list.</p>";s:4:"code";s:623:"// Test data
$yaml = '
IpPermissions:
  0:
    IpProtocol: tcp
    FromPort: 3023
    ToPort: 3024
    Groups:
      0:
        UserId: user1
        GroupName: group1
      1:
        UserId: user2
        GroupName: group2
    IpRanges:
      0:
        CidrIp: 192.168.0.1
      1:
        CidrIp: 192.168.0.2
  1:
    IpProtocol: tcp
    FromPort: 3023
    ToPort: 3024
    Groups:
      - { UserId: user1, GroupName: group1 }
      - { UserId: user2, GroupName: group2 }
    IpRanges:
      - { CidrIp: 192.168.0.1 }
      - { CidrIp: 192.168.0.2 }
';

$data = CFComplexType::yaml($yaml);

// Success?
var_dump($data);";s:6:"result";s:1121:"array(18) {
  ["IpPermissions.1.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.1.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.1.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.1.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.1.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.1.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.1.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.1.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.1.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
  ["IpPermissions.2.IpProtocol"]=&gt;
  string(3) "tcp"
  ["IpPermissions.2.FromPort"]=&gt;
  int(3023)
  ["IpPermissions.2.ToPort"]=&gt;
  int(3024)
  ["IpPermissions.2.Groups.1.UserId"]=&gt;
  string(5) "user1"
  ["IpPermissions.2.Groups.1.GroupName"]=&gt;
  string(6) "group1"
  ["IpPermissions.2.Groups.2.UserId"]=&gt;
  string(5) "user2"
  ["IpPermissions.2.Groups.2.GroupName"]=&gt;
  string(6) "group2"
  ["IpPermissions.2.IpRanges.1.CidrIp"]=&gt;
  string(11) "192.168.0.1"
  ["IpPermissions.2.IpRanges.2.CidrIp"]=&gt;
  string(11) "192.168.0.2"
}";}}}}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}}}