a:2:{s:4:"file";a:0:{}s:5:"class";a:8:{s:4:"name";s:13:"CFCredentials";s:4:"file";s:31:"utilities/credentials.class.php";s:3:"url";s:27:"../cfcredentials/index.html";s:11:"description";s:198:"<p>The <a href="../cfcredentials/index.html" rel="../../index.html#i=cfcredentials"><code>CFCredentials</code></a> class enables developers to easily switch between multiple sets of credentials.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2012.07.13";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"4";}s:6:"method";a:4:{i:0;a:5:{s:4:"name";s:11:"__construct";s:8:"modifier";s:13:"final private";s:11:"description";s:49:"<p>Prevents this class from being constructed</p>";s:11:"returnvalue";a:0:{}s:6:"source";s:39:"final private function __construct() {}";}i:1;a:7:{s:4:"name";s:3:"get";s:8:"modifier";s:13:"public static";s:11:"description";s:78:"<p>Retrieves the requested credentials from the internal credential store.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:15:"credential_name";}}s:11:"returnvalue";s:84:"<p>A stdClass object where the properties represent the keys that were provided.</p>";s:6:"source";s:435:"public static function get($credential_name = self::DEFAULT_KEY)
{
    // Make sure the credential set exists
    if (!isset(self::$credentials[$credential_name]))
    {
        throw new CFCredentials_Exception('The credential set, &quot;' . $credential_name . '&quot;, does not exist and cannot be retrieved.');
    }

    // Return the credential set as an object
    return new CFCredential(self::$credentials[$credential_name]);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:101:"<p>Set the credential sets that should be available to the application, and read back the values.</p>";s:4:"code";s:2135:"// Dependencies
require_once dirname(__FILE__) . '/../../sdk.class.php';
require_once dirname(__FILE__) . '/../testutil.inc.php';

/**
 * Create a group of credential sets. This would normally go inside the config.inc.php file.
 *
 * Each credential set is assigned a name. Any name that PHP allows as an array key may be used.
 * `@inherit` is a keyword that will tell the class to use the inherited credential set as a base,
 * then apply changes on top of it. The &quot;default&quot; credential set can be its own credential set,
 * or can reference another credential set by name.
 */
CFCredentials::set(array(

	// Credentials for the production environment
	'production' =&gt; array(
		'key' =&gt; 'production-key',
		'secret' =&gt; 'production-secret',
		'cache' =&gt; 'apc',
		'something_else' =&gt; 'abc123',
		'aardvark' =&gt; 'applesauce'
	),

	// Credentials for the staging environment. Inherits from &quot;production&quot;.
	'staging' =&gt; array(
		'@inherit' =&gt; 'production',
		'key' =&gt; 'staging-key',
		'secret' =&gt; 'staging-secret',
	),

	// Credentials for the development environment. Inherits from &quot;staging&quot;, and in-turn, &quot;production&quot;.
	'development' =&gt; array(
		'@inherit' =&gt; 'staging',
		'key' =&gt; 'development-key',
		'secret' =&gt; 'development-secret',
	),

	// Any name can be used for a credential set.
	'my-own-personal-credential-set' =&gt; array(
		'@inherit' =&gt; 'staging'
	),

	// Set a default credential set for ambiguous cases.
	'@default' =&gt; 'development'
));

/**
 * Requesting data back from the credential sets.
 */
echo CFCredentials::get('production')-&gt;key . PHP_EOL;
echo CFCredentials::get('production')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('staging')-&gt;key . PHP_EOL;
echo CFCredentials::get('staging')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('development')-&gt;key . PHP_EOL;
echo CFCredentials::get('development')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('my-own-personal-credential-set')-&gt;key . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get()-&gt;key . PHP_EOL;";s:6:"result";s:107:"production-key
applesauce

staging-key
applesauce

development-key
applesauce

staging-key

development-key";}}}i:2;a:5:{s:4:"name";s:9:"list_sets";s:8:"modifier";s:13:"public static";s:11:"description";s:62:"<p>Retrieves a list of all available credential set names.</p>";s:11:"returnvalue";s:52:"<p>A list of all available credential set names.</p>";s:6:"source";s:94:"public static function list_sets()
{
    return new CFArray(array_keys(self::$credentials));
}";}i:3;a:7:{s:4:"name";s:3:"set";s:8:"modifier";s:13:"public static";s:11:"description";s:41:"<p>Stores the credentials for re-use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"credential_sets";s:4:"type";s:5:"array";s:11:"description";s:82:"<p>The named credential sets that should be made available to the application.</p>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:1718:"public static function set(array $credential_sets)
{
    // Make sure a default credential set is specified or can be inferred
    if (count($credential_sets) === 1)
    {
        $credential_sets[self::DEFAULT_KEY] = reset($credential_sets);
    }

    // Resolve any @inherit tags
    foreach ($credential_sets as $credential_name =&gt; &amp;$credential_set)
    {
        if (is_array($credential_set))
        {
            foreach ($credential_set as $credential_key =&gt; &amp;$credential_value)
            {
                if ($credential_key === self::INHERIT_KEY)
                {
                    if (!isset($credential_sets[$credential_value]))
                    {
                        throw new CFCredentials_Exception('The credential set, &quot;' . $credential_value . '&quot;, does not exist and cannot be inherited.');
                    }

                    $credential_set = array_merge($credential_sets[$credential_value], $credential_set);
                    unset($credential_set[self::INHERIT_KEY]);
                }
            }
        }
    }

    // Normalize the value of the @default credential set
    if (isset($credential_sets[self::DEFAULT_KEY]))
    {
        $default = $credential_sets[self::DEFAULT_KEY];
        if (is_string($default))
        {
            if (!isset($credential_sets[$default]))
            {
                throw new CFCredentials_Exception('The credential set, &quot;' . $default . '&quot;, does not exist and cannot be used as the default credential set.');
            }

            $credential_sets[self::DEFAULT_KEY] = $credential_sets[$default];
        }
    }

    // Store the credentials
    self::$credentials = $credential_sets;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:101:"<p>Set the credential sets that should be available to the application, and read back the values.</p>";s:4:"code";s:2135:"// Dependencies
require_once dirname(__FILE__) . '/../../sdk.class.php';
require_once dirname(__FILE__) . '/../testutil.inc.php';

/**
 * Create a group of credential sets. This would normally go inside the config.inc.php file.
 *
 * Each credential set is assigned a name. Any name that PHP allows as an array key may be used.
 * `@inherit` is a keyword that will tell the class to use the inherited credential set as a base,
 * then apply changes on top of it. The &quot;default&quot; credential set can be its own credential set,
 * or can reference another credential set by name.
 */
CFCredentials::set(array(

	// Credentials for the production environment
	'production' =&gt; array(
		'key' =&gt; 'production-key',
		'secret' =&gt; 'production-secret',
		'cache' =&gt; 'apc',
		'something_else' =&gt; 'abc123',
		'aardvark' =&gt; 'applesauce'
	),

	// Credentials for the staging environment. Inherits from &quot;production&quot;.
	'staging' =&gt; array(
		'@inherit' =&gt; 'production',
		'key' =&gt; 'staging-key',
		'secret' =&gt; 'staging-secret',
	),

	// Credentials for the development environment. Inherits from &quot;staging&quot;, and in-turn, &quot;production&quot;.
	'development' =&gt; array(
		'@inherit' =&gt; 'staging',
		'key' =&gt; 'development-key',
		'secret' =&gt; 'development-secret',
	),

	// Any name can be used for a credential set.
	'my-own-personal-credential-set' =&gt; array(
		'@inherit' =&gt; 'staging'
	),

	// Set a default credential set for ambiguous cases.
	'@default' =&gt; 'development'
));

/**
 * Requesting data back from the credential sets.
 */
echo CFCredentials::get('production')-&gt;key . PHP_EOL;
echo CFCredentials::get('production')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('staging')-&gt;key . PHP_EOL;
echo CFCredentials::get('staging')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('development')-&gt;key . PHP_EOL;
echo CFCredentials::get('development')-&gt;aardvark . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get('my-own-personal-credential-set')-&gt;key . PHP_EOL;

echo PHP_EOL;

echo CFCredentials::get()-&gt;key . PHP_EOL;";s:6:"result";s:107:"production-key
applesauce

staging-key
applesauce

development-key
applesauce

staging-key

development-key";}}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"2";}s:8:"constant";a:2:{i:0;a:2:{s:4:"name";s:11:"DEFAULT_KEY";s:5:"value";s:8:"@default";}i:1;a:2:{s:4:"name";s:11:"INHERIT_KEY";s:5:"value";s:8:"@inherit";}}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"1";}s:8:"property";a:3:{s:4:"name";s:11:"credentials";s:8:"modifier";s:16:"protected static";s:11:"description";s:29:"<p>Stores the credentials</p>";}}}}