a:2:{s:4:"file";a:0:{}s:5:"class";a:8:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";s:3:"url";s:23:"../cfruntime/index.html";s:11:"description";s:165:"<p>Core functionality and default settings shared across all SDK classes. All methods and properties in this
class are inherited by the service-specific classes.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2012.05.25";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"29";}s:6:"method";a:25:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:128:"<p>The constructor. This class should not be instantiated directly. Rather, a service-specific class
should be instantiated.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:2050:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../cfruntime/set_cache_config.html" rel="../../index.html#m=cfruntime/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>instance_profile_timeout</code> - <code>integer</code> - Optional - When retrieving IAM instance profile credentials, there is a hard connection timeout that defaults to 2 seconds to prevent unnecessary on non-EC2 systems. This setting allows you to change that timeout if needed.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li><li><code>use_instance_profile_credentials</code> - <code>boolean</code> - Optional - Forces the use of IAM Instance Profile credentials, even when regular credentials are provided.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:3459:"public function __construct(array $options = array())
{
    // Instantiate the utilities class.
    $this-&gt;util = new $this-&gt;utilities_class();

    // Determine the current service.
    $this-&gt;service = get_class($this);

    // Create credentials based on the options
    $runtime_credentials = new CFCredential($options);
    $credentials_provided = false;

    // Retrieve a credential set from config.inc.php if it exists
    if (isset($options['credentials']))
    {
        // Use a specific credential set and merge with the runtime credentials
        $this-&gt;credentials = CFCredentials::get($options['credentials'])
            -&gt;merge($runtime_credentials);
    }
    else
    {
        try
        {
            // Use the default credential set and merge with the runtime credentials
            $this-&gt;credentials = CFCredentials::get(CFCredentials::DEFAULT_KEY)
                -&gt;merge($runtime_credentials);
        }
        catch (CFCredentials_Exception $e)
        {
            // Only the runtime credentials were provided
            $this-&gt;credentials = $runtime_credentials;
        }
    }

    // Check if keys were actually provided
    if (isset($this-&gt;credentials['key']) &amp;&amp; isset($this-&gt;credentials['secret']))
    {
        $credentials_provided = true;
    }

    // Check for an instance profile credentials override
    if (isset($this-&gt;credentials['use_instance_profile_credentials']) &amp;&amp; $this-&gt;credentials['use_instance_profile_credentials'])
    {
        $credentials_provided = false;
    }

    // Automatically enable whichever caching mechanism is set to default.
    $this-&gt;set_cache_config($this-&gt;credentials-&gt;default_cache_config);

    // If no credentials were provided, try to get them from the EC2 instance profile
    if (!$credentials_provided)
    {
        // Default caching mechanism is required
        if (!$this-&gt;credentials-&gt;default_cache_config)
        {
            // @codeCoverageIgnoreStart
            throw new CFCredentials_Exception('No credentials were provided. The SDK attempts to retrieve Instance '
                . 'Profile credentials from the EC2 Instance Metadata Service, but doing this requires the '
                . '&quot;default_cache_config&quot; option to be set in the config.inc.php file or constructor. In order to '
                . 'cache the retrieved credentials.');
            // @codeCoverageIgnoreEnd
        }

        // Instantiate and invoke the cache for instance profile credentials
        $cache = new $this-&gt;cache_class('instance_profile_credentials', $this-&gt;cache_location, 0, $this-&gt;cache_compress);
        if ($data = $cache-&gt;read())
        {
            $cache-&gt;expire_in((strtotime($data['expires']) - time()) * 0.85);
        }
        $instance_profile_credentials = $cache-&gt;response_manager(array($this, 'cache_instance_profile_credentials'), array($cache, $options));

        $this-&gt;credentials-&gt;key    = $instance_profile_credentials['key'];
        $this-&gt;credentials-&gt;secret = $instance_profile_credentials['secret'];
        $this-&gt;credentials-&gt;token  = $instance_profile_credentials['token'];
    }

    // Set internal credentials after they are resolved
    $this-&gt;key = $this-&gt;credentials-&gt;key;
    $this-&gt;secret_key = $this-&gt;credentials-&gt;secret;
    $this-&gt;auth_token = $this-&gt;credentials-&gt;token;
}";}i:1;a:7:{s:4:"name";s:23:"allow_hostname_override";s:8:"modifier";s:6:"public";s:11:"description";s:170:"<p>Disables any subsequent use of the <a href="../cfruntime/set_hostname.html" rel="../../index.html#m=cfruntime/set_hostname"><code>set_hostname()</code></a> method.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"override";s:4:"type";s:7:"boolean";s:11:"description";s:398:"<p>Whether or not subsequent calls to <a href="../cfruntime/set_hostname.html" rel="../../index.html#m=cfruntime/set_hostname"><code>set_hostname()</code></a> should be obeyed. A <code>false</code> value disables the further effectiveness of <a href="../cfruntime/set_hostname.html" rel="../../index.html#m=cfruntime/set_hostname"><code>set_hostname()</code></a>. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:124:"public function allow_hostname_override($override = true)
{
    $this-&gt;override_hostname = $override;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:2;a:6:{s:4:"name";s:12:"authenticate";s:8:"modifier";s:6:"public";s:11:"description";s:69:"<p>Default, shared method for authenticating a connection to AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"operation";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>Indicates the operation to perform.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"payload";s:4:"type";s:5:"array";s:11:"description";s:106:"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.</p>";}}}s:11:"returnvalue";s:48:"<p>Object containing a parsed HTTP response.</p>";s:6:"source";s:6988:"public function authenticate($operation, $payload)
{
    $original_payload = $payload;
    $method_arguments = func_get_args();
    $curlopts = array();
    $return_curl_handle = false;

    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)
    {
        $operation = $this-&gt;operation_prefix . $operation;
    }

    // Extract the custom CURLOPT settings from the payload
    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))
    {
        $curlopts = $payload['curlopts'];
        unset($payload['curlopts']);
    }

    // Determine whether the response or curl handle should be returned
    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))
    {
        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;
        unset($payload['returnCurlHandle']);
    }

    // Use the caching flow to determine if we need to do a round-trip to the server.
    if ($this-&gt;use_cache_flow)
    {
        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);

        // Parse the XML body
        $data = $this-&gt;parse_callback($data);

        // End!
        return $data;
    }

    /*%******************************************************************************************%*/

    // Signer
    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);
    $signer-&gt;key = $this-&gt;key;
    $signer-&gt;secret_key = $this-&gt;secret_key;
    $signer-&gt;auth_token = $this-&gt;auth_token;
    $signer-&gt;api_version = $this-&gt;api_version;
    $signer-&gt;utilities_class = $this-&gt;utilities_class;
    $signer-&gt;request_class = $this-&gt;request_class;
    $signer-&gt;response_class = $this-&gt;response_class;
    $signer-&gt;use_ssl = $this-&gt;use_ssl;
    $signer-&gt;proxy = $this-&gt;proxy;
    $signer-&gt;util = $this-&gt;util;
    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;
    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;
    $request = $signer-&gt;authenticate();

    // Update RequestCore settings
    $request-&gt;request_class = $this-&gt;request_class;
    $request-&gt;response_class = $this-&gt;response_class;
    $request-&gt;ssl_verification = $this-&gt;ssl_verification;

    /*%******************************************************************************************%*/

    // Debug mode
    if ($this-&gt;debug_mode)
    {
        $request-&gt;debug_mode = $this-&gt;debug_mode;
    }

    // Set custom CURLOPT settings
    if (count($curlopts))
    {
        $request-&gt;set_curlopts($curlopts);
    }

    // Manage the (newer) batch request API or the (older) returnCurlHandle setting.
    if ($this-&gt;use_batch_flow)
    {
        $handle = $request-&gt;prep_request();
        $this-&gt;batch_object-&gt;add($handle);
        $this-&gt;use_batch_flow = false;

        return $handle;
    }
    elseif ($return_curl_handle)
    {
        return $request-&gt;prep_request();
    }

    // Send!
    $request-&gt;send_request();

    // Prepare the response.
    $headers = $request-&gt;get_response_header();
    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;

    if (isset($signer-&gt;canonical_request))
    {
        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;
    }

    $headers['x-aws-request-headers'] = $request-&gt;request_headers;
    $headers['x-aws-body'] = $signer-&gt;querystring;

    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());

    $response_body = (string) $request-&gt;get_response_body();

    // Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.
    if (
        (integer) $request-&gt;get_response_code() === 500 || // Internal Error (presumably transient)
        (integer) $request-&gt;get_response_code() === 503)   // Service Unavailable (presumably transient)
    {
        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)
        {
            // Exponential backoff
            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);
            usleep($delay);
            $this-&gt;redirects++;
            $data = $this-&gt;authenticate($operation, $original_payload);
        }
    }

    // DynamoDB has additional, custom logic for retrying requests
    else
    {
        // If the request to DynamoDB was throttled, we need to retry
        $need_to_retry_dynamodb_request = (
            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;
            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;
            stripos($response_body, 'ProvisionedThroughputExceededException') !== false
        );

        // If the CRC32 of the response does not match the expected value, we need to retry
        $response_headers = $request-&gt;get_response_header();
        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))
        {
            $crc32_expected = $response_headers['x-amz-crc32'];
            $crc32_actual = hexdec(hash('crc32b', $response_body));
            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);
        }

        // Perform retry if necessary using a more aggressive exponential backoff
        if ($need_to_retry_dynamodb_request)
        {
            if ($this-&gt;redirects === 0)
            {
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))
            {
                // Exponential backoff
                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);
                usleep($delay);
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
        }
    }

    $this-&gt;redirects = 0;
    return $data;
}";}i:3;a:7:{s:4:"name";s:5:"batch";s:8:"modifier";s:6:"public";s:11:"description";s:86:"<p>Specifies that the intended request should be queued for a later batch request.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"queue";s:4:"type";s:14:"CFBatchRequest";s:11:"description";s:327:"<p>The <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a> instance to use for managing batch requests. If not available, it generates a new instance of <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:477:"public function batch(CFBatchRequest &amp;$queue = null)
{
    if ($queue)
    {
        $this-&gt;batch_object = $queue;
    }
    elseif ($this-&gt;internal_batch_object)
    {
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }
    else
    {
        $this-&gt;internal_batch_object = new $this-&gt;batch_class();
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }

    $this-&gt;use_batch_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:4;a:7:{s:4:"name";s:5:"cache";s:8:"modifier";s:6:"public";s:11:"description";s:323:"<p>Specifies that the resulting <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object should be cached according to the settings from
<a href="../cfruntime/set_cache_config.html" rel="../../index.html#m=cfruntime/set_cache_config"><code>set_cache_config()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"expires";s:4:"type";s:14:"string|integer";s:11:"description";s:232:"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href="http://php.net/strtotime"><code>strtotime()</code></a> (e.g. &#8220;1 hour&#8221;).</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:501:"public function cache($expires)
{
    // Die if they haven't used set_cache_config().
    if (!$this-&gt;cache_class)
    {
        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');
    }

    if (is_string($expires))
    {
        $expires = strtotime($expires);
        $this-&gt;cache_expires = $expires - time();
    }
    elseif (is_int($expires))
    {
        $this-&gt;cache_expires = $expires;
    }

    $this-&gt;use_cache_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:5:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:2;a:4:{s:5:"title";s:70:"<p>Fire a single request, and then cache the response to Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:338:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:3;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:4;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:5;a:6:{s:4:"name";s:34:"cache_instance_profile_credentials";s:8:"modifier";s:6:"public";s:11:"description";s:139:"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to
be manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:2563:"public function cache_instance_profile_credentials($cache, $options)
{
    $instance_profile_url = 'http://169.254.169.254/latest/meta-data/iam/security-credentials/';
    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;

    try
    {
        // Make a call to the EC2 Metadata Service to find the available instance profile
        $request = new RequestCore($instance_profile_url);
        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
        $response = $request-&gt;send_request(true);

        if ($response-&gt;isOK())
        {
            // Get the instance profile name
            $profile = (string) $response-&gt;body;

            // Make a call to the EC2 Metadata Service to get the instance profile credentials
            $request = new RequestCore($instance_profile_url . $profile);
            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
            $response = $request-&gt;send_request(true);

            if ($response-&gt;isOK())
            {
                // Get the credentials
                $credentials = json_decode($response-&gt;body, true);

                if ($credentials['Code'] === 'Success')
                {
                    // Determine the expiration time
                    $expiration_time = strtotime((string) $credentials['Expiration']);
                    $expiration_duration = round(($expiration_time - time()) * 0.85);
                    $cache-&gt;expire_in($expiration_duration);

                    // Return the credential information
                    return array(
                        'key'     =&gt; $credentials['AccessKeyId'],
                        'secret'  =&gt; $credentials['SecretAccessKey'],
                        'token'   =&gt; $credentials['Token'],
                        'expires' =&gt; $credentials['Expiration'],
                    );
                }
            }
        }
    }
    catch (cURL_Exception $e)
    {
        // The EC2 Metadata Service does not exist or had timed out.
        // An exception will be thrown on the next line.
    }

    // @codeCoverageIgnoreStart
    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '
        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '
        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');
    // @codeCoverageIgnoreEnd
}";}i:6;a:6:{s:4:"name";s:21:"cache_sts_credentials";s:8:"modifier";s:6:"public";s:11:"description";s:122:"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be
manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:1226:"public function cache_sts_credentials($cache, $options)
{
    $token = new AmazonSTS($options);
    $response = $token-&gt;get_session_token();

    if ($response-&gt;isOK())
    {
        // Update the expiration
        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);
        $expiration_duration = round(($expiration_time - time()) * 0.85);
        $cache-&gt;expire_in($expiration_duration);

        // Return the important data
        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;

        return array(
            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,
            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,
            'token'   =&gt; (string) $credentials-&gt;SessionToken,
            'expires' =&gt; (string) $credentials-&gt;Expiration,
        );
    }

    // @codeCoverageIgnoreStart
    throw new STS_Exception('Temporary credentials from the AWS Security '
        . 'Token Service could not be retrieved using the provided long '
        . 'term credentials. It\'s possible that the provided long term '
        . 'credentials were invalid.');
    // @codeCoverageIgnoreEnd
}";}i:7;a:6:{s:4:"name";s:12:"delete_cache";s:8:"modifier";s:6:"public";s:11:"description";s:169:"<p>Deletes a cached <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object using the specified cache storage type.</p>";s:11:"returnvalue";s:118:"<p>A value of <code>true</code> if cached object exists and is successfully deleted, otherwise <code>false</code>.</p>";s:6:"source";s:125:"public function delete_cache()
{
    $this-&gt;use_cache_flow = true;
    $this-&gt;delete_cache = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:4:{s:5:"title";s:41:"<p>Delete a cached response from APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:169:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:11:"bool(false)";}i:1;a:4:{s:5:"title";s:53:"<p>Delete a cached response from the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:173:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}i:2;a:4:{s:5:"title";s:46:"<p>Delete a cached response from Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:205:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}}}}i:8;a:7:{s:4:"name";s:11:"disable_ssl";s:8:"modifier";s:6:"public";s:11:"description";s:312:"<p>Disables SSL/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still
require SSL support.</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:192:"public function disable_ssl()
{
    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;use_ssl = false;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:35:"<p>Disable SSL for the service.</p>";s:11:"description";s:170:"<ul>
<li><strong>Note:</strong> It is not recommended to disable SSL.</li>
<li><strong>Note:</strong> This method is inherited by all service-specific classes.</li>
</ul>";s:4:"code";s:175:"// Disable SSL (Using @ to suppress the warning from the output)
$sdb = new AmazonSDB();
@$sdb-&gt;disable_ssl(true);

// Test if the value was set
var_dump($sdb-&gt;use_ssl);";s:6:"result";s:11:"bool(false)";}}s:9:"changelog";a:1:{s:6:"change";s:58:"<p>This method now throws a user warning when invoked.</p>";}}i:9;a:6:{s:4:"name";s:24:"disable_ssl_verification";s:8:"modifier";s:6:"public";s:11:"description";s:402:"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry
out a man-in-the-middle attack.</p>

<p>https://secure.wikimedia.org/wikipedia/en/wiki/Man-in-the-middle_attack</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"ssl_verification";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:314:"public function disable_ssl_verification($ssl_verification = false)
{
    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;ssl_verification = $ssl_verification;
    return $this;
}";}i:10;a:7:{s:4:"name";s:17:"enable_debug_mode";s:8:"modifier";s:6:"public";s:11:"description";s:75:"<p>Enables HTTP request/response header logging to <code>STDERR</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"enabled";s:4:"type";s:7:"boolean";s:11:"description";s:74:"<p>Whether or not to enable debug mode. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:109:"public function enable_debug_mode($enabled = true)
{
    $this-&gt;debug_mode = $enabled;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:82:"<p>Enable the logging of HTTP request/response headers to <code>STDERR</code>.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;enable_debug_mode();

// Test if the value was set
var_dump($sdb-&gt;debug_mode);";s:6:"result";s:10:"bool(true)";}}}i:11;a:6:{s:4:"name";s:7:"factory";s:8:"modifier";s:13:"public static";s:11:"description";s:76:"<p>Alternate approach to constructing a new instance. Supports chaining.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1569:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../cfruntime/set_cache_config.html" rel="../../index.html#m=cfruntime/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:303:"public static function factory(array $options = array())
{
    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))
    {
        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');
    }

    $self = get_called_class();
    return new $self($options);
}";}i:12;a:7:{s:4:"name";s:32:"register_streaming_read_callback";s:8:"modifier";s:6:"public";s:11:"description";s:753:"<p>Register a callback function to execute whenever a data stream is read from using
<a href="../cfrequest/streaming_read_callback.html" rel="../../index.html#m=cfrequest/streaming_read_callback"><code>CFRequest::streaming_read_callback()</code></a>.</p>

<p>The user-defined callback function should accept three arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$file_handle</code> - <code>resource</code> - Required - The file handle resource that represents the file on the local file system.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:143:"public function register_streaming_read_callback($callback)
{
    $this-&gt;registered_streaming_read_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:85:"<p>Register a callback function to execute when data is read from an open stream.</p>";s:4:"code";s:694:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $file_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is read locally.
$s3-&gt;register_streaming_read_callback('callback');

// Download a public object.
$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(
	'fileUpload' =&gt; './uploads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:13;a:7:{s:4:"name";s:33:"register_streaming_write_callback";s:8:"modifier";s:6:"public";s:11:"description";s:608:"<p>Register a callback function to execute whenever a data stream is written to using
<a href="../cfrequest/streaming_write_callback.html" rel="../../index.html#m=cfrequest/streaming_write_callback"><code>CFRequest::streaming_write_callback()</code></a>.</p>

<p>The user-defined callback function should accept two arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:145:"public function register_streaming_write_callback($callback)
{
    $this-&gt;registered_streaming_write_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:86:"<p>Register a callback function to execute when data is written to an open stream.</p>";s:4:"code";s:685:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is written locally.
$s3-&gt;register_streaming_write_callback('callback');

// Download a public object.
$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(
	'fileDownload' =&gt; './downloads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:14;a:6:{s:4:"name";s:4:"send";s:8:"modifier";s:6:"public";s:11:"description";s:71:"<p>Executes the batch request queue by sending all queued requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"clear_after_send";s:4:"type";s:7:"boolean";s:11:"description";s:204:"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true</code>. Set this to <code>false</code> if you are caching batch responses and want to retrieve results later.</p>";}}s:11:"returnvalue";s:126:"<p>An array of <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> objects.</p>";s:6:"source";s:2018:"public function send($clear_after_send = true)
{
    if ($this-&gt;use_batch_flow)
    {
        // When we send the request, disable batch flow.
        $this-&gt;use_batch_flow = false;

        // If we're not caching, simply send the request.
        if (!$this-&gt;use_cache_flow)
        {
            $response = $this-&gt;batch_object-&gt;send();
            $parsed_data = array_map(array($this, 'parse_callback'), $response);
            $parsed_data = new CFArray($parsed_data);

            // Clear the queue
            if ($clear_after_send)
            {
                $this-&gt;batch_object-&gt;queue = array();
            }

            return $parsed_data;
        }

        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));
        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);
        $parsed_data = new CFArray($parsed_data);

        // Clear the queue
        if ($clear_after_send)
        {
            $this-&gt;batch_object-&gt;queue = array();
        }

        // End!
        return $parsed_data;
    }

    // Load the class
    $null = new CFBatchRequest();
    unset($null);

    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');
}";}i:15;a:6:{s:4:"name";s:15:"set_batch_class";s:8:"modifier";s:6:"public";s:11:"description";s:291:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:116:"public function set_batch_class($class = 'CFBatchRequest')
{
    $this-&gt;batch_class = $class;
    return $this;
}";}i:16;a:7:{s:4:"name";s:16:"set_cache_config";s:8:"modifier";s:6:"public";s:11:"description";s:65:"<p>Set the caching configuration to use for response caching.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:1095:"<p>The location to store the cache object in. This may vary by cache method.</p><ul><li>File - The local file system paths such as <code>./cache</code> (relative) or <code>/tmp/cache/</code> (absolute). The location must be server-writable.</li><li>APC - Pass in <code>apc</code> to use this lightweight cache. You must have the <a href="http://php.net/apc">APC extension</a> installed.</li><li>XCache - Pass in <code>xcache</code> to use this lightweight cache. You must have the <a href="http://xcache.lighttpd.net">XCache</a> extension installed.</li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host</code> and a <code>port</code> value representing a <a href="http://php.net/memcached">Memcached</a> server to connect to.</li><li>PDO - A URL-style string (e.g. <code>pdo.mysql://user:pass@localhost/cache</code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:/sqlite/cache.db</code>). MUST be prefixed with <code>pdo.</code>. See <code>CachePDO</code> and <a href="http://php.net/pdo">PDO</a> for more details.</li></ul>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:241:"<p>Whether or not data should be gzipped before being stored. A value of <code>true</code> will compress the contents before caching them. A value of <code>false</code> will leave the contents uncompressed. Defaults to <code>true</code>.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:1210:"public function set_cache_config($location, $gzip = true)
{
    // If location is empty, don't do anything.
    if (empty($location))
    {
        return $this;
    }

    // If we have an array, we're probably passing in Memcached servers and ports.
    if (is_array($location))
    {
        $this-&gt;cache_class = 'CacheMC';
    }
    else
    {
        // I would expect locations like `/tmp/cache`, `pdo.mysql://user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.
        $type = strtolower(substr($location, 0, 3));
        switch ($type)
        {
            case 'apc':
                $this-&gt;cache_class = 'CacheAPC';
                break;

            case 'xca': // First three letters of `xcache`
                $this-&gt;cache_class = 'CacheXCache';
                break;

            case 'pdo':
                $this-&gt;cache_class = 'CachePDO';
                $location = substr($location, 4);
                break;

            default:
                $this-&gt;cache_class = 'CacheFile';
                break;
        }
    }

    // Set the remaining cache information.
    $this-&gt;cache_location = $location;
    $this-&gt;cache_compress = $gzip;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}}}}i:17;a:7:{s:4:"name";s:12:"set_hostname";s:8:"modifier";s:6:"public";s:11:"description";s:145:"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with
AWS, but run from a different hostname.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"hostname";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"port_number";s:4:"type";s:7:"integer";s:11:"description";s:139:"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:341:"public function set_hostname($hostname, $port_number = null)
{
    if ($this-&gt;override_hostname)
    {
        $this-&gt;hostname = $hostname;

        if ($port_number)
        {
            $this-&gt;port_number = $port_number;
            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;
        }
    }

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:18;a:7:{s:4:"name";s:15:"set_max_retries";s:8:"modifier";s:6:"public";s:11:"description";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"retries";s:4:"type";s:7:"integer";s:11:"description";s:88:"<p>The maximum number of times to retry failed requests. Defaults to <code>3</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:105:"public function set_max_retries($retries = 3)
{
    $this-&gt;max_retries = $retries;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_max_retries(3);

// Test if the value was set
var_dump($sdb-&gt;max_retries);";s:6:"result";s:6:"int(3)";}}}i:19;a:6:{s:4:"name";s:16:"set_parser_class";s:8:"modifier";s:6:"public";s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:115:"public function set_parser_class($class = 'CFSimpleXML')
{
    $this-&gt;parser_class = $class;
    return $this;
}";}i:20;a:7:{s:4:"name";s:9:"set_proxy";s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>Set the proxy settings to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"proxy";s:4:"type";s:6:"string";s:11:"description";s:102:"<p>Accepts proxy credentials in the following format: <code>proxy://user:pass@hostname:port</code></p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:85:"public function set_proxy($proxy)
{
    $this-&gt;proxy = $proxy;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>Set the proxy server to use for requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:151:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_proxy('proxy://user:pass@hostname:port');

// Test if the value was set
var_dump($sdb-&gt;proxy);";s:6:"result";s:44:"string(31) "proxy://user:pass@hostname:port"";}}}i:21;a:7:{s:4:"name";s:17:"set_request_class";s:8:"modifier";s:6:"public";s:11:"description";s:276:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";a:0:{}s:6:"source";s:115:"public function set_request_class($class = 'CFRequest')
{
    $this-&gt;request_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Set the request class to use in the toolkit.</p>";s:11:"description";s:158:"<p>The new request class must extend from <code>CFRequest</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:310:"// Custom class to extend RequestCore
class TestRequestCore extends RequestCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_request_class('TestRequestCore');

// Test if the value was set
var_dump($sdb-&gt;request_class);";s:6:"result";s:28:"string(15) "TestRequestCore"";}}}i:22;a:7:{s:4:"name";s:19:"set_resource_prefix";s:8:"modifier";s:6:"public";s:11:"description";s:117:"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible
with AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"prefix";s:4:"type";s:6:"string";s:11:"description";s:97:"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:107:"public function set_resource_prefix($prefix)
{
    $this-&gt;resource_prefix = $prefix;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:23;a:7:{s:4:"name";s:18:"set_response_class";s:8:"modifier";s:6:"public";s:11:"description";s:279:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:118:"public function set_response_class($class = 'CFResponse')
{
    $this-&gt;response_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:52:"<p>Set the response class to use in the toolkit.</p>";s:11:"description";s:160:"<p>The new response class must extend from <code>CFResponse</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:316:"// Custom class to extend ResponseCore
class TestResponseCore extends ResponseCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_response_class('TestResponseCore');

// Test if the value was set
var_dump($sdb-&gt;response_class);";s:6:"result";s:29:"string(16) "TestResponseCore"";}}}i:24;a:7:{s:4:"name";s:19:"set_utilities_class";s:8:"modifier";s:6:"public";s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:175:"public function set_utilities_class($class = 'CFUtilities')
{
    $this-&gt;utilities_class = $class;
    $this-&gt;util = new $this-&gt;utilities_class();
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:53:"<p>Set the utilities class to use in the toolkit.</p>";s:11:"description";s:162:"<p>The new utilities class must extend from <code>CFUtilities</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:317:"// Custom class to extend CFUtilities
class TestUtilities extends CFUtilities
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_utilities_class('TestUtilities');

// Test if the value was set
var_dump($sdb-&gt;util-&gt;test_method());";s:6:"result";s:10:"bool(true)";}}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"4";}s:8:"constant";a:4:{i:0;a:2:{s:4:"name";s:5:"BUILD";s:5:"value";s:14:"20130314130000";}i:1;a:2:{s:4:"name";s:4:"NAME";s:5:"value";s:11:"aws-sdk-php";}i:2;a:2:{s:4:"name";s:9:"USERAGENT";s:5:"value";s:65:"aws-sdk-php/1.6.2 PHP/5.4.9 curl/7.15.5 openssl/0.9.8e-fips-rhel5";}i:3;a:2:{s:4:"name";s:7:"VERSION";s:5:"value";s:5:"1.6.2";}}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"40";}s:8:"property";a:40:{i:0;a:3:{s:4:"name";s:11:"api_version";s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The supported API version.</p>";}i:1;a:3:{s:4:"name";s:10:"auth_class";s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The authentication class to use.</p>";}i:2;a:3:{s:4:"name";s:10:"auth_token";s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The Amazon Authentication Token.</p>";}i:3;a:4:{s:4:"name";s:11:"batch_class";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:14:"CFBatchRequest";}}s:11:"description";s:185:"<p>The default class to use for handling batch requests (defaults to <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>).</p>";}i:4;a:3:{s:4:"name";s:12:"batch_object";s:8:"modifier";s:6:"public";s:11:"description";s:53:"<p>The current instantiated batch request object.</p>";}i:5;a:3:{s:4:"name";s:11:"cache_class";s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The caching class to use.</p>";}i:6;a:3:{s:4:"name";s:14:"cache_compress";s:8:"modifier";s:6:"public";s:11:"description";s:38:"<p>The state of cache compression.</p>";}i:7;a:3:{s:4:"name";s:13:"cache_expires";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>When the cache should be considered stale.</p>";}i:8;a:3:{s:4:"name";s:14:"cache_location";s:8:"modifier";s:6:"public";s:11:"description";s:35:"<p>The caching location to use.</p>";}i:9;a:3:{s:4:"name";s:12:"cache_object";s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The current instantiated cache object.</p>";}i:10;a:3:{s:4:"name";s:11:"credentials";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>The credentials to use for authentication.</p>";}i:11;a:3:{s:4:"name";s:10:"debug_mode";s:8:"modifier";s:6:"public";s:11:"description";s:43:"<p>The state of the debug mode setting.</p>";}i:12;a:3:{s:4:"name";s:12:"delete_cache";s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>The state of the cache deletion setting.</p>";}i:13;a:3:{s:4:"name";s:8:"hostname";s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The alternate hostname to use, if any.</p>";}i:14;a:3:{s:4:"name";s:21:"internal_batch_object";s:8:"modifier";s:6:"public";s:11:"description";s:56:"<p>The internally instantiated batch request object.</p>";}i:15;a:3:{s:4:"name";s:3:"key";s:8:"modifier";s:6:"public";s:11:"description";s:26:"<p>The Amazon API Key.</p>";}i:16;a:4:{s:4:"name";s:11:"max_retries";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:1:"3";}}s:11:"description";s:52:"<p>The number of times to retry failed requests.</p>";}i:17;a:3:{s:4:"name";s:9:"operation";s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The operation to execute.</p>";}i:18;a:3:{s:4:"name";s:16:"operation_prefix";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>The string prefix to prepend to the operation name.</p>";}i:19;a:4:{s:4:"name";s:17:"override_hostname";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:186:"<p>The state of the capability to override the hostname with <a href="../cfruntime/set_hostname.html" rel="../../index.html#m=cfruntime/set_hostname"><code>set_hostname()</code></a>.</p>";}i:20;a:4:{s:4:"name";s:18:"parse_the_response";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:65:"<p>The state of whether the response should be parsed or not.</p>";}i:21;a:4:{s:4:"name";s:12:"parser_class";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFSimpleXML";}}s:11:"description";s:164:"<p>The default class to use for parsing XML (defaults to <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>).</p>";}i:22;a:3:{s:4:"name";s:7:"payload";s:8:"modifier";s:6:"public";s:11:"description";s:27:"<p>The payload to send.</p>";}i:23;a:3:{s:4:"name";s:11:"port_number";s:8:"modifier";s:6:"public";s:11:"description";s:48:"<p>The alternate port number to use, if any.</p>";}i:24;a:3:{s:4:"name";s:5:"proxy";s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The proxy to use for connecting.</p>";}i:25;a:3:{s:4:"name";s:9:"redirects";s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>The number of times a request has been retried.</p>";}i:26;a:3:{s:4:"name";s:34:"registered_streaming_read_callback";s:8:"modifier";s:6:"public";s:11:"description";s:77:"<p>The user-defined callback function to call when a stream is read from.</p>";}i:27;a:3:{s:4:"name";s:35:"registered_streaming_write_callback";s:8:"modifier";s:6:"public";s:11:"description";s:78:"<p>The user-defined callback function to call when a stream is written to.</p>";}i:28;a:4:{s:4:"name";s:13:"request_class";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:9:"CFRequest";}}s:11:"description";s:160:"<p>The default class to use for HTTP requests (defaults to <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>).</p>";}i:29;a:3:{s:4:"name";s:15:"resource_prefix";s:8:"modifier";s:6:"public";s:11:"description";s:52:"<p>The alternate resource prefix to use, if any.</p>";}i:30;a:4:{s:4:"name";s:14:"response_class";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:10:"CFResponse";}}s:11:"description";s:164:"<p>The default class to use for HTTP responses (defaults to <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>).</p>";}i:31;a:3:{s:4:"name";s:10:"secret_key";s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The Amazon API Secret Key.</p>";}i:32;a:3:{s:4:"name";s:7:"service";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>An identifier for the current AWS service.</p>";}i:33;a:4:{s:4:"name";s:16:"ssl_verification";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:49:"<p>The state of SSL certificate verification.</p>";}i:34;a:4:{s:4:"name";s:13:"use_aws_query";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:64:"<p>The state of whether auth should be handled as AWS Query.</p>";}i:35;a:3:{s:4:"name";s:14:"use_batch_flow";s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of batch flow usage.</p>";}i:36;a:3:{s:4:"name";s:14:"use_cache_flow";s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of cache flow usage.</p>";}i:37;a:4:{s:4:"name";s:7:"use_ssl";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:34:"<p>The state of SSL/HTTPS use.</p>";}i:38;a:3:{s:4:"name";s:4:"util";s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Handle for the utility functions.</p>";}i:39;a:4:{s:4:"name";s:15:"utilities_class";s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFUtilities";}}s:11:"description";s:162:"<p>The default class to use for utilities (defaults to <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>).</p>";}}}}}