a:2:{s:4:"file";a:0:{}s:5:"class";a:8:{s:4:"name";s:15:"CFStackTemplate";s:4:"file";s:33:"utilities/stacktemplate.class.php";s:3:"url";s:29:"../cfstacktemplate/index.html";s:11:"description";s:64:"<p>Simplifies the process of preparing JSON stack templates.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2011.02.03";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"2";}s:6:"method";a:2:{i:0;a:8:{s:4:"name";s:4:"json";s:8:"modifier";s:13:"public static";s:11:"description";s:47:"<p>Removes whitespace from a JSON template.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"template";s:4:"type";s:6:"string";s:11:"description";s:202:"<p>A JSON representation of the stack template. Must have <a href="http://docs.php.net/manual/en/function.json-decode.php#refsect1-function.json-decode-examples">strict JSON-specific formatting</a>.</p>";}}s:11:"returnvalue";s:45:"<p>A JSON representation of the template.</p>";s:6:"source";s:96:"public static function json($template)
{
    return json_encode(json_decode($template, true));
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Handle JSON version of the template.</p>";s:4:"code";s:1854:"$template = CFStackTemplate::json('{
	&quot;AWSTemplateFormatVersion&quot; : &quot;2010-09-09&quot;,
	&quot;Description&quot; : &quot;Create an EC2 instance running the Amazon Linux 32 bit AMI.&quot;,
	&quot;Parameters&quot; : {
		&quot;KeyPair&quot; : {
			&quot;Description&quot; : &quot;The EC2 Key Pair to allow SSH access to the instance&quot;,
			&quot;Type&quot; : &quot;String&quot;
		}
	},
	&quot;Mappings&quot; : {
		&quot;RegionMap&quot; : {
			&quot;us-east-1&quot; : { &quot;AMI&quot; : &quot;ami-76f0061f&quot; },
			&quot;us-west-1&quot; : { &quot;AMI&quot; : &quot;ami-655a0a20&quot; },
			&quot;eu-west-1&quot; : {	&quot;AMI&quot; : &quot;ami-7fd4e10b&quot; },
			&quot;ap-southeast-1&quot; : { &quot;AMI&quot; : &quot;ami-72621c20&quot; }
		}
	},
	&quot;Resources&quot; : {
		&quot;Ec2Instance&quot; : {
			&quot;Type&quot; : &quot;AWS::EC2::Instance&quot;,
			&quot;Properties&quot; : {
				&quot;KeyName&quot; : { &quot;Ref&quot; : &quot;KeyPair&quot; },
				&quot;ImageId&quot; : { &quot;Fn::FindInMap&quot; : [ &quot;RegionMap&quot;, { &quot;Ref&quot; : &quot;AWS::Region&quot; }, &quot;AMI&quot; ]}
			}
		}
	},
	&quot;Outputs&quot; : {
		&quot;InstanceId&quot; : {
			&quot;Description&quot; : &quot;The InstanceId of the newly created EC2 instance&quot;,
			&quot;Value&quot; : { &quot;Ref&quot; : &quot;Ec2Instance&quot; }
		},
		&quot;AZ&quot; : {
			&quot;Description&quot; : &quot;The Availability Zone of the newly created EC2 instance&quot;,
			&quot;Value&quot; : { &quot;Fn::GetAtt&quot; : [ &quot;Ec2Instance&quot;, &quot;AvailabilityZone&quot; ] }
		},
		&quot;PublicIP&quot; : {
			&quot;Description&quot; : &quot;The Public IP address of the newly created EC2 instance&quot;,
			&quot;Value&quot; : { &quot;Fn::GetAtt&quot; : [ &quot;Ec2Instance&quot;, &quot;PublicIp&quot; ] }
		}
	}
}');

var_dump(sha1($template));";s:6:"result";s:53:"string(40) "9424c0db71fca8b6e0200d77571e41bb867d7f4b"";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazoncloudformation/get_template.html" rel="../../index.html#m=amazoncloudformation/get_template"><code>AmazonCloudFormation::get_template()</code></a>";i:1;s:179:"<a href="../amazoncloudformation/validate_template.html" rel="../../index.html#m=amazoncloudformation/validate_template"><code>AmazonCloudFormation::validate_template()</code></a>";i:2;s:105:"<a href="../cfstacktemplate/map.html" rel="../../index.html#m=cfstacktemplate/map"><code>map()</code></a>";}}}i:1;a:8:{s:4:"name";s:3:"map";s:8:"modifier";s:13:"public static";s:11:"description";s:78:"<p>Converts an associative array (map) of the template into a JSON string.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"template";s:4:"type";s:5:"array";s:11:"description";s:71:"<p>An associative array that maps directly to its JSON counterpart.</p>";}}s:11:"returnvalue";s:45:"<p>A JSON representation of the template.</p>";s:6:"source";s:76:"public static function map($template)
{
    return json_encode($template);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:62:"<p>Handle associative array (map) version of the template.</p>";s:4:"code";s:1538:"$template = CFStackTemplate::map(array(
	'AWSTemplateFormatVersion' =&gt; '2010-09-09',
	'Description' =&gt; 'Create an EC2 instance running the Amazon Linux 32 bit AMI.',
	'Parameters' =&gt; array(
		'KeyPair' =&gt; array(
			'Description' =&gt; 'The EC2 Key Pair to allow SSH access to the instance',
			'Type' =&gt; 'String'
		)
	),
	'Mappings' =&gt; array(
		'RegionMap' =&gt; array(
			'us-east-1' =&gt; array( 'AMI' =&gt; 'ami-76f0061f' ),
			'us-west-1' =&gt; array( 'AMI' =&gt; 'ami-655a0a20' ),
			'eu-west-1' =&gt; array(	'AMI' =&gt; 'ami-7fd4e10b' ),
			'ap-southeast-1' =&gt; array( 'AMI' =&gt; 'ami-72621c20' )
		)
	),
	'Resources' =&gt; array(
		'Ec2Instance' =&gt; array(
			'Type' =&gt; 'AWS::EC2::Instance',
			'Properties' =&gt; array(
				'KeyName' =&gt; array( 'Ref' =&gt; 'KeyPair' ),
				'ImageId' =&gt; array( 'Fn::FindInMap' =&gt; array( 'RegionMap', array( 'Ref' =&gt; 'AWS::Region' ), 'AMI' ))
			)
		)
	),
	'Outputs' =&gt; array(
		'InstanceId' =&gt; array(
			'Description' =&gt; 'The InstanceId of the newly created EC2 instance',
			'Value' =&gt; array( 'Ref' =&gt; 'Ec2Instance' )
		),
		'AZ' =&gt; array(
			'Description' =&gt; 'The Availability Zone of the newly created EC2 instance',
			'Value' =&gt; array( 'Fn::GetAtt' =&gt; array( 'Ec2Instance', 'AvailabilityZone' ) )
		),
		'PublicIP' =&gt; array(
			'Description' =&gt; 'The Public IP address of the newly created EC2 instance',
			'Value' =&gt; array( 'Fn::GetAtt' =&gt; array( 'Ec2Instance', 'PublicIp' ) )
		)
	)
));

var_dump(sha1($template));";s:6:"result";s:53:"string(40) "9424c0db71fca8b6e0200d77571e41bb867d7f4b"";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazoncloudformation/get_template.html" rel="../../index.html#m=amazoncloudformation/get_template"><code>AmazonCloudFormation::get_template()</code></a>";i:1;s:179:"<a href="../amazoncloudformation/validate_template.html" rel="../../index.html#m=amazoncloudformation/validate_template"><code>AmazonCloudFormation::validate_template()</code></a>";i:2;s:108:"<a href="../cfstacktemplate/json.html" rel="../../index.html#m=cfstacktemplate/json"><code>json()</code></a>";}}}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}}}