a:2:{s:4:"file";a:0:{}s:5:"class";a:8:{s:4:"name";s:11:"CFUtilities";s:4:"file";s:29:"utilities/utilities.class.php";s:3:"url";s:25:"../cfutilities/index.html";s:11:"description";s:82:"<p>Contains a set of utility methods for connecting to, and working with, AWS.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2010.09.30";s:7:"license";s:53:"See the included NOTICE.md file for more information.";s:9:"copyright";s:53:"See the included NOTICE.md file for more information.";s:4:"link";s:47:"http://aws.amazon.com/php/ PHP Developer Center";}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"17";}s:6:"method";a:17:{i:0;a:5:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>Constructs a new instance of this class.</p>";s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:51:"public function __construct()
{
    return $this;
}";}i:1;a:7:{s:4:"name";s:23:"convert_date_to_iso8601";s:8:"modifier";s:6:"public";s:11:"description";s:84:"<p>Checks to see if a date stamp is ISO-8601 formatted, and if not, makes it so.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"datestamp";s:4:"type";s:6:"string";s:11:"description";s:70:"<p>A date stamp, or a string that can be parsed into a date stamp.</p>";}}s:11:"returnvalue";s:40:"<p>An ISO-8601 formatted date stamp.</p>";s:6:"source";s:260:"public function convert_date_to_iso8601($datestamp)
{
    if (!preg_match('/\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}((\+|-)\d{2}:\d{2}|Z)/m', $datestamp))
    {
        return gmdate(self::DATE_FORMAT_ISO8601, strtotime($datestamp));
    }

    return $datestamp;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Convert a date into ISO-8601 format.</p>";s:4:"code";s:323:"// Instantiate the object
$s3 = new AmazonS3();

// Test for ISO-8601, and convert if not.
$date_correct = '2009-08-01T07:00:00Z';
$date_incorrect = '1 August 2009, 7am GMT';

// Success?
var_dump($s3-&gt;util-&gt;convert_date_to_iso8601($date_correct));
var_dump($s3-&gt;util-&gt;convert_date_to_iso8601($date_incorrect));";s:6:"result";s:67:"string(20) "2009-08-01T07:00:00Z"
string(20) "2009-08-01T07:00:00Z"";}}}i:2;a:7:{s:4:"name";s:25:"convert_response_to_array";s:8:"modifier";s:6:"public";s:11:"description";s:59:"<p>Converts a SimpleXML response to an array structure.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"response";s:4:"type";s:12:"ResponseCore";s:11:"description";s:24:"<p>A response value.</p>";}}s:11:"returnvalue";s:65:"<p>The response value as a standard, multi-dimensional array.</p>";s:6:"source";s:123:"public function convert_response_to_array(ResponseCore $response)
{
    return json_decode(json_encode($response), true);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:71:"<p>Converts a SimpleXML response into a standard associative array.</p>";s:4:"code";s:291:"// Get a ResponseCore response
$pas = new AmazonPAS();
$data = $pas-&gt;item_search('skillet awake');

// Convert SimpleXMLElement to Array.
$data = $pas-&gt;util-&gt;convert_response_to_array($data);

// Success?
var_dump($data['body']['Items']['Request']['ItemSearchRequest']['Keywords']);";s:6:"result";s:26:"string(13) "skillet awake"";}}}i:3;a:6:{s:4:"name";s:11:"decode_uhex";s:8:"modifier";s:6:"public";s:11:"description";s:90:"<p>Decodes <code>\uXXXX</code> entities into their real unicode character equivalents.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:1:"s";s:4:"type";s:6:"string";s:11:"description";s:28:"<p>The string to decode.</p>";}}s:11:"returnvalue";s:26:"<p>The decoded string.</p>";s:6:"source";s:422:"public function decode_uhex($s)
{
    preg_match_all('/\\\u([0-9a-f]{4})/i', $s, $matches);
    $matches = $matches[count($matches) - 1];
    $map = array();

    foreach ($matches as $match)
    {
        if (!isset($map[$match]))
        {
            $map['\u' . $match] = html_entity_decode('&amp;#' . hexdec($match) . ';', ENT_NOQUOTES, 'UTF-8');
        }
    }

    return str_replace(array_keys($map), $map, $s);
}";}i:4;a:6:{s:4:"name";s:17:"encode_signature2";s:8:"modifier";s:6:"public";s:11:"description";s:46:"<p>Encode the value according to RFC 3986.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"string";s:4:"type";s:6:"string";s:11:"description";s:25:"<p>String to convert.</p>";}}s:11:"returnvalue";s:37:"<p>URL-friendly sign-able string.</p>";s:6:"source";s:128:"public function encode_signature2($string)
{
    $string = rawurlencode($string);
    return str_replace('%7E', '~', $string);
}";}i:5;a:6:{s:4:"name";s:13:"generate_guid";s:8:"modifier";s:6:"public";s:11:"description";s:31:"<p>Generates a random GUID.</p>";s:8:"metadata";a:2:{s:6:"author";s:87:"<a href="http://www.php.net/manual/en/function.com-create-guid.php#99425">Alix Axel</a>";s:7:"license";s:47:"http://www.php.net/license/3_01.txt PHP License";}s:11:"returnvalue";s:21:"<p>A random GUID.</p>";s:6:"source";s:333:"public function generate_guid()
{
    return sprintf(
        '%04X%04X-%04X-%04X-%04X-%04X%04X%04X',
        mt_rand(0, 65535),
        mt_rand(0, 65535),
        mt_rand(0, 65535),
        mt_rand(16384, 20479),
        mt_rand(32768, 49151),
        mt_rand(0, 65535),
        mt_rand(0, 65535),
        mt_rand(0, 65535)
    );
}";}i:6;a:6:{s:4:"name";s:13:"hex_to_base64";s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>Convert a HEX value to Base64.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:3:"str";s:4:"type";s:6:"string";s:11:"description";s:24:"<p>Value to convert.</p>";}}s:11:"returnvalue";s:29:"<p>Base64-encoded string.</p>";s:6:"source";s:198:"public function hex_to_base64($str)
{
    $raw = '';

    for ($i = 0; $i &lt; strlen($str); $i += 2)
    {
        $raw .= chr(hexdec(substr($str, $i, 2)));
    }

    return base64_encode($raw);
}";}i:7;a:7:{s:4:"name";s:9:"is_base64";s:8:"modifier";s:6:"public";s:11:"description";s:60:"<p>Determines whether the data is Base64 encoded or not.</p>";s:8:"metadata";a:1:{s:7:"license";s:72:"http://us.php.net/manual/en/function.base64-decode.php#81425 PHP License";}s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:1:"s";s:4:"type";s:6:"string";s:11:"description";s:26:"<p>The string to test.</p>";}}s:11:"returnvalue";s:51:"<p>Whether the string is Base64 encoded or not.</p>";s:6:"source";s:100:"public function is_base64($s)
{
    return (bool) preg_match('/^[a-zA-Z0-9\/\r\n+]*={0,2}$/', $s);
}";}i:8;a:6:{s:4:"name";s:7:"is_json";s:8:"modifier";s:6:"public";s:11:"description";s:59:"<p>Determines whether the data is a JSON string or not.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:1:"s";s:4:"type";s:6:"string";s:11:"description";s:26:"<p>The string to test.</p>";}}s:11:"returnvalue";s:56:"<p>Whether the string is a valid JSON object or not.</p>";s:6:"source";s:83:"public function is_json($s)
{
    return !!(json_decode($s) instanceof stdClass);
}";}i:9;a:7:{s:4:"name";s:11:"json_encode";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>Can be removed once all calls are updated.</p>";s:8:"metadata";a:1:{s:10:"deprecated";s:80:"Use <a href="http://php.net/json_encode"><code>json_encode()</code></a> instead.";}s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:3:"obj";s:4:"type";s:5:"mixed";s:11:"description";s:52:"<p>The PHP object to convert into a JSON string.</p>";}}s:11:"returnvalue";s:21:"<p>A JSON string.</p>";s:6:"source";s:67:"public function json_encode($obj)
{
    return json_encode($obj);
}";}i:10;a:7:{s:4:"name";s:5:"konst";s:8:"modifier";s:6:"public";s:11:"description";s:167:"<p>Retrieves the value of a class constant, while avoiding the <code>T_PAAMAYIM_NEKUDOTAYIM</code> error. Misspelled because <code>const</code> is a reserved word.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"class";s:4:"type";s:6:"object";s:11:"description";s:56:"<p>An instance of the class containing the constant.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"const";s:4:"type";s:6:"string";s:11:"description";s:44:"<p>The name of the constant to retrieve.</p>";}}}s:11:"returnvalue";s:39:"<p>The value of the class constant.</p>";s:6:"source";s:232:"public function konst($class, $const)
{
    if (is_string($class))
    {
        $ref = new ReflectionClass($class);
    }
    else
    {
        $ref = new ReflectionObject($class);
    }

    return $ref-&gt;getConstant($const);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:38:"<p>Very simple example of konst().</p>";s:4:"code";s:148:"$s3 = new AmazonS3();
$rfc2616 = $s3-&gt;util-&gt;konst($s3-&gt;util, 'DATE_FORMAT_RFC2616');
$date = gmdate($rfc2616, 946684800);

var_dump($date);";s:6:"result";s:42:"string(29) "Sat, 01 Jan 2000 00:00:00 GMT"";}}}i:11;a:7:{s:4:"name";s:14:"query_to_array";s:8:"modifier";s:6:"public";s:11:"description";s:111:"<p>Convert a query string into an associative array. Multiple, identical keys will become an indexed array.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"qs";s:4:"type";s:6:"string";s:11:"description";s:31:"<p>Query string to convert.</p>";}}s:11:"returnvalue";s:44:"<p>Associative array of keys and values.</p>";s:6:"source";s:597:"public function query_to_array($qs)
{
    $query = explode('&amp;', $qs);
    $data = array();

    foreach ($query as $q)
    {
        $q = explode('=', $q);

        if (isset($data[$q[0]]) &amp;&amp; is_array($data[$q[0]]))
        {
            $data[$q[0]][] = urldecode($q[1]);
        }
        else if (isset($data[$q[0]]) &amp;&amp; !is_array($data[$q[0]]))
        {
            $data[$q[0]] = array($data[$q[0]]);
            $data[$q[0]][] = urldecode($q[1]);
        }
        else
        {
            $data[urldecode($q[0])] = urldecode($q[1]);
        }
    }
    return $data;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:56:"<p>Decodes a query string into an associative array.</p>";s:4:"code";s:211:"// Instantiate
$s3 = new AmazonS3();

// Test data
$qs = $s3-&gt;util-&gt;to_query_string(array(
	'a' =&gt; 1,
	'b' =&gt; 2,
	'c' =&gt; 3,
));

// Success?
var_dump($qs);
var_dump($util-&gt;query_to_array($qs));";s:6:"result";s:132:"string(11) "a=1&amp;b=2&amp;c=3"
array(3) {
  ["a"]=&gt;
  string(1) "1"
  ["b"]=&gt;
  string(1) "2"
  ["c"]=&gt;
  string(1) "3"
}";}i:1;a:3:{s:5:"title";s:94:"<p>Decodes a query string into an associative array. Supports the same key more than once.</p>";s:4:"code";s:132:"// Instantiate
$s3 = new AmazonS3();

// Test data
var_dump($s3-&gt;util-&gt;query_to_array('a=1&amp;a=2&amp;a=3&amp;b=2&amp;c=3'));";s:6:"result";s:193:"array(3) {
  ["a"]=&gt;
  array(3) {
    [0]=&gt;
    string(1) "1"
    [1]=&gt;
    string(1) "2"
    [2]=&gt;
    string(1) "3"
  }
  ["b"]=&gt;
  string(1) "2"
  ["c"]=&gt;
  string(1) "3"
}";}}}}i:12;a:9:{s:4:"name";s:13:"size_readable";s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Return human readable file sizes.</p>";s:8:"metadata";a:2:{s:6:"author";a:2:{i:0;s:47:"<a href="mailto:aidan@php.net">Aidan Lister</a>";i:1;s:56:"<a href="mailto:ryan@getcloudfusion.com">Ryan Parman</a>";}s:7:"license";s:47:"http://www.php.net/license/3_01.txt PHP License";}s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"size";s:4:"type";s:7:"integer";s:11:"description";s:25:"<p>Filesize in bytes.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"unit";s:4:"type";s:6:"string";s:11:"description";s:73:"<p>The maximum unit to use. Defaults to the largest appropriate unit.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"default";s:4:"type";s:6:"string";s:11:"description";s:76:"<p>The format for the return string. Defaults to <code>%01.2f %s</code>.</p>";}}}s:11:"returnvalue";s:36:"<p>The human-readable file size.</p>";s:6:"source";s:626:"public function size_readable($size, $unit = null, $default = null)
{
    // Units
    $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB');
    $mod = 1024;
    $ii = count($sizes) - 1;

    // Max unit
    $unit = array_search((string) $unit, $sizes);
    if ($unit === null || $unit === false)
    {
        $unit = $ii;
    }

    // Return string
    if ($default === null)
    {
        $default = '%01.2f %s';
    }

    // Loop
    $i = 0;
    while ($unit != $i &amp;&amp; $size &gt;= 1024 &amp;&amp; $i &lt; $ii)
    {
        $size /= $mod;
        $i++;
    }

    return sprintf($default, $size, $sizes[$i]);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:62:"<p>Convert a number of bytes into a human-readable format.</p>";s:4:"code";s:104:"// Instantiate
$s3 = new AmazonS3();

// Test data
var_dump($s3-&gt;util-&gt;size_readable(9876543210));";s:6:"result";s:19:"string(7) "9.20 GB"";}}s:7:"seealso";a:1:{s:4:"link";s:89:"<a href="http://aidanlister.com/repos/v/function.size_readable.php">Original Function</a>";}}i:13;a:7:{s:4:"name";s:8:"time_hms";s:8:"modifier";s:6:"public";s:11:"description";s:62:"<p>Convert a number of seconds into Hours:Minutes:Seconds.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"seconds";s:4:"type";s:7:"integer";s:11:"description";s:40:"<p>The number of seconds to convert.</p>";}}s:11:"returnvalue";s:26:"<p>The formatted time.</p>";s:6:"source";s:454:"public function time_hms($seconds)
{
    $time = '';

    // First pass
    $hours = (int) ($seconds / 3600);
    $seconds = $seconds % 3600;
    $minutes = (int) ($seconds / 60);
    $seconds = $seconds % 60;

    // Cleanup
    $time .= ($hours) ? $hours . ':' : '';
    $time .= ($minutes &lt; 10 &amp;&amp; $hours &gt; 0) ? '0' . $minutes : $minutes;
    $time .= ':';
    $time .= ($seconds &lt; 10) ? '0' . $seconds : $seconds;

    return $time;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:57:"<p>Converts a number of seconds into HH:MM:SS format.</p>";s:4:"code";s:94:"// Instantiate
$s3 = new AmazonS3();

// Test data
var_dump($s3-&gt;util-&gt;time_hms(98765));";s:6:"result";s:20:"string(8) "27:26:05"";}}}i:14;a:7:{s:4:"name";s:15:"to_query_string";s:8:"modifier";s:6:"public";s:11:"description";s:56:"<p>Convert an associative array into a query string.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"array";s:4:"type";s:5:"array";s:11:"description";s:24:"<p>Array to convert.</p>";}}s:11:"returnvalue";s:33:"<p>URL-friendly query string.</p>";s:6:"source";s:305:"public function to_query_string($array)
{
    $temp = array();

    foreach ($array as $key =&gt; $value)
    {
        if (is_string($key) &amp;&amp; !is_array($value))
        {
            $temp[] = rawurlencode($key) . '=' . rawurlencode($value);
        }
    }

    return implode('&amp;', $temp);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:56:"<p>Convert an associative array into a query string.</p>";s:4:"code";s:146:"// Instantiate
$s3 = new AmazonS3();

// Test data
var_dump($s3-&gt;util-&gt;to_query_string(array(
	'a' =&gt; 1,
	'b' =&gt; 2,
	'c' =&gt; 3,
)));";s:6:"result";s:32:"string(11) "a=1&amp;b=2&amp;c=3"";}}}i:15;a:6:{s:4:"name";s:18:"to_signable_string";s:8:"modifier";s:6:"public";s:11:"description";s:60:"<p>Convert an associative array into a sign-able string.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"array";s:4:"type";s:5:"array";s:11:"description";s:24:"<p>Array to convert.</p>";}}s:11:"returnvalue";s:37:"<p>URL-friendly sign-able string.</p>";s:6:"source";s:235:"public function to_signable_string($array)
{
    $t = array();

    foreach ($array as $k =&gt; $v)
    {
        $t[] = $this-&gt;encode_signature2($k) . '=' . $this-&gt;encode_signature2($v);
    }

    return implode('&amp;', $t);
}";}i:16;a:7:{s:4:"name";s:9:"try_these";s:8:"modifier";s:6:"public";s:11:"description";s:178:"<p>Returns the first value that is set. Based on <a href="http://api.prototypejs.org/language/Try/these/">Try.these()</a> from <a href="http://prototypejs.org">Prototype</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"attrs";s:4:"type";s:5:"array";s:11:"description";s:183:"<p>The attributes to test, as strings. Intended for testing properties of the $base object, but also works with variables if you place an @ symbol at the beginning of the command.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"base";s:4:"type";s:6:"object";s:11:"description";s:38:"<p>The base object to use, if any.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"default";s:4:"type";s:5:"mixed";s:11:"description";s:77:"<p>What to return if there are no matches. Defaults to <code>null</code>.</p>";}}}s:11:"returnvalue";s:121:"<p>Either a matching property of a given object, boolean <code>false</code>, or any other data type you might choose.</p>";s:6:"source";s:442:"public function try_these($attrs, $base = null, $default = null)
{
    if ($base)
    {
        foreach ($attrs as $attr)
        {
            if (isset($base-&gt;$attr))
            {
                return $base-&gt;$attr;
            }
        }
    }
    else
    {
        foreach ($attrs as $attr)
        {
            if (isset($attr))
            {
                return $attr;
            }
        }
    }

    return $default;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Return the first non-falsey value.</p>";s:4:"code";s:234:"// Test data
$obj = new StdClass;
$obj-&gt;a = null;
$obj-&gt;b = null;
$obj-&gt;c = 1;
$obj-&gt;d = null;

// Instantiate
$s3 = new AmazonS3();

// Success?
var_dump($s3-&gt;util-&gt;try_these(array('a', 'b', 'c', 'd'), $obj, true));";s:6:"result";s:6:"int(1)";}}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"4";}s:8:"constant";a:4:{i:0;a:2:{s:4:"name";s:19:"DATE_FORMAT_ISO8601";s:5:"value";s:14:"Y-m-d\TH:i:s\Z";}i:1;a:2:{s:4:"name";s:17:"DATE_FORMAT_MYSQL";s:5:"value";s:11:"Y-m-d H:i:s";}i:2;a:2:{s:4:"name";s:19:"DATE_FORMAT_RFC2616";s:5:"value";s:21:"D, d M Y H:i:s \G\M\T";}i:3;a:2:{s:4:"name";s:17:"DATE_FORMAT_SIGV4";s:5:"value";s:10:"Ymd\THis\Z";}}}s:10:"properties";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}}}