a:2:{s:4:"file";a:0:{}s:5:"class";a:10:{s:4:"name";s:8:"CachePDO";s:4:"file";s:32:"lib/cachecore/cachepdo.class.php";s:3:"url";s:22:"../cachepdo/index.html";s:11:"description";s:132:"<p>Container for all PDO-based cache methods. Inherits additional methods from <CacheCore>. Adheres
to the ICacheCore interface.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2012.04.17";s:9:"copyright";a:4:{i:0;s:21:"2006-2012 Ryan Parman";i:1;s:22:"2006-2010 Foleeo, Inc.";i:2;s:40:"2012 Amazon.com, Inc. or its affiliates.";i:3;s:22:"2008-2010 Contributors";}s:7:"license";s:69:"http://opensource.org/licenses/bsd-license.php Simplified BSD License";s:4:"link";a:3:{i:0;s:44:"http://github.com/skyzyx/cachecore CacheCore";i:1;s:37:"http://getcloudfusion.com CloudFusion";i:2;s:22:"http://php.net/pdo PDO";}}s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:10:"implements";a:1:{s:9:"interface";a:2:{s:4:"name";s:10:"ICacheCore";s:4:"file";s:38:"lib/cachecore/icachecore.interface.php";}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"13";}s:6:"method";a:13:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:503:"<p>Constructs a new instance of this class.</p>

<p>Tested with <a href="http://mysql.com">MySQL 5.0.x</a>, <a href="http://postgresql.com">PostgreSQL</a>, and
<a href="http://sqlite.org">SQLite 3.x</a>. SQLite 2.x is assumed to work. No other PDO-supported databases have
been tested (e.g. Oracle, Microsoft SQL Server, IBM DB2, ODBC, Sybase, Firebird). Feel free to send
patches for additional database support.</p>

<p>See <a href="http://php.net/pdo">http://php.net/pdo</a> for more information.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"name";s:4:"type";s:6:"string";s:11:"description";s:52:"<p>A name to uniquely identify the cache object.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:107:"<p>The location to store the cache object in. This may vary by cache method. The default value is NULL.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"expires";s:4:"type";s:7:"integer";s:11:"description";s:94:"<p>The number of seconds until a cache object is considered stale. The default value is 0.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:85:"<p>Whether data should be gzipped before being stored. The default value is true.</p>";}}}s:11:"returnvalue";s:37:"<p>Reference to the cache object.</p>";s:6:"source";s:2008:"public function __construct($name, $location = null, $expires = 0, $gzip = true)
{
    // Make sure the name is no longer than 40 characters.
    $name = sha1($name);

    // Call parent constructor and set id.
    parent::__construct($name, $location, $expires, $gzip);
    $this-&gt;id = $this-&gt;name;
    $options = array();

    // Check if the location contains :// (e.g. mysql://user:pass@hostname:port/table)
    if (stripos($location, '://') === false)
    {
        // No? Just pass it through.
        $this-&gt;dsn = parse_url($location);
        $this-&gt;dsn_string = $location;
    }
    else
    {
        // Yes? Parse and set the DSN
        $this-&gt;dsn = parse_url($location);
        $this-&gt;dsn_string = $this-&gt;dsn['scheme'] . ':host=' . $this-&gt;dsn['host'] . ((isset($this-&gt;dsn['port'])) ? ';port=' . $this-&gt;dsn['port'] : '') . ';dbname=' . substr($this-&gt;dsn['path'], 1);
    }

    // Make sure that user/pass are defined.
    $user = isset($this-&gt;dsn['user']) ? $this-&gt;dsn['user'] : null;
    $pass = isset($this-&gt;dsn['pass']) ? $this-&gt;dsn['pass'] : null;

    // Set persistence for databases that support it.
    switch ($this-&gt;dsn['scheme'])
    {
        case 'mysql': // MySQL
        case 'pgsql': // PostgreSQL
            $options[PDO::ATTR_PERSISTENT] = true;
            break;
    }

    // Instantiate a new PDO object with a persistent connection.
    $this-&gt;pdo = new PDO($this-&gt;dsn_string, $user, $pass, $options);

    // Define prepared statements for improved performance.
    $this-&gt;create = $this-&gt;pdo-&gt;prepare(&quot;INSERT INTO cache (id, expires, data) VALUES (:id, :expires, :data)&quot;);
    $this-&gt;read = $this-&gt;pdo-&gt;prepare(&quot;SELECT id, expires, data FROM cache WHERE id = :id&quot;);
    $this-&gt;reset = $this-&gt;pdo-&gt;prepare(&quot;UPDATE cache SET expires = :expires WHERE id = :id&quot;);
    $this-&gt;delete = $this-&gt;pdo-&gt;prepare(&quot;DELETE FROM cache WHERE id = :id&quot;);
}";}i:1;a:6:{s:4:"name";s:6:"create";s:8:"modifier";s:6:"public";s:11:"description";s:27:"<p>Creates a new cache.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"data";s:4:"type";s:5:"mixed";s:11:"description";s:25:"<p>The data to cache.</p>";}}s:11:"returnvalue";s:44:"<p>Whether the operation was successful.</p>";s:6:"source";s:360:"public function create($data)
{
    $data = serialize($data);
    $data = $this-&gt;gzip ? gzcompress($data) : $data;

    $this-&gt;create-&gt;bindParam(':id', $this-&gt;id);
    $this-&gt;create-&gt;bindParam(':data', $data);
    $this-&gt;create-&gt;bindParam(':expires', $this-&gt;generate_timestamp());

    return (bool) $this-&gt;create-&gt;execute();
}";}i:2;a:5:{s:4:"name";s:6:"delete";s:8:"modifier";s:6:"public";s:11:"description";s:23:"<p>Deletes a cache.</p>";s:11:"returnvalue";s:44:"<p>Whether the operation was successful.</p>";s:6:"source";s:128:"public function delete()
{
    $this-&gt;delete-&gt;bindParam(':id', $this-&gt;id);
    return $this-&gt;delete-&gt;execute();
}";}i:3;a:7:{s:4:"name";s:9:"expire_in";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CacheCore";}}s:11:"description";s:55:"<p>Set the number of seconds until a cache expires.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"seconds";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:5:"$this";}}s:6:"source";a:1:{s:11:"@attributes";a:4:{s:4:"file";s:33:"lib/cachecore/cachecore.class.php";s:5:"start";s:3:"101";s:3:"end";s:3:"105";s:5:"lines";s:1:"5";}}}i:4;a:5:{s:4:"name";s:18:"generate_timestamp";s:8:"modifier";s:9:"protected";s:11:"description";s:73:"<p>Returns a timestamp value apropriate to the current database type.</p>";s:11:"returnvalue";s:68:"<p>Timestamp for MySQL and PostgreSQL, integer value for SQLite.</p>";s:6:"source";s:496:"protected function generate_timestamp()
{
    // Define 'expires' settings differently.
    switch ($this-&gt;dsn['scheme'])
    {
        // These support timestamps.
        case 'mysql': // MySQL
        case 'pgsql': // PostgreSQL
            $expires = date(DATE_FORMAT_MYSQL, time());
            break;

        // These support integers.
        case 'sqlite': // SQLite 3
        case 'sqlite2': // SQLite 2
            $expires = time();
            break;
    }

    return $expires;
}";}i:5;a:6:{s:4:"name";s:11:"get_drivers";s:8:"modifier";s:6:"public";s:11:"description";s:102:"<p>Returns a list of supported PDO database drivers. Identical to &lt;PDO::getAvailableDrivers()>.</p>";s:11:"returnvalue";s:46:"<p>The list of supported database drivers.</p>";s:6:"source";s:72:"public function get_drivers()
{
    return PDO::getAvailableDrivers();
}";s:7:"seealso";a:1:{s:4:"link";s:63:"<a href="http://php.net/pdo.getavailabledrivers">PHP Method</a>";}}i:6;a:7:{s:4:"name";s:4:"init";s:8:"modifier";s:13:"public static";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CacheCore";}}s:11:"description";s:75:"<p>Allows for chaining from the constructor. Requires PHP 5.3 or newer.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"name";s:4:"type";s:6:"string";s:11:"description";s:52:"<p>A name to uniquely identify the cache object.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:107:"<p>The location to store the cache object in. This may vary by cache method. The default value is NULL.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"expires";s:4:"type";s:7:"integer";s:11:"description";s:94:"<p>The number of seconds until a cache object is considered stale. The default value is 0.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:85:"<p>Whether data should be gzipped before being stored. The default value is true.</p>";}}}s:11:"returnvalue";s:37:"<p>Reference to the cache object.</p>";s:6:"source";a:1:{s:11:"@attributes";a:4:{s:4:"file";s:33:"lib/cachecore/cachecore.class.php";s:5:"start";s:2:"84";s:3:"end";s:2:"93";s:5:"lines";s:2:"10";}}}i:7;a:5:{s:4:"name";s:10:"is_expired";s:8:"modifier";s:6:"public";s:11:"description";s:57:"<p>Checks whether the cache object is expired or not.</p>";s:11:"returnvalue";s:43:"<p>Whether the cache is expired or not.</p>";s:6:"source";s:147:"public function is_expired()
{
    if ($this-&gt;timestamp() + $this-&gt;expires &lt; time())
    {
        return true;
    }

    return false;
}";}i:8;a:5:{s:4:"name";s:4:"read";s:8:"modifier";s:6:"public";s:11:"description";s:21:"<p>Reads a cache.</p>";s:11:"returnvalue";s:77:"<p>Either the content of the cache object, or boolean <code>false</code>.</p>";s:6:"source";s:447:"public function read()
{
    if (!$this-&gt;store_read)
    {
        $this-&gt;read-&gt;bindParam(':id', $this-&gt;id);
        $this-&gt;read-&gt;execute();
        $this-&gt;store_read = $this-&gt;read-&gt;fetch(PDO::FETCH_ASSOC);
    }

    if ($this-&gt;store_read)
    {
        $data = $this-&gt;store_read['data'];
        $data = $this-&gt;gzip ? gzuncompress($data) : $data;

        return unserialize($data);
    }

    return false;
}";}i:9;a:5:{s:4:"name";s:5:"reset";s:8:"modifier";s:6:"public";s:11:"description";s:41:"<p>Resets the freshness of the cache.</p>";s:11:"returnvalue";s:44:"<p>Whether the operation was successful.</p>";s:6:"source";s:211:"public function reset()
{
    $this-&gt;reset-&gt;bindParam(':id', $this-&gt;id);
    $this-&gt;reset-&gt;bindParam(':expires', $this-&gt;generate_timestamp());
    return (bool) $this-&gt;reset-&gt;execute();
}";}i:10;a:7:{s:4:"name";s:16:"response_manager";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CacheCore";}}s:11:"description";s:104:"<p>Provides a simple, straightforward cache-logic mechanism. Useful for non-complex response caches.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:15:"string|function";s:11:"description";s:80:"<p>The name of the function to fire when we need to fetch new data to cache.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:6:"params";s:4:"type";s:5:"array";s:11:"description";s:66:"<p>Parameters to pass into the callback function, as an array.</p>";}}}s:11:"returnvalue";s:39:"<p>The cached data being requested.</p>";s:6:"source";a:1:{s:11:"@attributes";a:4:{s:4:"file";s:33:"lib/cachecore/cachecore.class.php";s:5:"start";s:3:"114";s:3:"end";s:3:"143";s:5:"lines";s:2:"30";}}}i:11;a:5:{s:4:"name";s:9:"timestamp";s:8:"modifier";s:6:"public";s:11:"description";s:44:"<p>Retrieves the timestamp of the cache.</p>";s:11:"returnvalue";s:87:"<p>Either the Unix time stamp of the cache creation, or boolean <code>false</code>.</p>";s:6:"source";s:605:"public function timestamp()
{
    if (!$this-&gt;store_read)
    {
        $this-&gt;read-&gt;bindParam(':id', $this-&gt;id);
        $this-&gt;read-&gt;execute();
        $this-&gt;store_read = $this-&gt;read-&gt;fetch(PDO::FETCH_ASSOC);
    }

    if ($this-&gt;store_read)
    {
        $value = $this-&gt;store_read['expires'];

        // If 'expires' isn't yet an integer, convert it into one.
        if (!is_numeric($value))
        {
            $value = strtotime($value);
        }

        $this-&gt;timestamp = date('U', $value);
        return $this-&gt;timestamp;
    }

    return false;
}";}i:12;a:6:{s:4:"name";s:6:"update";s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>Updates an existing cache.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"data";s:4:"type";s:5:"mixed";s:11:"description";s:25:"<p>The data to cache.</p>";}}s:11:"returnvalue";s:44:"<p>Whether the operation was successful.</p>";s:6:"source";s:93:"public function update($data)
{
    $this-&gt;delete();
    return $this-&gt;create($data);
}";}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"15";}s:8:"property";a:15:{i:0;a:3:{s:4:"name";s:6:"create";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>Holds the prepared statement for creating an entry.</p>";}i:1;a:3:{s:4:"name";s:6:"delete";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>Holds the prepared statement for deleting an entry.</p>";}i:2;a:3:{s:4:"name";s:3:"dsn";s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>Holds the parsed URL components.</p>";}i:3;a:3:{s:4:"name";s:10:"dsn_string";s:8:"modifier";s:6:"public";s:11:"description";s:63:"<p>Holds the PDO-friendly version of the connection string.</p>";}i:4;a:4:{s:4:"name";s:7:"expires";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:71:"<p>The number of seconds before a cache object is considered stale.</p>";}i:5;a:4:{s:4:"name";s:4:"gzip";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:70:"<p>Stores whether or not the content should be gzipped when stored</p>";}i:6;a:4:{s:4:"name";s:2:"id";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:84:"<p>Used internally to uniquely identify the location + name of the cache object.</p>";}i:7;a:4:{s:4:"name";s:8:"location";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>Where to store the cache.</p>";}i:8;a:4:{s:4:"name";s:4:"name";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:55:"<p>A name to uniquely identify the cache object by.</p>";}i:9;a:3:{s:4:"name";s:3:"pdo";s:8:"modifier";s:6:"public";s:11:"description";s:46:"<p>Reference to the PDO connection object.</p>";}i:10;a:3:{s:4:"name";s:4:"read";s:8:"modifier";s:6:"public";s:11:"description";s:57:"<p>Holds the prepared statement for reading an entry.</p>";}i:11;a:3:{s:4:"name";s:5:"reset";s:8:"modifier";s:6:"public";s:11:"description";s:73:"<p>Holds the prepared statement for resetting the expiry of an entry.</p>";}i:12;a:3:{s:4:"name";s:10:"store_read";s:8:"modifier";s:6:"public";s:11:"description";s:105:"<p>Holds the response of the read so we only need to fetch it once instead of doing
multiple queries.</p>";}i:13;a:4:{s:4:"name";s:9:"timestamp";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CacheCore";s:4:"file";s:33:"lib/cachecore/cachecore.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:57:"<p>Stores the time when the cache object was created.</p>";}i:14;a:3:{s:4:"name";s:6:"update";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>Holds the prepared statement for updating an entry.</p>";}}}}}