a:2:{s:4:"file";a:0:{}s:5:"class";a:7:{s:4:"name";s:22:"DynamoDBSessionHandler";s:4:"file";s:43:"extensions/dynamodbsessionhandler.class.php";s:3:"url";s:36:"../dynamodbsessionhandler/index.html";s:11:"description";s:424:"<p>Provides an interface for using Amazon DynamoDB as a session store by hooking into
PHP&#8217;s session handler hooks. This class is not auto-loaded, and must be included
manually or via the <code>AmazonDynamoDB::register_session_hander()</code> method.</p>

<p>Once registered, You may use the native <code>$_SESSION</code> superglobal and
session functions, and the sessions will be stored automatically in DynamoDB.</p>";s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"17";}s:6:"method";a:17:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:78:"<p>Initializes the session handler and prepares the configuration options.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"dynamodb";s:4:"type";s:14:"AmazonDynamoDB";s:11:"description";s:42:"<p>An instance of the DynamoDB client.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:29:"<p>Configuration options.</p>";}}}s:11:"returnvalue";a:0:{}s:6:"source";s:692:"public function __construct(AmazonDynamoDB $dynamodb, array $options = array())
{
    // Store the AmazonDynamoDB client for use in the session handler
    $this-&gt;_dynamodb = $dynamodb;

    // Do type conversions on options and store the values
    foreach ($options as $key =&gt; $value)
    {
        if (isset(self::$_option_types[$key]))
        {
            settype($value, self::$_option_types[$key]);
            $this-&gt;{'_' . $key} = $value;
        }
    }

    // Make sure the lifetime is positive. Use the gc_maxlifetime otherwise
    if ($this-&gt;_session_lifetime &lt;= 0)
    {
        $this-&gt;_session_lifetime = (integer) ini_get('session.gc_maxlifetime');
    }
}";}i:1;a:6:{s:4:"name";s:10:"__destruct";s:8:"modifier";s:6:"public";s:11:"description";s:318:"<p>Destruct the session handler and make sure the session gets written.</p>

<p>NOTE: It is usually better practice to call <code>session_write_close()</code>
manually in your application as soon as session modifications are complete. This
is especially true if session locking is enabled (which it is by default).</p>";s:11:"returnvalue";a:0:{}s:6:"source";s:59:"public function __destruct()
{
    session_write_close();
}";s:7:"related";a:1:{s:6:"method";s:113:"<http://php.net/manual/en/function.session-set-save-handler.php#refsect1-function.session-set-save-handler-notes>";}}i:2;a:6:{s:4:"name";s:3:"_id";s:8:"modifier";s:9:"protected";s:11:"description";s:81:"<p>Prefix the session ID with the session name and prepare for DynamoDB usage</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"id";s:4:"type";s:6:"string";s:11:"description";s:22:"<p>The session ID.</p>";}}s:11:"returnvalue";s:54:"<p>The HashKeyElement value formatted as an array.</p>";s:6:"source";s:90:"protected function _id($id)
{
    return trim($this-&gt;_session_name . '_' . $id, '_');
}";}i:3;a:6:{s:4:"name";s:14:"_lock_and_read";s:8:"modifier";s:9:"protected";s:11:"description";s:137:"<p>Acquires a lock on a session in DynamoDB using conditional updates.</p>

<p>WARNING: There is a <code>while(true);</code> in here.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"id";s:4:"type";s:6:"string";s:11:"description";s:22:"<p>The session ID.</p>";}}s:11:"returnvalue";s:34:"<p>The response from DynamoDB.</p>";s:6:"source";s:1182:"protected function _lock_and_read($id)
{
    $now = time();
    $timeout = $now + $this-&gt;_max_lock_wait_time;

    do
    {
        // Acquire the lock
        $response = $this-&gt;_dynamodb-&gt;update_item(array(
            'TableName'        =&gt; $this-&gt;_table_name,
            'Key'              =&gt; array('HashKeyElement' =&gt; $this-&gt;_dynamodb-&gt;attribute($this-&gt;_id($id))),
            'AttributeUpdates' =&gt; array('lock' =&gt; $this-&gt;_dynamodb-&gt;attribute(1, 'update')),
            'Expected'         =&gt; array('lock' =&gt; array('Exists' =&gt; false)),
            'ReturnValues'     =&gt; 'ALL_NEW',
        ));

        // If lock succeeds (or times out), exit the loop, otherwise sleep and try again
        if ($response-&gt;isOK() || $now &gt;= $timeout)
        {
            return $response;
        }
        elseif (stripos((string) $response-&gt;body-&gt;asXML(), 'ConditionalCheckFailedException') !== false)
        {
            usleep(rand($this-&gt;_min_lock_retry_utime, $this-&gt;_max_lock_retry_utime));

            $now = time();
        }
        else
        {
            return null;
        }
    }
    while (true);
}";}i:4;a:5:{s:4:"name";s:5:"close";s:8:"modifier";s:6:"public";s:11:"description";s:94:"<p>Close a session from writing</p>

<p>Part of the standard PHP session handler interface</p>";s:11:"returnvalue";s:14:"<p>Success</p>";s:6:"source";s:849:"public function close()
{
    if (!$this-&gt;_session_written)
    {
        // Ensure that the session is unlocked even if the write did not happen
        $id = $this-&gt;_open_session;
        $response = $this-&gt;_dynamodb-&gt;update_item(array(
            'TableName'        =&gt; $this-&gt;_table_name,
            'Key'              =&gt; array('HashKeyElement' =&gt; $this-&gt;_dynamodb-&gt;attribute($this-&gt;_id($id))),
            'AttributeUpdates' =&gt; array(
                'expires'  =&gt; $this-&gt;_dynamodb-&gt;attribute(time() + $this-&gt;_session_lifetime, 'update'),
                'lock'     =&gt; array('Action' =&gt; AmazonDynamoDB::ACTION_DELETE)
            ),
        ));

        $this-&gt;_session_written = $response-&gt;isOK();
    }

    $this-&gt;_open_session = null;

    return $this-&gt;_session_written;
}";}i:5;a:5:{s:4:"name";s:13:"close_session";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>Delegates to <code>session_commit()</code></p>";s:11:"returnvalue";s:17:"<p>Chainable.</p>";s:6:"source";s:76:"public function close_session()
{
    session_commit();

    return $this;
}";}i:6;a:6:{s:4:"name";s:21:"create_sessions_table";s:8:"modifier";s:6:"public";s:11:"description";s:217:"<p>Creates a table in DynamoDB for session storage according to provided configuration options.</p>

<p>Note: Table creation may also be done via the AWS Console, which might make the most sense for this use case.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:19:"read_capacity_units";s:4:"type";s:7:"integer";s:11:"description";s:48:"<p>Read capacity units for table throughput.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:20:"write_capacity_units";s:4:"type";s:7:"integer";s:11:"description";s:49:"<p>Write capacity units for table throughput.</p>";}}}s:11:"returnvalue";s:44:"<p>Returns <code>true</code> on success.</p>";s:6:"source";s:649:"public function create_sessions_table($read_capacity_units = 10, $write_capacity_units = 5)
{
    $response = $this-&gt;_dynamodb-&gt;create_table(array(
        'TableName' =&gt; $this-&gt;_table_name,
        'KeySchema' =&gt; array(
            'HashKeyElement' =&gt; array(
                'AttributeName' =&gt; $this-&gt;_hash_key,
                'AttributeType' =&gt; AmazonDynamoDB::TYPE_STRING,
            )
        ),
        'ProvisionedThroughput' =&gt; array(
            'ReadCapacityUnits' =&gt; $read_capacity_units,
            'WriteCapacityUnits' =&gt; $write_capacity_units,
        )
    ));

    return $response-&gt;isOK();
}";}i:7;a:5:{s:4:"name";s:21:"delete_sessions_table";s:8:"modifier";s:6:"public";s:11:"description";s:173:"<p>Deletes the session storage table from DynamoDB.</p>

<p>Note: Table deletion may also be done via the AWS Console, which might make the most sense for this use case.</p>";s:11:"returnvalue";s:44:"<p>Returns <code>true</code> on success.</p>";s:6:"source";s:179:"public function delete_sessions_table()
{
    $response = $this-&gt;_dynamodb-&gt;delete_table(array('TableName' =&gt; $this-&gt;_table_name));

    return $response-&gt;isOK();
}";}i:8;a:6:{s:4:"name";s:7:"destroy";s:8:"modifier";s:6:"public";s:11:"description";s:103:"<p>Delete a session stored in DynamoDB.</p>

<p>Part of the standard PHP session handler interface.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"id";s:4:"type";s:6:"string";s:11:"description";s:22:"<p>The session ID.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:20:"garbage_collect_mode";s:4:"type";s:7:"boolean";s:11:"description";s:62:"<p>Whether or not the handler is doing garbage collection.</p>";}}}s:11:"returnvalue";s:46:"<p>Whether or not the operation succeeded.</p>";s:6:"source";s:812:"public function destroy($id, $garbage_collect_mode = false)
{
    // Make sure we don't prefix the ID a second time
    if (!$garbage_collect_mode)
    {
        $id = $this-&gt;_id($id);
    }

    $delete_options = array(
        'TableName' =&gt; $this-&gt;_table_name,
        'Key'       =&gt; array('HashKeyElement' =&gt; $this-&gt;_dynamodb-&gt;attribute($id)),
    );

    // Make sure not to garbage collect locked sessions
    if ($garbage_collect_mode &amp;&amp; $this-&gt;_session_locking)
    {
        $delete_options['Expected'] = array('lock' =&gt; array('Exists' =&gt; false));
    }

    // Send the delete request to DynamoDB
    $response = $this-&gt;_dynamodb-&gt;delete_item($delete_options);

    $this-&gt;_session_written = $response-&gt;isOK();

    return $this-&gt;_session_written;
}";}i:9;a:5:{s:4:"name";s:15:"destroy_session";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Delegates to <code>session_destroy()</code></p>";s:11:"returnvalue";s:17:"<p>Chainable.</p>";s:6:"source";s:79:"public function destroy_session()
{
    session_destroy();

    return $this;
}";}i:10;a:6:{s:4:"name";s:15:"garbage_collect";s:8:"modifier";s:6:"public";s:11:"description";s:140:"<p>Performs garbage collection on the sessions stored in the DynamoDB table.</p>

<p>Part of the standard PHP session handler interface.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"maxlifetime";s:4:"type";s:7:"integer";s:11:"description";s:65:"<p>The value of <code>session.gc_maxlifetime</code>. Ignored.</p>";}}s:11:"returnvalue";s:46:"<p>Whether or not the operation succeeded.</p>";s:6:"source";s:1014:"public function garbage_collect($maxlifetime = null)
{
    // Send a search request to DynamoDB looking for expired sessions
    $response = $this-&gt;_dynamodb-&gt;scan(array(
        'TableName'  =&gt; $this-&gt;_table_name,
        'ScanFilter' =&gt; array('expires' =&gt; array(
            'AttributeValueList' =&gt; array($this-&gt;_dynamodb-&gt;attribute(time())),
            'ComparisonOperator' =&gt; AmazonDynamoDB::CONDITION_LESS_THAN,
        )),
    ));

    // Delete the expired sessions
    if ($response-&gt;isOK())
    {
        $deleted = array();

        // Get the ID of and delete each session that is expired
        foreach ($response-&gt;body-&gt;Items as $item)
        {
            $id = (string) $item-&gt;{$this-&gt;_hash_key}-&gt;{AmazonDynamoDB::TYPE_STRING};
            $deleted[$id] = $this-&gt;destroy($id, true);
        }

        // Return true if all of the expired sessions were deleted
        return (array_sum($deleted) === count($deleted));
    }

    return false;
}";}i:11;a:5:{s:4:"name";s:15:"is_session_open";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Checks if the session is open and writable.</p>";s:11:"returnvalue";s:60:"<p>Whether or not the session is still open for writing.</p>";s:6:"source";s:83:"public function is_session_open()
{
    return (boolean) $this-&gt;_open_session;
}";}i:12;a:6:{s:4:"name";s:4:"open";s:8:"modifier";s:6:"public";s:11:"description";s:180:"<p>Open a session for writing. Triggered by <a href="http://php.net/session_start"><code>session_start()</code></a>.</p>

<p>Part of the standard PHP session handler interface.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"save_path";s:4:"type";s:6:"string";s:11:"description";s:115:"<p>The session save path (see <a href="http://php.net/session_save_path"><code>session_save_path()</code></a>).</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"session_name";s:4:"type";s:6:"string";s:11:"description";s:100:"<p>The session name (see <a href="http://php.net/session_name"><code>session_name()</code></a>).</p>";}}}s:11:"returnvalue";s:46:"<p>Whether or not the operation succeeded.</p>";s:6:"source";s:200:"public function open($save_path, $session_name)
{
    $this-&gt;_save_path    = $save_path;
    $this-&gt;_session_name = $session_name;
    $this-&gt;_open_session = session_id();

    return true;
}";}i:13;a:5:{s:4:"name";s:12:"open_session";s:8:"modifier";s:6:"public";s:11:"description";s:48:"<p>Delegates to <code>session_start()</code></p>";s:11:"returnvalue";s:17:"<p>Chainable.</p>";s:6:"source";s:74:"public function open_session()
{
    session_start();

    return $this;
}";}i:14;a:6:{s:4:"name";s:4:"read";s:8:"modifier";s:6:"public";s:11:"description";s:99:"<p>Read a session stored in DynamoDB</p>

<p>Part of the standard PHP session handler interface</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"id";s:4:"type";s:6:"string";s:11:"description";s:22:"<p>The session ID.</p>";}}s:11:"returnvalue";s:24:"<p>The session data.</p>";s:6:"source";s:1451:"public function read($id)
{
    $result = '';

    // Get the session data from DynamoDB (acquire a lock if locking is enabled)
    if ($this-&gt;_session_locking)
    {
        $response = $this-&gt;_lock_and_read($id);
        $node_name = 'Attributes';
    }
    else
    {
        $response = $this-&gt;_dynamodb-&gt;get_item(array(
            'TableName'      =&gt; $this-&gt;_table_name,
            'Key'            =&gt; array('HashKeyElement' =&gt; $this-&gt;_dynamodb-&gt;attribute($this-&gt;_id($id))),
            'ConsistentRead' =&gt; $this-&gt;_consistent_reads,
        ));
        $node_name = 'Item';
    }

    if ($response &amp;&amp; $response-&gt;isOK())
    {
        $item = array();

        // Get the data from the DynamoDB response
        if ($response-&gt;body-&gt;{$node_name})
        {
            foreach ($response-&gt;body-&gt;{$node_name}-&gt;children() as $key =&gt; $value)
            {
                $type = $value-&gt;children()-&gt;getName();
                $item[$key] = $value-&gt;{$type}-&gt;to_string();
            }
        }

        if (isset($item['expires']) &amp;&amp; isset($item['data']))
        {
            // Check the expiration date before using
            if ($item['expires'] &gt; time())
            {
                $result = $item['data'];
            }
            else
            {
                $this-&gt;destroy($id);
            }
        }
    }

    return $result;
}";}i:15;a:5:{s:4:"name";s:8:"register";s:8:"modifier";s:6:"public";s:11:"description";s:128:"<p>Register DynamoDB as a session handler.</p>

<p>Uses the PHP-provided method to register this class as a session handler.</p>";s:11:"returnvalue";s:17:"<p>Chainable.</p>";s:6:"source";s:281:"public function register()
{
    session_set_save_handler(
        array($this, 'open'),
        array($this, 'close'),
        array($this, 'read'),
        array($this, 'write'),
        array($this, 'destroy'),
        array($this, 'garbage_collect')
    );

    return $this;
}";}i:16;a:6:{s:4:"name";s:5:"write";s:8:"modifier";s:6:"public";s:11:"description";s:95:"<p>Write a session to DynamoDB.</p>

<p>Part of the standard PHP session handler interface.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:2:"id";s:4:"type";s:6:"string";s:11:"description";s:22:"<p>The session ID.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"data";s:4:"type";s:6:"string";s:11:"description";s:24:"<p>The session data.</p>";}}}s:11:"returnvalue";s:46:"<p>Whether or not the operation succeeded.</p>";s:6:"source";s:541:"public function write($id, $data)
{
    // Write the session data to DynamoDB
    $response = $this-&gt;_dynamodb-&gt;put_item(array(
        'TableName' =&gt; $this-&gt;_table_name,
        'Item'      =&gt; $this-&gt;_dynamodb-&gt;attributes(array(
            $this-&gt;_hash_key =&gt; $this-&gt;_id($id),
            'expires'        =&gt; time() + $this-&gt;_session_lifetime,
            'data'           =&gt; $data,
        )),
    ));

    $this-&gt;_session_written = $response-&gt;isOK();

    return $this-&gt;_session_written;
}";}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"14";}s:8:"property";a:14:{i:0;a:4:{s:4:"name";s:17:"_consistent_reads";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:8:"metadata";a:1:{s:3:"var";s:84:"boolean Whether or not the session handler should do consistent reads from DynamoDB.";}}i:1;a:3:{s:4:"name";s:9:"_dynamodb";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:36:"AmazonDynamoDB The DyanamoDB client.";}}i:2;a:4:{s:4:"name";s:9:"_hash_key";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:2:"id";}}s:8:"metadata";a:1:{s:3:"var";s:63:"string The name of the hash key in the DynamoDB sessions table.";}}i:3;a:4:{s:4:"name";s:21:"_max_lock_retry_utime";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:6:"100000";}}s:8:"metadata";a:1:{s:3:"var";s:102:"integer Maximum time, in microseconds, that the session handler should wait to retry acquiring a lock.";}}i:4;a:4:{s:4:"name";s:19:"_max_lock_wait_time";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:2:"30";}}s:8:"metadata";a:1:{s:3:"var";s:89:"integer Maximum time, in seconds, that the session handler should take to acquire a lock.";}}i:5;a:4:{s:4:"name";s:21:"_min_lock_retry_utime";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:5:"10000";}}s:8:"metadata";a:1:{s:3:"var";s:102:"integer Minimum time, in microseconds, that the session handler should wait to retry acquiring a lock.";}}i:6;a:3:{s:4:"name";s:13:"_open_session";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:46:"boolean Keeps track of if the session is open.";}}i:7;a:4:{s:4:"name";s:13:"_option_types";s:8:"modifier";s:16:"protected static";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:5:"array";s:5:"value";s:264:"array( "table_name" => "string", "hash_key" => "string", "session_lifetime" => "integer", "consistent_reads" => "boolean", "session_locking" => "boolean", "max_lock_wait_time" => "integer", "min_lock_retry_utime" => "integer", "max_lock_retry_utime" => "integer" )";}}s:8:"metadata";a:1:{s:3:"var";s:49:"array Type for casting the configuration options.";}}i:8;a:3:{s:4:"name";s:10:"_save_path";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:115:"string The session save path (see <a href="http://php.net/session_save_path"><code>session_save_path()</code></a>).";}}i:9;a:3:{s:4:"name";s:17:"_session_lifetime";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:82:"integer The lifetime of an inactive session before it should be garbage collected.";}}i:10;a:4:{s:4:"name";s:16:"_session_locking";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:8:"metadata";a:1:{s:3:"var";s:69:"boolean Whether or not the session handler should do session locking.";}}i:11;a:3:{s:4:"name";s:13:"_session_name";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:100:"string The session name (see <a href="http://php.net/session_name"><code>session_name()</code></a>).";}}i:12;a:3:{s:4:"name";s:16:"_session_written";s:8:"modifier";s:9:"protected";s:8:"metadata";a:1:{s:3:"var";s:51:"boolean Keeps track of whether the session is open.";}}i:13;a:4:{s:4:"name";s:11:"_table_name";s:8:"modifier";s:9:"protected";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:8:"sessions";}}s:8:"metadata";a:1:{s:3:"var";s:65:"string The name of the DynamoDB table in which to store sessions.";}}}}}}