a:2:{s:4:"file";a:0:{}s:5:"class";a:7:{s:4:"name";s:15:"S3StreamWrapper";s:4:"file";s:36:"extensions/s3streamwrapper.class.php";s:3:"url";s:29:"../s3streamwrapper/index.html";s:11:"description";s:194:"<p>Provides an interface for accessing Amazon S3 using PHP&#8217;s native file management functions.</p>

<p>Amazon S3 file patterns take the following form: <code>s3://bucket/object</code>.</p>";s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"22";}s:6:"method";a:22:{i:0;a:6:{s:4:"name";s:6:"client";s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>Fetches the client for the protocol being used.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"protocol";s:4:"type";s:6:"string";s:11:"description";s:56:"<p>The protocol associated with this stream wrapper.</p>";}}s:11:"returnvalue";s:57:"<p>The S3 client associated with this stream wrapper.</p>";s:6:"source";s:374:"public function client($protocol = null)
{
    if ($protocol == null)
    {
        if ($parsed = parse_url($this-&gt;path))
        {
            $protocol = $parsed['scheme'];
        }
        else
        {
            trigger_error(__CLASS__ . ' could not determine the protocol of the stream wrapper in use.');
        }
    }

    return self::$_clients[$protocol];
}";}i:1;a:5:{s:4:"name";s:12:"dir_closedir";s:8:"modifier";s:6:"public";s:11:"description";s:224:"<p>Close directory handle. This method is called in response to <a href="http://php.net/closedir"><code>closedir()</code></a>.</p>

<p>Since Amazon S3 doesn&#8217;t have real directories, always return <code>true</code>.</p>";s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:7:"boolean";}}s:6:"source";s:291:"public function dir_closedir()
{
    $this-&gt;position = 0;
    $this-&gt;path = null;
    $this-&gt;file_list = null;
    $this-&gt;open_file = null;
    $this-&gt;seek_position = 0;
    $this-&gt;eof = false;
    $this-&gt;buffer = null;
    $this-&gt;object_size = 0;

    return true;
}";}i:2;a:6:{s:4:"name";s:11:"dir_opendir";s:8:"modifier";s:6:"public";s:11:"description";s:127:"<p>Open directory handle. This method is called in response to <a href="http://php.net/opendir"><code>opendir()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:104:"<p>Specifies the URL that was passed to <a href="http://php.net/opendir"><code>opendir()</code></a>.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:7:"integer";s:11:"description";s:90:"<p>Not used. Passed in by <a href="http://php.net/opendir"><code>opendir()</code></a>.</p>";}}}s:11:"returnvalue";s:77:"<p>Returns <code>true</code> on success or <code>false</code> on failure.</p>";s:6:"source";s:408:"public function dir_opendir($path, $options)
{
    $this-&gt;path = $path;
    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($path);

    $pattern = '/^' . self::regex_token($object_name) . '(.*)[^\/$]/';

    $this-&gt;file_list = $this-&gt;client($protocol)-&gt;get_object_list($bucket, array(
        'pcre' =&gt; $pattern
    ));

    return (count($this-&gt;file_list)) ? true : false;
}";}i:3;a:5:{s:4:"name";s:11:"dir_readdir";s:8:"modifier";s:6:"public";s:11:"description";s:104:"<p>This method is called in response to <a href="http://php.net/readdir"><code>readdir()</code></a>.</p>";s:11:"returnvalue";s:109:"<p>Should return a string representing the next filename, or <code>false</code> if there is no next file.</p>";s:6:"source";s:248:"public function dir_readdir()
{
    if (isset($this-&gt;file_list[$this-&gt;position]))
    {
        $out = $this-&gt;file_list[$this-&gt;position];
        $this-&gt;position++;
    }
    else
    {
        $out = false;
    }

    return $out;
}";}i:4;a:5:{s:4:"name";s:13:"dir_rewinddir";s:8:"modifier";s:6:"public";s:11:"description";s:527:"<p>This method is called in response to <a href="http://php.net/rewinddir"><code>rewinddir()</code></a>.</p>

<p>Should reset the output generated by <a href="http://php.net/streamwrapper.dir_readdir"><code>streamWrapper::dir_readdir()</code></a>. i.e.: The next call to
<a href="http://php.net/streamwrapper.dir_readdir"><code>streamWrapper::dir_readdir()</code></a> should return the first entry in the location returned by
<a href="http://php.net/streamwrapper.dir_opendir"><code>streamWrapper::dir_opendir()</code></a>.</p>";s:11:"returnvalue";s:77:"<p>Returns <code>true</code> on success or <code>false</code> on failure.</p>";s:6:"source";s:81:"public function dir_rewinddir()
{
    $this-&gt;position = 0;

    return true;
}";}i:5;a:6:{s:4:"name";s:5:"mkdir";s:8:"modifier";s:6:"public";s:11:"description";s:121:"<p>Create a new bucket. This method is called in response to <a href="http://php.net/mkdir"><code>mkdir()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:33:"<p>The bucket name to create.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"mode";s:4:"type";s:7:"integer";s:11:"description";s:166:"<p>Permissions. 700-range permissions map to ACL_PUBLIC. 600-range permissions map to ACL_AUTH_READ. All other permissions map to ACL_PRIVATE. Expects octal form.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:7:"integer";s:11:"description";s:15:"<p>Ignored.</p>";}}}s:11:"returnvalue";s:58:"<p>Whether the bucket was created successfully or not.</p>";s:6:"source";s:802:"public function mkdir($path, $mode, $options)
{
    // Get the value that was *actually* passed in as mode, and default to 0
    $trace_slice = array_slice(debug_backtrace(), -1);
    $mode = isset($trace_slice[0]['args'][1]) ? decoct($trace_slice[0]['args'][1]) : 0;

    $this-&gt;path = $path;
    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($path);

    if (in_array($mode, range(700, 799)))
    {
        $acl = AmazonS3::ACL_PUBLIC;
    }
    elseif (in_array($mode, range(600, 699)))
    {
        $acl = AmazonS3::ACL_AUTH_READ;
    }
    else
    {
        $acl = AmazonS3::ACL_PRIVATE;
    }

    $client = $this-&gt;client($protocol);
    $region = $client-&gt;hostname;
    $response = $client-&gt;create_bucket($bucket, $region, $acl);

    return $response-&gt;isOK();
}";}i:6;a:6:{s:4:"name";s:10:"parse_path";s:8:"modifier";s:6:"public";s:11:"description";s:68:"<p>Parses an S3 URL into the parts needed by the stream wrapper.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:25:"<p>The path to parse.</p>";}}s:11:"returnvalue";s:92:"<p>An array of 3 items: protocol, bucket, and object name ready for <code>list()</code>.</p>";s:6:"source";s:310:"public function parse_path($path)
{
    $url = parse_url($path);

    return array(
        $url['scheme'],                                       // Protocol
        $url['host'],                                         // Bucket
        (isset($url['path']) ? substr($url['path'], 1) : ''), // Object
    );
}";}i:7;a:6:{s:4:"name";s:11:"regex_token";s:8:"modifier";s:13:"public static";s:11:"description";s:45:"<p>Makes the given token PCRE-compatible.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"token";s:4:"type";s:6:"string";s:11:"description";s:16:"<p>The token</p>";}}s:11:"returnvalue";s:47:"<p>The PCRE-compatible version of the token</p>";s:6:"source";s:169:"public static function regex_token($token)
{
    $token = str_replace('/', '\/', $token);
    $token = quotemeta($token);
    return str_replace('\\\\', '\\', $token);
}";}i:8;a:6:{s:4:"name";s:8:"register";s:8:"modifier";s:13:"public static";s:11:"description";s:63:"<p>Registers the S3StreamWrapper class as a stream wrapper.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:2:"s3";s:4:"type";s:8:"AmazonS3";s:11:"description";s:42:"<p>An instance of the AmazonS3 client.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"protocol";s:4:"type";s:6:"string";s:11:"description";s:44:"<p>The name of the protocol to register.</p>";}}}s:11:"returnvalue";s:49:"<p>Whether or not the registration succeeded.</p>";s:6:"source";s:213:"public static function register(AmazonS3 $s3 = null, $protocol = 's3')
{
    S3StreamWrapper::$_clients[$protocol] = $s3 ? $s3 : new AmazonS3();

    return stream_wrapper_register($protocol, 'S3StreamWrapper');
}";}i:9;a:6:{s:4:"name";s:6:"rename";s:8:"modifier";s:6:"public";s:11:"description";s:131:"<p>Renames a file or directory. This method is called in response to <a href="http://php.net/rename"><code>rename()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"path_from";s:4:"type";s:6:"string";s:11:"description";s:35:"<p>The URL to the current file.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"path_to";s:4:"type";s:6:"string";s:11:"description";s:70:"<p>The URL which the <code>$path_from</code> should be renamed to.</p>";}}}s:11:"returnvalue";s:77:"<p>Returns <code>true</code> on success or <code>false</code> on failure.</p>";s:6:"source";s:739:"public function rename($path_from, $path_to)
{
    list($protocol, $from_bucket_name, $from_object_name) = $this-&gt;parse_path($path_from);
    list($protocol, $to_bucket_name, $to_object_name) = $this-&gt;parse_path($path_to);

    $copy_response = $this-&gt;client($protocol)-&gt;copy_object(
        array('bucket' =&gt; $from_bucket_name, 'filename' =&gt; $from_object_name),
        array('bucket' =&gt; $to_bucket_name,   'filename' =&gt; $to_object_name  )
    );

    if ($copy_response-&gt;isOK())
    {
        $delete_response = $this-&gt;client($protocol)-&gt;delete_object($from_bucket_name, $from_object_name);

        if ($delete_response-&gt;isOK())
        {
            return true;
        }
    }

    return false;
}";}i:10;a:6:{s:4:"name";s:5:"rmdir";s:8:"modifier";s:6:"public";s:11:"description";s:100:"<p>This method is called in response to <a href="http://php.net/rmdir"><code>rmdir()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:33:"<p>The bucket name to create.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"context";s:4:"type";s:7:"boolean";s:11:"description";s:15:"<p>Ignored.</p>";}}}s:11:"returnvalue";s:58:"<p>Whether the bucket was deleted successfully or not.</p>";s:6:"source";s:251:"public function rmdir($path, $context)
{
    $this-&gt;path = $path;
    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($path);

    $response = $this-&gt;client($protocol)-&gt;delete_bucket($bucket);

    return $response-&gt;isOK();
}";}i:11;a:5:{s:4:"name";s:12:"stream_close";s:8:"modifier";s:6:"public";s:11:"description";s:209:"<p>Close a resource. This method is called in response to <a href="http://php.net/fclose"><code>fclose()</code></a>.</p>

<p>All resources that were locked, or allocated, by the wrapper should be released.</p>";s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:273:"public function stream_close()
{
    $this-&gt;position = 0;
    $this-&gt;path = null;
    $this-&gt;file_list = null;
    $this-&gt;open_file = null;
    $this-&gt;seek_position = 0;
    $this-&gt;eof = false;
    $this-&gt;buffer = null;
    $this-&gt;object_size = 0;
}";}i:12;a:5:{s:4:"name";s:10:"stream_eof";s:8:"modifier";s:6:"public";s:11:"description";s:139:"<p>Tests for end-of-file on a file pointer. This method is called in response to <a href="http://php.net/feof"><code>feof()</code></a>.</p>";s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:7:"boolean";}}s:6:"source";s:58:"public function stream_eof()
{
    return $this-&gt;eof;
}";}i:13;a:5:{s:4:"name";s:12:"stream_flush";s:8:"modifier";s:6:"public";s:11:"description";s:331:"<p>Flushes the output. This method is called in response to <a href="http://php.net/fflush"><code>fflush()</code></a>. If you have cached data in
your stream but not yet stored it into the underlying storage, you should do so now.</p>

<p>Since this implementation doesn&#8217;t buffer streams, simply return <code>true</code>.</p>";s:11:"returnvalue";s:40:"<p>Whether or not flushing succeeded</p>";s:6:"source";s:450:"public function stream_flush()
{
    if ($this-&gt;buffer === null)
    {
        return false;
    }

    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($this-&gt;path);

    $response = $this-&gt;client($protocol)-&gt;create_object($bucket, $object_name, array(
        'body' =&gt; $this-&gt;buffer,
    ));

    $this-&gt;seek_position = 0;
    $this-&gt;buffer = null;
    $this-&gt;eof = true;

    return $response-&gt;isOK();
}";}i:14;a:6:{s:4:"name";s:11:"stream_open";s:8:"modifier";s:6:"public";s:11:"description";s:244:"<p>Opens file or URL. This method is called immediately after the wrapper is initialized
(e.g., by <a href="http://php.net/fopen"><code>fopen()</code></a> and <a href="http://php.net/file_get_contents"><code>file_get_contents()</code></a>).</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:66:"<p>Specifies the URL that was passed to the original function.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"mode";s:4:"type";s:6:"string";s:11:"description";s:15:"<p>Ignored.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:7:"integer";s:11:"description";s:15:"<p>Ignored.</p>";}i:3;a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"opened_path";}}}s:11:"returnvalue";s:77:"<p>Returns <code>true</code> on success or <code>false</code> on failure.</p>";s:6:"source";s:243:"public function stream_open($path, $mode, $options, &amp;$opened_path)
{
    $opened_path = $path;
    $this-&gt;open_file = $path;
    $this-&gt;path = $path;
    $this-&gt;seek_position = 0;
    $this-&gt;object_size = 0;

    return true;
}";}i:15;a:6:{s:4:"name";s:11:"stream_read";s:8:"modifier";s:6:"public";s:11:"description";s:353:"<p>Read from stream. This method is called in response to <a href="http://php.net/fread"><code>fread()</code></a> and <a href="http://php.net/fgets"><code>fgets()</code></a>.</p>

<p>It is important to avoid reading files that are near to or larger than the amount of memory
allocated to PHP, otherwise &#8220;out of memory&#8221; errors will occur.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"count";s:4:"type";s:7:"integer";s:11:"description";s:56:"<p>Always equal to 8192. PHP is fun, isn&#8217;t it?</p>";}}s:11:"returnvalue";s:44:"<p>The contents of the Amazon S3 object.</p>";s:6:"source";s:1293:"public function stream_read($count)
{
    if ($this-&gt;eof)
    {
        return false;
    }

    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($this-&gt;path);

    if ($this-&gt;seek_position &gt; 0 &amp;&amp; $this-&gt;object_size)
    {
        if ($count + $this-&gt;seek_position &gt; $this-&gt;object_size)
        {
            $count = $this-&gt;object_size - $this-&gt;seek_position;
        }

        $start = $this-&gt;seek_position;
        $end = $this-&gt;seek_position + $count;

        $response = $this-&gt;client($protocol)-&gt;get_object($bucket, $object_name, array(
            'range' =&gt; $start . '-' . $end
        ));
    }
    else
    {
        $response = $this-&gt;client($protocol)-&gt;get_object($bucket, $object_name);
        $this-&gt;object_size = isset($response-&gt;header['content-length']) ? $response-&gt;header['content-length'] : 0;
    }

    if (!$response-&gt;isOK())
    {
        return false;
    }

    $data = substr($response-&gt;body, 0, min($count, $this-&gt;object_size));
    $this-&gt;seek_position += strlen($data);


    if ($this-&gt;seek_position &gt;= $this-&gt;object_size)
    {
        $this-&gt;eof = true;
        $this-&gt;seek_position = 0;
        $this-&gt;object_size = 0;
    }

    return $data;
}";}i:16;a:6:{s:4:"name";s:11:"stream_seek";s:8:"modifier";s:6:"public";s:11:"description";s:271:"<p>Seeks to specific location in a stream. This method is called in response to <a href="http://php.net/fseek"><code>fseek()</code></a>. The read/write
position of the stream should be updated according to the <code>$offset</code> and <code>$whence</code>
parameters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"offset";s:4:"type";s:7:"integer";s:11:"description";s:64:"<p>The number of bytes to offset from the start of the file.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"whence";s:4:"type";s:7:"integer";s:11:"description";s:50:"<p>Ignored. Always uses <code>SEEK_SET</code>.</p>";}}}s:11:"returnvalue";s:46:"<p>Whether or not the seek was successful.</p>";s:6:"source";s:106:"public function stream_seek($offset, $whence)
{
    $this-&gt;seek_position = $offset;

    return true;
}";}i:17;a:5:{s:4:"name";s:11:"stream_stat";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Retrieve information about a file resource.</p>";s:11:"returnvalue";s:96:"<p>Returns the same data as a call to <a href="http://php.net/stat"><code>stat()</code></a>.</p>";s:6:"source";s:86:"public function stream_stat()
{
    return $this-&gt;url_stat($this-&gt;path, null);
}";}i:18;a:5:{s:4:"name";s:11:"stream_tell";s:8:"modifier";s:6:"public";s:11:"description";s:143:"<p>Retrieve the current position of a stream. This method is called in response to <a href="http://php.net/ftell"><code>ftell()</code></a>.</p>";s:11:"returnvalue";s:50:"<p>Returns the current position of the stream.</p>";s:6:"source";s:69:"public function stream_tell()
{
    return $this-&gt;seek_position;
}";}i:19;a:6:{s:4:"name";s:12:"stream_write";s:8:"modifier";s:6:"public";s:11:"description";s:283:"<p>Write to stream. This method is called in response to <a href="http://php.net/fwrite"><code>fwrite()</code></a>.</p>

<p>It is important to avoid reading files that are larger than the amount of memory allocated to PHP,
otherwise &#8220;out of memory&#8221; errors will occur.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"data";s:4:"type";s:6:"string";s:11:"description";s:39:"<p>The data to write to the stream.</p>";}}s:11:"returnvalue";s:59:"<p>The number of bytes that were written to the stream.</p>";s:6:"source";s:172:"public function stream_write($data)
{
    $size = strlen($data);

    $this-&gt;seek_position = $size;
    $this-&gt;buffer .= $data;

    return $this-&gt;seek_position;
}";}i:20;a:6:{s:4:"name";s:6:"unlink";s:8:"modifier";s:6:"public";s:11:"description";s:117:"<p>Delete a file. This method is called in response to <a href="http://php.net/unlink"><code>unlink()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:44:"<p>The file URL which should be deleted.</p>";}}s:11:"returnvalue";s:77:"<p>Returns <code>true</code> on success or <code>false</code> on failure.</p>";s:6:"source";s:256:"public function unlink($path)
{
    $this-&gt;path = $path;
    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($path);

    $response = $this-&gt;client($protocol)-&gt;delete_object($bucket, $object_name);

    return $response-&gt;isOK();
}";}i:21;a:6:{s:4:"name";s:8:"url_stat";s:8:"modifier";s:6:"public";s:11:"description";s:120:"<p>This method is called in response to all <a href="http://php.net/stat"><code>stat()</code></a> related functions.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"path";s:4:"type";s:6:"string";s:11:"description";s:148:"<p>The file path or URL to stat. Note that in the case of a URL, it must be a <code>://</code> delimited URL. Other URL forms are not supported.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"flags";s:4:"type";s:7:"integer";s:11:"description";s:100:"<p>Holds additional flags set by the streams API. This implementation ignores all defined flags.</p>";}}}s:11:"returnvalue";s:190:"<p>Should return as many elements as <a href="http://php.net/stat"><code>stat()</code></a> does. Unknown or unavailable values should be set to a rational value (usually <code>0</code>).</p>";s:6:"source";s:3011:"public function url_stat($path, $flags)
{
    // Defaults
    $out = array();
    $out[0] = $out['dev'] = 0;
    $out[1] = $out['ino'] = 0;
    $out[2] = $out['mode'] = 0;
    $out[3] = $out['nlink'] = 0;
    $out[4] = $out['uid'] = 0;
    $out[5] = $out['gid'] = 0;
    $out[6] = $out['rdev'] = 0;
    $out[7] = $out['size'] = 0;
    $out[8] = $out['atime'] = 0;
    $out[9] = $out['mtime'] = 0;
    $out[10] = $out['ctime'] = 0;
    $out[11] = $out['blksize'] = 0;
    $out[12] = $out['blocks'] = 0;

    $this-&gt;path = $path;
    list($protocol, $bucket, $object_name) = $this-&gt;parse_path($this-&gt;path);

    $file = null;
    $mode = 0;

    if ($object_name)
    {
        $response = $this-&gt;client($protocol)-&gt;list_objects($bucket, array(
            'prefix' =&gt; $object_name
        ));

        if (!$response-&gt;isOK())
        {
            return $out;
        }

        // Ummm... yeah...
        if (is_object($response-&gt;body))
        {
            $file = $response-&gt;body-&gt;Contents[0];
        }
        else
        {
            $body = simplexml_load_string($response-&gt;body);
            $file = $body-&gt;Contents[0];
        }
    }
    else
    {
        $response = $this-&gt;client($protocol)-&gt;list_objects($bucket);

        if (!$response-&gt;isOK())
        {
            return $out;
        }
    }

    /*
    Type &amp; Permission bitwise values (only those that pertain to S3).
    Simulate the concept of a &quot;directory&quot;. Nothing has an executable bit because there's no executing on S3.
    Reference: http://docstore.mik.ua/orelly/webprog/pcook/ch19_13.htm

    0100000 =&gt; type:   regular file
    0040000 =&gt; type:   directory
    0000400 =&gt; owner:  read permission
    0000200 =&gt; owner:  write permission
    0000040 =&gt; group:  read permission
    0000020 =&gt; group:  write permission
    0000004 =&gt; others: read permission
    0000002 =&gt; others: write permission
    */

    // File or directory?
    // @todo: Add more detailed support for permissions. Currently only takes OWNER into account.
    if (!$object_name) // Root of the bucket
    {
        $mode = octdec('0040777');
    }
    elseif ($file)
    {
        $mode = (str_replace('//', '/', $object_name . '/') === (string) $file-&gt;Key) ? octdec('0040777') : octdec('0100777'); // Directory, Owner R/W : Regular File, Owner R/W
    }
    else
    {
        $mode = octdec('0100777');
    }

    // Update stat output
    $out[2] = $out['mode'] = $mode;
    $out[4] = $out['uid'] = (isset($file) ? (string) $file-&gt;Owner-&gt;ID : 0);
    $out[7] = $out['size'] = (isset($file) ? (string) $file-&gt;Size : 0);
    $out[8] = $out['atime'] = (isset($file) ? date('U', strtotime((string) $file-&gt;LastModified)) : 0);
    $out[9] = $out['mtime'] = (isset($file) ? date('U', strtotime((string) $file-&gt;LastModified)) : 0);
    $out[10] = $out['ctime'] = (isset($file) ? date('U', strtotime((string) $file-&gt;LastModified)) : 0);

    return $out;
}";}}}s:9:"constants";a:1:{s:11:"@attributes";a:1:{s:5:"count";s:1:"0";}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:1:"9";}s:8:"property";a:9:{i:0;a:3:{s:4:"name";s:8:"_clients";s:8:"modifier";s:16:"protected static";s:8:"metadata";a:1:{s:3:"var";s:65:"array An array of AmazonS3 clients registered as stream wrappers.";}}i:1;a:2:{s:4:"name";s:6:"buffer";s:8:"modifier";s:6:"public";}i:2;a:2:{s:4:"name";s:3:"eof";s:8:"modifier";s:6:"public";}i:3;a:2:{s:4:"name";s:9:"file_list";s:8:"modifier";s:6:"public";}i:4;a:2:{s:4:"name";s:11:"object_size";s:8:"modifier";s:6:"public";}i:5;a:2:{s:4:"name";s:9:"open_file";s:8:"modifier";s:6:"public";}i:6;a:2:{s:4:"name";s:4:"path";s:8:"modifier";s:6:"public";}i:7;a:2:{s:4:"name";s:8:"position";s:8:"modifier";s:6:"public";}i:8;a:2:{s:4:"name";s:13:"seek_position";s:8:"modifier";s:6:"public";}}}}}