{"file":{},"class":{"name":"AmazonCloudFront","file":"services\/cloudfront.class.php","url":"..\/amazoncloudfront\/index.html","description":"<p>Amazon CloudFront is a web service for content delivery. It makes it easier for you to distribute content\nto end users quickly, with low latency and high data transfer speeds.<\/p>\n\n<p>CloudFront delivers your content through a worldwide network of edge locations. End users are routed to\nthe nearest edge location, so content is delivered with the best possible performance. CloudFront works\nseamlessly with the Amazon Simple Storage Service, which durably stores the original, definitive versions\nof your files.<\/p>","metadata":{"version":"2012.04.20","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":["http:\/\/aws.amazon.com\/cloudfront\/ Amazon CloudFront","http:\/\/aws.amazon.com\/documentation\/cloudfront\/ Amazon CloudFront documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"56"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazoncloudfront\/index.html\" rel=\"..\/..\/index.html#i=amazoncloudfront\"><code>AmazonCloudFront<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoncloudfront\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2012-03-15';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV2REST';\n\n    $this-&gt;base_xml = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;&lt;%s xmlns=&quot;http:\/\/cloudfront.amazonaws.com\/doc\/' . $this-&gt;api_version . '\/&quot;&gt;&lt;\/%1$s&gt;';\n\n    parent::__construct($options);\n\n    \/\/ Set a default key pair ID and private key\n    $this-&gt;key_pair_id = $this-&gt;credentials-&gt;cloudfront_keypair;\n    $this-&gt;private_key = $this-&gt;credentials-&gt;cloudfront_pem;\n}"},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazoncloudfront\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazoncloudfront\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazoncloudfront\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","description":"<p>Authenticates a connection to Amazon CloudFront. This method should not be used directly unless\nyou&#8217;re writing custom methods for this class.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>The HTTP method to use to connect. Accepts <code>GET<\/code>, <code>POST<\/code>, <code>PUT<\/code>, <code>DELETE<\/code>, and <code>HEAD<\/code>.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    \/\/ Extract data from payload\n    $querystring = null;\n    $opt = ($payload) ? $payload : array();\n    $method = $operation;\n    $path = isset($opt['path']) ? $opt['path'] : null;\n    $xml = isset($opt['xml']) ? $opt['xml'] : null;\n    $etag = isset($opt['etag']) ? $opt['etag'] : null;\n\n    $method_arguments = func_get_args();\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $method . sha1($path) . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/\/ Generate query string\n    if (isset($opt['query_string']) &amp;&amp; count($opt['query_string']))\n    {\n        $querystring = '?' . $this-&gt;util-&gt;to_query_string($opt['query_string']);\n    }\n\n    \/\/ Gather information to pass along to other classes.\n    $helpers = array(\n        'utilities' =&gt; $this-&gt;utilities_class,\n        'request' =&gt; $this-&gt;request_class,\n        'response' =&gt; $this-&gt;response_class,\n    );\n\n    \/\/ Compose the endpoint URL.\n    $request_url = 'https:\/\/' . $this-&gt;hostname . '\/' . $this-&gt;api_version;\n    $request_url .= ($path) ? $path : '';\n    $request_url .= ($querystring) ? $querystring : '';\n\n    \/\/ Compose the request.\n    $request = new $this-&gt;request_class($request_url, $this-&gt;proxy, $helpers, $this-&gt;credentials);\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/\/ Pass along registered stream callbacks\n    if ($this-&gt;registered_streaming_read_callback)\n    {\n        $request-&gt;register_streaming_read_callback($this-&gt;registered_streaming_read_callback);\n    }\n\n    if ($this-&gt;registered_streaming_write_callback)\n    {\n        $request-&gt;register_streaming_write_callback($this-&gt;registered_streaming_write_callback);\n    }\n\n    \/\/ Generate required headers.\n    $request-&gt;set_method($method);\n    $canonical_date = gmdate($this-&gt;util-&gt;konst($this-&gt;util, 'DATE_FORMAT_RFC2616'));\n    $request-&gt;add_header('x-amz-date', $canonical_date);\n    $signature = base64_encode(hash_hmac('sha1', $canonical_date, $this-&gt;secret_key, true));\n    $request-&gt;add_header('Authorization', 'AWS ' . $this-&gt;key . ':' . $signature);\n\n    \/\/ Add configuration XML if we have it.\n    if ($xml)\n    {\n        $request-&gt;add_header('Content-Length', strlen($xml));\n        $request-&gt;add_header('Content-Type', 'application\/xml');\n        $request-&gt;set_body($xml);\n    }\n\n    \/\/ Set If-Match: ETag header if we have one.\n    if ($etag)\n    {\n        $request-&gt;add_header('If-Match', $etag);\n    }\n\n    $curlopts = array();\n\n    \/\/ Set custom CURLOPT settings\n    if (isset($opt['curlopts']))\n    {\n        $curlopts = $opt['curlopts'];\n    }\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $curlopts[CURLOPT_VERBOSE] = true;\n    }\n\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif (isset($opt['returnCurlHandle']) &amp;&amp; $opt['returnCurlHandle'] == (bool) true)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    if ($xml) $headers['x-aws-body'] = $xml;\n\n    $data =  new $this-&gt;response_class($headers, $this-&gt;parse_callback($request-&gt;get_response_body()), $request-&gt;get_response_code());\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if ((integer) $request-&gt;get_response_code() === 500 || (integer) $request-&gt;get_response_code() === 503)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($method, $opt);\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}","seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/DeveloperGuide\/RESTAuthentication.html\">Authentication<\/a>"}},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazoncloudfront\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"create_distribution","modifier":"public","description":"<p>Creates an Amazon CloudFront distribution. You can have up to 100 distributions in the Amazon\nCloudFront system.<\/p>\n\n<p>For an Adobe Real-Time Messaging Protocol (RTMP) streaming distribution, set the <code>Streaming<\/code> option\nto true.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"origin","type":"string","description":"<p>The source to use for the Amazon CloudFront distribution. Use an Amazon S3 bucket name, or a fully-qualified non-S3 domain name prefixed with <code>http:\/\/<\/code> or <code>https:\/\/<\/code>.<\/p>"},{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>CNAME<\/code> - <code>string|array<\/code> - Optional - A DNS CNAME to use to map to the Amazon CloudFront distribution. If setting more than one, use an indexed array. Supports 1-10 CNAMEs.<\/li><li><code>Comment<\/code> - <code>string<\/code> - Optional - A comment to apply to the distribution. Cannot exceed 128 characters.<\/li><li><code>DefaultRootObject<\/code> - <code>string<\/code> - Optional - The file to load when someone accesses the root of the Amazon CloudFront domain (e.g., <code>index.html<\/code>).<\/li><li><code>Enabled<\/code> - <code>string<\/code> - Optional - A value of <code>true<\/code> will enable the distribution. A value of <code>false<\/code> will disable it. The default value is <code>true<\/code>.<\/li><li><code>OriginAccessIdentity<\/code> - <code>string<\/code> - Optional - The origin access identity (OAI) associated with this distribution. Use the Identity ID from the OAI, not the <code>CanonicalId<\/code>. Requires an S3 origin.<\/li><li><code>OriginProtocolPolicy<\/code> - <code>string<\/code> - Optional - The origin protocol policy to apply to your origin. If you specify <code>http-only<\/code>, CloudFront will use HTTP only to access the origin. If you specify <code>match-viewer<\/code>, CloudFront will fetch from your origin using HTTP or HTTPS, based on the protocol of the viewer request. [Allowed values: <code>http-only<\/code>, <code>match-viewer<\/code>]. The default value is <code>match-viewer<\/code>. Requires a non-S3 origin.<\/li><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> creates a streaming distribution. A value of <code>false<\/code> creates a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>Logging<\/code> - <code>array<\/code> - Optional - Controls whether access logs are written for the distribution. If you want to turn on access logs, include this element; if you want to turn off access logs, remove this element.<\/li><li><code>TrustedSigners<\/code> - <code>array<\/code> - Optional - An array of AWS account numbers for users who are trusted signers. Explicity add the value <code>Self<\/code> to the array to add your own account as a trusted signer.<\/li><li><code>RequiredProtocols<\/code> - <code>string<code> - Optional -  Use this element to restrict access to your distribution solely to HTTPS requests. Without this element, CloudFront can use any available protocol to serve the request.<\/li><li><code>CachingBehavior<\/code> - <code>array<\/code> - Optional - Determines the minimum TTL for objects in the CloudFront cache. This value specifies a lower bound for values in the headers for an object, for example, in the Cache-Control max-age directive.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_distribution($origin, $caller_reference, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $xml = $this-&gt;generate_config_xml($origin, $caller_reference, $opt);\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'xml' =&gt; $xml));\n\n    return $this-&gt;authenticate('POST', $opt);\n}","examples":{"example":[{"title":"<p>Create a new CloudFront distribution with logging and CNAMEs enabled.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;create_distribution(''my-bucket'', 'AWSPHPSDKCFDemo01', array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'CNAME' =&gt; array(\n\t\t'cname-php-10.example.com',\n\t\t'cname-php-20.example.com'\n\t),\n\t'Logging' =&gt; array(\n\t\t'Bucket' =&gt; 'my-bucket-logs',\n\t\t'Prefix' =&gt; 'log_'\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new streaming CloudFront distribution with logging and CNAMEs enabled.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;create_distribution('my-bucket', 'php1' . time(), array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'CNAME' =&gt; 'cname-php-3.example.com',\n\t'Logging' =&gt; array(\n\t\t'Bucket' =&gt; 'my-bucket-logs',\n\t\t'Prefix' =&gt; 'log_',\n\t),\n\t'RequiredProtocols' =&gt; 'https',\n\t'Streaming' =&gt; true,\n\t'OriginAccessIdentity' =&gt; 'E3HV63EQPFPPOA',\n\t'TrustedSigners' =&gt; array(\n\t\t'Self',\n\t\t'178280267275',\n\t),\n\t'CachingBehavior' =&gt; array(\n\t\t'MinTTL' =&gt; '30 minutes',\n\t),\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new CloudFront distribution from a non-S3 origin.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;create_distribution('http:\/\/'www.example.com'', 'php2' . time(), array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'OriginProtocolPolicy' =&gt; 'match-viewer',\n\t'CNAME' =&gt; array(\n\t\t'cname-php-4.example.com',\n\t\t'cname-php-5.example.com'\n\t),\n\t'Logging' =&gt; array(\n\t\t'Bucket' =&gt; 'my-bucket-logs',\n\t\t'Prefix' =&gt; 'nonS3_'\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/CreateDistribution.html\">POST Distribution<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/CreateStreamingDistribution.html\">POST Streaming Distribution<\/a>"]}},{"name":"create_invalidation","modifier":"public","description":"<p>Creates a new invalidation request.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"req"},"name":"paths","type":"string|array","description":"<p>One or more paths to set for invalidation. Pass a string for a single value, or an indexed array for multiple values. values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_invalidation($distribution_id, $caller_reference, $paths, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Paths'] = $paths;\n\n    $path = '\/distribution\/' . $distribution_id . '\/invalidation';\n    $xml = $this-&gt;generate_invalidation_xml($caller_reference, $opt);\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'xml' =&gt; $xml));\n\n    return $this-&gt;authenticate('POST', $opt);\n}","examples":{"example":{"title":"<p>Create a new CloudFront invalidation request.<\/p>","description":"<p>In this example, we don&#8217;t know the file path to invalidate, so we&#8217;ll invalidate everything in the distribution.<\/p>","code":"$s3 = new AmazonS3();\n$cdn = new AmazonCloudFront();\n\n\/\/ Get the information about the distribution.\n$distribution_info = $cdn-&gt;get_distribution_info('E2L6A3OZHQT5W4');\n\n\/\/ Fetch the fully-qualified domain name for the origin bucket.\n$origin_bucket_fqdn = (string) $distribution_info-&gt;body-&gt;DistributionConfig-&gt;S3Origin-&gt;DNSName;\n\n\/\/ Strip the hostname, and only leave the bucket name.\n$origin_bucket = substr($origin_bucket_fqdn, 0, -17); \/\/ Remove `.s3.amazonaws.com`\n\n\/\/ Get the list of files from the S3 bucket.\n$file_paths = $s3-&gt;get_object_list($origin_bucket);\n\n\/\/ Create a new invalidation.\n$response = $cdn-&gt;create_invalidation('E2L6A3OZHQT5W4', 'aws-php-sdk-test' . time(), $file_paths);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_invalidation\"><code>get_invalidation()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_invalidations.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_invalidations\"><code>list_invalidations()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/CreateInvalidation.html\">POST Invalidation<\/a>"}},{"name":"create_oai","modifier":"public","description":"<p>Creates a new Amazon CloudFront origin access identity (OAI). You can create up to 100 OAIs per AWS\naccount. For more information, see the Amazon CloudFront Developer Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Comment<\/code> - <code>string<\/code> - Optional - A comment about the OAI.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_oai($caller_reference, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/origin-access-identity\/cloudfront';\n    $xml = $this-&gt;generate_oai_xml($caller_reference, $opt);\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'xml' =&gt; $xml));\n\n    return $this-&gt;authenticate('POST', $opt);\n}","examples":{"example":{"title":"<p>Create a new Origin Access Identity.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;create_oai('my-identity-' . time(), array(\n\t'Comment' =&gt; 'This is a test distribution.'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/CreateOAI.html\">POST Origin Access Identity<\/a>"}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_distribution","modifier":"public","description":"<p>Deletes a disabled distribution. If distribution hasn&#8217;t been disabled, Amazon CloudFront returns a\n<code>DistributionNotDisabled<\/code> error. Use <a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a> to disable a distribution before\nattempting to delete.<\/p>\n\n<p>For an Adobe Real-Time Messaging Protocol (RTMP) streaming distribution, set the <code>Streaming<\/code> option\nto be <code>true<\/code>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"etag","type":"string","description":"<p>The <code>ETag<\/code> header value retrieved from <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_distribution($distribution_id, $etag, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n    $path .= '\/' . $distribution_id;\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'etag' =&gt; $etag));\n\n    return $this-&gt;authenticate('DELETE', $opt);\n}","examples":{"example":{"title":"<p>Delete a distribution.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n\/\/ Fetch an updated ETag value\n$etag = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4')-&gt;header['etag'];\n\n\/\/ Set the updated config XML to the distribution.\n$response = $cdn-&gt;delete_distribution('E2L6A3OZHQT5W4', $etag);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/DeleteDistribution.html\">DELETE Distribution<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/DeleteStreamingDistribution.html\">DELETE Streaming Distribution<\/a>"]}},{"name":"delete_oai","modifier":"public","description":"<p>Deletes an Amazon CloudFront origin access identity (OAI). To delete an OAI, the identity must first\nbe disassociated from all distributions (by updating each distribution&#8217;s configuration to omit the\n<code>OriginAccessIdentity<\/code> element). Wait until each distribution&#8217;s state is <code>Deployed<\/code>\nbefore deleting the OAI.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"identity_id","type":"string","description":"<p>An Identity ID for an existing OAI.<\/p>"},{"@attributes":{"choice":"req"},"name":"etag","type":"string","description":"<p>The <code>ETag<\/code> header value retrieved from a call to <a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_oai($identity_id, $etag, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/origin-access-identity\/cloudfront\/' . $identity_id;\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'etag' =&gt; $etag));\n\n    return $this-&gt;authenticate('DELETE', $opt);\n}","examples":{"example":{"title":"<p>Delete an OAI.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$oai = $cdn-&gt;get_oai('E3HV63EQPFPPOA');\n\n\/\/ Was the request successful?\nif ($oai-&gt;isOK())\n{\n\t$etag = $oai-&gt;header['etag'];\n\t$response = $cdn-&gt;delete_oai('E3HV63EQPFPPOA', $etag);\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/DeleteOAI.html\">DELETE Origin Access Identity<\/a>"}},{"name":"disable_ssl","modifier":"public","description":"<p>Overrides the <a href=\"..\/cfruntime\/disable_ssl.html\" rel=\"..\/..\/index.html#m=cfruntime\/disable_ssl\"><code>CFRuntime::disable_ssl()<\/code><\/a> method from the base class. SSL is required for CloudFront.<\/p>","returnvalue":{"@attributes":{"type":"void"}},"source":"public function disable_ssl()\n{\n    throw new CloudFront_Exception('SSL\/HTTPS is REQUIRED for Amazon CloudFront and cannot be disabled.');\n}","related":{"method":["<a href=\"..\/amazoncloudfront\/set_keypair_id.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_keypair_id\"><code>set_keypair_id()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_private_key.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_private_key\"><code>set_private_key()<\/code><\/a>"]}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoncloudfront\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"generate_config_xml","modifier":"public","description":"<p>Generates the distribution configuration XML used with <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> and\n<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"origin","type":"string","description":"<p>The source to use for the Amazon CloudFront distribution. Use an Amazon S3 bucket name, or a fully-qualified non-S3 domain name prefixed with <code>http:\/\/<\/code> or <code>https:\/\/<\/code>.<\/p>"},{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>CNAME<\/code> - <code>string|array<\/code> - Optional - A DNS CNAME to use to map to the Amazon CloudFront distribution. If setting more than one, use an indexed array. Supports 1-10 CNAMEs.<\/li><li><code>Comment<\/code> - <code>string<\/code> - Optional - A comment to apply to the distribution. Cannot exceed 128 characters.<\/li><li><code>DefaultRootObject<\/code> - <code>string<\/code> - Optional - The file to load when someone accesses the root of your Amazon CloudFront domain (e.g., <code>index.html<\/code>).<\/li><li><code>Enabled<\/code> - <code>string<\/code> - Optional - A value of <code>true<\/code> enables the distribution. A value of <code>false<\/code> disables it. The default value is <code>true<\/code>.<\/li><li><code>Logging<\/code> - <code>array<\/code> - Optional - An array that contains two keys: <code>Bucket<\/code>, specifying where logs are written to, and <code>Prefix<\/code>, specifying a prefix to append to log file names.<\/li><li><code>OriginAccessIdentity<\/code> - <code>string<\/code> - Optional - The origin access identity (OAI) associated with this distribution. Use the Identity ID from the OAI, not the <code>CanonicalId<\/code>. Requires an S3 origin.<\/li><li><code>OriginProtocolPolicy<\/code> - <code>string<\/code> - Optional - The origin protocol policy to apply to your origin. If you specify <code>http-only<\/code>, CloudFront will use HTTP only to access the origin. If you specify <code>match-viewer<\/code>, CloudFront will fetch from your origin using HTTP or HTTPS, based on the protocol of the viewer request. It has a default value of <code>match-viewer<\/code>. [Allowed values: <code>http-only<\/code>, <code>match-viewer<\/code>]<\/li><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>TrustedSigners<\/code> - <code>array<\/code> - Optional - An array of AWS account numbers for users who are trusted signers. Explicity add the value <code>Self<\/code> to the array to add your own account as a trusted signer.<\/li><\/ul>"}]},"returnvalue":"<p>An XML document to be used as the distribution configuration.<\/p>","source":"public function generate_config_xml($origin, $caller_reference, $opt = null)\n{\n    \/\/ Default, empty XML\n    $xml = simplexml_load_string(sprintf($this-&gt;base_xml, (\n        (isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'StreamingDistributionConfig' : 'DistributionConfig')\n    ));\n\n    if (substr($origin, 0, 7) === 'http:\/\/' || substr($origin, 0, 8) === 'https:\/\/')\n    {\n        \/\/ Custom Origin\n        $custom_origin = $xml-&gt;addChild('CustomOrigin');\n        $custom_origin-&gt;addChild('DNSName', str_replace(array('http:\/\/', 'https:\/\/'), '', $origin));\n\n        if (isset($opt['OriginProtocolPolicy']))\n        {\n            $custom_origin-&gt;addChild('OriginProtocolPolicy', $opt['OriginProtocolPolicy']);\n        }\n        else\n        {\n            $custom_origin-&gt;addChild('OriginProtocolPolicy', 'match-viewer');\n        }\n    }\n    else\n    {\n        \/\/ S3 Origin\n        $s3_origin = $xml-&gt;addChild('S3Origin');\n        $s3_origin-&gt;addChild('DNSName', $origin . ((stripos($origin, '.s3.amazonaws.com') === false) ? '.s3.amazonaws.com' : ''));\n\n        \/\/ Origin Access Identity\n        if (isset($opt['OriginAccessIdentity']))\n        {\n            $s3_origin-&gt;addChild('OriginAccessIdentity', 'origin-access-identity\/cloudfront\/' . $opt['OriginAccessIdentity']);\n        }\n    }\n\n    \/\/ CallerReference\n    $xml-&gt;addChild('CallerReference', $caller_reference);\n\n    \/\/ CNAME\n    if (isset($opt['CNAME']))\n    {\n        if (is_array($opt['CNAME']))\n        {\n            foreach ($opt['CNAME'] as $cname)\n            {\n                $xml-&gt;addChild('CNAME', $cname);\n            }\n        }\n        else\n        {\n            $xml-&gt;addChild('CNAME', $opt['CNAME']);\n        }\n    }\n\n    \/\/ Comment\n    if (isset($opt['Comment']))\n    {\n        $xml-&gt;addChild('Comment', $opt['Comment']);\n    }\n\n    \/\/ Enabled\n    if (isset($opt['Enabled']))\n    {\n        $xml-&gt;addChild('Enabled', $opt['Enabled'] ? 'true' : 'false');\n    }\n    else\n    {\n        $xml-&gt;addChild('Enabled', 'true');\n    }\n\n    \/\/ Logging\n    if (isset($opt['Logging']))\n    {\n        if (is_array($opt['Logging']))\n        {\n            $logging = $xml-&gt;addChild('Logging');\n            $bucket_name = $opt['Logging']['Bucket'];\n\n            \/\/ Origin\n            $logging-&gt;addChild('Bucket', $bucket_name . (\n                (stripos($bucket_name, '.s3.amazonaws.com') === false) ? '.s3.amazonaws.com' : ''\n            ));\n\n            $logging-&gt;addChild('Prefix', $opt['Logging']['Prefix']);\n        }\n    }\n\n    \/\/ Required Protocols\n    if (isset($opt['RequiredProtocols']))\n    {\n        $required_protocols = $xml-&gt;addChild('RequiredProtocols');\n        $required_protocols-&gt;addChild('Protocol', $opt['RequiredProtocols']);\n    }\n\n    \/\/ Caching Behavior\n    if (isset($opt['CachingBehavior']) &amp;&amp; is_array($opt['CachingBehavior']))\n    {\n        $caching_behavior = $xml-&gt;addChild('CachingBehavior');\n\n        if (isset($opt['CachingBehavior']['MinTTL']))\n        {\n            $min_ttl = $opt['CachingBehavior']['MinTTL'];\n\n            if (is_string($min_ttl))\n            {\n                $min_ttl = strtotime($min_ttl);\n            }\n\n            $caching_behavior-&gt;addChild('MinTTL', $min_ttl);\n        }\n    }\n\n    \/\/ Trusted Signers\n    if (isset($opt['TrustedSigners']))\n    {\n        $trusted_signers = $xml-&gt;addChild('TrustedSigners');\n\n        \/\/ Not an array? Convert to one.\n        if (!is_array($opt['TrustedSigners']))\n        {\n            $opt['TrustedSigners'] = array($opt['TrustedSigners']);\n        }\n\n        \/\/ Handle 'Self' vs. everything else\n        foreach ($opt['TrustedSigners'] as $signer)\n        {\n            if (strtolower($signer) === 'self')\n            {\n                $trusted_signers-&gt;addChild('Self');\n            }\n            else\n            {\n                $trusted_signers-&gt;addChild('AwsAccountNumber', $signer);\n            }\n        }\n    }\n\n    \/\/ DefaultRootObject\n    if (isset($opt['DefaultRootObject']))\n    {\n        $xml-&gt;addChild('DefaultRootObject', $opt['DefaultRootObject']);\n    }\n\n    return $xml-&gt;asXML();\n}","examples":{"example":[{"title":"<p>Generate the configuration XML document.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;generate_config_xml('my-bucket', 'CFdemo3');\n\n\/\/ Success?\nvar_dump($response);"},{"title":"<p>Generate the configuration XML document, enabling logging and using a fully-qualified domain name for Amazon S3.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;generate_config_xml('my-bucket.s3.amazonaws.com', 'CFdemo3', array(\n\t'Logging' =&gt; array(\n\t\t'Bucket' =&gt; 'my-bucket-logs',\n\t\t'Prefix' =&gt; 'log_'\n\t)\n));\n\n\/\/ Success?\nvar_dump($response);"},{"title":"<p>Generate the configuration XML document, enabling streaming and multiple CNAMEs, and using a fully-qualified domain name for Amazon S3.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;generate_config_xml('my-bucket.s3.amazonaws.com', 'CFdemo3', array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'CNAME' =&gt; array(\n\t\t'cname.example.com',\n\t\t'cname2.example.com',\n\t\t'cname3.example.com'\n\t),\n\t'Streaming' =&gt; true,\n\t'DefaultRootObject' =&gt; 'text\/sample.txt',\n\t'CachingBehavior' =&gt; array(\n\t\t'MinTTL' =&gt; '30 minutes',\n\t),\n));\n\n\/\/ Success?\nvar_dump($response);"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"generate_invalidation_xml","modifier":"public","description":"<p>Generates the Invalidation Config XML used in <a href=\"..\/amazoncloudfront\/create_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_invalidation\"><code>create_invalidation()<\/code><\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Paths<\/code> - <code>string|array<\/code> - Optional - One or more paths to set for invalidation. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul>"}]},"returnvalue":"<p>An XML document to be used as the Invalidation configuration.<\/p>","source":"public function generate_invalidation_xml($caller_reference, $opt = null)\n{\n    \/\/ Default, empty XML\n    $xml = simplexml_load_string(sprintf($this-&gt;base_xml, 'InvalidationBatch'));\n\n    \/\/ CallerReference\n    $xml-&gt;addChild('CallerReference', $caller_reference);\n\n    \/\/ Paths\n    if (isset($opt['Paths']))\n    {\n        $paths = is_array($opt['Paths']) ? $opt['Paths'] : array($opt['Paths']);\n\n        foreach ($paths as $path)\n        {\n            $path = str_replace('%2F', '\/', rawurlencode($path));\n            $path = (substr($path, 0, 1) === '\/') ? $path : ('\/' . $path);\n            $xml-&gt;addChild('Path', $path);\n        }\n    }\n\n    return $xml-&gt;asXML();\n}","related":{"method":["<a href=\"..\/amazoncloudfront\/create_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_invalidation\"><code>create_invalidation()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_invalidation\"><code>get_invalidation()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_invalidations.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_invalidations\"><code>list_invalidations()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"generate_oai_xml","modifier":"public","description":"<p>Used to generate the origin access identity (OAI) Config XML used in <a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"caller_reference","type":"string","description":"<p>A unique identifier for the request. A timestamp-appended string is recommended.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Comment<\/code> - <code>string<\/code> - Optional - Replaces the existing value for &#8220;Comment&#8221;. Cannot exceed 128 characters.<\/li><\/ul>"}]},"returnvalue":"<p>An XML document to be used as the OAI configuration.<\/p>","source":"public function generate_oai_xml($caller_reference, $opt = null)\n{\n    \/\/ Default, empty XML\n    $xml = simplexml_load_string(sprintf($this-&gt;base_xml, 'CloudFrontOriginAccessIdentityConfig'));\n\n    \/\/ CallerReference\n    $xml-&gt;addChild('CallerReference', $caller_reference);\n\n    \/\/ Comment\n    if (isset($opt['Comment']))\n    {\n        $xml-&gt;addChild('Comment', $opt['Comment']);\n    }\n\n    return $xml-&gt;asXML();\n}","examples":{"example":{"title":"<p>Generate the OAI XML document.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n\/\/ Generate Origin Access Identity XML\n$response = $cdn-&gt;generate_oai_xml('demo-' . time());\n\n\/\/ Success?\nvar_dump($response);"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"get_distribution_config","modifier":"public","description":"<p>Gets the current distribution configuration for the specified distribution ID.<\/p>\n\n<p>Standard distributions are handled separately from streaming distributions. For streaming\ndistributions, set the <code>Streaming<\/code> option to true.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_distribution_config($distribution_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n    $path .= '\/' . $distribution_id . '\/config';\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":{"title":"<p>Get the current configuration XML for a given distribution.<\/p>","code":"\/\/ Get distribution info\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetConfig.html\">GET Distribution Config<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetStreamingDistConfig.html\">GET Streaming Distribution Config<\/a>"]}},{"name":"get_distribution_info","modifier":"public","description":"<p>Gets distribution information for the specified distribution ID.<\/p>\n\n<p>Standard distributions are handled separately from streaming distributions. For streaming\ndistributions, set the <code>Streaming<\/code> option to true.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_distribution_info($distribution_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n    $path .= '\/' . $distribution_id;\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":[{"title":"<p>Get the current information from a given distribution.<\/p>","code":"\/\/ Get distribution info\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_distribution_info('E2L6A3OZHQT5W4');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Get the current information from a given streaming distribution.<\/p>","code":"\/\/ Get distribution info\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_distribution_info('E2L6A3OZHQT5W4', array(\n\t'Streaming' =&gt; true\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetDistribution.html\">GET Distribution<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetStreamingDistribution.html\">GET Streaming Distribution<\/a>"]}},{"name":"get_distribution_list","modifier":"public","description":"<p>Gets a simplified list of standard distribution IDs.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the distribution caller references against.<\/p>"}},"returnvalue":"<p>A list of standard distribution IDs.<\/p>","source":"public function get_distribution_list($pcre = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new CloudFront_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $list = $this-&gt;list_distributions();\n    if ($list = $list-&gt;body-&gt;Id())\n    {\n        $list = $list-&gt;map_string($pcre);\n        return $list;\n    }\n\n    return array();\n}","examples":{"example":{"title":"<p>Get a list of all standard distributions.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_distribution_list();\n\n\/\/ Success?\nvar_dump($response);"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]}},{"name":"get_invalidation","modifier":"public","description":"<p>Gets information about an invalidation.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"invalidation_id","type":"string","description":"<p>The invalidation ID returned from <a href=\"..\/amazoncloudfront\/create_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_invalidation\"><code>create_invalidation()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_invalidations.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_invalidations\"><code>list_invalidations()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_invalidation($distribution_id, $invalidation_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/distribution\/' . $distribution_id . '\/invalidation\/' . $invalidation_id;\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":{"title":"<p>Get an invalidation request.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_invalidation('E2L6A3OZHQT5W4', 'I23JJ6UUOZGFOW');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_invalidation\"><code>create_invalidation()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_invalidations.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_invalidations\"><code>list_invalidations()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetInvalidation.html\">GET Invalidation<\/a>"}},{"name":"get_oai","modifier":"public","description":"<p>Gets information about an origin access identity (OAI).<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"identity_id","type":"string","description":"<p>The Identity ID for an existing OAI.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_oai($identity_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/origin-access-identity\/cloudfront\/' . $identity_id;\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":{"title":"<p>Get an OAI.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_oai('E3HV63EQPFPPOA');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetOAI.html\">GET Origin Access Identity<\/a>"}},{"name":"get_oai_config","modifier":"public","description":"<p>Gets the configuration of the origin access identity (OAI) for the specified identity ID.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"identity_id","type":"string","description":"<p>An Identity ID for an existing OAI.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_oai_config($identity_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/origin-access-identity\/cloudfront\/' . $identity_id . '\/config';\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":{"title":"<p>Update the OAI configuration.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n\/\/ Get the existing OAI configuration\n$config = $cdn-&gt;get_oai_config('E3HV63EQPFPPOA');\n\n\/\/ Was the request successful?\nif ($config-&gt;isOK())\n{\n\t\/\/ Grab the ETag header\n\t$etag = $config-&gt;header['etag'];\n\n\t\/\/ Update the configuration. (Returns XML.)\n\t$updated_xml = $cdn-&gt;update_oai_xml($config, array(\n\t\t'Comment' =&gt; 'This is my updated comment.'\n\t));\n\n\t\/\/ Update the OAI configuration.\n\t$response = $cdn-&gt;set_oai_config('E3HV63EQPFPPOA', $updated_xml, $etag);\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/GetOAIConfig.html\">GET Origin Access Identity Config<\/a>"}},{"name":"get_oai_list","modifier":"public","description":"<p>Gets a simplified list of origin access identity (OAI) IDs.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the OAI caller references against.<\/p>"}},"returnvalue":"<p>A list of OAI IDs.<\/p>","source":"public function get_oai_list($pcre = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new CloudFront_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $list = $this-&gt;list_oais();\n    if ($list = $list-&gt;body-&gt;Id())\n    {\n        $list = $list-&gt;map_string($pcre);\n        return $list;\n    }\n\n    return array();\n}","examples":{"example":{"title":"<p>Get a list of all OAIs.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_oai_list();\n\n\/\/ Success?\nvar_dump($response);"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"get_private_object_url","modifier":"public","description":"<p>Generates a time-limited and\/or query signed request for a private file with additional optional\nrestrictions.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_hostname","type":"string","description":"<p>The hostname of the distribution. Obtained from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name of the object. Query parameters can be included. You can use multicharacter match wild cards () or a single-character match wild card (?) anywhere in the string.<\/p>"},{"@attributes":{"choice":"req"},"name":"expires","type":"integer|string","description":"<p>The expiration time expressed either as a number of seconds since UNIX Epoch, or any string that <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> can understand.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>BecomeAvailable<\/code> - <code>integer|string<\/code> - Optional - The time when the private URL becomes active. Can be expressed either as a number of seconds since UNIX Epoch, or any string that <code>strtotime()<\/code> can understand.<\/li><li><code>IPAddress<\/code> - <code>string<\/code> - Optional - A single IP address to restrict the access to.<\/li><li><code>Secure<\/code> - <code>boolean<\/code> - Optional - Whether or not to use HTTPS as the protocol scheme. A value of <code>true<\/code> uses <code>https<\/code>. A value of <code>false<\/code> uses <code>http<\/code>. The default value is <code>false<\/code>.<\/li><\/ul>"}]},"returnvalue":"<p>The file URL with authentication parameters.<\/p>","source":"public function get_private_object_url($distribution_hostname, $filename, $expires, $opt = null)\n{\n    if (!$this-&gt;key_pair_id || !$this-&gt;private_key)\n    {\n        throw new CloudFront_Exception('You must set both a Amazon CloudFront keypair ID and an RSA private key for that keypair before using ' . __FUNCTION__ . '()');\n    }\n    if (!function_exists('openssl_sign'))\n    {\n        throw new CloudFront_Exception(__FUNCTION__ . '() uses functions from the OpenSSL PHP Extension &lt;http:\/\/php.net\/openssl&gt;, which is not installed in this PHP installation');\n    }\n\n    if (!$opt) $opt = array();\n\n    $resource = '';\n    $expiration_key = 'Expires';\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n    }\n    $conjunction = (strpos($filename, '?') === false ? '?' : '&amp;');\n\n    \/\/ Determine the protocol scheme\n    switch (substr($distribution_hostname, 0, 1) === 's')\n    {\n        \/\/ Streaming\n        case 's':\n            $scheme = 'rtmp';\n            $resource = str_replace(array('%3F', '%3D', '%26', '%2F'), array('?', '=', '&amp;', '\/'), rawurlencode($filename));\n            break;\n\n        \/\/ Default\n        case 'd':\n        default:\n            $scheme = 'http';\n            $scheme .= (isset($opt['Secure']) &amp;&amp; $opt['Secure'] === true ? 's' : '');\n            $resource = $scheme . ':\/\/' . $distribution_hostname . '\/' . str_replace(array('%3F', '%3D', '%26', '%2F'), array('?', '=', '&amp;', '\/'), rawurlencode($filename));\n            break;\n    }\n\n    \/\/ Generate default policy\n    $raw_policy = array(\n        'Statement' =&gt; array(\n            array(\n                'Resource' =&gt; $resource,\n                'Condition' =&gt; array(\n                    'DateLessThan' =&gt; array(\n                        'AWS:EpochTime' =&gt; $expires\n                    )\n                )\n            )\n        )\n    );\n\n    \/\/ Become Available\n    if (isset($opt['BecomeAvailable']))\n    {\n        \/\/ Switch to 'Policy' instead\n        $expiration_key = 'Policy';\n\n        \/\/ Update the policy\n        $raw_policy['Statement'][0]['Condition']['DateGreaterThan'] = array(\n            'AWS:EpochTime' =&gt; strtotime($opt['BecomeAvailable'])\n        );\n    }\n\n    \/\/ IP Address\n    if (isset($opt['IPAddress']))\n    {\n        \/\/ Switch to 'Policy' instead\n        $expiration_key = 'Policy';\n\n        \/\/ Update the policy\n        $raw_policy['Statement'][0]['Condition']['IpAddress'] = array(\n            'AWS:SourceIp' =&gt; $opt['IPAddress']\n        );\n    }\n\n    \/\/ Munge the policy\n    $json_policy = str_replace('\\\/', '\/', json_encode($raw_policy));\n    $json_policy = $this-&gt;util-&gt;decode_uhex($json_policy);\n    $encoded_policy = strtr(base64_encode($json_policy), '+=\/', '-_~');\n\n    \/\/ Generate the signature\n    openssl_sign($json_policy, $signature, $this-&gt;private_key);\n    $signature = strtr(base64_encode($signature), '+=\/', '-_~');\n\n    return $scheme . ':\/\/' . $distribution_hostname . '\/'\n        . str_replace(array('%3F', '%3D', '%26', '%2F'), array('?', '=', '&amp;', '\/'), rawurlencode($filename))\n        . $conjunction\n        . ($expiration_key === 'Expires' ? ($expiration_key . '=' . $expires) : ($expiration_key . '=' . $encoded_policy))\n        . '&amp;Key-Pair-Id=' . $this-&gt;key_pair_id\n        . '&amp;Signature=' . $signature;\n}","examples":{"example":{"title":"<p>Get a private object URL.<\/p>","description":"<ol>\n<li>Ensure you have the <a href=\"http:\/\/php.net\/openssl\">OpenSSL PHP Extension<\/a> installed.<\/li>\n<li>In your AWS Account Settings, create a new CloudFront key-pair to give you a key-pair ID, and download a *.pem private key.<\/li>\n<li>Add the key-pair ID and the contents of your private key to your <code>config.inc.php<\/code> file.<\/li>\n<li>In Amazon CloudFront, Create a new origin access identity (OAI).<\/li>\n<li>In Amazon S3, set the object permissions as Owner = Full Control and the OAI ID = Read<\/li>\n<li>Call <code>get_private_object_url()<\/code>.<\/li>\n<\/ol>","code":"$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_private_object_url(\n\t'dabcdefghijklxyz.cloudfront.net',\n\t'video\/folder with spaces\/s&aring;mpl&eacute;.mp4',\n\t'5 minutes'\n);\n\n\/\/ Success?\nvar_dump($response);"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/DeveloperGuide\/PrivateContent.html\">Serving Private Content<\/a>"}},{"name":"get_streaming_distribution_list","modifier":"public","description":"<p>Gets a simplified list of streaming distribution IDs.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the distribution caller references against.<\/p>"}},"returnvalue":"<p>A list of streaming distribution IDs.<\/p>","source":"public function get_streaming_distribution_list($pcre = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new CloudFront_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $list = $this-&gt;list_distributions(array(\n        'Streaming' =&gt; true\n    ));\n    if ($list = $list-&gt;body-&gt;Id())\n    {\n        $list = $list-&gt;map_string($pcre);\n        return $list;\n    }\n\n    return array();\n}","examples":{"example":{"title":"<p>Get a list of all streaming distributions.<\/p>","code":"\/\/ Generate configuration XML\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;get_streaming_distribution_list();\n\n\/\/ Success?\nvar_dump($response);"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]}},{"name":"list_distributions","modifier":"public","description":"<p>Gets a list of distributions. By default, the list is returned as one result. If needed, paginate the\nlist by specifying values for the <code>MaxItems<\/code> and <code>Marker<\/code> parameters.<\/p>\n\n<p>Standard distributions are listed separately from streaming distributions. For streaming distributions,\nset the <code>Streaming<\/code> option to true.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this setting when paginating results to indicate where in your list of distributions to begin. The results include distributions in the list that occur after the marker. To get the next page of results, set the <code>Marker<\/code> to the value of the <code>NextMarker<\/code> from the current page&#8217;s response (which is also the ID of the last distribution on that page).<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - The maximum number of distributions you want in the response body. Maximum of 100.<\/li><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_distributions($opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['query_string'] = array();\n\n    \/\/ Pass these to the query string\n    foreach (array('Marker', 'MaxItems') as $option)\n    {\n        if (isset($opt[$option]))\n        {\n            $opt['query_string'][$option] = $opt[$option];\n        }\n    }\n\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":[{"title":"<p>List standard distributions.<\/p>","code":"\/\/ Update the XML content\n$cdn = new AmazonCloudFront();\n$response = $cdn-&gt;list_distributions();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>List a single streaming distribution.<\/p>","code":"\/\/ Update the XML content\n$cdn = new AmazonCloudFront();\n$response = $cdn-&gt;list_distributions(array(\n\t'MaxItems' =&gt; 1,\n\t'Streaming' =&gt; true\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/ListDistributions.html\">GET Distribution List<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/ListStreamingDistributions.html\">GET Streaming Distribution List<\/a>"]}},{"name":"list_invalidations","modifier":"public","description":"<p>Gets a list of invalidations. By default, the list is returned as one result. If needed, paginate the\nlist by specifying values for the <code>MaxItems<\/code> and <code>Marker<\/code> parameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this when paginating results to indicate where in the list of invalidations to begin. The results include invalidations in the list that occur after the marker. To get the next page of results, set the <code>Marker<\/code> parameter to the value of the <code>NextMarker<\/code> parameter from the current page&#8217;s response, which is also the ID of the last invalidation on that page.<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - The maximum number of invalidations you want in the response body. A maximum value of 100 can be used.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_invalidations($distribution_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['query_string'] = array();\n\n    \/\/ Pass these to the query string\n    foreach (array('Marker', 'MaxItems') as $option)\n    {\n        if (isset($opt[$option]))\n        {\n            $opt['query_string'][$option] = $opt[$option];\n        }\n    }\n\n    $path = '\/distribution\/' . $distribution_id . '\/invalidation';\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":{"title":"<p>List pending or recent invalidations.<\/p>","code":"\/\/ Update the XML content\n$cdn = new AmazonCloudFront();\n$response = $cdn-&gt;list_invalidations('E2L6A3OZHQT5W4');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_invalidation\"><code>create_invalidation()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_invalidation.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_invalidation\"><code>get_invalidation()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/ListInvalidation.html\">GET Invalidation List<\/a>"}},{"name":"list_oais","modifier":"public","description":"<p>Gets a list of origin access identity (OAI) summaries. By default, the list is returned as one result.\nIf needed, paginate the list by specifying values for the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this when paginating results to indicate where in your list of distributions to begin. The results include distributions in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page&#8217;s response (which is also the ID of the last distribution on that page).<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - The maximum number of distributions you want in the response body. Maximum of 100.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_oais($opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['query_string'] = array();\n\n    \/\/ Pass these to the query string\n    foreach (array('Marker', 'MaxItems') as $option)\n    {\n        if (isset($opt[$option]))\n        {\n            $opt['query_string'][$option] = $opt[$option];\n        }\n    }\n\n    $path = '\/origin-access-identity\/cloudfront';\n\n    $opt = array_merge($opt, array('path' =&gt; $path));\n\n    return $this-&gt;authenticate('GET', $opt);\n}","examples":{"example":[{"title":"<p>List all OAIs.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;list_oais();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>List a single OAI.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n$response = $cdn-&gt;list_oais(array(\n\t'MaxItems' =&gt; 1\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/ListOAIs.html\">GET Origin Access Identity List<\/a>"}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"remove_cname","modifier":"public","description":"<p>Removes one or more CNAMEs from a <code>DistibutionConfig<\/code> XML document.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"xml","type":"CFSimpleXML|CFResponse|string","description":"<p>The source DistributionConfig XML to make updates to. Can be the <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a> body of a <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a> response, the entire <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> of a <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a> response, or a string of XML generated by <a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"cname","type":"string|array","description":"<p>The value or values to remove from the existing list of CNAME values. To add a CNAME value, see <a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>.<\/p>"}]},"returnvalue":"<p>XML document.<\/p>","source":"public function remove_cname($xml, $cname)\n{\n    \/\/ If we receive a full CFResponse object, only use the body.\n    if ($xml instanceof CFResponse)\n    {\n        $xml = $xml-&gt;body;\n    }\n\n    \/\/ If we received a string of XML, convert it into a CFSimpleXML object.\n    if (is_string($xml))\n    {\n        $xml = simplexml_load_string($xml);\n    }\n\n    \/\/ Let's make sure that we have CNAMEs to remove in the first place.\n    if (isset($xml-&gt;CNAME))\n    {\n        \/\/ If we have an array of CNAME values...\n        if (is_array($cname))\n        {\n            foreach ($cname as $cn)\n            {\n                for ($i = 0, $length = sizeof($xml-&gt;CNAME); $i &lt; $length; $i++)\n                {\n                    if ((string) $xml-&gt;CNAME[$i] == $cn)\n                    {\n                        unset($xml-&gt;CNAME[$i]);\n                        break;\n                    }\n                }\n            }\n        }\n\n        \/\/ If we only have one CNAME value...\n        else\n        {\n            for ($i = 0, $length = sizeof($xml-&gt;CNAME); $i &lt; $length; $i++)\n            {\n                if ((string) $xml-&gt;CNAME[$i] == $cname)\n                {\n                    unset($xml-&gt;CNAME[$i]);\n                    break;\n                }\n            }\n        }\n    }\n\n    return $xml-&gt;asXML();\n}","examples":{"example":{"title":"<p>Remove a CNAME from a distribution.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n\/\/ Sample XML content\n$config_xml = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4');\n\n\/\/ Update the XML content\n$response = $cdn-&gt;remove_cname($config_xml, 'cname.example.com');\n\n\/\/ Success?\nvar_dump($response);"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_distribution_config","modifier":"public","description":"<p>Sets a new distribution configuration for the specified distribution ID.<\/p>\n\n<p>Standard distributions are handled separately from streaming distributions. For streaming\ndistributions, set the <code>Streaming<\/code> option to true.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"distribution_id","type":"string","description":"<p>The distribution ID returned from <a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"xml","type":"string","description":"<p>The DistributionConfig XML generated by <a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"etag","type":"string","description":"<p>The ETag header value retrieved from <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Streaming<\/code> - <code>boolean<\/code> - Optional - Whether or not this should be for a streaming distribution. A value of <code>true<\/code> will create a streaming distribution. A value of <code>false<\/code> will create a standard distribution. The default value is <code>false<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_distribution_config($distribution_id, $xml, $etag, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/' . ((isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'streaming-distribution' : 'distribution');\n    $path .= '\/' . $distribution_id . '\/config';\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'xml' =&gt; $xml, 'etag' =&gt; $etag));\n\n    return $this-&gt;authenticate('PUT', $opt);\n}","examples":{"example":[{"title":"<p>Update a standard distribution configuration.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n\/\/ Pull existing config XML...\n$existing_xml = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4');\n\n\/\/ Was the request successful?\nif ($existing_xml-&gt;isOK())\n{\n\t\/\/ Generate an updated XML config...\n\t$updated_xml = $cdn-&gt;update_config_xml($existing_xml, array(\n\t\t'Enabled' =&gt; false\n\t));\n\n\t\/\/ Fetch an updated ETag value\n\t$etag = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4')-&gt;header['etag'];\n\n\t\/\/ Set the updated config XML to the distribution.\n\t$response = $cdn-&gt;set_distribution_config('E2L6A3OZHQT5W4', $updated_xml, $etag);\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"},{"title":"<p>Update a streaming distribution configuration.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n\/\/ Pull existing config XML...\n$existing_xml = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4', array(\n\t'Streaming' =&gt; true\n));\n\n\/\/ Was the request successful?\nif ($existing_xml-&gt;isOK())\n{\n\t\/\/ Generate an updated XML config...\n\t$updated_xml = $cdn-&gt;update_config_xml($existing_xml, array(\n\t\t'Enabled' =&gt; false,\n\t\t'Streaming' =&gt; true,\n\t\t'CachingBehavior' =&gt; array(\n\t\t\t'MinTTL' =&gt; '30 minutes',\n\t\t),\n\t));\n\n\t\/\/ Fetch an updated ETag value\n\t$etag = $existing_xml-&gt;header['etag'];\n\n\t\/\/ Set the updated config XML to the distribution.\n\t$response = $cdn-&gt;set_distribution_config('E2L6A3OZHQT5W4', $updated_xml, $etag, array(\n\t\t'Streaming' =&gt; true\n\t));\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]},"seealso":{"link":["<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/PutConfig.html\">PUT Distribution Config<\/a>","<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/PutStreamingDistConfig.html\">PUT Streaming Distribution Config<\/a>"]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_keypair_id","modifier":"public","description":"<p>Set the key ID of the RSA key pair being used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"key_pair_id","type":"string","description":"<p>The ID of the RSA key pair being used.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_keypair_id($key_pair_id)\n{\n    $this-&gt;key_pair_id = $key_pair_id;\n    return $this;\n}","related":{"method":["<a href=\"..\/amazoncloudfront\/disable_ssl.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/disable_ssl\"><code>disable_ssl()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_private_key.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_private_key\"><code>set_private_key()<\/code><\/a>"]}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_oai_config","modifier":"public","description":"<p>Sets the configuration for an Amazon CloudFront origin access identity (OAI). Use this when updating\nthe configuration. Currently, only comments may be updated.  Follow the same process as when updating\nan identity&#8217;s configuration as you do when updating a distribution&#8217;s configuration. For more\ninformation, go to Updating a Distribution&#8217;s Configuration in the Amazon CloudFront Developer Guide.<\/p>\n\n<p>When attempting to change configuration items that are not allowed to be updated, Amazon CloudFront\nreturns an <code>IllegalUpdate<\/code> error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"identity_id","type":"string","description":"<p>An Identity ID for an existing OAI.<\/p>"},{"@attributes":{"choice":"req"},"name":"xml","type":"string","description":"<p>The configuration XML generated by <a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"etag","type":"string","description":"<p>The ETag header value retrieved from a call to <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_oai_config($identity_id, $xml, $etag, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    $path = '\/origin-access-identity\/cloudfront\/' . $identity_id . '\/config';\n\n    $opt = array_merge($opt, array('path' =&gt; $path, 'xml' =&gt; $xml, 'etag' =&gt; $etag));\n\n    return $this-&gt;authenticate('PUT', $opt);\n}","examples":{"example":{"title":"<p>Update the OAI configuration.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n\/\/ Get the existing OAI configuration\n$config = $cdn-&gt;get_oai_config('E3HV63EQPFPPOA');\n\n\/\/ Was the request successful?\nif ($config-&gt;isOK())\n{\n\t\/\/ Grab the ETag header\n\t$etag = $config-&gt;header['etag'];\n\n\t\/\/ Update the configuration. (Returns XML.)\n\t$updated_xml = $cdn-&gt;update_oai_xml($config, array(\n\t\t'Comment' =&gt; 'This is my updated comment.'\n\t));\n\n\t\/\/ Update the OAI configuration.\n\t$response = $cdn-&gt;set_oai_config('E3HV63EQPFPPOA', $updated_xml, $etag);\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonCloudFront\/latest\/APIReference\/PutOAIConfig.html\">PUT Origin Access Identity Config<\/a>"}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_private_key","modifier":"public","description":"<p>Set the private key resource locator being used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"private_key","type":"string","description":"<p>The contents of the RSA private key used to sign requests.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_private_key($private_key)\n{\n    $this-&gt;private_key = $private_key;\n    return $this;\n}","related":{"method":["<a href=\"..\/amazoncloudfront\/disable_ssl.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/disable_ssl\"><code>disable_ssl()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_keypair_id.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_keypair_id\"><code>set_keypair_id()<\/code><\/a>"]}},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"update_config_xml","modifier":"public","description":"<p>Updates an existing configuration XML document.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"xml","type":"CFSimpleXML|CFResponse|string","description":"<p>The source configuration XML to make updates to. Can be the <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a> body of a <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a> response, the entire <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> of a <a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a> response, or a string of XML generated by <a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>CNAME<\/code> - <code>string|array<\/code> - Optional - The value or values to add to the existing list of CNAME values. If setting more than one, use an indexed array. Supports up to 10 CNAMEs.<\/li><li><code>Comment<\/code> - <code>string<\/code> - Optional - A comment to apply to the distribution. Cannot exceed 128 characters.<\/li><li><code>DefaultRootObject<\/code> - <code>string<\/code> - Optional - The file to load when someone accesses the root of your Amazon CloudFront domain (e.g., <code>index.html<\/code>).<\/li><li><code>Enabled<\/code> - <code>string<\/code> - Optional - A value of <code>true<\/code> enables the distribution. A value of <code>false<\/code> disables it. The default value is <code>true<\/code>.<\/li><li><code>Logging<\/code> - <code>array<\/code> - Optional - An array that contains two keys: <code>Bucket<\/code>, specifying where logs are written to, and <code>Prefix<\/code>, specifying a prefix to append to log file names.<\/li><li><code>OriginAccessIdentity<\/code> - <code>string<\/code> - Optional - The origin access identity (OAI) associated with this distribution. Use the Identity ID from the OAI, not the <code>CanonicalId<\/code>.<\/li><li><code>TrustedSigners<\/code> - <code>array<\/code> - Optional - An array of AWS account numbers for users who are trusted signers. Explicity add the value <code>Self<\/code> to the array to add your own account as a trusted signer.<\/li><\/ul>"}]},"returnvalue":"<p>XML document.<\/p>","source":"public function update_config_xml($xml, $opt = null)\n{\n    \/\/ If we receive a full CFResponse object, only use the body.\n    if ($xml instanceof CFResponse)\n    {\n        $xml = $xml-&gt;body;\n    }\n\n    \/\/ If we received a string of XML, convert it into a CFSimpleXML object.\n    if (is_string($xml))\n    {\n        $xml = simplexml_load_string($xml, $this-&gt;parser_class);\n    }\n\n    \/\/ Default, empty XML\n    $update = simplexml_load_string(sprintf($this-&gt;base_xml, (\n        (isset($opt['Streaming']) &amp;&amp; $opt['Streaming'] == (bool) true) ? 'StreamingDistributionConfig' : 'DistributionConfig')\n    ), $this-&gt;parser_class);\n\n    \/\/ These can't change.\n    if (isset($xml-&gt;S3Origin))\n    {\n        $origin = $update-&gt;addChild('S3Origin');\n        $origin-&gt;addChild('DNSName', $xml-&gt;S3Origin-&gt;DNSName);\n\n        \/\/ origin access identity\n        if (isset($opt['OriginAccessIdentity']))\n        {\n            $origin-&gt;addChild('OriginAccessIdentity', 'origin-access-identity\/cloudfront\/' . $opt['OriginAccessIdentity']);\n        }\n        elseif (isset($xml-&gt;S3Origin-&gt;OriginAccessIdentity))\n        {\n            $origin-&gt;addChild('OriginAccessIdentity', $xml-&gt;S3Origin-&gt;OriginAccessIdentity);\n        }\n    }\n    elseif (isset($xml-&gt;CustomOrigin))\n    {\n        $origin = $update-&gt;addChild('CustomOrigin');\n        $origin-&gt;addChild('DNSName', $xml-&gt;CustomOrigin-&gt;DNSName);\n\n        \/\/ Copy OriginProtocolPolicy for update\n        if ( isset($xml-&gt;CustomOrigin-&gt;OriginProtocolPolicy) )\n        {\n            $origin-&gt;addChild('OriginProtocolPolicy', $xml-&gt;CustomOrigin-&gt;OriginProtocolPolicy);\n        }\n\n        \/\/ origin access identity\n        if (isset($opt['OriginAccessIdentity']))\n        {\n            $origin-&gt;addChild('OriginAccessIdentity', 'origin-access-identity\/cloudfront\/' . $opt['OriginAccessIdentity']);\n        }\n        elseif (isset($xml-&gt;CustomOrigin-&gt;OriginAccessIdentity))\n        {\n            $origin-&gt;addChild('OriginAccessIdentity', $xml-&gt;CustomOrigin-&gt;OriginAccessIdentity);\n        }\n    }\n\n    $update-&gt;addChild('CallerReference', $xml-&gt;CallerReference);\n\n    \/\/ Add existing CNAME values\n    if ($xml-&gt;CNAME)\n    {\n        $update-&gt;addChild('CNAME', $xml-&gt;CNAME);\n    }\n\n    \/\/ Add new CNAME values\n    if (isset($opt['CNAME']))\n    {\n        if (is_array($opt['CNAME']))\n        {\n            foreach ($opt['CNAME'] as $cname)\n            {\n                $update-&gt;addChild('CNAME', $cname);\n            }\n        }\n        else\n        {\n            $update-&gt;addChild('CNAME', $opt['CNAME']);\n        }\n    }\n\n    \/\/ Comment\n    if (isset($opt['Comment']))\n    {\n        $update-&gt;addChild('Comment', $opt['Comment']);\n    }\n    elseif (isset($xml-&gt;Comment))\n    {\n        $update-&gt;addChild('Comment', $xml-&gt;Comment);\n    }\n\n    \/\/ DefaultRootObject\n    if (isset($opt['DefaultRootObject']))\n    {\n        $update-&gt;addChild('DefaultRootObject', $opt['DefaultRootObject']);\n    }\n    elseif (isset($xml-&gt;DefaultRootObject))\n    {\n        $update-&gt;addChild('DefaultRootObject', $xml-&gt;DefaultRootObject);\n    }\n\n    \/\/ Enabled\n    if (isset($opt['Enabled']))\n    {\n        $update-&gt;addChild('Enabled', $opt['Enabled'] ? 'true' : 'false');\n    }\n    elseif (isset($xml-&gt;Enabled))\n    {\n        $update-&gt;addChild('Enabled', $xml-&gt;Enabled);\n    }\n\n    \/\/ Logging\n    if (isset($opt['Logging']))\n    {\n        if (is_array($opt['Logging']))\n        {\n            $logging = $update-&gt;addChild('Logging');\n            $bucket_name = $opt['Logging']['Bucket'];\n\n            \/\/ Origin\n            $logging-&gt;addChild('Bucket', $bucket_name . ((stripos($bucket_name, '.s3.amazonaws.com') === false) ? '.s3.amazonaws.com' : ''));\n\n            $logging-&gt;addChild('Prefix', $opt['Logging']['Prefix']);\n        }\n    }\n    elseif (isset($xml-&gt;Logging))\n    {\n        $logging = $update-&gt;addChild('Logging');\n        $logging-&gt;addChild('Bucket', $xml-&gt;Logging-&gt;Bucket);\n        $logging-&gt;addChild('Prefix', $xml-&gt;Logging-&gt;Prefix);\n    }\n\n    \/\/ Required Protocols\n    if (isset($opt['RequiredProtocols']))\n    {\n        $required_protocols = $xml-&gt;addChild('RequiredProtocols');\n        $required_protocols-&gt;addChild('Protocol', $opt['RequiredProtocols']);\n    }\n    elseif (isset($xml-&gt;RequiredProtocols))\n    {\n        $required_protocols = $update-&gt;addChild('RequiredProtocols');\n        $required_protocols-&gt;addChild('Protocol', $xml-&gt;RequiredProtocols-&gt;Protocol);\n    }\n\n    \/\/ Caching Behavior\n    if (isset($opt['CachingBehavior']) &amp;&amp; is_array($opt['CachingBehavior']))\n    {\n        $caching_behavior = $xml-&gt;addChild('CachingBehavior');\n\n        if (isset($opt['CachingBehavior']['MinTTL']))\n        {\n            $min_ttl = $opt['CachingBehavior']['MinTTL'];\n\n            if (is_string($min_ttl))\n            {\n                $min_ttl = strtotime($min_ttl);\n            }\n\n            $caching_behavior-&gt;addChild('MinTTL', $min_ttl);\n        }\n    }\n    elseif (isset($xml-&gt;CachingBehavior))\n    {\n        $caching_behavior = $update-&gt;addChild('CachingBehavior');\n        $caching_behavior-&gt;addChild('MinTTL', $xml-&gt;CachingBehavior-&gt;MinTTL);\n    }\n\n    \/\/ Trusted Signers\n    if (isset($opt['TrustedSigners']))\n    {\n        $trusted_signers = $update-&gt;addChild('TrustedSigners');\n\n        \/\/ Not an array? Convert to one.\n        if (!is_array($opt['TrustedSigners']))\n        {\n            $opt['TrustedSigners'] = array($opt['TrustedSigners']);\n        }\n\n        \/\/ Handle 'Self' vs. everything else\n        foreach ($opt['TrustedSigners'] as $signer)\n        {\n            if (strtolower($signer) === 'self')\n            {\n                $trusted_signers-&gt;addChild('Self');\n            }\n            else\n            {\n                $trusted_signers-&gt;addChild('AwsAccountNumber', $signer);\n            }\n        }\n    }\n    elseif (isset($xml-&gt;TrustedSigners) &amp;&amp; $xml-&gt;TrustedSigners-&gt;count())\n    {\n        $trusted_signers = $update-&gt;addChild('TrustedSigners');\n\n        \/\/ Handle 'Self' vs. everything else\n        foreach ($xml-&gt;TrustedSigners-&gt;children() as $signer_key =&gt; $signer_value)\n        {\n            if (strtolower((string) $signer_key) === 'self')\n            {\n                $trusted_signers-&gt;addChild('Self');\n            }\n            else\n            {\n                $trusted_signers-&gt;addChild('AwsAccountNumber', (string) $signer_value);\n            }\n        }\n    }\n\n    \/\/ Output\n    return $update-&gt;asXML();\n}","examples":{"example":[{"title":"<p>Update a distribution with comments, a single CNAME, and a default root object.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n$config_xml = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4');\n\n\/\/ Update the XML content\n$response = $cdn-&gt;update_config_xml($config_xml, array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'CNAME' =&gt; 'cname.example.com',\n\t'DefaultRootObject' =&gt; 'text\/sample.txt'\n));\n\n\/\/ Success?\nvar_dump($response);"},{"title":"<p>Update a streaming distribution with comments, a single CNAME, and a default root object.<\/p>","code":"$cdn = new AmazonCloudFront();\n\n$config_xml = $cdn-&gt;get_distribution_config('E2L6A3OZHQT5W4');\n\n\/\/ Update the XML content\n$response = $cdn-&gt;update_config_xml($config_xml, array(\n\t'Enabled' =&gt; true,\n\t'Comment' =&gt; 'This is my sample comment',\n\t'CNAME' =&gt; 'cname.example.com',\n\t'Streaming' =&gt; true,\n\t'DefaultRootObject' =&gt; 'text\/sample.txt'\n));\n\n\/\/ Success?\nvar_dump($response);"}]},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_distribution\"><code>create_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_distribution.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_distribution\"><code>delete_distribution()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_config\"><code>get_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_info.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_info\"><code>get_distribution_info()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_distribution_list\"><code>get_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_streaming_distribution_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_streaming_distribution_list\"><code>get_streaming_distribution_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_distributions.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_distributions\"><code>list_distributions()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_distribution_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_distribution_config\"><code>set_distribution_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>"]}},{"name":"update_oai_xml","modifier":"public","description":"<p>Updates the origin access identity (OAI) configureation XML used in <a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"xml","type":"CFSimpleXML|CFResponse|string","description":"<p>The source configuration XML to make updates to. Can be the <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a> body of a <a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a> response, the entire <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> of a <a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a> response, or a string of XML generated by <a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a> or <a href=\"..\/amazoncloudfront\/update_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_oai_xml\"><code>update_oai_xml()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Comment<\/code> - <code>string<\/code> - Optional - Replaces the existing value for &#8220;Comment&#8221;. Cannot exceed 128 characters.<\/li><\/ul>"}]},"returnvalue":"<p>XML document.<\/p>","source":"public function update_oai_xml($xml, $opt = null)\n{\n    \/\/ If we receive a full CFResponse object, only use the body.\n    if ($xml instanceof CFResponse)\n    {\n        $xml = $xml-&gt;body;\n    }\n\n    \/\/ If we received a string of XML, convert it into a CFSimpleXML object.\n    if (is_string($xml))\n    {\n        $xml = simplexml_load_string($xml, $this-&gt;parser_class);\n    }\n\n    \/\/ Update the comment, if we have one.\n    if (isset($opt['Comment']) &amp;&amp; isset($xml-&gt;Comment))\n    {\n        $xml-&gt;Comment = $opt['Comment'];\n    }\n    elseif (isset($opt['Comment']))\n    {\n        $xml-&gt;addChild('Comment', $opt['Comment']);\n    }\n\n    return $xml-&gt;asXML();\n}","examples":{"example":{"title":"<p>Update the OAI configuration.<\/p>","code":"\/\/ Create a new CloudFront distribution from an S3 bucket.\n$cdn = new AmazonCloudFront();\n\n\/\/ Get the existing OAI configuration\n$config = $cdn-&gt;get_oai_config('E3HV63EQPFPPOA');\n\n\/\/ Was the request successful?\nif ($config-&gt;isOK())\n{\n\t\/\/ Grab the ETag header\n\t$etag = $config-&gt;header['etag'];\n\n\t\/\/ Update the configuration. (Returns XML.)\n\t$updated_xml = $cdn-&gt;update_oai_xml($config, array(\n\t\t'Comment' =&gt; 'This is my updated comment.'\n\t));\n\n\t\/\/ Update the OAI configuration.\n\t$response = $cdn-&gt;set_oai_config('E3HV63EQPFPPOA', $updated_xml, $etag);\n\n\t\/\/ Success?\n\tvar_dump($response-&gt;isOK());\n}","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoncloudfront\/create_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/create_oai\"><code>create_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/delete_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/delete_oai\"><code>delete_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_config_xml\"><code>generate_config_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_invalidation_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_invalidation_xml\"><code>generate_invalidation_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/generate_oai_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/generate_oai_xml\"><code>generate_oai_xml()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai\"><code>get_oai()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_config\"><code>get_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/get_oai_list.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/get_oai_list\"><code>get_oai_list()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/list_oais.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/list_oais\"><code>list_oais()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/remove_cname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/remove_cname\"><code>remove_cname()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/set_oai_config.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_oai_config\"><code>set_oai_config()<\/code><\/a>","<a href=\"..\/amazoncloudfront\/update_config_xml.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/update_config_xml\"><code>update_config_xml()<\/code><\/a>"]}}]},"constants":{"@attributes":{"count":"7"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"cloudfront.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"STATE_DEPLOYED","value":"Deployed"},{"name":"STATE_INPROGRESS","value":"InProgress"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"44"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"base_xml","modifier":"public","description":"<p>The base content to use for generating the DistributionConfig XML.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"domain","modifier":"public","description":"<p>The CloudFront distribution domain to use.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"key_pair_id","modifier":"public","description":"<p>The RSA key pair ID to use.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazoncloudfront\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudfront\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"private_key","modifier":"public","description":"<p>The RSA private key resource locator.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}