{"file":{},"class":{"name":"AmazonCloudSearch","file":"services\/cloudsearch.class.php","url":"..\/amazoncloudsearch\/index.html","description":"<p>You use the Configuration Service to create, configure, and manage search domains. Amazon\nCloudSearch configuration requests are submitted to\n<code>cloudsearch.us-east-1.amazonaws.com<\/code> using the AWS Query protocol.<\/p>","metadata":{"version":"2013.01.14","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/cloudsearch\/ Amazon CloudSearch","http:\/\/aws.amazon.com\/cloudsearch\/documentation\/ Amazon CloudSearch documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"50"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazoncloudsearch\/index.html\" rel=\"..\/..\/index.html#i=amazoncloudsearch\"><code>AmazonCloudSearch<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoncloudsearch\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2011-02-01';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV4Query';\n\n    return parent::__construct($options);\n}"},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazoncloudsearch\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazoncloudsearch\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazoncloudsearch\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazoncloudsearch\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"create_domain","modifier":"public","description":"<p>Creates a new search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_domain($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('CreateDomain', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a search domain.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe the CloudSearch domains\n\necho &quot;# Describing the CloudSearch domain, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_domains(array(\n\t'DomainNames' =&gt; $domain_name\n));\n\nprint_r($response-&gt;body-&gt;Arn()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"define_index_field","modifier":"public","description":"<p>Configures an <code>IndexField<\/code> for the search domain. Used to create new fields and\nmodify existing ones. If the field exists, the new configuration replaces the old one. You can\nconfigure a maximum of 200 index fields.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"index_field","type":"array","description":"<p>Defines a field in the index, including its name, type, and the source of its data. The <code>IndexFieldType<\/code> indicates which of the options will be present. It is invalid to specify options for a type other than the <code>IndexFieldType<\/code>.<\/p>\n\n<ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>IndexFieldName<\/code> - <code>string<\/code> - Required - The name of a field in the search index. Field names must begin with a letter and can contain the following characters: a-z (lowercase), 0-9, and _ (underscore). Uppercase letters and hyphens are not allowed. The names &#8220;body&#8221;, &#8220;docid&#8221;, and &#8220;text_relevance&#8221; are reserved and cannot be specified as field or rank expression names. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/li><li><code>IndexFieldType<\/code> - <code>string<\/code> - Required - The type of field. Based on this type, exactly one of the <code>UIntOptions<\/code>, <code>LiteralOptions<\/code> or <code>TextOptions<\/code> must be present. [Allowed values: <code>uint<\/code>, <code>literal<\/code>, <code>text<\/code>]<\/li><li><code>UIntOptions<\/code> - <code>array<\/code> - Optional - Options for an unsigned integer field. Present if <code>IndexFieldType<\/code> specifies the field is of type unsigned integer. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>DefaultValue<\/code> - <code>integer<\/code> - Optional - The default value for an unsigned integer field.<\/li><\/ul><\/li><\/ul><\/li><li><code>LiteralOptions<\/code> - <code>array<\/code> - Optional - Options for literal field. Present if <code>IndexFieldType<\/code> specifies the field is of type literal. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>DefaultValue<\/code> - <code>string<\/code> - Optional - The default value for a literal field.<\/li><li><code>SearchEnabled<\/code> - <code>boolean<\/code> - Optional - Specifies whether search is enabled for this field.<\/li><li><code>FacetEnabled<\/code> - <code>boolean<\/code> - Optional - Specifies whether facets are enabled for this field.<\/li><li><code>ResultEnabled<\/code> - <code>boolean<\/code> - Optional - Specifies whether values of this field can be returned in search results and used for ranking.<\/li><\/ul><\/li><\/ul><\/li><li><code>TextOptions<\/code> - <code>array<\/code> - Optional - Options for text field. Present if <code>IndexFieldType<\/code> specifies the field is of type text. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>DefaultValue<\/code> - <code>string<\/code> - Optional - The default value for a text field.<\/li><li><code>FacetEnabled<\/code> - <code>boolean<\/code> - Optional - Specifies whether facets are enabled for this field.<\/li><li><code>ResultEnabled<\/code> - <code>boolean<\/code> - Optional - Specifies whether values of this field can be returned in search results and used for ranking.<\/li><\/ul><\/li><\/ul><\/li><li><code>SourceAttributes<\/code> - <code>array<\/code> - Optional - An optional list of source attributes that provide data for this index field. If not specified, the data is pulled from a source attribute with the same name as this <code>IndexField<\/code>. When one or more source attributes are specified, an optional data transformation can be applied to the source data when populating the index field. You can configure a maximum of 20 sources for an <code>IndexField<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SourceDataFunction<\/code> - <code>string<\/code> - Required - Identifies the transformation to apply when copying data from a source attribute. [Allowed values: <code>Copy<\/code>, <code>TrimTitle<\/code>, <code>Map<\/code>]<\/li><li><code>SourceDataCopy<\/code> - <code>array<\/code> - Optional - Copies data from a source document attribute to an <code>IndexField<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SourceName<\/code> - <code>string<\/code> - Required - The name of the document source field to add to this <code>IndexField<\/code>. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/li><li><code>DefaultValue<\/code> - <code>string<\/code> - Optional - The value of a field or source document attribute.<\/li><\/ul><\/li><\/ul><\/li><li><code>SourceDataTrimTitle<\/code> - <code>array<\/code> - Optional - Trims common title words from a source document attribute when populating an <code>IndexField<\/code>. This can be used to create an <code>IndexField<\/code> you can use for sorting. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SourceName<\/code> - <code>string<\/code> - Required - The name of the document source field to add to this <code>IndexField<\/code>. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/li><li><code>DefaultValue<\/code> - <code>string<\/code> - Optional - The value of a field or source document attribute.<\/li><li><code>Separator<\/code> - <code>string<\/code> - Optional - The separator that follows the text to trim.<\/li><li><code>Language<\/code> - <code>string<\/code> - Optional - An <a href=\"http:\/\/tools.ietf.org\/html\/rfc4646\">IETF RFC 4646<\/a> language code. Only the primary language is considered. English (en) is currently the only supported language. [Constraints: The value must match the following regular expression pattern: <code>[a-zA-Z]{2,8}(?:-[a-zA-Z]{2,8})*<\/code>]<\/li><\/ul><\/li><\/ul><\/li><li><code>SourceDataMap<\/code> - <code>array<\/code> - Optional - Maps source document attribute values to new values when populating the <code>IndexField<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SourceName<\/code> - <code>string<\/code> - Required - The name of the document source field to add to this <code>IndexField<\/code>. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/li><li><code>DefaultValue<\/code> - <code>string<\/code> - Optional - The value of a field or source document attribute.<\/li><li><code>Cases<\/code> - <code>array<\/code> - Optional - A map that translates source field values to custom values. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>[custom-key]<\/code> - <code>string<\/code> - Optional - The value of a field or source document attribute.<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function define_index_field($domain_name, $index_field, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    \/\/ Required map (non-list)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'IndexField' =&gt; (is_array($index_field) ? $index_field : array($index_field))\n    ), 'member'));\n\n    return $this-&gt;authenticate('DefineIndexField', $opt);\n}","examples":{"example":{"title":"<p>Create and delete an index field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$index_field = 'test_integer';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $index_field,\n\t'IndexFieldType' =&gt; 'uint',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe index fields\n\necho &quot;# Describing the CloudSearch index fields, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_index_fields($domain_name);\n\nprint_r($response-&gt;body-&gt;IndexFieldName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Index documents\n\necho &quot;# Indexing documents, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;index_documents($domain_name);\n\nprint_r($response-&gt;body-&gt;member()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete index fields\n\necho '# Deleting the CloudSearch index field...' . PHP_EOL;\n$response = $search-&gt;delete_index_field($domain_name, $index_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch index field was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"define_rank_expression","modifier":"public","description":"<p>Configures a <code>RankExpression<\/code> for the search domain. Used to create new rank\nexpressions and modify existing ones. If the expression exists, the new configuration replaces\nthe old one. You can configure a maximum of 50 rank expressions.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"rank_expression","type":"array","description":"<p>A named expression that can be evaluated at search time and used for ranking or thresholding in a search query.<\/p>\n\n<ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>RankName<\/code> - <code>string<\/code> - Required - The name of a rank expression. Rank expression names must begin with a letter and can contain the following characters: a-z (lowercase), 0-9, and _ (underscore). Uppercase letters and hyphens are not allowed. The names &#8220;body&#8221;, &#8220;docid&#8221;, and &#8220;text_relevance&#8221; are reserved and cannot be specified as field or rank expression names. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/li><li><code>RankExpression<\/code> - <code>string<\/code> - Required - The expression to evaluate for ranking or thresholding while processing a search request. The <code>RankExpression<\/code> syntax is based on JavaScript expressions and supports:<ul><li>Integer, floating point, hex and octal literals<\/li><li>Shortcut evaluation of logical operators such that an expression <code>a || b<\/code> evaluates to the value <code>a<\/code> if <code>a<\/code> is <code>true<\/code> without evaluting <code>b<\/code> at all<\/li><li>JavaScript order of precendence for operators<\/li><li>Arithmetic operators: <code>+ - \/ %<\/code> <\/li><li>Boolean operators (including the ternary operator)<\/li><li>Bitwise operators<\/li><li>Comparison operators<\/li><li>Common mathematic functions: <code>abs ceil erf exp floor lgamma ln log2 log10 max min sqrt pow<\/code> <\/li><li>Trigonometric library functions: <code>acosh acos asinh asin atanh atan cosh cos sinh sin tanh tan<\/code> <\/li><li>Random generation of a number between 0 and 1: <code>rand<\/code> <\/li><li>Current time in epoch: <code>time<\/code> <\/li><li>The <code>min max<\/code> functions that operate on a variable argument list<\/li><\/ul>Intermediate results are calculated as double precision floating point values. The final return value of a <code>RankExpression<\/code> is automatically converted from floating point to a 32-bit unsigned integer by rounding to the nearest integer, with a natural floor of 0 and a ceiling of max(uint32_t), 4294967295. Mathematical errors such as dividing by 0 will fail during evaluation and return a value of 0. The source data for a <code>RankExpression<\/code> can be the name of an <code>IndexField<\/code> of type uint, another <code>RankExpression<\/code> or the reserved name <em>text_relevance<\/em>. The text_relevance source is defined to return an integer from 0 to 1000 (inclusive) to indicate how relevant a document is to the search request, taking into account repetition of search terms in the document and proximity of search terms to each other in each matching <code>IndexField<\/code> in the document. For more information about using rank expressions to customize ranking, see the Amazon CloudSearch Developer Guide.<\/li><\/ul><\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function define_rank_expression($domain_name, $rank_expression, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    \/\/ Required map (non-list)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'RankExpression' =&gt; (is_array($rank_expression) ? $rank_expression : array($rank_expression))\n    ), 'member'));\n\n    return $this-&gt;authenticate('DefineRankExpression', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a rank expression.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$rank_expression = 'test_expression';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define rank expressions\n\necho '# Defining a new CloudSearch rank expression' . PHP_EOL;\n$response = $search-&gt;define_rank_expression($domain_name, array(\n\t'RankName' =&gt; $rank_expression,\n\t'RankExpression' =&gt; '(0.7*text_relevance)',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined a rank expression...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe rank expressions\n\necho &quot;# Describing the CloudSearch rank expressions, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_rank_expressions($domain_name);\n\nprint_r($response-&gt;body-&gt;RankName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete rank expressions\n\necho '# Deleting the CloudSearch rank expression...' . PHP_EOL;\n$response = $search-&gt;delete_rank_expression($domain_name, $rank_expression);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch rank expression was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_domain","modifier":"public","description":"<p>Permanently deletes a search domain and all of its data.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_domain($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DeleteDomain', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a search domain.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe the CloudSearch domains\n\necho &quot;# Describing the CloudSearch domain, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_domains(array(\n\t'DomainNames' =&gt; $domain_name\n));\n\nprint_r($response-&gt;body-&gt;Arn()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"delete_index_field","modifier":"public","description":"<p>Removes an <code>IndexField<\/code> from the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"index_field_name","type":"string","description":"<p>A string that represents the name of an index field. Field names must begin with a letter and can contain the following characters: a-z (lowercase), 0-9, and _ (underscore). Uppercase letters and hyphens are not allowed. The names &#8220;body&#8221;, &#8220;docid&#8221;, and &#8220;text_relevance&#8221; are reserved and cannot be specified as field or rank expression names. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_index_field($domain_name, $index_field_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['IndexFieldName'] = $index_field_name;\n    \n    return $this-&gt;authenticate('DeleteIndexField', $opt);\n}","examples":{"example":{"title":"<p>Create and delete an index field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$index_field = 'test_integer';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $index_field,\n\t'IndexFieldType' =&gt; 'uint',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe index fields\n\necho &quot;# Describing the CloudSearch index fields, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_index_fields($domain_name);\n\nprint_r($response-&gt;body-&gt;IndexFieldName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Index documents\n\necho &quot;# Indexing documents, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;index_documents($domain_name);\n\nprint_r($response-&gt;body-&gt;member()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete index fields\n\necho '# Deleting the CloudSearch index field...' . PHP_EOL;\n$response = $search-&gt;delete_index_field($domain_name, $index_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch index field was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"delete_rank_expression","modifier":"public","description":"<p>Removes a <code>RankExpression<\/code> from the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"rank_name","type":"string","description":"<p>The name of the <code>RankExpression<\/code> to delete. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9_]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_rank_expression($domain_name, $rank_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['RankName'] = $rank_name;\n    \n    return $this-&gt;authenticate('DeleteRankExpression', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a rank expression.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$rank_expression = 'test_expression';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define rank expressions\n\necho '# Defining a new CloudSearch rank expression' . PHP_EOL;\n$response = $search-&gt;define_rank_expression($domain_name, array(\n\t'RankName' =&gt; $rank_expression,\n\t'RankExpression' =&gt; '(0.7*text_relevance)',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined a rank expression...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe rank expressions\n\necho &quot;# Describing the CloudSearch rank expressions, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_rank_expressions($domain_name);\n\nprint_r($response-&gt;body-&gt;RankName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete rank expressions\n\necho '# Deleting the CloudSearch rank expression...' . PHP_EOL;\n$response = $search-&gt;delete_rank_expression($domain_name, $rank_expression);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch rank expression was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_default_search_field","modifier":"public","description":"<p>Gets the default search field configured for the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_default_search_field($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DescribeDefaultSearchField', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the default search field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$search_field = 'test_field';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $search_field,\n\t'IndexFieldType' =&gt; 'text',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update default search field\n\nsleep(1);\n\necho &quot;# Update the default search field, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_default_search_field($domain_name, $search_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the default search field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe default search field\n\necho &quot;# Describing the default search field, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_default_search_field($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_domains","modifier":"public","description":"<p>Gets information about the search domains owned by this account. Can be limited to specific\ndomains. Shows all domains by default.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>DomainNames<\/code> - <code>string|array<\/code> - Optional - Limits the DescribeDomains response to the specified search domains. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_domains($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['DomainNames']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'DomainNames' =&gt; (is_array($opt['DomainNames']) ? $opt['DomainNames'] : array($opt['DomainNames']))\n        ), 'member'));\n        unset($opt['DomainNames']);\n    }\n\n    return $this-&gt;authenticate('DescribeDomains', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a search domain.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe the CloudSearch domains\n\necho &quot;# Describing the CloudSearch domain, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_domains(array(\n\t'DomainNames' =&gt; $domain_name\n));\n\nprint_r($response-&gt;body-&gt;Arn()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_index_fields","modifier":"public","description":"<p>Gets information about the index fields configured for the search domain. Can be limited to\nspecific fields by name. Shows all fields by default.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>FieldNames<\/code> - <code>string|array<\/code> - Optional - Limits the <code>DescribeIndexFields<\/code> response to the specified fields. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_index_fields($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['FieldNames']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'FieldNames' =&gt; (is_array($opt['FieldNames']) ? $opt['FieldNames'] : array($opt['FieldNames']))\n        ), 'member'));\n        unset($opt['FieldNames']);\n    }\n\n    return $this-&gt;authenticate('DescribeIndexFields', $opt);\n}","examples":{"example":{"title":"<p>Create and delete an index field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$index_field = 'test_integer';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $index_field,\n\t'IndexFieldType' =&gt; 'uint',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe index fields\n\necho &quot;# Describing the CloudSearch index fields, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_index_fields($domain_name);\n\nprint_r($response-&gt;body-&gt;IndexFieldName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Index documents\n\necho &quot;# Indexing documents, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;index_documents($domain_name);\n\nprint_r($response-&gt;body-&gt;member()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete index fields\n\necho '# Deleting the CloudSearch index field...' . PHP_EOL;\n$response = $search-&gt;delete_index_field($domain_name, $index_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch index field was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_rank_expressions","modifier":"public","description":"<p>Gets the rank expressions configured for the search domain. Can be limited to specific rank\nexpressions by name. Shows all rank expressions by default.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>RankNames<\/code> - <code>string|array<\/code> - Optional - Limits the <code>DescribeRankExpressions<\/code> response to the specified fields. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_rank_expressions($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['RankNames']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'RankNames' =&gt; (is_array($opt['RankNames']) ? $opt['RankNames'] : array($opt['RankNames']))\n        ), 'member'));\n        unset($opt['RankNames']);\n    }\n\n    return $this-&gt;authenticate('DescribeRankExpressions', $opt);\n}","examples":{"example":{"title":"<p>Create and delete a rank expression.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$rank_expression = 'test_expression';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define rank expressions\n\necho '# Defining a new CloudSearch rank expression' . PHP_EOL;\n$response = $search-&gt;define_rank_expression($domain_name, array(\n\t'RankName' =&gt; $rank_expression,\n\t'RankExpression' =&gt; '(0.7*text_relevance)',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined a rank expression...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe rank expressions\n\necho &quot;# Describing the CloudSearch rank expressions, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_rank_expressions($domain_name);\n\nprint_r($response-&gt;body-&gt;RankName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete rank expressions\n\necho '# Deleting the CloudSearch rank expression...' . PHP_EOL;\n$response = $search-&gt;delete_rank_expression($domain_name, $rank_expression);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch rank expression was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_service_access_policies","modifier":"public","description":"<p>Gets information about the resource-based policies that control access to the domain&#8217;s document\nand search services.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_service_access_policies($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DescribeServiceAccessPolicies', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the service access policies.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update service access policies\n\nsleep(1);\n\necho &quot;# Update the service access policies, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_service_access_policies($domain_name, '{my-policy}');\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the service access policies...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe service access policies\n\necho &quot;# Describing the service access policies, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_service_access_policies($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Described the service access policies...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_stemming_options","modifier":"public","description":"<p>Gets the stemming dictionary configured for the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_stemming_options($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DescribeStemmingOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the stemming options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$stemming_options = '{&quot;stems&quot;: {&quot;people&quot;: &quot;person&quot;, &quot;walking&quot;: &quot;walk&quot;}}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update stemming options\n\nsleep(1);\n\necho &quot;# Update the stemming options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_stemming_options($domain_name, $stemming_options);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the stemming options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe stemming options\n\necho &quot;# Describing the stemming options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_stemming_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_stopword_options","modifier":"public","description":"<p>Gets the stopwords configured for the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_stopword_options($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DescribeStopwordOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the stopword options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$stopwords = '{&quot;stopwords&quot;:[&quot;a&quot;, &quot;an&quot;, &quot;the&quot;, &quot;of&quot;]}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update stopword options\n\nsleep(1);\n\necho &quot;# Update the stopword options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_stopword_options($domain_name, $stopwords);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the stopword options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe stopword options\n\necho &quot;# Describing the stopword options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_stopword_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"describe_synonym_options","modifier":"public","description":"<p>Gets the synonym dictionary configured for the search domain.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_synonym_options($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('DescribeSynonymOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the synonym options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$synonyms = '{&quot;synonyms&quot;: {&quot;cat&quot;: [&quot;feline&quot;, &quot;kitten&quot;], &quot;puppy&quot;: &quot;dog&quot;}}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update synonym options\n\nsleep(1);\n\necho &quot;# Update the synonym options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_synonym_options($domain_name, $synonyms);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the synonym options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe synonym options\n\necho &quot;# Describing the synonym options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_synonym_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoncloudsearch\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"index_documents","modifier":"public","description":"<p>Tells the search domain to start indexing its documents using the latest text processing\noptions and <code>IndexFields<\/code>. This operation must be invoked to make options whose\n<code>OptionStatus<\/code> has <code>OptionState<\/code> of <code>RequiresIndexDocuments<\/code>\nvisible in search results.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function index_documents($domain_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    \n    return $this-&gt;authenticate('IndexDocuments', $opt);\n}","examples":{"example":{"title":"<p>Create and delete an index field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$index_field = 'test_integer';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $index_field,\n\t'IndexFieldType' =&gt; 'uint',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe index fields\n\necho &quot;# Describing the CloudSearch index fields, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_index_fields($domain_name);\n\nprint_r($response-&gt;body-&gt;IndexFieldName()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Index documents\n\necho &quot;# Indexing documents, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;index_documents($domain_name);\n\nprint_r($response-&gt;body-&gt;member()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete index fields\n\necho '# Deleting the CloudSearch index field...' . PHP_EOL;\n$response = $search-&gt;delete_index_field($domain_name, $index_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch index field was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazoncloudsearch\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazoncloudsearch\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"update_default_search_field","modifier":"public","description":"<p>Configures the default search field for the search domain. The default search field is used\nwhen a search request does not specify which fields to search. By default, it is configured to\ninclude the contents of all of the domain&#8217;s text fields.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"default_search_field","type":"string","description":"<p>The <code>IndexField<\/code> to use for search requests issued with the <code>q<\/code> parameter. The default is an empty string, which automatically searches all text fields.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_default_search_field($domain_name, $default_search_field, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['DefaultSearchField'] = $default_search_field;\n    \n    return $this-&gt;authenticate('UpdateDefaultSearchField', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the default search field.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$search_field = 'test_field';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Define index fields\n\necho '# Defining a new CloudSearch index field' . PHP_EOL;\n$response = $search-&gt;define_index_field($domain_name, array(\n\t'IndexFieldName' =&gt; $search_field,\n\t'IndexFieldType' =&gt; 'text',\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Defined an index field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update default search field\n\nsleep(1);\n\necho &quot;# Update the default search field, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_default_search_field($domain_name, $search_field);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the default search field...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe default search field\n\necho &quot;# Describing the default search field, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_default_search_field($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"update_service_access_policies","modifier":"public","description":"<p>Configures the policies that control access to the domain&#8217;s document and search services. The\nmaximum size of an access policy document is 100KB.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"access_policies","type":"string","description":"<p>An IAM access policy as described in <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?AccessPolicyLanguage.html\" target=\"_blank\">The Access Policy Language<\/a> in <em>Using AWS Identity and Access Management<\/em>. The maximum size of an access policy document is 100KB. Example: <code>{\"Statement\": [{\"Effect\":\"Allow\", \"Action\": \"<em>\", \"Resource\": \"arn:aws:cs:us-east-1:1234567890:search\/movies\", \"Condition\": { \"IpAddress\": { aws:SourceIp\": [\"203.0.113.1\/32\"] } }}, {\"Effect\":\"Allow\", \"Action\": \"<\/em>\", \"Resource\": \"arn:aws:cs:us-east-1:1234567890:documents\/movies\", \"Condition\": { \"IpAddress\": { aws:SourceIp\": [\"203.0.113.1\/32\"] } }} ]}<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_service_access_policies($domain_name, $access_policies, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['AccessPolicies'] = $access_policies;\n    \n    return $this-&gt;authenticate('UpdateServiceAccessPolicies', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the service access policies.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update service access policies\n\nsleep(1);\n\necho &quot;# Update the service access policies, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_service_access_policies($domain_name, '{my-policy}');\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the service access policies...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe service access policies\n\necho &quot;# Describing the service access policies, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_service_access_policies($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Described the service access policies...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"update_stemming_options","modifier":"public","description":"<p>Configures a stemming dictionary for the search domain. The stemming dictionary is used during\nindexing and when processing search requests. The maximum size of the stemming dictionary is\n500KB.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"stems","type":"string","description":"<p>Maps terms to their stems, serialized as a JSON document. The document has a single object with one property &#8220;stems&#8221; whose value is an object mapping terms to their stems. The maximum size of a stemming document is 500KB. Example: <code>{ \"stems\": {\"people\": \"person\", \"walking\": \"walk\"} }<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_stemming_options($domain_name, $stems, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['Stems'] = $stems;\n    \n    return $this-&gt;authenticate('UpdateStemmingOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the stemming options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$stemming_options = '{&quot;stems&quot;: {&quot;people&quot;: &quot;person&quot;, &quot;walking&quot;: &quot;walk&quot;}}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update stemming options\n\nsleep(1);\n\necho &quot;# Update the stemming options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_stemming_options($domain_name, $stemming_options);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the stemming options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe stemming options\n\necho &quot;# Describing the stemming options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_stemming_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"update_stopword_options","modifier":"public","description":"<p>Configures stopwords for the search domain. Stopwords are used during indexing and when\nprocessing search requests. The maximum size of the stopwords dictionary is 10KB.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"stopwords","type":"string","description":"<p>Lists stopwords serialized as a JSON document. The document has a single object with one property &#8220;stopwords&#8221; whose value is an array of strings. The maximum size of a stopwords document is 10KB. Example: <code>{ \"stopwords\": [\"a\", \"an\", \"the\", \"of\"] }<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_stopword_options($domain_name, $stopwords, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['Stopwords'] = $stopwords;\n    \n    return $this-&gt;authenticate('UpdateStopwordOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the stopword options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$stopwords = '{&quot;stopwords&quot;:[&quot;a&quot;, &quot;an&quot;, &quot;the&quot;, &quot;of&quot;]}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update stopword options\n\nsleep(1);\n\necho &quot;# Update the stopword options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_stopword_options($domain_name, $stopwords);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the stopword options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe stopword options\n\necho &quot;# Describing the stopword options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_stopword_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}},{"name":"update_synonym_options","modifier":"public","description":"<p>Configures a synonym dictionary for the search domain. The synonym dictionary is used during\nindexing to configure mappings for terms that occur in text fields. The maximum size of the\nsynonym dictionary is 100KB.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"domain_name","type":"string","description":"<p>A string that represents the name of a domain. Domain names must be unique across the domains owned by an account within an AWS region. Domain names must start with a letter or number and can contain the following characters: a-z (lowercase), 0-9, and - (hyphen). Uppercase letters and underscores are not allowed. [Constraints: The value must be between 3 and 28 characters, and must match the following regular expression pattern: <code>[a-z][a-z0-9&#45;]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"synonyms","type":"string","description":"<p>Maps terms to their synonyms, serialized as a JSON document. The document has a single object with one property &#8220;synonyms&#8221; whose value is an object mapping terms to their synonyms. Each synonym is a simple string or an array of strings. The maximum size of a stopwords document is 100KB. Example: <code>{ \"synonyms\": {\"cat\": [\"feline\", \"kitten\"], \"puppy\": \"dog\"} }<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_synonym_options($domain_name, $synonyms, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DomainName'] = $domain_name;\n    $opt['Synonyms'] = $synonyms;\n    \n    return $this-&gt;authenticate('UpdateSynonymOptions', $opt);\n}","examples":{"example":{"title":"<p>Update and describe the synonym options.<\/p>","code":"\/\/ Instantiate the class\n$search = new AmazonCloudSearch();\n\n$domain_name = 'my-domain';\n$synonyms = '{&quot;synonyms&quot;: {&quot;cat&quot;: [&quot;feline&quot;, &quot;kitten&quot;], &quot;puppy&quot;: &quot;dog&quot;}}';\n\n\/*%**************************************************************%*\/\n\/\/ Create a new CloudSearch domain\n\necho '# Creating a new CloudSearch domain' . PHP_EOL;\n$response = $search-&gt;create_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Kicked off the creation of the CloudSearch domain...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Update synonym options\n\nsleep(1);\n\necho &quot;# Update the synonym options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;update_synonym_options($domain_name, $synonyms);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updated the synonym options...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Describe synonym options\n\necho &quot;# Describing the synonym options, \\&quot;${domain_name}\\&quot;&quot; . PHP_EOL;\n$response = $search-&gt;describe_synonym_options($domain_name);\n\nprint_r($response-&gt;body-&gt;Options()-&gt;map_string());\n\necho PHP_EOL;\n\n\/*%**************************************************************%*\/\n\/\/ Delete the CloudSearch domain\n\necho '# Deleting the CloudSearch domain...' . PHP_EOL;\n$response = $search-&gt;delete_domain($domain_name);\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'CloudSearch domain was deleted successfully.' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}"}}}]},"constants":{"@attributes":{"count":"7"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"cloudsearch.us-east-1.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_US_E1","value":"cloudsearch.us-east-1.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"cloudsearch.us-east-1.amazonaws.com"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazoncloudsearch\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoncloudsearch\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}