{"file":{},"class":{"name":"AmazonDynamoDB","file":"services\/dynamodb.class.php","url":"..\/amazondynamodb\/index.html","description":"<p>Amazon DynamoDB is a fast, highly scalable, highly available, cost-effective non-relational\ndatabase service.<\/p>\n\n<p>Amazon DynamoDB removes traditional scalability limitations on data storage while maintaining\nlow latency and predictable performance.<\/p>","metadata":{"version":"2013.01.14","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/dynamodb\/ Amazon DynamoDB","http:\/\/aws.amazon.com\/dynamodb\/documentation\/ Amazon DynamoDB documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"49"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazondynamodb\/index.html\" rel=\"..\/..\/index.html#i=amazondynamodb\"><code>AmazonDynamoDB<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazondynamodb\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2011-12-05';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV4JSON';\n    $this-&gt;operation_prefix = 'x-amz-target:DynamoDB_20111205.';\n\n    parent::__construct($options);\n}"},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazondynamodb\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazondynamodb\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazondynamodb\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"attribute","modifier":"public","description":"<p>Formats a value into the DynamoDB attribute value format (e.g. <code>array('S' => 'value')<\/code> ).<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"value","type":"mixed","description":"<p>The value to be formatted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"format","type":"string","description":"<p>The format of the result (based loosely on the type of operation)<\/p>"},{"@attributes":{"choice":"opt"},"name":"type_override","type":"string","description":"<p>Any valid attribute type to override the calculated type.<\/p>"}]},"returnvalue":"<p>An attribute value suitable for DynamoDB.<\/p>","source":"public function attribute($value, $format = 'put', $type_override = null)\n{\n    $info = $this-&gt;get_attribute_value_info($value);\n\n    if (!$info)\n    {\n        return null;\n    }\n\n    if ($type_override)\n    {\n        static $valid_types = array(\n            self::TYPE_STRING,\n            self::TYPE_NUMBER,\n            self::TYPE_BINARY,\n            self::TYPE_STRING_SET,\n            self::TYPE_NUMBER_SET,\n            self::TYPE_BINARY_SET,\n        );\n\n        $info['type'] = in_array($type_override, $valid_types) ? $type_override : $info['type'];\n    }\n\n    $result = array($info['type'] =&gt; $info['value']);\n\n    \/\/ In some cases the result needs to be wrapped with &quot;Value&quot;\n    if ($format === 'update' || $format === 'expected')\n    {\n        $result = array('Value' =&gt; $result);\n    }\n\n    return $result;\n}","examples":{"example":[{"title":"<p>Marshal values into DynamoDB-ready formats (single values)<\/p>","code":"\/\/ Instantiate the class\n$ddb = new AmazonDynamoDB();\n\n$attribute1 = $ddb-&gt;attribute('foo');\n$attribute2 = $ddb-&gt;attribute(1);\n$attribute3 = $ddb-&gt;attribute(array('foo', 'bar', 'baz'));\n$attribute4 = $ddb-&gt;attribute(array(1, 2, 3));\n\nvar_dump($attribute1, $attribute2, $attribute3, $attribute4);","result":"array(1) {\n  [\"S\"]=&gt;\n  string(3) \"foo\"\n}\narray(1) {\n  [\"N\"]=&gt;\n  string(1) \"1\"\n}\narray(1) {\n  [\"SS\"]=&gt;\n  array(3) {\n    [0]=&gt;\n    string(3) \"foo\"\n    [1]=&gt;\n    string(3) \"bar\"\n    [2]=&gt;\n    string(3) \"baz\"\n  }\n}\narray(1) {\n  [\"NS\"]=&gt;\n  array(3) {\n    [0]=&gt;\n    string(1) \"1\"\n    [1]=&gt;\n    string(1) \"2\"\n    [2]=&gt;\n    string(1) \"3\"\n  }\n}"},{"title":"<p>Marshal attribute values into DynamoDB-ready formats (single value for update)<\/p>","code":"\/\/ Instantiate the class\n$ddb = new AmazonDynamoDB();\n\n$attribute1 = $ddb-&gt;attribute(1, 'put');\n$attribute2\t= $ddb-&gt;attribute(1, 'update');\n\nvar_dump($attribute1, $attribute2);","result":"array(1) {\n  [\"N\"]=&gt;\n  string(1) \"1\"\n}\narray(1) {\n  [\"Value\"]=&gt;\n  array(1) {\n    [\"N\"]=&gt;\n    string(1) \"1\"\n  }\n}"}]}},{"name":"attributes","modifier":"public","description":"<p>Formats a set of values into the DynamoDB attribute value format.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"values","type":"array","description":"<p>The values to be formatted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"format","type":"string","description":"<p>The format of the result (based loosely on the type of operation)<\/p>"}]},"returnvalue":"<p>The formatted array.<\/p>","source":"public function attributes(array $values, $format = 'put')\n{\n    $results = array();\n\n    foreach ($values as $key =&gt; $value)\n    {\n        $results[$key] = $this-&gt;attribute($value, $format);\n    }\n\n    $results = array_filter($results);\n\n    return $results;\n}","examples":{"example":{"title":"<p>Marshal values into DynamoDB-ready formats (arrays of values)<\/p>","code":"\/\/ Instantiate the class\n$ddb = new AmazonDynamoDB();\n\n$data = array(\n\t'id'      =&gt; 15,\n\t'title'   =&gt; 'Foobaring Foo Bar for Foo',\n\t'author'  =&gt; 'Dr. Foo B. Baz',\n\t'tags'    =&gt; array('foo', 'bar', 'baz'),\n\t'links'   =&gt; array(),\n);\n\n\/\/ Format for put_item\n$attributes1 = $ddb-&gt;attributes($data);\n\n\/\/ Format for update_item\n$attributes2 = $ddb-&gt;attributes($data, 'update');\n\nvar_dump($attributes1, $attributes2);","result":"array(4) {\n  [\"id\"]=&gt;\n  array(1) {\n    [\"N\"]=&gt;\n    string(2) \"15\"\n  }\n  [\"title\"]=&gt;\n  array(1) {\n    [\"S\"]=&gt;\n    string(25) \"Foobaring Foo Bar for Foo\"\n  }\n  [\"author\"]=&gt;\n  array(1) {\n    [\"S\"]=&gt;\n    string(14) \"Dr. Foo B. Baz\"\n  }\n  [\"tags\"]=&gt;\n  array(1) {\n    [\"SS\"]=&gt;\n    array(3) {\n      [0]=&gt;\n      string(3) \"foo\"\n      [1]=&gt;\n      string(3) \"bar\"\n      [2]=&gt;\n      string(3) \"baz\"\n    }\n  }\n}\narray(4) {\n  [\"id\"]=&gt;\n  array(1) {\n    [\"Value\"]=&gt;\n    array(1) {\n      [\"N\"]=&gt;\n      string(2) \"15\"\n    }\n  }\n  [\"title\"]=&gt;\n  array(1) {\n    [\"Value\"]=&gt;\n    array(1) {\n      [\"S\"]=&gt;\n      string(25) \"Foobaring Foo Bar for Foo\"\n    }\n  }\n  [\"author\"]=&gt;\n  array(1) {\n    [\"Value\"]=&gt;\n    array(1) {\n      [\"S\"]=&gt;\n      string(14) \"Dr. Foo B. Baz\"\n    }\n  }\n  [\"tags\"]=&gt;\n  array(1) {\n    [\"Value\"]=&gt;\n    array(1) {\n      [\"SS\"]=&gt;\n      array(3) {\n        [0]=&gt;\n        string(3) \"foo\"\n        [1]=&gt;\n        string(3) \"bar\"\n        [2]=&gt;\n        string(3) \"baz\"\n      }\n    }\n  }\n}"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"batch_get_item","modifier":"public","description":"<p>Retrieves the attributes for multiple items from multiple tables using their primary keys.<\/p>\n\n<p>The maximum number of item attributes that can be retrieved for a single operation is 100.\nAlso, the number of items retrieved is constrained by a 1 MB the size limit. If the response\nsize limit is exceeded or a partial result is returned due to an internal processing failure,\nAmazon DynamoDB returns an <code>UnprocessedKeys<\/code> value so you can retry the operation\nstarting with the next item to get.<\/p>\n\n<p>Amazon DynamoDB automatically adjusts the number of items returned per page to enforce this\nlimit. For example, even if you ask to retrieve 100 items, but each individual item is 50k in\nsize, the system returns 20 items and an appropriate <code>UnprocessedKeys<\/code> value so you\ncan get the next page of results. If necessary, your application needs its own logic to\nassemble the pages of results into one set.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>RequestItems<\/code> - <code>array<\/code> - Required - A map of the table name and corresponding items to get by primary key. While requesting items, each table name can be invoked only once per operation. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - This key is variable (e.g., user-specified). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>] <ul><li><code>Keys<\/code> - <code>array<\/code> - Required - The primary key that uniquely identifies each item in a table. A primary key can be a one attribute (hash) primary key or a two attribute (hash-and-range) primary key. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>AttributesToGet<\/code> - <code>string|array<\/code> - Optional - List of <code>Attribute<\/code> names. If attribute names are not specified then all attributes will be returned. If some attributes are not found, they will not appear in the result. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>ConsistentRead<\/code> - <code>boolean<\/code> - Optional - If set to <code>true<\/code>, then a consistent read is issued. Otherwise eventually-consistent is used.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function batch_get_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('BatchGetItem', $opt);\n}","examples":{"example":[{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Set up batch requests\n$queue = new CFBatchRequest();\n$queue-&gt;use_credentials($dynamodb-&gt;credentials);\n\n\/\/ Add items to the batch\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value1',\n\t\t'key2'          =&gt; 'value2',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&aring;&eacute;&icirc;&oslash;&uuml;'\n\t))\n));\n\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value3',\n\t\t'key2'          =&gt; 'value4',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&icirc;&oslash;&uuml;&aring;&eacute;'\n\t))\n));\n\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value5',\n\t\t'key2'          =&gt; 'value6',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&uuml;&oslash;&icirc;&eacute;&aring;'\n\t))\n));\n\n\/\/ Execute the batch of requests in parallel\n$responses = $dynamodb-&gt;batch($queue)-&gt;send();\n\n\/\/ Check for success...\nif ($responses-&gt;areOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($responses);\n}\n\n####################################################################\n# Getting multiple items\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting multiple items from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;batch_get_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\t'Keys' =&gt; array( \/\/ Key #1\n\t\t\t\t$dynamodb-&gt;attributes(array(\n\t\t\t\t\t'HashKeyElement'  =&gt; 1,\n\t\t\t\t\t'RangeKeyElement' =&gt; $current_time,\n\t\t\t\t)),\n\t\t\t\t$dynamodb-&gt;attributes(array( \/\/ Key #2\n\t\t\t\t\t'HashKeyElement'  =&gt; 2,\n\t\t\t\t\t'RangeKeyElement' =&gt; $current_time,\n\t\t\t\t)),\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tsleep(5);\n\n\t\/\/ Collect the values we want to show\n\t$result = array();\n\tforeach ($response-&gt;body-&gt;Responses-&gt;{$table_name}-&gt;Items as $item)\n\t{\n\t\t$result[] = array(\n\t\t\t'id'            =&gt; (string) $item-&gt;{'id'}-&gt;{AmazonDynamoDB::TYPE_NUMBER},\n\t\t\t'date'          =&gt; (string) $item-&gt;{'date'}-&gt;{AmazonDynamoDB::TYPE_NUMBER},\n\t\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; (string) $item-&gt;{'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l'}-&gt;{AmazonDynamoDB::TYPE_STRING},\n\t\t);\n\t}\n\n\t\/\/ Output\n\tprint_r($result);\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"},{"title":"<p>Handle retrieved NULL bytes.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER,\n\t\t),\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 10,\n\t\t'WriteCapacityUnits' =&gt; 5,\n\t),\n));\n\nvar_dump($response-&gt;isOK());\n\nif (!$response-&gt;isOK())\n{\n\tdie('Table creation failed.');\n}\n\n\/\/ Sleep and poll during table creation\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\n####################################################################\n# Add data containing a NULL byte to the table\n\n\/\/ Create a class with a private\/protected member\nclass Dummy\n{\n\tprivate   $private_prop   = 'private';\n\tprotected $protected_prop = 'private';\n\tpublic    $public_prop    = 'public';\n}\n\n\/\/ Store the serialized PHP class in DynamoDB\n$response = $dynamodb-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id' =&gt; 1,\n\t\t'data' =&gt; serialize(new Dummy)\n\t))\n));\n\nvar_dump($response-&gt;isOK());\n\nsleep(1);\n\n####################################################################\n# Getting an item\n\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\tAmazonDynamoDB::TYPE_NUMBER =&gt; '1'\n\t\t),\n\t),\n));\n\nvar_dump($response-&gt;isOK());\n\n\/\/ Read back the serialized data. Decode it during stringification, or force it with to_string().\n$dummy = unserialize($response-&gt;body-&gt;Item-&gt;data-&gt;{AmazonDynamoDB::TYPE_STRING}-&gt;to_string());\n\n\/\/ Output the public value\nvar_dump($dummy-&gt;public_prop);\n\n####################################################################\n# Deleting the table\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nvar_dump($response-&gt;isOK());\n\n\/\/ Sleep and poll until table is deleted\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);","result":"bool(true)\nbool(true)\nbool(true)\nstring(6) \"public\"\nbool(true)"}]}},{"name":"batch_write_item","modifier":"public","description":"<p>Allows to execute a batch of Put and\/or Delete Requests for many tables in a single call. A\ntotal of 25 requests are allowed.<\/p>\n\n<p>There are no transaction guarantees provided by this API. It does not allow conditional puts\nnor does it support return values.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>RequestItems<\/code> - <code>array<\/code> - Required - A map of table name to list-of-write-requests. Used as input to the <code>BatchWriteItem<\/code> API call <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - This key is variable (e.g., user-specified). <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>PutRequest<\/code> - <code>array<\/code> - Optional - A container for a Put BatchWrite request <ul><li><code>Item<\/code> - <code>array<\/code> - Required - The item to put <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - AttributeValue can be <code>String<\/code>, <code>Number<\/code>, <code>Binary<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>, <code>BinarySet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>DeleteRequest<\/code> - <code>array<\/code> - Optional - A container for a Delete BatchWrite request <ul><li><code>Key<\/code> - <code>array<\/code> - Required - The item&#8217;s key to be delete <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>value<\/code> - <code>array<\/code> - Optional - AttributeValue can be <code>String<\/code>, <code>Number<\/code>, <code>Binary<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>, <code>BinarySet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function batch_write_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('BatchWriteItem', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table-' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Getting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('id', 'date', 'key1', 'key2', 'key3'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Updating an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating an item from the table...&quot; . PHP_EOL;\n\n\/\/ Updating an item\n$response = $dynamodb-&gt;update_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributeUpdates' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING =&gt; 'updated-value1')\n\t\t),\n\t\t'key2' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_DELETE\n\t\t),\n\t\t'key3' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_ADD,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING_SET =&gt; array('sub-value3'))\n\t\t),\n\t\t'key4' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; $dynamodb-&gt;binary('binary-value')\n\t\t),\n\t),\n\t'Expected' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Value' =&gt; array( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updating the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Checking the binary result\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('key4'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key4-&gt;{AmazonDynamoDB::TYPE_BINARY});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Deleting an item\n$response = $dynamodb-&gt;delete_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 1, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Deleting the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\techo '.';\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"binary","modifier":"public","description":"<p>A shortcut\/factory-type method for indicating a DynamoDB binary type. Binary types are\nlike strings but get base64 encoded automatically. The DynamoDB service decodes these\nvalues and stores them in the raw format. This allows the transfer of binary data to\nDynamoDB without the extra storage costs of the base64 encoding inflation.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"value","type":"string","description":"<p>The value to be converted to a binary type<\/p>"}},"returnvalue":{"@attributes":{"type":"DynamoDB_Binary"}},"source":"public function binary($value)\n{\n    return new DynamoDB_Binary($value);\n}"},{"name":"binary_set","modifier":"public","description":"<p>A shortcut\/factory-type method for indicating a DynamoDB binary set type.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"values","type":"array","description":"<p>The values to be converted to a binary set.<\/p>"}},"returnvalue":{"@attributes":{"type":"DynamoDB_BinarySet"}},"source":"public function binary_set($values)\n{\n    if (is_scalar($values))\n    {\n        $values = func_get_args();\n    }\n\n    return new DynamoDB_BinarySet($values);\n}"},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazondynamodb\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"create_table","modifier":"public","description":"<p>Adds a new table to your account.<\/p>\n\n<p>The table name must be unique among those associated with the AWS Account issuing the request,\nand the AWS Region that receives the request (e.g. <code>us-east-1<\/code>).<\/p>\n\n<p>The <code>CreateTable<\/code> operation triggers an asynchronous workflow to begin creating the\ntable. Amazon DynamoDB immediately returns the state of the table (<code>CREATING<\/code>) until\nthe table is in the <code>ACTIVE<\/code> state. Once the table is in the <code>ACTIVE<\/code>\nstate, you can perform data plane operations.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table you want to create. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>KeySchema<\/code> - <code>array<\/code> - Required - The KeySchema identifies the primary key as a one attribute primary key (hash) or a composite two attribute (hash-and-range) primary key. Single attribute primary keys have one index value: a <code>HashKeyElement<\/code>. A composite hash-and-range primary key contains two attribute values: a <code>HashKeyElement<\/code> and a <code>RangeKeyElement<\/code>. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>AttributeName<\/code> - <code>string<\/code> - Required - The <code>AttributeName<\/code> of the <code>KeySchemaElement<\/code>.<\/li><li><code>AttributeType<\/code> - <code>string<\/code> - Required - The <code>AttributeType<\/code> of the <code>KeySchemaElement<\/code> which can be a <code>String<\/code> or a <code>Number<\/code>. [Allowed values: <code>S<\/code>, <code>N<\/code>, <code>B<\/code>]<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>AttributeName<\/code> - <code>string<\/code> - Required - The <code>AttributeName<\/code> of the <code>KeySchemaElement<\/code>.<\/li><li><code>AttributeType<\/code> - <code>string<\/code> - Required - The <code>AttributeType<\/code> of the <code>KeySchemaElement<\/code> which can be a <code>String<\/code> or a <code>Number<\/code>. [Allowed values: <code>S<\/code>, <code>N<\/code>, <code>B<\/code>]<\/li><\/ul><\/li><\/ul><\/li><li><code>ProvisionedThroughput<\/code> - <code>array<\/code> - Required - Provisioned throughput reserves the required read and write resources for your table in terms of <code>ReadCapacityUnits<\/code> and <code>WriteCapacityUnits<\/code>. Values for provisioned throughput depend upon your expected read\/write rates, item size, and consistency. Provide the expected number of read and write operations, assuming an item size of 1k and strictly consistent reads. For 2k item size, double the value. For 3k, triple the value, etc. Eventually-consistent reads consume half the resources of strictly consistent reads. <ul><li><code>ReadCapacityUnits<\/code> - <code>long<\/code> - Required - <code>ReadCapacityUnits<\/code> are in terms of strictly consistent reads, assuming items of 1k. 2k items require twice the <code>ReadCapacityUnits<\/code>. Eventually-consistent reads only require half the <code>ReadCapacityUnits<\/code> of stirctly consistent reads.<\/li><li><code>WriteCapacityUnits<\/code> - <code>long<\/code> - Required - <code>WriteCapacityUnits<\/code> are in terms of strictly consistent reads, assuming items of 1k. 2k items require twice the <code>WriteCapacityUnits<\/code>.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_table($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CreateTable', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'ID',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'Date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Collect all table names in the account\n\necho PHP_EOL . PHP_EOL;\necho '# Collecting a complete list of tables in the account...' . PHP_EOL;\n\n$response = $dynamodb-&gt;list_tables();\nprint_r($response-&gt;body-&gt;TableNames-&gt;to_array()-&gt;getArrayCopy());\n\n####################################################################\n# Describe a specific table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Describing the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nprint_r($response-&gt;body);\n\n####################################################################\n# Updating the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$dynamodb-&gt;update_table(array(\n\t'TableName' =&gt; $table_name,\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 400,\n\t\t'WriteCapacityUnits' =&gt; 400\n\t)\n));\n\n$table_status = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($table_status-&gt;isOK())\n{\n\tprint_r($table_status-&gt;body-&gt;Table-&gt;ProvisionedThroughput-&gt;to_array()-&gt;getArrayCopy());\n}\nelse\n{\n\tprint_r($table_status);\n}\n\n####################################################################\n# Sleep and poll until the table has been updated.\n\n$count = 0;\ndo {\n\tsleep(5);\n\t$count += 5;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been updated (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_item","modifier":"public","description":"<p>Deletes a single item in a table by primary key.<\/p>\n\n<p>You can perform a conditional delete operation that deletes the item if it exists, or if it has\nan expected attribute value.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to delete an item. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>Key<\/code> - <code>array<\/code> - Required - The primary key that uniquely identifies each item in a table. A primary key can be a one attribute (hash) primary key or a two attribute (hash-and-range) primary key. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>Expected<\/code> - <code>array<\/code> - Optional - Designates an attribute for a conditional modification. The <code>Expected<\/code> parameter allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute has a particular value before modifying it. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - Allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute value already exists; or if the attribute value exists and has a particular value before changing it. <ul><li><code>Value<\/code> - <code>array<\/code> - Optional - Specify whether or not a value already exists and has a specific content for the attribute name-value pair. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>Exists<\/code> - <code>boolean<\/code> - Optional - Specify whether or not a value already exists for the attribute name-value pair.<\/li><\/ul><\/li><\/ul><\/li><li><code>ReturnValues<\/code> - <code>string<\/code> - Optional - Use this parameter if you want to get the attribute name-value pairs before or after they are modified. For <code>PUT<\/code> operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>. For update operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code> or <code>UPDATED_NEW<\/code>.<ul><li> <code>NONE<\/code>: Nothing is returned.<\/li><li> <code>ALL_OLD<\/code>: Returns the attributes of the item as they were before the operation.<\/li><li> <code>UPDATED_OLD<\/code>: Returns the values of the updated attributes, only, as they were before the operation.<\/li><li> <code>ALL_NEW<\/code>: Returns all the attributes and their new values after the operation.<\/li><li> <code>UPDATED_NEW<\/code>: Returns the values of the updated attributes, only, as they are after the operation.<\/li><\/ul> [Allowed values: <code>NONE<\/code>, <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code>, <code>UPDATED_NEW<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteItem', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table-' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Getting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('id', 'date', 'key1', 'key2', 'key3'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Updating an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating an item from the table...&quot; . PHP_EOL;\n\n\/\/ Updating an item\n$response = $dynamodb-&gt;update_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributeUpdates' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING =&gt; 'updated-value1')\n\t\t),\n\t\t'key2' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_DELETE\n\t\t),\n\t\t'key3' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_ADD,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING_SET =&gt; array('sub-value3'))\n\t\t),\n\t\t'key4' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; $dynamodb-&gt;binary('binary-value')\n\t\t),\n\t),\n\t'Expected' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Value' =&gt; array( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updating the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Checking the binary result\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('key4'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key4-&gt;{AmazonDynamoDB::TYPE_BINARY});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Deleting an item\n$response = $dynamodb-&gt;delete_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 1, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Deleting the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\techo '.';\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"delete_table","modifier":"public","description":"<p>Deletes a table and all of its items.<\/p>\n\n<p>If the table is in the <code>ACTIVE<\/code> state, you can delete it. If a table is in\n<code>CREATING<\/code> or <code>UPDATING<\/code> states then Amazon DynamoDB returns a\n<code>ResourceInUseException<\/code>. If the specified table does not exist, Amazon DynamoDB\nreturns a <code>ResourceNotFoundException<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table you want to delete. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_table($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteTable', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'ID',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'Date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Collect all table names in the account\n\necho PHP_EOL . PHP_EOL;\necho '# Collecting a complete list of tables in the account...' . PHP_EOL;\n\n$response = $dynamodb-&gt;list_tables();\nprint_r($response-&gt;body-&gt;TableNames-&gt;to_array()-&gt;getArrayCopy());\n\n####################################################################\n# Describe a specific table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Describing the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nprint_r($response-&gt;body);\n\n####################################################################\n# Updating the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$dynamodb-&gt;update_table(array(\n\t'TableName' =&gt; $table_name,\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 400,\n\t\t'WriteCapacityUnits' =&gt; 400\n\t)\n));\n\n$table_status = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($table_status-&gt;isOK())\n{\n\tprint_r($table_status-&gt;body-&gt;Table-&gt;ProvisionedThroughput-&gt;to_array()-&gt;getArrayCopy());\n}\nelse\n{\n\tprint_r($table_status);\n}\n\n####################################################################\n# Sleep and poll until the table has been updated.\n\n$count = 0;\ndo {\n\tsleep(5);\n\t$count += 5;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been updated (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"describe_table","modifier":"public","description":"<p>Retrieves information about the table, including the current status of the table, the primary\nkey schema and when the table was created.<\/p>\n\n<p>If the table does not exist, Amazon DynamoDB returns a <code>ResourceNotFoundException<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table you want to describe. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_table($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeTable', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'ID',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'Date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Collect all table names in the account\n\necho PHP_EOL . PHP_EOL;\necho '# Collecting a complete list of tables in the account...' . PHP_EOL;\n\n$response = $dynamodb-&gt;list_tables();\nprint_r($response-&gt;body-&gt;TableNames-&gt;to_array()-&gt;getArrayCopy());\n\n####################################################################\n# Describe a specific table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Describing the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nprint_r($response-&gt;body);\n\n####################################################################\n# Updating the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$dynamodb-&gt;update_table(array(\n\t'TableName' =&gt; $table_name,\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 400,\n\t\t'WriteCapacityUnits' =&gt; 400\n\t)\n));\n\n$table_status = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($table_status-&gt;isOK())\n{\n\tprint_r($table_status-&gt;body-&gt;Table-&gt;ProvisionedThroughput-&gt;to_array()-&gt;getArrayCopy());\n}\nelse\n{\n\tprint_r($table_status);\n}\n\n####################################################################\n# Sleep and poll until the table has been updated.\n\n$count = 0;\ndo {\n\tsleep(5);\n\t$count += 5;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been updated (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazondynamodb\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"get_attribute_value_info","modifier":"protected","description":"<p>An internal, recursive function for doing the attribute value formatting.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"value","type":"mixed","description":"<p>The value being formatted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"depth","type":"integer","description":"<p>The current recursion level. Anything higher than one will terminate the function.<\/p>"}]},"returnvalue":"<p>An array of information about the attribute value, including it&#8217;s string value and type.<\/p>","source":"protected function get_attribute_value_info($value, $depth = 0)\n{\n    \/\/ If the recursion limit is succeeded, then the value is invalid\n    if ($depth &gt; 1)\n    {\n        return null;\n    }\n\n    \/\/ Handle objects (including DynamoDB Binary types)\n    if (is_object($value))\n    {\n        if ($value instanceof DynamoDB_Binary || $value instanceof DynamoDB_BinarySet)\n        {\n            $type = ($value instanceof DynamoDB_Binary) ? self::TYPE_BINARY : self::TYPE_BINARY_SET;\n            return array(\n                'value' =&gt; $value-&gt;{$type},\n                'type'  =&gt; $type\n            );\n        }\n        elseif ($value instanceof Traversable)\n        {\n            $value = iterator_to_array($value);\n        }\n        elseif (method_exists($value, '__toString'))\n        {\n            $value = (string) $value;\n        }\n        else\n        {\n            return null;\n        }\n    }\n\n    \/\/ Handle empty values (zeroes are OK though) and resources\n    if ($value === null || $value === array() || $value === '' || is_resource($value))\n    {\n        return null;\n    }\n\n    \/\/ Create the attribute value info\n    $info = array();\n\n    \/\/ Handle boolean values\n    if (is_bool($value))\n    {\n        $info['type'] = self::TYPE_NUMBER;\n        $info['value'] = $value ? '1' : '0';\n    }\n    \/\/ Handle numeric values\n    elseif (is_int($value) || is_float($value))\n    {\n        $info['type'] = self::TYPE_NUMBER;\n        $info['value'] = (string) $value;\n    }\n    \/\/ Handle arrays\n    elseif (is_array($value))\n    {\n        $set_type = null;\n        $info['value'] = array();\n\n        \/\/ Loop through each value to analyze and prepare it\n        foreach ($value as $sub_value)\n        {\n            \/\/ Recursively get the info for this sub-value. The depth param only allows one level of recursion\n            $sub_info = $this-&gt;get_attribute_value_info($sub_value, $depth + 1);\n\n            \/\/ If a sub-value is invalid, the whole array is invalid as well\n            if ($sub_info === null)\n            {\n                return null;\n            }\n\n            \/\/ The type of each sub-value must be the same, or else the whole array is invalid\n            if ($set_type === null)\n            {\n                $set_type = $sub_info['type'];\n            }\n            elseif ($set_type !== $sub_info['type'])\n            {\n                return null;\n            }\n\n            \/\/ Save the value for the upstream array\n            $info['value'][] = $sub_info['value'];\n        }\n\n        \/\/ Make sure the type is changed to be the appropriate array\/set type\n        $info['type'] = $set_type . self::SUFFIX_FOR_TYPES;\n    }\n    \/\/ Handle strings\n    else\n    {\n        $info = array('value' =&gt; (string) $value, 'type' =&gt; self::TYPE_STRING);\n    }\n\n    return $info;\n}"},{"name":"get_item","modifier":"public","description":"<p>Retrieves a set of Attributes for an item that matches the primary key.<\/p>\n\n<p>The <code>GetItem<\/code> operation provides an eventually-consistent read by default. If\neventually-consistent reads are not acceptable for your application, use\n<code>ConsistentRead<\/code>. Although this operation might take longer than a standard read, it\nalways returns the last updated value.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to get an item. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>Key<\/code> - <code>array<\/code> - Required - The primary key that uniquely identifies each item in a table. A primary key can be a one attribute (hash) primary key or a two attribute (hash-and-range) primary key. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>AttributesToGet<\/code> - <code>string|array<\/code> - Optional - List of <code>Attribute<\/code> names. If attribute names are not specified then all attributes will be returned. If some attributes are not found, they will not appear in the result. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>ConsistentRead<\/code> - <code>boolean<\/code> - Optional - If set to <code>true<\/code>, then a consistent read is issued. Otherwise eventually-consistent is used.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['AttributesToGet']))\n    {\n        $opt['AttributesToGet'] = (is_array($opt['AttributesToGet']) ? $opt['AttributesToGet'] : array($opt['AttributesToGet']));\n    }\n\n    return $this-&gt;authenticate('GetItem', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table-' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Getting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('id', 'date', 'key1', 'key2', 'key3'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Updating an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating an item from the table...&quot; . PHP_EOL;\n\n\/\/ Updating an item\n$response = $dynamodb-&gt;update_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributeUpdates' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING =&gt; 'updated-value1')\n\t\t),\n\t\t'key2' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_DELETE\n\t\t),\n\t\t'key3' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_ADD,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING_SET =&gt; array('sub-value3'))\n\t\t),\n\t\t'key4' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; $dynamodb-&gt;binary('binary-value')\n\t\t),\n\t),\n\t'Expected' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Value' =&gt; array( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updating the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Checking the binary result\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('key4'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key4-&gt;{AmazonDynamoDB::TYPE_BINARY});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Deleting an item\n$response = $dynamodb-&gt;delete_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 1, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Deleting the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\techo '.';\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"list_tables","modifier":"public","description":"<p>Retrieves a paginated list of table names created by the AWS Account of the caller in the AWS\nRegion (e.g. <code>us-east-1<\/code>).<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ExclusiveStartTableName<\/code> - <code>string<\/code> - Optional - The name of the table that starts the list. If you already ran a <code>ListTables<\/code> operation and received a <code>LastEvaluatedTableName<\/code> value in the response, use that value here to continue the list. [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>Limit<\/code> - <code>integer<\/code> - Optional - A number of maximum table names to return.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_tables($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListTables', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'ID',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'Date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Collect all table names in the account\n\necho PHP_EOL . PHP_EOL;\necho '# Collecting a complete list of tables in the account...' . PHP_EOL;\n\n$response = $dynamodb-&gt;list_tables();\nprint_r($response-&gt;body-&gt;TableNames-&gt;to_array()-&gt;getArrayCopy());\n\n####################################################################\n# Describe a specific table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Describing the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nprint_r($response-&gt;body);\n\n####################################################################\n# Updating the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$dynamodb-&gt;update_table(array(\n\t'TableName' =&gt; $table_name,\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 400,\n\t\t'WriteCapacityUnits' =&gt; 400\n\t)\n));\n\n$table_status = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($table_status-&gt;isOK())\n{\n\tprint_r($table_status-&gt;body-&gt;Table-&gt;ProvisionedThroughput-&gt;to_array()-&gt;getArrayCopy());\n}\nelse\n{\n\tprint_r($table_status);\n}\n\n####################################################################\n# Sleep and poll until the table has been updated.\n\n$count = 0;\ndo {\n\tsleep(5);\n\t$count += 5;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been updated (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"put_item","modifier":"public","description":"<p>Creates a new item, or replaces an old item with a new item (including all the attributes).<\/p>\n\n<p>If an item already exists in the specified table with the same primary key, the new item\ncompletely replaces the existing item. You can perform a conditional put (insert a new item if\none with the specified primary key doesn&#8217;t exist), or replace an existing item if it has\ncertain attribute values.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to put an item. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>Item<\/code> - <code>array<\/code> - Required - A map of the attributes for the item, and must include the primary key values that define the item. Other attribute name-value pairs can be provided for the item. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - AttributeValue can be <code>String<\/code>, <code>Number<\/code>, <code>Binary<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>, <code>BinarySet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>Expected<\/code> - <code>array<\/code> - Optional - Designates an attribute for a conditional modification. The <code>Expected<\/code> parameter allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute has a particular value before modifying it. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - Allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute value already exists; or if the attribute value exists and has a particular value before changing it. <ul><li><code>Value<\/code> - <code>array<\/code> - Optional - Specify whether or not a value already exists and has a specific content for the attribute name-value pair. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>Exists<\/code> - <code>boolean<\/code> - Optional - Specify whether or not a value already exists for the attribute name-value pair.<\/li><\/ul><\/li><\/ul><\/li><li><code>ReturnValues<\/code> - <code>string<\/code> - Optional - Use this parameter if you want to get the attribute name-value pairs before or after they are modified. For <code>PUT<\/code> operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>. For update operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code> or <code>UPDATED_NEW<\/code>.<ul><li> <code>NONE<\/code>: Nothing is returned.<\/li><li> <code>ALL_OLD<\/code>: Returns the attributes of the item as they were before the operation.<\/li><li> <code>UPDATED_OLD<\/code>: Returns the values of the updated attributes, only, as they were before the operation.<\/li><li> <code>ALL_NEW<\/code>: Returns all the attributes and their new values after the operation.<\/li><li> <code>UPDATED_NEW<\/code>: Returns the values of the updated attributes, only, as they are after the operation.<\/li><\/ul> [Allowed values: <code>NONE<\/code>, <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code>, <code>UPDATED_NEW<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function put_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('PutItem', $opt);\n}","examples":{"example":[{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table-' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Getting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('id', 'date', 'key1', 'key2', 'key3'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Updating an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating an item from the table...&quot; . PHP_EOL;\n\n\/\/ Updating an item\n$response = $dynamodb-&gt;update_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributeUpdates' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING =&gt; 'updated-value1')\n\t\t),\n\t\t'key2' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_DELETE\n\t\t),\n\t\t'key3' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_ADD,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING_SET =&gt; array('sub-value3'))\n\t\t),\n\t\t'key4' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; $dynamodb-&gt;binary('binary-value')\n\t\t),\n\t),\n\t'Expected' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Value' =&gt; array( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updating the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Checking the binary result\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('key4'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key4-&gt;{AmazonDynamoDB::TYPE_BINARY});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Deleting an item\n$response = $dynamodb-&gt;delete_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 1, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Deleting the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\techo '.';\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"},{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Set up batch requests\n$queue = new CFBatchRequest();\n$queue-&gt;use_credentials($dynamodb-&gt;credentials);\n\n\/\/ Add items to the batch\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value1',\n\t\t'key2'          =&gt; 'value2',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&aring;&eacute;&icirc;&oslash;&uuml;'\n\t))\n));\n\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value3',\n\t\t'key2'          =&gt; 'value4',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&icirc;&oslash;&uuml;&aring;&eacute;'\n\t))\n));\n\n$dynamodb-&gt;batch($queue)-&gt;put_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'id'            =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t'date'          =&gt; $current_time, \/\/ Range Key\n\t\t'key1'          =&gt; 'value5',\n\t\t'key2'          =&gt; 'value6',\n\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; '&uuml;&oslash;&icirc;&eacute;&aring;'\n\t))\n));\n\n\/\/ Execute the batch of requests in parallel\n$responses = $dynamodb-&gt;batch($queue)-&gt;send();\n\n\/\/ Check for success...\nif ($responses-&gt;areOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($responses);\n}\n\n####################################################################\n# Getting multiple items\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting multiple items from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;batch_get_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\t'Keys' =&gt; array( \/\/ Key #1\n\t\t\t\t$dynamodb-&gt;attributes(array(\n\t\t\t\t\t'HashKeyElement'  =&gt; 1,\n\t\t\t\t\t'RangeKeyElement' =&gt; $current_time,\n\t\t\t\t)),\n\t\t\t\t$dynamodb-&gt;attributes(array( \/\/ Key #2\n\t\t\t\t\t'HashKeyElement'  =&gt; 2,\n\t\t\t\t\t'RangeKeyElement' =&gt; $current_time,\n\t\t\t\t)),\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tsleep(5);\n\n\t\/\/ Collect the values we want to show\n\t$result = array();\n\tforeach ($response-&gt;body-&gt;Responses-&gt;{$table_name}-&gt;Items as $item)\n\t{\n\t\t$result[] = array(\n\t\t\t'id'            =&gt; (string) $item-&gt;{'id'}-&gt;{AmazonDynamoDB::TYPE_NUMBER},\n\t\t\t'date'          =&gt; (string) $item-&gt;{'date'}-&gt;{AmazonDynamoDB::TYPE_NUMBER},\n\t\t\t'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l' =&gt; (string) $item-&gt;{'&icirc;&ntilde;t&eacute;rn&aring;t&icirc;&oslash;n&aring;l'}-&gt;{AmazonDynamoDB::TYPE_STRING},\n\t\t);\n\t}\n\n\t\/\/ Output\n\tprint_r($result);\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}]}},{"name":"query","modifier":"public","description":"<p>Gets the values of one or more items and its attributes by primary key (composite primary key,\nonly).<\/p>\n\n<p>Narrow the scope of the query using comparison operators on the <code>RangeKeyValue<\/code> of\nthe composite key. Use the <code>ScanIndexForward<\/code> parameter to get results in forward or\nreverse order by range key.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to query. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>AttributesToGet<\/code> - <code>string|array<\/code> - Optional - List of <code>Attribute<\/code> names. If attribute names are not specified then all attributes will be returned. If some attributes are not found, they will not appear in the result. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Limit<\/code> - <code>integer<\/code> - Optional - The maximum number of items to return. If Amazon DynamoDB hits this limit while querying the table, it stops the query and returns the matching values up to the limit, and a <code>LastEvaluatedKey<\/code> to apply in a subsequent operation to continue the query. Also, if the result set size exceeds 1MB before Amazon DynamoDB hits this limit, it stops the query and returns the matching values, and a <code>LastEvaluatedKey<\/code> to apply in a subsequent operation to continue the query.<\/li><li><code>ConsistentRead<\/code> - <code>boolean<\/code> - Optional - If set to <code>true<\/code>, then a consistent read is issued. Otherwise eventually-consistent is used.<\/li><li><code>Count<\/code> - <code>boolean<\/code> - Optional - If set to <code>true<\/code>, Amazon DynamoDB returns a total number of items that match the query parameters, instead of a list of the matching items and their attributes. Do not set <code>Count<\/code> to <code>true<\/code> while providing a list of <code>AttributesToGet<\/code>, otherwise Amazon DynamoDB returns a validation error.<\/li><li><code>HashKeyValue<\/code> - <code>array<\/code> - Required - Attribute value of the hash component of the composite primary key. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyCondition<\/code> - <code>array<\/code> - Optional - A container for the attribute values and comparison operators to use for the query. <ul><li><code>AttributeValueList<\/code> - <code>array<\/code> - Optional - A list of attribute values to be used with a comparison operator for a scan or query operation. For comparisons that require more than one value, such as a <code>BETWEEN<\/code> comparison, the AttributeValueList contains two attribute values and the comparison operator. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>ComparisonOperator<\/code> - <code>string<\/code> - Required - A comparison operator is an enumeration of several operations:<ul><li> <code>EQ<\/code> for <em>equal<\/em>.<\/li><li> <code>NE<\/code> for <em>not equal<\/em>.<\/li><li> <code>IN<\/code> checks for exact matches.<\/li><li> <code>LE<\/code> for <em>less than or equal to<\/em>.<\/li><li> <code>LT<\/code> for <em>less than<\/em>.<\/li><li> <code>GE<\/code> for <em>greater than or equal to<\/em>.<\/li><li> <code>GT<\/code> for <em>greater than<\/em>.<\/li><li> <code>BETWEEN<\/code> for <em>between<\/em>.<\/li><li> <code>NOT_NULL<\/code> for <em>exists<\/em>.<\/li><li> <code>NULL<\/code> for <em>not exists<\/em>.<\/li><li> <code>CONTAINS<\/code> for substring or value in a set.<\/li><li> <code>NOT_CONTAINS<\/code> for absence of a substring or absence of a value in a set.<\/li><li> <code>BEGINS_WITH<\/code> for a substring prefix.<\/li><\/ul>Scan operations support all available comparison operators. Query operations support a subset of the available comparison operators: EQ, LE, LT, GE, GT, BETWEEN, and BEGINS_WITH. [Allowed values: <code>EQ<\/code>, <code>NE<\/code>, <code>IN<\/code>, <code>LE<\/code>, <code>LT<\/code>, <code>GE<\/code>, <code>GT<\/code>, <code>BETWEEN<\/code>, <code>NOT_NULL<\/code>, <code>NULL<\/code>, <code>CONTAINS<\/code>, <code>NOT_CONTAINS<\/code>, <code>BEGINS_WITH<\/code>]<\/li><\/ul><\/li><li><code>ScanIndexForward<\/code> - <code>boolean<\/code> - Optional - Specifies forward or backward traversal of the index. Amazon DynamoDB returns results reflecting the requested order, determined by the range key. The default value is <code>true<\/code> (forward).<\/li><li><code>ExclusiveStartKey<\/code> - <code>array<\/code> - Optional - Primary key of the item from which to continue an earlier query. An earlier query might provide this value as the <code>LastEvaluatedKey<\/code> if that query operation was interrupted before completing the query; either because of the result set size or the <code>Limit<\/code> parameter. The <code>LastEvaluatedKey<\/code> can be passed back in a new query request to continue the operation from that point. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function query($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['AttributesToGet']))\n    {\n        $opt['AttributesToGet'] = (is_array($opt['AttributesToGet']) ? $opt['AttributesToGet'] : array($opt['AttributesToGet']));\n    }\n\n    return $this-&gt;authenticate('Query', $opt);\n}","examples":{"example":{"title":"<p>Scan the database for information.<\/p>","description":"<p>Examples for <a href=\"http:\/\/docs.amazonwebservices.com\/amazondynamodb\/2011-12-05\/developerguide\/LowLevelPHPScanning.html\">Scan<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER,\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER,\n\t\t),\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 10,\n\t\t'WriteCapacityUnits' =&gt; 5,\n\t),\n));\n\nvar_dump($response-&gt;isOK());\n\nif (!$response-&gt;isOK())\n{\n\tdie('Table creation failed.');\n}\n\n\/\/ Sleep and poll during table creation\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\n####################################################################\n# Add data to the table\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\nvar_dump($response-&gt;isOK());\n\nsleep(1);\n\n####################################################################\n# Scan the database\n\n\/\/ Scan the database for matches\n$response = $dynamodb-&gt;scan(array(\n\t'TableName'       =&gt; $table_name,\n\t'AttributesToGet' =&gt; array('id', 'key1', 'key2', 'key3'),\n\t'ScanFilter'      =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'ComparisonOperator' =&gt; AmazonDynamoDB::CONDITION_EQUAL,\n\t\t\t'AttributeValueList' =&gt; array(\n\t\t\t\tarray( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t\t)\n\t\t),\n\t)\n));\n\n\/\/ Did we get back what we expected?\nvar_dump((integer) $response-&gt;body-&gt;Items-&gt;id-&gt;{AmazonDynamoDB::TYPE_NUMBER});\n\n####################################################################\n# Query the database\n\n$response = $dynamodb-&gt;query(array(\n\t'TableName'    =&gt; $table_name,\n\t'HashKeyValue' =&gt; array(\n\t\tAmazonDynamoDB::TYPE_NUMBER =&gt; '1'\n\t),\n\t'RangeKeyCondition' =&gt; array(\n\t\t'ComparisonOperator' =&gt; AmazonDynamoDB::CONDITION_GREATER_THAN_OR_EQUAL,\n\t\t'AttributeValueList' =&gt; array(\n\t\t\tarray(AmazonDynamoDB::TYPE_NUMBER =&gt; '0')\n\t\t),\n\t)\n));\n\n\/\/ Did we get back what we expected?\nvar_dump((string) $response-&gt;body-&gt;Items-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n\n####################################################################\n# Deleting the table\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nvar_dump($response-&gt;isOK());\n\n\/\/ Sleep and poll until table is deleted\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);","result":"bool(true)\nbool(true)\nint(3)\nstring(6) \"value1\"\nbool(true)"}}},{"name":"register_session_handler","modifier":"public","description":"<p>Registers DynamoDB as the default session handler for PHP.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"config","type":"array","description":"<p>An array of configuration items for the session handler.<\/p>"}},"returnvalue":"<p>The session handler object.<\/p>","source":"public function register_session_handler(array $config = array())\n{\n    require_once dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'extensions'\n        . DIRECTORY_SEPARATOR . 'dynamodbsessionhandler.class.php';\n\n    $dynamo_session_handler = new DynamoDBSessionHandler($this, $config);\n    $dynamo_session_handler-&gt;register();\n\n    return $dynamo_session_handler;\n}"},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"scan","modifier":"public","description":"<p>Retrieves one or more items and its attributes by performing a full scan of a table.<\/p>\n\n<p>Provide a <code>ScanFilter<\/code> to get more specific results.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to scan. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>AttributesToGet<\/code> - <code>string|array<\/code> - Optional - List of <code>Attribute<\/code> names. If attribute names are not specified then all attributes will be returned. If some attributes are not found, they will not appear in the result. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Limit<\/code> - <code>integer<\/code> - Optional - The maximum number of items to return. If Amazon DynamoDB hits this limit while scanning the table, it stops the scan and returns the matching values up to the limit, and a <code>LastEvaluatedKey<\/code> to apply in a subsequent operation to continue the scan. Also, if the scanned data set size exceeds 1 MB before Amazon DynamoDB hits this limit, it stops the scan and returns the matching values up to the limit, and a <code>LastEvaluatedKey<\/code> to apply in a subsequent operation to continue the scan.<\/li><li><code>Count<\/code> - <code>boolean<\/code> - Optional - If set to <code>true<\/code>, Amazon DynamoDB returns a total number of items for the <code>Scan<\/code> operation, even if the operation has no matching items for the assigned filter. Do not set <code>Count<\/code> to <code>true<\/code> while providing a list of <code>AttributesToGet<\/code>, otherwise Amazon DynamoDB returns a validation error.<\/li><li><code>ScanFilter<\/code> - <code>array<\/code> - Optional - Evaluates the scan results and returns only the desired values. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - This key is variable (e.g., user-specified). <ul><li><code>AttributeValueList<\/code> - <code>array<\/code> - Optional - A list of attribute values to be used with a comparison operator for a scan or query operation. For comparisons that require more than one value, such as a <code>BETWEEN<\/code> comparison, the AttributeValueList contains two attribute values and the comparison operator. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>ComparisonOperator<\/code> - <code>string<\/code> - Required - A comparison operator is an enumeration of several operations:<ul><li> <code>EQ<\/code> for <em>equal<\/em>.<\/li><li> <code>NE<\/code> for <em>not equal<\/em>.<\/li><li> <code>IN<\/code> checks for exact matches.<\/li><li> <code>LE<\/code> for <em>less than or equal to<\/em>.<\/li><li> <code>LT<\/code> for <em>less than<\/em>.<\/li><li> <code>GE<\/code> for <em>greater than or equal to<\/em>.<\/li><li> <code>GT<\/code> for <em>greater than<\/em>.<\/li><li> <code>BETWEEN<\/code> for <em>between<\/em>.<\/li><li> <code>NOT_NULL<\/code> for <em>exists<\/em>.<\/li><li> <code>NULL<\/code> for <em>not exists<\/em>.<\/li><li> <code>CONTAINS<\/code> for substring or value in a set.<\/li><li> <code>NOT_CONTAINS<\/code> for absence of a substring or absence of a value in a set.<\/li><li> <code>BEGINS_WITH<\/code> for a substring prefix.<\/li><\/ul>Scan operations support all available comparison operators. Query operations support a subset of the available comparison operators: EQ, LE, LT, GE, GT, BETWEEN, and BEGINS_WITH. [Allowed values: <code>EQ<\/code>, <code>NE<\/code>, <code>IN<\/code>, <code>LE<\/code>, <code>LT<\/code>, <code>GE<\/code>, <code>GT<\/code>, <code>BETWEEN<\/code>, <code>NOT_NULL<\/code>, <code>NULL<\/code>, <code>CONTAINS<\/code>, <code>NOT_CONTAINS<\/code>, <code>BEGINS_WITH<\/code>]<\/li><\/ul><\/li><\/ul><\/li><li><code>ExclusiveStartKey<\/code> - <code>array<\/code> - Optional - Primary key of the item from which to continue an earlier scan. An earlier scan might provide this value if that scan operation was interrupted before scanning the entire table; either because of the result set size or the <code>Limit<\/code> parameter. The <code>LastEvaluatedKey<\/code> can be passed back in a new scan request to continue the operation from that point. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function scan($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['AttributesToGet']))\n    {\n        $opt['AttributesToGet'] = (is_array($opt['AttributesToGet']) ? $opt['AttributesToGet'] : array($opt['AttributesToGet']));\n    }\n\n    return $this-&gt;authenticate('Scan', $opt);\n}","examples":{"example":{"title":"<p>Scan the database for information.<\/p>","description":"<p>Examples for <a href=\"http:\/\/docs.amazonwebservices.com\/amazondynamodb\/2011-12-05\/developerguide\/LowLevelPHPScanning.html\">Scan<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER,\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER,\n\t\t),\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 10,\n\t\t'WriteCapacityUnits' =&gt; 5,\n\t),\n));\n\nvar_dump($response-&gt;isOK());\n\nif (!$response-&gt;isOK())\n{\n\tdie('Table creation failed.');\n}\n\n\/\/ Sleep and poll during table creation\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\n####################################################################\n# Add data to the table\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3, \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; time(),\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\nvar_dump($response-&gt;isOK());\n\nsleep(1);\n\n####################################################################\n# Scan the database\n\n\/\/ Scan the database for matches\n$response = $dynamodb-&gt;scan(array(\n\t'TableName'       =&gt; $table_name,\n\t'AttributesToGet' =&gt; array('id', 'key1', 'key2', 'key3'),\n\t'ScanFilter'      =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'ComparisonOperator' =&gt; AmazonDynamoDB::CONDITION_EQUAL,\n\t\t\t'AttributeValueList' =&gt; array(\n\t\t\t\tarray( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t\t)\n\t\t),\n\t)\n));\n\n\/\/ Did we get back what we expected?\nvar_dump((integer) $response-&gt;body-&gt;Items-&gt;id-&gt;{AmazonDynamoDB::TYPE_NUMBER});\n\n####################################################################\n# Query the database\n\n$response = $dynamodb-&gt;query(array(\n\t'TableName'    =&gt; $table_name,\n\t'HashKeyValue' =&gt; array(\n\t\tAmazonDynamoDB::TYPE_NUMBER =&gt; '1'\n\t),\n\t'RangeKeyCondition' =&gt; array(\n\t\t'ComparisonOperator' =&gt; AmazonDynamoDB::CONDITION_GREATER_THAN_OR_EQUAL,\n\t\t'AttributeValueList' =&gt; array(\n\t\t\tarray(AmazonDynamoDB::TYPE_NUMBER =&gt; '0')\n\t\t),\n\t)\n));\n\n\/\/ Did we get back what we expected?\nvar_dump((string) $response-&gt;body-&gt;Items-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n\n####################################################################\n# Deleting the table\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nvar_dump($response-&gt;isOK());\n\n\/\/ Sleep and poll until table is deleted\ndo\n{\n\tsleep(1);\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);","result":"bool(true)\nbool(true)\nint(3)\nstring(6) \"value1\"\nbool(true)"}}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazondynamodb\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_us_w1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_us_w1\"><code>REGION_US_W1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_us_w2\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_us_w2\"><code>REGION_US_W2<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_eu_w1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_eu_w1\"><code>REGION_EU_W1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_apac_se1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_apac_se1\"><code>REGION_APAC_SE1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_apac_se2\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_apac_se2\"><code>REGION_APAC_SE2<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_apac_ne1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_apac_ne1\"><code>REGION_APAC_NE1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_sa_e1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_sa_e1\"><code>REGION_SA_E1<\/code><\/a>, <a href=\"..\/amazondynamodb\/constants.html#region_us_gov1\" rel=\"..\/..\/index.html#c=amazondynamodb\/region_us_gov1\"><code>REGION_US_GOV1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"update_item","modifier":"public","description":"<p>Edits an existing item&#8217;s attributes.<\/p>\n\n<p>You can perform a conditional update (insert a new attribute name-value pair if it doesn&#8217;t\nexist, or replace an existing name-value pair if it has certain expected attribute values).<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table in which you want to update an item. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>Key<\/code> - <code>array<\/code> - Required - The primary key that uniquely identifies each item in a table. A primary key can be a one attribute (hash) primary key or a two attribute (hash-and-range) primary key. <ul><li><code>HashKeyElement<\/code> - <code>array<\/code> - Required - A hash key element is treated as the primary key, and can be a string or a number. Single attribute primary keys have one index value. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>RangeKeyElement<\/code> - <code>array<\/code> - Optional - A range key element is treated as a secondary key (used in conjunction with the primary key), and can be a string or a number, and is only used for hash-and-range primary keys. The value can be <code>String<\/code>, <code>Number<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><\/ul><\/li><li><code>AttributeUpdates<\/code> - <code>array<\/code> - Required - Map of attribute name to the new value and action for the update. The attribute names specify the attributes to modify, and cannot contain any primary key attributes. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - Specifies the attribute to update and how to perform the update. Possible values: <code>PUT<\/code> (default), <code>ADD<\/code> or <code>DELETE<\/code>. <ul><li><code>Value<\/code> - <code>array<\/code> - Optional - AttributeValue can be <code>String<\/code>, <code>Number<\/code>, <code>Binary<\/code>, <code>StringSet<\/code>, <code>NumberSet<\/code>, <code>BinarySet<\/code>. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>Action<\/code> - <code>string<\/code> - Optional - The type of action for an item update operation. Only use the add action for numbers or sets; the specified value is added to the existing value. If a set of values is specified, the values are added to the existing set. Adds the specified attribute. If the attribute exists, it is replaced by the new value. If no value is specified, this removes the attribute and its value. If a set of values is specified, then the values in the specified set are removed from the old set. [Allowed values: <code>ADD<\/code>, <code>PUT<\/code>, <code>DELETE<\/code>]<\/li><\/ul><\/li><\/ul><\/li><li><code>Expected<\/code> - <code>array<\/code> - Optional - Designates an attribute for a conditional modification. The <code>Expected<\/code> parameter allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute has a particular value before modifying it. <ul><li><code>[custom-key]<\/code> - <code>array<\/code> - Optional - Allows you to provide an attribute name, and whether or not Amazon DynamoDB should check to see if the attribute value already exists; or if the attribute value exists and has a particular value before changing it. <ul><li><code>Value<\/code> - <code>array<\/code> - Optional - Specify whether or not a value already exists and has a specific content for the attribute name-value pair. <ul><li><code>S<\/code> - <code>string<\/code> - Optional - Strings are Unicode with UTF-8 binary encoding. The maximum size is limited by the size of the primary key (1024 bytes as a range part of a key or 2048 bytes as a single part hash key) or the item size (64k).<\/li><li><code>N<\/code> - <code>string<\/code> - Optional - Numbers are positive or negative exact-value decimals and integers. A number can have up to 38 digits precision and can be between 10^-128 to 10^+126.<\/li><li><code>B<\/code> - <code>blob<\/code> - Optional - Binary attributes are sequences of unsigned bytes.<\/li><li><code>SS<\/code> - <code>string|array<\/code> - Optional - A set of strings. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>NS<\/code> - <code>string|array<\/code> - Optional - A set of numbers. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>BS<\/code> - <code>blob<\/code> - Optional - A set of binary attributes.<\/li><\/ul><\/li><li><code>Exists<\/code> - <code>boolean<\/code> - Optional - Specify whether or not a value already exists for the attribute name-value pair.<\/li><\/ul><\/li><\/ul><\/li><li><code>ReturnValues<\/code> - <code>string<\/code> - Optional - Use this parameter if you want to get the attribute name-value pairs before or after they are modified. For <code>PUT<\/code> operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>. For update operations, the possible parameter values are <code>NONE<\/code> (default) or <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code> or <code>UPDATED_NEW<\/code>.<ul><li> <code>NONE<\/code>: Nothing is returned.<\/li><li> <code>ALL_OLD<\/code>: Returns the attributes of the item as they were before the operation.<\/li><li> <code>UPDATED_OLD<\/code>: Returns the values of the updated attributes, only, as they were before the operation.<\/li><li> <code>ALL_NEW<\/code>: Returns all the attributes and their new values after the operation.<\/li><li> <code>UPDATED_NEW<\/code>: Returns the values of the updated attributes, only, as they are after the operation.<\/li><\/ul> [Allowed values: <code>NONE<\/code>, <code>ALL_OLD<\/code>, <code>UPDATED_OLD<\/code>, <code>ALL_NEW<\/code>, <code>UPDATED_NEW<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_item($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateItem', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table-' . time();\n$current_time = (int) time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'id',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Adding data to the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Adding data to the table...&quot; . PHP_EOL;\n\n\/\/ Add items to the batch\n$response = $dynamodb-&gt;batch_write_item(array(\n\t'RequestItems' =&gt; array(\n\t\t$table_name =&gt; array(\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 1,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value1',\n\t\t\t\t\t\t'key2' =&gt; 'value2',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 2,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value3',\n\t\t\t\t\t\t'key2' =&gt; 'value4',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t\tarray(\n\t\t\t\t'PutRequest' =&gt; array(\n\t\t\t\t\t'Item' =&gt; $dynamodb-&gt;attributes(array(\n\t\t\t\t\t\t'id'   =&gt; 3,             \/\/ Primary (Hash) Key\n\t\t\t\t\t\t'date' =&gt; $current_time, \/\/ Range Key\n\t\t\t\t\t\t'key1' =&gt; 'value5',\n\t\t\t\t\t\t'key2' =&gt; 'value6',\n\t\t\t\t\t\t'key3' =&gt; array('sub-value1', 'sub-value2'),\n\t\t\t\t\t))\n\t\t\t\t)\n\t\t\t),\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo &quot;The data has been added to the table.&quot; . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Getting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('id', 'date', 'key1', 'key2', 'key3'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key1-&gt;{AmazonDynamoDB::TYPE_STRING});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Updating an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating an item from the table...&quot; . PHP_EOL;\n\n\/\/ Updating an item\n$response = $dynamodb-&gt;update_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributeUpdates' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING =&gt; 'updated-value1')\n\t\t),\n\t\t'key2' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_DELETE\n\t\t),\n\t\t'key3' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_ADD,\n\t\t\t'Value'  =&gt; array(AmazonDynamoDB::TYPE_STRING_SET =&gt; array('sub-value3'))\n\t\t),\n\t\t'key4' =&gt; array(\n\t\t\t'Action' =&gt; AmazonDynamoDB::ACTION_PUT,\n\t\t\t'Value'  =&gt; $dynamodb-&gt;binary('binary-value')\n\t\t),\n\t),\n\t'Expected' =&gt; array(\n\t\t'key1' =&gt; array(\n\t\t\t'Value' =&gt; array( AmazonDynamoDB::TYPE_STRING =&gt; 'value5' )\n\t\t)\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Updating the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Checking the binary result\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Getting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Get an item\n$response = $dynamodb-&gt;get_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 3,             \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\t'AttributesToGet' =&gt; array('key4'),\n\t'ConsistentRead' =&gt; 'true'\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\tvar_dump((string) $response-&gt;body-&gt;Item-&gt;key4-&gt;{AmazonDynamoDB::TYPE_BINARY});\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting an item\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting an item from the table...&quot; . PHP_EOL;\n\n\/\/ Deleting an item\n$response = $dynamodb-&gt;delete_item(array(\n\t'TableName' =&gt; $table_name,\n\t'Key' =&gt; $dynamodb-&gt;attributes(array(\n\t\t'HashKeyElement'  =&gt; 1, \/\/ &quot;id&quot; column\n\t\t'RangeKeyElement' =&gt; $current_time, \/\/ &quot;date&quot; column\n\t)),\n\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'Deleting the item...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\techo '.';\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}},{"name":"update_table","modifier":"public","description":"<p>Updates the provisioned throughput for the given table.<\/p>\n\n<p>Setting the throughput for a table helps you manage performance and is part of the Provisioned\nThroughput feature of Amazon DynamoDB.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TableName<\/code> - <code>string<\/code> - Required - The name of the table you want to update. Allowed characters are <code>a-z<\/code>, <code>A-Z<\/code>, <code>0-9<\/code>, <code>_<\/code> (underscore), <code>-<\/code> (hyphen) and <code>.<\/code> (period). [Constraints: The value must be between 3 and 255 characters, and must match the following regular expression pattern: <code>[a-zA-Z0-9_.-]+<\/code>]<\/li><li><code>ProvisionedThroughput<\/code> - <code>array<\/code> - Required - Provisioned throughput reserves the required read and write resources for your table in terms of <code>ReadCapacityUnits<\/code> and <code>WriteCapacityUnits<\/code>. Values for provisioned throughput depend upon your expected read\/write rates, item size, and consistency. Provide the expected number of read and write operations, assuming an item size of 1k and strictly consistent reads. For 2k item size, double the value. For 3k, triple the value, etc. Eventually-consistent reads consume half the resources of strictly consistent reads. <ul><li><code>ReadCapacityUnits<\/code> - <code>long<\/code> - Required - <code>ReadCapacityUnits<\/code> are in terms of strictly consistent reads, assuming items of 1k. 2k items require twice the <code>ReadCapacityUnits<\/code>. Eventually-consistent reads only require half the <code>ReadCapacityUnits<\/code> of stirctly consistent reads.<\/li><li><code>WriteCapacityUnits<\/code> - <code>long<\/code> - Required - <code>WriteCapacityUnits<\/code> are in terms of strictly consistent reads, assuming items of 1k. 2k items require twice the <code>WriteCapacityUnits<\/code>.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_table($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateTable', $opt);\n}","examples":{"example":{"title":"<p>Create a new table with a Hash Key.<\/p>","code":"\/\/ Instantiate the class\n$dynamodb = new AmazonDynamoDB();\n\n$table_name = 'my-table' . time();\n\n####################################################################\n# Create a new DynamoDB table\n\n$response = $dynamodb-&gt;create_table(array(\n\t'TableName' =&gt; $table_name,\n\t'KeySchema' =&gt; array(\n\t\t'HashKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'ID',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t),\n\t\t'RangeKeyElement' =&gt; array(\n\t\t\t'AttributeName' =&gt; 'Date',\n\t\t\t'AttributeType' =&gt; AmazonDynamoDB::TYPE_NUMBER\n\t\t)\n\t),\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 50,\n\t\t'WriteCapacityUnits' =&gt; 50\n\t)\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo '# Kicked off the creation of the DynamoDB table...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been created\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been created (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Collect all table names in the account\n\necho PHP_EOL . PHP_EOL;\necho '# Collecting a complete list of tables in the account...' . PHP_EOL;\n\n$response = $dynamodb-&gt;list_tables();\nprint_r($response-&gt;body-&gt;TableNames-&gt;to_array()-&gt;getArrayCopy());\n\n####################################################################\n# Describe a specific table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Describing the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\nprint_r($response-&gt;body);\n\n####################################################################\n# Updating the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Updating the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$dynamodb-&gt;update_table(array(\n\t'TableName' =&gt; $table_name,\n\t'ProvisionedThroughput' =&gt; array(\n\t\t'ReadCapacityUnits' =&gt; 400,\n\t\t'WriteCapacityUnits' =&gt; 400\n\t)\n));\n\n$table_status = $dynamodb-&gt;describe_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($table_status-&gt;isOK())\n{\n\tprint_r($table_status-&gt;body-&gt;Table-&gt;ProvisionedThroughput-&gt;to_array()-&gt;getArrayCopy());\n}\nelse\n{\n\tprint_r($table_status);\n}\n\n####################################################################\n# Sleep and poll until the table has been updated.\n\n$count = 0;\ndo {\n\tsleep(5);\n\t$count += 5;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((string) $response-&gt;body-&gt;Table-&gt;TableStatus !== 'ACTIVE');\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been updated (slept ${count} seconds).&quot; . PHP_EOL;\n\n####################################################################\n# Deleting the table\n\necho PHP_EOL . PHP_EOL;\necho &quot;# Deleting the \\&quot;${table_name}\\&quot; table...&quot; . PHP_EOL;\n\n$response = $dynamodb-&gt;delete_table(array(\n\t'TableName' =&gt; $table_name\n));\n\n\/\/ Check for success...\nif ($response-&gt;isOK())\n{\n\techo 'The table is in the process of deleting...' . PHP_EOL;\n}\nelse\n{\n\tprint_r($response);\n}\n\n####################################################################\n# Sleep and poll until the table has been deleted.\n\n$count = 0;\ndo {\n\tsleep(1);\n\t$count++;\n\n\t$response = $dynamodb-&gt;describe_table(array(\n\t\t'TableName' =&gt; $table_name\n\t));\n}\nwhile ((integer) $response-&gt;status !== 400);\n\necho &quot;The table \\&quot;${table_name}\\&quot; has been deleted (slept ${count} seconds).&quot; . PHP_EOL;"}}}]},"constants":{"@attributes":{"count":"53"},"constant":[{"name":"ACTION_ADD","value":"ADD"},{"name":"ACTION_DELETE","value":"DELETE"},{"name":"ACTION_PUT","value":"PUT"},{"name":"BUILD","value":"20130314130000"},{"name":"CONDITION_BEGINS_WITH","value":"BEGINS_WITH"},{"name":"CONDITION_BETWEEN","value":"BETWEEN"},{"name":"CONDITION_CONTAINS","value":"CONTAINS"},{"name":"CONDITION_DOESNT_CONTAIN","value":"NOT_CONTAINS"},{"name":"CONDITION_EQUAL","value":"EQ"},{"name":"CONDITION_GREATER_THAN","value":"GT"},{"name":"CONDITION_GREATER_THAN_OR_EQUAL","value":"GE"},{"name":"CONDITION_IN","value":"IN"},{"name":"CONDITION_LESS_THAN","value":"LT"},{"name":"CONDITION_LESS_THAN_OR_EQUAL","value":"LE"},{"name":"CONDITION_NOT_EQUAL","value":"NE"},{"name":"CONDITION_NOT_NULL","value":"NOT_NULL"},{"name":"CONDITION_NULL","value":"NULL"},{"name":"DEFAULT_URL","value":"dynamodb.us-east-1.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_APAC_NE1","value":"dynamodb.ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1","value":"dynamodb.ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE2","value":"dynamodb.ap-southeast-2.amazonaws.com"},{"name":"REGION_CALIFORNIA","value":"dynamodb.us-west-1.amazonaws.com"},{"name":"REGION_EU_W1","value":"dynamodb.eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND","value":"dynamodb.eu-west-1.amazonaws.com"},{"name":"REGION_OREGON","value":"dynamodb.us-west-2.amazonaws.com"},{"name":"REGION_SAO_PAULO","value":"dynamodb.sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1","value":"dynamodb.sa-east-1.amazonaws.com"},{"name":"REGION_SINGAPORE","value":"dynamodb.ap-southeast-1.amazonaws.com"},{"name":"REGION_SYDNEY","value":"dynamodb.ap-southeast-2.amazonaws.com"},{"name":"REGION_TOKYO","value":"dynamodb.ap-northeast-1.amazonaws.com"},{"name":"REGION_US_E1","value":"dynamodb.us-east-1.amazonaws.com"},{"name":"REGION_US_GOV1","value":"dynamodb.us-gov-west-1.amazonaws.com"},{"name":"REGION_US_W1","value":"dynamodb.us-west-1.amazonaws.com"},{"name":"REGION_US_W2","value":"dynamodb.us-west-2.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"dynamodb.us-east-1.amazonaws.com"},{"name":"RETURN_ALL_NEW","value":"ALL_NEW"},{"name":"RETURN_ALL_OLD","value":"ALL_OLD"},{"name":"RETURN_NONE","value":"NONE"},{"name":"RETURN_UPDATED_NEW","value":"UPDATED_NEW"},{"name":"RETURN_UPDATED_OLD","value":"UPDATED_OLD"},{"name":"SUFFIX_FOR_TYPES","value":"S"},{"name":"TYPE_ARRAY_OF_BINARIES","value":"BS"},{"name":"TYPE_ARRAY_OF_NUMBERS","value":"NS"},{"name":"TYPE_ARRAY_OF_STRINGS","value":"SS"},{"name":"TYPE_BINARY","value":"B"},{"name":"TYPE_BINARY_SET","value":"BS"},{"name":"TYPE_NUMBER","value":"N"},{"name":"TYPE_NUMBER_SET","value":"NS"},{"name":"TYPE_STRING","value":"S"},{"name":"TYPE_STRING_SET","value":"SS"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazondynamodb\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazondynamodb\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}