{"file":{},"class":{"name":"AmazonEC2","file":"services\/ec2.class.php","url":"..\/amazonec2\/index.html","description":"<p>Amazon Elastic Compute Cloud (Amazon EC2) is a web service that provides resizable compute\ncapacity in the cloud. It is designed to make web-scale computing easier for developers.<\/p>\n\n<p>Amazon EC2&#8217;s simple web service interface allows you to obtain and configure capacity with\nminimal friction. It provides you with complete control of your computing resources and lets\nyou run on Amazon&#8217;s proven computing environment. Amazon EC2 reduces the time required to\nobtain and boot new server instances to minutes, allowing you to quickly scale capacity, both\nup and down, as your computing requirements change. Amazon EC2 changes the economics of\ncomputing by allowing you to pay only for capacity that you actually use. Amazon EC2 provides\ndevelopers the tools to build failure resilient applications and isolate themselves from common\nfailure scenarios.<\/p>\n\n<p>Visit <a href=\"http:\/\/aws.amazon.com\/ec2\/\">http:\/\/aws.amazon.com\/ec2\/<\/a> for more information.<\/p>","metadata":{"version":"2013.03.14","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/ec2\/ Amazon EC2","http:\/\/aws.amazon.com\/ec2\/documentation\/ Amazon EC2 documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"179"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazonec2\/index.html\" rel=\"..\/..\/index.html#i=amazonec2\"><code>AmazonEC2<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonec2\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2013-02-01';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV2Query';\n\n    return parent::__construct($options);\n}"},{"name":"activate_license","modifier":"public","description":"<p>Activates a specific number of licenses for a 90-day period. Activations can be done against a\nspecific license ID.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"license_id","type":"string","description":"<p>Specifies the ID for the specific license to activate against.<\/p>"},{"@attributes":{"choice":"req"},"name":"capacity","type":"integer","description":"<p>Specifies the additional number of licenses to activate.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function activate_license($license_id, $capacity, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['LicenseId'] = $license_id;\n    $opt['Capacity'] = $capacity;\n    \n    return $this-&gt;authenticate('ActivateLicense', $opt);\n}","examples":{"example":{"title":"<p>Activate a Microsoft\u00ae Windows\u00ae license.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;activate_license('lic-1234abcd', 1);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/bundle_instance.html\" rel=\"..\/..\/index.html#m=amazonec2\/bundle_instance\"><code>bundle_instance()<\/code><\/a>","<a href=\"..\/amazonec2\/cancel_bundle_task.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_bundle_task\"><code>cancel_bundle_task()<\/code><\/a>","<a href=\"..\/amazonec2\/deactivate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/deactivate_license\"><code>deactivate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_bundle_tasks.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_bundle_tasks\"><code>describe_bundle_tasks()<\/code><\/a>","<a href=\"..\/amazonec2\/get_password_data.html\" rel=\"..\/..\/index.html#m=amazonec2\/get_password_data\"><code>get_password_data()<\/code><\/a>"]}},{"name":"allocate_address","modifier":"public","description":"<p>The AllocateAddress operation acquires an elastic IP address for use with your account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Domain<\/code> - <code>string<\/code> - Optional - Set to <code>vpc<\/code> to allocate the address to your VPC. By default, will allocate to EC2. [Allowed values: <code>vpc<\/code>, <code>standard<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function allocate_address($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('AllocateAddress', $opt);\n}","examples":{"example":{"title":"<p>Allocate a new Elastic IP address.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;allocate_address();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_address\"><code>associate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_addresses.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_addresses\"><code>describe_addresses()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_address\"><code>disassociate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/release_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/release_address\"><code>release_address()<\/code><\/a>"]}},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazonec2\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazonec2\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazonec2\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"assign_private_ip_addresses","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PrivateIpAddress<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>SecondaryPrivateIpAddressCount<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>AllowReassignment<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function assign_private_ip_addresses($network_interface_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['PrivateIpAddress']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'PrivateIpAddress' =&gt; (is_array($opt['PrivateIpAddress']) ? $opt['PrivateIpAddress'] : array($opt['PrivateIpAddress']))\n        )));\n        unset($opt['PrivateIpAddress']);\n    }\n\n    return $this-&gt;authenticate('AssignPrivateIpAddresses', $opt);\n}"},{"name":"associate_address","modifier":"public","description":"<p>The AssociateAddress operation associates an elastic IP address with an instance.<\/p>\n\n<p>If the IP address is currently assigned to another instance, the IP address is assigned to the\nnew instance. This is an idempotent operation. If you enter it more than once, Amazon EC2 does\nnot return an error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The instance to associate with the IP address.<\/p>"},{"@attributes":{"choice":"req"},"name":"public_ip","type":"string","description":"<p>IP address that you are assigning to the instance.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AllocationId<\/code> - <code>string<\/code> - Optional - The allocation ID that AWS returned when you allocated the elastic IP address for use with Amazon VPC.<\/li><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - <\/li><li><code>AllowReassociation<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function associate_address($instance_id, $public_ip, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    $opt['PublicIp'] = $public_ip;\n    \n    return $this-&gt;authenticate('AssociateAddress', $opt);\n}","examples":{"example":{"title":"<p>AmazonEC2 - Associate Address<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;associate_address('i-1f549375', '184.73.247.11');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/allocate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/allocate_address\"><code>allocate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_addresses.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_addresses\"><code>describe_addresses()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_address\"><code>disassociate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/release_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/release_address\"><code>release_address()<\/code><\/a>"]}},{"name":"associate_dhcp_options","modifier":"public","description":"<p>Associates a set of DHCP options (that you&#8217;ve previously created) with the specified VPC. Or,\nassociates the default DHCP options with the VPC. The default set consists of the standard EC2\nhost name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type.\nAfter you associate the options with the VPC, any existing instances and all new instances that\nyou launch in that VPC use the options. For more information about the supported DHCP options\nand using them with Amazon VPC, go to Using DHCP Options in the Amazon Virtual Private Cloud\nDeveloper Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"dhcp_options_id","type":"string","description":"<p>The ID of the DHCP options to associate with the VPC. Specify &#8220;default&#8221; to associate the default DHCP options with the VPC.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC to associate the DHCP options with.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function associate_dhcp_options($dhcp_options_id, $vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DhcpOptionsId'] = $dhcp_options_id;\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('AssociateDhcpOptions', $opt);\n}","examples":{"example":{"title":"<p>Associate a set of DHCP options with a VPC.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;associate_dhcp_options('dopt-2a7ad743', 'vpc-abcd1234');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_dhcp_options\"><code>create_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_dhcp_options\"><code>delete_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_dhcp_options\"><code>describe_dhcp_options()<\/code><\/a>"]}},{"name":"associate_route_table","modifier":"public","description":"<p>Associates a subnet with a route table. The subnet and route table must be in the same VPC.\nThis association causes traffic originating from the subnet to be routed according to the\nroutes in the route table. The action returns an association ID, which you need if you want to\ndisassociate the route table from the subnet later. A route table can be associated with\nmultiple subnets.<\/p>\n\n<p>For more information about route tables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subnet_id","type":"string","description":"<p>The ID of the subnet.<\/p>"},{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the route table.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function associate_route_table($subnet_id, $route_table_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubnetId'] = $subnet_id;\n    $opt['RouteTableId'] = $route_table_id;\n    \n    return $this-&gt;authenticate('AssociateRouteTable', $opt);\n}","examples":{"example":{"title":"<p>Associate a VPC route table with a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;associate_route_table('subnet-cd8a0aa4', 'rtb-2c8a0a45');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"attach_internet_gateway","modifier":"public","description":"<p>Attaches an Internet gateway to a VPC, enabling connectivity between the Internet and the VPC.\nFor more information about your VPC and Internet gateway, go to the Amazon Virtual Private\nCloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"internet_gateway_id","type":"string","description":"<p>The ID of the Internet gateway to attach.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function attach_internet_gateway($internet_gateway_id, $vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InternetGatewayId'] = $internet_gateway_id;\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('AttachInternetGateway', $opt);\n}","examples":{"example":{"title":"<p>Attach an internet gateway to a running VPC.<\/p>","description":"<p>Here is the flow:<\/p>\n\n<ol>\n<li>Create a new VPC with <a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a> and a CIDR block.<\/li>\n<li>Create a new Route Table with <a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>.<\/li>\n<li>Create a new Internet Gateway with <a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>.<\/li>\n<li>Attach the Internet Gateway to the VPC with <a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>.<\/li>\n<li>Create a new Route with <a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>.<\/li>\n<\/ol>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;attach_internet_gateway('igw-be7cfdd7', 'vpc-7e7dfc17');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_internet_gateway\"><code>delete_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_internet_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_internet_gateways\"><code>describe_internet_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_internet_gateway\"><code>detach_internet_gateway()<\/code><\/a>"]}},{"name":"attach_network_interface","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"device_index","type":"integer","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function attach_network_interface($network_interface_id, $instance_id, $device_index, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    $opt['InstanceId'] = $instance_id;\n    $opt['DeviceIndex'] = $device_index;\n    \n    return $this-&gt;authenticate('AttachNetworkInterface', $opt);\n}","examples":{"example":{"title":"<p>Attach a network interface to a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;attach_network_interface($network_interface_id, $instance_id, 1);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"attach_volume","modifier":"public","description":"<p>Attach a previously created volume to a running instance.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":"<p>The ID of the Amazon EBS volume. The volume and instance must be within the same Availability Zone and the instance must be running.<\/p>"},{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance to which the volume attaches. The volume and instance must be within the same Availability Zone and the instance must be running.<\/p>"},{"@attributes":{"choice":"req"},"name":"device","type":"string","description":"<p>Specifies how the device is exposed to the instance (e.g., <code>\/dev\/sdh<\/code>).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function attach_volume($volume_id, $instance_id, $device, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    $opt['InstanceId'] = $instance_id;\n    $opt['Device'] = $device;\n    \n    return $this-&gt;authenticate('AttachVolume', $opt);\n}","examples":{"example":{"title":"<p>Attach an EBS volume to a running instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Attach the volume\n$response = $ec2-&gt;attach_volume('vol-fc482995', 'i-1f549375', '\/dev\/sdg');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"attach_vpn_gateway","modifier":"public","description":"<p>Attaches a VPN gateway to a VPC. This is the last step required to get your VPC fully connected\nto your data center before launching instances in it. For more information, go to Process for\nUsing Amazon VPC in the Amazon Virtual Private Cloud Developer Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_gateway_id","type":"string","description":"<p>The ID of the VPN gateway to attach to the VPC.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC to attach to the VPN gateway.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function attach_vpn_gateway($vpn_gateway_id, $vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnGatewayId'] = $vpn_gateway_id;\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('AttachVpnGateway', $opt);\n}","examples":{"example":{"title":"<p>Attach a VPN gateway to an existing VPC.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;attach_vpn_gateway('vgw-9aa347f3', 'vpc-fd7cd194');\n\nvar_dump($response-&gt;isOK());"}},"related":{"method":["<a href=\"..\/amazonec2\/create_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_gateway\"><code>create_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_gateway\"><code>delete_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_gateways\"><code>describe_vpn_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_vpn_gateway\"><code>detach_vpn_gateway()<\/code><\/a>"]}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"authorize_security_group_egress","modifier":"public","description":"<p>This action applies only to security groups in a VPC; it&#8217;s not supported for EC2 security\ngroups. For information about Amazon Virtual Private Cloud and VPC security groups, go to the\nAmazon Virtual Private Cloud User Guide.<\/p>\n\n<p>The action adds one or more egress rules to a VPC security group. Specifically, this permits\ninstances in a security group to send traffic to either one or more destination CIDR IP address\nranges, or to one or more destination security groups in the same VPC.<\/p>\n\n<p>Each rule consists of the protocol (e.g., TCP), plus either a CIDR range, or a source group.\nFor the TCP and UDP protocols, you must also specify the destination port or port range. For\nthe ICMP protocol, you must also specify the ICMP type and code. You can use <code>-1<\/code> as\na wildcard for the ICMP type or code.<\/p>\n\n<p>Rule changes are propagated to instances within the security group as quickly as possible.\nHowever, a small delay might occur.<\/p>\n\n<p><strong>Important:<\/strong> For VPC security groups: You can have up to 50 rules total per\ngroup (covering both ingress and egress).<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_id","type":"string","description":"<p>ID of the VPC security group to modify.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>IpPermissions<\/code> - <code>array<\/code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol<\/code> - <code>string<\/code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code><\/li><li><code>FromPort<\/code> - <code>integer<\/code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1<\/code> indicates a wildcard (i.e., any ICMP type number).<\/li><li><code>ToPort<\/code> - <code>integer<\/code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1<\/code> indicates a wildcard (i.e., any ICMP code).<\/li><li><code>Groups<\/code> - <code>array<\/code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of an account.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><\/ul><\/li><\/ul><\/li><li><code>IpRanges<\/code> - <code>string|array<\/code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function authorize_security_group_egress($group_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupId'] = $group_id;\n    \n    \/\/ Optional list + map\n    if (isset($opt['IpPermissions']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'IpPermissions' =&gt; $opt['IpPermissions']\n        )));\n        unset($opt['IpPermissions']);\n    }\n\n    return $this-&gt;authenticate('AuthorizeSecurityGroupEgress', $opt);\n}","examples":{"example":{"title":"<p>Authorize Security Group Egress<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;authorize_security_group_egress('sg-830d1eef', array(\n\t'IpPermissions' =&gt; array(\n\t\tarray( \/\/ Set 0\n\t\t\t'IpProtocol' =&gt; 'tcp',\n\t\t\t'FromPort' =&gt; '80',\n\t\t\t'ToPort' =&gt; '80',\n\t\t\t'IpRanges' =&gt; array(\n\t\t\t\tarray('CidrIp' =&gt; '205.192.0.0\/16'), \/\/ Range 0\n\t\t\t)\n\t\t)\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]}},{"name":"authorize_security_group_ingress","modifier":"public","description":"<p>The AuthorizeSecurityGroupIngress operation adds permissions to a security group.<\/p>\n\n<p>Permissions are specified by the IP protocol (TCP, UDP or ICMP), the source of the request (by\nIP range or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and\nUDP), and the ICMP codes and types (for ICMP). When authorizing ICMP, <code>-1<\/code> can be\nused as a wildcard in the type and code fields.<\/p>\n\n<p>Permission changes are propagated to instances within the security group as quickly as\npossible. However, depending on the number of instances, a small delay might occur.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the standard (EC2) security group to modify. The group must belong to your account. Can be used instead of GroupID for standard (EC2) security groups.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the standard (EC2) or VPC security group to modify. The group must belong to your account. Required for VPC security groups; can be used instead of GroupName for standard (EC2) security groups.<\/li><li><code>IpPermissions<\/code> - <code>array<\/code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol<\/code> - <code>string<\/code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code><\/li><li><code>FromPort<\/code> - <code>integer<\/code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1<\/code> indicates a wildcard (i.e., any ICMP type number).<\/li><li><code>ToPort<\/code> - <code>integer<\/code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1<\/code> indicates a wildcard (i.e., any ICMP code).<\/li><li><code>Groups<\/code> - <code>array<\/code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of an account.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><\/ul><\/li><\/ul><\/li><li><code>IpRanges<\/code> - <code>string|array<\/code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function authorize_security_group_ingress($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['IpPermissions']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'IpPermissions' =&gt; $opt['IpPermissions']\n        )));\n        unset($opt['IpPermissions']);\n    }\n\n    return $this-&gt;authenticate('AuthorizeSecurityGroupIngress', $opt);\n}","examples":{"example":{"title":"<p>Authorize Security Group Ingress<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;authorize_security_group_ingress(array(\n\t'GroupName' =&gt; 'default',\n\t'IpPermissions' =&gt; array(\n\t\tarray( \/\/ Set 0\n\t\t\t'IpProtocol' =&gt; 'tcp',\n\t\t\t'FromPort' =&gt; '80',\n\t\t\t'ToPort' =&gt; '80',\n\t\t\t'IpRanges' =&gt; array(\n\t\t\t\tarray('CidrIp' =&gt; '205.192.0.0\/16'), \/\/ Range 0\n\t\t\t)\n\t\t)\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/index.html?ApiReference-query-AuthorizeSecurityGroupIngress.html\">AuthorizeSecurityGroupIngress<\/a> operation introduced backwards-incompatible changes in the <code>2011-01-01<\/code> API release. The <code>GroupName<\/code> parameter is no longer required. Instead <code>GroupName<\/code> or <code>GroupId<\/code> are conditionally required.<\/p>"}},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"bundle_instance","modifier":"public","description":"<p>The BundleInstance operation request that an instance is bundled the next time it boots. The\nbundling process creates a new image from a running instance and stores the AMI data in S3. Once\nbundled, the image must be registered in the normal way using the RegisterImage API.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance to bundle.<\/p>"},{"@attributes":{"choice":"req"},"name":"policy","type":"array","description":"<p>The details of S3 storage for bundling a Windows instance. Takes an associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Bucket<\/code> - <code>string<\/code> - Optional - The bucket in which to store the AMI. You can specify a bucket that you already own or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone else, Amazon EC2 returns an error.<\/li><li><code>Prefix<\/code> - <code>string<\/code> - Optional - The prefix to use when storing the AMI in S3.<\/li><li><code>AWSAccessKeyId<\/code> - <code>string<\/code> - Optional - The Access Key ID of the owner of the Amazon S3 bucket. Use the <a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a> method of a <a href=\"..\/cfpolicy\/index.html\" rel=\"..\/..\/index.html#i=cfpolicy\"><code>CFPolicy<\/code><\/a> instance.<\/li><li><code>UploadPolicy<\/code> - <code>string<\/code> - Optional - A Base64-encoded Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon S3 on the user&#8217;s behalf. Use the <a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a> method of a <a href=\"..\/cfpolicy\/index.html\" rel=\"..\/..\/index.html#i=cfpolicy\"><code>CFPolicy<\/code><\/a> instance.<\/li><li><code>UploadPolicySignature<\/code> - <code>string<\/code> - Optional - The signature of the Base64 encoded JSON document. Use the <a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a> method of a <a href=\"..\/cfpolicy\/index.html\" rel=\"..\/..\/index.html#i=cfpolicy\"><code>CFPolicy<\/code><\/a> instance.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function bundle_instance($instance_id, $policy, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'Storage.S3' =&gt; $policy\n    )));\n\n    return $this-&gt;authenticate('BundleInstance', $opt, $this-&gt;hostname);\n}","examples":{"example":{"title":"<p>Bundle a running Windows-based instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Create the S3 policy\n$policy = new CFPolicy($ec2, array(\n\t'expiration' =&gt; $ec2-&gt;util-&gt;convert_date_to_iso8601('+12 hours'), \/\/ Expire in 12 hours\n\t'conditions' =&gt; array(\n\t\tarray('acl' =&gt; 'public-read'),\n\t\tarray('bucket' =&gt; 'my-bucket')\n\t)\n));\n\n\/\/ Bundle the Windows instance\n$response = $ec2-&gt;bundle_instance($instance_id, array(\n\t'Bucket' =&gt; 'my-bucket',\n\t'Prefix' =&gt; 'windows',\n\t'AWSAccessKeyId' =&gt; $policy-&gt;get_key(),\n\t'UploadPolicy' =&gt; $policy-&gt;get_policy(),\n\t'UploadPolicySignature' =&gt; $policy-&gt;get_policy_signature()\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/activate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/activate_license\"><code>activate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/cancel_bundle_task.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_bundle_task\"><code>cancel_bundle_task()<\/code><\/a>","<a href=\"..\/amazonec2\/deactivate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/deactivate_license\"><code>deactivate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_bundle_tasks.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_bundle_tasks\"><code>describe_bundle_tasks()<\/code><\/a>","<a href=\"..\/amazonec2\/get_password_data.html\" rel=\"..\/..\/index.html#m=amazonec2\/get_password_data\"><code>get_password_data()<\/code><\/a>"]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazonec2\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cancel_bundle_task","modifier":"public","description":"<p>CancelBundleTask operation cancels a pending or in-progress bundling task. This is an\nasynchronous call and it make take a while for the task to be canceled. If a task is canceled\nwhile it is storing items, there may be parts of the incomplete AMI stored in S3. It is up to\nthe caller to clean up these parts from S3.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bundle_id","type":"string","description":"<p>The ID of the bundle task to cancel.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function cancel_bundle_task($bundle_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['BundleId'] = $bundle_id;\n    \n    return $this-&gt;authenticate('CancelBundleTask', $opt);\n}","examples":{"example":{"title":"<p>Cancel the bundling of a Windows-based instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Cancel the bundle task\n$response = $ec2-&gt;cancel_bundle_task($bundle_id); \n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/activate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/activate_license\"><code>activate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/bundle_instance.html\" rel=\"..\/..\/index.html#m=amazonec2\/bundle_instance\"><code>bundle_instance()<\/code><\/a>","<a href=\"..\/amazonec2\/deactivate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/deactivate_license\"><code>deactivate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_bundle_tasks.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_bundle_tasks\"><code>describe_bundle_tasks()<\/code><\/a>","<a href=\"..\/amazonec2\/get_password_data.html\" rel=\"..\/..\/index.html#m=amazonec2\/get_password_data\"><code>get_password_data()<\/code><\/a>"]}},{"name":"cancel_conversion_task","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"conversion_task_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ReasonMessage<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function cancel_conversion_task($conversion_task_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ConversionTaskId'] = $conversion_task_id;\n    \n    return $this-&gt;authenticate('CancelConversionTask', $opt);\n}"},{"name":"cancel_export_task","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"export_task_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function cancel_export_task($export_task_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ExportTaskId'] = $export_task_id;\n    \n    return $this-&gt;authenticate('CancelExportTask', $opt);\n}"},{"name":"cancel_reserved_instances_listing","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"reserved_instances_listing_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function cancel_reserved_instances_listing($reserved_instances_listing_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ReservedInstancesListingId'] = $reserved_instances_listing_id;\n    \n    return $this-&gt;authenticate('CancelReservedInstancesListing', $opt);\n}"},{"name":"cancel_spot_instance_requests","modifier":"public","description":"<p>Cancels one or more Spot Instance requests.<\/p>\n\n<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that\nyou specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based\non available Spot Instance capacity and current spot instance requests.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"spot_instance_request_id","type":"string|array","description":"<p>Specifies the ID of the Spot Instance request. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function cancel_spot_instance_requests($spot_instance_request_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'SpotInstanceRequestId' =&gt; (is_array($spot_instance_request_id) ? $spot_instance_request_id : array($spot_instance_request_id))\n    )));\n\n    return $this-&gt;authenticate('CancelSpotInstanceRequests', $opt);\n}","examples":{"example":{"title":"<p>Cancel spot instance requests<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;cancel_spot_instance_requests('sir-769afa02');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"confirm_product_instance","modifier":"public","description":"<p>The ConfirmProductInstance operation returns true if the specified product code is attached to\nthe specified instance. The operation returns false if the product code is not attached to the\ninstance.<\/p>\n\n<p>The ConfirmProductInstance operation can only be executed by the owner of the AMI. This feature\nis useful when an AMI owner is providing support and wants to verify whether a user&#8217;s instance\nis eligible.<\/p>\n<p>This method is used in conjunction with AWS DevPay, which is not otherwise supported by this SDK.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"product_code","type":"string","description":"<p>The product code to confirm.<\/p>"},{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance to confirm.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function confirm_product_instance($product_code, $instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ProductCode'] = $product_code;\n    $opt['InstanceId'] = $instance_id;\n    \n    return $this-&gt;authenticate('ConfirmProductInstance', $opt);\n}","related":{}},{"name":"copy_image","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"source_region","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"source_image_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"name","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>ClientToken<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function copy_image($source_region, $source_image_id, $name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SourceRegion'] = $source_region;\n    $opt['SourceImageId'] = $source_image_id;\n    $opt['Name'] = $name;\n    \n    return $this-&gt;authenticate('CopyImage', $opt);\n}"},{"name":"copy_snapshot","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"source_region","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"source_snapshot_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function copy_snapshot($source_region, $source_snapshot_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SourceRegion'] = $source_region;\n    $opt['SourceSnapshotId'] = $source_snapshot_id;\n    \n    return $this-&gt;authenticate('CopySnapshot', $opt);\n}"},{"name":"create_customer_gateway","modifier":"public","description":"<p>Provides information to AWS about your customer gateway device. The customer gateway is the\nappliance at your end of the VPN connection (compared to the VPN gateway, which is the device\nat the AWS side of the VPN connection). You can have a single active customer gateway per AWS\naccount (active means that you&#8217;ve created a VPN connection to use with the customer gateway).\nAWS might delete any customer gateway that you create with this operation if you leave it\ninactive for an extended period of time.<\/p>\n\n<p>You must provide the Internet-routable IP address of the customer gateway&#8217;s external interface.\nThe IP address must be static.<\/p>\n\n<p>You must also provide the device&#8217;s Border Gateway Protocol (BGP) Autonomous System Number\n(ASN). You can use an existing ASN assigned to your network. If you don&#8217;t have an ASN already,\nyou can use a private ASN (in the 64512 - 65534 range). For more information about ASNs, go to\n<a href=\n\"http:\/\/en.wikipedia.org\/wiki\/Autonomous_system_%28Internet%29\">http:\/\/en.wikipedia.org\/wiki\/Autonomous_system_%28Internet%29<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of VPN connection this customer gateway supports.<\/p>"},{"@attributes":{"choice":"req"},"name":"ip_address","type":"string","description":"<p>The Internet-routable IP address for the customer gateway&#8217;s outside interface. The address must be static<\/p>"},{"@attributes":{"choice":"req"},"name":"bgp_asn","type":"integer","description":"<p>The customer gateway&#8217;s Border Gateway Protocol (BGP) Autonomous System Number (ASN).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_customer_gateway($type, $ip_address, $bgp_asn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Type'] = $type;\n    $opt['IpAddress'] = $ip_address;\n    $opt['BgpAsn'] = $bgp_asn;\n    \n    return $this-&gt;authenticate('CreateCustomerGateway', $opt);\n}","examples":{"example":{"title":"<p>Create a new VPC customer gateway.<\/p>","code":"$ec2 = new AmazonEC2();\n\n\/\/ IP: 1.1.1.1; Port: 65534\n$response = $ec2-&gt;create_customer_gateway('ipsec.1', '1.1.1.1', '65534');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_customer_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_customer_gateway\"><code>delete_customer_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_customer_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_customer_gateways\"><code>describe_customer_gateways()<\/code><\/a>"]}},{"name":"create_dhcp_options","modifier":"public","description":"<p>Creates a set of DHCP options that you can then associate with one or more VPCs, causing all\nexisting and new instances that you launch in those VPCs to use the set of DHCP options. The\nfollowing table lists the individual DHCP options you can specify. For more information about\nthe options, go to <a href=\n\"http:\/\/www.ietf.org\/rfc\/rfc2132.txt\">http:\/\/www.ietf.org\/rfc\/rfc2132.txt<\/a><\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"dhcp_configuration","type":"array","description":"<p>A set of one or more DHCP configurations.<\/p>\n\n<ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Key<\/code> - <code>string<\/code> - Optional - Contains the name of a DHCP option.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains a set of values for a DHCP option. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_dhcp_options($dhcp_configuration, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list + map\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'DhcpConfiguration' =&gt; (is_array($dhcp_configuration) ? $dhcp_configuration : array($dhcp_configuration))\n    )));\n\n    return $this-&gt;authenticate('CreateDhcpOptions', $opt);\n}","examples":{"example":{"title":"<p>Create a new set of DHCP options.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_dhcp_options(array(\n\tarray('Key' =&gt; 'domain-name',         'Value' =&gt; 'example.com'),\n\tarray('Key' =&gt; 'ntp-servers',         'Value' =&gt; '140.142.16.34'),\n\tarray('Key' =&gt; 'domain-name-servers', 'Value' =&gt; array('8.8.8.8', '8.8.4.4', '208.67.222.222', '208.67.222.220')),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_dhcp_options\"><code>associate_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_dhcp_options\"><code>delete_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_dhcp_options\"><code>describe_dhcp_options()<\/code><\/a>"]}},{"name":"create_image","modifier":"public","description":"<p>Creates an Amazon EBS-backed AMI from a &#8220;running&#8221; or &#8220;stopped&#8221; instance. AMIs that use an\nAmazon EBS root device boot faster than AMIs that use instance stores. They can be up to 1 TiB\nin size, use storage that persists on instance failure, and can be stopped and started.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance from which to create the new image.<\/p>"},{"@attributes":{"choice":"req"},"name":"name","type":"string","description":"<p>The name for the new AMI being created.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - The description for the new AMI being created.<\/li><li><code>NoReboot<\/code> - <code>boolean<\/code> - Optional - By default this property is set to <code>false<\/code>, which means Amazon EC2 attempts to cleanly shut down the instance before image creation and reboots the instance afterwards. When set to true, Amazon EC2 will not shut down the instance before creating the image. When this option is used, file system integrity on the created image cannot be guaranteed.<\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - The BlockDeviceMappingItemType data type. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - Specifies the virtual device name.<\/li><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - Specifies the device name (e.g., <code>\/dev\/sdh<\/code>).<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which the volume will be created.<\/li><li><code>VolumeSize<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - Specifies the device name to suppress during instance launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_image($instance_id, $name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    $opt['Name'] = $name;\n    \n    \/\/ Optional list + map\n    if (isset($opt['BlockDeviceMapping']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']\n        )));\n        unset($opt['BlockDeviceMapping']);\n    }\n\n    return $this-&gt;authenticate('CreateImage', $opt);\n}","examples":{"example":{"title":"<p>Create and register a new image from a running, EBS-backed instance.<\/p>","description":"<p><strong>Note:<\/strong> This will not work on S3-backed AMIs.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_image('i-1d549377', 'my-ebs-image');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]}},{"name":"create_instance_export_task","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>TargetEnvironment<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>citrix<\/code>, <code>vmware<\/code>]<\/li><li><code>ExportToS3<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>DiskImageFormat<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>vmdk<\/code>, <code>vhd<\/code>]<\/li><li><code>ContainerFormat<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>ova<\/code>]<\/li><li><code>S3Bucket<\/code> - <code>string<\/code> - Optional - <\/li><li><code>S3Prefix<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_instance_export_task($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['ExportToS3']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ExportToS3' =&gt; $opt['ExportToS3']\n        )));\n        unset($opt['ExportToS3']);\n    }\n\n    return $this-&gt;authenticate('CreateInstanceExportTask', $opt);\n}"},{"name":"create_internet_gateway","modifier":"public","description":"<p>Creates a new Internet gateway in your AWS account. After creating the Internet gateway, you\nthen attach it to a VPC using <code>AttachInternetGateway<\/code>. For more information about\nyour VPC and Internet gateway, go to Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_internet_gateway($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('CreateInternetGateway', $opt);\n}","examples":{"example":{"title":"<p>Create a new internet gateway for a VPC.<\/p>","description":"<p>Here is the flow:<\/p>\n\n<ol>\n<li>Create a new VPC with <a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a> and a CIDR block.<\/li>\n<li>Create a new Route Table with <a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>.<\/li>\n<li>Create a new Internet Gateway with <a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>.<\/li>\n<li>Attach the Internet Gateway to the VPC with <a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>.<\/li>\n<li>Create a new Route with <a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>.<\/li>\n<\/ol>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_internet_gateway();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_internet_gateway\"><code>delete_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_internet_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_internet_gateways\"><code>describe_internet_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_internet_gateway\"><code>detach_internet_gateway()<\/code><\/a>"]}},{"name":"create_key_pair","modifier":"public","description":"<p>The CreateKeyPair operation creates a new 2048 bit RSA key pair and returns a unique ID that\ncan be used to reference this key pair when launching new instances. For more information, see\nRunInstances.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"key_name","type":"string","description":"<p>The unique name for the new key pair.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_key_pair($key_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['KeyName'] = $key_name;\n    \n    return $this-&gt;authenticate('CreateKeyPair', $opt);\n}","examples":{"example":{"title":"<p>Create a new key pair.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_key_pair('my-keypair');\n\nif (isset($response-&gt;body-&gt;keyMaterial))\n{\n\tfile_put_contents($response-&gt;body-&gt;keyName . '.pem', (string) $response-&gt;body-&gt;keyMaterial);\n}\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_key_pair\"><code>delete_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_key_pairs.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_key_pairs\"><code>describe_key_pairs()<\/code><\/a>","<a href=\"..\/amazonec2\/import_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/import_key_pair\"><code>import_key_pair()<\/code><\/a>"]}},{"name":"create_network_acl","modifier":"public","description":"<p>Creates a new network ACL in a VPC. Network ACLs provide an optional layer of security (on top\nof security groups) for the instances in your VPC. For more information about network ACLs, go\nto Network ACLs in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC where the network ACL will be created.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_network_acl($vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('CreateNetworkAcl', $opt);\n}","examples":{"example":{"title":"<p>Create a new Network Access Control List (ACL).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_network_acl('vpc-7e7dfc17');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"create_network_acl_entry","modifier":"public","description":"<p>Creates an entry (i.e., rule) in a network ACL with a rule number you specify. Each network ACL\nhas a set of numbered ingress rules and a separate set of numbered egress rules. When\ndetermining whether a packet should be allowed in or out of a subnet associated with the ACL,\nAmazon VPC processes the entries in the ACL according to the rule numbers, in ascending order.<\/p>\n\n<p><strong>Important:<\/strong> We recommend that you leave room between the rules (e.g., 100, 110,\n120, etc.), and not number them sequentially (101, 102, 103, etc.). This allows you to easily\nadd a new rule between existing ones without having to renumber the rules.<\/p>\n\n<p>After you add an entry, you can&#8217;t modify it; you must either replace it, or create a new entry\nand delete the old one.<\/p>\n\n<p>For more information about network ACLs, go to Network ACLs in the Amazon Virtual Private Cloud\nUser Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_acl_id","type":"string","description":"<p>ID of the ACL where the entry will be created.<\/p>"},{"@attributes":{"choice":"req"},"name":"rule_number","type":"integer","description":"<p>Rule number to assign to the entry (e.g., 100). ACL entries are processed in ascending order by rule number.<\/p>"},{"@attributes":{"choice":"req"},"name":"protocol","type":"string","description":"<p>IP protocol the rule applies to. Valid Values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code> or an IP protocol number.<\/p>"},{"@attributes":{"choice":"req"},"name":"rule_action","type":"string","description":"<p>Whether to allow or deny traffic that matches the rule. [Allowed values: <code>allow<\/code>, <code>deny<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"egress","type":"boolean","description":"<p>Whether this rule applies to egress traffic from the subnet (<code>true<\/code>) or ingress traffic to the subnet (<code>false<\/code>).<\/p>"},{"@attributes":{"choice":"req"},"name":"cidr_block","type":"string","description":"<p>The CIDR range to allow or deny, in CIDR notation (e.g., <code>172.16.0.0\/24<\/code>).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Icmp<\/code> - <code>array<\/code> - Optional - ICMP values. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Type<\/code> - <code>integer<\/code> - Optional - For the ICMP protocol, the ICMP type. A value of <code>-1<\/code> is a wildcard meaning all types. Required if specifying <code>icmp<\/code> for the protocol.<\/li><li><code>Code<\/code> - <code>integer<\/code> - Optional - For the ICMP protocol, the ICMP code. A value of <code>-1<\/code> is a wildcard meaning all codes. Required if specifying <code>icmp<\/code> for the protocol.<\/li><\/ul><\/li><\/ul><\/li><li><code>PortRange<\/code> - <code>array<\/code> - Optional - Port ranges. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>From<\/code> - <code>integer<\/code> - Optional - The first port in the range. Required if specifying <code>tcp<\/code> or <code>udp<\/code> for the protocol.<\/li><li><code>To<\/code> - <code>integer<\/code> - Optional - The last port in the range. Required if specifying <code>tcp<\/code> or <code>udp<\/code> for the protocol.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_network_acl_entry($network_acl_id, $rule_number, $protocol, $rule_action, $egress, $cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkAclId'] = $network_acl_id;\n    $opt['RuleNumber'] = $rule_number;\n    $opt['Protocol'] = $protocol;\n    $opt['RuleAction'] = $rule_action;\n    $opt['Egress'] = $egress;\n    $opt['CidrBlock'] = $cidr_block;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Icmp']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Icmp' =&gt; $opt['Icmp']\n        )));\n        unset($opt['Icmp']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['PortRange']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'PortRange' =&gt; $opt['PortRange']\n        )));\n        unset($opt['PortRange']);\n    }\n\n    return $this-&gt;authenticate('CreateNetworkAclEntry', $opt);\n}","examples":{"example":{"title":"<p>Create a new entry in the Network Access Control List (ACL).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$tcp = 6;\n$response = $ec2-&gt;create_network_acl_entry('acl-4abf3f23', 1, $tcp, 'allow', 'true', '172.16.0.0\/24', array(\n\t'PortRange' =&gt; array(\n\t\t'From' =&gt; 80,\n\t\t'To' =&gt; 80\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"create_network_interface","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subnet_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - <\/li><li><code>SecurityGroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>PrivateIpAddresses<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Required - <\/li><li><code>Primary<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>SecondaryPrivateIpAddressCount<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_network_interface($subnet_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubnetId'] = $subnet_id;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['SecurityGroupId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))\n        )));\n        unset($opt['SecurityGroupId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['PrivateIpAddresses']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'PrivateIpAddresses' =&gt; $opt['PrivateIpAddresses']\n        )));\n        unset($opt['PrivateIpAddresses']);\n    }\n\n    return $this-&gt;authenticate('CreateNetworkInterface', $opt);\n}","examples":{"example":{"title":"<p>Create a new network interface.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_network_interface($subnet_id);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"create_placement_group","modifier":"public","description":"<p>Creates a <code>PlacementGroup<\/code> into which multiple Amazon EC2 instances can be launched.\nUsers must give the group a name unique within the scope of the user account.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>The name of the <code>PlacementGroup<\/code>.<\/p>"},{"@attributes":{"choice":"req"},"name":"strategy","type":"string","description":"<p>The <code>PlacementGroup<\/code> strategy. [Allowed values: <code>cluster<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_placement_group($group_name, $strategy, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['Strategy'] = $strategy;\n    \n    return $this-&gt;authenticate('CreatePlacementGroup', $opt);\n}","examples":{"example":{"title":"<p>Create a new cluster-compute placement group.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_placement_group('php-cluster', 'cluster');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_placement_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_placement_group\"><code>delete_placement_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_placement_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_placement_groups\"><code>describe_placement_groups()<\/code><\/a>"]}},{"name":"create_reserved_instances_listing","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"reserved_instances_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"instance_count","type":"integer","description":{}},{"@attributes":{"choice":"req"},"name":"price_schedules","type":"array","description":"<ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Term<\/code> - <code>long<\/code> - Optional - <\/li><li><code>Price<\/code> - <code>double<\/code> - Optional - <\/li><li><code>CurrencyCode<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul>"},{"@attributes":{"choice":"req"},"name":"client_token","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_reserved_instances_listing($reserved_instances_id, $instance_count, $price_schedules, $client_token, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ReservedInstancesId'] = $reserved_instances_id;\n    $opt['InstanceCount'] = $instance_count;\n    $opt['ClientToken'] = $client_token;\n    \n    \/\/ Required list + map\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'PriceSchedules' =&gt; (is_array($price_schedules) ? $price_schedules : array($price_schedules))\n    )));\n\n    return $this-&gt;authenticate('CreateReservedInstancesListing', $opt);\n}"},{"name":"create_route","modifier":"public","description":"<p>Creates a new route in a route table within a VPC. The route&#8217;s target can be either a gateway\nattached to the VPC or a NAT instance in the VPC.<\/p>\n\n<p>When determining how to route traffic, we use the route with the most specific match. For\nexample, let&#8217;s say the traffic is destined for <code>192.0.2.3<\/code>, and the route table\nincludes the following two routes:<\/p>\n\n<ul><li><code>192.0.2.0\/24<\/code> (goes to some target A)<\/li><li><code>192.0.2.0\/28<\/code> (goes to some target B)<\/li><\/ul>\n\n<p>Both routes apply to the traffic destined for <code>192.0.2.3<\/code>. However, the second route\nin the list is more specific, so we use that route to determine where to target the traffic.<\/p>\n\n<p>For more information about route tables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the route table where the route will be added.<\/p>"},{"@attributes":{"choice":"req"},"name":"destination_cidr_block","type":"string","description":"<p>The CIDR address block used for the destination match. For example: <code>0.0.0.0\/0<\/code>. Routing decisions are based on the most specific match.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayId<\/code> - <code>string<\/code> - Optional - The ID of a VPN or Internet gateway attached to your VPC. You must provide either <code>GatewayId<\/code> or <code>InstanceId<\/code>, but not both.<\/li><li><code>InstanceId<\/code> - <code>string<\/code> - Optional - The ID of a NAT instance in your VPC. You must provide either <code>GatewayId<\/code> or <code>InstanceId<\/code>, but not both.<\/li><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_route($route_table_id, $destination_cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    $opt['DestinationCidrBlock'] = $destination_cidr_block;\n    \n    return $this-&gt;authenticate('CreateRoute', $opt);\n}","examples":{"example":{"title":"<p>Create a new VPC route.<\/p>","description":"<p>Here is the flow:<\/p>\n\n<ol>\n<li>Create a new VPC with <a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a> and a CIDR block.<\/li>\n<li>Create a new Route Table with <a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>.<\/li>\n<li>Create a new Internet Gateway with <a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>.<\/li>\n<li>Attach the Internet Gateway to the VPC with <a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>.<\/li>\n<li>Create a new Route with <a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>.<\/li>\n<\/ol>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_route('rtb-e68b0b8f', '0.0.0.0\/0', array(\n\t'GatewayId' =&gt; 'igw-8c8e0ee5'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"create_route_table","modifier":"public","description":"<p>Creates a new route table within a VPC. After you create a new route table, you can add routes\nand associate the table with a subnet. For more information about route tables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC where the route table will be created.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_route_table($vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('CreateRouteTable', $opt);\n}","examples":{"example":{"title":"<p>Create a new VPC route table.<\/p>","description":"<p>Here is the flow:<\/p>\n\n<ol>\n<li>Create a new VPC with <a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a> and a CIDR block.<\/li>\n<li>Create a new Route Table with <a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>.<\/li>\n<li>Create a new Internet Gateway with <a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>.<\/li>\n<li>Attach the Internet Gateway to the VPC with <a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>.<\/li>\n<li>Create a new Route with <a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>.<\/li>\n<\/ol>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_route_table('vpc-7e7dfc17');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"create_security_group","modifier":"public","description":"<p>The CreateSecurityGroup operation creates a new security group.<\/p>\n\n<p>Every instance is launched in a security group. If no security group is specified during\nlaunch, the instances are launched in the default security group. Instances within the same\nsecurity group have unrestricted network access to each other. Instances will reject network\naccess attempts from other instances in a different security group. As the owner of instances\nyou can grant or revoke specific permissions using the AuthorizeSecurityGroupIngress and\nRevokeSecurityGroupIngress operations.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the security group.<\/p>"},{"@attributes":{"choice":"req"},"name":"group_description","type":"string","description":"<p>Description of the group. This is informational only.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VpcId<\/code> - <code>string<\/code> - Optional - ID of the VPC.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_security_group($group_name, $group_description, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['GroupDescription'] = $group_description;\n    \n    return $this-&gt;authenticate('CreateSecurityGroup', $opt);\n}","examples":{"example":[{"title":"<p>Create a new security group.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_security_group('my-security-group', 'This is a test description.');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Security groups only support US-ASCII characters.<\/p>","description":"<p>The example below will fail with an error.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_security_group('my-security-group', '&aring;&eacute;&icirc;&oslash;&uuml;&iexcl;&trade;&pound;&cent;&infin;&sect;&para;&bull;&ordf;&ordm;&ndash;&ne;');\n\nvar_dump($response-&gt;isOK());","result":"bool(false)"},{"title":"<p>Create a new security group for a VPC.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_security_group('my-vpc-security-group', 'This is a test VPC description', array(\n\t'VpcId' =&gt; 'vpc-fd7cd194'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]}},{"name":"create_snapshot","modifier":"public","description":"<p>Create a snapshot of the volume identified by volume ID. A volume does not have to be detached\nat the time the snapshot is taken.<\/p>\n\n<p class=\"note\">\nSnapshot creation requires that the system is in a consistent state. For instance, this means\nthat if taking a snapshot of a database, the tables must be read-only locked to ensure that the\nsnapshot will not contain a corrupted version of the database. Therefore, be careful when using\nthis API to ensure that the system remains in the consistent state until the create snapshot\nstatus has returned.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":"<p>The ID of the volume from which to create the snapshot.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - The description for the new snapshot.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_snapshot($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('CreateSnapshot', $opt);\n}","examples":{"example":{"title":"<p>Create a snapshot from an EBS volume.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Create the snapshot\n$response = $ec2-&gt;create_snapshot('vol-fc482995', array(\n\t'Description' =&gt; 'my-snapshot'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-CreateSnapshot.html\">CreateSnapshot<\/a> operation introduced backwards-incompatible changes in the <code>2011-02-28<\/code> API release. The <code>Description<\/code> parameter is no longer required.<\/p>"}},{"name":"create_spot_datafeed_subscription","modifier":"public","description":"<p>Creates the data feed for Spot Instances, enabling you to view Spot Instance usage logs. You\ncan create one data feed per account.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The Amazon S3 bucket in which to store the Spot Instance datafeed.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Prefix<\/code> - <code>string<\/code> - Optional - The prefix that is prepended to datafeed files.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_spot_datafeed_subscription($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Bucket'] = $bucket;\n    \n    return $this-&gt;authenticate('CreateSpotDatafeedSubscription', $opt);\n}","examples":{"example":{"title":"<p>Create a new spot datafeed subscription.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_spot_datafeed_subscription('my-spot-bucket', array(\n\t'Prefix' =&gt; 'spot_data_'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"create_subnet","modifier":"public","description":"<p>Creates a subnet in an existing VPC. You can create up to 20 subnets in a VPC. If you add more\nthan one subnet to a VPC, they&#8217;re set up in a star topology with a logical router in the\nmiddle. When you create each subnet, you provide the VPC ID and the CIDR block you want for the\nsubnet. Once you create a subnet, you can&#8217;t change its CIDR block. The subnet&#8217;s CIDR block can\nbe the same as the VPC&#8217;s CIDR block (assuming you want only a single subnet in the VPC), or a\nsubset of the VPC&#8217;s CIDR block. If you create more than one subnet in a VPC, the subnets&#8217; CIDR\nblocks must not overlap. The smallest subnet (and VPC) you can create uses a <code>\/28<\/code>\nnetmask (16 IP addresses), and the largest uses a <code>\/18<\/code> netmask (16,384 IP\naddresses).<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>AWS reserves both the first four and the last IP address in each subnet&#8217;s CIDR block. They&#8217;re\nnot available for use.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC to create the subnet in.<\/p>"},{"@attributes":{"choice":"req"},"name":"cidr_block","type":"string","description":"<p>The CIDR block the subnet is to cover.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The Availability Zone to create the subnet in.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_subnet($vpc_id, $cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    $opt['CidrBlock'] = $cidr_block;\n    \n    return $this-&gt;authenticate('CreateSubnet', $opt);\n}","examples":{"example":{"title":"<p>Create a new subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_subnet('vpc-fd7cd194', '10.0.0.0\/24', array(\n\t'AvailabilityZone' =&gt; 'us-east-1b',\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_subnet.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_subnet\"><code>delete_subnet()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_subnets.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_subnets\"><code>describe_subnets()<\/code><\/a>"]}},{"name":"create_tags","modifier":"public","description":"<p>Adds or overwrites tags for the specified resources. Each resource can have a maximum of 10\ntags. Each tag consists of a key-value pair. Tag keys must be unique per resource.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"resource_id","type":"string|array","description":"<p>One or more IDs of resources to tag. This could be the ID of an AMI, an instance, an EBS volume, or snapshot, etc. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"req"},"name":"tag","type":"array","description":"<p>The tags to add or overwrite for the specified resources. Each tag item consists of a key-value pair.<\/p>\n\n<ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Key<\/code> - <code>string<\/code> - Optional - The tag&#8217;s key.<\/li><li><code>Value<\/code> - <code>string<\/code> - Optional - The tag&#8217;s value.<\/li><\/ul><\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_tags($resource_id, $tag, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'ResourceId' =&gt; (is_array($resource_id) ? $resource_id : array($resource_id))\n    )));\n    \n    \/\/ Required list + map\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'Tag' =&gt; (is_array($tag) ? $tag : array($tag))\n    )));\n\n    return $this-&gt;authenticate('CreateTags', $opt);\n}","examples":{"example":{"title":"<p>Create new tags for a given resource ID.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_tags('aki-00006369', array(\n\tarray('Key' =&gt; 'alpha', 'Value' =&gt; 'abc'),\n\tarray('Key' =&gt; 'alpha', 'Value' =&gt; 'def'),\n\tarray('Key' =&gt; 'beta', 'Value' =&gt; 'ghi'),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_tags\"><code>delete_tags()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_tags\"><code>describe_tags()<\/code><\/a>"]}},{"name":"create_volume","modifier":"public","description":"<p>Initializes an empty volume of a given size.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"availability_zone","type":"string","description":"<p>The Availability Zone in which to create the new volume.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Size<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes. Required if you are not creating a volume from a snapshot.<\/li><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which to create the new volume.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_volume($availability_zone, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AvailabilityZone'] = $availability_zone;\n    \n    return $this-&gt;authenticate('CreateVolume', $opt);\n}","examples":{"example":{"title":"<p>Create a new volume in the same availability zone as a running instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Describe the running instance to get the Availability Zone\n$describe = $ec2-&gt;describe_instances(array(\n\t'InstanceId' =&gt; 'i-1f549375'\n));\n\n\/\/ Grab the Availability Zone\n$avail_zone = (string) $describe-&gt;body-&gt;availabilityZone(0); \/\/ First result of the built-in XPath search.\n\n\/\/ Create the volume\n$response = $ec2-&gt;create_volume($avail_zone, array(\n\t'Size' =&gt; 10 \/\/ Gibibytes\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"create_vpc","modifier":"public","description":"<p>Creates a VPC with the CIDR block you specify. The smallest VPC you can create uses a\n<code>\/28<\/code> netmask (16 IP addresses), and the largest uses a <code>\/18<\/code> netmask\n(16,384 IP addresses). To help you decide how big to make your VPC, go to the topic about\ncreating VPCs in the Amazon Virtual Private Cloud Developer Guide.<\/p>\n\n<p>By default, each instance you launch in the VPC has the default DHCP options (the standard EC2\nhost name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type).<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cidr_block","type":"string","description":"<p>A valid CIDR block.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceTenancy<\/code> - <code>string<\/code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means instances must be launched with tenancy as dedicated.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_vpc($cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['CidrBlock'] = $cidr_block;\n    \n    return $this-&gt;authenticate('CreateVpc', $opt);\n}","examples":{"example":{"title":"<p>Create a new virtual private cloud.<\/p>","description":"<p>Here is the flow:<\/p>\n\n<ol>\n<li>Create a new VPC with <a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a> and a CIDR block.<\/li>\n<li>Create a new Route Table with <a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>.<\/li>\n<li>Create a new Internet Gateway with <a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>.<\/li>\n<li>Attach the Internet Gateway to the VPC with <a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>.<\/li>\n<li>Create a new Route with <a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>.<\/li>\n<\/ol>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_vpc('10.0.0.0\/20');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpc\"><code>delete_vpc()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpcs.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpcs\"><code>describe_vpcs()<\/code><\/a>"]}},{"name":"create_vpn_connection","modifier":"public","description":"<p>Creates a new VPN connection between an existing VPN gateway and customer gateway. The only\nsupported connection type is ipsec.1.<\/p>\n\n<p>The response includes information that you need to configure your customer gateway, in XML\nformat. We recommend you use the command line version of this operation\n(<code>ec2-create-vpn-connection<\/code>), which takes an <code>-f<\/code> option (for format)\nand returns configuration information formatted as expected by the vendor you specified, or in\na generic, human readable format. For information about the command, go to\n<code>ec2-create-vpn-connection<\/code> in the Amazon Virtual Private Cloud Command Line\nReference.<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>We strongly recommend you use HTTPS when calling this operation because the response contains\nsensitive cryptographic information for configuring your customer gateway.<\/p>\n\n<p>If you decide to shut down your VPN connection for any reason and then create a new one, you\nmust re-configure your customer gateway with the new information returned from this call.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of VPN connection.<\/p>"},{"@attributes":{"choice":"req"},"name":"customer_gateway_id","type":"string","description":"<p>The ID of the customer gateway.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpn_gateway_id","type":"string","description":"<p>The ID of the VPN gateway.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Options<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>StaticRoutesOnly<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_vpn_connection($type, $customer_gateway_id, $vpn_gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Type'] = $type;\n    $opt['CustomerGatewayId'] = $customer_gateway_id;\n    $opt['VpnGatewayId'] = $vpn_gateway_id;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Options']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Options' =&gt; $opt['Options']\n        )));\n        unset($opt['Options']);\n    }\n\n    return $this-&gt;authenticate('CreateVpnConnection', $opt);\n}","examples":{"example":{"title":"<p>Create a new VPN connection.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_vpn_connection('ipsec.1', 'cgw-10a84c79', 'vgw-9aa347f3');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/delete_vpn_connection.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_connection\"><code>delete_vpn_connection()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_connections.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_connections\"><code>describe_vpn_connections()<\/code><\/a>"]}},{"name":"create_vpn_connection_route","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_connection_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"destination_cidr_block","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_vpn_connection_route($vpn_connection_id, $destination_cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnConnectionId'] = $vpn_connection_id;\n    $opt['DestinationCidrBlock'] = $destination_cidr_block;\n    \n    return $this-&gt;authenticate('CreateVpnConnectionRoute', $opt);\n}"},{"name":"create_vpn_gateway","modifier":"public","description":"<p>Creates a new VPN gateway. A VPN gateway is the VPC-side endpoint for your VPN connection. You\ncan create a VPN gateway before creating the VPC itself.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of VPN connection this VPN gateway supports.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The Availability Zone in which to create the VPN gateway.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_vpn_gateway($type, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Type'] = $type;\n    \n    return $this-&gt;authenticate('CreateVpnGateway', $opt);\n}","examples":{"example":{"title":"<p>Create a new VPN gateway.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;create_vpn_gateway('ipsec.1', array(\n\t'AvailabilityZone' =&gt; 'us-east-1b',\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_vpn_gateway\"><code>attach_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_gateway\"><code>delete_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_gateways\"><code>describe_vpn_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_vpn_gateway\"><code>detach_vpn_gateway()<\/code><\/a>"]}},{"name":"deactivate_license","modifier":"public","description":"<p>Deactivates a specific number of licenses. Deactivations can be done against a specific license\nID after they have persisted for at least a 90-day period.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"license_id","type":"string","description":"<p>Specifies the ID for the specific license to deactivate against.<\/p>"},{"@attributes":{"choice":"req"},"name":"capacity","type":"integer","description":"<p>Specifies the amount of capacity to deactivate against the license.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deactivate_license($license_id, $capacity, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['LicenseId'] = $license_id;\n    $opt['Capacity'] = $capacity;\n    \n    return $this-&gt;authenticate('DeactivateLicense', $opt);\n}","examples":{"example":{"title":"<p>Deactivate a Microsoft\u00ae Windows\u00ae license.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;deactivate_license('lic-1234abcd', 1);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/activate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/activate_license\"><code>activate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/bundle_instance.html\" rel=\"..\/..\/index.html#m=amazonec2\/bundle_instance\"><code>bundle_instance()<\/code><\/a>","<a href=\"..\/amazonec2\/cancel_bundle_task.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_bundle_task\"><code>cancel_bundle_task()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_bundle_tasks.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_bundle_tasks\"><code>describe_bundle_tasks()<\/code><\/a>","<a href=\"..\/amazonec2\/get_password_data.html\" rel=\"..\/..\/index.html#m=amazonec2\/get_password_data\"><code>get_password_data()<\/code><\/a>"]}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_customer_gateway","modifier":"public","description":"<p>Deletes a customer gateway. You must delete the VPN connection before deleting the customer\ngateway.<\/p>\n\n<p>You can have a single active customer gateway per AWS account (active means that you&#8217;ve created\na VPN connection with that customer gateway). AWS might delete any customer gateway you leave\ninactive for an extended period of time.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"customer_gateway_id","type":"string","description":"<p>The ID of the customer gateway to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_customer_gateway($customer_gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['CustomerGatewayId'] = $customer_gateway_id;\n    \n    return $this-&gt;authenticate('DeleteCustomerGateway', $opt);\n}","examples":{"example":{"title":"<p>Delete a customer gateway.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Delete the customer gateway\n$response = $ec2-&gt;delete_customer_gateway('cgw-10a84c79');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_customer_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_customer_gateway\"><code>create_customer_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_customer_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_customer_gateways\"><code>describe_customer_gateways()<\/code><\/a>"]}},{"name":"delete_dhcp_options","modifier":"public","description":"<p>Deletes a set of DHCP options that you specify. Amazon VPC returns an error if the set of\noptions you specify is currently associated with a VPC. You can disassociate the set of options\nby associating either a new set of options or the default options with the VPC.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"dhcp_options_id","type":"string","description":"<p>The ID of the DHCP options set to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_dhcp_options($dhcp_options_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['DhcpOptionsId'] = $dhcp_options_id;\n    \n    return $this-&gt;authenticate('DeleteDhcpOptions', $opt);\n}","examples":{"example":{"title":"<p>Delete a set of DHCP options.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response1 = $ec2-&gt;associate_dhcp_options('default', 'vpc-abcd1234');\n\nsleep(10);\n\n$response2 = $ec2-&gt;delete_dhcp_options('dopt-427bd62b');\n\nvar_dump($response2-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_dhcp_options\"><code>associate_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/create_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_dhcp_options\"><code>create_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_dhcp_options\"><code>describe_dhcp_options()<\/code><\/a>"]}},{"name":"delete_internet_gateway","modifier":"public","description":"<p>Deletes an Internet gateway from your AWS account. The gateway must not be attached to a VPC.\nFor more information about your VPC and Internet gateway, go to Amazon Virtual Private Cloud\nUser Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"internet_gateway_id","type":"string","description":"<p>The ID of the Internet gateway to be deleted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_internet_gateway($internet_gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InternetGatewayId'] = $internet_gateway_id;\n    \n    return $this-&gt;authenticate('DeleteInternetGateway', $opt);\n}","examples":{"example":{"title":"<p>Delete an internet gateway.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_internet_gateway('igw-be7cfdd7');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_internet_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_internet_gateways\"><code>describe_internet_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_internet_gateway\"><code>detach_internet_gateway()<\/code><\/a>"]}},{"name":"delete_key_pair","modifier":"public","description":"<p>The DeleteKeyPair operation deletes a key pair.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"key_name","type":"string","description":"<p>The name of the Amazon EC2 key pair to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_key_pair($key_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['KeyName'] = $key_name;\n    \n    return $this-&gt;authenticate('DeleteKeyPair', $opt);\n}","examples":{"example":{"title":"<p>Delete a key pair.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_key_pair('my-keypair');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_key_pair\"><code>create_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_key_pairs.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_key_pairs\"><code>describe_key_pairs()<\/code><\/a>","<a href=\"..\/amazonec2\/import_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/import_key_pair\"><code>import_key_pair()<\/code><\/a>"]}},{"name":"delete_network_acl","modifier":"public","description":"<p>Deletes a network ACL from a VPC. The ACL must not have any subnets associated with it. You\ncan&#8217;t delete the default network ACL. For more information about network ACLs, go to Network\nACLs in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_acl_id","type":"string","description":"<p>The ID of the network ACL to be deleted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_network_acl($network_acl_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkAclId'] = $network_acl_id;\n    \n    return $this-&gt;authenticate('DeleteNetworkAcl', $opt);\n}","examples":{"example":{"title":"<p>Delete a Network Access Control List (ACL).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_network_acl('acl-4abf3f23');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"delete_network_acl_entry","modifier":"public","description":"<p>Deletes an ingress or egress entry (i.e., rule) from a network ACL. For more information about\nnetwork ACLs, go to Network ACLs in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_acl_id","type":"string","description":"<p>ID of the network ACL.<\/p>"},{"@attributes":{"choice":"req"},"name":"rule_number","type":"integer","description":"<p>Rule number for the entry to delete.<\/p>"},{"@attributes":{"choice":"req"},"name":"egress","type":"boolean","description":"<p>Whether the rule to delete is an egress rule (<code>true<\/code>) or ingress rule (<code>false<\/code>).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_network_acl_entry($network_acl_id, $rule_number, $egress, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkAclId'] = $network_acl_id;\n    $opt['RuleNumber'] = $rule_number;\n    $opt['Egress'] = $egress;\n    \n    return $this-&gt;authenticate('DeleteNetworkAclEntry', $opt);\n}","examples":{"example":{"title":"<p>Delete an entry in the Network Access Control List (ACL).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_network_acl_entry('acl-4abf3f23', 1, 'true');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"delete_network_interface","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_network_interface($network_interface_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    return $this-&gt;authenticate('DeleteNetworkInterface', $opt);\n}","examples":{"example":{"title":"<p>Create a new network interface.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_network_interface($network_interface_id);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"delete_placement_group","modifier":"public","description":"<p>Deletes a <code>PlacementGroup<\/code> from a user&#8217;s account. Terminate all Amazon EC2 instances\nin the placement group before deletion.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>The name of the <code>PlacementGroup<\/code> to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_placement_group($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('DeletePlacementGroup', $opt);\n}","examples":{"example":{"title":"<p>Delete a cluster-compute placement group.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_placement_group('php-cluster');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_placement_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_placement_group\"><code>create_placement_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_placement_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_placement_groups\"><code>describe_placement_groups()<\/code><\/a>"]}},{"name":"delete_route","modifier":"public","description":"<p>Deletes a route from a route table in a VPC. For more information about route tables, go to\n<a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the route table where the route will be deleted.<\/p>"},{"@attributes":{"choice":"req"},"name":"destination_cidr_block","type":"string","description":"<p>The CIDR range for the route you want to delete. The value you specify must exactly match the CIDR for the route you want to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_route($route_table_id, $destination_cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    $opt['DestinationCidrBlock'] = $destination_cidr_block;\n    \n    return $this-&gt;authenticate('DeleteRoute', $opt);\n}","examples":{"example":{"title":"<p>Delete a VPC route.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_route('rtb-e68b0b8f', '0.0.0.0\/0');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"delete_route_table","modifier":"public","description":"<p>Deletes a route table from a VPC. The route table must not be associated with a subnet. You\ncan&#8217;t delete the main route table. For more information about route tables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the route table to be deleted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_route_table($route_table_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    \n    return $this-&gt;authenticate('DeleteRouteTable', $opt);\n}","examples":{"example":{"title":"<p>Delete a VPC route table.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_route_table('rtb-e68b0b8f');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"delete_security_group","modifier":"public","description":"<p>The DeleteSecurityGroup operation deletes a security group.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>If you attempt to delete a security group that contains instances, a fault is returned.<\/p>\n\n<p>If you attempt to delete a security group that is referenced by another security group, a fault\nis returned. For example, if security group B has a rule that allows access from security group\nA, security group A cannot be deleted until the allow rule is removed.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GroupName<\/code> - <code>string<\/code> - Optional - The name of the Amazon EC2 security group to delete.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - The ID of the Amazon EC2 security group to delete.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_security_group($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('DeleteSecurityGroup', $opt);\n}","examples":{"example":{"title":"<p>Delete a security group.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_security_group(array('GroupName' =&gt; 'my-security-group'));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]}},{"name":"delete_snapshot","modifier":"public","description":"<p>Deletes the snapshot identified by <code>snapshotId<\/code>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"snapshot_id","type":"string","description":"<p>The ID of the snapshot to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_snapshot($snapshot_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SnapshotId'] = $snapshot_id;\n    \n    return $this-&gt;authenticate('DeleteSnapshot', $opt);\n}","examples":{"example":{"title":"<p>Delete a snapshot.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_snapshot('snap-a99b8bc1');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"delete_spot_datafeed_subscription","modifier":"public","description":"<p>Deletes the data feed for Spot Instances.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_spot_datafeed_subscription($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('DeleteSpotDatafeedSubscription', $opt);\n}","examples":{"example":{"title":"<p>Delete a spot datafeed subscription.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_spot_datafeed_subscription();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"delete_subnet","modifier":"public","description":"<p>Deletes a subnet from a VPC. You must terminate all running instances in the subnet before\ndeleting it, otherwise Amazon VPC returns an error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subnet_id","type":"string","description":"<p>The ID of the subnet you want to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_subnet($subnet_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubnetId'] = $subnet_id;\n    \n    return $this-&gt;authenticate('DeleteSubnet', $opt);\n}","examples":{"example":{"title":"<p>Delete a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $response = $ec2-&gt;delete_subnet('subnet-2d78d544');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_subnet.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_subnet\"><code>create_subnet()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_subnets.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_subnets\"><code>describe_subnets()<\/code><\/a>"]}},{"name":"delete_tags","modifier":"public","description":"<p>Deletes tags from the specified Amazon EC2 resources.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"resource_id","type":"string|array","description":"<p>A list of one or more resource IDs. This could be the ID of an AMI, an instance, an EBS volume, or snapshot, etc. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Tag<\/code> - <code>array<\/code> - Optional - The tags to delete from the specified resources. Each tag item consists of a key-value pair. If a tag is specified without a value, the tag and all of its values are deleted. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Key<\/code> - <code>string<\/code> - Optional - The tag&#8217;s key.<\/li><li><code>Value<\/code> - <code>string<\/code> - Optional - The tag&#8217;s value.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_tags($resource_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'ResourceId' =&gt; (is_array($resource_id) ? $resource_id : array($resource_id))\n    )));\n\n    \/\/ Optional list + map\n    if (isset($opt['Tag']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Tag' =&gt; $opt['Tag']\n        )));\n        unset($opt['Tag']);\n    }\n\n    return $this-&gt;authenticate('DeleteTags', $opt);\n}","examples":{"example":{"title":"<p>Delete a tag.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_tags('aki-00006369', array(\n\t'Tag' =&gt; array(\n\t\tarray('Key' =&gt; 'alpha', 'Value' =&gt; 'abc'),\n\t\tarray('Key' =&gt; 'alpha', 'Value' =&gt; 'def'),\n\t\tarray('Key' =&gt; 'beta', 'Value' =&gt; 'ghi'),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_tags\"><code>create_tags()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_tags\"><code>describe_tags()<\/code><\/a>"]}},{"name":"delete_volume","modifier":"public","description":"<p>Deletes a previously created volume. Once successfully deleted, a new volume can be created\nwith the same name.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":"<p>The ID of the EBS volume to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_volume($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('DeleteVolume', $opt);\n}","examples":{"example":{"title":"<p>Delete an EBS volume.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Delete the volume\n$response = $ec2-&gt;delete_volume('vol-fc482995');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"delete_vpc","modifier":"public","description":"<p>Deletes a VPC. You must detach or delete all gateways or other objects that are dependent on\nthe VPC first. For example, you must terminate all running instances, delete all VPC security\ngroups (except the default), delete all the route tables (except the default), etc.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC you want to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_vpc($vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('DeleteVpc', $opt);\n}","examples":{"example":{"title":"<p>Delete a VPC.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Delete the VPC\n$response = $ec2-&gt;delete_vpc('vpc-abcd1234');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpcs.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpcs\"><code>describe_vpcs()<\/code><\/a>"]}},{"name":"delete_vpn_connection","modifier":"public","description":"<p>Deletes a VPN connection. Use this if you want to delete a VPC and all its associated\ncomponents. Another reason to use this operation is if you believe the tunnel credentials for\nyour VPN connection have been compromised. In that situation, you can delete the VPN connection\nand create a new one that has new keys, without needing to delete the VPC or VPN gateway. If\nyou create a new VPN connection, you must reconfigure the customer gateway using the new\nconfiguration information returned with the new VPN connection ID.<\/p>\n\n<p>If you&#8217;re deleting the VPC and all its associated parts, we recommend you detach the VPN\ngateway from the VPC and delete the VPC before deleting the VPN connection.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_connection_id","type":"string","description":"<p>The ID of the VPN connection to delete<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_vpn_connection($vpn_connection_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnConnectionId'] = $vpn_connection_id;\n    \n    return $this-&gt;authenticate('DeleteVpnConnection', $opt);\n}","examples":{"example":{"title":"<p>Delete a VPN connection.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;delete_vpn_connection('vpn-44a8938f');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_vpn_connection.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_connection\"><code>create_vpn_connection()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_connections.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_connections\"><code>describe_vpn_connections()<\/code><\/a>"]}},{"name":"delete_vpn_connection_route","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_connection_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"destination_cidr_block","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_vpn_connection_route($vpn_connection_id, $destination_cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnConnectionId'] = $vpn_connection_id;\n    $opt['DestinationCidrBlock'] = $destination_cidr_block;\n    \n    return $this-&gt;authenticate('DeleteVpnConnectionRoute', $opt);\n}"},{"name":"delete_vpn_gateway","modifier":"public","description":"<p>Deletes a VPN gateway. Use this when you want to delete a VPC and all its associated components\nbecause you no longer need them. We recommend that before you delete a VPN gateway, you detach\nit from the VPC and delete the VPN connection. Note that you don&#8217;t need to delete the VPN\ngateway if you just want to delete and re-create the VPN connection between your VPC and data\ncenter.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_gateway_id","type":"string","description":"<p>The ID of the VPN gateway to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_vpn_gateway($vpn_gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnGatewayId'] = $vpn_gateway_id;\n    \n    return $this-&gt;authenticate('DeleteVpnGateway', $opt);\n}","examples":{"example":{"title":"<p>Delete a VPN gateway.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Delete the VPN gateway\n$response = $ec2-&gt;delete_vpn_gateway('vgw-42ad482b');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_vpn_gateway\"><code>attach_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_gateway\"><code>create_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_gateways\"><code>describe_vpn_gateways()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_vpn_gateway\"><code>detach_vpn_gateway()<\/code><\/a>"]}},{"name":"deregister_image","modifier":"public","description":"<p>The DeregisterImage operation deregisters an AMI. Once deregistered, instances of the AMI can\nno longer be launched.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"image_id","type":"string","description":"<p>The ID of the AMI to deregister.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deregister_image($image_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ImageId'] = $image_id;\n    \n    return $this-&gt;authenticate('DeregisterImage', $opt);\n}","examples":{"example":{"title":"<p>Deregister an image.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Deregister the image\n$response = $ec2-&gt;deregister_image('ami-42ad462b');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]}},{"name":"describe_account_attributes","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AttributeName<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_account_attributes($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['AttributeName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'AttributeName' =&gt; (is_array($opt['AttributeName']) ? $opt['AttributeName'] : array($opt['AttributeName']))\n        )));\n        unset($opt['AttributeName']);\n    }\n\n    return $this-&gt;authenticate('DescribeAccountAttributes', $opt);\n}"},{"name":"describe_addresses","modifier":"public","description":"<p>The DescribeAddresses operation lists elastic IP addresses assigned to your account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PublicIp<\/code> - <code>string|array<\/code> - Optional - The optional list of Elastic IP addresses to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Addresses. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>AllocationId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_addresses($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['PublicIp']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'PublicIp' =&gt; (is_array($opt['PublicIp']) ? $opt['PublicIp'] : array($opt['PublicIp']))\n        )));\n        unset($opt['PublicIp']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['AllocationId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'AllocationId' =&gt; (is_array($opt['AllocationId']) ? $opt['AllocationId'] : array($opt['AllocationId']))\n        )));\n        unset($opt['AllocationId']);\n    }\n\n    return $this-&gt;authenticate('DescribeAddresses', $opt);\n}","examples":{"example":[{"title":"<p>Describe all IP addresses.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_addresses();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe a specific group of IP addresses.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_addresses();\n$ip_addresses = array();\n\n\/\/ Collect existing IP addresses to describe\nif ($response-&gt;body-&gt;addressesSet-&gt;item)\n{\n\tforeach ($response-&gt;body-&gt;addressesSet-&gt;item as $item)\n\t{\n\t\t$ip_addresses[] = (string) $item-&gt;publicIp;\n\t}\n}\n\n\/\/ Describe the group of IP addresses\n$response = $ec2-&gt;describe_addresses(array(\n\t'PublicIp' =&gt; $ip_addresses\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter IP addresses.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_addresses(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'public-ip')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/allocate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/allocate_address\"><code>allocate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/associate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_address\"><code>associate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_address\"><code>disassociate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/release_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/release_address\"><code>release_address()<\/code><\/a>"]}},{"name":"describe_availability_zones","modifier":"public","description":"<p>The DescribeAvailabilityZones operation describes availability zones that are currently\navailable to the account and their states.<\/p>\n\n<p>Availability zones are not the same across accounts. The availability zone\n<code>us-east-1a<\/code> for account A is not necessarily the same as <code>us-east-1a<\/code>\nfor account B. Zone assignments are mapped independently for each account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ZoneName<\/code> - <code>string|array<\/code> - Optional - A list of the availability zone names to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for AvailabilityZones. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_availability_zones($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['ZoneName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ZoneName' =&gt; (is_array($opt['ZoneName']) ? $opt['ZoneName'] : array($opt['ZoneName']))\n        )));\n        unset($opt['ZoneName']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeAvailabilityZones', $opt);\n}","examples":{"example":[{"title":"<p>Describe all availability zones.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_availability_zones();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe a single availability zone.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_availability_zones(array(\n\t'ZoneName' =&gt; 'us-east-1a'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe multiple availability zones.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_availability_zones(array(\n\t'ZoneName' =&gt; array(\n\t\t'us-east-1a',\n\t\t'us-east-1b',\n\t\t'us-east-1c'\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter availability zones.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_availability_zones(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":"<a href=\"..\/amazonec2\/describe_regions.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_regions\"><code>describe_regions()<\/code><\/a>"}},{"name":"describe_bundle_tasks","modifier":"public","description":"<p>The DescribeBundleTasks operation describes in-progress and recent bundle tasks. Complete and\nfailed tasks are removed from the list a short time after completion. If no bundle ids are\ngiven, all bundle tasks are returned.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>BundleId<\/code> - <code>string|array<\/code> - Optional - The list of bundle task IDs to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for BundleTasks. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_bundle_tasks($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['BundleId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'BundleId' =&gt; (is_array($opt['BundleId']) ? $opt['BundleId'] : array($opt['BundleId']))\n        )));\n        unset($opt['BundleId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeBundleTasks', $opt);\n}","examples":{"example":[{"title":"<p>Describe the current bundle tasks.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_bundle_tasks();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter bundle tasks.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_bundle_tasks(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'completed')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/activate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/activate_license\"><code>activate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/bundle_instance.html\" rel=\"..\/..\/index.html#m=amazonec2\/bundle_instance\"><code>bundle_instance()<\/code><\/a>","<a href=\"..\/amazonec2\/cancel_bundle_task.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_bundle_task\"><code>cancel_bundle_task()<\/code><\/a>","<a href=\"..\/amazonec2\/deactivate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/deactivate_license\"><code>deactivate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/get_password_data.html\" rel=\"..\/..\/index.html#m=amazonec2\/get_password_data\"><code>get_password_data()<\/code><\/a>"]}},{"name":"describe_conversion_tasks","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Filter<\/code> - <code>array<\/code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*<\/code> specifies that zero or more characters must match, and <code>?<\/code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\\*amazon\\?\\\\<\/code> specifies the literal string <code>*amazon?\\<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>ConversionTaskId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_conversion_tasks($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['ConversionTaskId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ConversionTaskId' =&gt; (is_array($opt['ConversionTaskId']) ? $opt['ConversionTaskId'] : array($opt['ConversionTaskId']))\n        )));\n        unset($opt['ConversionTaskId']);\n    }\n\n    return $this-&gt;authenticate('DescribeConversionTasks', $opt);\n}"},{"name":"describe_customer_gateways","modifier":"public","description":"<p>Gives you information about your customer gateways. You can filter the results to return\ninformation only about customer gateways that match criteria you specify. For example, you\ncould ask to get information about a particular customer gateway (or all) only if the gateway&#8217;s\nstate is pending or available. You can specify multiple filters (e.g., the customer gateway has\na particular IP address for the Internet-routable external interface, and the gateway&#8217;s state\nis pending or available). The result includes information for a particular customer gateway\nonly if the gateway matches all your filters. If there&#8217;s no match, no special message is\nreturned; the response is simply empty. The following table shows the available filters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>CustomerGatewayId<\/code> - <code>string|array<\/code> - Optional - A set of one or more customer gateway IDs. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Customer Gateways. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_customer_gateways($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['CustomerGatewayId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'CustomerGatewayId' =&gt; (is_array($opt['CustomerGatewayId']) ? $opt['CustomerGatewayId'] : array($opt['CustomerGatewayId']))\n        )));\n        unset($opt['CustomerGatewayId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeCustomerGateways', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPC customer gateways.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_customer_gateways();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter customer VPC gateways.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_customer_gateways(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available'),\n\t\tarray('Name' =&gt; 'type', 'Value' =&gt; 'ipsec.1'),\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_customer_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_customer_gateway\"><code>create_customer_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_customer_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_customer_gateway\"><code>delete_customer_gateway()<\/code><\/a>"]}},{"name":"describe_dhcp_options","modifier":"public","description":"<p>Gives you information about one or more sets of DHCP options. You can specify one or more DHCP\noptions set IDs, or no IDs (to describe all your sets of DHCP options). The returned\ninformation consists of:<\/p>\n\n<ul><li>The DHCP options set ID<\/li><li>The options<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>DhcpOptionsId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for DhcpOptions. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_dhcp_options($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['DhcpOptionsId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'DhcpOptionsId' =&gt; (is_array($opt['DhcpOptionsId']) ? $opt['DhcpOptionsId'] : array($opt['DhcpOptionsId']))\n        )));\n        unset($opt['DhcpOptionsId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeDhcpOptions', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPC DHCP options.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_dhcp_options();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter VPC DHCP options by tags matching multiple values.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_dhcp_options(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'tag:Purpose', 'Value' =&gt; array('X', 'Y')),\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/associate_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_dhcp_options\"><code>associate_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/create_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_dhcp_options\"><code>create_dhcp_options()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_dhcp_options.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_dhcp_options\"><code>delete_dhcp_options()<\/code><\/a>"]}},{"name":"describe_export_tasks","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ExportTaskId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_export_tasks($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['ExportTaskId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ExportTaskId' =&gt; (is_array($opt['ExportTaskId']) ? $opt['ExportTaskId'] : array($opt['ExportTaskId']))\n        )));\n        unset($opt['ExportTaskId']);\n    }\n\n    return $this-&gt;authenticate('DescribeExportTasks', $opt);\n}","examples":{"example":{"title":"<p>EC2 - Describe Export Tasks<\/p>","code":"\/\/ Dependencies\nrequire_once dirname(__FILE__) . '\/..\/..\/sdk.class.php';\nrequire_once dirname(__FILE__) . '\/..\/testutil.inc.php';\n\n\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_export_tasks();\n\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_image_attribute","modifier":"public","description":"<p>The DescribeImageAttribute operation returns information about an attribute of an AMI. Only one\nattribute can be specified per call.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"image_id","type":"string","description":"<p>The ID of the AMI whose attribute is to be described.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the attribute to describe. Available attribute names: <code>productCodes<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>launchPermisson<\/code>, <code>blockDeviceMapping<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_image_attribute($image_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ImageId'] = $image_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('DescribeImageAttribute', $opt);\n}","examples":{"example":{"title":"<p>Describe the attributes of a given image.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_image_attribute('ami-42ad462b', 'productCodes');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]}},{"name":"describe_images","modifier":"public","description":"<p>The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the\nuser. Information returned includes image type, product codes, architecture, and kernel and RAM\ndisk IDs. Images available to the user include public images available for any user to launch,\nprivate images owned by the user making the request, and private images owned by other users\nfor which the user has explicit launch permissions.<\/p>\n\n<p>Launch permissions fall into three categories:<\/p>\n\n<ul><li><strong>Public:<\/strong> The owner of the AMI granted launch permissions for the AMI to the\nall group. All users have launch permissions for these AMIs.<\/li><li><strong>Explicit:<\/strong> The owner of the AMI granted launch permissions to a specific\nuser.<\/li><li><strong>Implicit:<\/strong> A user has implicit launch permissions for all AMIs he or she\nowns.<\/li><\/ul>\n\n<p>The list of AMIs returned can be modified by specifying AMI IDs, AMI owners, or users with\nlaunch permissions. If no options are specified, Amazon EC2 returns all AMIs for which the user\nhas launch permissions.<\/p>\n\n<p>If you specify one or more AMI IDs, only AMIs that have the specified IDs are returned. If you\nspecify an invalid AMI ID, a fault is returned. If you specify an AMI ID for which you do not\nhave access, it will not be included in the returned results.<\/p>\n\n<p>If you specify one or more AMI owners, only AMIs from the specified owners and for which you\nhave access are returned. The results can include the account IDs of the specified owners,\namazon for AMIs owned by Amazon or self for AMIs that you own.<\/p>\n\n<p>If you specify a list of executable users, only users that have launch permissions for the AMIs\nare returned. You can specify account IDs (if you own the AMI(s)), self for AMIs for which you\nown or have explicit permissions, or all for public AMIs.<\/p>\n\n<p class=\"note\">\nDeregistered images are included in the returned results for an unspecified interval after\nderegistration.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ImageId<\/code> - <code>string|array<\/code> - Optional - An optional list of the AMI IDs to describe. If not specified, all AMIs will be described. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Owner<\/code> - <code>string|array<\/code> - Optional - The optional list of owners for the described AMIs. The IDs amazon, self, and explicit can be used to include AMIs owned by Amazon, AMIs owned by the user, and AMIs for which the user has explicit launch permissions, respectively. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>ExecutableBy<\/code> - <code>string|array<\/code> - Optional - The optional list of users with explicit launch permissions for the described AMIs. The user ID can be a user&#8217;s account ID, &#8216;self&#8217; to return AMIs for which the sender of the request has explicit launch permissions, or &#8216;all&#8217; to return AMIs with public launch permissions. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Images. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_images($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['ImageId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ImageId' =&gt; (is_array($opt['ImageId']) ? $opt['ImageId'] : array($opt['ImageId']))\n        )));\n        unset($opt['ImageId']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['Owner']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Owner' =&gt; (is_array($opt['Owner']) ? $opt['Owner'] : array($opt['Owner']))\n        )));\n        unset($opt['Owner']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['ExecutableBy']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ExecutableBy' =&gt; (is_array($opt['ExecutableBy']) ? $opt['ExecutableBy'] : array($opt['ExecutableBy']))\n        )));\n        unset($opt['ExecutableBy']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeImages', $opt);\n}","examples":{"example":[{"title":"<p>Describe all accessible images.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_images();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe all images owned by Amazon.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_images(array(\n\t'Owner' =&gt; 'amazon'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe all images that your account can execute.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_images(array(\n\t'ExecutableBy' =&gt; 'self'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter accessible images.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_images(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'architecture',        'Value' =&gt; 'x86_64'     ),\n\t\tarray('Name' =&gt; 'image-type',          'Value' =&gt; 'machine'    ),\n\t\tarray('Name' =&gt; 'root-device-type',    'Value' =&gt; 'ebs'        ),\n\t\tarray('Name' =&gt; 'virtualization-type', 'Value' =&gt; 'paravirtual'),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]}},{"name":"describe_instance_attribute","modifier":"public","description":"<p>Returns information about an attribute of an instance. Only one attribute can be specified per\ncall.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance whose instance attribute is being described.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the attribute to describe. Available attribute names: <code>instanceType<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code>, <code>instanceInitiatedShutdownBehavior<\/code>, <code>rootDeviceName<\/code>, <code>blockDeviceMapping<\/code> [Allowed values: <code>instanceType<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code>, <code>instanceInitiatedShutdownBehavior<\/code>, <code>rootDeviceName<\/code>, <code>blockDeviceMapping<\/code>, <code>productCodes<\/code>, <code>sourceDestCheck<\/code>, <code>groupSet<\/code>, <code>ebsOptimized<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_instance_attribute($instance_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('DescribeInstanceAttribute', $opt);\n}","examples":{"example":{"title":"<p>Describe the attributes of a given instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_instance_attribute('i-1f549375', 'instanceType');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"describe_instance_status","modifier":"public","description":"<p>Describes the status of an Amazon Elastic Compute Cloud (Amazon EC2) instance. Instance status\nprovides information about two types of scheduled events for an instance that may require your\nattention:<\/p>\n\n<ul><li>Scheduled Reboot: When Amazon EC2 determines that an instance must be rebooted, the\ninstance&#8217;s status will return one of two event codes: <code>system-reboot<\/code> or\n<code>instance-reboot<\/code>. System reboot commonly occurs if certain maintenance or upgrade\noperations require a reboot of the underlying host that supports an instance. Instance reboot\ncommonly occurs if the instance must be rebooted, rather than the underlying host. Rebooting\nevents include a scheduled start and end time.<\/li><li>Scheduled Retirement: When Amazon EC2 determines that an instance must be shut down, the\ninstance&#8217;s status will return an event code called <code>instance-retirement<\/code>. Retirement\ncommonly occurs when the underlying host is degraded and must be replaced. Retirement events\ninclude a scheduled start and end time. You&#8217;re also notified by email if one of your instances\nis set to retiring. The email message indicates when your instance will be permanently retired.<\/li><\/ul>\n\n<p>If your instance is permanently retired, it will not be restarted. You can avoid retirement by\nmanually restarting your instance when its event code is <code>instance-retirement<\/code>. This\nensures that your instance is started on a healthy host.<\/p>\n\n<p><code>DescribeInstanceStatus<\/code> returns information only for instances in the running\nstate.<\/p>\n\n<p>You can filter the results to return information only about instances that match criteria you\nspecify. For example, you could get information about instances in a specific Availability\nZone. You can specify multiple values for a filter (e.g., more than one Availability Zone). An\ninstance must match at least one of the specified values for it to be included in the results.<\/p>\n\n<p>You can specify multiple filters. An instance must match all the filters for it to be included\nin the results. If there&#8217;s no match, no special message is returned; the response is simply\nempty.<\/p>\n\n<p>You can use wildcards with the filter values: <code><em><\/code> matches zero or more characters,\nand <code>?<\/code> matches exactly one character. You can escape special characters using a\nbackslash before the character. For example, a value of <code>&#42;amazon\\?&#92;<\/code> searches for\nthe literal string <code><\/em>amazon?\\<\/code>.<\/p>\n\n<p>The following filters are available:<\/p>\n\n<ul><li><code>availability-zone<\/code> - Filter on an instance&#8217;s availability zone.<\/li><li><code>instance-state-name<\/code> - Filter on the intended state of the instance, e.g.,\nrunning.<\/li><li><code>instance-state-code<\/code> - Filter on the intended state code of the instance, e.g.,\n16.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceId<\/code> - <code>string|array<\/code> - Optional - The list of instance IDs. If not specified, all instances are described. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - The list of filters to limit returned results. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>NextToken<\/code> - <code>string<\/code> - Optional - A string specifying the next paginated set of results to return.<\/li><li><code>MaxResults<\/code> - <code>integer<\/code> - Optional - The maximum number of paginated instance items per response.<\/li><li><code>IncludeAllInstances<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_instance_status($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['InstanceId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))\n        )));\n        unset($opt['InstanceId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeInstanceStatus', $opt);\n}"},{"name":"describe_instances","modifier":"public","description":"<p>The DescribeInstances operation returns information about instances that you own.<\/p>\n\n<p>If you specify one or more instance IDs, Amazon EC2 returns information for those instances. If\nyou do not specify instance IDs, Amazon EC2 returns information for all relevant instances. If\nyou specify an invalid instance ID, a fault is returned. If you specify an instance that you do\nnot own, it will not be included in the returned results.<\/p>\n\n<p>Recently terminated instances might appear in the returned results. This interval is usually\nless than one hour.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceId<\/code> - <code>string|array<\/code> - Optional - An optional list of the instances to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Instances. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/index.html?ApiReference-query-DescribeInstances.html\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_instances($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['InstanceId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))\n        )));\n        unset($opt['InstanceId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeInstances', $opt);\n}","examples":{"example":[{"title":"<p>Describe all instances.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_instances();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter instances.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_instances(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'architecture', 'Value' =&gt; 'x86_64'),\n\t\tarray('Name' =&gt; 'root-device-type', 'Value' =&gt; 'ebs'),\n\t\tarray('Name' =&gt; 'virtualization-type', 'Value' =&gt; 'paravirtual'),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"describe_internet_gateways","modifier":"public","description":"<p>Gives you information about your Internet gateways. You can filter the results to return\ninformation only about Internet gateways that match criteria you specify. For example, you\ncould get information only about gateways with particular tags. The Internet gateway must match\nat least one of the specified values for it to be included in the results.<\/p>\n\n<p>You can specify multiple filters (e.g., the Internet gateway is attached to a particular VPC\nand is tagged with a particular value). The result includes information for a particular\nInternet gateway only if the gateway matches all your filters. If there&#8217;s no match, no special\nmessage is returned; the response is simply empty.<\/p>\n\n<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and\n<code>?<\/code> matches exactly one character. You can escape special characters using a\nbackslash before the character. For example, a value of <code>&#42;amazon\\?&#92;<\/code> searches for\nthe literal string <code>*amazon?\\<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InternetGatewayId<\/code> - <code>string|array<\/code> - Optional - One or more Internet gateway IDs. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Internet Gateways. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_internet_gateways($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['InternetGatewayId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'InternetGatewayId' =&gt; (is_array($opt['InternetGatewayId']) ? $opt['InternetGatewayId'] : array($opt['InternetGatewayId']))\n        )));\n        unset($opt['InternetGatewayId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeInternetGateways', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPC internet gateways.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_internet_gateways();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe a specific VPC internet gateway.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_internet_gateways(array(\n\t'InternetGatewayId' =&gt; 'igw-be7cfdd7'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_internet_gateway\"><code>delete_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_internet_gateway\"><code>detach_internet_gateway()<\/code><\/a>"]}},{"name":"describe_key_pairs","modifier":"public","description":"<p>The DescribeKeyPairs operation returns information about key pairs available to you. If you\nspecify key pairs, information about those key pairs is returned. Otherwise, information for\nall registered key pairs is returned.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>KeyName<\/code> - <code>string|array<\/code> - Optional - The optional list of key pair names to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for KeyPairs. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_key_pairs($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['KeyName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'KeyName' =&gt; (is_array($opt['KeyName']) ? $opt['KeyName'] : array($opt['KeyName']))\n        )));\n        unset($opt['KeyName']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeKeyPairs', $opt);\n}","examples":{"example":[{"title":"<p>Describe the key pairs in your account.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_key_pairs();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe specific key pairs in your account.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_key_pairs(array(\n\t'KeyName' =&gt; 'my-keypair'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe multiple key pairs in your account.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_key_pairs(array(\n\t'KeyName' =&gt; array(\n\t\t'my-keypair',\n\t\t'my-keypair2'\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter key pairs.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_key_pairs(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'key-name'),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_key_pair\"><code>create_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_key_pair\"><code>delete_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/import_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/import_key_pair\"><code>import_key_pair()<\/code><\/a>"]}},{"name":"describe_licenses","modifier":"public","description":"<p>Provides details of a user&#8217;s registered licenses. Zero or more IDs may be specified on the\ncall. When one or more license IDs are specified, only data for the specified IDs are returned.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>LicenseId<\/code> - <code>string|array<\/code> - Optional - Specifies the license registration for which details are to be returned. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Licenses. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_licenses($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['LicenseId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'LicenseId' =&gt; (is_array($opt['LicenseId']) ? $opt['LicenseId'] : array($opt['LicenseId']))\n        )));\n        unset($opt['LicenseId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeLicenses', $opt);\n}"},{"name":"describe_network_acls","modifier":"public","description":"<p>Gives you information about the network ACLs in your VPC. You can filter the results to return\ninformation only about ACLs that match criteria you specify. For example, you could get\ninformation only the ACL associated with a particular subnet. The ACL must match at least one\nof the specified values for it to be included in the results.<\/p>\n\n<p>You can specify multiple filters (e.g., the ACL is associated with a particular subnet and has\nan egress entry that denies traffic to a particular port). The result includes information for\na particular ACL only if it matches all your filters. If there&#8217;s no match, no special message\nis returned; the response is simply empty.<\/p>\n\n<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and\n<code>?<\/code> matches exactly one character. You can escape special characters using a\nbackslash before the character. For example, a value of <code>&#42;amazon\\?&#92;<\/code> searches for\nthe literal string <code>*amazon?\\<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NetworkAclId<\/code> - <code>string|array<\/code> - Optional - One or more network ACL IDs. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Network ACLs. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_network_acls($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['NetworkAclId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'NetworkAclId' =&gt; (is_array($opt['NetworkAclId']) ? $opt['NetworkAclId'] : array($opt['NetworkAclId']))\n        )));\n        unset($opt['NetworkAclId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeNetworkAcls', $opt);\n}","examples":{"example":[{"title":"<p>Describe all Network Access Control Lists (ACLs).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_network_acls();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe all Network Access Control Lists (ACLs).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_network_acls(array(\n\t'NetworkAclId' =&gt; 'acl-4abf3f23',\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"describe_network_interface_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>SourceDestCheck<\/code> - <code>string<\/code> - Optional - <\/li><li><code>GroupSet<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Attachment<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_network_interface_attribute($network_interface_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    return $this-&gt;authenticate('DescribeNetworkInterfaceAttribute', $opt);\n}"},{"name":"describe_network_interfaces","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NetworkInterfaceId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*<\/code> specifies that zero or more characters must match, and <code>?<\/code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\\*amazon\\?\\\\<\/code> specifies the literal string <code>*amazon?\\<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_network_interfaces($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['NetworkInterfaceId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'NetworkInterfaceId' =&gt; (is_array($opt['NetworkInterfaceId']) ? $opt['NetworkInterfaceId'] : array($opt['NetworkInterfaceId']))\n        )));\n        unset($opt['NetworkInterfaceId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeNetworkInterfaces', $opt);\n}","examples":{"example":{"title":"<p>List the network interfaces.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_network_interfaces();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"describe_placement_groups","modifier":"public","description":"<p>Returns information about one or more <code>PlacementGroup<\/code> instances in a user&#8217;s\naccount.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GroupName<\/code> - <code>string|array<\/code> - Optional - The name of the <code>PlacementGroup<\/code>. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Placement Groups. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_placement_groups($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['GroupName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'GroupName' =&gt; (is_array($opt['GroupName']) ? $opt['GroupName'] : array($opt['GroupName']))\n        )));\n        unset($opt['GroupName']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribePlacementGroups', $opt);\n}","examples":{"example":[{"title":"<p>Describe cluster-compute placement groups.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_placement_groups();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe a single cluster-compute placement group.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_placement_groups(array(\n\t'GroupName' =&gt; 'php-cluster'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_placement_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_placement_group\"><code>create_placement_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_placement_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_placement_group\"><code>delete_placement_group()<\/code><\/a>"]}},{"name":"describe_regions","modifier":"public","description":"<p>The DescribeRegions operation describes regions zones that are currently available to the\naccount.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>RegionName<\/code> - <code>string|array<\/code> - Optional - The optional list of regions to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Regions. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_regions($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['RegionName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'RegionName' =&gt; (is_array($opt['RegionName']) ? $opt['RegionName'] : array($opt['RegionName']))\n        )));\n        unset($opt['RegionName']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeRegions', $opt);\n}","examples":{"example":[{"title":"<p>Describe available regions.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_regions();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe a specific region.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_regions(array(\n\t'RegionName' =&gt; 'us-west-1'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe multiple regions.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_regions(array(\n\t'RegionName' =&gt; array(\n\t\t'us-west-1',\n\t\t'us-east-1',\n\t\t'eu-west-1',\n\t\t'ap-southeast-1'\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter available regions.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_regions(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'endpoint', 'Value' =&gt; 'ec2.us-east-1.amazonaws.com')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":"<a href=\"..\/amazonec2\/describe_availability_zones.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_availability_zones\"><code>describe_availability_zones()<\/code><\/a>"}},{"name":"describe_reserved_instances","modifier":"public","description":"<p>The DescribeReservedInstances operation describes Reserved Instances that were purchased for\nuse with your account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ReservedInstancesId<\/code> - <code>string|array<\/code> - Optional - The optional list of Reserved Instance IDs to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for ReservedInstances. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>OfferingType<\/code> - <code>string<\/code> - Optional - The Reserved Instance offering type.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_reserved_instances($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['ReservedInstancesId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ReservedInstancesId' =&gt; (is_array($opt['ReservedInstancesId']) ? $opt['ReservedInstancesId'] : array($opt['ReservedInstancesId']))\n        )));\n        unset($opt['ReservedInstancesId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeReservedInstances', $opt);\n}","examples":{"example":[{"title":"<p>Describe reserved instances.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_reserved_instances();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter reserved instances.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_reserved_instances(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'duration',            'Value' =&gt; strtotime('1 year')),\n\t\tarray('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux\/UNIX'       ),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/describe_reserved_instances_offerings.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_reserved_instances_offerings\"><code>describe_reserved_instances_offerings()<\/code><\/a>","<a href=\"..\/amazonec2\/purchase_reserved_instances_offering.html\" rel=\"..\/..\/index.html#m=amazonec2\/purchase_reserved_instances_offering\"><code>purchase_reserved_instances_offering()<\/code><\/a>"]}},{"name":"describe_reserved_instances_listings","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ReservedInstancesId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>ReservedInstancesListingId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Filters<\/code> - <code>array<\/code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*<\/code> specifies that zero or more characters must match, and <code>?<\/code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\\*amazon\\?\\\\<\/code> specifies the literal string <code>*amazon?\\<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_reserved_instances_listings($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['Filters']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filters' =&gt; $opt['Filters']\n        )));\n        unset($opt['Filters']);\n    }\n\n    return $this-&gt;authenticate('DescribeReservedInstancesListings', $opt);\n}"},{"name":"describe_reserved_instances_offerings","modifier":"public","description":"<p>The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are\navailable for purchase. With Amazon EC2 Reserved Instances, you purchase the right to launch\nAmazon EC2 instances for a period of time (without getting insufficient capacity errors) and\npay a lower usage rate for the actual time used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ReservedInstancesOfferingId<\/code> - <code>string|array<\/code> - Optional - An optional list of the unique IDs of the Reserved Instance offerings to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>InstanceType<\/code> - <code>string<\/code> - Optional - The instance type on which the Reserved Instance can be used. [Allowed values: <code>t1.micro<\/code>, <code>m1.small<\/code>, <code>m1.medium<\/code>, <code>m1.large<\/code>, <code>m1.xlarge<\/code>, <code>m2.xlarge<\/code>, <code>m2.2xlarge<\/code>, <code>m2.4xlarge<\/code>, <code>m3.xlarge<\/code>, <code>m3.2xlarge<\/code>, <code>c1.medium<\/code>, <code>c1.xlarge<\/code>, <code>hi1.4xlarge<\/code>, <code>hs1.8xlarge<\/code>, <code>cc1.4xlarge<\/code>, <code>cc2.8xlarge<\/code>, <code>cg1.4xlarge<\/code>]<\/li><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The Availability Zone in which the Reserved Instance can be used.<\/li><li><code>ProductDescription<\/code> - <code>string<\/code> - Optional - The Reserved Instance product description.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for ReservedInstancesOfferings. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>InstanceTenancy<\/code> - <code>string<\/code> - Optional - The tenancy of the Reserved Instance offering. A Reserved Instance with tenancy of dedicated will run on single-tenant hardware and can only be launched within a VPC.<\/li><li><code>OfferingType<\/code> - <code>string<\/code> - Optional - The Reserved Instance offering type.<\/li><li><code>NextToken<\/code> - <code>string<\/code> - Optional - <\/li><li><code>MaxResults<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_reserved_instances_offerings($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['ReservedInstancesOfferingId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ReservedInstancesOfferingId' =&gt; (is_array($opt['ReservedInstancesOfferingId']) ? $opt['ReservedInstancesOfferingId'] : array($opt['ReservedInstancesOfferingId']))\n        )));\n        unset($opt['ReservedInstancesOfferingId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeReservedInstancesOfferings', $opt);\n}","examples":{"example":[{"title":"<p>Describe reserved instances offerings.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_reserved_instances_offerings(array(\n\t'AvailabilityZone' =&gt; 'us-east-1a',\n\t'InstanceType' =&gt; 'c1.medium'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter Reserved Instances Offerings<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_reserved_instances_offerings(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'duration',            'Value' =&gt; strtotime('1 year')),\n\t\tarray('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux\/UNIX'       ),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/describe_reserved_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_reserved_instances\"><code>describe_reserved_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/purchase_reserved_instances_offering.html\" rel=\"..\/..\/index.html#m=amazonec2\/purchase_reserved_instances_offering\"><code>purchase_reserved_instances_offering()<\/code><\/a>"]}},{"name":"describe_route_tables","modifier":"public","description":"<p>Gives you information about your route tables. You can filter the results to return information\nonly about tables that match criteria you specify. For example, you could get information only\nabout a table associated with a particular subnet. You can specify multiple values for the\nfilter. The table must match at least one of the specified values for it to be included in the\nresults.<\/p>\n\n<p>You can specify multiple filters (e.g., the table has a particular route, and is associated\nwith a particular subnet). The result includes information for a particular table only if it\nmatches all your filters. If there&#8217;s no match, no special message is returned; the response is\nsimply empty.<\/p>\n\n<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and\n<code>?<\/code> matches exactly one character. You can escape special characters using a\nbackslash before the character. For example, a value of <code>&#42;amazon\\?&#92;<\/code> searches for\nthe literal string <code>*amazon?\\<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>RouteTableId<\/code> - <code>string|array<\/code> - Optional - One or more route table IDs. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Route Tables. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_route_tables($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['RouteTableId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'RouteTableId' =&gt; (is_array($opt['RouteTableId']) ? $opt['RouteTableId'] : array($opt['RouteTableId']))\n        )));\n        unset($opt['RouteTableId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeRouteTables', $opt);\n}","examples":{"example":{"title":"<p>Describe all VPC route tables;<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_route_tables();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"describe_security_groups","modifier":"public","description":"<p>The DescribeSecurityGroups operation returns information about security groups that you own.<\/p>\n\n<p>If you specify security group names, information about those security group is returned.\nOtherwise, information for all security group is returned. If you specify a group that does not\nexist, a fault is returned.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GroupName<\/code> - <code>string|array<\/code> - Optional - The optional list of Amazon EC2 security groups to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>GroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for SecurityGroups. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_security_groups($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['GroupName']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'GroupName' =&gt; (is_array($opt['GroupName']) ? $opt['GroupName'] : array($opt['GroupName']))\n        )));\n        unset($opt['GroupName']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['GroupId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'GroupId' =&gt; (is_array($opt['GroupId']) ? $opt['GroupId'] : array($opt['GroupId']))\n        )));\n        unset($opt['GroupId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeSecurityGroups', $opt);\n}","examples":{"example":[{"title":"<p>Describe security groups.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_security_groups();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe security groups with a given group name.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_security_groups(array(\n\t'GroupName' =&gt; 'default'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe security groups with multiple group names.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_security_groups(array(\n\t'GroupName' =&gt; array(\n\t\t'default',\n\t\t'foo-test'\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter security groups.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_security_groups(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'owner-id')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]}},{"name":"describe_snapshot_attribute","modifier":"public","description":"<p>Returns information about an attribute of a snapshot. Only one attribute can be specified per\ncall.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"snapshot_id","type":"string","description":"<p>The ID of the EBS snapshot whose attribute is being described.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the EBS attribute to describe. Available attribute names: createVolumePermission [Allowed values: <code>productCodes<\/code>, <code>createVolumePermission<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_snapshot_attribute($snapshot_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SnapshotId'] = $snapshot_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('DescribeSnapshotAttribute', $opt);\n}","examples":{"example":{"title":"<p>Describe snapshot attributes.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_snapshot_attribute('snap-a99b8bc1', 'createVolumePermission');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"describe_snapshots","modifier":"public","description":"<p>Returns information about the Amazon EBS snapshots available to you. Snapshots available to you\ninclude public snapshots available for any AWS account to launch, private snapshots you own,\nand private snapshots owned by another AWS account but for which you&#8217;ve been given explicit\ncreate volume permissions.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>SnapshotId<\/code> - <code>string|array<\/code> - Optional - The optional list of EBS snapshot IDs to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Owner<\/code> - <code>string|array<\/code> - Optional - The optional list of EBS snapshot owners. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>RestorableBy<\/code> - <code>string|array<\/code> - Optional - The optional list of users who have permission to create volumes from the described EBS snapshots. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Snapshots. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_snapshots($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['SnapshotId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SnapshotId' =&gt; (is_array($opt['SnapshotId']) ? $opt['SnapshotId'] : array($opt['SnapshotId']))\n        )));\n        unset($opt['SnapshotId']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['Owner']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Owner' =&gt; (is_array($opt['Owner']) ? $opt['Owner'] : array($opt['Owner']))\n        )));\n        unset($opt['Owner']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['RestorableBy']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'RestorableBy' =&gt; (is_array($opt['RestorableBy']) ? $opt['RestorableBy'] : array($opt['RestorableBy']))\n        )));\n        unset($opt['RestorableBy']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeSnapshots', $opt);\n}","examples":{"example":[{"title":"<p>Describe snapshots that are owned by you.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_snapshots(array(\n\t'Owner' =&gt; 'self'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe images that are owned by yourself or Amazon, and restorable by you.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_snapshots(array(\n\t'Owner' =&gt; array(\n\t\t'self',\n\t\t'amazon'\n\t),\n\t'RestorableBy' =&gt; CFCredentials::get('@default')-&gt;account_id\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter snapshots.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_snapshots(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'status', 'Value' =&gt; 'pending')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"describe_spot_datafeed_subscription","modifier":"public","description":"<p>Describes the data feed for Spot Instances.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_spot_datafeed_subscription($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('DescribeSpotDatafeedSubscription', $opt);\n}","examples":{"example":{"title":"<p>Describe spot datafeed subscription.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_spot_datafeed_subscription();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"describe_spot_instance_requests","modifier":"public","description":"<p>Describes Spot Instance requests. Spot Instances are instances that Amazon EC2 starts on your\nbehalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2\nperiodically sets the Spot Price based on available Spot Instance capacity and current spot\ninstance requests. For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2010-08-31\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2010-08-31\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>\n\n<p>You can filter the results to return information only about Spot Instance requests that match\ncriteria you specify. For example, you could get information about requests where the Spot\nPrice you specified is a certain value (you can&#8217;t use greater than or less than comparison, but\nyou can use <code>*<\/code> and <code>?<\/code> wildcards). You can specify multiple values for a\nfilter. A Spot Instance request must match at least one of the specified values for it to be\nincluded in the results.<\/p>\n\n<p>You can specify multiple filters (e.g., the Spot Price is equal to a particular value, and the\ninstance type is <code>m1.small<\/code>). The result includes information for a particular\nrequest only if it matches all your filters. If there&#8217;s no match, no special message is\nreturned; the response is simply empty.<\/p>\n\n<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and\n<code>?<\/code> matches exactly one character. You can escape special characters using a\nbackslash before the character. For example, a value of <code>&#42;amazon\\?&#92;<\/code> searches for\nthe literal string <code>*amazon?\\<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>SpotInstanceRequestId<\/code> - <code>string|array<\/code> - Optional - The ID of the request. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for SpotInstances. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_spot_instance_requests($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['SpotInstanceRequestId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SpotInstanceRequestId' =&gt; (is_array($opt['SpotInstanceRequestId']) ? $opt['SpotInstanceRequestId'] : array($opt['SpotInstanceRequestId']))\n        )));\n        unset($opt['SpotInstanceRequestId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeSpotInstanceRequests', $opt);\n}","examples":{"example":[{"title":"<p>Describe spot instance requests.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_spot_instance_requests();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe spot instance requests.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_spot_instance_requests(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux\/UNIX'),\n\t\tarray('Name' =&gt; 'state',               'Value' =&gt; 'active'    ),\n\t\tarray('Name' =&gt; 'type',                'Value' =&gt; 'one-time'  ),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"describe_spot_price_history","modifier":"public","description":"<p>Describes the Spot Price history.<\/p>\n\n<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that\nyou specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based\non available Spot Instance capacity and current spot instance requests.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>StartTime<\/code> - <code>string<\/code> - Optional - The start date and time of the Spot Instance price history data. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>EndTime<\/code> - <code>string<\/code> - Optional - The end date and time of the Spot Instance price history data. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>InstanceType<\/code> - <code>string|array<\/code> - Optional - Specifies the instance type to return. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>ProductDescription<\/code> - <code>string|array<\/code> - Optional - The description of the AMI. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for SpotPriceHistory. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - Filters the results by availability zone (ex: &#8216;us-east-1a&#8217;).<\/li><li><code>MaxResults<\/code> - <code>integer<\/code> - Optional - Specifies the number of rows to return.<\/li><li><code>NextToken<\/code> - <code>string<\/code> - Optional - Specifies the next set of rows to return.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_spot_price_history($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional DateTime\n    if (isset($opt['StartTime']))\n    {\n        $opt['StartTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['StartTime']);\n    }\n    \n    \/\/ Optional DateTime\n    if (isset($opt['EndTime']))\n    {\n        $opt['EndTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['EndTime']);\n    }\n\n    \/\/ Optional list (non-map)\n    if (isset($opt['InstanceType']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'InstanceType' =&gt; (is_array($opt['InstanceType']) ? $opt['InstanceType'] : array($opt['InstanceType']))\n        )));\n        unset($opt['InstanceType']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['ProductDescription']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ProductDescription' =&gt; (is_array($opt['ProductDescription']) ? $opt['ProductDescription'] : array($opt['ProductDescription']))\n        )));\n        unset($opt['ProductDescription']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeSpotPriceHistory', $opt);\n}","examples":{"example":[{"title":"<p>Describe spot price history.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_spot_price_history(array(\n\t'StartTime' =&gt; '3 months ago',\n\t'EndTime' =&gt; 'yesterday, 9am',\n\t'InstanceType' =&gt; array(\n\t\t'm1.small',\n\t\t'c1.medium'\n\t),\n\t'ProductDescription' =&gt; 'Linux\/UNIX'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter spot price history.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_spot_price_history(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux\/UNIX'),\n\t\tarray('Name' =&gt; 'instance-type',       'Value' =&gt; 't1.micro'  ),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/request_spot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/request_spot_instances\"><code>request_spot_instances()<\/code><\/a>"]}},{"name":"describe_subnets","modifier":"public","description":"<p>Gives you information about your subnets. You can filter the results to return information only\nabout subnets that match criteria you specify.<\/p>\n\n<p>For example, you could ask to get information about a particular subnet (or all) only if the\nsubnet&#8217;s state is available. You can specify multiple filters (e.g., the subnet is in a\nparticular VPC, and the subnet&#8217;s state is available).<\/p>\n\n<p>The result includes information for a particular subnet only if the subnet matches all your\nfilters. If there&#8217;s no match, no special message is returned; the response is simply empty. The\nfollowing table shows the available filters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>SubnetId<\/code> - <code>string|array<\/code> - Optional - A set of one or more subnet IDs. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Subnets. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_subnets($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['SubnetId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SubnetId' =&gt; (is_array($opt['SubnetId']) ? $opt['SubnetId'] : array($opt['SubnetId']))\n        )));\n        unset($opt['SubnetId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeSubnets', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPC subnets.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_subnets();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter VPC subnets by available state.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_subnets(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available')\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_subnet.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_subnet\"><code>create_subnet()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_subnet.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_subnet\"><code>delete_subnet()<\/code><\/a>"]}},{"name":"describe_tags","modifier":"public","description":"<p>Describes the tags for the specified resources.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for tags. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_tags($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeTags', $opt);\n}","examples":{"example":[{"title":"<p>Describe all tags.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_tags();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe tags for a given resource ID.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_tags(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'resource-id', 'Value' =&gt; 'aki-00006369')\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_tags\"><code>create_tags()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_tags.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_tags\"><code>delete_tags()<\/code><\/a>"]}},{"name":"describe_volume_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Attribute<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>autoEnableIO<\/code>, <code>productCodes<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_volume_attribute($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('DescribeVolumeAttribute', $opt);\n}"},{"name":"describe_volume_status","modifier":"public","description":"<p>Describes the status of a volume.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*<\/code> specifies that zero or more characters must match, and <code>?<\/code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\\*amazon\\?\\\\<\/code> specifies the literal string <code>*amazon?\\<\/code>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>NextToken<\/code> - <code>string<\/code> - Optional - <\/li><li><code>MaxResults<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_volume_status($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['VolumeId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'VolumeId' =&gt; (is_array($opt['VolumeId']) ? $opt['VolumeId'] : array($opt['VolumeId']))\n        )));\n        unset($opt['VolumeId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeVolumeStatus', $opt);\n}"},{"name":"describe_volumes","modifier":"public","description":"<p>Describes the status of the indicated volume or, in lieu of any specified, all volumes\nbelonging to the caller. Volumes that have been deleted are not described.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeId<\/code> - <code>string|array<\/code> - Optional - The optional list of EBS volumes to describe. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for Volumes. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_volumes($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['VolumeId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'VolumeId' =&gt; (is_array($opt['VolumeId']) ? $opt['VolumeId'] : array($opt['VolumeId']))\n        )));\n        unset($opt['VolumeId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeVolumes', $opt);\n}","examples":{"example":[{"title":"<p>Describe EBS volumes.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_volumes();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter EBS volumes.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_volumes(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'attachment.status', 'Value' =&gt; 'attached' ),\n\t\tarray('Name' =&gt; 'status',            'Value' =&gt; 'available'),\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"describe_vpc_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Attribute<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>enableDnsSupport<\/code>, <code>enableDnsHostnames<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_vpc_attribute($vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('DescribeVpcAttribute', $opt);\n}"},{"name":"describe_vpcs","modifier":"public","description":"<p>Gives you information about your VPCs. You can filter the results to return information only\nabout VPCs that match criteria you specify.<\/p>\n\n<p>For example, you could ask to get information about a particular VPC or VPCs (or all your VPCs)\nonly if the VPC&#8217;s state is available. You can specify multiple filters (e.g., the VPC uses one\nof several sets of DHCP options, and the VPC&#8217;s state is available). The result includes\ninformation for a particular VPC only if the VPC matches all your filters.<\/p>\n\n<p>If there&#8217;s no match, no special message is returned; the response is simply empty. The\nfollowing table shows the available filters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VpcId<\/code> - <code>string|array<\/code> - Optional - The ID of a VPC you want information about. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for VPCs. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_vpcs($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['VpcId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'VpcId' =&gt; (is_array($opt['VpcId']) ? $opt['VpcId'] : array($opt['VpcId']))\n        )));\n        unset($opt['VpcId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeVpcs', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPCs.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpcs();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter VPCs by available state.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpcs(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available')\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpc\"><code>create_vpc()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpc.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpc\"><code>delete_vpc()<\/code><\/a>"]}},{"name":"describe_vpn_connections","modifier":"public","description":"<p>Gives you information about your VPN connections.<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>We strongly recommend you use HTTPS when calling this operation because the response contains\nsensitive cryptographic information for configuring your customer gateway.<\/p>\n\n<p>You can filter the results to return information only about VPN connections that match criteria\nyou specify. For example, you could ask to get information about a particular VPN connection\n(or all) only if the VPN&#8217;s state is pending or available. You can specify multiple filters\n(e.g., the VPN connection is associated with a particular VPN gateway, and the gateway&#8217;s state\nis pending or available). The result includes information for a particular VPN connection only\nif the VPN connection matches all your filters. If there&#8217;s no match, no special message is\nreturned; the response is simply empty. The following table shows the available filters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VpnConnectionId<\/code> - <code>string|array<\/code> - Optional - A VPN connection ID. More than one may be specified per request. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for VPN Connections. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_vpn_connections($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['VpnConnectionId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'VpnConnectionId' =&gt; (is_array($opt['VpnConnectionId']) ? $opt['VpnConnectionId'] : array($opt['VpnConnectionId']))\n        )));\n        unset($opt['VpnConnectionId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeVpnConnections', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPN connections.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpn_connections();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Filter VPN connections by available state.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpn_connections(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available')\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/create_vpn_connection.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_connection\"><code>create_vpn_connection()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpn_connection.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_connection\"><code>delete_vpn_connection()<\/code><\/a>"]}},{"name":"describe_vpn_gateways","modifier":"public","description":"<p>Gives you information about your VPN gateways. You can filter the results to return information\nonly about VPN gateways that match criteria you specify.<\/p>\n\n<p>For example, you could ask to get information about a particular VPN gateway (or all) only if\nthe gateway&#8217;s state is pending or available. You can specify multiple filters (e.g., the VPN\ngateway is in a particular Availability Zone and the gateway&#8217;s state is pending or available).<\/p>\n\n<p>The result includes information for a particular VPN gateway only if the gateway matches all\nyour filters. If there&#8217;s no match, no special message is returned; the response is simply\nempty. The following table shows the available filters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VpnGatewayId<\/code> - <code>string|array<\/code> - Optional - A list of filters used to match properties for VPN Gateways. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Filter<\/code> - <code>array<\/code> - Optional - A list of filters used to match properties for VPN Gateways. For a complete reference to the available filter keys for this operation, see the <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/\">Amazon EC2 API reference<\/a>. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Name<\/code> - <code>string<\/code> - Optional - Specifies the name of the filter.<\/li><li><code>Value<\/code> - <code>string|array<\/code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_vpn_gateways($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list (non-map)\n    if (isset($opt['VpnGatewayId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'VpnGatewayId' =&gt; (is_array($opt['VpnGatewayId']) ? $opt['VpnGatewayId'] : array($opt['VpnGatewayId']))\n        )));\n        unset($opt['VpnGatewayId']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['Filter']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Filter' =&gt; $opt['Filter']\n        )));\n        unset($opt['Filter']);\n    }\n\n    return $this-&gt;authenticate('DescribeVpnGateways', $opt);\n}","examples":{"example":[{"title":"<p>Describe all VPN gateways.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpn_gateways();\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Describe all VPN gateways.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;describe_vpn_gateways(array(\n\t'Filter' =&gt; array(\n\t\tarray('Name' =&gt; 'state', 'Value' =&gt; 'available')\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/attach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_vpn_gateway\"><code>attach_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_gateway\"><code>create_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_gateway\"><code>delete_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_vpn_gateway\"><code>detach_vpn_gateway()<\/code><\/a>"]}},{"name":"detach_internet_gateway","modifier":"public","description":"<p>Detaches an Internet gateway from a VPC, disabling connectivity between the Internet and the\nVPC. The VPC must not contain any running instances with elastic IP addresses. For more\ninformation about your VPC and Internet gateway, go to Amazon Virtual Private Cloud User Guide.<\/p>\n\n<p>For more information about Amazon Virtual Private Cloud and Internet gateways, go to the Amazon\nVirtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"internet_gateway_id","type":"string","description":"<p>The ID of the Internet gateway to detach.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function detach_internet_gateway($internet_gateway_id, $vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InternetGatewayId'] = $internet_gateway_id;\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('DetachInternetGateway', $opt);\n}","examples":{"example":{"title":"<p>Detach an internet gateway from a running VPC.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;detach_internet_gateway('igw-be7cfdd7', 'vpc-7e7dfc17');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_internet_gateway\"><code>attach_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_internet_gateway\"><code>create_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_internet_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_internet_gateway\"><code>delete_internet_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_internet_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_internet_gateways\"><code>describe_internet_gateways()<\/code><\/a>"]}},{"name":"detach_network_interface","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"attachment_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Force<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function detach_network_interface($attachment_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AttachmentId'] = $attachment_id;\n    \n    return $this-&gt;authenticate('DetachNetworkInterface', $opt);\n}","examples":{"example":{"title":"<p>Detach a network interface to a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;detach_network_interface($network_interface_attachment_id);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"detach_volume","modifier":"public","description":"<p>Detach a previously attached volume from a running instance.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":"<p>The ID of the volume to detach.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceId<\/code> - <code>string<\/code> - Optional - The ID of the instance from which to detach the the specified volume.<\/li><li><code>Device<\/code> - <code>string<\/code> - Optional - The device name to which the volume is attached on the specified instance.<\/li><li><code>Force<\/code> - <code>boolean<\/code> - Optional - Forces detachment if the previous detachment attempt did not occur cleanly (logging into an instance, unmounting the volume, and detaching normally). This option can lead to data loss or a corrupted file system. Use this option only as a last resort to detach a volume from a failed instance. The instance will not have an opportunity to flush file system caches nor file system meta data. If you use this option, you must perform file system check and repair procedures.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function detach_volume($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('DetachVolume', $opt);\n}","examples":{"example":{"title":"<p>Detach an EBS volume from a running instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Detach the volume\n$response = $ec2-&gt;detach_volume($volume_id, array(\n\t'InstanceId' =&gt; 'i-1f549375',\n\t'Device' =&gt; '\/dev\/sdg'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]}},{"name":"detach_vpn_gateway","modifier":"public","description":"<p>Detaches a VPN gateway from a VPC. You do this if you&#8217;re planning to turn off the VPC and not\nuse it anymore. You can confirm a VPN gateway has been completely detached from a VPC by\ndescribing the VPN gateway (any attachments to the VPN gateway are also described).<\/p>\n\n<p>You must wait for the attachment&#8217;s state to switch to detached before you can delete the VPC or\nattach a different VPC to the VPN gateway.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpn_gateway_id","type":"string","description":"<p>The ID of the VPN gateway to detach from the VPC.<\/p>"},{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":"<p>The ID of the VPC to detach the VPN gateway from.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function detach_vpn_gateway($vpn_gateway_id, $vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpnGatewayId'] = $vpn_gateway_id;\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('DetachVpnGateway', $opt);\n}","examples":{"example":{"title":"<p>Detach a VPN gateway from an existing VPC.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;detach_vpn_gateway('vgw-9aa347f3', 'vpc-fd7cd194');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_vpn_gateway\"><code>attach_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/create_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_vpn_gateway\"><code>create_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_vpn_gateway.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_vpn_gateway\"><code>delete_vpn_gateway()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_vpn_gateways.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_vpn_gateways\"><code>describe_vpn_gateways()<\/code><\/a>"]}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"disable_vgw_route_propagation","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"gateway_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function disable_vgw_route_propagation($route_table_id, $gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    $opt['GatewayId'] = $gateway_id;\n    \n    return $this-&gt;authenticate('DisableVgwRoutePropagation', $opt);\n}"},{"name":"disassociate_address","modifier":"public","description":"<p>The DisassociateAddress operation disassociates the specified elastic IP address from the\ninstance to which it is assigned. This is an idempotent operation. If you enter it more than\nonce, Amazon EC2 does not return an error.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PublicIp<\/code> - <code>string<\/code> - Optional - The elastic IP address that you are disassociating from the instance.<\/li><li><code>AssociationId<\/code> - <code>string<\/code> - Optional - Association ID corresponding to the VPC elastic IP address you want to disassociate.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function disassociate_address($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('DisassociateAddress', $opt);\n}","examples":{"example":{"title":"<p>AmazonEC2 - Disassociate Address<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;disassociate_address('184.73.247.11');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/allocate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/allocate_address\"><code>allocate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/associate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_address\"><code>associate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_addresses.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_addresses\"><code>describe_addresses()<\/code><\/a>","<a href=\"..\/amazonec2\/release_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/release_address\"><code>release_address()<\/code><\/a>"]}},{"name":"disassociate_route_table","modifier":"public","description":"<p>Disassociates a subnet from a route table.<\/p>\n\n<p>After you perform this action, the subnet no longer uses the routes in the route table. Instead\nit uses the routes in the VPC&#8217;s main route table. For more information about route tables, go\nto <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"association_id","type":"string","description":"<p>The association ID representing the current association between the route table and subnet.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function disassociate_route_table($association_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AssociationId'] = $association_id;\n    \n    return $this-&gt;authenticate('DisassociateRouteTable', $opt);\n}","examples":{"example":{"title":"<p>Disassociate a VPC route table association from a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;disassociate_route_table('rtbassoc-ac8a0ac5');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"enable_vgw_route_propagation","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"gateway_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function enable_vgw_route_propagation($route_table_id, $gateway_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    $opt['GatewayId'] = $gateway_id;\n    \n    return $this-&gt;authenticate('EnableVgwRoutePropagation', $opt);\n}"},{"name":"enable_volume_io","modifier":"public","description":"<p>Enable IO on the volume after an event has occured.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function enable_volume_io($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('EnableVolumeIO', $opt);\n}"},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonec2\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"get_console_output","modifier":"public","description":"<p>The GetConsoleOutput operation retrieves console output for the specified instance.<\/p>\n\n<p>Instance console output is buffered and posted shortly after instance boot, reboot, and\ntermination. Amazon EC2 preserves the most recent 64 KB output which will be available for at least\none hour after the most recent post.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance for which you want console output.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response. The value of <code>output<\/code> is automatically Base64-decoded.<\/p>","source":"public function get_console_output($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n\n    $response = $this-&gt;authenticate('GetConsoleOutput', $opt, $this-&gt;hostname);\n\n    \/\/ Automatically Base64-decode the &lt;output&gt; value.\n    if ($this-&gt;util-&gt;is_base64((string) $response-&gt;body-&gt;output))\n    {\n        $response-&gt;body-&gt;output = base64_decode($response-&gt;body-&gt;output);\n    }\n\n    return $response;\n}","examples":{"example":{"title":"<p>Get the EC2 console output.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Get console output\n$response = $ec2-&gt;get_console_output('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_password_data","modifier":"public","description":"<p>Retrieves the encrypted administrator password for the instances running Windows.<\/p>\n\n<p>The Windows password is only generated the first time an AMI is launched. It is not generated for\nrebundled AMIs or after the password is changed on an instance. The password is encrypted using the\nkey pair that you provided.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance for which you want the Windows administrator password.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>DecryptPasswordWithKey<\/code> - <code>string<\/code> - Optional - Enables the decryption of the Administrator password for the given Microsoft Windows instance. Specifies the RSA private key that is associated with the keypair ID which was used to launch the Microsoft Windows instance.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_password_data($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n\n    \/\/ Unless DecryptPasswordWithKey is set, simply return the response.\n    if (!isset($opt['DecryptPasswordWithKey']))\n    {\n        return $this-&gt;authenticate('GetPasswordData', $opt, $this-&gt;hostname);\n    }\n\n    \/\/ Otherwise, decrypt the password.\n    else\n    {\n        \/\/ Get a resource representing the private key.\n        $private_key = openssl_pkey_get_private($opt['DecryptPasswordWithKey']);\n        unset($opt['DecryptPasswordWithKey']);\n\n        \/\/ Fetch the encrypted password.\n        $response = $this-&gt;authenticate('GetPasswordData', $opt, $this-&gt;hostname);\n        $data = trim((string) $response-&gt;body-&gt;passwordData);\n\n        \/\/ If it's Base64-encoded...\n        if ($this-&gt;util-&gt;is_base64($data))\n        {\n            \/\/ Base64-decode it, and decrypt it with the private key.\n            if (openssl_private_decrypt(base64_decode($data), $decrypted, $private_key))\n            {\n                \/\/ Replace the previous password data with the decrypted value.\n                $response-&gt;body-&gt;passwordData = $decrypted;\n            }\n        }\n\n        return $response;\n    }\n}","examples":{"example":[{"title":"<p>Get encoded Windows password.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Get console output\n$response = $ec2-&gt;get_password_data('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Get the decrypted version of the Windows password.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Get console output\n$response = $ec2-&gt;get_password_data('i-1f549375', array(\n\t'DecryptPasswordWithKey' =&gt; file_get_contents('my-keypair.pem')\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strlen((string) $response-&gt;body-&gt;passwordData)); \/\/ Length of the password"}]},"related":{"method":["<a href=\"..\/amazonec2\/activate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/activate_license\"><code>activate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/bundle_instance.html\" rel=\"..\/..\/index.html#m=amazonec2\/bundle_instance\"><code>bundle_instance()<\/code><\/a>","<a href=\"..\/amazonec2\/cancel_bundle_task.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_bundle_task\"><code>cancel_bundle_task()<\/code><\/a>","<a href=\"..\/amazonec2\/deactivate_license.html\" rel=\"..\/..\/index.html#m=amazonec2\/deactivate_license\"><code>deactivate_license()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_bundle_tasks.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_bundle_tasks\"><code>describe_bundle_tasks()<\/code><\/a>"]}},{"name":"import_instance","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"platform","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>LaunchSpecification<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Architecture<\/code> - <code>string<\/code> - Optional - <\/li><li><code>SecurityGroup<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>AdditionalInfo<\/code> - <code>string<\/code> - Optional - <\/li><li><code>UserData<\/code> - <code>string<\/code> - Optional - <\/li><li><code>InstanceType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>t1.micro<\/code>, <code>m1.small<\/code>, <code>m1.medium<\/code>, <code>m1.large<\/code>, <code>m1.xlarge<\/code>, <code>m2.xlarge<\/code>, <code>m2.2xlarge<\/code>, <code>m2.4xlarge<\/code>, <code>m3.xlarge<\/code>, <code>m3.2xlarge<\/code>, <code>c1.medium<\/code>, <code>c1.xlarge<\/code>, <code>hi1.4xlarge<\/code>, <code>hs1.8xlarge<\/code>, <code>cc1.4xlarge<\/code>, <code>cc2.8xlarge<\/code>, <code>cg1.4xlarge<\/code>]<\/li><li><code>Placement<\/code> - <code>array<\/code> - Optional - Describes where an Amazon EC2 instance is running within an Amazon EC2 region. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The availability zone in which an Amazon EC2 instance runs.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - The name of the <code>PlacementGroup<\/code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.<\/li><li><code>Tenancy<\/code> - <code>string<\/code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means all instances launched into the VPC will be launched as dedicated tenancy regardless of the tenancy assigned to the instance at launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - The BlockDeviceMappingItemType data type. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - Specifies the virtual device name.<\/li><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - Specifies the device name (e.g., <code>\/dev\/sdh<\/code>).<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which the volume will be created.<\/li><li><code>VolumeSize<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - Specifies the device name to suppress during instance launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>Monitoring<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>SubnetId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>DisableApiTermination<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>InstanceInitiatedShutdownBehavior<\/code> - <code>string<\/code> - Optional - <\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>DiskImage<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Image<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Format<\/code> - <code>string<\/code> - Required - <\/li><li><code>Bytes<\/code> - <code>long<\/code> - Required - <\/li><li><code>ImportManifestUrl<\/code> - <code>string<\/code> - Required - <\/li><\/ul><\/li><\/ul><\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Volume<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Size<\/code> - <code>long<\/code> - Required - <\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function import_instance($platform, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Platform'] = $platform;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['LaunchSpecification']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'LaunchSpecification' =&gt; $opt['LaunchSpecification']\n        )));\n        unset($opt['LaunchSpecification']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['DiskImage']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'DiskImage' =&gt; $opt['DiskImage']\n        )));\n        unset($opt['DiskImage']);\n    }\n\n    return $this-&gt;authenticate('ImportInstance', $opt);\n}"},{"name":"import_key_pair","modifier":"public","description":"<p>Imports the public key from an RSA key pair created with a third-party tool. This operation differs\nfrom CreateKeyPair as the private key is never transferred between the caller and AWS servers.<\/p>\n\n<p>RSA key pairs are easily created on Microsoft Windows and Linux OS systems using the <code>ssh-keygen<\/code>\ncommand line tool provided with the standard OpenSSH installation. Standard library support for RSA\nkey pair creation is also available for Java, Ruby, Python, and many other programming languages.<\/p>\n\n<p>The following formats are supported:<\/p>\n\n<ul><li>OpenSSH public key format.<\/li><li>Base64 encoded DER format.<\/li><li>SSH public key file format as specified in <a href=\"http:\/\/tools.ietf.org\/html\/rfc4716\">RFC 4716<\/a>.<\/li><\/ul>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"key_name","type":"string","description":"<p>The unique name for the key pair.<\/p>"},{"@attributes":{"choice":"req"},"name":"public_key_material","type":"string","description":"<p>The public key portion of the key pair being imported.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function import_key_pair($key_name, $public_key_material, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['KeyName'] = $key_name;\n    $opt['PublicKeyMaterial'] = $this-&gt;util-&gt;is_base64($public_key_material) ? $public_key_material : base64_encode($public_key_material);\n\n    return $this-&gt;authenticate('ImportKeyPair', $opt, $this-&gt;hostname);\n}","related":{"method":["<a href=\"..\/amazonec2\/create_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_key_pair\"><code>create_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_key_pair.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_key_pair\"><code>delete_key_pair()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_key_pairs.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_key_pairs\"><code>describe_key_pairs()<\/code><\/a>"]}},{"name":"import_volume","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Image<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Format<\/code> - <code>string<\/code> - Required - <\/li><li><code>Bytes<\/code> - <code>long<\/code> - Required - <\/li><li><code>ImportManifestUrl<\/code> - <code>string<\/code> - Required - <\/li><\/ul><\/li><\/ul><\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Volume<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Size<\/code> - <code>long<\/code> - Required - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function import_volume($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional map (non-list)\n    if (isset($opt['Image']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Image' =&gt; $opt['Image']\n        )));\n        unset($opt['Image']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Volume']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Volume' =&gt; $opt['Volume']\n        )));\n        unset($opt['Volume']);\n    }\n\n    return $this-&gt;authenticate('ImportVolume', $opt);\n}"},{"name":"modify_image_attribute","modifier":"public","description":"<p>The ModifyImageAttribute operation modifies an attribute of an AMI.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"image_id","type":"string","description":"<p>The ID of the AMI whose attribute you want to modify.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Attribute<\/code> - <code>string<\/code> - Optional - The name of the AMI attribute you want to modify. Available attributes: <code>launchPermission<\/code>, <code>productCodes<\/code><\/li><li><code>OperationType<\/code> - <code>string<\/code> - Optional - The type of operation being requested. Available operation types: <code>add<\/code>, <code>remove<\/code><\/li><li><code>UserId<\/code> - <code>string|array<\/code> - Optional - The AWS user ID being added to or removed from the list of users with launch permissions for this AMI. Only valid when the launchPermission attribute is being modified. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>UserGroup<\/code> - <code>string|array<\/code> - Optional - The user group being added to or removed from the list of user groups with launch permissions for this AMI. Only valid when the launchPermission attribute is being modified. Available user groups: <code>all<\/code> Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>ProductCode<\/code> - <code>string|array<\/code> - Optional - The list of product codes being added to or removed from the specified AMI. Only valid when the productCodes attribute is being modified. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Value<\/code> - <code>string<\/code> - Optional - The value of the attribute being modified. Only valid when the description attribute is being modified.<\/li><li><code>LaunchPermission<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Add<\/code> - <code>array<\/code> - Optional - Describes a permission to launch an Amazon Machine Image (AMI). <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of the user involved in this launch permission.<\/li><li><code>Group<\/code> - <code>string<\/code> - Optional - The AWS group of the user involved in this launch permission. Available groups: <code>all<\/code><\/li><\/ul><\/li><\/ul><\/li><li><code>Remove<\/code> - <code>array<\/code> - Optional - Describes a permission to launch an Amazon Machine Image (AMI). <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of the user involved in this launch permission.<\/li><li><code>Group<\/code> - <code>string<\/code> - Optional - The AWS group of the user involved in this launch permission. Available groups: <code>all<\/code><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>Description.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_image_attribute($image_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ImageId'] = $image_id;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['UserId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'UserId' =&gt; (is_array($opt['UserId']) ? $opt['UserId'] : array($opt['UserId']))\n        )));\n        unset($opt['UserId']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['UserGroup']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'UserGroup' =&gt; (is_array($opt['UserGroup']) ? $opt['UserGroup'] : array($opt['UserGroup']))\n        )));\n        unset($opt['UserGroup']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['ProductCode']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ProductCode' =&gt; (is_array($opt['ProductCode']) ? $opt['ProductCode'] : array($opt['ProductCode']))\n        )));\n        unset($opt['ProductCode']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['LaunchPermission']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'LaunchPermission' =&gt; $opt['LaunchPermission']\n        )));\n        unset($opt['LaunchPermission']);\n    }\n\n    return $this-&gt;authenticate('ModifyImageAttribute', $opt);\n}","examples":{"example":{"title":"<p>Modify an attribute of an image.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;modify_image_attribute('ami-42ad462b', array(\n\t'LaunchPermission' =&gt; array(\n\t\t'Add' =&gt; array(array('Group' =&gt; 'all'))\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-ModifyImageAttribute.html\">ModifyImageAttribute<\/a> operation introduced backwards-incompatible changes in the <code>2011-02-28<\/code> API release. The <code>Attribute<\/code> parameter is no longer required.<\/p>"}},{"name":"modify_instance_attribute","modifier":"public","description":"<p>Modifies an attribute of an instance.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the instance whose attribute is being modified.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Attribute<\/code> - <code>string<\/code> - Optional - The name of the attribute being modified. Available attribute names: <code>instanceType<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code>, <code>instanceInitiatedShutdownBehavior<\/code>, <code>rootDevice<\/code>, <code>blockDeviceMapping<\/code> [Allowed values: <code>instanceType<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code>, <code>instanceInitiatedShutdownBehavior<\/code>, <code>rootDeviceName<\/code>, <code>blockDeviceMapping<\/code>, <code>productCodes<\/code>, <code>sourceDestCheck<\/code>, <code>groupSet<\/code>, <code>ebsOptimized<\/code>]<\/li><li><code>Value<\/code> - <code>string<\/code> - Optional - The new value of the instance attribute being modified. Only valid when <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code> or <code>instanceInitiateShutdownBehavior<\/code> is specified as the attribute being modified.<\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - The new block device mappings for the instance whose attributes are being modified. Only valid when blockDeviceMapping is specified as the attribute being modified. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - The device name (e.g., <code>\/dev\/sdh<\/code>) at which the block device is exposed on the instance.<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - The EBS instance block device specification describing the EBS block device to map to the specified device name on a running instance. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VolumeId<\/code> - <code>string<\/code> - Optional - The ID of the EBS volume that should be mounted as a block device on an Amazon EC2 instance.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><\/ul><\/li><\/ul><\/li><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - The virtual device name.<\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - When set to the empty string, specifies that the device name in this object should not be mapped to any real device.<\/li><\/ul><\/li><\/ul><\/li><li><code>SourceDestCheck.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>DisableApiTermination.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>InstanceType.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>Kernel.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>Ramdisk.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>UserData.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>InstanceInitiatedShutdownBehavior.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>GroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>EbsOptimized.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_instance_attribute($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    \n    \/\/ Optional list + map\n    if (isset($opt['BlockDeviceMapping']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']\n        )));\n        unset($opt['BlockDeviceMapping']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['GroupId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'GroupId' =&gt; (is_array($opt['GroupId']) ? $opt['GroupId'] : array($opt['GroupId']))\n        )));\n        unset($opt['GroupId']);\n    }\n\n    return $this-&gt;authenticate('ModifyInstanceAttribute', $opt);\n}","examples":{"example":{"title":"<p>Modify an attribute on a stopped EBS-backed instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;modify_instance_attribute('i-1f549375', array(\n\t'InstanceType.Value' =&gt; 'c1.medium'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-ModifyInstanceAttribute.html\">ModifyInstanceAttribute<\/a> operation introduced backwards-incompatible changes in the <code>2011-02-28<\/code> API release. The <code>Attribute<\/code> parameter is no longer required.<\/p>"}},{"name":"modify_network_interface_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Description.Value<\/code> - <code>string<\/code> - Optional - String value<\/li><li><code>SourceDestCheck.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>SecurityGroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Attachment<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>AttachmentId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_network_interface_attribute($network_interface_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['SecurityGroupId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))\n        )));\n        unset($opt['SecurityGroupId']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Attachment']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Attachment' =&gt; $opt['Attachment']\n        )));\n        unset($opt['Attachment']);\n    }\n\n    return $this-&gt;authenticate('ModifyNetworkInterfaceAttribute', $opt);\n}","examples":{"example":{"title":"<p>Modify, describe, and reset network interface attributes.<\/p>","code":"$ec2 = new AmazonEC2();\n\n###########################################################################\n# Modify Network Interface Attribute\n\n$response = $ec2-&gt;modify_network_interface_attribute($network_interface_id, array(\n\t'SourceDestCheck.Value' =&gt; 'false',\n));\n\nvar_dump($response-&gt;isOK());\n\n###########################################################################\n# Describe Network Interface Attributes\n\n$response = $ec2-&gt;describe_network_interface_attribute($network_interface_id, array(\n        'Attribute' =&gt; 'sourceDestCheck',\n));\n\nvar_dump($response-&gt;isOK());\n\n###########################################################################\n# Reset Network Interface Attribute\n\n$response = $ec2-&gt;reset_network_interface_attribute($network_interface_id, array(\n\t'Attribute' =&gt; 'sourceDestCheck',\n));\n\nvar_dump($response-&gt;isOK());\n\nsleep(5);","result":"bool(true)\nbool(true)\nbool(true)"}}},{"name":"modify_snapshot_attribute","modifier":"public","description":"<p>Adds or remove permission settings for the specified snapshot.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"snapshot_id","type":"string","description":"<p>The ID of the EBS snapshot whose attributes are being modified.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Attribute<\/code> - <code>string<\/code> - Optional - The name of the attribute being modified. Available attribute names: <code>createVolumePermission<\/code> [Allowed values: <code>productCodes<\/code>, <code>createVolumePermission<\/code>]<\/li><li><code>OperationType<\/code> - <code>string<\/code> - Optional - The operation to perform on the attribute. Available operation names: <code>add<\/code>, <code>remove<\/code><\/li><li><code>UserId<\/code> - <code>string|array<\/code> - Optional - The AWS user IDs to add to or remove from the list of users that have permission to create EBS volumes from the specified snapshot. Currently supports &#8220;all&#8221;. <p class=\"note\">Only valid when the <code>createVolumePermission<\/code> attribute is being modified.<\/p> Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>UserGroup<\/code> - <code>string|array<\/code> - Optional - The AWS group names to add to or remove from the list of groups that have permission to create EBS volumes from the specified snapshot. Currently supports &#8220;all&#8221;. <p class=\"note\">Only valid when the <code>createVolumePermission<\/code> attribute is being modified.<\/p> Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>CreateVolumePermission<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Add<\/code> - <code>array<\/code> - Optional - Describes a permission allowing either a user or group to create a new EBS volume from a snapshot. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The user ID of the user that can create volumes from the snapshot.<\/li><li><code>Group<\/code> - <code>string<\/code> - Optional - The group that is allowed to create volumes from the snapshot (currently supports &#8220;all&#8221;).<\/li><\/ul><\/li><\/ul><\/li><li><code>Remove<\/code> - <code>array<\/code> - Optional - Describes a permission allowing either a user or group to create a new EBS volume from a snapshot. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The user ID of the user that can create volumes from the snapshot.<\/li><li><code>Group<\/code> - <code>string<\/code> - Optional - The group that is allowed to create volumes from the snapshot (currently supports &#8220;all&#8221;).<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_snapshot_attribute($snapshot_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SnapshotId'] = $snapshot_id;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['UserId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'UserId' =&gt; (is_array($opt['UserId']) ? $opt['UserId'] : array($opt['UserId']))\n        )));\n        unset($opt['UserId']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['UserGroup']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'UserGroup' =&gt; (is_array($opt['UserGroup']) ? $opt['UserGroup'] : array($opt['UserGroup']))\n        )));\n        unset($opt['UserGroup']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['CreateVolumePermission']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'CreateVolumePermission' =&gt; $opt['CreateVolumePermission']\n        )));\n        unset($opt['CreateVolumePermission']);\n    }\n\n    return $this-&gt;authenticate('ModifySnapshotAttribute', $opt);\n}","examples":{"example":{"title":"<p>Modify an attribute for a snapshot.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;modify_snapshot_attribute($snapshot_id, array(\n\t'CreateVolumePermission' =&gt; array(\n\t\t'Add' =&gt; array(array('UserId' =&gt; '960747153117'))\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_snapshot_attribute\"><code>reset_snapshot_attribute()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-ModifySnapshotAttribute.html\">ModifySnapshotAttribute<\/a> operation introduced backwards-incompatible changes in the <code>2011-11-01<\/code> API release. Parameters that used to be optional are now required, and the function signature has changed.<\/p>"}},{"name":"modify_volume_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"volume_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AutoEnableIO.Value<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_volume_attribute($volume_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VolumeId'] = $volume_id;\n    \n    return $this-&gt;authenticate('ModifyVolumeAttribute', $opt);\n}"},{"name":"modify_vpc_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"vpc_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>EnableDnsSupport.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>EnableDnsHostnames.Value<\/code> - <code>boolean<\/code> - Optional - Boolean value<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function modify_vpc_attribute($vpc_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VpcId'] = $vpc_id;\n    \n    return $this-&gt;authenticate('ModifyVpcAttribute', $opt);\n}"},{"name":"monitor_instances","modifier":"public","description":"<p>Enables monitoring for a running instance.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of Amazon EC2 instances on which to enable monitoring. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function monitor_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('MonitorInstances', $opt);\n}","examples":{"example":{"title":"<p>Enable monitoring for an instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Terminate instances\n$response = $ec2-&gt;monitor_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":"<a href=\"..\/amazonec2\/unmonitor_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/unmonitor_instances\"><code>unmonitor_instances()<\/code><\/a>"}},{"name":"purchase_reserved_instances_offering","modifier":"public","description":"<p>The PurchaseReservedInstancesOffering operation purchases a Reserved Instance for use with your\naccount. With Amazon EC2 Reserved Instances, you purchase the right to launch Amazon EC2\ninstances for a period of time (without getting insufficient capacity errors) and pay a lower\nusage rate for the actual time used.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"reserved_instances_offering_id","type":"string","description":"<p>The unique ID of the Reserved Instances offering being purchased.<\/p>"},{"@attributes":{"choice":"req"},"name":"instance_count","type":"integer","description":"<p>The number of Reserved Instances to purchase.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>LimitPrice<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Amount<\/code> - <code>double<\/code> - Optional - <\/li><li><code>CurrencyCode<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function purchase_reserved_instances_offering($reserved_instances_offering_id, $instance_count, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ReservedInstancesOfferingId'] = $reserved_instances_offering_id;\n    $opt['InstanceCount'] = $instance_count;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['LimitPrice']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'LimitPrice' =&gt; $opt['LimitPrice']\n        )));\n        unset($opt['LimitPrice']);\n    }\n\n    return $this-&gt;authenticate('PurchaseReservedInstancesOffering', $opt);\n}","examples":{"example":{"title":"<p>Purchase a reserved instances offering.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;purchase_reserved_instances_offering('438012d3-352b-4361-9d2e-a3166db861b1', 1);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_reserved_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_reserved_instances\"><code>describe_reserved_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_reserved_instances_offerings.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_reserved_instances_offerings\"><code>describe_reserved_instances_offerings()<\/code><\/a>"]}},{"name":"reboot_instances","modifier":"public","description":"<p>The RebootInstances operation requests a reboot of one or more instances. This operation is\nasynchronous; it only queues a request to reboot the specified instance(s). The operation will\nsucceed if the instances are valid and belong to the user. Requests to reboot terminated\ninstances are ignored.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of instances to terminate. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function reboot_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('RebootInstances', $opt);\n}","examples":{"example":{"title":"<p>Reboot an instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;reboot_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"register_image","modifier":"public","description":"<p>The RegisterImage operation registers an AMI with Amazon EC2. Images must be registered before\nthey can be launched. For more information, see RunInstances.<\/p>\n\n<p>Each AMI is associated with an unique ID which is provided by the Amazon EC2 service through\nthe RegisterImage operation. During registration, Amazon EC2 retrieves the specified image\nmanifest from Amazon S3 and verifies that the image is owned by the user registering the image.<\/p>\n\n<p>The image manifest is retrieved once and stored within the Amazon EC2. Any modifications to an\nimage in Amazon S3 invalidates this registration. If you make changes to an image, deregister\nthe previous image and register the new image. For more information, see DeregisterImage.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ImageLocation<\/code> - <code>string<\/code> - Optional - The full path to your AMI manifest in Amazon S3 storage.<\/li><li><code>Name<\/code> - <code>string<\/code> - Optional - The name to give the new Amazon Machine Image. Constraints: 3-128 alphanumeric characters, parenthesis (<code>()<\/code>), commas (<code>,<\/code>), slashes (<code>\/<\/code>), dashes (<code>-<\/code>), or underscores(<code>_<\/code>)<\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - The description describing the new AMI.<\/li><li><code>Architecture<\/code> - <code>string<\/code> - Optional - The architecture of the image. Valid Values: <code>i386<\/code>, <code>x86_64<\/code><\/li><li><code>KernelId<\/code> - <code>string<\/code> - Optional - The optional ID of a specific kernel to register with the new AMI.<\/li><li><code>RamdiskId<\/code> - <code>string<\/code> - Optional - The optional ID of a specific ramdisk to register with the new AMI. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether you need to specify a RAM disk.<\/li><li><code>RootDeviceName<\/code> - <code>string<\/code> - Optional - The root device name (e.g., <code>\/dev\/sda1<\/code>).<\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - The block device mappings for the new AMI, which specify how different block devices (ex: EBS volumes and ephemeral drives) will be exposed on instances launched from the new image. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - Specifies the virtual device name.<\/li><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - Specifies the device name (e.g., <code>\/dev\/sdh<\/code>).<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which the volume will be created.<\/li><li><code>VolumeSize<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - Specifies the device name to suppress during instance launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function register_image($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['BlockDeviceMapping']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']\n        )));\n        unset($opt['BlockDeviceMapping']);\n    }\n\n    return $this-&gt;authenticate('RegisterImage', $opt);\n}","examples":{"example":{"title":"<p>Register an S3-backed AMI.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Register the image\n$response = $ec2-&gt;register_image(array(\n\t'ImageLocation' =&gt; 'my-image-bucket\/image01.manifest.xml',\n\t'Name' =&gt; 'my-image',\n\t'Description' =&gt; 'This is a sample description.',\n\t'BlockDeviceMapping' =&gt; array(\n\t\tarray( \/\/ BlockDeviceMapping.0.{key}={value}\n\t\t\t&quot;DeviceName&quot; =&gt; &quot;\/dev\/sdg&quot;,\n\t\t\t&quot;VirtualName&quot; =&gt; &quot;sdg&quot;,\n\t\t\t&quot;Ebs&quot; =&gt; array(\n\t\t\t\t&quot;VolumeSize&quot; =&gt; 5,\n\t\t\t\t&quot;DeleteOnTermination&quot; =&gt; &quot;true&quot;\n\t\t\t)\n\t\t),\n\t\tarray( \/\/ BlockDeviceMapping.1.{key}={value}\n\t\t\t&quot;DeviceName&quot; =&gt; &quot;\/dev\/sdh&quot;,\n\t\t\t&quot;VirtualName&quot; =&gt; &quot;sdh&quot;,\n\t\t\t&quot;Ebs&quot; =&gt; array(\n\t\t\t\t&quot;VolumeSize&quot; =&gt; 5,\n\t\t\t\t&quot;DeleteOnTermination&quot; =&gt; &quot;true&quot;\n\t\t\t)\n\t\t)\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_image_attribute\"><code>reset_image_attribute()<\/code><\/a>"]},"changelog":{"change":"<p>The <code>$image_location<\/code> parameter is no longer required. To specify the image location for S3-backed AMIs, pass a value to the <code>ImageLocation<\/code> optional parameter.<\/p>"}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"release_address","modifier":"public","description":"<p>The ReleaseAddress operation releases an elastic IP address associated with your account.<\/p>\n\n<p class=\"note\">\nReleasing an IP address automatically disassociates it from any instance with which it is\nassociated. For more information, see DisassociateAddress.\n<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>After releasing an elastic IP address, it is released to the IP address pool and might no\nlonger be available to your account. Make sure to update your DNS records and any servers or\ndevices that communicate with the address.<\/p>\n\n<p>If you run this operation on an elastic IP address that is already released, the address might\nbe assigned to another account which will cause Amazon EC2 to return an error.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PublicIp<\/code> - <code>string<\/code> - Optional - The elastic IP address that you are releasing from your account.<\/li><li><code>AllocationId<\/code> - <code>string<\/code> - Optional - The allocation ID that AWS provided when you allocated the address for use with Amazon VPC.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function release_address($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ReleaseAddress', $opt);\n}","examples":{"example":{"title":"<p>Release an Elastic IP address.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;release_address(array(\n\t'PublicIp' =&gt; '184.73.247.11'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/allocate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/allocate_address\"><code>allocate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/associate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_address\"><code>associate_address()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_addresses.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_addresses\"><code>describe_addresses()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_address.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_address\"><code>disassociate_address()<\/code><\/a>"]}},{"name":"replace_network_acl_association","modifier":"public","description":"<p>Changes which network ACL a subnet is associated with. By default when you create a subnet,\nit&#8217;s automatically associated with the default network ACL. For more information about network\nACLs, go to Network ACLs in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"association_id","type":"string","description":"<p>The ID representing the current association between the original network ACL and the subnet.<\/p>"},{"@attributes":{"choice":"req"},"name":"network_acl_id","type":"string","description":"<p>The ID of the new ACL to associate with the subnet.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function replace_network_acl_association($association_id, $network_acl_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AssociationId'] = $association_id;\n    $opt['NetworkAclId'] = $network_acl_id;\n    \n    return $this-&gt;authenticate('ReplaceNetworkAclAssociation', $opt);\n}","examples":{"example":{"title":"<p>Replace an existing Network Access Control List (ACL) association.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;replace_network_acl_association('rtbassoc-babe3ed3', 'acl-4abf3f23');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_entry\"><code>replace_network_acl_entry()<\/code><\/a>"]}},{"name":"replace_network_acl_entry","modifier":"public","description":"<p>Replaces an entry (i.e., rule) in a network ACL. For more information about network ACLs, go to\nNetwork ACLs in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_acl_id","type":"string","description":"<p>ID of the ACL where the entry will be replaced.<\/p>"},{"@attributes":{"choice":"req"},"name":"rule_number","type":"integer","description":"<p>Rule number of the entry to replace.<\/p>"},{"@attributes":{"choice":"req"},"name":"protocol","type":"string","description":"<p>IP protocol the rule applies to. Valid Values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code> or an IP protocol number.<\/p>"},{"@attributes":{"choice":"req"},"name":"rule_action","type":"string","description":"<p>Whether to allow or deny traffic that matches the rule. [Allowed values: <code>allow<\/code>, <code>deny<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"egress","type":"boolean","description":"<p>Whether this rule applies to egress traffic from the subnet (<code>true<\/code>) or ingress traffic (<code>false<\/code>).<\/p>"},{"@attributes":{"choice":"req"},"name":"cidr_block","type":"string","description":"<p>The CIDR range to allow or deny, in CIDR notation (e.g., <code>172.16.0.0\/24<\/code>).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Icmp<\/code> - <code>array<\/code> - Optional - ICMP values. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Type<\/code> - <code>integer<\/code> - Optional - For the ICMP protocol, the ICMP type. A value of <code>-1<\/code> is a wildcard meaning all types. Required if specifying <code>icmp<\/code> for the protocol.<\/li><li><code>Code<\/code> - <code>integer<\/code> - Optional - For the ICMP protocol, the ICMP code. A value of <code>-1<\/code> is a wildcard meaning all codes. Required if specifying <code>icmp<\/code> for the protocol.<\/li><\/ul><\/li><\/ul><\/li><li><code>PortRange<\/code> - <code>array<\/code> - Optional - Port ranges. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>From<\/code> - <code>integer<\/code> - Optional - The first port in the range. Required if specifying <code>tcp<\/code> or <code>udp<\/code> for the protocol.<\/li><li><code>To<\/code> - <code>integer<\/code> - Optional - The last port in the range. Required if specifying <code>tcp<\/code> or <code>udp<\/code> for the protocol.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function replace_network_acl_entry($network_acl_id, $rule_number, $protocol, $rule_action, $egress, $cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkAclId'] = $network_acl_id;\n    $opt['RuleNumber'] = $rule_number;\n    $opt['Protocol'] = $protocol;\n    $opt['RuleAction'] = $rule_action;\n    $opt['Egress'] = $egress;\n    $opt['CidrBlock'] = $cidr_block;\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Icmp']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Icmp' =&gt; $opt['Icmp']\n        )));\n        unset($opt['Icmp']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['PortRange']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'PortRange' =&gt; $opt['PortRange']\n        )));\n        unset($opt['PortRange']);\n    }\n\n    return $this-&gt;authenticate('ReplaceNetworkAclEntry', $opt);\n}","examples":{"example":{"title":"<p>Replace an existing entry in the Network Access Control List (ACL).<\/p>","code":"$ec2 = new AmazonEC2();\n\n$tcp = 6;\n$response = $ec2-&gt;replace_network_acl_entry('acl-4abf3f23', 1, $tcp, 'allow', 'true', '172.16.0.0\/24', array(\n\t'PortRange' =&gt; array(\n\t\t'From' =&gt; 443,\n\t\t'To' =&gt; 443\n\t)\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl\"><code>create_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/create_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_network_acl_entry\"><code>create_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl\"><code>delete_network_acl()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_network_acl_entry.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_network_acl_entry\"><code>delete_network_acl_entry()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_network_acls.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_network_acls\"><code>describe_network_acls()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_network_acl_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_network_acl_association\"><code>replace_network_acl_association()<\/code><\/a>"]}},{"name":"replace_route","modifier":"public","description":"<p>Replaces an existing route within a route table in a VPC. For more information about route\ntables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the route table where the route will be replaced.<\/p>"},{"@attributes":{"choice":"req"},"name":"destination_cidr_block","type":"string","description":"<p>The CIDR address block used for the destination match. For example: <code>0.0.0.0\/0<\/code>. The value you provide must match the CIDR of an existing route in the table.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayId<\/code> - <code>string<\/code> - Optional - The ID of a VPN or Internet gateway attached to your VPC.<\/li><li><code>InstanceId<\/code> - <code>string<\/code> - Optional - The ID of a NAT instance in your VPC.<\/li><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function replace_route($route_table_id, $destination_cidr_block, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RouteTableId'] = $route_table_id;\n    $opt['DestinationCidrBlock'] = $destination_cidr_block;\n    \n    return $this-&gt;authenticate('ReplaceRoute', $opt);\n}","examples":{"example":{"title":"<p>Replace an existing VPC route.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;replace_route('rtb-e68b0b8f', '0.0.0.0\/0', array(\n\t'GatewayId' =&gt; 'igw-8c8e0ee5'\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route_table_association.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route_table_association\"><code>replace_route_table_association()<\/code><\/a>"]}},{"name":"replace_route_table_association","modifier":"public","description":"<p>Changes the route table associated with a given subnet in a VPC. After you execute this action,\nthe subnet uses the routes in the new route table it&#8217;s associated with. For more information\nabout route tables, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AmazonVPC\/latest\/UserGuide\/VPC_Route_Tables.html\">Route\nTables<\/a> in the Amazon Virtual Private Cloud User Guide.<\/p>\n\n<p>You can also use this to change which table is the main route table in the VPC. You just\nspecify the main route table&#8217;s association ID and the route table that you want to be the new\nmain route table.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"association_id","type":"string","description":"<p>The ID representing the current association between the original route table and the subnet.<\/p>"},{"@attributes":{"choice":"req"},"name":"route_table_id","type":"string","description":"<p>The ID of the new route table to associate with the subnet.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function replace_route_table_association($association_id, $route_table_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AssociationId'] = $association_id;\n    $opt['RouteTableId'] = $route_table_id;\n    \n    return $this-&gt;authenticate('ReplaceRouteTableAssociation', $opt);\n}","examples":{"example":{"title":"<p>Replace an existing VPC route table association with a subnet.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;replace_route_table_association('rtbassoc-ac8a0ac5', 'rtb-e68b0b8f');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/associate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/associate_route_table\"><code>associate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route\"><code>create_route()<\/code><\/a>","<a href=\"..\/amazonec2\/create_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_route_table\"><code>create_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route\"><code>delete_route()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_route_table\"><code>delete_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_route_tables.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_route_tables\"><code>describe_route_tables()<\/code><\/a>","<a href=\"..\/amazonec2\/disassociate_route_table.html\" rel=\"..\/..\/index.html#m=amazonec2\/disassociate_route_table\"><code>disassociate_route_table()<\/code><\/a>","<a href=\"..\/amazonec2\/replace_route.html\" rel=\"..\/..\/index.html#m=amazonec2\/replace_route\"><code>replace_route()<\/code><\/a>"]}},{"name":"report_instance_status","modifier":"public","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Status<\/code> - <code>string<\/code> - Optional - <\/li><li><code>StartTime<\/code> - <code>string<\/code> - Optional -  May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>EndTime<\/code> - <code>string<\/code> - Optional -  May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>ReasonCode<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function report_instance_status($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional DateTime\n    if (isset($opt['StartTime']))\n    {\n        $opt['StartTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['StartTime']);\n    }\n    \n    \/\/ Optional DateTime\n    if (isset($opt['EndTime']))\n    {\n        $opt['EndTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['EndTime']);\n    }\n\n    \/\/ Optional list (non-map)\n    if (isset($opt['InstanceId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))\n        )));\n        unset($opt['InstanceId']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['ReasonCode']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'ReasonCode' =&gt; (is_array($opt['ReasonCode']) ? $opt['ReasonCode'] : array($opt['ReasonCode']))\n        )));\n        unset($opt['ReasonCode']);\n    }\n\n    return $this-&gt;authenticate('ReportInstanceStatus', $opt);\n}"},{"name":"request_spot_instances","modifier":"public","description":"<p>Creates a Spot Instance request.<\/p>\n\n<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that\nyou specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based\non available Spot Instance capacity and current spot instance requests.<\/p>\n\n<p>For conceptual information about Spot Instances, refer to the <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/DeveloperGuide\/\">Amazon Elastic Compute\nCloud Developer Guide<\/a> or <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/2009-11-30\/UserGuide\/\">Amazon Elastic Compute Cloud\nUser Guide.<\/a><\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"spot_price","type":"string","description":"<p>Specifies the maximum hourly price for any Spot Instance launched to fulfill the request.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>InstanceCount<\/code> - <code>integer<\/code> - Optional - Specifies the maximum number of Spot Instances to launch.<\/li><li><code>Type<\/code> - <code>string<\/code> - Optional - Specifies the Spot Instance type. [Allowed values: <code>one-time<\/code>, <code>persistent<\/code>]<\/li><li><code>ValidFrom<\/code> - <code>string<\/code> - Optional - Defines the start date of the request. If this is a one-time request, the request becomes active at this date and time and remains active until all instances launch, the request expires, or the request is canceled. If the request is persistent, the request becomes active at this date and time and remains active until it expires or is canceled. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>ValidUntil<\/code> - <code>string<\/code> - Optional - End date of the request. If this is a one-time request, the request remains active until all instances launch, the request is canceled, or this date is reached. If the request is persistent, it remains active until it is canceled or this date and time is reached. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>LaunchGroup<\/code> - <code>string<\/code> - Optional - Specifies the instance launch group. Launch groups are Spot Instances that launch and terminate together.<\/li><li><code>AvailabilityZoneGroup<\/code> - <code>string<\/code> - Optional - Specifies the Availability Zone group. When specifying the same Availability Zone group for all Spot Instance requests, all Spot Instances are launched in the same Availability Zone.<\/li><li><code>LaunchSpecification<\/code> - <code>array<\/code> - Optional - Specifies additional launch instance information. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>ImageId<\/code> - <code>string<\/code> - Optional - The AMI ID.<\/li><li><code>KeyName<\/code> - <code>string<\/code> - Optional - The name of the key pair.<\/li><li><code>GroupSet<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>GroupName<\/code> - <code>string<\/code> - Optional - <\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>SecurityGroup<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>UserData<\/code> - <code>string<\/code> - Optional - Optional data, specific to a user&#8217;s application, to provide in the launch request. All instances that collectively comprise the launch request have access to this data. User data is never returned through API responses.<\/li><li><code>AddressingType<\/code> - <code>string<\/code> - Optional - Deprecated.<\/li><li><code>InstanceType<\/code> - <code>string<\/code> - Optional - Specifies the instance type. [Allowed values: <code>t1.micro<\/code>, <code>m1.small<\/code>, <code>m1.medium<\/code>, <code>m1.large<\/code>, <code>m1.xlarge<\/code>, <code>m2.xlarge<\/code>, <code>m2.2xlarge<\/code>, <code>m2.4xlarge<\/code>, <code>m3.xlarge<\/code>, <code>m3.2xlarge<\/code>, <code>c1.medium<\/code>, <code>c1.xlarge<\/code>, <code>hi1.4xlarge<\/code>, <code>hs1.8xlarge<\/code>, <code>cc1.4xlarge<\/code>, <code>cc2.8xlarge<\/code>, <code>cg1.4xlarge<\/code>]<\/li><li><code>Placement<\/code> - <code>array<\/code> - Optional - Defines a placement item. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The availability zone in which an Amazon EC2 instance runs.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - The name of the <code>PlacementGroup<\/code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.<\/li><\/ul><\/li><\/ul><\/li><li><code>KernelId<\/code> - <code>string<\/code> - Optional - Specifies the ID of the kernel to select.<\/li><li><code>RamdiskId<\/code> - <code>string<\/code> - Optional - Specifies the ID of the RAM disk to select. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether or not you need to specify a RAM disk and search for the kernel ID.<\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - Specifies how block devices are exposed to the instance. Each mapping is made up of a virtualName and a deviceName. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - Specifies the virtual device name.<\/li><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - Specifies the device name (e.g., <code>\/dev\/sdh<\/code>).<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which the volume will be created.<\/li><li><code>VolumeSize<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - Specifies the device name to suppress during instance launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>Monitoring.Enabled<\/code> - <code>boolean<\/code> - Optional - Enables monitoring for the instance.<\/li><li><code>SubnetId<\/code> - <code>string<\/code> - Optional - Specifies the Amazon VPC subnet ID within which to launch the instance(s) for Amazon Virtual Private Cloud.<\/li><li><code>NetworkInterfaceSet<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>DeviceIndex<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>SubnetId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - <\/li><li><code>SecurityGroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>PrivateIpAddresses<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Required - <\/li><li><code>Primary<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>SecondaryPrivateIpAddressCount<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>IamInstanceProfile<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Arn<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Name<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>EbsOptimized<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function request_spot_instances($spot_price, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SpotPrice'] = $spot_price;\n    \n    \/\/ Optional DateTime\n    if (isset($opt['ValidFrom']))\n    {\n        $opt['ValidFrom'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['ValidFrom']);\n    }\n    \n    \/\/ Optional DateTime\n    if (isset($opt['ValidUntil']))\n    {\n        $opt['ValidUntil'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['ValidUntil']);\n    }\n\n    \/\/ Optional map (non-list)\n    if (isset($opt['LaunchSpecification']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'LaunchSpecification' =&gt; $opt['LaunchSpecification']\n        )));\n        unset($opt['LaunchSpecification']);\n    }\n\n    return $this-&gt;authenticate('RequestSpotInstances', $opt);\n}","examples":{"example":{"title":"<p>Request a spot instance up to a certain price point.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;request_spot_instances('0.05', array(\n\t'Type' =&gt; 'one-time',\n\t'ValidUntil' =&gt; 'tomorrow',\n\t'LaunchSpecification' =&gt; array(\n\t\t'ImageId' =&gt; 'ami-42ad462b',\n\t\t'InstanceType' =&gt; 'm1.small'\n\t),\n));\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/cancel_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/cancel_spot_instance_requests\"><code>cancel_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/create_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_spot_datafeed_subscription\"><code>create_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_spot_datafeed_subscription\"><code>delete_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_datafeed_subscription.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_datafeed_subscription\"><code>describe_spot_datafeed_subscription()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_instance_requests.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_instance_requests\"><code>describe_spot_instance_requests()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_spot_price_history.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_spot_price_history\"><code>describe_spot_price_history()<\/code><\/a>"]}},{"name":"reset_image_attribute","modifier":"public","description":"<p>The ResetImageAttribute operation resets an attribute of an AMI to its default value.<\/p>\n\n<p class=\"note\">\nThe productCodes attribute cannot be reset.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"image_id","type":"string","description":"<p>The ID of the AMI whose attribute is being reset.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the attribute being reset. Available attribute names: <code>launchPermission<\/code><\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function reset_image_attribute($image_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ImageId'] = $image_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('ResetImageAttribute', $opt);\n}","examples":{"example":{"title":"<p>Reset image attributes to default settings.<\/p>","code":"$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;reset_image_attribute('ami-42ad462b', 'launchPermission');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/create_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_image\"><code>create_image()<\/code><\/a>","<a href=\"..\/amazonec2\/deregister_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/deregister_image\"><code>deregister_image()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_image_attribute\"><code>describe_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_images.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_images\"><code>describe_images()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_image_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_image_attribute\"><code>modify_image_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/register_image.html\" rel=\"..\/..\/index.html#m=amazonec2\/register_image\"><code>register_image()<\/code><\/a>"]}},{"name":"reset_instance_attribute","modifier":"public","description":"<p>Resets an attribute of an instance to its default value.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string","description":"<p>The ID of the Amazon EC2 instance whose attribute is being reset.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the attribute being reset. Available attribute names: <code>kernel<\/code>, <code>ramdisk<\/code> [Allowed values: <code>instanceType<\/code>, <code>kernel<\/code>, <code>ramdisk<\/code>, <code>userData<\/code>, <code>disableApiTermination<\/code>, <code>instanceInitiatedShutdownBehavior<\/code>, <code>rootDeviceName<\/code>, <code>blockDeviceMapping<\/code>, <code>productCodes<\/code>, <code>sourceDestCheck<\/code>, <code>groupSet<\/code>, <code>ebsOptimized<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function reset_instance_attribute($instance_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceId'] = $instance_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('ResetInstanceAttribute', $opt);\n}","examples":{"example":{"title":"<p>Reset the attributes of a stopped instance to default settings.<\/p>","code":"$ec2 = new AmazonEC2();\n$response = $ec2-&gt;reset_instance_attribute('i-1f549375', 'kernel');\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"reset_network_interface_attribute","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>SourceDestCheck<\/code> - <code>string<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function reset_network_interface_attribute($network_interface_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    return $this-&gt;authenticate('ResetNetworkInterfaceAttribute', $opt);\n}"},{"name":"reset_snapshot_attribute","modifier":"public","description":"<p>Resets permission settings for the specified snapshot.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"snapshot_id","type":"string","description":"<p>The ID of the snapshot whose attribute is being reset.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute","type":"string","description":"<p>The name of the attribute being reset. Available attribute names: <code>createVolumePermission<\/code> [Allowed values: <code>productCodes<\/code>, <code>createVolumePermission<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function reset_snapshot_attribute($snapshot_id, $attribute, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SnapshotId'] = $snapshot_id;\n    $opt['Attribute'] = $attribute;\n    \n    return $this-&gt;authenticate('ResetSnapshotAttribute', $opt);\n}","examples":{"example":{"title":"<p>Reset the attributes for a snapshot to default settings.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;reset_snapshot_attribute('snap-a99b8bc1', 'createVolumePermission');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/attach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/attach_volume\"><code>attach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/create_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_snapshot\"><code>create_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/create_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_volume\"><code>create_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_snapshot.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_snapshot\"><code>delete_snapshot()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_volume\"><code>delete_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshot_attribute\"><code>describe_snapshot_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_snapshots.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_snapshots\"><code>describe_snapshots()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_volumes.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_volumes\"><code>describe_volumes()<\/code><\/a>","<a href=\"..\/amazonec2\/detach_volume.html\" rel=\"..\/..\/index.html#m=amazonec2\/detach_volume\"><code>detach_volume()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_snapshot_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_snapshot_attribute\"><code>modify_snapshot_attribute()<\/code><\/a>"]}},{"name":"revoke_security_group_egress","modifier":"public","description":"<p>This action applies only to security groups in a VPC. It doesn&#8217;t work with EC2 security groups.\nFor information about Amazon Virtual Private Cloud and VPC security groups, go to the Amazon\nVirtual Private Cloud User Guide.<\/p>\n\n<p>The action removes one or more egress rules from a VPC security group. The values that you\nspecify in the revoke request (e.g., ports, etc.) must match the existing rule&#8217;s values in\norder for the rule to be revoked.<\/p>\n\n<p>Each rule consists of the protocol, and the CIDR range or destination security group. For the\nTCP and UDP protocols, you must also specify the destination port or range of ports. For the\nICMP protocol, you must also specify the ICMP type and code.<\/p>\n\n<p>Rule changes are propagated to instances within the security group as quickly as possible.\nHowever, a small delay might occur.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_id","type":"string","description":"<p>ID of the VPC security group to modify.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>IpPermissions<\/code> - <code>array<\/code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol<\/code> - <code>string<\/code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code><\/li><li><code>FromPort<\/code> - <code>integer<\/code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1<\/code> indicates a wildcard (i.e., any ICMP type number).<\/li><li><code>ToPort<\/code> - <code>integer<\/code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1<\/code> indicates a wildcard (i.e., any ICMP code).<\/li><li><code>Groups<\/code> - <code>array<\/code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of an account.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><\/ul><\/li><\/ul><\/li><li><code>IpRanges<\/code> - <code>string|array<\/code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function revoke_security_group_egress($group_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupId'] = $group_id;\n    \n    \/\/ Optional list + map\n    if (isset($opt['IpPermissions']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'IpPermissions' =&gt; $opt['IpPermissions']\n        )));\n        unset($opt['IpPermissions']);\n    }\n\n    return $this-&gt;authenticate('RevokeSecurityGroupEgress', $opt);\n}","examples":{"example":{"title":"<p>Revoke Security Group Egress<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;revoke_security_group_egress('sg-830d1eef', array(\n\t'IpPermissions' =&gt; array(\n\t\tarray( \/\/ Set 0\n\t\t\t'IpProtocol' =&gt; 'tcp',\n\t\t\t'FromPort' =&gt; '80',\n\t\t\t'ToPort' =&gt; '80',\n\t\t\t'IpRanges' =&gt; array(\n\t\t\t\tarray('CidrIp' =&gt; '205.192.0.0\/16'), \/\/ Range 0\n\t\t\t)\n\t\t)\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_ingress\"><code>revoke_security_group_ingress()<\/code><\/a>"]}},{"name":"revoke_security_group_ingress","modifier":"public","description":"<p>The RevokeSecurityGroupIngress operation revokes permissions from a security group. The\npermissions used to revoke must be specified using the same values used to grant the\npermissions.<\/p>\n\n<p>Permissions are specified by IP protocol (TCP, UDP, or ICMP), the source of the request (by IP\nrange or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and\nUDP), and the ICMP codes and types (for ICMP).<\/p>\n\n<p>Permission changes are quickly propagated to instances within the security group. However,\ndepending on the number of instances in the group, a small delay might occur.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the standard (EC2) security group to modify. The group must belong to your account. Can be used instead of GroupID for standard (EC2) security groups.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the standard (EC2) or VPC security group to modify. The group must belong to your account. Required for VPC security groups; can be used instead of GroupName for standard (EC2) security groups.<\/li><li><code>IpPermissions<\/code> - <code>array<\/code> - Optional - List of IP permissions to revoke on the specified security group. For an IP permission to be removed, it must exactly match one of the IP permissions you specify in this list. Specifying permissions through IP permissions is the preferred way of revoking permissions since it offers more flexibility and control. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol<\/code> - <code>string<\/code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp<\/code>, <code>udp<\/code>, <code>icmp<\/code><\/li><li><code>FromPort<\/code> - <code>integer<\/code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1<\/code> indicates a wildcard (i.e., any ICMP type number).<\/li><li><code>ToPort<\/code> - <code>integer<\/code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1<\/code> indicates a wildcard (i.e., any ICMP code).<\/li><li><code>Groups<\/code> - <code>array<\/code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>UserId<\/code> - <code>string<\/code> - Optional - The AWS user ID of an account.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><li><code>GroupId<\/code> - <code>string<\/code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.<\/li><\/ul><\/li><\/ul><\/li><li><code>IpRanges<\/code> - <code>string|array<\/code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function revoke_security_group_ingress($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Optional list + map\n    if (isset($opt['IpPermissions']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'IpPermissions' =&gt; $opt['IpPermissions']\n        )));\n        unset($opt['IpPermissions']);\n    }\n\n    return $this-&gt;authenticate('RevokeSecurityGroupIngress', $opt);\n}","examples":{"example":{"title":"<p>Revoke security group ingress.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;revoke_security_group_ingress(array(\n\t'GroupName' =&gt; 'default',\n\t'IpPermissions' =&gt; array(\n\t\tarray( \/\/ Set 0\n\t\t\t'IpProtocol' =&gt; 'tcp',\n\t\t\t'FromPort' =&gt; '80',\n\t\t\t'ToPort' =&gt; '80',\n\t\t\t'IpRanges' =&gt; array(\n\t\t\t\tarray('CidrIp' =&gt; '205.192.0.0\/16'), \/\/ Range 0\n\t\t\t)\n\t\t)\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonec2\/authorize_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_egress\"><code>authorize_security_group_egress()<\/code><\/a>","<a href=\"..\/amazonec2\/authorize_security_group_ingress.html\" rel=\"..\/..\/index.html#m=amazonec2\/authorize_security_group_ingress\"><code>authorize_security_group_ingress()<\/code><\/a>","<a href=\"..\/amazonec2\/create_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/create_security_group\"><code>create_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/delete_security_group.html\" rel=\"..\/..\/index.html#m=amazonec2\/delete_security_group\"><code>delete_security_group()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_security_groups.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_security_groups\"><code>describe_security_groups()<\/code><\/a>","<a href=\"..\/amazonec2\/revoke_security_group_egress.html\" rel=\"..\/..\/index.html#m=amazonec2\/revoke_security_group_egress\"><code>revoke_security_group_egress()<\/code><\/a>"]},"changelog":{"change":"<p>The <a href=\"http:\/\/docs.aws.amazon.com\/AWSEC2\/latest\/APIReference\/index.html?ApiReference-query-RevokeSecurityGroupIngress.html\">RevokeSecurityGroupIngress<\/a> operation introduced backwards-incompatible changes in the <code>2011-01-01<\/code> API release. The <code>GroupName<\/code> parameter is no longer required. Instead <code>GroupName<\/code> or <code>GroupId<\/code> are conditionally required.<\/p>"}},{"name":"run_instances","modifier":"public","description":"<p>The RunInstances operation launches a specified number of instances.<\/p>\n\n<p>If Amazon EC2 cannot launch the minimum number AMIs you request, no instances launch. If there\nis insufficient capacity to launch the maximum number of AMIs you request, Amazon EC2 launches\nas many as possible to satisfy the requested maximum values.<\/p>\n\n<p>Every instance is launched in a security group. If you do not specify a security group at\nlaunch, the instances start in your default security group. For more information on creating\nsecurity groups, see CreateSecurityGroup.<\/p>\n\n<p>An optional instance type can be specified. For information about instance types, see Instance\nTypes.<\/p>\n\n<p>You can provide an optional key pair ID for each image in the launch request (for more\ninformation, see CreateKeyPair). All instances that are created from images that use this key\npair will have access to the associated public key at boot. You can use this key to provide\nsecure access to an instance of an image on a per-instance basis. Amazon EC2 public images use\nthis feature to provide secure access without passwords.<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>Launching public images without a key pair ID will leave them inaccessible.<\/p>\n\n<p>The public key material is made available to the instance at boot time by placing it in the\n<code>openssh_id.pub<\/code> file on a logical device that is exposed to the instance as\n<code>\/dev\/sda2<\/code> (the ephemeral store). The format of this file is suitable for use as an\nentry within <code>~\/.ssh\/authorized_keys<\/code> (the OpenSSH format). This can be done at boot\n(e.g., as part of <code>rc.local<\/code>) allowing for secure access without passwords.<\/p>\n\n<p>Optional user data can be provided in the launch request. All instances that collectively\ncomprise the launch request have access to this data For more information, see Instance\nMetadata.<\/p>\n\n<p class=\"note\">\nIf any of the AMIs have a product code attached for which the user has not subscribed, the\nRunInstances call will fail.\n<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>We strongly recommend using the 2.6.18 Xen stock kernel with the <code>c1.medium<\/code> and\n<code>c1.xlarge<\/code> instances. Although the default Amazon EC2 kernels will work, the new\nkernels provide greater stability and performance for these instance types. For more\ninformation about kernels, see Kernels, RAM Disks, and Block Device Mappings.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"image_id","type":"string","description":"<p>Unique ID of a machine image, returned by a call to DescribeImages.<\/p>"},{"@attributes":{"choice":"req"},"name":"min_count","type":"integer","description":"<p>Minimum number of instances to launch. If the value is more than Amazon EC2 can launch, no instances are launched at all.<\/p>"},{"@attributes":{"choice":"req"},"name":"max_count","type":"integer","description":"<p>Maximum number of instances to launch. If the value is more than Amazon EC2 can launch, the largest possible number above minCount will be launched instead. Between 1 and the maximum number allowed for your account (default: 20).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>KeyName<\/code> - <code>string<\/code> - Optional - The name of the key pair.<\/li><li><code>SecurityGroup<\/code> - <code>string|array<\/code> - Optional - The names of the security groups into which the instances will be launched. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>SecurityGroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>UserData<\/code> - <code>string<\/code> - Optional - Specifies additional information to make available to the instance(s).<\/li><li><code>InstanceType<\/code> - <code>string<\/code> - Optional - Specifies the instance type for the launched instances. [Allowed values: <code>t1.micro<\/code>, <code>m1.small<\/code>, <code>m1.medium<\/code>, <code>m1.large<\/code>, <code>m1.xlarge<\/code>, <code>m2.xlarge<\/code>, <code>m2.2xlarge<\/code>, <code>m2.4xlarge<\/code>, <code>m3.xlarge<\/code>, <code>m3.2xlarge<\/code>, <code>c1.medium<\/code>, <code>c1.xlarge<\/code>, <code>hi1.4xlarge<\/code>, <code>hs1.8xlarge<\/code>, <code>cc1.4xlarge<\/code>, <code>cc2.8xlarge<\/code>, <code>cg1.4xlarge<\/code>]<\/li><li><code>Placement<\/code> - <code>array<\/code> - Optional - Specifies the placement constraints (Availability Zones) for launching the instances. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone<\/code> - <code>string<\/code> - Optional - The availability zone in which an Amazon EC2 instance runs.<\/li><li><code>GroupName<\/code> - <code>string<\/code> - Optional - The name of the <code>PlacementGroup<\/code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.<\/li><li><code>Tenancy<\/code> - <code>string<\/code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means all instances launched into the VPC will be launched as dedicated tenancy regardless of the tenancy assigned to the instance at launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>KernelId<\/code> - <code>string<\/code> - Optional - The ID of the kernel with which to launch the instance.<\/li><li><code>RamdiskId<\/code> - <code>string<\/code> - Optional - The ID of the RAM disk with which to launch the instance. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether you need to specify a RAM disk. To find kernel requirements, go to the Resource Center and search for the kernel ID.<\/li><li><code>BlockDeviceMapping<\/code> - <code>array<\/code> - Optional - Specifies how block devices are exposed to the instance. Each mapping is made up of a virtualName and a deviceName. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>VirtualName<\/code> - <code>string<\/code> - Optional - Specifies the virtual device name.<\/li><li><code>DeviceName<\/code> - <code>string<\/code> - Optional - Specifies the device name (e.g., <code>\/dev\/sdh<\/code>).<\/li><li><code>Ebs<\/code> - <code>array<\/code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The ID of the snapshot from which the volume will be created.<\/li><li><code>VolumeSize<\/code> - <code>integer<\/code> - Optional - The size of the volume, in gigabytes.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.<\/li><li><code>VolumeType<\/code> - <code>string<\/code> - Optional -  [Allowed values: <code>standard<\/code>, <code>io1<\/code>]<\/li><li><code>Iops<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>NoDevice<\/code> - <code>string<\/code> - Optional - Specifies the device name to suppress during instance launch.<\/li><\/ul><\/li><\/ul><\/li><li><code>Monitoring.Enabled<\/code> - <code>boolean<\/code> - Optional - Enables monitoring for the instance.<\/li><li><code>SubnetId<\/code> - <code>string<\/code> - Optional - Specifies the subnet ID within which to launch the instance(s) for Amazon Virtual Private Cloud.<\/li><li><code>DisableApiTermination<\/code> - <code>boolean<\/code> - Optional - Specifies whether the instance can be terminated using the APIs. You must modify this attribute before you can terminate any &#8220;locked&#8221; instances from the APIs.<\/li><li><code>InstanceInitiatedShutdownBehavior<\/code> - <code>string<\/code> - Optional - Specifies whether the instance&#8217;s Amazon EBS volumes are stopped or terminated when the instance is shut down.<\/li><li><code>License<\/code> - <code>array<\/code> - Optional - Specifies active licenses in use and attached to an Amazon EC2 instance. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Pool<\/code> - <code>string<\/code> - Optional - The license pool from which to take a license when starting Amazon EC2 instances in the associated <code>RunInstances<\/code> request.<\/li><\/ul><\/li><\/ul><\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - If you&#8217;re using Amazon Virtual Private Cloud, you can optionally use this parameter to assign the instance a specific available IP address from the subnet.<\/li><li><code>ClientToken<\/code> - <code>string<\/code> - Optional - Unique, case-sensitive identifier you provide to ensure idempotency of the request. For more information, go to How to Ensure Idempotency in the Amazon Elastic Compute Cloud User Guide.<\/li><li><code>NetworkInterface<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>DeviceIndex<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>SubnetId<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - <\/li><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Optional - <\/li><li><code>SecurityGroupId<\/code> - <code>string|array<\/code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>DeleteOnTermination<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>PrivateIpAddresses<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress<\/code> - <code>string<\/code> - Required - <\/li><li><code>Primary<\/code> - <code>boolean<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>SecondaryPrivateIpAddressCount<\/code> - <code>integer<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>IamInstanceProfile<\/code> - <code>array<\/code> - Optional -  <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>Arn<\/code> - <code>string<\/code> - Optional - <\/li><li><code>Name<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><\/ul><\/li><li><code>EbsOptimized<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function run_instances($image_id, $min_count, $max_count, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ImageId'] = $image_id;\n    $opt['MinCount'] = $min_count;\n    $opt['MaxCount'] = $max_count;\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['SecurityGroup']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SecurityGroup' =&gt; (is_array($opt['SecurityGroup']) ? $opt['SecurityGroup'] : array($opt['SecurityGroup']))\n        )));\n        unset($opt['SecurityGroup']);\n    }\n    \n    \/\/ Optional list (non-map)\n    if (isset($opt['SecurityGroupId']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))\n        )));\n        unset($opt['SecurityGroupId']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['Placement']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'Placement' =&gt; $opt['Placement']\n        )));\n        unset($opt['Placement']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['BlockDeviceMapping']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']\n        )));\n        unset($opt['BlockDeviceMapping']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['License']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'License' =&gt; $opt['License']\n        )));\n        unset($opt['License']);\n    }\n    \n    \/\/ Optional list + map\n    if (isset($opt['NetworkInterface']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'NetworkInterface' =&gt; $opt['NetworkInterface']\n        )));\n        unset($opt['NetworkInterface']);\n    }\n    \n    \/\/ Optional map (non-list)\n    if (isset($opt['IamInstanceProfile']))\n    {\n        $opt = array_merge($opt, CFComplexType::map(array(\n            'IamInstanceProfile' =&gt; $opt['IamInstanceProfile']\n        )));\n        unset($opt['IamInstanceProfile']);\n    }\n\n    return $this-&gt;authenticate('RunInstances', $opt);\n}","examples":{"example":[{"title":"<p>Launch an EC2 instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Boot an instance of the image\n$response = $ec2-&gt;run_instances('ami-84db39ed', 1, 1, array(\n\t'InstanceType' =&gt; 'm1.small'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Run an instance in the VPC under a subnet<\/p>","code":"\/\/ Dependencies\nrequire_once dirname(__FILE__) . '\/..\/..\/sdk.class.php';\nrequire_once dirname(__FILE__) . '\/..\/testutil.inc.php';\n\n\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Boot an instance of the image into the subnet in the VPC\n$response = $ec2-&gt;run_instances($image_id, 1, 1, array(\n\t'InstanceType' =&gt; 'm1.small',\n        'SubnetId' =&gt; $subnet_id,\n));\n\n\/\/ Temporarily cache the InstanceID\nif ($response-&gt;isOK() &amp;&amp; isset($response-&gt;body-&gt;instancesSet-&gt;item-&gt;instanceId))\n{\n        $instance_id = (string) $response-&gt;body-&gt;instancesSet-&gt;item-&gt;instanceId;\n\tfile_put_contents(dirname(__FILE__) . '\/cache\/instance_id_subnet.cache', $instance_id);\n}\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\n\n    \/\/ Block until it's available\n    if (isset($instance_id))\n    {\n        \/\/ If it's not running yet, sleep for 20 seconds and check again\n        do\n        {\n            echo '.'; \/\/ Output something so we don't get a processing timeout from the test runner\n            sleep(10);\n\n            \/\/ Update the status of the instance\n            $status_check = $ec2-&gt;describe_instances(array(\n                'InstanceId' =&gt; $instance_id\n            ));\n        }\n        while ((int) $status_check-&gt;body-&gt;reservationSet-&gt;item-&gt;instancesSet-&gt;item-&gt;instanceState-&gt;code !== AmazonEC2::STATE_RUNNING);\n\n        echo 'done';\n    }"}]},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazonec2\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazonec2\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_us_w1\" rel=\"..\/..\/index.html#c=amazonec2\/region_us_w1\"><code>REGION_US_W1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_us_w2\" rel=\"..\/..\/index.html#c=amazonec2\/region_us_w2\"><code>REGION_US_W2<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_eu_w1\" rel=\"..\/..\/index.html#c=amazonec2\/region_eu_w1\"><code>REGION_EU_W1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_apac_se1\" rel=\"..\/..\/index.html#c=amazonec2\/region_apac_se1\"><code>REGION_APAC_SE1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_apac_se2\" rel=\"..\/..\/index.html#c=amazonec2\/region_apac_se2\"><code>REGION_APAC_SE2<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_apac_ne1\" rel=\"..\/..\/index.html#c=amazonec2\/region_apac_ne1\"><code>REGION_APAC_NE1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_us_gov1\" rel=\"..\/..\/index.html#c=amazonec2\/region_us_gov1\"><code>REGION_US_GOV1<\/code><\/a>, <a href=\"..\/amazonec2\/constants.html#region_sa_e1\" rel=\"..\/..\/index.html#c=amazonec2\/region_sa_e1\"><code>REGION_SA_E1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"example":{"title":"<p>Set the region to use.<\/p>","code":"$ec2 = new AmazonEC2();\n\n\/\/ Set the region to US-East (Northern Virginia)\n$ec2-&gt;set_region(AmazonEC2::REGION_US_E1);\n\n\/\/ Describe instances\n$response = $ec2-&gt;describe_instances();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"start_instances","modifier":"public","description":"<p>Starts an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon\nEBS volumes as their root devices can be quickly stopped and started. When an instance is\nstopped, the compute resources are released and you are not billed for hourly instance usage.\nHowever, your root partition Amazon EBS volume remains, continues to persist your data, and you\nare charged for Amazon EBS volume usage. You can restart your instance at any time.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>Performing this operation on an instance that uses an instance store as its root device returns\nan error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of Amazon EC2 instances to start. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function start_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('StartInstances', $opt);\n}","examples":{"example":{"title":"<p>Start a stopped EBS-backed instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;start_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"stop_instances","modifier":"public","description":"<p>Stops an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon\nEBS volumes as their root devices can be quickly stopped and started. When an instance is\nstopped, the compute resources are released and you are not billed for hourly instance usage.\nHowever, your root partition Amazon EBS volume remains, continues to persist your data, and you\nare charged for Amazon EBS volume usage. You can restart your instance at any time.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>Before stopping an instance, make sure it is in a state from which it can be restarted.\nStopping an instance does not preserve data stored in RAM.<\/p>\n\n<p>Performing this operation on an instance that uses an instance store as its root device returns\nan error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of Amazon EC2 instances to stop. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Force<\/code> - <code>boolean<\/code> - Optional - Forces the instance to stop. The instance will not have an opportunity to flush file system caches nor file system meta data. If you use this option, you must perform file system check and repair procedures. This option is not recommended for Windows instances.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function stop_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('StopInstances', $opt);\n}","examples":{"example":{"title":"<p>Stop a running EBS-backed instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n$response = $ec2-&gt;stop_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());"}},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/terminate_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/terminate_instances\"><code>terminate_instances()<\/code><\/a>"]}},{"name":"terminate_instances","modifier":"public","description":"<p>The TerminateInstances operation shuts down one or more instances. This operation is\nidempotent; if you terminate an instance more than once, each call will succeed.<\/p>\n\n<p>Terminated instances will remain visible after termination (approximately one hour).<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of instances to terminate. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function terminate_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('TerminateInstances', $opt);\n}","examples":{"example":[{"title":"<p>Terminate an instance in the VPC subnet<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Terminate instances\n$response = $ec2-&gt;terminate_instances($instance_id);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Terminate an instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Terminate instances\n$response = $ec2-&gt;terminate_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazonec2\/describe_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instance_attribute\"><code>describe_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/describe_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/describe_instances\"><code>describe_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/modify_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/modify_instance_attribute\"><code>modify_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/reboot_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/reboot_instances\"><code>reboot_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/reset_instance_attribute.html\" rel=\"..\/..\/index.html#m=amazonec2\/reset_instance_attribute\"><code>reset_instance_attribute()<\/code><\/a>","<a href=\"..\/amazonec2\/run_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/run_instances\"><code>run_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/start_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/start_instances\"><code>start_instances()<\/code><\/a>","<a href=\"..\/amazonec2\/stop_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/stop_instances\"><code>stop_instances()<\/code><\/a>"]}},{"name":"unassign_private_ip_addresses","modifier":"public","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"network_interface_id","type":"string","description":{}},{"@attributes":{"choice":"req"},"name":"private_ip_address","type":"string|array","description":"<p>Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function unassign_private_ip_addresses($network_interface_id, $private_ip_address, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['NetworkInterfaceId'] = $network_interface_id;\n    \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'PrivateIpAddress' =&gt; (is_array($private_ip_address) ? $private_ip_address : array($private_ip_address))\n    )));\n\n    return $this-&gt;authenticate('UnassignPrivateIpAddresses', $opt);\n}"},{"name":"unmonitor_instances","modifier":"public","description":"<p>Disables monitoring for a running instance.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_id","type":"string|array","description":"<p>The list of Amazon EC2 instances on which to disable monitoring. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function unmonitor_instances($instance_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))\n    )));\n\n    return $this-&gt;authenticate('UnmonitorInstances', $opt);\n}","examples":{"example":{"title":"<p>Disable monitoring on an instance.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Terminate instances\n$response = $ec2-&gt;unmonitor_instances('i-1f549375');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":"<a href=\"..\/amazonec2\/monitor_instances.html\" rel=\"..\/..\/index.html#m=amazonec2\/monitor_instances\"><code>monitor_instances()<\/code><\/a>"}}]},"constants":{"@attributes":{"count":"45"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"ec2.us-east-1.amazonaws.com"},{"name":"INSTANCE_CLUSTER_4XLARGE","value":"cc1.4xlarge"},{"name":"INSTANCE_CLUSTER_8XLARGE","value":"cc2.8xlarge"},{"name":"INSTANCE_CLUSTER_GPU_XLARGE","value":"cg1.4xlarge"},{"name":"INSTANCE_HIGH_CPU_MEDIUM","value":"c1.medium"},{"name":"INSTANCE_HIGH_CPU_XLARGE","value":"c1.xlarge"},{"name":"INSTANCE_HIGH_IO_4XLARGE","value":"hi1.4xlarge"},{"name":"INSTANCE_HIGH_MEM_2XLARGE","value":"m2.2xlarge"},{"name":"INSTANCE_HIGH_MEM_4XLARGE","value":"m2.4xlarge"},{"name":"INSTANCE_HIGH_MEM_XLARGE","value":"m2.xlarge"},{"name":"INSTANCE_LARGE","value":"m1.large"},{"name":"INSTANCE_M3_4XLARGE","value":"m3.4xlarge"},{"name":"INSTANCE_M3_XLARGE","value":"m3.xlarge"},{"name":"INSTANCE_MEDIUM","value":"m1.medium"},{"name":"INSTANCE_MICRO","value":"t1.micro"},{"name":"INSTANCE_SMALL","value":"m1.small"},{"name":"INSTANCE_STORAGE_8XLARGE","value":"hs1.8xlarge"},{"name":"INSTANCE_XLARGE","value":"m1.xlarge"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_APAC_NE1","value":"ec2.ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1","value":"ec2.ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE2","value":"ec2.ap-southeast-2.amazonaws.com"},{"name":"REGION_CALIFORNIA","value":"ec2.us-west-1.amazonaws.com"},{"name":"REGION_EU_W1","value":"ec2.eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND","value":"ec2.eu-west-1.amazonaws.com"},{"name":"REGION_OREGON","value":"ec2.us-west-2.amazonaws.com"},{"name":"REGION_SAO_PAULO","value":"ec2.sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1","value":"ec2.sa-east-1.amazonaws.com"},{"name":"REGION_SINGAPORE","value":"ec2.ap-southeast-1.amazonaws.com"},{"name":"REGION_SYDNEY","value":"ec2.ap-southeast-2.amazonaws.com"},{"name":"REGION_TOKYO","value":"ec2.ap-northeast-1.amazonaws.com"},{"name":"REGION_US_E1","value":"ec2.us-east-1.amazonaws.com"},{"name":"REGION_US_GOV1","value":"ec2.us-gov-west-1.amazonaws.com"},{"name":"REGION_US_W1","value":"ec2.us-west-1.amazonaws.com"},{"name":"REGION_US_W2","value":"ec2.us-west-2.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"ec2.us-east-1.amazonaws.com"},{"name":"STATE_PENDING","value":"0"},{"name":"STATE_RUNNING","value":"16"},{"name":"STATE_SHUTTING_DOWN","value":"32"},{"name":"STATE_STOPPED","value":"80"},{"name":"STATE_STOPPING","value":"64"},{"name":"STATE_TERMINATED","value":"48"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazonec2\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonec2\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}