{"file":{},"class":{"name":"AmazonIAM","file":"services\/iam.class.php","url":"..\/amazoniam\/index.html","description":"<p>This guide provides descriptions of the Identity and Access Management (IAM) API as well as\nlinks to related content in the guide, <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/\" target=\"_blank\">Using IAM<\/a>.<\/p>\n\n<p>IAM is a web service that enables AWS customers to manage users and user permissions under\ntheir AWS account. For more information about this product go to <a href=\n\"http:\/\/aws.amazon.com\/iam\/\" target=\"_blank\">AWS Identity and Access Management (IAM)<\/a>. For\ninformation about setting up signatures and authorization through the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.<\/p>\n\n<p>If you&#8217;re new to AWS and need additional technical information about a specific AWS product,\nyou can find the product&#8217;stechnical documentation at <a href=\n\"http:\/\/aws.amazon.com\/documentation\/\" target=\n\"_blank\">http:\/\/aws.amazon.com\/documentation\/<\/a>.<\/p>","metadata":{"version":"2013.01.14","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/iam\/ AWS Identity and Access Management","http:\/\/aws.amazon.com\/iam\/documentation\/ AWS Identity and Access Management documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"99"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazoniam\/index.html\" rel=\"..\/..\/index.html#i=amazoniam\"><code>AmazonIAM<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoniam\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2010-05-08';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV4Query';\n\n    return parent::__construct($options);\n}"},{"name":"add_role_to_instance_profile","modifier":"public","description":"<p>Adds the specified role to the specified instance profile. For more information about roles, go\nto <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>. For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_profile_name","type":"string","description":"<p>Name of the instance profile to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to add. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_role_to_instance_profile($instance_profile_name, $role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceProfileName'] = $instance_profile_name;\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('AddRoleToInstanceProfile', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ Role policy\n$role_policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Create role\n$response = $iam-&gt;create_role('example-role', AmazonIAM::STANDARD_EC2_ASSUME_ROLE_POLICY);\nvar_dump($response-&gt;isOK());\n\n\/\/ Create instance profile\n$response = $iam-&gt;create_instance_profile('example-profile');\nvar_dump($response-&gt;isOK());\n\n\/\/ Put role policy\n$response = $iam-&gt;put_role_policy('example-role', 'example-role-policy', $role_policy-&gt;get_json());\nvar_dump($response-&gt;isOK());\n\n\/\/ Add role to instance\n$response = $iam-&gt;add_role_to_instance_profile('example-profile', 'example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"add_user_to_group","modifier":"public","description":"<p>Adds the specified user to the specified group.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to add. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_user_to_group($group_name, $user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('AddUserToGroup', $opt);\n}","examples":{"example":{"title":"<p>Add a user to a group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Add a user to a group\n$response = $iam-&gt;add_user_to_group('abcd_group', 'johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/list_groups_for_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups_for_user\"><code>list_groups_for_user()<\/code><\/a>","<a href=\"..\/amazoniam\/remove_user_from_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/remove_user_from_group\"><code>remove_user_from_group()<\/code><\/a>"]}},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazoniam\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazoniam\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazoniam\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazoniam\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"change_password","modifier":"public","description":"<p>Changes the password of the IAM user calling <code>ChangePassword<\/code>. The root account\npassword is not affected by this action. For information about modifying passwords, see\n<a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/Using_ManagingLogins.html\"\ntarget=\"_blank\">Managing Passwords<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"old_password","type":"string","description":"<p>[Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"new_password","type":"string","description":"<p>[Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function change_password($old_password, $new_password, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['OldPassword'] = $old_password;\n    $opt['NewPassword'] = $new_password;\n    \n    return $this-&gt;authenticate('ChangePassword', $opt);\n}","examples":{"example":{"title":"<p>Change the IAM user's password.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM(array('key' =&gt; $access_key, 'secret' =&gt; $secret_key));\n\n$response = $iam-&gt;change_password('password', 'new-password');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"create_access_key","modifier":"public","description":"<p>Creates a new AWS Secret Access Key and corresponding AWS Access Key ID for the specified user.\nThe default status for new keys is <code>Active<\/code>.<\/p>\n\n<p>If you do not specify a user name, IAM determines the user name implicitly based on the AWS\nAccess Key ID signing the request. Because this action works for access keys under the AWS\naccount, you can use this API to manage root credentials even if the AWS account has no\nassociated users.<\/p>\n\n<p>For information about limits on the number of keys you can create, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"important\">\nTo ensure the security of your AWS account, the Secret Access Key is accessible only during key\nand user creation. You must save the key (for example, in a text file) if you want to be able\nto access it again. If a secret key is lost, you can delete the access keys for the associated\nuser and then create new keys.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - The user name that the new key will belong to. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_access_key($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('CreateAccessKey', $opt);\n}","examples":{"example":{"title":"<p>Create new access key and assign it to a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;create_access_key(array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_access_key\"><code>delete_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/list_access_keys.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_access_keys\"><code>list_access_keys()<\/code><\/a>","<a href=\"..\/amazoniam\/update_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_access_key\"><code>update_access_key()<\/code><\/a>"]}},{"name":"create_account_alias","modifier":"public","description":"<p>This action creates an alias for your AWS account. For information about using an AWS account\nalias, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AccountAlias.html\"\ntarget=\"_blank\">Using an Alias for Your AWS Account ID<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"account_alias","type":"string","description":"<p>Name of the account alias to create. [Constraints: The value must be between 3 and 63 characters, and must match the following regular expression pattern: <code>^<a href=\"([a-z0-9]|-(?!-))*[a-z0-9]\">a-z0-9<\/a>?$<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_account_alias($account_alias, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AccountAlias'] = $account_alias;\n    \n    return $this-&gt;authenticate('CreateAccountAlias', $opt);\n}","examples":{"example":{"title":"<p>Create a new alias for your account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM(array(\n\t'key'    =&gt; 'USERS_KEY',\n\t'secret' =&gt; 'USERS_SECRET_KEY'\n));\n\n$response = $iam-&gt;create_account_alias('joe');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"create_group","modifier":"public","description":"<p>Creates a new group.<\/p>\n\n<p>For information about the number of groups you can create, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to create. Do not include the path in this value. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path to the group. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_group($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('CreateGroup', $opt);\n}","examples":{"example":[{"title":"<p>Create a new user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;create_group('abc_group');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new child group\n$response = $iam-&gt;create_group('xyz_group', array(\n\t'Path' =&gt; '\/abc_group\/'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoniam\/delete_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group\"><code>delete_group()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group\"><code>get_group()<\/code><\/a>","<a href=\"..\/amazoniam\/list_groups.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups\"><code>list_groups()<\/code><\/a>","<a href=\"..\/amazoniam\/update_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_group\"><code>update_group()<\/code><\/a>"]}},{"name":"create_instance_profile","modifier":"public","description":"<p>Creates a new instance profile. For information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>\n\n<p>For information about the number of instance profiles you can create, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_profile_name","type":"string","description":"<p>Name of the instance profile to create. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path to the instance profile. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_instance_profile($instance_profile_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceProfileName'] = $instance_profile_name;\n    \n    return $this-&gt;authenticate('CreateInstanceProfile', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ Role policy\n$role_policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Create role\n$response = $iam-&gt;create_role('example-role', AmazonIAM::STANDARD_EC2_ASSUME_ROLE_POLICY);\nvar_dump($response-&gt;isOK());\n\n\/\/ Create instance profile\n$response = $iam-&gt;create_instance_profile('example-profile');\nvar_dump($response-&gt;isOK());\n\n\/\/ Put role policy\n$response = $iam-&gt;put_role_policy('example-role', 'example-role-policy', $role_policy-&gt;get_json());\nvar_dump($response-&gt;isOK());\n\n\/\/ Add role to instance\n$response = $iam-&gt;add_role_to_instance_profile('example-profile', 'example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"create_login_profile","modifier":"public","description":"<p>Creates a password for the specified user, giving the user the ability to access AWS services\nthrough the AWS Management Console. For more information about managing passwords, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_ManagingLogins.html\"\ntarget=\"_blank\">Managing Passwords<\/a> in <em>Using IAM<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to create a password for. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"password","type":"string","description":"<p>The new password for the user name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_login_profile($user_name, $password, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['Password'] = $password;\n    \n    return $this-&gt;authenticate('CreateLoginProfile', $opt);\n}","examples":{"example":{"title":"<p>Create a login profile for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;create_login_profile('johndoe2', 'password');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_login_profile\"><code>delete_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/get_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_login_profile\"><code>get_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/update_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_login_profile\"><code>update_login_profile()<\/code><\/a>"]}},{"name":"create_role","modifier":"public","description":"<p>Creates a new role for your AWS account. For more information about roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>. For information about limitations on role names and the number of roles you can\ncreate, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p>The policy grants permission to an EC2 instance to assume the role. The policy is URL-encoded\naccording to RFC 3986. For more information about RFC 3986, go to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>. Currently,\nonly EC2 instances can assume roles.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to create. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"assume_role_policy_document","type":"string","description":"<p>The policy that grants an entity permission to assume the role. [Constraints: The value must be between 1 and 131072 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path to the role. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_role($role_name, $assume_role_policy_document, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    $opt['AssumeRolePolicyDocument'] = $assume_role_policy_document;\n    \n    return $this-&gt;authenticate('CreateRole', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ Role policy\n$role_policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Create role\n$response = $iam-&gt;create_role('example-role', AmazonIAM::STANDARD_EC2_ASSUME_ROLE_POLICY);\nvar_dump($response-&gt;isOK());\n\n\/\/ Create instance profile\n$response = $iam-&gt;create_instance_profile('example-profile');\nvar_dump($response-&gt;isOK());\n\n\/\/ Put role policy\n$response = $iam-&gt;put_role_policy('example-role', 'example-role-policy', $role_policy-&gt;get_json());\nvar_dump($response-&gt;isOK());\n\n\/\/ Add role to instance\n$response = $iam-&gt;add_role_to_instance_profile('example-profile', 'example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"create_user","modifier":"public","description":"<p>Creates a new user for your AWS account.<\/p>\n\n<p>For information about limitations on the number of users you can create, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to create. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path for the user name. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_user($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('CreateUser', $opt);\n}","examples":{"example":{"title":"<p>Create a new user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;create_user('johndoe', array(\n\t'Path' =&gt; '\/abc_group\/xyz_group\/'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user\"><code>delete_user()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user\"><code>get_user()<\/code><\/a>","<a href=\"..\/amazoniam\/list_users.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_users\"><code>list_users()<\/code><\/a>","<a href=\"..\/amazoniam\/update_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_user\"><code>update_user()<\/code><\/a>"]}},{"name":"create_virtual_mfa_device","modifier":"public","description":"<p>Creates a new virtual MFA device for the AWS account. After creating the virtual MFA, use\n<a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/APIReference\/API_EnableMFADevice.html\"\ntarget=\"_blank\">EnableMFADevice<\/a> to attach the MFA device to an IAM user. For more\ninformation about creating and working with virtual MFA devices, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_VirtualMFA.html\"\ntarget=\"_blank\">Using a Virtual MFA Device<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p>For information about limits on the number of MFA devices you can create, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"important\">\nThe seed information contained in the QR code and the Base32 string should be treated like any\nother secret access information, such as your AWS access keys or your passwords. After you\nprovision your virtual device, you should ensure that the information is destroyed following\nsecure procedures.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"virtual_mfa_device_name","type":"string","description":"<p>The name of the virtual MFA device. Use with path to uniquely identify a virtual MFA device. [Constraints: The value must be more than 1 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path for the virtual MFA device. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_virtual_mfa_device($virtual_mfa_device_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['VirtualMFADeviceName'] = $virtual_mfa_device_name;\n    \n    return $this-&gt;authenticate('CreateVirtualMFADevice', $opt);\n}"},{"name":"deactivate_mfa_device","modifier":"public","description":"<p>Deactivates the specified MFA device and removes it from association with the user name for\nwhich it was originally enabled.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user whose MFA device you want to deactivate. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"serial_number","type":"string","description":"<p>The serial number that uniquely identifies the MFA device. For virtual MFA devices, the serial number is the device ARN. [Constraints: The value must be between 9 and 256 characters, and must match the following regular expression pattern: <code>[\\w+=\/:,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deactivate_mfa_device($user_name, $serial_number, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['SerialNumber'] = $serial_number;\n    \n    return $this-&gt;authenticate('DeactivateMFADevice', $opt);\n}","examples":{"example":{"title":"<p>Deactivates a multi-factor authentication device.<\/p>","description":"<p>Learn more about multi-factor authentication at <a href=\"http:\/\/aws.amazon.com\/mfa\/\">aws.amazon.com\/mfa<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;deactivate_mfa_device('johndoe2', CFCredentials::get('@default')-&gt;mfa_serial);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/enable_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/enable_mfa_device\"><code>enable_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/list_mfa_devices.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_mfa_devices\"><code>list_mfa_devices()<\/code><\/a>","<a href=\"..\/amazoniam\/resync_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/resync_mfa_device\"><code>resync_mfa_device()<\/code><\/a>"]}},{"name":"delete_access_key","modifier":"public","description":"<p>Deletes the access key associated with the specified user.<\/p>\n\n<p>If you do not specify a user name, IAM determines the user name implicitly based on the AWS\nAccess Key ID signing the request. Because this action works for access keys under the AWS\naccount, you can use this API to manage root credentials even if the AWS account has no\nassociated users.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"access_key_id","type":"string","description":"<p>The Access Key ID for the Access Key ID and Secret Access Key you want to delete. [Constraints: The value must be between 16 and 32 characters, and must match the following regular expression pattern: <code>[\\w]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user whose key you want to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_access_key($access_key_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AccessKeyId'] = $access_key_id;\n    \n    return $this-&gt;authenticate('DeleteAccessKey', $opt);\n}","examples":{"example":{"title":"<p>Delete an access key.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_access_key('AKIAIN7OWEXAMPLENN2A', array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_access_key\"><code>create_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/list_access_keys.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_access_keys\"><code>list_access_keys()<\/code><\/a>","<a href=\"..\/amazoniam\/update_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_access_key\"><code>update_access_key()<\/code><\/a>"]}},{"name":"delete_account_alias","modifier":"public","description":"<p>Deletes the specified AWS account alias. For information about using an AWS account alias, see\n<a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AccountAlias.html\" target=\n\"_blank\">Using an Alias for Your AWS Account ID<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"account_alias","type":"string","description":"<p>Name of the account alias to delete. [Constraints: The value must be between 3 and 63 characters, and must match the following regular expression pattern: <code>^<a href=\"([a-z0-9]|-(?!-))*[a-z0-9]\">a-z0-9<\/a>?$<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_account_alias($account_alias, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AccountAlias'] = $account_alias;\n    \n    return $this-&gt;authenticate('DeleteAccountAlias', $opt);\n}","examples":{"example":{"title":"<p>Delete an alias for your account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM(array(\n\t'key'    =&gt; 'USERS_KEY',\n\t'secret' =&gt; 'USERS_SECRET_KEY'\n));\n\n$response = $iam-&gt;delete_account_alias('joe');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"delete_account_password_policy","modifier":"public","description":"<p>Deletes the password policy for the AWS account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_account_password_policy($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('DeleteAccountPasswordPolicy', $opt);\n}","examples":{"example":{"title":"<p>Delete the account password policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_account_password_policy('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_group","modifier":"public","description":"<p>Deletes the specified group. The group must not contain any users or have any attached\npolicies.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_group($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('DeleteGroup', $opt);\n}","examples":{"example":[{"title":"<p>Delete a user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Delete a child group\n$response = $iam-&gt;delete_group('wxyz_group');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Delete a user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Delete a parent group\n$response = $iam-&gt;delete_group('abcd_group');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoniam\/create_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_group\"><code>create_group()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group\"><code>get_group()<\/code><\/a>","<a href=\"..\/amazoniam\/list_groups.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups\"><code>list_groups()<\/code><\/a>","<a href=\"..\/amazoniam\/update_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_group\"><code>update_group()<\/code><\/a>"]}},{"name":"delete_group_policy","modifier":"public","description":"<p>Deletes the specified policy that is associated with the specified group.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group the policy is associated with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_group_policy($group_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('DeleteGroupPolicy', $opt);\n}","examples":{"example":{"title":"<p>Delete a group policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_group_policy('abcd_group', 'group-policy');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group_policy\"><code>get_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_group_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_group_policies\"><code>list_group_policies()<\/code><\/a>","<a href=\"..\/amazoniam\/put_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_group_policy\"><code>put_group_policy()<\/code><\/a>"]}},{"name":"delete_instance_profile","modifier":"public","description":"<p>Deletes the specified instance profile. The instance profile must not have an associated role.<\/p>\n\n<p class=\"important\">\nMake sure you do not have any Amazon EC2 instances running with the instance profile you are\nabout to delete. Deleting a role or instance profile that is associated with a running instance\nwill break any applications running on the instance.\n<\/p>\n\n<p>For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_profile_name","type":"string","description":"<p>Name of the instance profile to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_instance_profile($instance_profile_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceProfileName'] = $instance_profile_name;\n    \n    return $this-&gt;authenticate('DeleteInstanceProfile', $opt);\n}","examples":{"0":{}}},{"name":"delete_login_profile","modifier":"public","description":"<p>Deletes the password for the specified user, which terminates the user&#8217;s ability to access AWS\nservices through the AWS Management Console.<\/p>\n\n<p class=\"important\">\nDeleting a user&#8217;s password does not prevent a user from accessing IAM through the command line\ninterface or the API. To prevent all user access you must also either make the access key\ninactive or delete it. For more information about making keys inactive or deleting them, see\n<code>UpdateAccessKey<\/code> and <code>DeleteAccessKey<\/code>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user whose password you want to delete. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_login_profile($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('DeleteLoginProfile', $opt);\n}","examples":{"example":{"title":"<p>Delete a login profile for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_login_profile('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_login_profile\"><code>create_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/get_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_login_profile\"><code>get_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/update_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_login_profile\"><code>update_login_profile()<\/code><\/a>"]}},{"name":"delete_role","modifier":"public","description":"<p>Deletes the specified role. The role must not have any policies attached. For more information\nabout roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>.<\/p>\n\n<p class=\"important\">\nMake sure you do not have any Amazon EC2 instances running with the role you are about to\ndelete. Deleting a role or instance profile that is associated with a running instance will\nbreak any applications running on the instance.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to delete. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_role($role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('DeleteRole', $opt);\n}","examples":{"0":{}}},{"name":"delete_role_policy","modifier":"public","description":"<p>Deletes the specified policy associated with the specified role.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role the associated with the policy. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_role_policy($role_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('DeleteRolePolicy', $opt);\n}","examples":{"0":{}}},{"name":"delete_server_certificate","modifier":"public","description":"<p>Deletes the specified server certificate.<\/p>\n\n<p class=\"important\">\nIf you are using a server certificate with Elastic Load Balancing, deleting the certificate\ncould have implications for your application. If Elastic Load Balancing doesn&#8217;t detect the\ndeletion of bound certificates, it may continue to use the certificates. This could cause\nElastic Load Balancing to stop accepting traffic. We recommend that you remove the reference to\nthe certificate from Elastic Load Balancing before using this command to delete the\ncertificate. For more information, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/ElasticLoadBalancing\/latest\/APIReference\/API_DeleteLoadBalancerListeners.html\"\ntarget=\"blank\">DeleteLoadBalancerListeners<\/a> in the <em>Elastic Load Balancing API\nReference<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"server_certificate_name","type":"string","description":"<p>The name of the server certificate you want to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_server_certificate($server_certificate_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ServerCertificateName'] = $server_certificate_name;\n    \n    return $this-&gt;authenticate('DeleteServerCertificate', $opt);\n}","examples":{"example":{"title":"<p>Delete a server certificate.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_server_certificate('my-server-cert');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"delete_signing_certificate","modifier":"public","description":"<p>Deletes the specified signing certificate associated with the specified user.<\/p>\n\n<p>If you do not specify a user name, IAM determines the user name implicitly based on the AWS\nAccess Key ID signing the request. Because this action works for access keys under the AWS\naccount, you can use this API to manage root credentials even if the AWS account has no\nassociated users.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"certificate_id","type":"string","description":"<p>ID of the signing certificate to delete. [Constraints: The value must be between 24 and 128 characters, and must match the following regular expression pattern: <code>[\\w]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user the signing certificate belongs to. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_signing_certificate($certificate_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['CertificateId'] = $certificate_id;\n    \n    return $this-&gt;authenticate('DeleteSigningCertificate', $opt);\n}","examples":{"example":{"title":"<p>Delete an X.509 signing certificate.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_signing_certificate('H76F5K3WMTCK7KW2OTVKONTEYEXAMPLE', array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/list_signing_certificates.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_signing_certificates\"><code>list_signing_certificates()<\/code><\/a>","<a href=\"..\/amazoniam\/update_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_signing_certificate\"><code>update_signing_certificate()<\/code><\/a>","<a href=\"..\/amazoniam\/upload_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/upload_signing_certificate\"><code>upload_signing_certificate()<\/code><\/a>"]}},{"name":"delete_user","modifier":"public","description":"<p>Deletes the specified user. The user must not belong to any groups, have any keys or signing\ncertificates, or have any attached policies.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_user($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('DeleteUser', $opt);\n}","examples":{"example":{"title":"<p>Delete a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Delete a user\n$response = $iam-&gt;delete_user('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_user\"><code>create_user()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user\"><code>get_user()<\/code><\/a>","<a href=\"..\/amazoniam\/list_users.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_users\"><code>list_users()<\/code><\/a>","<a href=\"..\/amazoniam\/update_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_user\"><code>update_user()<\/code><\/a>"]}},{"name":"delete_user_policy","modifier":"public","description":"<p>Deletes the specified policy associated with the specified user.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user the policy is associated with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to delete. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_user_policy($user_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('DeleteUserPolicy', $opt);\n}","examples":{"example":{"title":"<p>Delete a user policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;delete_user_policy('johndoe2', 'user-policy');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/decode_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/decode_policy\"><code>CFPolicy::decode_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user_policy\"><code>get_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_user_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_user_policies\"><code>list_user_policies()<\/code><\/a>","<a href=\"..\/amazoniam\/put_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_user_policy\"><code>put_user_policy()<\/code><\/a>"]}},{"name":"delete_virtual_mfa_device","modifier":"public","description":"<p>Deletes a virtual MFA device.<\/p>\n\n<p class=\"note\">\nYou must deactivate a user&#8217;s virtual MFA device before you can delete it. For information about\ndeactivating MFA devices, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/APIReference\/API_DeactivateMFADevice.html\">DeactivateMFADevice<\/a>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"serial_number","type":"string","description":"<p>The serial number that uniquely identifies the MFA device. For virtual MFA devices, the serial number is the same as the ARN. [Constraints: The value must be between 9 and 256 characters, and must match the following regular expression pattern: <code>[\\w+=\/:,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_virtual_mfa_device($serial_number, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SerialNumber'] = $serial_number;\n    \n    return $this-&gt;authenticate('DeleteVirtualMFADevice', $opt);\n}"},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"enable_mfa_device","modifier":"public","description":"<p>Enables the specified MFA device and associates it with the specified user name. When enabled,\nthe MFA device is required for every subsequent login by the user name associated with the\ndevice.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user for whom you want to enable the MFA device. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"serial_number","type":"string","description":"<p>The serial number that uniquely identifies the MFA device. For virtual MFA devices, the serial number is the device ARN. [Constraints: The value must be between 9 and 256 characters, and must match the following regular expression pattern: <code>[\\w+=\/:,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"authentication_code1","type":"string","description":"<p>An authentication code emitted by the device. [Constraints: The value must be between 6 and 6 characters, and must match the following regular expression pattern: <code>[\\d]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"authentication_code2","type":"string","description":"<p>A subsequent authentication code emitted by the device. [Constraints: The value must be between 6 and 6 characters, and must match the following regular expression pattern: <code>[\\d]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function enable_mfa_device($user_name, $serial_number, $authentication_code1, $authentication_code2, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['SerialNumber'] = $serial_number;\n    $opt['AuthenticationCode1'] = $authentication_code1;\n    $opt['AuthenticationCode2'] = $authentication_code2;\n    \n    return $this-&gt;authenticate('EnableMFADevice', $opt);\n}","examples":{"example":{"title":"<p>Enable a multi-factor authentication device.<\/p>","description":"<p>Learn more about multi-factor authentication at <a href=\"http:\/\/aws.amazon.com\/mfa\/\">aws.amazon.com\/mfa<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;enable_mfa_device('johndoe2', CFCredentials::get('@default')-&gt;mfa_serial, '123456', '987654');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/deactivate_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/deactivate_mfa_device\"><code>deactivate_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/list_mfa_devices.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_mfa_devices\"><code>list_mfa_devices()<\/code><\/a>","<a href=\"..\/amazoniam\/resync_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/resync_mfa_device\"><code>resync_mfa_device()<\/code><\/a>"]}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazoniam\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"get_account_password_policy","modifier":"public","description":"<p>Retrieves the password policy for the AWS account. For more information about using a password\npolicy, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/Using_ManagingPasswordPolicies.html\">Managing\nan IAM Password Policy<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_account_password_policy($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('GetAccountPasswordPolicy', $opt);\n}","examples":{"example":{"title":"<p>Get the account password policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;get_account_password_policy();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_account_summary","modifier":"public","description":"<p>Retrieves account level information about account entity usage and IAM quotas.<\/p>\n\n<p>For information about limitations on IAM entities, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_account_summary($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('GetAccountSummary', $opt);\n}","examples":{"example":{"title":"<p>Get a summary of your account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM(array(\n\t'key'    =&gt; 'USERS_KEY',\n\t'secret' =&gt; 'USERS_SECRET_KEY'\n));\n\n$response = $iam-&gt;get_account_summary();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{}},{"name":"get_group","modifier":"public","description":"<p>Returns a list of users that are in the specified group. You can paginate the results using the\n<code>MaxItems<\/code> and <code>Marker<\/code> parameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_group($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('GetGroup', $opt);\n}","examples":{"example":{"title":"<p>Get an existing group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;get_group('wxyz_group');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_group\"><code>create_group()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group\"><code>delete_group()<\/code><\/a>","<a href=\"..\/amazoniam\/list_groups.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups\"><code>list_groups()<\/code><\/a>","<a href=\"..\/amazoniam\/update_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_group\"><code>update_group()<\/code><\/a>"]}},{"name":"get_group_policy","modifier":"public","description":"<p>Retrieves the specified policy document for the specified group. The returned policy is\nURL-encoded according to RFC 3986. For more information about RFC 3986, go to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group the policy is associated with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to get. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_group_policy($group_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('GetGroupPolicy', $opt);\n}","examples":{"example":{"title":"<p>Get an existing group policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;get_group_policy('abcd_group', 'group-policy');\n\nif ($response-&gt;isOK() &amp;&amp; $response-&gt;body-&gt;PolicyDocument(0))\n{\n\t$policy_document = (string) $response-&gt;body-&gt;PolicyDocument(0);\n\t$policy_object = CFPolicy::decode_policy($policy_document);\n\n\tprint_r($policy_object);\n}","result":"Array\n(\n    [Statement] =&gt; Array\n        (\n            [0] =&gt; Array\n                (\n                    [Effect] =&gt; Allow\n                    [Action] =&gt; *\n                    [Resource] =&gt; *\n                )\n\n        )\n\n)"}},"related":{"method":["<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group_policy\"><code>delete_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_group_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_group_policies\"><code>list_group_policies()<\/code><\/a>","<a href=\"..\/amazoniam\/put_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_group_policy\"><code>put_group_policy()<\/code><\/a>"]}},{"name":"get_instance_profile","modifier":"public","description":"<p>Retrieves information about the specified instance profile, including the instance profile&#8217;s\npath, GUID, ARN, and role. For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>. For more information about ARNs, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/Using_Identifiers.html#Identifiers_ARNs\">\nARNs<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_profile_name","type":"string","description":"<p>Name of the instance profile to get information about. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_instance_profile($instance_profile_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceProfileName'] = $instance_profile_name;\n    \n    return $this-&gt;authenticate('GetInstanceProfile', $opt);\n}"},{"name":"get_login_profile","modifier":"public","description":"<p>Retrieves the user name and password create date for the specified user.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user whose login profile you want to retrieve. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_login_profile($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('GetLoginProfile', $opt);\n}","examples":{"example":{"title":"<p>Get a login profile for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;get_login_profile('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_login_profile\"><code>create_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_login_profile\"><code>delete_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/update_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_login_profile\"><code>update_login_profile()<\/code><\/a>"]}},{"name":"get_role","modifier":"public","description":"<p>Retrieves information about the specified role, including the role&#8217;s path, GUID, ARN, and the\npolicy granting permission to EC2 to assume the role. For more information about ARNs, go to\n<a href=\n\"%20http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/Using_Identifiers.html#Identifiers_ARNs\">\nARNs<\/a>. For more information about roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>.<\/p>\n\n<p>The returned policy is URL-encoded according to RFC 3986. For more information about RFC 3986,\ngo to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to get information about. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_role($role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('GetRole', $opt);\n}"},{"name":"get_role_policy","modifier":"public","description":"<p>Retrieves the specified policy document for the specified role. For more information about\nroles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>.<\/p>\n\n<p>The returned policy is URL-encoded according to RFC 3986. For more information about RFC 3986,\ngo to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role associated with the policy. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to get. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_role_policy($role_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('GetRolePolicy', $opt);\n}"},{"name":"get_server_certificate","modifier":"public","description":"<p>Retrieves information about the specified server certificate.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"server_certificate_name","type":"string","description":"<p>The name of the server certificate you want to retrieve information about. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_server_certificate($server_certificate_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ServerCertificateName'] = $server_certificate_name;\n    \n    return $this-&gt;authenticate('GetServerCertificate', $opt);\n}","examples":{"example":{"title":"<p>Get a server certificate.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;get_server_certificate('my-server-cert');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_user","modifier":"public","description":"<p>Retrieves information about the specified user, including the user&#8217;s path, GUID, and ARN.<\/p>\n\n<p>If you do not specify a user name, IAM determines the user name implicitly based on the AWS\nAccess Key ID signing the request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user to get information about. This parameter is optional. If it is not included, it defaults to the user making the request. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_user($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('GetUser', $opt);\n}","examples":{"example":{"title":"<p>Get an existing user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;get_user(array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_user\"><code>create_user()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user\"><code>delete_user()<\/code><\/a>","<a href=\"..\/amazoniam\/list_users.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_users\"><code>list_users()<\/code><\/a>","<a href=\"..\/amazoniam\/update_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_user\"><code>update_user()<\/code><\/a>"]}},{"name":"get_user_policy","modifier":"public","description":"<p>Retrieves the specified policy document for the specified user. The returned policy is\nURL-encoded according to RFC 3986. For more information about RFC 3986, go to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user who the policy is associated with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document to get. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_user_policy($user_name, $policy_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['PolicyName'] = $policy_name;\n    \n    return $this-&gt;authenticate('GetUserPolicy', $opt);\n}","examples":{"example":{"title":"<p>Get an existing user policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;get_user_policy('johndoe2', 'user-policy');\n\nif ($response-&gt;isOK() &amp;&amp; $response-&gt;body-&gt;PolicyDocument(0))\n{\n\t$policy_document = (string) $response-&gt;body-&gt;PolicyDocument(0);\n\t$policy_object = CFPolicy::decode_policy($policy_document);\n\n\tprint_r($policy_object);\n}","result":"Array\n(\n    [Statement] =&gt; Array\n        (\n            [0] =&gt; Array\n                (\n                    [Effect] =&gt; Allow\n                    [Action] =&gt; *\n                    [Resource] =&gt; *\n                )\n\n        )\n\n)"}},"related":{"method":["<a href=\"..\/cfpolicy\/decode_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/decode_policy\"><code>CFPolicy::decode_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user_policy\"><code>delete_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_user_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_user_policies\"><code>list_user_policies()<\/code><\/a>","<a href=\"..\/amazoniam\/put_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_user_policy\"><code>put_user_policy()<\/code><\/a>"]}},{"name":"list_access_keys","modifier":"public","description":"<p>Returns information about the Access Key IDs associated with the specified user. If there are\nnone, the action returns an empty list.<\/p>\n\n<p>Although each user is limited to a small number of keys, you can still paginate the results\nusing the <code>MaxItems<\/code> and <code>Marker<\/code> parameters.<\/p>\n\n<p>If the <code>UserName<\/code> field is not specified, the UserName is determined implicitly\nbased on the AWS Access Key ID used to sign the request. Because this action works for access\nkeys under the AWS account, this API can be used to manage root credentials even if the AWS\naccount has no associated users.<\/p>\n\n<p class=\"note\">\nTo ensure the security of your AWS account, the secret access key is accessible only during key\nand user creation.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of keys you want in the response. If there are additional keys beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_access_keys($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListAccessKeys', $opt);\n}","examples":{"example":[{"title":"<p>List all access keys.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_access_keys();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>List access keys for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_access_keys(array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoniam\/create_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_access_key\"><code>create_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_access_key\"><code>delete_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/update_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_access_key\"><code>update_access_key()<\/code><\/a>"]}},{"name":"list_account_aliases","modifier":"public","description":"<p>Lists the account aliases associated with the account. For information about using an AWS\naccount alias, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AccountAlias.html\" target=\n\"_blank\">Using an Alias for Your AWS Account ID<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of account aliases you want in the response. If there are additional account aliases beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_account_aliases($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListAccountAliases', $opt);\n}","examples":{"example":{"title":"<p>List aliases for your account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM(array(\n\t'key'    =&gt; 'USERS_KEY',\n\t'secret' =&gt; 'USERS_SECRET_KEY'\n));\n\n$response = $iam-&gt;list_account_aliases();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"list_group_policies","modifier":"public","description":"<p>Lists the names of the policies associated with the specified group. If there are none, the\naction returns an empty list.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>The name of the group to list policies for. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of policy names you want in the response. If there are additional policy names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_group_policies($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('ListGroupPolicies', $opt);\n}","examples":{"example":{"title":"<p>List all group policies.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_group_policies('abcd_group');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group_policy\"><code>delete_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group_policy\"><code>get_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/put_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_group_policy\"><code>put_group_policy()<\/code><\/a>"]}},{"name":"list_groups","modifier":"public","description":"<p>Lists the groups that have the specified path prefix.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PathPrefix<\/code> - <code>string<\/code> - Optional - The path prefix for filtering the results. For example: <code>\/division_abc\/subdivision_xyz\/<\/code>, which would get all groups whose path starts with <code>\/division_abc\/subdivision_xyz\/<\/code>. This parameter is optional. If it is not included, it defaults to a slash (\/), listing all groups. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>\\u002F[\\u0021-\\u007F]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of groups you want in the response. If there are additional groups beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_groups($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListGroups', $opt);\n}","examples":{"example":{"title":"<p>List the user groups available on this account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_groups();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_group\"><code>create_group()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group\"><code>delete_group()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group\"><code>get_group()<\/code><\/a>","<a href=\"..\/amazoniam\/update_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_group\"><code>update_group()<\/code><\/a>"]}},{"name":"list_groups_for_user","modifier":"public","description":"<p>Lists the groups the specified user belongs to.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>The name of the user to list groups for. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of groups you want in the response. If there are additional groups beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_groups_for_user($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('ListGroupsForUser', $opt);\n}","examples":{"example":{"title":"<p>List the groups associated with a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_groups_for_user('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/add_user_to_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/add_user_to_group\"><code>add_user_to_group()<\/code><\/a>","<a href=\"..\/amazoniam\/remove_user_from_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/remove_user_from_group\"><code>remove_user_from_group()<\/code><\/a>"]}},{"name":"list_instance_profiles","modifier":"public","description":"<p>Lists the instance profiles that have the specified path prefix. If there are none, the action\nreturns an empty list. For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PathPrefix<\/code> - <code>string<\/code> - Optional - The path prefix for filtering the results. For example: <code>\/application_abc\/component_xyz\/<\/code>, which would get all instance profiles whose path starts with <code>\/application_abc\/component_xyz\/<\/code>. This parameter is optional. If it is not included, it defaults to a slash (\/), listing all instance profiles. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>\\u002F[\\u0021-\\u007F]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_instance_profiles($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListInstanceProfiles', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ List instance profiles\n$response = $iam-&gt;list_instance_profiles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List roles\n$response = $iam-&gt;list_roles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List instance profiles for role\n$response = $iam-&gt;list_instance_profiles_for_role('example-role');\nvar_dump($response-&gt;isOK());\n\n\/\/ List role policies\n$response = $iam-&gt;list_role_policies('example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"list_instance_profiles_for_role","modifier":"public","description":"<p>Lists the instance profiles that have the specified associated role. If there are none, the\naction returns an empty list. For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>The name of the role to list instance profiles for. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_instance_profiles_for_role($role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('ListInstanceProfilesForRole', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ List instance profiles\n$response = $iam-&gt;list_instance_profiles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List roles\n$response = $iam-&gt;list_roles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List instance profiles for role\n$response = $iam-&gt;list_instance_profiles_for_role('example-role');\nvar_dump($response-&gt;isOK());\n\n\/\/ List role policies\n$response = $iam-&gt;list_role_policies('example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"list_mfa_devices","modifier":"public","description":"<p>Lists the MFA devices. If the request includes the user name, then this action lists all the\nMFA devices associated with the specified user name. If you do not specify a user name, IAM\ndetermines the user name implicitly based on the AWS Access Key ID signing the request.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user whose MFA devices you want to list. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of MFA devices you want in the response. If there are additional MFA devices beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_mfa_devices($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListMFADevices', $opt);\n}","examples":{"example":{"title":"<p>Lists multi-factor authentication devices for a user.<\/p>","description":"<p>Learn more about multi-factor authentication at <a href=\"http:\/\/aws.amazon.com\/mfa\/\">aws.amazon.com\/mfa<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_mfa_devices('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/deactivate_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/deactivate_mfa_device\"><code>deactivate_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/enable_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/enable_mfa_device\"><code>enable_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/resync_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/resync_mfa_device\"><code>resync_mfa_device()<\/code><\/a>"]},"changelog":{"change":"<p>The <code>ListMFADevices<\/code> operation introduced backwards-incompatible changes in this update. These changes were accounted for in this version of the SDK.<\/p>"}},{"name":"list_role_policies","modifier":"public","description":"<p>Lists the names of the policies associated with the specified role. If there are none, the\naction returns an empty list.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>The name of the role to list policies for. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_role_policies($role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('ListRolePolicies', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ List instance profiles\n$response = $iam-&gt;list_instance_profiles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List roles\n$response = $iam-&gt;list_roles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List instance profiles for role\n$response = $iam-&gt;list_instance_profiles_for_role('example-role');\nvar_dump($response-&gt;isOK());\n\n\/\/ List role policies\n$response = $iam-&gt;list_role_policies('example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"list_roles","modifier":"public","description":"<p>Lists the roles that have the specified path prefix. If there are none, the action returns an\nempty list. For more information about roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>\n\n<p>The returned policy is URL-encoded according to RFC 3986. For more information about RFC 3986,\ngo to <a href=\n\"http:\/\/www.faqs.org\/rfcs\/rfc3986.html\">http:\/\/www.faqs.org\/rfcs\/rfc3986.html<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PathPrefix<\/code> - <code>string<\/code> - Optional - The path prefix for filtering the results. For example: <code>\/application_abc\/component_xyz\/<\/code>, which would get all roles whose path starts with <code>\/application_abc\/component_xyz\/<\/code>. This parameter is optional. If it is not included, it defaults to a slash (\/), listing all roles. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>\\u002F[\\u0021-\\u007F]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_roles($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListRoles', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ List instance profiles\n$response = $iam-&gt;list_instance_profiles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List roles\n$response = $iam-&gt;list_roles();\nvar_dump($response-&gt;isOK());\n\n\/\/ List instance profiles for role\n$response = $iam-&gt;list_instance_profiles_for_role('example-role');\nvar_dump($response-&gt;isOK());\n\n\/\/ List role policies\n$response = $iam-&gt;list_role_policies('example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"list_server_certificates","modifier":"public","description":"<p>Lists the server certificates that have the specified path prefix. If none exist, the action\nreturns an empty list.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PathPrefix<\/code> - <code>string<\/code> - Optional - The path prefix for filtering the results. For example: <code>\/company\/servercerts<\/code> would get all server certificates for which the path starts with <code>\/company\/servercerts<\/code>. This parameter is optional. If it is not included, it defaults to a slash (\/), listing all server certificates. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>\\u002F[\\u0021-\\u007F]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of server certificates you want in the response. If there are additional server certificates beyond the maximum you specify, the <code>IsTruncated<\/code> response element will be set to <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_server_certificates($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListServerCertificates', $opt);\n}","examples":{"example":{"title":"<p>List the server certificates available on this account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_server_certificates();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"list_signing_certificates","modifier":"public","description":"<p>Returns information about the signing certificates associated with the specified user. If there\nare none, the action returns an empty list.<\/p>\n\n<p>Although each user is limited to a small number of signing certificates, you can still paginate\nthe results using the <code>MaxItems<\/code> and <code>Marker<\/code> parameters.<\/p>\n\n<p>If the <code>UserName<\/code> field is not specified, the user name is determined implicitly\nbased on the AWS Access Key ID used to sign the request. Because this action works for access\nkeys under the AWS account, this API can be used to manage root credentials even if the AWS\naccount has no associated users.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - The name of the user. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of certificate IDs you want in the response. If there are additional certificate IDs beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_signing_certificates($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListSigningCertificates', $opt);\n}","examples":{"example":{"title":"<p>Lists all X.509 signing certificates.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_signing_certificates();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_signing_certificate\"><code>delete_signing_certificate()<\/code><\/a>","<a href=\"..\/amazoniam\/update_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_signing_certificate\"><code>update_signing_certificate()<\/code><\/a>","<a href=\"..\/amazoniam\/upload_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/upload_signing_certificate\"><code>upload_signing_certificate()<\/code><\/a>"]}},{"name":"list_user_policies","modifier":"public","description":"<p>Lists the names of the policies associated with the specified user. If there are none, the\naction returns an empty list.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>The name of the user to list policies for. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this only when paginating results to indicate the maximum number of policy names you want in the response. If there are additional policy names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_user_policies($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('ListUserPolicies', $opt);\n}","examples":{"example":{"title":"<p>List all user policies.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_user_policies('johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/decode_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/decode_policy\"><code>CFPolicy::decode_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user_policy\"><code>delete_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user_policy\"><code>get_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/put_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/put_user_policy\"><code>put_user_policy()<\/code><\/a>"]}},{"name":"list_users","modifier":"public","description":"<p>Lists the users that have the specified path prefix. If there are none, the action returns an\nempty list.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>PathPrefix<\/code> - <code>string<\/code> - Optional - The path prefix for filtering the results. For example: <code>\/division_abc\/subdivision_xyz\/<\/code>, which would get all user names whose path starts with <code>\/division_abc\/subdivision_xyz\/<\/code>. This parameter is optional. If it is not included, it defaults to a slash (\/), listing all user names. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>\\u002F[\\u0021-\\u007F]*<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_users($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListUsers', $opt);\n}","examples":{"example":{"title":"<p>List the users available on this account.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;list_users();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_user\"><code>create_user()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user\"><code>delete_user()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user\"><code>get_user()<\/code><\/a>","<a href=\"..\/amazoniam\/update_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_user\"><code>update_user()<\/code><\/a>"]}},{"name":"list_virtual_mfa_devices","modifier":"public","description":"<p>Lists the virtual MFA devices under the AWS account by assignment status. If you do not specify\nan assignment status, the action returns a list of all virtual MFA devices. Assignment status\ncan be <code>Assigned<\/code>, <code>Unassigned<\/code>, or <code>Any<\/code>.<\/p>\n\n<p>You can paginate the results using the <code>MaxItems<\/code> and <code>Marker<\/code>\nparameters.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AssignmentStatus<\/code> - <code>string<\/code> - Optional - The status (unassigned or assigned) of the devices to list. If you do not specify an <code>AssignmentStatus<\/code>, the action defaults to <code>Any<\/code> which lists both assigned and unassigned virtual MFA devices. [Allowed values: <code>Assigned<\/code>, <code>Unassigned<\/code>, <code>Any<\/code>]<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - Use this parameter only when paginating results, and only in a subsequent request after you&#8217;ve received a response where the results are truncated. Set it to the value of the <code>Marker<\/code> element in the response you just received. [Constraints: The value must be between 1 and 320 characters, and must match the following regular expression pattern: <code>[\\u0020-\\u00FF]*<\/code>]<\/li><li><code>MaxItems<\/code> - <code>integer<\/code> - Optional - Use this parameter only when paginating results to indicate the maximum number of user names you want in the response. If there are additional user names beyond the maximum you specify, the <code>IsTruncated<\/code> response element is <code>true<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_virtual_mfa_devices($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListVirtualMFADevices', $opt);\n}"},{"name":"put_group_policy","modifier":"public","description":"<p>Adds (or updates) a policy document associated with the specified group. For information about\npolicies, refer to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?PoliciesOverview.html\"\ntarget=\"_blank\">Overview of Policies<\/a> in <em>Using AWS Identity and Access Management<\/em>.<\/p>\n\n<p>For information about limits on the number of policies you can associate with a group, see\n<a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"note\">\nBecause policy documents can be large, you should use POST rather than GET when calling\n<code>PutGroupPolicy<\/code>. For information about setting up signatures and authorization\nthrough the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to associate the policy with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_document","type":"string","description":"<p>The policy document. [Constraints: The value must be between 1 and 131072 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function put_group_policy($group_name, $policy_name, $policy_document, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['PolicyName'] = $policy_name;\n    $opt['PolicyDocument'] = $policy_document;\n    \n    return $this-&gt;authenticate('PutGroupPolicy', $opt);\n}","examples":{"example":{"title":"<p>Set a group policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Generate the group policy\n$policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Set the group policy\n$response = $iam-&gt;put_group_policy('abcd_group', 'group-policy', $policy-&gt;get_json());\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group_policy\"><code>delete_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group_policy\"><code>get_group_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_group_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_group_policies\"><code>list_group_policies()<\/code><\/a>"]}},{"name":"put_role_policy","modifier":"public","description":"<p>Adds (or updates) a policy document associated with the specified role. For information about\npolicies, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?PoliciesOverview.html\"\ntarget=\"_blank\">Overview of Policies<\/a> in <em>Using AWS Identity and Access Management<\/em>.<\/p>\n\n<p>For information about limits on the policies you can associate with a role, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"note\">\nBecause policy documents can be large, you should use POST rather than GET when calling\n<code>PutRolePolicy<\/code>. For information about setting up signatures and authorization\nthrough the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to associate the policy with. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_document","type":"string","description":"<p>The policy document. [Constraints: The value must be between 1 and 131072 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function put_role_policy($role_name, $policy_name, $policy_document, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    $opt['PolicyName'] = $policy_name;\n    $opt['PolicyDocument'] = $policy_document;\n    \n    return $this-&gt;authenticate('PutRolePolicy', $opt);\n}","examples":{"example":{"title":"<p>Test the preparation of instance profiles and roles.<\/p>","code":"\/\/ Instantiate the client\n$iam = new AmazonIAM();\n\n\/\/ Role policy\n$role_policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Create role\n$response = $iam-&gt;create_role('example-role', AmazonIAM::STANDARD_EC2_ASSUME_ROLE_POLICY);\nvar_dump($response-&gt;isOK());\n\n\/\/ Create instance profile\n$response = $iam-&gt;create_instance_profile('example-profile');\nvar_dump($response-&gt;isOK());\n\n\/\/ Put role policy\n$response = $iam-&gt;put_role_policy('example-role', 'example-role-policy', $role_policy-&gt;get_json());\nvar_dump($response-&gt;isOK());\n\n\/\/ Add role to instance\n$response = $iam-&gt;add_role_to_instance_profile('example-profile', 'example-role');\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"put_user_policy","modifier":"public","description":"<p>Adds (or updates) a policy document associated with the specified user. For information about\npolicies, refer to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?PoliciesOverview.html\"\ntarget=\"_blank\">Overview of Policies<\/a> in <em>Using AWS Identity and Access Management<\/em>.<\/p>\n\n<p>For information about limits on the number of policies you can associate with a user, see\n<a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"note\">\nBecause policy documents can be large, you should use POST rather than GET when calling\n<code>PutUserPolicy<\/code>. For information about setting up signatures and authorization\nthrough the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to associate the policy with. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_name","type":"string","description":"<p>Name of the policy document. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_document","type":"string","description":"<p>The policy document. [Constraints: The value must be between 1 and 131072 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function put_user_policy($user_name, $policy_name, $policy_document, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['PolicyName'] = $policy_name;\n    $opt['PolicyDocument'] = $policy_document;\n    \n    return $this-&gt;authenticate('PutUserPolicy', $opt);\n}","examples":{"example":{"title":"<p>Set a user policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Generate the user policy\n$policy = new CFPolicy($iam, array(\n\t'Statement' =&gt; array(\n\t\tarray(\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Action' =&gt; '*',\n\t\t\t'Resource' =&gt; '*'\n\t\t)\n\t)\n));\n\n\/\/ Set the user policy\n$response = $iam-&gt;put_user_policy('johndoe2', 'user-policy', $policy-&gt;get_json());\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/cfpolicy\/decode_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/decode_policy\"><code>CFPolicy::decode_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_json.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_json\"><code>CFPolicy::get_json()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_key.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_key\"><code>CFPolicy::get_key()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy\"><code>CFPolicy::get_policy()<\/code><\/a>","<a href=\"..\/cfpolicy\/get_policy_signature.html\" rel=\"..\/..\/index.html#m=cfpolicy\/get_policy_signature\"><code>CFPolicy::get_policy_signature()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user_policy\"><code>delete_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user_policy.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user_policy\"><code>get_user_policy()<\/code><\/a>","<a href=\"..\/amazoniam\/list_user_policies.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_user_policies\"><code>list_user_policies()<\/code><\/a>"]}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"remove_role_from_instance_profile","modifier":"public","description":"<p>Removes the specified role from the specified instance profile.<\/p>\n\n<p class=\"important\">\nMake sure you do not have any Amazon EC2 instances running with the role you are about to\nremove from the instance profile. Removing a role from an instance profile that is associated\nwith a running instance will break any applications running on the instance.\n<\/p>\n\n<p>For more information about roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>. For more information about instance profiles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/AboutInstanceProfiles.html\">About\nInstance Profiles<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"instance_profile_name","type":"string","description":"<p>Name of the instance profile to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to remove. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function remove_role_from_instance_profile($instance_profile_name, $role_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['InstanceProfileName'] = $instance_profile_name;\n    $opt['RoleName'] = $role_name;\n    \n    return $this-&gt;authenticate('RemoveRoleFromInstanceProfile', $opt);\n}","examples":{"0":{}}},{"name":"remove_user_from_group","modifier":"public","description":"<p>Removes the specified user from the specified group.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to remove. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function remove_user_from_group($group_name, $user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('RemoveUserFromGroup', $opt);\n}","examples":{"example":{"title":"<p>Remove a user from a group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Add a user to a group\n$response = $iam-&gt;remove_user_from_group('abcd_group', 'johndoe2');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/add_user_to_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/add_user_to_group\"><code>add_user_to_group()<\/code><\/a>","<a href=\"..\/amazoniam\/list_groups_for_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups_for_user\"><code>list_groups_for_user()<\/code><\/a>"]}},{"name":"resync_mfa_device","modifier":"public","description":"<p>Synchronizes the specified MFA device with AWS servers.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user whose MFA device you want to resynchronize. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"serial_number","type":"string","description":"<p>Serial number that uniquely identifies the MFA device. [Constraints: The value must be between 9 and 256 characters, and must match the following regular expression pattern: <code>[\\w+=\/:,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"authentication_code1","type":"string","description":"<p>An authentication code emitted by the device. [Constraints: The value must be between 6 and 6 characters, and must match the following regular expression pattern: <code>[\\d]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"authentication_code2","type":"string","description":"<p>A subsequent authentication code emitted by the device. [Constraints: The value must be between 6 and 6 characters, and must match the following regular expression pattern: <code>[\\d]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function resync_mfa_device($user_name, $serial_number, $authentication_code1, $authentication_code2, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    $opt['SerialNumber'] = $serial_number;\n    $opt['AuthenticationCode1'] = $authentication_code1;\n    $opt['AuthenticationCode2'] = $authentication_code2;\n    \n    return $this-&gt;authenticate('ResyncMFADevice', $opt);\n}","examples":{"example":{"title":"<p>Resyncs a multi-factor authentication device.<\/p>","description":"<p>Learn more about multi-factor authentication at <a href=\"http:\/\/aws.amazon.com\/mfa\/\">aws.amazon.com\/mfa<\/a>.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;resync_mfa_device('johndoe2', CFCredentials::get('@default')-&gt;mfa_serial, '123456', '987654');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/deactivate_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/deactivate_mfa_device\"><code>deactivate_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/enable_mfa_device.html\" rel=\"..\/..\/index.html#m=amazoniam\/enable_mfa_device\"><code>enable_mfa_device()<\/code><\/a>","<a href=\"..\/amazoniam\/list_mfa_devices.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_mfa_devices\"><code>list_mfa_devices()<\/code><\/a>"]}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazoniam\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazoniam\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>, <a href=\"..\/amazoniam\/constants.html#region_us_gov1\" rel=\"..\/..\/index.html#c=amazoniam\/region_us_gov1\"><code>REGION_US_GOV1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"update_access_key","modifier":"public","description":"<p>Changes the status of the specified access key from Active to Inactive, or vice versa. This\naction can be used to disable a user&#8217;s key as part of a key rotation work flow.<\/p>\n\n<p>If the <code>UserName<\/code> field is not specified, the UserName is determined implicitly\nbased on the AWS Access Key ID used to sign the request. Because this action works for access\nkeys under the AWS account, this API can be used to manage root credentials even if the AWS\naccount has no associated users.<\/p>\n\n<p>For information about rotating keys, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?ManagingCredentials.html\"\ntarget=\"_blank\">Managing Keys and Certificates<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"access_key_id","type":"string","description":"<p>The Access Key ID of the Secret Access Key you want to update. [Constraints: The value must be between 16 and 32 characters, and must match the following regular expression pattern: <code>[\\w]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"status","type":"string","description":"<p>The status you want to assign to the Secret Access Key. <code>Active<\/code> means the key can be used for API calls to AWS, while <code>Inactive<\/code> means the key cannot be used. [Allowed values: <code>Active<\/code>, <code>Inactive<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user whose key you want to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_access_key($access_key_id, $status, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['AccessKeyId'] = $access_key_id;\n    $opt['Status'] = $status;\n    \n    return $this-&gt;authenticate('UpdateAccessKey', $opt);\n}","examples":{"example":{"title":"<p>Update an access key for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;update_access_key('AKIAIN7OWEXAMPLENN2A', 'Active', array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_access_key\"><code>create_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_access_key.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_access_key\"><code>delete_access_key()<\/code><\/a>","<a href=\"..\/amazoniam\/list_access_keys.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_access_keys\"><code>list_access_keys()<\/code><\/a>"]}},{"name":"update_account_password_policy","modifier":"public","description":"<p>Updates the password policy settings for the account. For more information about using a\npassword policy, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/Using_ManagingPasswordPolicies.html\">Managing\nan IAM Password Policy<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>MinimumPasswordLength<\/code> - <code>integer<\/code> - Optional - <\/li><li><code>RequireSymbols<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>RequireNumbers<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>RequireUppercaseCharacters<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>RequireLowercaseCharacters<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>AllowUsersToChangePassword<\/code> - <code>boolean<\/code> - Optional - <\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_account_password_policy($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('UpdateAccountPasswordPolicy', $opt);\n}","examples":{"example":{"title":"<p>Update the account password policy.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;update_account_password_policy(array(\n\t'AllowUsersToChangePassword' =&gt; 'true',\n\t'MinimumPasswordLength'      =&gt; 6,\n\t'RequireSymbols'             =&gt; 'false',\n\t'RequireNumbers'             =&gt; 'true',\n\t'RequireUppercaseCharacters' =&gt; 'false',\n\t'RequireLowercaseCharacters' =&gt; 'true',\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"update_assume_role_policy","modifier":"public","description":"<p>Updates the policy that grants an entity permission to assume a role. Currently, only an Amazon\nEC2 instance can assume a role. For more information about roles, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/WorkingWithRoles.html\">Working with\nRoles<\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"role_name","type":"string","description":"<p>Name of the role to update. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"policy_document","type":"string","description":"<p>The policy that grants an entity permission to assume the role. [Constraints: The value must be between 1 and 131072 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_assume_role_policy($role_name, $policy_document, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['RoleName'] = $role_name;\n    $opt['PolicyDocument'] = $policy_document;\n    \n    return $this-&gt;authenticate('UpdateAssumeRolePolicy', $opt);\n}"},{"name":"update_group","modifier":"public","description":"<p>Updates the name and\/or the path of the specified group.<\/p>\n\n<p class=\"important\">\nYou should understand the implications of changing a group&#8217;s path or name. For more\ninformation, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Renaming.html\" target=\n\"_blank\">Renaming Users and Groups<\/a> in <em>Using AWS Identity and Access Management<\/em>.\n<\/p>\n\n<p class=\"note\">\nTo change a group name the requester must have appropriate permissions on both the source\nobject and the target object. For example, to change Managers to MGRs, the entity making the\nrequest must have permission on Managers and MGRs, or must have permission on all (*). For more\ninformation about permissions, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/PermissionsAndPolicies.html\" target=\n\"blank\">Permissions and Policies<\/a>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"group_name","type":"string","description":"<p>Name of the group to update. If you&#8217;re changing the name of the group, this is the original name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NewPath<\/code> - <code>string<\/code> - Optional - New path for the group. Only include this if changing the group&#8217;s path. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>NewGroupName<\/code> - <code>string<\/code> - Optional - New name for the group. Only include this if changing the group&#8217;s name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_group($group_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['GroupName'] = $group_name;\n    \n    return $this-&gt;authenticate('UpdateGroup', $opt);\n}","examples":{"example":[{"title":"<p>Update an existing user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;update_group('xyz_group', array(\n\t'NewGroupName' =&gt; 'wxyz_group'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Update an existing user group.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Create a new parent group\n$response = $iam-&gt;update_group('abc_group', array(\n\t'NewGroupName' =&gt; 'abcd_group'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"related":{"method":["<a href=\"..\/amazoniam\/create_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_group\"><code>create_group()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_group\"><code>delete_group()<\/code><\/a>","<a href=\"..\/amazoniam\/get_group.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_group\"><code>get_group()<\/code><\/a>","<a href=\"..\/amazoniam\/list_groups.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_groups\"><code>list_groups()<\/code><\/a>"]}},{"name":"update_login_profile","modifier":"public","description":"<p>Changes the password for the specified user.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user whose password you want to update. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Password<\/code> - <code>string<\/code> - Optional - The new password for the user name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_login_profile($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('UpdateLoginProfile', $opt);\n}","examples":{"example":{"title":"<p>Update a login profile for a user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;update_login_profile('johndoe2', array(\n\t'Password' =&gt; 'new-password'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_login_profile\"><code>create_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_login_profile\"><code>delete_login_profile()<\/code><\/a>","<a href=\"..\/amazoniam\/get_login_profile.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_login_profile\"><code>get_login_profile()<\/code><\/a>"]}},{"name":"update_server_certificate","modifier":"public","description":"<p>Updates the name and\/or the path of the specified server certificate.<\/p>\n\n<p class=\"important\">\nYou should understand the implications of changing a server certificate&#8217;s path or name. For\nmore information, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/ManagingServerCerts.html\" target=\n\"_blank\">Managing Server Certificates<\/a> in <em>Using AWS Identity and Access Management<\/em>.\n<\/p>\n\n<p class=\"note\">\nTo change a server certificate name the requester must have appropriate permissions on both the\nsource object and the target object. For example, to change the name from ProductionCert to\nProdCert, the entity making the request must have permission on ProductionCert and ProdCert, or\nmust have permission on all (*). For more information about permissions, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/PermissionsAndPolicies.html\" target=\n\"blank\">Permissions and Policies<\/a>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"server_certificate_name","type":"string","description":"<p>The name of the server certificate that you want to update. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NewPath<\/code> - <code>string<\/code> - Optional - The new path for the server certificate. Include this only if you are updating the server certificate&#8217;s path. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>NewServerCertificateName<\/code> - <code>string<\/code> - Optional - The new name for the server certificate. Include this only if you are updating the server certificate&#8217;s name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_server_certificate($server_certificate_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ServerCertificateName'] = $server_certificate_name;\n    \n    return $this-&gt;authenticate('UpdateServerCertificate', $opt);\n}","examples":{"example":{"title":"<p>Updates the information for a server certificate.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;update_server_certificate('my-server-cert', array(\n\t'NewPath' =&gt; '\/'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"update_signing_certificate","modifier":"public","description":"<p>Changes the status of the specified signing certificate from active to disabled, or vice versa.\nThis action can be used to disable a user&#8217;s signing certificate as part of a certificate\nrotation work flow.<\/p>\n\n<p>If the <code>UserName<\/code> field is not specified, the UserName is determined implicitly\nbased on the AWS Access Key ID used to sign the request. Because this action works for access\nkeys under the AWS account, this API can be used to manage root credentials even if the AWS\naccount has no associated users.<\/p>\n\n<p>For information about rotating certificates, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?ManagingCredentials.html\"\ntarget=\"_blank\">Managing Keys and Certificates<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"certificate_id","type":"string","description":"<p>The ID of the signing certificate you want to update. [Constraints: The value must be between 24 and 128 characters, and must match the following regular expression pattern: <code>[\\w]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"status","type":"string","description":"<p>The status you want to assign to the certificate. <code>Active<\/code> means the certificate can be used for API calls to AWS, while <code>Inactive<\/code> means the certificate cannot be used. [Allowed values: <code>Active<\/code>, <code>Inactive<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user the signing certificate belongs to. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_signing_certificate($certificate_id, $status, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['CertificateId'] = $certificate_id;\n    $opt['Status'] = $status;\n    \n    return $this-&gt;authenticate('UpdateSigningCertificate', $opt);\n}","examples":{"example":{"title":"<p>Update the status of an X.509 signing certificate.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;update_signing_certificate('H76F5K3WMTCK7KW2OTVKONTEYEXAMPLE', 'Inactive', array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_signing_certificate\"><code>delete_signing_certificate()<\/code><\/a>","<a href=\"..\/amazoniam\/list_signing_certificates.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_signing_certificates\"><code>list_signing_certificates()<\/code><\/a>","<a href=\"..\/amazoniam\/upload_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/upload_signing_certificate\"><code>upload_signing_certificate()<\/code><\/a>"]}},{"name":"update_user","modifier":"public","description":"<p>Updates the name and\/or the path of the specified user.<\/p>\n\n<p class=\"important\">\nYou should understand the implications of changing a user&#8217;s path or name. For more information,\nsee <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Renaming.html\" target=\n\"_blank\">Renaming Users and Groups<\/a> in <em>Using AWS Identity and Access Management<\/em>.\n<\/p>\n\n<p class=\"note\">\nTo change a user name the requester must have appropriate permissions on both the source object\nand the target object. For example, to change Bob to Robert, the entity making the request must\nhave permission on Bob and Robert, or must have permission on all (*). For more information\nabout permissions, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/PermissionsAndPolicies.html\" target=\n\"blank\">Permissions and Policies<\/a>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"user_name","type":"string","description":"<p>Name of the user to update. If you&#8217;re changing the name of the user, this is the original user name. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NewPath<\/code> - <code>string<\/code> - Optional - New path for the user. Include this parameter only if you&#8217;re changing the user&#8217;s path. [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>NewUserName<\/code> - <code>string<\/code> - Optional - New name for the user. Include this parameter only if you&#8217;re changing the user&#8217;s name. [Constraints: The value must be between 1 and 64 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_user($user_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['UserName'] = $user_name;\n    \n    return $this-&gt;authenticate('UpdateUser', $opt);\n}","examples":{"example":{"title":"<p>Update an existing user.<\/p>","code":"\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n\/\/ Update a user\n$response = $iam-&gt;update_user('johndoe', array(\n\t'NewUserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/create_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/create_user\"><code>create_user()<\/code><\/a>","<a href=\"..\/amazoniam\/delete_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_user\"><code>delete_user()<\/code><\/a>","<a href=\"..\/amazoniam\/get_user.html\" rel=\"..\/..\/index.html#m=amazoniam\/get_user\"><code>get_user()<\/code><\/a>","<a href=\"..\/amazoniam\/list_users.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_users\"><code>list_users()<\/code><\/a>"]}},{"name":"upload_server_certificate","modifier":"public","description":"<p>Uploads a server certificate entity for the AWS account. The server certificate entity includes\na public key certificate, a private key, and an optional certificate chain, which should all be\nPEM-encoded.<\/p>\n\n<p>For information about the number of server certificates you can upload, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?LimitationsOnEntities.html\"\ntarget=\"_blank\">Limitations on IAM Entities<\/a> in <em>Using AWS Identity and Access\nManagement<\/em>.<\/p>\n\n<p class=\"note\">\nBecause the body of the public key certificate, private key, and the certificate chain can be\nlarge, you should use POST rather than GET when calling <code>UploadServerCertificate<\/code>.\nFor information about setting up signatures and authorization through the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"server_certificate_name","type":"string","description":"<p>The name for the server certificate. Do not include the path in this value. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"certificate_body","type":"string","description":"<p>The contents of the public key certificate in PEM-encoded format. [Constraints: The value must be between 1 and 16384 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"private_key","type":"string","description":"<p>The contents of the private key in PEM-encoded format. [Constraints: The value must be between 1 and 16384 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]*<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Path<\/code> - <code>string<\/code> - Optional - The path for the server certificate. For more information about paths, see <a href=\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/index.html?Using_Identifiers.html\" target=\"_blank\">Identifiers for IAM Entities<\/a> in <em>Using AWS Identity and Access Management<\/em>. This parameter is optional. If it is not included, it defaults to a slash (\/). [Constraints: The value must be between 1 and 512 characters, and must match the following regular expression pattern: <code>(\\u002F)|(\\u002F[\\u0021-\\u007F]+\\u002F)<\/code>]<\/li><li><code>CertificateChain<\/code> - <code>string<\/code> - Optional - The contents of the certificate chain. This is typically a concatenation of the PEM-encoded public key certificates of the chain. [Constraints: The value must be between 1 and 2097152 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function upload_server_certificate($server_certificate_name, $certificate_body, $private_key, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['ServerCertificateName'] = $server_certificate_name;\n    $opt['CertificateBody'] = $certificate_body;\n    $opt['PrivateKey'] = $private_key;\n    \n    return $this-&gt;authenticate('UploadServerCertificate', $opt);\n}","examples":{"example":{"title":"<p>Upload a server certificate.<\/p>","code":"$certificate_body = &lt;&lt;&lt;CERT\n-----BEGIN EXAMPLE CERTIFICATE-----\nEXAMPLECAsKgAwIBAgIJANgRVq\/2z7jfMA0GCSqGSIb3DQEBBQUAMHwxCzAJBgNV\nBAYTAkdEXAMPLEYDVQQIEwlCZXJrc2hpcmUxEDAOBgNVBAcTB05ld2J1cnkxFzAV\nBgNVBAoTDk15IEEXAMPLEnkgTHRkMQ0wCwYDVQQDEwRob21lMR8wHQYJKoZIhvcN\nAQkBFhBub3JtakBhbWF6bEXAMPLEMB4XDTEwMDkzMDIzMjYwOFoXDTEyMDkyOTIz\nMjYwOFowfDELMAkGA1UEBhMCR0IxEXAMPLEVBAgTCUJlcmtzaGlyZTEQMA4GA1UE\nBxMHTmV3YnVyeTEXMBUGA1UEChMOTXkgQ29EXAMPLEBMdGQxDTALBgNVBAMTBGhv\nbWUxHzAdBgkqhkiG9w0BCQEWEG5vcm1qQGFtYXpvbiEXAMPLEZ8wDQYJKoZIhvcN\nAQEBBQADgY0AMIGJAoGBAOOQH8UKlqWQEit6jWYPFs5w3UJcbEXAMPLEyl+2Pug+\nhSrqpeMXET0BJBHbIi6QQ\/EVTIUWyBg9nizuzuPhVq+y58V1YPc5cmnTEXAMPLE6\nEXAMPLEr67Y3kYnNYWeQdXS37EAnBffgqQNP3PSIRdnHuQmpG3gQQl+bXQQEHCr9\nAgMBAAGEXAMPLE8wHQYDVR0OBBYEFMJCfM4jUOassmmWUx6vlmhUtwccMIGvBgNV\nHSMEgacwgaSAFMEXAMPLEOassmmWUx6vlmhUtwccoYGApH4wfDELMAkGA1UEBhMC\nR0IxEjAQBgNVBAgTCUJlcEXAMPLEZTEQMA4GA1UEBxMHTmV3YnVyeTEXMBUGA1UE\nChMOTXkgQ29tcGFueSBMdGQxDTALEXAMPLETBGhvbWUxHzAdBgkqhkiG9w0BCQEW\nEG5vcm1qQGFtYXpvbi5jb22CCQDYEVav9s+EXAMPLENVHRMEBTADAQH\/MA0GCSqG\nSIb3DQEBBQUAA4GBAKFzoqAIEZyMFgLEU+lCCSITFcEXAMPLEcEykAjMO20ahYXi\ndNizI8fApMQppcTfJj4iYpaD0KKPRQpyLAttT\/V9jmcWbpULWEXAMPLEJ92ZBxYf\nEXAMPLEmTuL784RKKxOSnKKWj4M5an7xSf1tA5mV6okFDyyN0lCsmKL0c03E\n-----END EXAMPLE CERTIFICATE-----\nCERT;\n\n$private_key = &lt;&lt;&lt;CERT\n-----BEGIN EXAMPLE PRIVATE KEY-----\nEXAMPLEBAAKBgQDjkB\/FCpalkBIreo1mDxbOcN1CXGyULCu3V8pftj7oPoUq6qXj\nFxE9ASQEXAMPLEPxFUyFFsgYPZ4s7s7j4VavsufFdWD3OXJp0z1p53KGOpE0U1P1\nK+u2N5GJzWFnkHEXAMPLEwX34KkDT9z0iEXZx7kJqRt4EEJfm10EBBwq\/QIDAQAB\nAoGBAJQkNwpnIjsV1z5GwEXAMPLEL6IL2QN83di1ZiF42usGCFsv9l4nnilAnOKi\n7VWyxQgk\/XOGqSxesKI\/tJ\/VCkCMEXAMPLEp7CQQYDELtUEDadJ77w+ZemNKScDD\nCXlIZ1z1W739tYYgNTZ8HLA7w0uVrfZHoMZEXAMPLEPSLLlhAkEA\/8NnI6Set64T\nDsH0byUQv\/O6VgQvBvoogYlb60\/C7DWn4WC2PgNiOfEXAMPLELci27nriuWxOtWR\ndLhN8wSQIwJBAOPGCjEToxmhsV69Bb5ZYiE3b0xdAGquFKrdcEXAMPLENRJ\/IkNU\npY26F8GZdyZl0eTJbTGDUCitCp2hKSL+el8CQG2MndXXgiA80G7mxrMAEXAMPLE+\nEXAMPLEFkfiVfnE8fj779LNVMbKUGsOUE7Z7QtQIq4of3izMI3RyKPkpgC8CQQDE\n6wsWoMaEXAMPLEVOmpIW64kieOkKUdP2YJlFwiAjcICgrB8gHMdAP1mYe6giHzcW\nV\/o6Ky+a6vdZjeEXAMPLEkEArbLU9LfQmAq33t1K1Pv9Yq78sqwLpwR7gDhwGPGd\nUS3NZ8NTQUlWVi4QB7qoLEXAMPLEBaqFIyh83FIYqP\/eYQ==\n-----END EXAMPLE PRIVATE KEY-----\nCERT;\n\n\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;upload_server_certificate('my-server-cert', $certificate_body, $private_key, array(\n\t'Path' =&gt; '\/mycerts\/'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"upload_signing_certificate","modifier":"public","description":"<p>Uploads an X.509 signing certificate and associates it with the specified user. Some AWS\nservices use X.509 signing certificates to validate requests that are signed with a\ncorresponding private key. When you upload the certificate, its default status is\n<code>Active<\/code>.<\/p>\n\n<p>If the <code>UserName<\/code> field is not specified, the user name is determined implicitly\nbased on the AWS Access Key ID used to sign the request. Because this action works for access\nkeys under the AWS account, this API can be used to manage root credentials even if the AWS\naccount has no associated users.<\/p>\n\n<p class=\"note\">\nBecause the body of a X.509 certificate can be large, you should use POST rather than GET when\ncalling <code>UploadSigningCertificate<\/code>. For information about setting up signatures and\nauthorization through the API, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/signing_aws_api_requests.html\" target=\n\"_blank\">Signing AWS API Requests<\/a> in the <em>AWS General Reference<\/em>. For general\ninformation about using the Query API with IAM, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/IAM\/latest\/UserGuide\/IAM_UsingQueryAPI.html\" target=\n\"_blank\">Making Query Requests<\/a> in <em>Using IAM<\/em>.\n<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"certificate_body","type":"string","description":"<p>The contents of the signing certificate. [Constraints: The value must be between 1 and 16384 characters, and must match the following regular expression pattern: <code>[\\u0009\\u000A\\u000D\\u0020-\\u00FF]+<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>UserName<\/code> - <code>string<\/code> - Optional - Name of the user the signing certificate is for. [Constraints: The value must be between 1 and 128 characters, and must match the following regular expression pattern: <code>[\\w+=,.@-]*<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function upload_signing_certificate($certificate_body, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['CertificateBody'] = $certificate_body;\n    \n    return $this-&gt;authenticate('UploadSigningCertificate', $opt);\n}","examples":{"example":{"title":"<p>Upload an X.509 signing certificate.<\/p>","code":"$x509_certificate = &lt;&lt;&lt;CERT\n-----BEGIN EXAMPLE CERTIFICATE-----\nEXAMPLECAeGgAwIBAgIGAIBHCmYxMA0GCSqGSIb3DQEBBQUAMFMxCzAJBgNVBAYT\nAlVTMRMEXAMPLEQKEwpBbWF6b24uY29tMQwwCgYDVQQLEwNBV1MxITAfBgNVBAMT\nGEFXUyBMaW1pdGEXAMPLE3VyYW5jZSBDQTAeFw0xMDA5MDEwMzE0NDRaFw0xMTA5\nMDEwMzE0NDRaMFMxCzAJBEXAMPLEAlVTMRMwEQYDVQQKEwpBbWF6b24uY29tMRcw\nFQYDVQQLEw5BV1MtRGV2ZWxvcGVyEXAMPLEGA1UEAxMNMTM1ZDUzaHpjOWppajCB\nnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEEXAMPLEkQAQQQJYx1ZSo2hHkruELw\nl8xQVIMwWkyL4COOKAKFPjnM8AbpXT98DcwnvMTPodEXAMPLERBwZUlXhvsXCIZ\/\nPyBC18ef7suZbITHhSCOyqiR0iZOyTsK7h9xF5pGptgrCGrMIEXAMPLEGOb7Tl+5\nP6hE+TGzD\/c9aK8CAwEAAaNXMFUwDgYDVR0PAQH\/BAQDAgWgMBYGA1UdEXAMPLEM\nEXAMPLEGAQUFBwMCMAwGA1UdEwEB\/wQCMAAwHQYDVR0OBBYEFLxafWX3qRESqFU1\n4\/A4QW+EXAMPLE0GCSqGSIb3DQEBBQUAA4GBADCWnRMuwpCzlHtAOQTAszq6LPBB\nUDVslkapUlDKjQEXAMPLE1A3+PCmZXWVW0zkmzZn1komB4\/3GofnKWxjot5y+dnU\ntPdpG8PdAOPTTYqLEOnIqEXAMPLEsvswV5CbNPIZzsAmOVtw1D3u+qUAW8yXidH6\njl5XFaJpamQ0vpIy\n-----END EXAMPLE CERTIFICATE-----\nCERT;\n\n\/\/ Instantiate the class\n$iam = new AmazonIAM();\n\n$response = $iam-&gt;upload_signing_certificate($x509_certificate, array(\n\t'UserName' =&gt; 'johndoe2'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazoniam\/delete_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/delete_signing_certificate\"><code>delete_signing_certificate()<\/code><\/a>","<a href=\"..\/amazoniam\/list_signing_certificates.html\" rel=\"..\/..\/index.html#m=amazoniam\/list_signing_certificates\"><code>list_signing_certificates()<\/code><\/a>","<a href=\"..\/amazoniam\/update_signing_certificate.html\" rel=\"..\/..\/index.html#m=amazoniam\/update_signing_certificate\"><code>update_signing_certificate()<\/code><\/a>"]}}]},"constants":{"@attributes":{"count":"9"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"iam.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_US_E1","value":"iam.amazonaws.com"},{"name":"REGION_US_GOV1","value":"iam.us-gov.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"iam.amazonaws.com"},{"name":"STANDARD_EC2_ASSUME_ROLE_POLICY","value":"{\"Statement\":[{\"Principal\":{\"Service\":[\"ec2.amazonaws.com\"]},\"Effect\":\"Allow\",\"Action\":[\"sts:AssumeRole\"]}]}"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazoniam\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazoniam\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}