{"file":{},"class":{"name":"AmazonSNS","file":"services\/sns.class.php","url":"..\/amazonsns\/index.html","description":"<p>This is the <em>Amazon Simple Notification Service (Amazon SNS) API Reference<\/em>. This guide\nprovides detailed information about Amazon SNS actions, data types, parameters, and errors. For\ndetailed information about Amazon SNS features and their associated API calls, go to the\n<a href=\"http:\/\/docs.amazonwebservices.com\/sns\/latest\/gsg\/\">Amazon SNS Getting Started\nGuide<\/a>.<\/p>\n\n<p>Amazon Simple Notification Service is a web service that enables you to build distributed\nweb-enabled applications. Applications can use Amazon SNS to easily push real-time notification\nmessages to interested subscribers over multiple delivery protocols. For more information about\nthis product go to <a href=\"http:\/\/aws.amazon.com\/sns\/\">http:\/\/aws.amazon.com\/sns<\/a>.<\/p>\n\n<p>Use the following links to get started using the <em>Amazon Simple Notification Service API\nReference<\/em>:<\/p>\n\n<ul><li><a href=\"http:\/\/docs.amazonwebservices.com\/sns\/latest\/api\/API_Operations.html\">Actions<\/a>:\nAn alphabetical list of all Amazon SNS actions.<\/li><li><a href=\"http:\/\/docs.amazonwebservices.com\/sns\/latest\/api\/API_Types.html\">Data Types<\/a>:\nAn alphabetical list of all Amazon SNS data types.<\/li><li><a href=\"http:\/\/docs.amazonwebservices.com\/sns\/latest\/api\/CommonParameters.html\">Common\nParameters<\/a>: Parameters that all Query actions can use.<\/li><li><a href=\"http:\/\/docs.amazonwebservices.com\/sns\/latest\/api\/CommonErrors.html\">Common\nErrors<\/a>: Client and server errors that all actions can return.<\/li><li><a href=\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/index.html?rande.html\">Regions\nand Endpoints<\/a>: Itemized regions and endpoints for all AWS products.<\/li><li><a href=\n\"http:\/\/sns.us-east-1.amazonaws.com\/doc\/2010-03-31\/SimpleNotificationService.wsdl\">WSDL\nLocation<\/a>:\nhttp:\/\/sns.us-east-1.amazonaws.com\/doc\/2010-03-31\/SimpleNotificationService.wsdl<\/li><\/ul>","metadata":{"version":"2013.01.15","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/sns\/ Amazon Simple Notification Service","http:\/\/aws.amazon.com\/sns\/documentation\/ Amazon Simple Notification Service documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"46"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazonsns\/index.html\" rel=\"..\/..\/index.html#i=amazonsns\"><code>AmazonSNS<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonsns\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2010-03-31';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV2Query';\n\n    return parent::__construct($options);\n}"},{"name":"add_permission","modifier":"public","description":"<p>The AddPermission action adds a statement to a topic&#8217;s access control policy, granting access\nfor the specified AWS accounts to the specified actions.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic whose access control policy you wish to modify.<\/p>"},{"@attributes":{"choice":"req"},"name":"label","type":"string","description":"<p>A unique identifier for the new policy statement.<\/p>"},{"@attributes":{"choice":"req"},"name":"aws_account_id","type":"string|array","description":"<p>The AWS account IDs of the users (principals) who will be given access to the specified actions. The users must have AWS accounts, but do not need to be signed up for this service. Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"req"},"name":"action_name","type":"string|array","description":"<p>The action you want to allow for the specified principal(s). Pass a string for a single value, or an indexed array for multiple values.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_permission($topic_arn, $label, $aws_account_id, $action_name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['Label'] = $label;\n    \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'AWSAccountId' =&gt; (is_array($aws_account_id) ? $aws_account_id : array($aws_account_id))\n    ), 'member'));\n    \n    \/\/ Required list (non-map)\n    $opt = array_merge($opt, CFComplexType::map(array(\n        'ActionName' =&gt; (is_array($action_name) ? $action_name : array($action_name))\n    ), 'member'));\n\n    return $this-&gt;authenticate('AddPermission', $opt);\n}","examples":{"example":{"title":"<p>Add permissions for a user.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Add permission\n$response = $sns-&gt;add_permission(\n\t'arn:aws:sns:us-east-1:9876543210:example-topic',\n\t'my-permission-label',\n\tarray( 9876543210, CFCredentials::get('@default')-&gt;account_id ),\n\tarray( 'Publish', 'GetTopicAttributes' )\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":"<a href=\"..\/amazonsns\/remove_permission.html\" rel=\"..\/..\/index.html#m=amazonsns\/remove_permission\"><code>remove_permission()<\/code><\/a>"}},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazonsns\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazonsns\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazonsns\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazonsns\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"confirm_subscription","modifier":"public","description":"<p>The ConfirmSubscription action verifies an endpoint owner&#8217;s intent to receive messages by\nvalidating the token sent to the endpoint by an earlier Subscribe action. If the token is\nvalid, the action creates a new subscription and returns its Amazon Resource Name (ARN). This\ncall requires an AWS signature only when the AuthenticateOnUnsubscribe flag is set to &#8220;true&#8221;.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic for which you wish to confirm a subscription.<\/p>"},{"@attributes":{"choice":"req"},"name":"token","type":"string","description":"<p>Short-lived token sent to an endpoint during the Subscribe action.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>AuthenticateOnUnsubscribe<\/code> - <code>string<\/code> - Optional - Indicates that you want to disallow unauthenticated unsubscribes of the subscription. If value of this parameter is &#8220;true&#8221; and the request has an AWS signature then only the topic owner and the subscription owner will be permitted to unsubscribe the endpoint. The unsubscribe action will require AWS authentication.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function confirm_subscription($topic_arn, $token, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['Token'] = $token;\n    \n    return $this-&gt;authenticate('ConfirmSubscription', $opt);\n}","examples":{"example":{"title":"<p>Confirm a subscription to a topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Subscribe to notifications\n$response = $sns-&gt;confirm_subscription(\n\t'arn:aws:sns:us-east-1:9876543210:my-topic', \/\/ $topic\n\t'0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie=' \/\/ $token\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/list_subscriptions.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions\"><code>list_subscriptions()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/subscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/subscribe\"><code>subscribe()<\/code><\/a>","<a href=\"..\/amazonsns\/unsubscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/unsubscribe\"><code>unsubscribe()<\/code><\/a>"]}},{"name":"create_topic","modifier":"public","description":"<p>The CreateTopic action creates a topic to which notifications can be published. Users can\ncreate at most 25 topics. This action is idempotent, so if the requester already owns a topic\nwith the specified name, that topic&#8217;s ARN will be returned without creating a new topic.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"name","type":"string","description":"<p>The name of the topic you want to create. Constraints: Topic names must be made up of only uppercase and lowercase ASCII letters, numbers, and hyphens, and must be between 1 and 256 characters long.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_topic($name, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['Name'] = $name;\n    \n    return $this-&gt;authenticate('CreateTopic', $opt);\n}","examples":{"example":{"title":"<p>Create a new topic in the (default) US-East region.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Create a new topic\n$response = $sns-&gt;create_topic('example-topic');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/delete_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/delete_topic\"><code>delete_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/get_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/get_topic_attributes\"><code>get_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/list_topics.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_topics\"><code>list_topics()<\/code><\/a>","<a href=\"..\/amazonsns\/set_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_topic_attributes\"><code>set_topic_attributes()<\/code><\/a>"]}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_topic","modifier":"public","description":"<p>The DeleteTopic action deletes a topic and all its subscriptions. Deleting a topic might\nprevent some messages previously sent to the topic from being delivered to subscribers. This\naction is idempotent, so deleting a topic that does not exist will not result in an error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic you want to delete.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_topic($topic_arn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    \n    return $this-&gt;authenticate('DeleteTopic', $opt);\n}","examples":{"example":{"title":"<p>Delete a topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Delete a topic\n$response = $sns-&gt;delete_topic('arn:aws:sns:us-east-1:9876543210:example-topic');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/create_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/create_topic\"><code>create_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/get_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/get_topic_attributes\"><code>get_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/list_topics.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_topics\"><code>list_topics()<\/code><\/a>","<a href=\"..\/amazonsns\/set_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_topic_attributes\"><code>set_topic_attributes()<\/code><\/a>"]}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonsns\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"get_subscription_attributes","modifier":"public","description":"<p>The GetSubscriptionAttribtues action returns all of the properties of a subscription.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subscription_arn","type":"string","description":"<p>The ARN of the subscription whose properties you want to get.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_subscription_attributes($subscription_arn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubscriptionArn'] = $subscription_arn;\n    \n    return $this-&gt;authenticate('GetSubscriptionAttributes', $opt);\n}"},{"name":"get_topic_attributes","modifier":"public","description":"<p>The GetTopicAttribtues action returns all of the properties of a topic customers have created.\nTopic properties returned might differ based on the authorization of the user.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic whose properties you want to get.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_topic_attributes($topic_arn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    \n    return $this-&gt;authenticate('GetTopicAttributes', $opt);\n}","examples":{"example":{"title":"<p>Get the attributes of a given topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Get topic attributes\n$response = $sns-&gt;get_topic_attributes('arn:aws:sns:us-east-1:9876543210:example-topic');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/create_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/create_topic\"><code>create_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/delete_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/delete_topic\"><code>delete_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/list_topics.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_topics\"><code>list_topics()<\/code><\/a>","<a href=\"..\/amazonsns\/set_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_topic_attributes\"><code>set_topic_attributes()<\/code><\/a>"]}},{"name":"get_topic_list","modifier":"public","description":"<p>Gets a simple list of Topic ARNs.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the names against.<\/p>"}},"returnvalue":"<p>A list of Topic ARNs.<\/p>","source":"public function get_topic_list($pcre = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new SNS_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    \/\/ Get a list of topics.\n    $list = $this-&gt;list_topics();\n    if ($list = $list-&gt;body-&gt;TopicArn())\n    {\n        $list = $list-&gt;map_string($pcre);\n        return $list;\n    }\n\n    return array();\n}","examples":{"example":[{"title":"<p>Get a simple array of Topic ARNs.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ List all topics\n$response = $sns-&gt;get_topic_list();\n\n\/\/ Success? (Array, not a CFResponse object)\nvar_dump($response);"},{"title":"<p>Get a simple array of Topic ARNs, filtered by a regular expression.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ List all topics\n$response = $sns-&gt;get_topic_list('\/example-topic\/i');\n\n\/\/ Success? (Array, not a CFResponse object)\nvar_dump($response);"}]},"seealso":{"link":"<a href=\"http:\/\/php.net\/pcre\">Perl-Compatible Regular Expression (PCRE) Docs<\/a>"}},{"name":"list_subscriptions","modifier":"public","description":"<p>The ListSubscriptions action returns a list of the requester&#8217;s subscriptions. Each call returns\na limited list of subscriptions, up to 100. If there are more subscriptions, a NextToken is\nalso returned. Use the NextToken parameter in a new ListSubscriptions call to get further\nresults.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NextToken<\/code> - <code>string<\/code> - Optional - Token returned by the previous ListSubscriptions request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_subscriptions($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListSubscriptions', $opt);\n}","examples":{"example":{"title":"<p>List subscriptions.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ List subscriptions\n$response = $sns-&gt;list_subscriptions();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/confirm_subscription.html\" rel=\"..\/..\/index.html#m=amazonsns\/confirm_subscription\"><code>confirm_subscription()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/subscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/subscribe\"><code>subscribe()<\/code><\/a>","<a href=\"..\/amazonsns\/unsubscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/unsubscribe\"><code>unsubscribe()<\/code><\/a>"]}},{"name":"list_subscriptions_by_topic","modifier":"public","description":"<p>The ListSubscriptionsByTopic action returns a list of the subscriptions to a specific topic.\nEach call returns a limited list of subscriptions, up to 100. If there are more subscriptions,\na NextToken is also returned. Use the NextToken parameter in a new ListSubscriptionsByTopic\ncall to get further results.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic for which you wish to find subscriptions.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NextToken<\/code> - <code>string<\/code> - Optional - Token returned by the previous ListSubscriptionsByTopic request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_subscriptions_by_topic($topic_arn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    \n    return $this-&gt;authenticate('ListSubscriptionsByTopic', $opt);\n}","examples":{"example":{"title":"<p>List the subscriptions for a given topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Get topic attributes\n$response = $sns-&gt;list_subscriptions_by_topic('arn:aws:sns:us-east-1:9876543210:example-topic');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/confirm_subscription.html\" rel=\"..\/..\/index.html#m=amazonsns\/confirm_subscription\"><code>confirm_subscription()<\/code><\/a>","<a href=\"..\/amazonsns\/create_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/create_topic\"><code>create_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/delete_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/delete_topic\"><code>delete_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/get_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/get_topic_attributes\"><code>get_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions\"><code>list_subscriptions()<\/code><\/a>","<a href=\"..\/amazonsns\/list_topics.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_topics\"><code>list_topics()<\/code><\/a>","<a href=\"..\/amazonsns\/set_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_topic_attributes\"><code>set_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/subscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/subscribe\"><code>subscribe()<\/code><\/a>","<a href=\"..\/amazonsns\/unsubscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/unsubscribe\"><code>unsubscribe()<\/code><\/a>"]}},{"name":"list_topics","modifier":"public","description":"<p>The ListTopics action returns a list of the requester&#8217;s topics. Each call returns a limited\nlist of topics, up to 100. If there are more topics, a NextToken is also returned. Use the\nNextToken parameter in a new ListTopics call to get further results.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>NextToken<\/code> - <code>string<\/code> - Optional - Token returned by the previous ListTopics request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_topics($opt = null)\n{\n    if (!$opt) $opt = array();\n            \n    return $this-&gt;authenticate('ListTopics', $opt);\n}","examples":{"example":{"title":"<p>List all topics.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ List all topics\n$response = $sns-&gt;list_topics();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/create_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/create_topic\"><code>create_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/delete_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/delete_topic\"><code>delete_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/get_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/get_topic_attributes\"><code>get_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/set_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_topic_attributes\"><code>set_topic_attributes()<\/code><\/a>"]}},{"name":"publish","modifier":"public","description":"<p>The Publish action sends a message to all of a topic&#8217;s subscribed endpoints. When a messageId\nis returned, the message has been saved and Amazon SNS will attempt to deliver it to the\ntopic&#8217;s subscribers shortly. The format of the outgoing message to each subscribed endpoint\ndepends on the notification protocol selected.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The topic you want to publish to.<\/p>"},{"@attributes":{"choice":"req"},"name":"message","type":"string","description":"<p>The message you want to send to the topic. Constraints: Messages must be UTF-8 encoded strings at most 8 KB in size (8192 bytes, not 8192 characters).<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Subject<\/code> - <code>string<\/code> - Optional - Optional parameter to be used as the &#8220;Subject&#8221; line of when the message is delivered to e-mail endpoints. This field will also be included, if present, in the standard JSON messages delivered to other endpoints. Constraints: Subjects must be ASCII text that begins with a letter, number or punctuation mark; must not include line breaks or control characters; and must be less than 100 characters long.<\/li><li><code>MessageStructure<\/code> - <code>string<\/code> - Optional - Optional parameter. It will have one valid value: &#8220;json&#8221;. If this option, Message is present and set to &#8220;json&#8221;, the value of Message must: be a syntactically valid JSON object. It must contain at least a top level JSON key of &#8220;default&#8221; with a value that is a string. For any other top level key that matches one of our transport protocols (e.g. &#8220;http&#8221;), then the corresponding value (if it is a string) will be used for the message published for that protocol Constraints: Keys in the JSON object that correspond to supported transport protocols must have simple JSON string values. The values will be parsed (unescaped) before they are used in outgoing messages. Typically, outbound notifications are JSON encoded (meaning, the characters will be reescaped for sending). JSON strings are UTF-8. Values have a minimum length of 0 (the empty string, &#8220;&#8221;, is allowed). Values have a maximum length bounded by the overall message size (so, including multiple protocols may limit message sizes). Non-string values will cause the key to be ignored. Keys that do not correspond to supported transport protocols will be ignored. Duplicate keys are not allowed. Failure to parse or validate any key or value in the message will cause the Publish call to return an error (no partial delivery).<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function publish($topic_arn, $message, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['Message'] = $message;\n    \n    return $this-&gt;authenticate('Publish', $opt);\n}","examples":{"example":{"title":"<p>Publish a message to the topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Get topic attributes\n$response = $sns-&gt;publish(\n\t'arn:aws:sns:us-east-1:9876543210:example-topic',\n\t'This is my very first message to the world!',\n\tarray(\n\t\t'Subject' =&gt; 'Hello world!'\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"remove_permission","modifier":"public","description":"<p>The RemovePermission action removes a statement from a topic&#8217;s access control policy.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic whose access control policy you wish to modify.<\/p>"},{"@attributes":{"choice":"req"},"name":"label","type":"string","description":"<p>The unique label of the statement you want to remove.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function remove_permission($topic_arn, $label, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['Label'] = $label;\n    \n    return $this-&gt;authenticate('RemovePermission', $opt);\n}","examples":{"example":{"title":"<p>Remove a set of permissions.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Remove a set of permissions\n$response = $sns-&gt;remove_permission(\n\t'arn:aws:sns:us-east-1:9876543210:example-topic',\n\t'my-permission-label'\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":"<a href=\"..\/amazonsns\/add_permission.html\" rel=\"..\/..\/index.html#m=amazonsns\/add_permission\"><code>add_permission()<\/code><\/a>"}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazonsns\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazonsns\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_us_w1\" rel=\"..\/..\/index.html#c=amazonsns\/region_us_w1\"><code>REGION_US_W1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_us_w2\" rel=\"..\/..\/index.html#c=amazonsns\/region_us_w2\"><code>REGION_US_W2<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_eu_w1\" rel=\"..\/..\/index.html#c=amazonsns\/region_eu_w1\"><code>REGION_EU_W1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_apac_se1\" rel=\"..\/..\/index.html#c=amazonsns\/region_apac_se1\"><code>REGION_APAC_SE1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_apac_se2\" rel=\"..\/..\/index.html#c=amazonsns\/region_apac_se2\"><code>REGION_APAC_SE2<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_apac_ne1\" rel=\"..\/..\/index.html#c=amazonsns\/region_apac_ne1\"><code>REGION_APAC_NE1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_sa_e1\" rel=\"..\/..\/index.html#c=amazonsns\/region_sa_e1\"><code>REGION_SA_E1<\/code><\/a>, <a href=\"..\/amazonsns\/constants.html#region_us_gov1\" rel=\"..\/..\/index.html#c=amazonsns\/region_us_gov1\"><code>REGION_US_GOV1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"example":{"title":"<p>Set the region to send notifications through.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Set the region to US-East (Northern Virginia)\n$sns-&gt;set_region(AmazonSNS::REGION_US_E1);\n\n\/\/ List all topics\n$response = $sns-&gt;list_topics();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_subscription_attributes","modifier":"public","description":"<p>The SetSubscriptionAttributes action allows a subscription owner to set an attribute of the\ntopic to a new value.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subscription_arn","type":"string","description":"<p>The ARN of the subscription to modify.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute_name","type":"string","description":"<p>The name of the attribute you want to set. Only a subset of the subscriptions attributes are mutable. Valid values: DeliveryPolicy<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute_value","type":"string","description":"<p>The new value for the attribute.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_subscription_attributes($subscription_arn, $attribute_name, $attribute_value, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubscriptionArn'] = $subscription_arn;\n    $opt['AttributeName'] = $attribute_name;\n    $opt['AttributeValue'] = $attribute_value;\n    \n    return $this-&gt;authenticate('SetSubscriptionAttributes', $opt);\n}"},{"name":"set_topic_attributes","modifier":"public","description":"<p>The SetTopicAttributes action allows a topic owner to set an attribute of the topic to a new\nvalue.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of the topic to modify.<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute_name","type":"string","description":"<p>The name of the attribute you want to set. Only a subset of the topic&#8217;s attributes are mutable. Valid values: Policy | DisplayName<\/p>"},{"@attributes":{"choice":"req"},"name":"attribute_value","type":"string","description":"<p>The new value for the attribute.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_topic_attributes($topic_arn, $attribute_name, $attribute_value, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['AttributeName'] = $attribute_name;\n    $opt['AttributeValue'] = $attribute_value;\n    \n    return $this-&gt;authenticate('SetTopicAttributes', $opt);\n}","examples":{"example":{"title":"<p>Set an attribute for a given topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Get topic attributes\n$response = $sns-&gt;set_topic_attributes(\n\t'arn:aws:sns:us-east-1:9876543210:example-topic',\n\t'DisplayName',\n\t'my-display-value'\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/create_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/create_topic\"><code>create_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/delete_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/delete_topic\"><code>delete_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/get_topic_attributes.html\" rel=\"..\/..\/index.html#m=amazonsns\/get_topic_attributes\"><code>get_topic_attributes()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/list_topics.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_topics\"><code>list_topics()<\/code><\/a>"]}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"subscribe","modifier":"public","description":"<p>The Subscribe action prepares to subscribe an endpoint by sending the endpoint a confirmation\nmessage. To actually create a subscription, the endpoint owner must call the\nConfirmSubscription action with the token from the confirmation message. Confirmation tokens\nare valid for three days.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The ARN of topic you want to subscribe to.<\/p>"},{"@attributes":{"choice":"req"},"name":"protocol","type":"string","description":"<p>The protocol you want to use. Supported protocols include:<\/p>\n\n<ul><li>http &#8212; delivery of JSON-encoded message via HTTP POST<\/li><li>https &#8212; delivery of JSON-encoded message via HTTPS POST<\/li><li>email &#8212; delivery of message via SMTP<\/li><li>email-json &#8212; delivery of JSON-encoded message via SMTP<\/li><li>sqs &#8212; delivery of JSON-encoded message to an Amazon SQS queue<\/li><\/ul>"},{"@attributes":{"choice":"req"},"name":"endpoint","type":"string","description":"<p>The endpoint that you want to receive notifications. Endpoints vary by protocol:<\/p>\n\n<ul><li>For the http protocol, the endpoint is an URL beginning with &#8220;http:\/\/&#8221;<\/li><li>For the https protocol, the endpoint is a URL beginning with &#8220;https:\/\/&#8221;<\/li><li>For the email protocol, the endpoint is an e-mail address<\/li><li>For the email-json protocol, the endpoint is an e-mail address<\/li><li>For the sqs protocol, the endpoint is the ARN of an Amazon SQS queue<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function subscribe($topic_arn, $protocol, $endpoint, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['TopicArn'] = $topic_arn;\n    $opt['Protocol'] = $protocol;\n    $opt['Endpoint'] = $endpoint;\n    \n    return $this-&gt;authenticate('Subscribe', $opt);\n}","examples":{"example":{"title":"<p>Subscribe to a topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Subscribe to notifications\n\n$response = $sns-&gt;subscribe(\n\t'arn:aws:sns:us-east-1:9876543210:my-topic',\n\t'sqs',\n\t'arn:aws:sqs:us-east-1:9876543210:my-sqs-queue'\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/confirm_subscription.html\" rel=\"..\/..\/index.html#m=amazonsns\/confirm_subscription\"><code>confirm_subscription()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions\"><code>list_subscriptions()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/unsubscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/unsubscribe\"><code>unsubscribe()<\/code><\/a>"]}},{"name":"unsubscribe","modifier":"public","description":"<p>The Unsubscribe action deletes a subscription. If the subscription requires authentication for\ndeletion, only the owner of the subscription or the its topic&#8217;s owner can unsubscribe, and an\nAWS signature is required. If the Unsubscribe call does not require authentication and the\nrequester is not the subscription owner, a final cancellation message is delivered to the\nendpoint, so that the endpoint owner can easily resubscribe to the topic if the Unsubscribe\nrequest was unintended.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"subscription_arn","type":"string","description":"<p>The ARN of the subscription to be deleted.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function unsubscribe($subscription_arn, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['SubscriptionArn'] = $subscription_arn;\n    \n    return $this-&gt;authenticate('Unsubscribe', $opt);\n}","examples":{"example":{"title":"<p>Unsubscribe from a topic.<\/p>","code":"$sns = new AmazonSNS();\n\n\/\/ Unsubscribe from notifications\n$response = $sns-&gt;unsubscribe('arn:aws:sns:us-east-1:9876543210:my-topic:afe06644-0b1e-4f32-9f65-2dafe2d1e817');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"related":{"method":["<a href=\"..\/amazonsns\/confirm_subscription.html\" rel=\"..\/..\/index.html#m=amazonsns\/confirm_subscription\"><code>confirm_subscription()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions\"><code>list_subscriptions()<\/code><\/a>","<a href=\"..\/amazonsns\/list_subscriptions_by_topic.html\" rel=\"..\/..\/index.html#m=amazonsns\/list_subscriptions_by_topic\"><code>list_subscriptions_by_topic()<\/code><\/a>","<a href=\"..\/amazonsns\/subscribe.html\" rel=\"..\/..\/index.html#m=amazonsns\/subscribe\"><code>subscribe()<\/code><\/a>"]}}]},"constants":{"@attributes":{"count":"22"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"sns.us-east-1.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_APAC_NE1","value":"sns.ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1","value":"sns.ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE2","value":"sns.ap-southeast-2.amazonaws.com"},{"name":"REGION_CALIFORNIA","value":"sns.us-west-1.amazonaws.com"},{"name":"REGION_EU_W1","value":"sns.eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND","value":"sns.eu-west-1.amazonaws.com"},{"name":"REGION_OREGON","value":"sns.us-west-2.amazonaws.com"},{"name":"REGION_SAO_PAULO","value":"sns.sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1","value":"sns.sa-east-1.amazonaws.com"},{"name":"REGION_SINGAPORE","value":"sns.ap-southeast-1.amazonaws.com"},{"name":"REGION_SYDNEY","value":"sns.ap-southeast-2.amazonaws.com"},{"name":"REGION_TOKYO","value":"sns.ap-northeast-1.amazonaws.com"},{"name":"REGION_US_E1","value":"sns.us-east-1.amazonaws.com"},{"name":"REGION_US_GOV1","value":"sns.us-gov-west-1.amazonaws.com"},{"name":"REGION_US_W1","value":"sns.us-west-1.amazonaws.com"},{"name":"REGION_US_W2","value":"sns.us-west-2.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"sns.us-east-1.amazonaws.com"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazonsns\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonsns\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}