{"file":{},"class":{"name":"AmazonSWF","file":"services\/swf.class.php","url":"..\/amazonswf\/index.html","description":"<p>The Amazon Simple Workflow Service API Reference is intended for programmers who need detailed\ninformation about the Amazon SWF actions and data types.<\/p>\n\n<p>For an broader overview of the Amazon SWF programming model, please go to the <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/\">Amazon SWF Developer Guide<\/a>.<\/p>\n\n<p>This section provides an overview of Amazon SWF actions.<\/p>\n\n<p><strong>Action Categories<\/strong><\/p>\n\n<p>The Amazon SWF actions can be grouped into the following major categories.<\/p>\n\n<ul><li>Actions related to Activities<\/li><li>Actions related to Deciders<\/li><li>Actions related to Workflow Executions<\/li><li>Actions related to Administration<\/li><li>Actions related to Visibility<\/li><\/ul>\n\n<p><strong>Actions related to Activities<\/strong><\/p>\n\n<p>The following are actions that are performed by activity workers:<\/p>\n\n<ul><li><a href=\"API_PollForActivityTask.html\" title=\n\"PollForActivityTask\">PollForActivityTask<\/a><\/li><li><a href=\"API_RespondActivityTaskCompleted.html\" title=\n\"RespondActivityTaskCompleted\">RespondActivityTaskCompleted<\/a><\/li><li><a href=\"API_RespondActivityTaskFailed.html\" title=\n\"RespondActivityTaskFailed\">RespondActivityTaskFailed<\/a><\/li><li><a href=\"API_RespondActivityTaskCanceled.html\" title=\n\"RespondActivityTaskCanceled\">RespondActivityTaskCanceled<\/a><\/li><li><a href=\"API_RecordActivityTaskHeartbeat.html\" title=\n\"RecordActivityTaskHeartbeat\">RecordActivityTaskHeartbeat<\/a><\/li><\/ul>\n\n<p>Activity workers use the <a href=\"API_PollForActivityTask.html\" title=\n\"PollForActivityTask\">PollForActivityTask<\/a> to get new activity tasks. After a worker\nreceives an activity task from Amazon SWF, it performs the task and responds using <a href=\n\"API_RespondActivityTaskCompleted.html\" title=\n\"RespondActivityTaskCompleted\">RespondActivityTaskCompleted<\/a> if successful or <a href=\n\"API_RespondActivityTaskFailed.html\" title=\n\"RespondActivityTaskFailed\">RespondActivityTaskFailed<\/a> if unsuccessful.<\/p>\n\n<p><strong>Actions related to Deciders<\/strong><\/p>\n\n<p>The following are actions that are performed by deciders:<\/p>\n\n<ul><li><a href=\"API_PollForDecisionTask.html\" title=\n\"PollForDecisionTask\">PollForDecisionTask<\/a><\/li><li><a href=\"API_RespondDecisionTaskCompleted.html\" title=\n\"RespondDecisionTaskCompleted\">RespondDecisionTaskCompleted<\/a><\/li><\/ul>\n\n<p>Deciders use <a href=\"API_PollForDecisionTask.html\" title=\n\"PollForDecisionTask\">PollForDecisionTask<\/a> to get decision tasks. After a decider receives a\ndecision task from Amazon SWF, it examines its workflow execution history and decides what to\ndo next. It calls <a href=\"API_RespondDecisionTaskCompleted.html\" title=\n\"RespondDecisionTaskCompleted\">RespondDecisionTaskCompleted<\/a> to complete the decision task\nand provide zero or more next decisions.<\/p>\n\n<p><strong>Actions related to Workflow Executions<\/strong><\/p>\n\n<p>The following actions operate on a workflow execution:<\/p>\n\n<ul><li><a href=\"API_RequestCancelWorkflowExecution.html\" title=\n\"RequestCancelWorkflowExecution\">RequestCancelWorkflowExecution<\/a><\/li><li><a href=\"API_StartWorkflowExecution.html\" title=\n\"StartWorkflowExecution\">StartWorkflowExecution<\/a><\/li><li><a href=\"API_SignalWorkflowExecution.html\" title=\n\"SignalWorkflowExecution\">SignalWorkflowExecution<\/a><\/li><li><a href=\"API_TerminateWorkflowExecution.html\" title=\n\"TerminateWorkflowExecution\">TerminateWorkflowExecution<\/a><\/li><\/ul>\n\n<p><strong>Actions related to Administration<\/strong><\/p>\n\n<p>Although you can perform administrative tasks from the Amazon SWF console, you can use the\nactions in this section to automate functions or build your own administrative tools.<\/p>\n\n<p><strong>Activity Management<\/strong><\/p>\n\n<ul><li><a href=\"API_RegisterActivityType.html\" title=\n\"RegisterActivityType\">RegisterActivityType<\/a><\/li><li><a href=\"API_DeprecateActivityType.html\" title=\n\"DeprecateActivityType\">DeprecateActivityType<\/a><\/li><\/ul>\n\n<p><strong>Workflow Management<\/strong><\/p>\n\n<ul><li><a href=\"API_RegisterWorkflowType.html\" title=\n\"RegisterWorkflowType\">RegisterWorkflowType<\/a><\/li><li><a href=\"API_DeprecateWorkflowType.html\" title=\n\"DeprecateWorkflowType\">DeprecateWorkflowType<\/a><\/li><\/ul>\n\n<p><strong>Domain Management<\/strong><\/p>\n\n<ul><li><a href=\"API_RegisterDomain.html\" title=\"RegisterDomain\">RegisterDomain<\/a><\/li><li><a href=\"API_DeprecateDomain.html\" title=\"DeprecateDomain\">DeprecateDomain<\/a><\/li><\/ul>\n\n<p><strong>Workflow Execution Management<\/strong><\/p>\n\n<ul><li><a href=\"API_RequestCancelWorkflowExecution.html\" title=\n\"RequestCancelWorkflowExecution\">RequestCancelWorkflowExecution<\/a><\/li><li><a href=\"API_TerminateWorkflowExecution.html\" title=\n\"TerminateWorkflowExecution\">TerminateWorkflowExecution<\/a><\/li><\/ul>\n\n<p><strong>Visibility Actions<\/strong><\/p>\n\n<p>Although you can perform visibility actions from the Amazon SWF console, you can use the\nactions in this section to build your own console or administrative tools.<\/p>\n\n<p><strong>Activity Visibility<\/strong><\/p>\n\n<ul><li><a href=\"API_ListActivityTypes.html\" title=\"ListActivities\">ListActivityTypes<\/a><\/li><li><a href=\"API_DescribeActivityType.html\" title=\n\"DescribeActivityType\">DescribeActivity<\/a><\/li><\/ul>\n\n<p><strong>Workflow Visibility<\/strong><\/p>\n\n<ul><li><a href=\"API_ListWorkflowTypes.html\" title=\"ListWorkflowTypes\">ListWorkflowTypes<\/a><\/li><li><a href=\"API_DescribeWorkflowType.html\" title=\n\"DescribeWorkflowType\">DescribeWorkflowType<\/a><\/li><\/ul>\n\n<p><strong>Workflow Execution Visibility<\/strong><\/p>\n\n<ul><li><a href=\"API_DescribeWorkflowExecution.html\" title=\n\"DescribeWorkflowExecution\">DescribeWorkflowExecution<\/a><\/li><li><a href=\"API_ListOpenWorkflowExecutions.html\" title=\n\"ListOpenWorkflowExecutions\">ListOpenWorkflowExecutions<\/a><\/li><li><a href=\"API_ListClosedWorkflowExecutions.html\" title=\n\"ListClosedWorkflowExecutions\">ListClosedWorkflowExecutions<\/a><\/li><li><a href=\"API_CountOpenWorkflowExecutions.html\" title=\n\"CountOpenWorkflowExecutions\">CountOpenWorkflowExecutions<\/a><\/li><li><a href=\"API_CountClosedWorkflowExecutions.html\" title=\n\"CountClosedWorkflowExecutions\">CountClosedWorkflowExecutions<\/a><\/li><li><a href=\"API_GetWorkflowExecutionHistory.html\" title=\n\"GetWorkflowExecutionHistory\">GetWorkflowExecutionHistory<\/a><\/li><\/ul>\n\n<p><strong>Domain Visibility<\/strong><\/p>\n\n<ul><li><a href=\"API_ListDomains.html\" title=\"ListDomains\">ListDomains<\/a><\/li><li><a href=\"API_DescribeDomain.html\" title=\"DescribeDomain\">DescribeDomain<\/a><\/li><\/ul>\n\n<p><strong>Task List Visibility<\/strong><\/p>\n\n<ul><li><a href=\"API_CountPendingActivityTasks.html\" title=\n\"CountPendingActivityTasks\">CountPendingActivityTasks<\/a><\/li><li><a href=\"API_CountPendingDecisionTasks.html\" title=\n\"CountPendingDecisionTasks\">CountPendingDecisionTasks<\/a><\/li><\/ul>","metadata":{"version":"2013.02.21","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/simpleworkflow\/ Amazon Simple Workflow","http:\/\/aws.amazon.com\/simpleworkflow\/documentation\/ Amazon Simple Workflow documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"61"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazonswf\/index.html\" rel=\"..\/..\/index.html#i=amazonswf\"><code>AmazonSWF<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonswf\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2012-01-25';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV3JSON';\n    $this-&gt;operation_prefix = &quot;x-amz-target:SimpleWorkflowService.&quot;;\n\n    return parent::__construct($options);\n}"},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazonswf\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazonswf\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazonswf\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazonswf\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"count_closed_workflow_executions","modifier":"public","description":"<p>Returns the number of closed workflow executions within the given domain that meet the\nspecified filtering criteria.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>tag<\/code>: String constraint. The key is <code>swf:tagFilter.tag<\/code>.<\/li><li><code>typeFilter.name<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.name<\/code>.<\/li><li><code>typeFilter.version<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow executions to count.<\/li><li><code>startTimeFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions that meet the start time criteria of the filter are counted. <p class=\"note\"> <code>startTimeFilter<\/code> and <code>closeTimeFilter<\/code> are mutually exclusive. You must specify one of these in a request but not both.<\/p> <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>closeTimeFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions that meet the close time criteria of the filter are counted. <p class=\"note\"> <code>startTimeFilter<\/code> and <code>closeTimeFilter<\/code> are mutually exclusive. You must specify one of these in a request but not both.<\/p> <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>executionFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions matching the <code>WorkflowId<\/code> in the filter are counted. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId to pass of match the criteria of this filter.<\/li><\/ul><\/li><li><code>typeFilter<\/code> - <code>array<\/code> - Optional - If specified, indicates the type of the workflow executions to be counted. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>name<\/code> - <code>string<\/code> - Required - Name of the workflow type. This field is required.<\/li><li><code>version<\/code> - <code>string<\/code> - Optional - Version of the workflow type.<\/li><\/ul><\/li><li><code>tagFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions that have a tag that matches the filter are counted. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>tag<\/code> - <code>string<\/code> - Required - Specifies the tag that must be associated with the execution for it to meet the filter criteria. This field is required.<\/li><\/ul><\/li><li><code>closeStatusFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions that match this close status are counted. This filter has an affect only if <code>executionStatus<\/code> is specified as <code>CLOSED<\/code>. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>status<\/code> - <code>string<\/code> - Required - The close status that must match the close status of an execution for it to meet the criteria of this filter. This field is required. [Allowed values: <code>COMPLETED<\/code>, <code>FAILED<\/code>, <code>CANCELED<\/code>, <code>TERMINATED<\/code>, <code>CONTINUED_AS_NEW<\/code>, <code>TIMED_OUT<\/code>]<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function count_closed_workflow_executions($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CountClosedWorkflowExecutions', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"count_open_workflow_executions","modifier":"public","description":"<p>Returns the number of open workflow executions within the given domain that meet the specified\nfiltering criteria.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>tag<\/code>: String constraint. The key is <code>swf:tagFilter.tag<\/code>.<\/li><li><code>typeFilter.name<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.name<\/code>.<\/li><li><code>typeFilter.version<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow executions to count.<\/li><li><code>startTimeFilter<\/code> - <code>array<\/code> - Required - Specifies the start time criteria that workflow executions must meet in order to be counted. <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>typeFilter<\/code> - <code>array<\/code> - Optional - Specifies the type of the workflow executions to be counted. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>name<\/code> - <code>string<\/code> - Required - Name of the workflow type. This field is required.<\/li><li><code>version<\/code> - <code>string<\/code> - Optional - Version of the workflow type.<\/li><\/ul><\/li><li><code>tagFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions that have a tag that matches the filter are counted. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>tag<\/code> - <code>string<\/code> - Required - Specifies the tag that must be associated with the execution for it to meet the filter criteria. This field is required.<\/li><\/ul><\/li><li><code>executionFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions matching the <code>WorkflowId<\/code> in the filter are counted. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId to pass of match the criteria of this filter.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function count_open_workflow_executions($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CountOpenWorkflowExecutions', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"count_pending_activity_tasks","modifier":"public","description":"<p>Returns the estimated number of activity tasks in the specified task list. The count returned\nis an approximation and is not guaranteed to be exact. If you specify a task list that no\nactivity task was ever scheduled in then 0 will be returned.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Use a <strong>Condition<\/strong> element with the <code>swf:taskList.name<\/code> key to\nallow the action to access only certain task lists.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain that contains the task list.<\/li><li><code>taskList<\/code> - <code>array<\/code> - Required - The name of the task list. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function count_pending_activity_tasks($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CountPendingActivityTasks', $opt);\n}"},{"name":"count_pending_decision_tasks","modifier":"public","description":"<p>Returns the estimated number of decision tasks in the specified task list. The count returned\nis an approximation and is not guaranteed to be exact. If you specify a task list that no\ndecision task was ever scheduled in then 0 will be returned.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Use a <strong>Condition<\/strong> element with the <code>swf:taskList.name<\/code> key to\nallow the action to access only certain task lists.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain that contains the task list.<\/li><li><code>taskList<\/code> - <code>array<\/code> - Required - The name of the task list. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function count_pending_decision_tasks($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CountPendingDecisionTasks', $opt);\n}"},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"deprecate_activity_type","modifier":"public","description":"<p>Deprecates the specified <em>activity type<\/em>. After an activity type has been deprecated,\nyou cannot create new tasks of that activity type. Tasks of this type that were scheduled\nbefore the type was deprecated will continue to run.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>activityType.name<\/code>: String constraint. The key is\n<code>swf:activityType.name<\/code>.<\/li><li><code>activityType.version<\/code>: String constraint. The key is\n<code>swf:activityType.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the activity type is registered.<\/li><li><code>activityType<\/code> - <code>array<\/code> - Required - The activity type to deprecate. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of this activity. <p class=\"note\">The combination of activity type name and version must be unique within a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of this activity. <p class=\"note\">The combination of activity type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deprecate_activity_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeprecateActivityType', $opt);\n}","examples":{"example":{"title":"<p>Activity Type CRUD.<\/p>","description":"<p>Shows an example of activity type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new activity type\n\necho '# Registering a new activity type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_activity_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $activity_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the activity type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_activity_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'activityType' =&gt; array(\n\t\t\t\t'name'    =&gt; $activity_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Activity type was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered activity types\n\necho &quot;# Listing all registered activity types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_activity_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;activityType-&gt;name . ' ' .\n\t     (string) $item-&gt;activityType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific activity type\n\necho &quot;# Describing the \\&quot;${activity_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a activity type\n\necho '# Deprecating an activity type...' . PHP_EOL;\n$deprecate_activity_type = $swf-&gt;deprecate_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Activity flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"deprecate_domain","modifier":"public","description":"<p>Deprecates the specified domain. After a domain has been deprecated it cannot be used to create\nnew workflow executions or register new types. However, you can still use visibility actions on\nthis domain. Deprecating a domain also deprecates all activity and workflow types registered in\nthe domain. Executions that were started before the domain was deprecated will continue to run.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the domain to deprecate.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deprecate_domain($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeprecateDomain', $opt);\n}","examples":{"example":{"title":"<p>Workflow Domain CRUD.<\/p>","description":"<p>Shows an example of workflow domain CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow domain\n\necho &quot;# Registering a new workflow domain, \\&quot;${workflow_domain}\\&quot;...&quot; . PHP_EOL;\n\n$domain = $swf-&gt;register_domain(array(\n\t'name' =&gt; $workflow_domain,\n\t'workflowExecutionRetentionPeriodInDays' =&gt; '1'\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Domain was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Domain creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow domains\n\necho '# Listing all registered workflow domains...' . PHP_EOL;\n\n\/\/ Grab a list of &quot;registered&quot; domains and list them.\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_domains(array(\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED\n))\n-&gt;body-&gt;domainInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' . (string) $item-&gt;name . PHP_EOL;\n});\n\necho '.' . PHP_EOL . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific domain\n\necho &quot;# Describing the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\nprint_r($describe-&gt;body);\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow domain\n\necho &quot;# Deprecating the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n$deprecate = $swf-&gt;deprecate_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\ndo {\n\tsleep(1);\n\n\t$describe = $swf-&gt;describe_domain(array(\n\t\t'name' =&gt; $workflow_domain\n\t));\n}\nwhile ($deprecate-&gt;status === 200 &amp;&amp; (string) $describe-&gt;body-&gt;domainInfo-&gt;status !== AmazonSWF::STATUS_DEPRECATED);\n\nif ($deprecate-&gt;isOK())\n{\n\techo &quot;Domain \\&quot;${workflow_domain}\\&quot; has been successfully deprecated.&quot; . PHP_EOL;\n}\nelse\n{\n\techo &quot;Domain has failed to deprecated.&quot; . PHP_EOL;\n\tprint_r($deprecate-&gt;body);\n}"}}},{"name":"deprecate_workflow_type","modifier":"public","description":"<p>Deprecates the specified <em>workflow type<\/em>. After a workflow type has been deprecated, you\ncannot create new executions of that type. Executions that were started before the type was\ndeprecated will continue to run. A deprecated workflow type may still be used when calling\nvisibility actions.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>workflowType.name<\/code>: String constraint. The key is\n<code>swf:workflowType.name<\/code>.<\/li><li><code>workflowType.version<\/code>: String constraint. The key is\n<code>swf:workflowType.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the workflow type is registered.<\/li><li><code>workflowType<\/code> - <code>array<\/code> - Required - The workflow type to deprecate. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function deprecate_workflow_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeprecateWorkflowType', $opt);\n}","examples":{"example":{"title":"<p>Workflow Type CRUD.<\/p>","description":"<p>Shows an example of workflow type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow type\n\necho '# Registering a new workflow type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_workflow_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $workflow_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the workflow type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_workflow_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'workflowType' =&gt; array(\n\t\t\t\t'name'    =&gt; $workflow_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Worktype flow was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Workflow type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow types\n\necho &quot;# Listing all registered workflow types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_workflow_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;workflowType-&gt;name . ' ' .\n\t     (string) $item-&gt;workflowType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific workflow type\n\necho &quot;# Describing the \\&quot;${workflow_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow type\n\necho '# Deprecating a workflow type...' . PHP_EOL;\n$deprecate_workflow_type = $swf-&gt;deprecate_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Worktype flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Worktype flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"describe_activity_type","modifier":"public","description":"<p>Returns information about the specified activity type. This includes configuration settings\nprovided at registration time as well as other general information about the type.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>activityType.name<\/code>: String constraint. The key is\n<code>swf:activityType.name<\/code>.<\/li><li><code>activityType.version<\/code>: String constraint. The key is\n<code>swf:activityType.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the activity type is registered.<\/li><li><code>activityType<\/code> - <code>array<\/code> - Required - The activity type to describe. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of this activity. <p class=\"note\">The combination of activity type name and version must be unique within a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of this activity. <p class=\"note\">The combination of activity type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_activity_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeActivityType', $opt);\n}","examples":{"example":{"title":"<p>Activity Type CRUD.<\/p>","description":"<p>Shows an example of activity type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new activity type\n\necho '# Registering a new activity type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_activity_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $activity_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the activity type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_activity_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'activityType' =&gt; array(\n\t\t\t\t'name'    =&gt; $activity_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Activity type was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered activity types\n\necho &quot;# Listing all registered activity types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_activity_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;activityType-&gt;name . ' ' .\n\t     (string) $item-&gt;activityType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific activity type\n\necho &quot;# Describing the \\&quot;${activity_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a activity type\n\necho '# Deprecating an activity type...' . PHP_EOL;\n$deprecate_activity_type = $swf-&gt;deprecate_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Activity flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"describe_domain","modifier":"public","description":"<p>Returns information about the specified domain including description and status.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the domain to describe.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_domain($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeDomain', $opt);\n}","examples":{"example":{"title":"<p>Workflow Domain CRUD.<\/p>","description":"<p>Shows an example of workflow domain CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow domain\n\necho &quot;# Registering a new workflow domain, \\&quot;${workflow_domain}\\&quot;...&quot; . PHP_EOL;\n\n$domain = $swf-&gt;register_domain(array(\n\t'name' =&gt; $workflow_domain,\n\t'workflowExecutionRetentionPeriodInDays' =&gt; '1'\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Domain was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Domain creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow domains\n\necho '# Listing all registered workflow domains...' . PHP_EOL;\n\n\/\/ Grab a list of &quot;registered&quot; domains and list them.\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_domains(array(\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED\n))\n-&gt;body-&gt;domainInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' . (string) $item-&gt;name . PHP_EOL;\n});\n\necho '.' . PHP_EOL . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific domain\n\necho &quot;# Describing the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\nprint_r($describe-&gt;body);\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow domain\n\necho &quot;# Deprecating the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n$deprecate = $swf-&gt;deprecate_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\ndo {\n\tsleep(1);\n\n\t$describe = $swf-&gt;describe_domain(array(\n\t\t'name' =&gt; $workflow_domain\n\t));\n}\nwhile ($deprecate-&gt;status === 200 &amp;&amp; (string) $describe-&gt;body-&gt;domainInfo-&gt;status !== AmazonSWF::STATUS_DEPRECATED);\n\nif ($deprecate-&gt;isOK())\n{\n\techo &quot;Domain \\&quot;${workflow_domain}\\&quot; has been successfully deprecated.&quot; . PHP_EOL;\n}\nelse\n{\n\techo &quot;Domain has failed to deprecated.&quot; . PHP_EOL;\n\tprint_r($deprecate-&gt;body);\n}"}}},{"name":"describe_workflow_execution","modifier":"public","description":"<p>Returns information about the specified workflow execution including its type and some\nstatistics.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow execution.<\/li><li><code>execution<\/code> - <code>array<\/code> - Required - The workflow execution to describe. <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The user defined identifier associated with the workflow execution.<\/li><li><code>runId<\/code> - <code>string<\/code> - Required - A system generated unique identifier for the workflow execution.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_workflow_execution($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeWorkflowExecution', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"describe_workflow_type","modifier":"public","description":"<p>Returns information about the specified <em>workflow type<\/em>. This includes configuration\nsettings specified when the type was registered and other information such as creation date,\ncurrent status, etc.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>workflowType.name<\/code>: String constraint. The key is\n<code>swf:workflowType.name<\/code>.<\/li><li><code>workflowType.version<\/code>: String constraint. The key is\n<code>swf:workflowType.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which this workflow type is registered.<\/li><li><code>workflowType<\/code> - <code>array<\/code> - Required - The workflow type to describe. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_workflow_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeWorkflowType', $opt);\n}","examples":{"example":{"title":"<p>Workflow Type CRUD.<\/p>","description":"<p>Shows an example of workflow type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow type\n\necho '# Registering a new workflow type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_workflow_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $workflow_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the workflow type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_workflow_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'workflowType' =&gt; array(\n\t\t\t\t'name'    =&gt; $workflow_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Worktype flow was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Workflow type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow types\n\necho &quot;# Listing all registered workflow types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_workflow_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;workflowType-&gt;name . ' ' .\n\t     (string) $item-&gt;workflowType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific workflow type\n\necho &quot;# Describing the \\&quot;${workflow_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow type\n\necho '# Deprecating a workflow type...' . PHP_EOL;\n$deprecate_workflow_type = $swf-&gt;deprecate_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Worktype flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Worktype flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonswf\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"get_workflow_execution_history","modifier":"public","description":"<p>Returns the history of the specified workflow execution. The results may be split into multiple\npages. To retrieve subsequent pages, make the call again using the <code>nextPageToken<\/code>\nreturned by the initial call.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow execution.<\/li><li><code>execution<\/code> - <code>array<\/code> - Required - Specifies the workflow execution for which to return the history. <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The user defined identifier associated with the workflow execution.<\/li><li><code>runId<\/code> - <code>string<\/code> - Required - A system generated unique identifier for the workflow execution.<\/li><\/ul><\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If a <code>NextPageToken<\/code> is returned, the result has more than one pages. To get the next page, repeat the call and specify the nextPageToken with all other arguments unchanged.<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - Specifies the maximum number of history events returned in one page. The next page in the result is identified by the <code>NextPageToken<\/code> returned. By default 100 history events are returned in a page but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size larger than 100. Note that the number of events may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the events in reverse order. By default the results are returned in ascending order of the <code>eventTimeStamp<\/code> of the events.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_workflow_execution_history($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('GetWorkflowExecutionHistory', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"list_activity_types","modifier":"public","description":"<p>Returns information about all activities registered in the specified domain that match the\nspecified name and registration status. The result includes information like creation date,\ncurrent status of the activity, etc. The results may be split into multiple pages. To retrieve\nsubsequent pages, make the call again using the <code>nextPageToken<\/code> returned by the\ninitial call.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the activity types have been registered.<\/li><li><code>name<\/code> - <code>string<\/code> - Optional - If specified, only lists the activity types that have this name.<\/li><li><code>registrationStatus<\/code> - <code>string<\/code> - Required - Specifies the registration status of the activity types to list. [Allowed values: <code>REGISTERED<\/code>, <code>DEPRECATED<\/code>]<\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextResultToken<\/code> was returned, the results have more than one page. To get the next page of results, repeat the call with the <code>nextPageToken<\/code> and keep all other arguments unchanged.<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of types may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the results in reverse order. By default the results are returned in ascending alphabetical order of the <code>name<\/code> of the activity types.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_activity_types($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListActivityTypes', $opt);\n}","examples":{"example":{"title":"<p>Activity Type CRUD.<\/p>","description":"<p>Shows an example of activity type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new activity type\n\necho '# Registering a new activity type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_activity_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $activity_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the activity type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_activity_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'activityType' =&gt; array(\n\t\t\t\t'name'    =&gt; $activity_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Activity type was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered activity types\n\necho &quot;# Listing all registered activity types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_activity_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;activityType-&gt;name . ' ' .\n\t     (string) $item-&gt;activityType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific activity type\n\necho &quot;# Describing the \\&quot;${activity_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a activity type\n\necho '# Deprecating an activity type...' . PHP_EOL;\n$deprecate_activity_type = $swf-&gt;deprecate_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Activity flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"list_closed_workflow_executions","modifier":"public","description":"<p>Returns a list of closed workflow executions in the specified domain that meet the filtering\ncriteria. The results may be split into multiple pages. To retrieve subsequent pages, make the\ncall again using the nextPageToken returned by the initial call.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>tag<\/code>: String constraint. The key is <code>swf:tagFilter.tag<\/code>.<\/li><li><code>typeFilter.name<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.name<\/code>.<\/li><li><code>typeFilter.version<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain that contains the workflow executions to list.<\/li><li><code>startTimeFilter<\/code> - <code>array<\/code> - Optional - If specified, the workflow executions are included in the returned results based on whether their start times are within the range specified by this filter. Also, if this parameter is specified, the returned results are ordered by their start times. <p class=\"note\"> <code>startTimeFilter<\/code> and <code>closeTimeFilter<\/code> are mutually exclusive. You must specify one of these in a request but not both.<\/p> <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>closeTimeFilter<\/code> - <code>array<\/code> - Optional - If specified, the workflow executions are included in the returned results based on whether their close times are within the range specified by this filter. Also, if this parameter is specified, the returned results are ordered by their close times. <p class=\"note\"> <code>startTimeFilter<\/code> and <code>closeTimeFilter<\/code> are mutually exclusive. You must specify one of these in a request but not both.<\/p> <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>executionFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions matching the workflow id specified in the filter are returned. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId to pass of match the criteria of this filter.<\/li><\/ul><\/li><li><code>closeStatusFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions that match this <em>close status<\/em> are listed. For example, if TERMINATED is specified, then only TERMINATED workflow executions are listed. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>status<\/code> - <code>string<\/code> - Required - The close status that must match the close status of an execution for it to meet the criteria of this filter. This field is required. [Allowed values: <code>COMPLETED<\/code>, <code>FAILED<\/code>, <code>CANCELED<\/code>, <code>TERMINATED<\/code>, <code>CONTINUED_AS_NEW<\/code>, <code>TIMED_OUT<\/code>]<\/li><\/ul><\/li><li><code>typeFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions of the type specified in the filter are returned. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>name<\/code> - <code>string<\/code> - Required - Name of the workflow type. This field is required.<\/li><li><code>version<\/code> - <code>string<\/code> - Optional - Version of the workflow type.<\/li><\/ul><\/li><li><code>tagFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions that have the matching tag are listed. <p class=\"note\"> <code>closeStatusFilter<\/code>, <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>tag<\/code> - <code>string<\/code> - Required - Specifies the tag that must be associated with the execution for it to meet the filter criteria. This field is required.<\/li><\/ul><\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextPageToken<\/code> was returned, the results are being paginated. To get the next page of results, repeat the call with the returned token and all other arguments unchanged.<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of executions may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the results in reverse order. By default the results are returned in descending order of the start or the close time of the executions.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_closed_workflow_executions($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListClosedWorkflowExecutions', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"list_domains","modifier":"public","description":"<p>Returns the list of domains registered in the account. The results may be split into multiple\npages. To retrieve subsequent pages, make the call again using the nextPageToken returned by\nthe initial call.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains. The element must be set to <code>arn:aws:swf::AccountID:domain\/*\"<\/code>,\nwhere &acirc;&euro;&oelig;AccountID&#8221; is the account ID, with no dashes.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextPageToken<\/code> was returned, the result has more than one page. To get the next page of results, repeat the call with the returned token and all other arguments unchanged.<\/li><li><code>registrationStatus<\/code> - <code>string<\/code> - Required - Specifies the registration status of the domains to list. [Allowed values: <code>REGISTERED<\/code>, <code>DEPRECATED<\/code>]<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of domains may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the results in reverse order. By default the results are returned in ascending alphabetical order of the <code>name<\/code> of the domains.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_domains($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListDomains', $opt);\n}","examples":{"example":{"title":"<p>Workflow Domain CRUD.<\/p>","description":"<p>Shows an example of workflow domain CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow domain\n\necho &quot;# Registering a new workflow domain, \\&quot;${workflow_domain}\\&quot;...&quot; . PHP_EOL;\n\n$domain = $swf-&gt;register_domain(array(\n\t'name' =&gt; $workflow_domain,\n\t'workflowExecutionRetentionPeriodInDays' =&gt; '1'\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Domain was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Domain creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow domains\n\necho '# Listing all registered workflow domains...' . PHP_EOL;\n\n\/\/ Grab a list of &quot;registered&quot; domains and list them.\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_domains(array(\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED\n))\n-&gt;body-&gt;domainInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' . (string) $item-&gt;name . PHP_EOL;\n});\n\necho '.' . PHP_EOL . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific domain\n\necho &quot;# Describing the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\nprint_r($describe-&gt;body);\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow domain\n\necho &quot;# Deprecating the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n$deprecate = $swf-&gt;deprecate_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\ndo {\n\tsleep(1);\n\n\t$describe = $swf-&gt;describe_domain(array(\n\t\t'name' =&gt; $workflow_domain\n\t));\n}\nwhile ($deprecate-&gt;status === 200 &amp;&amp; (string) $describe-&gt;body-&gt;domainInfo-&gt;status !== AmazonSWF::STATUS_DEPRECATED);\n\nif ($deprecate-&gt;isOK())\n{\n\techo &quot;Domain \\&quot;${workflow_domain}\\&quot; has been successfully deprecated.&quot; . PHP_EOL;\n}\nelse\n{\n\techo &quot;Domain has failed to deprecated.&quot; . PHP_EOL;\n\tprint_r($deprecate-&gt;body);\n}"}}},{"name":"list_open_workflow_executions","modifier":"public","description":"<p>Returns a list of open workflow executions in the specified domain that meet the filtering\ncriteria. The results may be split into multiple pages. To retrieve subsequent pages, make the\ncall again using the nextPageToken returned by the initial call.<\/p>\n\n<p class=\"note\">\nThis operation is eventually consistent. The results are best effort and may not exactly\nreflect recent updates and changes.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>tag<\/code>: String constraint. The key is <code>swf:tagFilter.tag<\/code>.<\/li><li><code>typeFilter.name<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.name<\/code>.<\/li><li><code>typeFilter.version<\/code>: String constraint. String constraint. The key is\n<code>swf:typeFilter.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain that contains the workflow executions to list.<\/li><li><code>startTimeFilter<\/code> - <code>array<\/code> - Required - Workflow executions are included in the returned results based on whether their start times are within the range specified by this filter. <ul><li><code>oldestDate<\/code> - <code>string<\/code> - Required - Specifies the oldest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>latestDate<\/code> - <code>string<\/code> - Optional - Specifies the latest start or close date and time to return. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><\/ul><\/li><li><code>typeFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions of the type specified in the filter are returned. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>name<\/code> - <code>string<\/code> - Required - Name of the workflow type. This field is required.<\/li><li><code>version<\/code> - <code>string<\/code> - Optional - Version of the workflow type.<\/li><\/ul><\/li><li><code>tagFilter<\/code> - <code>array<\/code> - Optional - If specified, only executions that have the matching tag are listed. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>tag<\/code> - <code>string<\/code> - Required - Specifies the tag that must be associated with the execution for it to meet the filter criteria. This field is required.<\/li><\/ul><\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextPageToken<\/code> was returned, the results are being paginated. To get the next page of results, repeat the call with the returned token and all other arguments unchanged.<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of executions may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the results in reverse order. By default the results are returned in descending order of the start time of the executions.<\/li><li><code>executionFilter<\/code> - <code>array<\/code> - Optional - If specified, only workflow executions matching the workflow id specified in the filter are returned. <p class=\"note\"> <code>executionFilter<\/code>, <code>typeFilter<\/code> and <code>tagFilter<\/code> are mutually exclusive. You can specify at most one of these in a request.<\/p> <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId to pass of match the criteria of this filter.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_open_workflow_executions($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListOpenWorkflowExecutions', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"list_workflow_types","modifier":"public","description":"<p>Returns information about workflow types in the specified domain. The results may be split into\nmultiple pages that can be retrieved by making the call repeatedly.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the workflow types have been registered.<\/li><li><code>name<\/code> - <code>string<\/code> - Optional - If specified, lists the workflow type with this name.<\/li><li><code>registrationStatus<\/code> - <code>string<\/code> - Required - Specifies the registration status of the workflow types to list. [Allowed values: <code>REGISTERED<\/code>, <code>DEPRECATED<\/code>]<\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextPageToken<\/code> was returned, the results are being paginated. To get the next page of results, repeat the call with the returned token and all other arguments unchanged.<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of types may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the results in reverse order. By default the results are returned in ascending alphabetical order of the <code>name<\/code> of the workflow types.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_workflow_types($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListWorkflowTypes', $opt);\n}","examples":{"example":{"title":"<p>Workflow Type CRUD.<\/p>","description":"<p>Shows an example of workflow type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow type\n\necho '# Registering a new workflow type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_workflow_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $workflow_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the workflow type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_workflow_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'workflowType' =&gt; array(\n\t\t\t\t'name'    =&gt; $workflow_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Worktype flow was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Workflow type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow types\n\necho &quot;# Listing all registered workflow types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_workflow_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;workflowType-&gt;name . ' ' .\n\t     (string) $item-&gt;workflowType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific workflow type\n\necho &quot;# Describing the \\&quot;${workflow_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow type\n\necho '# Deprecating a workflow type...' . PHP_EOL;\n$deprecate_workflow_type = $swf-&gt;deprecate_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Worktype flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Worktype flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"poll_for_activity_task","modifier":"public","description":"<p>Used by workers to get an <code>ActivityTask<\/code> from the specified activity\n<code>taskList<\/code>. This initiates a long poll, where the service holds the HTTP connection\nopen and responds as soon as a task becomes available. The maximum time the service holds on to\nthe request before responding is 60 seconds. If no task is available within 60 seconds, the\npoll will return an empty result. An empty result, in this context, means that an ActivityTask\nis returned, but that the value of taskToken is an empty string. If a task is returned, the\nworker should use its type to identify and process it correctly.<\/p>\n\n<p class=\"important\">\nWorkers should set their client side socket timeout to at least 70 seconds (10 seconds higher\nthan the maximum time service may hold the poll request).\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Use a <strong>Condition<\/strong> element with the <code>swf:taskList.name<\/code> key to\nallow the action to access only certain task lists.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain that contains the task lists being polled.<\/li><li><code>taskList<\/code> - <code>array<\/code> - Required - Specifies the task list to poll for activity tasks. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>identity<\/code> - <code>string<\/code> - Optional - Identity of the worker making the request, which is recorded in the <code>ActivityTaskStarted<\/code> event in the workflow history. This enables diagnostic tracing when problems arise. The form of this identity is user defined.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function poll_for_activity_task($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('PollForActivityTask', $opt);\n}"},{"name":"poll_for_decision_task","modifier":"public","description":"<p>Used by deciders to get a <code>DecisionTask<\/code> from the specified decision\n<code>taskList<\/code>. A decision task may be returned for any open workflow execution that is\nusing the specified task list. The task includes a paginated view of the history of the\nworkflow execution. The decider should use the workflow type and the history to determine how\nto properly handle the task.<\/p>\n\n<p>This action initiates a long poll, where the service holds the HTTP connection open and\nresponds as soon a task becomes available. If no decision task is available in the specified\ntask list before the timeout of 60 seconds expires, an empty result is returned. An empty\nresult, in this context, means that a DecisionTask is returned, but that the value of taskToken\nis an empty string.<\/p>\n\n<p class=\"important\">\nDeciders should set their client side socket timeout to at least 70 seconds (10 seconds higher\nthan the timeout).\n<\/p>\n\n<p class=\"important\">\nBecause the number of workflow history events for a single workflow execution might be very\nlarge, the result returned might be split up across a number of pages. To retrieve subsequent\npages, make additional calls to <code>PollForDecisionTask<\/code> using the\n<code>nextPageToken<\/code> returned by the initial call. Note that you do <strong>not<\/strong>\ncall <code>GetWorkflowExecutionHistory<\/code> with this <code>nextPageToken<\/code>. Instead,\ncall <code>PollForDecisionTask<\/code> again.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Use a <strong>Condition<\/strong> element with the <code>swf:taskList.name<\/code> key to\nallow the action to access only certain task lists.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the task lists to poll.<\/li><li><code>taskList<\/code> - <code>array<\/code> - Required - Specifies the task list to poll for decision tasks. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>identity<\/code> - <code>string<\/code> - Optional - Identity of the decider making the request, which is recorded in the DecisionTaskStarted event in the workflow history. This enables diagnostic tracing when problems arise. The form of this identity is user defined.<\/li><li><code>nextPageToken<\/code> - <code>string<\/code> - Optional - If on a previous call to this method a <code>NextPageToken<\/code> was returned, the results are being paginated. To get the next page of results, repeat the call with the returned token and all other arguments unchanged. <p class=\"note\">The <code>nextPageToken<\/code> returned by this action cannot be used with <code>GetWorkflowExecutionHistory<\/code> to get the next page. You must call <code>PollForDecisionTask<\/code> again (with the <code>nextPageToken<\/code>) to retrieve the next page of history records. Calling <code>PollForDecisionTask<\/code> with a <code>nextPageToken<\/code> will not return a new decision task.<\/p> .<\/li><li><code>maximumPageSize<\/code> - <code>integer<\/code> - Optional - The maximum number of history events returned in each page. The default is 100, but the caller can override this value to a page size <em>smaller<\/em> than the default. You cannot specify a page size greater than 100. Note that the number of events may be less than the maxiumum page size, in which case, the returned page will have fewer results than the maximumPageSize specified.<\/li><li><code>reverseOrder<\/code> - <code>boolean<\/code> - Optional - When set to <code>true<\/code>, returns the events in reverse order. By default the results are returned in ascending order of the <code>eventTimestamp<\/code> of the events.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function poll_for_decision_task($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('PollForDecisionTask', $opt);\n}"},{"name":"record_activity_task_heartbeat","modifier":"public","description":"<p>Used by activity workers to report to the service that the <code>ActivityTask<\/code>\nrepresented by the specified <code>taskToken<\/code> is still making progress. The worker can\nalso (optionally) specify details of the progress, for example percent complete, using the\n<code>details<\/code> parameter. This action can also be used by the worker as a mechanism to\ncheck if cancellation is being requested for the activity task. If a cancellation is being\nattempted for the specified task, then the boolean <code>cancelRequested<\/code> flag returned\nby the service is set to <code>true<\/code>.<\/p>\n\n<p>This action resets the <code>taskHeartbeatTimeout<\/code> clock. The\n<code>taskHeartbeatTimeout<\/code> is specified in <code>RegisterActivityType<\/code>.<\/p>\n\n<p>This action does not in itself create an event in the workflow execution history. However, if\nthe task times out, the workflow execution history will contain a\n<code>ActivityTaskTimedOut<\/code> event that contains the information from the last heartbeat\ngenerated by the activity worker.<\/p>\n\n<p class=\"note\">\nThe <code>taskStartToCloseTimeout<\/code> of an activity type is the maximum duration of an\nactivity task, regardless of the number of <code>RecordActivityTaskHeartbeat<\/code> requests\nreceived. The <code>taskStartToCloseTimeout<\/code> is also specified in\n<code>RegisterActivityType<\/code>.\n<\/p>\n\n<p class=\"note\">\nThis operation is only useful for long-lived activities to report liveliness of the task and to\ndetermine if a cancellation is being attempted.\n<\/p>\n\n<p class=\"important\">\nIf the <code>cancelRequested<\/code> flag returns <code>true<\/code>, a cancellation is being\nattempted. If the worker can cancel the activity, it should respond with\n<code>RespondActivityTaskCanceled<\/code>. Otherwise, it should ignore the cancellation request.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>taskToken<\/code> - <code>string<\/code> - Required - The <code>taskToken<\/code> of the <code>ActivityTask<\/code>. <p class=\"important\">The <code>taskToken<\/code> is generated by the service and should be treated as an opaque value. If the task is passed to another process, its <code>taskToken<\/code> must also be passed. This enables it to provide its progress and respond with results.<\/p><\/li><li><code>details<\/code> - <code>string<\/code> - Optional - If specified, contains details about the progress of the task.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function record_activity_task_heartbeat($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RecordActivityTaskHeartbeat', $opt);\n}"},{"name":"register_activity_type","modifier":"public","description":"<p>Registers a new <em>activity type<\/em> along with its configuration settings in the specified\ndomain.<\/p>\n\n<p class=\"important\">\nA <code>TypeAlreadyExists<\/code> fault is returned if the type already exists in the domain.\nYou cannot change any configuration settings of the type after its registration, and it must be\nregistered as a new version.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>defaultTaskList<\/code>: String constraint. The key is\n<code>swf:defaultTaskList.name<\/code>.<\/li><li><code>name<\/code>: String constraint. The key is <code>swf:name<\/code>.<\/li><li><code>version<\/code>: String constraint. The key is <code>swf:version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which this activity is to be registered.<\/li><li><code>name<\/code> - <code>string<\/code> - Required - The name of the activity type within the domain. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the activity type. <p class=\"note\">The activity type consists of the name and version, the combination of which must be unique within the domain.<\/p> The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>description<\/code> - <code>string<\/code> - Optional - A textual description of the activity type.<\/li><li><code>defaultTaskStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum duration that a worker can take to process tasks of this activity type. This default can be overridden when scheduling an activity task using the <code>ScheduleActivityTask<\/code> <code>Decision<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><li><code>defaultTaskHeartbeatTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum time before which a worker processing a task of this type must report progress by calling <code>RecordActivityTaskHeartbeat<\/code>. If the timeout is exceeded, the activity task is automatically timed out. This default can be overridden when scheduling an activity task using the <code>ScheduleActivityTask<\/code> <code>Decision<\/code>. If the activity worker subsequently attempts to record a heartbeat or returns a result, the activity worker receives an <code>UnknownResource<\/code> fault. In this case, Amazon SWF no longer considers the activity task to be valid; the activity worker should clean up the activity task. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><li><code>defaultTaskList<\/code> - <code>array<\/code> - Optional - If set, specifies the default task list to use for scheduling tasks of this activity type. This default task list is used if a task list is not provided when a task is scheduled through the <code>ScheduleActivityTask<\/code> <code>Decision<\/code>. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>defaultTaskScheduleToStartTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum duration that a task of this activity type can wait before being assigned to a worker. This default can be overridden when scheduling an activity task using the <code>ScheduleActivityTask<\/code> <code>Decision<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><li><code>defaultTaskScheduleToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum duration for a task of this activity type. This default can be overridden when scheduling an activity task using the <code>ScheduleActivityTask<\/code> <code>Decision<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function register_activity_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RegisterActivityType', $opt);\n}","examples":{"example":{"title":"<p>Activity Type CRUD.<\/p>","description":"<p>Shows an example of activity type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new activity type\n\necho '# Registering a new activity type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_activity_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $activity_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the activity type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_activity_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'activityType' =&gt; array(\n\t\t\t\t'name'    =&gt; $activity_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Activity type was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered activity types\n\necho &quot;# Listing all registered activity types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_activity_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;activityType-&gt;name . ' ' .\n\t     (string) $item-&gt;activityType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific activity type\n\necho &quot;# Describing the \\&quot;${activity_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a activity type\n\necho '# Deprecating an activity type...' . PHP_EOL;\n$deprecate_activity_type = $swf-&gt;deprecate_activity_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'activityType' =&gt; array(\n\t\t'name'    =&gt; $activity_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Activity flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Activity flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"register_domain","modifier":"public","description":"<p>Registers a new domain.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>You cannot use an IAM policy to control domain access for this action. The name of the\ndomain being registered is available as the resource of this action.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>name<\/code> - <code>string<\/code> - Required - Name of the domain to register. The name must be unique. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>description<\/code> - <code>string<\/code> - Optional - Textual description of the domain.<\/li><li><code>workflowExecutionRetentionPeriodInDays<\/code> - <code>string<\/code> - Required - Specifies the duration&#8212; <strong><em>in days<\/em><\/strong> &#8212;for which the record (including the history) of workflow executions in this domain should be kept by the service. After the retention period, the workflow execution will not be available in the results of visibility calls. If a duration of <code>NONE<\/code> is specified, the records for workflow executions in this domain are not retained at all.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function register_domain($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RegisterDomain', $opt);\n}","examples":{"example":{"title":"<p>Workflow Domain CRUD.<\/p>","description":"<p>Shows an example of workflow domain CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"\/\/ Instantiate the class\n$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow domain\n\necho &quot;# Registering a new workflow domain, \\&quot;${workflow_domain}\\&quot;...&quot; . PHP_EOL;\n\n$domain = $swf-&gt;register_domain(array(\n\t'name' =&gt; $workflow_domain,\n\t'workflowExecutionRetentionPeriodInDays' =&gt; '1'\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Domain was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Domain creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow domains\n\necho '# Listing all registered workflow domains...' . PHP_EOL;\n\n\/\/ Grab a list of &quot;registered&quot; domains and list them.\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_domains(array(\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED\n))\n-&gt;body-&gt;domainInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' . (string) $item-&gt;name . PHP_EOL;\n});\n\necho '.' . PHP_EOL . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific domain\n\necho &quot;# Describing the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\nprint_r($describe-&gt;body);\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow domain\n\necho &quot;# Deprecating the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n$deprecate = $swf-&gt;deprecate_domain(array(\n\t'name' =&gt; $workflow_domain\n));\n\ndo {\n\tsleep(1);\n\n\t$describe = $swf-&gt;describe_domain(array(\n\t\t'name' =&gt; $workflow_domain\n\t));\n}\nwhile ($deprecate-&gt;status === 200 &amp;&amp; (string) $describe-&gt;body-&gt;domainInfo-&gt;status !== AmazonSWF::STATUS_DEPRECATED);\n\nif ($deprecate-&gt;isOK())\n{\n\techo &quot;Domain \\&quot;${workflow_domain}\\&quot; has been successfully deprecated.&quot; . PHP_EOL;\n}\nelse\n{\n\techo &quot;Domain has failed to deprecated.&quot; . PHP_EOL;\n\tprint_r($deprecate-&gt;body);\n}"}}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_workflow_type","modifier":"public","description":"<p>Registers a new <em>workflow type<\/em> and its configuration settings in the specified domain.<\/p>\n\n<p>The retention period for the workflow history is set by the <code>RegisterDomain<\/code> action.<\/p>\n\n<p class=\"important\">\nIf the type already exists, then a <code>TypeAlreadyExists<\/code> fault is returned. You cannot\nchange the configuration settings of a workflow type once it is registered and it must be\nregistered as a new version.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>defaultTaskList<\/code>: String constraint. The key is\n<code>swf:defaultTaskList.name<\/code>.<\/li><li><code>name<\/code>: String constraint. The key is <code>swf:name<\/code>.<\/li><li><code>version<\/code>: String constraint. The key is <code>swf:version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which to register the workflow type.<\/li><li><code>name<\/code> - <code>string<\/code> - Required - The name of the workflow type. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the workflow type. <p class=\"note\">The workflow type consists of the name and version, the combination of which must be unique within the domain. To get a list of all currently registered workflow types, use the <code>ListWorkflowTypes<\/code> action.<\/p> The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>description<\/code> - <code>string<\/code> - Optional - Textual description of the workflow type.<\/li><li><code>defaultTaskStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum duration of decision tasks for this workflow type. This default can be overridden when starting a workflow execution using the <code>StartWorkflowExecution<\/code> action or the <code>StartChildWorkflowExecution<\/code> <code>Decision<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><li><code>defaultExecutionStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the default maximum duration for executions of this workflow type. You can override this default when starting an execution through the <code>StartWorkflowExecution<\/code> Action or <code>StartChildWorkflowExecution<\/code> <code>Decision<\/code>. The duration is specified in seconds. The valid values are integers greater than or equal to 0. Unlike some of the other timeout parameters in Amazon SWF, you cannot specify a value of &#8220;NONE&#8221; for <code>defaultExecutionStartToCloseTimeout<\/code>; there is a one-year max limit on the time that a workflow execution can run. Exceeding this limit will always cause the workflow execution to time out.<\/li><li><code>defaultTaskList<\/code> - <code>array<\/code> - Optional - If set, specifies the default task list to use for scheduling decision tasks for executions of this workflow type. This default is used only if a task list is not provided when starting the execution through the <code>StartWorkflowExecution<\/code> Action or <code>StartChildWorkflowExecution<\/code> <code>Decision<\/code>. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>defaultChildPolicy<\/code> - <code>string<\/code> - Optional - If set, specifies the default policy to use for the child workflow executions when a workflow execution of this type is terminated, by calling the <code>TerminateWorkflowExecution<\/code> action explicitly or due to an expired timeout. This default can be overridden when starting a workflow execution using the <code>StartWorkflowExecution<\/code> action or the <code>StartChildWorkflowExecution<\/code> <code>Decision<\/code>. The supported child policies are:<ul><li> <strong>TERMINATE:<\/strong> the child executions will be terminated.<\/li><li> <strong>REQUEST_CANCEL:<\/strong> a request to cancel will be attempted for each child execution by recording a <code>WorkflowExecutionCancelRequested<\/code> event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.<\/li><li> <strong>ABANDON:<\/strong> no action will be taken. The child executions will continue to run.<\/li><\/ul> [Allowed values: <code>TERMINATE<\/code>, <code>REQUEST_CANCEL<\/code>, <code>ABANDON<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function register_workflow_type($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RegisterWorkflowType', $opt);\n}","examples":{"example":{"title":"<p>Workflow Type CRUD.<\/p>","description":"<p>Shows an example of workflow type CRUD methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Register a new workflow type\n\necho '# Registering a new workflow type...' . PHP_EOL;\n$workflow_type = $swf-&gt;register_workflow_type(array(\n\t'domain'             =&gt; $workflow_domain,\n\t'name'               =&gt; $workflow_type_name,\n\t'version'            =&gt; '1.0',\n\t'description'        =&gt; 'A test task to show how this thing works.',\n\t'defaultChildPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'defaultTaskList'    =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Waiting for the workflow type to become ready...' . PHP_EOL;\n\n\tdo {\n\t\tsleep(1);\n\n\t\t$describe = $swf-&gt;describe_workflow_type(array(\n\t\t\t'domain'       =&gt; $workflow_domain,\n\t\t\t'workflowType' =&gt; array(\n\t\t\t\t'name'    =&gt; $workflow_type_name,\n\t\t\t\t'version' =&gt; '1.0'\n\t\t\t)\n\t\t));\n\t}\n\twhile ((string) $describe-&gt;body-&gt;typeInfo-&gt;status !== AmazonSWF::STATUS_REGISTERED);\n\n\techo 'Worktype flow was created successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Workflow type creation failed.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List all registered workflow types\n\necho &quot;# Listing all registered workflow types for the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Anonymous callbacks require PHP 5.3. PHP 5.2 users can create a\n\/\/ named function and pass it to the each() method.\n$swf-&gt;list_workflow_types(array(\n\t'domain' =&gt; $workflow_domain,\n\t'registrationStatus' =&gt; AmazonSWF::STATUS_REGISTERED,\n))\n-&gt;body-&gt;typeInfos()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;status . ': ' .\n\t     (string) $item-&gt;workflowType-&gt;name . ' ' .\n\t     (string) $item-&gt;workflowType-&gt;version . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describing a specific workflow type\n\necho &quot;# Describing the \\&quot;${workflow_type_name}\\&quot; workflow type from the \\&quot;${workflow_domain}\\&quot; domain...&quot; . PHP_EOL;\n\n\/\/ Describe a domain\n$describe = $swf-&gt;describe_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t)\n));\n\nprint_r($describe-&gt;body);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Deprecate a workflow type\n\necho '# Deprecating a workflow type...' . PHP_EOL;\n$deprecate_workflow_type = $swf-&gt;deprecate_workflow_type(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0',\n\t)\n));\n\nif ($domain-&gt;isOK())\n{\n\techo 'Worktype flow was deprecated successfully.' . PHP_EOL;\n}\nelse\n{\n\techo 'Worktype flow deprecation failed.';\n}\n\necho PHP_EOL;"}}},{"name":"request_cancel_workflow_execution","modifier":"public","description":"<p>Records a <code>WorkflowExecutionCancelRequested<\/code> event in the currently running workflow\nexecution identified by the given domain, workflowId, and runId. This logically requests the\ncancellation of the workflow execution as a whole. It is up to the decider to take appropriate\nactions when it receives an execution history with this event.<\/p>\n\n<p class=\"note\">\nIf the runId is not specified, the <code>WorkflowExecutionCancelRequested<\/code> event is\nrecorded in the history of the current open workflow execution with the specified workflowId in\nthe domain.\n<\/p>\n\n<p class=\"note\">\nBecause this action allows the workflow to properly clean up and gracefully close, it should be\nused instead of <code>TerminateWorkflowExecution<\/code> when possible.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow execution to cancel.<\/li><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId of the workflow execution to cancel.<\/li><li><code>runId<\/code> - <code>string<\/code> - Optional - The runId of the workflow execution to cancel.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function request_cancel_workflow_execution($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RequestCancelWorkflowExecution', $opt);\n}","examples":{"example":{"title":"<p>Signal and Cancel a Workflow Execution<\/p>","description":"<p>Shows an example of signaling and canceling a workflow execution.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Signal the workflow with an event and new data\n\necho '# Signaling the workflow with an event and new data...' . PHP_EOL;\n$signal = $swf-&gt;signal_workflow_execution(array(\n\t'domain'     =&gt; $workflow_domain,\n\t'workflowId' =&gt; 'my-workflow-execution',\n\t'runId'      =&gt; $run_id,\n\t'signalName' =&gt; 'my-test-signal',\n\t'input'      =&gt; 'data for my test signal'\n));\n\nif ($signal-&gt;isOK())\n{\n\techo 'Successfully signaled the workflow with an event and new data.' . PHP_EOL;\n}\nelse\n{\n\techo 'Failed to signal the workflow an new event.' . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Cancel a workflow execution\n\necho '# Canceling the workflow execution...' . PHP_EOL;\n$cancel = $swf-&gt;request_cancel_workflow_execution(array(\n\t'domain'     =&gt; $workflow_domain,\n\t'workflowId' =&gt; 'my-workflow-execution',\n\t'runId'      =&gt; $run_id\n));\n\nif ($cancel-&gt;isOK())\n{\n\techo 'Successfully canceled the workflow.' . PHP_EOL;\n}\nelse\n{\n\techo 'Failed to cancel the workflow.' . PHP_EOL;\n}\n\necho PHP_EOL;"}}},{"name":"respond_activity_task_canceled","modifier":"public","description":"<p>Used by workers to tell the service that the <code>ActivityTask<\/code> identified by the\n<code>taskToken<\/code> was successfully canceled. Additional <code>details<\/code> can be\noptionally provided using the <code>details<\/code> argument.<\/p>\n\n<p>These <code>details<\/code> (if provided) appear in the <code>ActivityTaskCanceled<\/code> event\nadded to the workflow history.<\/p>\n\n<p class=\"important\">\nOnly use this operation if the <code>canceled<\/code> flag of a\n<code>RecordActivityTaskHeartbeat<\/code> request returns <code>true<\/code> and if the activity\ncan be safely undone or abandoned.\n<\/p>\n\n<p>A task is considered open from the time that it is scheduled until it is closed. Therefore a\ntask is reported as open while a worker is processing it. A task is closed after it has been\nspecified in a call to <code>RespondActivityTaskCompleted<\/code>, RespondActivityTaskCanceled,\n<code>RespondActivityTaskFailed<\/code>, or the task has <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dg-basic.html#swf-dev-timeout-types\">\ntimed out<\/a>.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>taskToken<\/code> - <code>string<\/code> - Required - The <code>taskToken<\/code> of the <code>ActivityTask<\/code>. <p class=\"important\">The <code>taskToken<\/code> is generated by the service and should be treated as an opaque value. If the task is passed to another process, its <code>taskToken<\/code> must also be passed. This enables it to provide its progress and respond with results.<\/p><\/li><li><code>details<\/code> - <code>string<\/code> - Optional - Optional information about the cancellation.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function respond_activity_task_canceled($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RespondActivityTaskCanceled', $opt);\n}"},{"name":"respond_activity_task_completed","modifier":"public","description":"<p>Used by workers to tell the service that the <code>ActivityTask<\/code> identified by the\n<code>taskToken<\/code> completed successfully with a <code>result<\/code> (if provided). The\n<code>result<\/code> appears in the <code>ActivityTaskCompleted<\/code> event in the workflow\nhistory.<\/p>\n\n<p class=\"important\">\nIf the requested task does not complete successfully, use\n<code>RespondActivityTaskFailed<\/code> instead. If the worker finds that the task is canceled\nthrough the <code>canceled<\/code> flag returned by <code>RecordActivityTaskHeartbeat<\/code>, it\nshould cancel the task, clean up and then call <code>RespondActivityTaskCanceled<\/code>.\n<\/p>\n\n<p>A task is considered open from the time that it is scheduled until it is closed. Therefore a\ntask is reported as open while a worker is processing it. A task is closed after it has been\nspecified in a call to RespondActivityTaskCompleted, <code>RespondActivityTaskCanceled<\/code>,\n<code>RespondActivityTaskFailed<\/code>, or the task has <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dg-basic.html#swf-dev-timeout-types\">\ntimed out<\/a>.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>taskToken<\/code> - <code>string<\/code> - Required - The <code>taskToken<\/code> of the <code>ActivityTask<\/code>. <p class=\"important\">The <code>taskToken<\/code> is generated by the service and should be treated as an opaque value. If the task is passed to another process, its <code>taskToken<\/code> must also be passed. This enables it to provide its progress and respond with results.<\/p><\/li><li><code>result<\/code> - <code>string<\/code> - Optional - The result of the activity task. It is a free form string that is implementation specific.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function respond_activity_task_completed($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RespondActivityTaskCompleted', $opt);\n}"},{"name":"respond_activity_task_failed","modifier":"public","description":"<p>Used by workers to tell the service that the <code>ActivityTask<\/code> identified by the\n<code>taskToken<\/code> has failed with <code>reason<\/code> (if specified). The\n<code>reason<\/code> and <code>details<\/code> appear in the <code>ActivityTaskFailed<\/code>\nevent added to the workflow history.<\/p>\n\n<p>A task is considered open from the time that it is scheduled until it is closed. Therefore a\ntask is reported as open while a worker is processing it. A task is closed after it has been\nspecified in a call to <code>RespondActivityTaskCompleted<\/code>,\n<code>RespondActivityTaskCanceled<\/code>, RespondActivityTaskFailed, or the task has <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dg-basic.html#swf-dev-timeout-types\">\ntimed out<\/a>.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>taskToken<\/code> - <code>string<\/code> - Required - The <code>taskToken<\/code> of the <code>ActivityTask<\/code>. <p class=\"important\">The <code>taskToken<\/code> is generated by the service and should be treated as an opaque value. If the task is passed to another process, its <code>taskToken<\/code> must also be passed. This enables it to provide its progress and respond with results.<\/p><\/li><li><code>reason<\/code> - <code>string<\/code> - Optional - Description of the error that may assist in diagnostics.<\/li><li><code>details<\/code> - <code>string<\/code> - Optional - Optional detailed information about the failure.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function respond_activity_task_failed($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('RespondActivityTaskFailed', $opt);\n}"},{"name":"respond_decision_task_completed","modifier":"public","description":"<p>Used by deciders to tell the service that the <code>DecisionTask<\/code> identified by the\n<code>taskToken<\/code> has successfully completed. The <code>decisions<\/code> argument\nspecifies the list of decisions made while processing the task.<\/p>\n\n<p>A <code>DecisionTaskCompleted<\/code> event is added to the workflow history. The\n<code>executionContext<\/code> specified is attached to the event in the workflow execution\nhistory.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>If an IAM policy grants permission to use <code>RespondDecisionTaskCompleted<\/code>, it can\nexpress permissions for the list of decisions in the <code>decisions<\/code> parameter in the\nsame way as for the regular API. This approach maintains a uniform conceptual model and helps\nkeep policies readable. For more information, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>taskToken<\/code> - <code>string<\/code> - Required - The <code>taskToken<\/code> from the <code>DecisionTask<\/code>. <p class=\"important\">The <code>taskToken<\/code> is generated by the service and should be treated as an opaque value. If the task is passed to another process, its <code>taskToken<\/code> must also be passed. This enables it to provide its progress and respond with results.<\/p><\/li><li><code>decisions<\/code> - <code>array<\/code> - Optional - The list of decisions (possibly empty) made by the decider while processing this decision task. See the docs for the <code>Decision<\/code> structure for details. <ul><li><code>x<\/code> - <code>array<\/code> - Optional - This represents a simple array index. <ul><li><code>decisionType<\/code> - <code>string<\/code> - Required - Specifies the type of the decision. [Allowed values: <code>ScheduleActivityTask<\/code>, <code>RequestCancelActivityTask<\/code>, <code>CompleteWorkflowExecution<\/code>, <code>FailWorkflowExecution<\/code>, <code>CancelWorkflowExecution<\/code>, <code>ContinueAsNewWorkflowExecution<\/code>, <code>RecordMarker<\/code>, <code>StartTimer<\/code>, <code>CancelTimer<\/code>, <code>SignalExternalWorkflowExecution<\/code>, <code>RequestCancelExternalWorkflowExecution<\/code>, <code>StartChildWorkflowExecution<\/code>]<\/li><li><code>scheduleActivityTaskDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>ScheduleActivityTask<\/code> decision. It is not set for other decision types. <ul><li><code>activityType<\/code> - <code>array<\/code> - Required - The type of the activity task to schedule. This field is required. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of this activity. <p class=\"note\">The combination of activity type name and version must be unique within a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of this activity. <p class=\"note\">The combination of activity type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>activityId<\/code> - <code>string<\/code> - Required - The <code>activityId<\/code> of the activity task. This field is required. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>control<\/code> - <code>string<\/code> - Optional - Optional data attached to the event that can be used by the decider in subsequent workflow tasks. This data is not sent to the activity.<\/li><li><code>input<\/code> - <code>string<\/code> - Optional - The input provided to the activity task.<\/li><li><code>scheduleToCloseTimeout<\/code> - <code>string<\/code> - Optional - The maximum duration for this activity task. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A schedule-to-close timeout for this activity task must be specified either as a default for the activity type or through this field. If neither this field is set nor a default schedule-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>taskList<\/code> - <code>array<\/code> - Optional - If set, specifies the name of the task list in which to schedule the activity task. If not specified, the <code>defaultTaskList<\/code> registered with the activity type will be used. <p class=\"note\">A task list for this activity task must be specified either as a default for the activity type or through this field. If neither this field is set nor a default task list was specified at registration time then a fault will be returned.<\/p> The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>scheduleToStartTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the maximum duration the activity task can wait to be assigned to a worker. This overrides the default schedule-to-start timeout specified when registering the activity type using <code>RegisterActivityType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A schedule-to-start timeout for this activity task must be specified either as a default for the activity type or through this field. If neither this field is set nor a default schedule-to-start timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>startToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the maximum duration a worker may take to process this activity task. This overrides the default start-to-close timeout specified when registering the activity type using <code>RegisterActivityType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A start-to-close timeout for this activity task must be specified either as a default for the activity type or through this field. If neither this field is set nor a default start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>heartbeatTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the maximum time before which a worker processing a task of this type must report progress by calling <code>RecordActivityTaskHeartbeat<\/code>. If the timeout is exceeded, the activity task is automatically timed out. If the worker subsequently attempts to record a heartbeat or returns a result, it will be ignored. This overrides the default heartbeat timeout specified when registering the activity type using <code>RegisterActivityType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration.<\/li><\/ul><\/li><li><code>requestCancelActivityTaskDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>RequestCancelActivityTask<\/code> decision. It is not set for other decision types. <ul><li><code>activityId<\/code> - <code>string<\/code> - Required - The <code>activityId<\/code> of the activity task to be canceled.<\/li><\/ul><\/li><li><code>completeWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>CompleteWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>result<\/code> - <code>string<\/code> - Optional - The result of the workflow execution. The form of the result is implementation defined.<\/li><\/ul><\/li><li><code>failWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>FailWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>reason<\/code> - <code>string<\/code> - Optional - A descriptive reason for the failure that may help in diagnostics.<\/li><li><code>details<\/code> - <code>string<\/code> - Optional - Optional details of the failure.<\/li><\/ul><\/li><li><code>cancelWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>CancelWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>details<\/code> - <code>string<\/code> - Optional - Optional details of the cancellation.<\/li><\/ul><\/li><li><code>continueAsNewWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>ContinueAsNewWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>input<\/code> - <code>string<\/code> - Optional - The input provided to the new workflow execution.<\/li><li><code>executionStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - If set, specifies the total duration for this workflow execution. This overrides the <code>defaultExecutionStartToCloseTimeout<\/code> specified when registering the workflow type. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">An execution start-to-close timeout for this workflow execution must be specified either as a default for the workflow type or through this field. If neither this field is set nor a default execution start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>taskList<\/code> - <code>array<\/code> - Optional - Represents a task list. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>taskStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - Specifies the maximum duration of decision tasks for the new workflow execution. This parameter overrides the <code>defaultTaskStartToCloseTimout<\/code> specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A task start-to-close timeout for the new workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default task start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>childPolicy<\/code> - <code>string<\/code> - Optional - If set, specifies the policy to use for the child workflow executions of the new execution if it is terminated by calling the <code>TerminateWorkflowExecution<\/code> action explicitly or due to an expired timeout. This policy overrides the default child policy specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The supported child policies are:<ul><li> <strong>TERMINATE:<\/strong> the child executions will be terminated.<\/li><li> <strong>REQUEST_CANCEL:<\/strong> a request to cancel will be attempted for each child execution by recording a <code>WorkflowExecutionCancelRequested<\/code> event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.<\/li><li> <strong>ABANDON:<\/strong> no action will be taken. The child executions will continue to run.<\/li><\/ul> <p class=\"note\">A child policy for the new workflow execution must be specified either as a default registered for its workflow type or through this field. If neither this field is set nor a default child policy was specified at registration time then a fault will be returned.<\/p> [Allowed values: <code>TERMINATE<\/code>, <code>REQUEST_CANCEL<\/code>, <code>ABANDON<\/code>]<\/li><li><code>tagList<\/code> - <code>string|array<\/code> - Optional - The list of tags to associate with the new workflow execution. A maximum of 5 tags can be specified. You can list workflow executions with a specific tag by calling <code>ListOpenWorkflowExecutions<\/code> or <code>ListClosedWorkflowExecutions<\/code> and specifying a <code>TagFilter<\/code>. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>workflowTypeVersion<\/code> - <code>string<\/code> - Optional - <\/li><\/ul><\/li><li><code>recordMarkerDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>RecordMarker<\/code> decision. It is not set for other decision types. <ul><li><code>markerName<\/code> - <code>string<\/code> - Required - The name of the marker. This file is required.<\/li><li><code>details<\/code> - <code>string<\/code> - Optional - Optional details of the marker.<\/li><\/ul><\/li><li><code>startTimerDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>StartTimer<\/code> decision. It is not set for other decision types. <ul><li><code>timerId<\/code> - <code>string<\/code> - Required - The unique Id of the timer. This field is required. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>control<\/code> - <code>string<\/code> - Optional - Optional data attached to the event that can be used by the decider in subsequent workflow tasks.<\/li><li><code>startToFireTimeout<\/code> - <code>string<\/code> - Required - The duration to wait before firing the timer. This field is required. The duration is specified in seconds. The valid values are integers greater than or equal to 0.<\/li><\/ul><\/li><li><code>cancelTimerDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>CancelTimer<\/code> decision. It is not set for other decision types. <ul><li><code>timerId<\/code> - <code>string<\/code> - Required - The unique Id of the timer to cancel. This field is required.<\/li><\/ul><\/li><li><code>signalExternalWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>SignalExternalWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The <code>workflowId<\/code> of the workflow execution to be signaled. This field is required.<\/li><li><code>runId<\/code> - <code>string<\/code> - Optional - The <code>runId<\/code> of the workflow execution to be signaled.<\/li><li><code>signalName<\/code> - <code>string<\/code> - Required - The name of the signal.The target workflow execution will use the signal name and input to process the signal. This field is required.<\/li><li><code>input<\/code> - <code>string<\/code> - Optional - Optional input to be provided with the signal.The target workflow execution will use the signal name and input to process the signal.<\/li><li><code>control<\/code> - <code>string<\/code> - Optional - Optional data attached to the event that can be used by the decider in subsequent decision tasks.<\/li><\/ul><\/li><li><code>requestCancelExternalWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>RequestCancelExternalWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>workflowId<\/code> - <code>string<\/code> - Required - The <code>workflowId<\/code> of the external workflow execution to cancel. This field is required.<\/li><li><code>runId<\/code> - <code>string<\/code> - Optional - The <code>runId<\/code> of the external workflow execution to cancel.<\/li><li><code>control<\/code> - <code>string<\/code> - Optional - Optional data attached to the event that can be used by the decider in subsequent workflow tasks.<\/li><\/ul><\/li><li><code>startChildWorkflowExecutionDecisionAttributes<\/code> - <code>array<\/code> - Optional - Provides details of the <code>StartChildWorkflowExecution<\/code> decision. It is not set for other decision types. <ul><li><code>workflowType<\/code> - <code>array<\/code> - Required - The type of the workflow execution to be started. This field is required. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>workflowId<\/code> - <code>string<\/code> - Required - The <code>workflowId<\/code> of the workflow execution. This field is required. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>control<\/code> - <code>string<\/code> - Optional - Optional data attached to the event that can be used by the decider in subsequent workflow tasks. This data is not sent to the child workflow execution.<\/li><li><code>input<\/code> - <code>string<\/code> - Optional - The input to be provided to the workflow execution.<\/li><li><code>executionStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - The total duration for this workflow execution. This overrides the defaultExecutionStartToCloseTimeout specified when registering the workflow type. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">An execution start-to-close timeout for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default execution start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>taskList<\/code> - <code>array<\/code> - Optional - The name of the task list to be used for decision tasks of the child workflow execution. <p class=\"note\">A task list for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default task list was specified at registration time then a fault will be returned.<\/p> The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>taskStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - Specifies the maximum duration of decision tasks for this workflow execution. This parameter overrides the <code>defaultTaskStartToCloseTimout<\/code> specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A task start-to-close timeout for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default task start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>childPolicy<\/code> - <code>string<\/code> - Optional - If set, specifies the policy to use for the child workflow executions if the workflow execution being started is terminated by calling the <code>TerminateWorkflowExecution<\/code> action explicitly or due to an expired timeout. This policy overrides the default child policy specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The supported child policies are:<ul><li> <strong>TERMINATE:<\/strong> the child executions will be terminated.<\/li><li> <strong>REQUEST_CANCEL:<\/strong> a request to cancel will be attempted for each child execution by recording a <code>WorkflowExecutionCancelRequested<\/code> event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.<\/li><li> <strong>ABANDON:<\/strong> no action will be taken. The child executions will continue to run.<\/li><\/ul> <p class=\"note\">A child policy for the workflow execution being started must be specified either as a default registered for its workflow type or through this field. If neither this field is set nor a default child policy was specified at registration time then a fault will be returned.<\/p> [Allowed values: <code>TERMINATE<\/code>, <code>REQUEST_CANCEL<\/code>, <code>ABANDON<\/code>]<\/li><li><code>tagList<\/code> - <code>string|array<\/code> - Optional - The list of tags to associate with the child workflow execution. A maximum of 5 tags can be specified. You can list workflow executions with a specific tag by calling <code>ListOpenWorkflowExecutions<\/code> or <code>ListClosedWorkflowExecutions<\/code> and specifying a <code>TagFilter<\/code>. Pass a string for a single value, or an indexed array for multiple values.<\/li><\/ul><\/li><\/ul><\/li><\/ul><\/li><li><code>executionContext<\/code> - <code>string<\/code> - Optional - User defined context to add to workflow execution.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function respond_decision_task_completed($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['decisions']))\n    {\n        $opt['decisions'] = (is_array($opt['decisions']) ? $opt['decisions'] : array($opt['decisions']));\n    }\n\n    return $this-&gt;authenticate('RespondDecisionTaskCompleted', $opt);\n}"},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazonswf\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazonswf\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"signal_workflow_execution","modifier":"public","description":"<p>Records a <code>WorkflowExecutionSignaled<\/code> event in the workflow execution history and\ncreates a decision task for the workflow execution identified by the given domain, workflowId\nand runId. The event is recorded with the specified user defined signalName and input (if\nprovided).<\/p>\n\n<p class=\"note\">\nIf a runId is not specified, then the <code>WorkflowExecutionSignaled<\/code> event is recorded\nin the history of the current open workflow with the matching workflowId in the domain.\n<\/p>\n\n<p class=\"note\">\nIf the specified workflow execution is not open, this method fails with\n<code>UnknownResource<\/code>.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain containing the workflow execution to signal.<\/li><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId of the workflow execution to signal.<\/li><li><code>runId<\/code> - <code>string<\/code> - Optional - The runId of the workflow execution to signal.<\/li><li><code>signalName<\/code> - <code>string<\/code> - Required - The name of the signal. This name must be meaningful to the target workflow.<\/li><li><code>input<\/code> - <code>string<\/code> - Optional - Data to attach to the <code>WorkflowExecutionSignaled<\/code> event in the target workflow execution&#8217;s history.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function signal_workflow_execution($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('SignalWorkflowExecution', $opt);\n}","examples":{"example":{"title":"<p>Signal and Cancel a Workflow Execution<\/p>","description":"<p>Shows an example of signaling and canceling a workflow execution.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Signal the workflow with an event and new data\n\necho '# Signaling the workflow with an event and new data...' . PHP_EOL;\n$signal = $swf-&gt;signal_workflow_execution(array(\n\t'domain'     =&gt; $workflow_domain,\n\t'workflowId' =&gt; 'my-workflow-execution',\n\t'runId'      =&gt; $run_id,\n\t'signalName' =&gt; 'my-test-signal',\n\t'input'      =&gt; 'data for my test signal'\n));\n\nif ($signal-&gt;isOK())\n{\n\techo 'Successfully signaled the workflow with an event and new data.' . PHP_EOL;\n}\nelse\n{\n\techo 'Failed to signal the workflow an new event.' . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Cancel a workflow execution\n\necho '# Canceling the workflow execution...' . PHP_EOL;\n$cancel = $swf-&gt;request_cancel_workflow_execution(array(\n\t'domain'     =&gt; $workflow_domain,\n\t'workflowId' =&gt; 'my-workflow-execution',\n\t'runId'      =&gt; $run_id\n));\n\nif ($cancel-&gt;isOK())\n{\n\techo 'Successfully canceled the workflow.' . PHP_EOL;\n}\nelse\n{\n\techo 'Failed to cancel the workflow.' . PHP_EOL;\n}\n\necho PHP_EOL;"}}},{"name":"start_workflow_execution","modifier":"public","description":"<p>Starts an execution of the workflow type in the specified domain using the provided\n<code>workflowId<\/code> and input data.<\/p>\n\n<p>This action returns the newly started workflow execution.<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>Constrain the following parameters by using a <code>Condition<\/code> element with the\nappropriate keys.\n<ul><li><code>tagList.member.0<\/code>: The key is <code>swf:tagList.member.0<\/code>.<\/li><li><code>tagList.member.1<\/code>: The key is <code>swf:tagList.member.1<\/code>.<\/li><li><code>tagList.member.2<\/code>: The key is <code>swf:tagList.member.2<\/code>.<\/li><li><code>tagList.member.3<\/code>: The key is <code>swf:tagList.member.3<\/code>.<\/li><li><code>tagList.member.4<\/code>: The key is <code>swf:tagList.member.4<\/code>.<\/li><li><code>taskList<\/code>: String constraint. The key is\n<code>swf:taskList.name<\/code>.<\/li><li><code>name<\/code>: String constraint. The key is\n<code>swf:workflowType.name<\/code>.<\/li><li><code>version<\/code>: String constraint. The key is\n<code>swf:workflowType.version<\/code>.<\/li><\/ul><\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The name of the domain in which the workflow execution is created.<\/li><li><code>workflowId<\/code> - <code>string<\/code> - Required - The user defined identifier associated with the workflow execution. You can use this to associate a custom identifier with the workflow execution. You may specify the same identifier if a workflow execution is logically a <em>restart<\/em> of a previous execution. You cannot have two open workflow executions with the same <code>workflowId<\/code> at the same time. The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;.<\/li><li><code>workflowType<\/code> - <code>array<\/code> - Required - The type of the workflow to start. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><li><code>version<\/code> - <code>string<\/code> - Required - The version of the workflow type. This field is required. <p class=\"note\">The combination of workflow type name and version must be unique with in a domain.<\/p><\/li><\/ul><\/li><li><code>taskList<\/code> - <code>array<\/code> - Optional - The task list to use for the decision tasks generated for this workflow execution. This overrides the <code>defaultTaskList<\/code> specified when registering the workflow type. <p class=\"note\">A task list for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default task list was specified at registration time then a fault will be returned.<\/p> The specified string must not start or end with whitespace. It must not contain a <code>:<\/code> (colon), <code>\/<\/code> (slash), <code>|<\/code> (vertical bar), or any control characters (\\u0000-\\u001f | \\u007f - \\u009f). Also, it must not contain the literal string &#8220;arn&#8221;. <ul><li><code>name<\/code> - <code>string<\/code> - Required - The name of the task list.<\/li><\/ul><\/li><li><code>input<\/code> - <code>string<\/code> - Optional - The input for the workflow execution. This is a free form string which should be meaningful to the workflow you are starting. This <code>input<\/code> is made available to the new workflow execution in the <code>WorkflowExecutionStarted<\/code> history event.<\/li><li><code>executionStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - The total duration for this workflow execution. This overrides the defaultExecutionStartToCloseTimeout specified when registering the workflow type. The duration is specified in seconds. The valid values are integers greater than or equal to 0. Exceeding this limit will cause the workflow execution to time out. Unlike some of the other timeout parameters in Amazon SWF, you cannot specify a value of &#8220;NONE&#8221; for this timeout; there is a one-year max limit on the time that a workflow execution can run. <p class=\"note\">An execution start-to-close timeout must be specified either through this parameter or as a default when the workflow type is registered. If neither this parameter nor a default execution start-to-close timeout is specified, a fault is returned.<\/p><\/li><li><code>tagList<\/code> - <code>string|array<\/code> - Optional - The list of tags to associate with the workflow execution. You can specify a maximum of 5 tags. You can list workflow executions with a specific tag by calling <code>ListOpenWorkflowExecutions<\/code> or <code>ListClosedWorkflowExecutions<\/code> and specifying a <code>TagFilter<\/code>. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>taskStartToCloseTimeout<\/code> - <code>string<\/code> - Optional - Specifies the maximum duration of decision tasks for this workflow execution. This parameter overrides the <code>defaultTaskStartToCloseTimout<\/code> specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The valid values are integers greater than or equal to <code>0<\/code>. An integer value can be used to specify the duration in seconds while <code>NONE<\/code> can be used to specify unlimited duration. <p class=\"note\">A task start-to-close timeout for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default task start-to-close timeout was specified at registration time then a fault will be returned.<\/p><\/li><li><code>childPolicy<\/code> - <code>string<\/code> - Optional - If set, specifies the policy to use for the child workflow executions of this workflow execution if it is terminated, by calling the <code>TerminateWorkflowExecution<\/code> action explicitly or due to an expired timeout. This policy overrides the default child policy specified when registering the workflow type using <code>RegisterWorkflowType<\/code>. The supported child policies are:<ul><li> <strong>TERMINATE:<\/strong> the child executions will be terminated.<\/li><li> <strong>REQUEST_CANCEL:<\/strong> a request to cancel will be attempted for each child execution by recording a <code>WorkflowExecutionCancelRequested<\/code> event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.<\/li><li> <strong>ABANDON:<\/strong> no action will be taken. The child executions will continue to run.<\/li><\/ul> <p class=\"note\">A child policy for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default child policy was specified at registration time then a fault will be returned.<\/p> [Allowed values: <code>TERMINATE<\/code>, <code>REQUEST_CANCEL<\/code>, <code>ABANDON<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function start_workflow_execution($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['tagList']))\n    {\n        $opt['tagList'] = (is_array($opt['tagList']) ? $opt['tagList'] : array($opt['tagList']));\n    }\n\n    return $this-&gt;authenticate('StartWorkflowExecution', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}},{"name":"terminate_workflow_execution","modifier":"public","description":"<p>Records a <code>WorkflowExecutionTerminated<\/code> event and forces closure of the workflow\nexecution identified by the given domain, runId, and workflowId. The child policy, registered\nwith the workflow type or specified when starting this execution, is applied to any open child\nworkflow executions of this workflow execution.<\/p>\n\n<p class=\"important\">\nIf the identified workflow execution was in progress, it is terminated immediately.\n<\/p>\n\n<p class=\"note\">\nIf a runId is not specified, then the <code>WorkflowExecutionTerminated<\/code> event is\nrecorded in the history of the current open workflow with the matching workflowId in the\ndomain.\n<\/p>\n\n<p class=\"note\">\nYou should consider using <code>RequestCancelWorkflowExecution<\/code> action instead because it\nallows the workflow to gracefully close while <code>TerminateWorkflowExecution<\/code> does not.\n<\/p>\n\n<p><strong>Access Control<\/strong><\/p>\n\n<p>You can use IAM policies to control this action&#8217;s access to Amazon SWF resources as follows:<\/p>\n\n<ul><li>Use a <code>Resource<\/code> element with the domain name to limit the action to only\nspecified domains.<\/li><li>Use an <code>Action<\/code> element to allow or deny permission to call this action.<\/li><li>You cannot use an IAM policy to constrain this action&#8217;s parameters.<\/li><\/ul>\n\n<p>If the caller does not have sufficient permissions to invoke the action, or the parameter\nvalues fall outside the specified constraints, the action fails by throwing\n<code>OperationNotPermitted<\/code>. For details and example IAM policies, see <a href=\n\"http:\/\/docs.aws.amazon.com\/amazonswf\/latest\/developerguide\/swf-dev-iam.html\">Using IAM to\nManage Access to Amazon SWF Workflows<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>domain<\/code> - <code>string<\/code> - Required - The domain of the workflow execution to terminate.<\/li><li><code>workflowId<\/code> - <code>string<\/code> - Required - The workflowId of the workflow execution to terminate.<\/li><li><code>runId<\/code> - <code>string<\/code> - Optional - The runId of the workflow execution to terminate.<\/li><li><code>reason<\/code> - <code>string<\/code> - Optional - An optional descriptive reason for terminating the workflow execution.<\/li><li><code>details<\/code> - <code>string<\/code> - Optional - Optional details for terminating the workflow execution.<\/li><li><code>childPolicy<\/code> - <code>string<\/code> - Optional - If set, specifies the policy to use for the child workflow executions of the workflow execution being terminated. This policy overrides the child policy specified for the workflow execution at registration time or when starting the execution. The supported child policies are:<ul><li> <strong>TERMINATE:<\/strong> the child executions will be terminated.<\/li><li> <strong>REQUEST_CANCEL:<\/strong> a request to cancel will be attempted for each child execution by recording a <code>WorkflowExecutionCancelRequested<\/code> event in its history. It is up to the decider to take appropriate actions when it receives an execution history with this event.<\/li><li> <strong>ABANDON:<\/strong> no action will be taken. The child executions will continue to run.<\/li><\/ul> <p class=\"note\">A child policy for this workflow execution must be specified either as a default for the workflow type or through this parameter. If neither this parameter is set nor a default child policy was specified at registration time, a fault will be returned.<\/p> [Allowed values: <code>TERMINATE<\/code>, <code>REQUEST_CANCEL<\/code>, <code>ABANDON<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function terminate_workflow_execution($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('TerminateWorkflowExecution', $opt);\n}","examples":{"example":{"title":"<p>Workflow Execution<\/p>","description":"<p>Shows an example of workflow execution methods.<\/p>\n\n<p>This sample uses anonymous functions, which are only available in PHP 5.3+. For PHP 5.2 users, you must used <em>named<\/em> functions instead of <em>anonymous<\/em> ones.<\/p>","code":"$swf = new AmazonSWF();\n\n\/\/ Setup\n$timestamp = time();\n$workflow_domain = 'my-domain' . $timestamp;\n$workflow_type_name = 'my-workflow-type';\n$activity_type_name = 'my-activity-type';\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Start a workflow execution\n\necho '# Starting a new workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;start_workflow_execution(array(\n\t'domain'       =&gt; $workflow_domain,\n\t'workflowId'   =&gt; 'my-workflow-execution',\n\t'workflowType' =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'taskList'     =&gt; array(\n\t\t'name' =&gt; 'my-task-list'\n\t),\n\t'tagList'      =&gt; array('tag1', 'tag2'),\n\t'childPolicy'  =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'taskStartToCloseTimeout'      =&gt; '30',\n\t'executionStartToCloseTimeout' =&gt; '30',\n));\n\n\/\/ Grab the Run ID\n$run_id = (string) $workflow-&gt;body-&gt;runId;\necho 'Workflow Run ID: ';\necho $run_id . PHP_EOL;\n\nif ($workflow-&gt;isOK())\n{\n\techo 'The workflow execution has started...' . PHP_EOL;\n}\nelse\n{\n\techo 'The workflow execution has failed to start.';\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List open workflow executions\n\necho '# List of open executions...' . PHP_EOL;\n$list_open_exec = $swf-&gt;list_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_open_exec instanceof Countable)\n{\n\t$list_open_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_open_exec-&gt;executionInfos))\n{\n\techo (string) $list_open_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ List closed workflow executions\n\necho '# List of closed executions...' . PHP_EOL;\n$list_closed_exec = $swf-&gt;list_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n))\n-&gt;body-&gt;executionInfos();\n\nif ($list_closed_exec instanceof Countable)\n{\n\t$list_closed_exec-&gt;each(function($item)\n\t{\n\t\techo (string) $item-&gt;execution-&gt;workflowId . PHP_EOL;\n\t});\n}\nelseif (isset($list_closed_exec-&gt;executionInfos))\n{\n\techo (string) $list_closed_exec-&gt;executionInfos-&gt;execution-&gt;workflowId . PHP_EOL;\n}\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count open workflow executions\n\necho 'Count of open executions: ';\n$count_open_exec = $swf-&gt;count_open_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Count closed workflow executions\n\necho 'Count of closed executions: ';\n$count_closed_exec = $swf-&gt;count_closed_workflow_executions(array(\n\t'domain'          =&gt; $workflow_domain,\n\t'typeFilter'      =&gt; array(\n\t\t'name'    =&gt; $workflow_type_name,\n\t\t'version' =&gt; '1.0'\n\t),\n\t'startTimeFilter' =&gt; array(\n\t\t'oldestDate' =&gt; strtotime('yesterday, midnight')\n\t)\n));\n\necho (string) $count_open_exec-&gt;body-&gt;count . PHP_EOL;\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Describe a workflow execution\n\necho '# Describing an execution\\'s tags...' . PHP_EOL;\n$describe = $swf-&gt;describe_workflow_execution(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n));\n\n$tags = $describe-&gt;body-&gt;executionInfo-&gt;tagList-&gt;to_array()-&gt;getArrayCopy();\nprint_r($tags['tagList']);\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Get a workflow execution\n\n$history_events = array();\necho '# Getting the timestamps of all of the events...' . PHP_EOL;\n$swf-&gt;get_workflow_execution_history(array(\n\t'domain'    =&gt; $workflow_domain,\n\t'execution' =&gt; array(\n\t\t'workflowId' =&gt; 'my-workflow-execution',\n\t\t'runId'      =&gt; $run_id,\n\t)\n))\n-&gt;body-&gt;events()-&gt;each(function($item)\n{\n\techo (string) $item-&gt;eventType . PHP_EOL;\n});\n\necho PHP_EOL;\n\n\/\/-----------------------------------------------------------------\/\/\n\/\/ Terminate a workflow execution\n\necho '# Terminating a workflow execution...' . PHP_EOL;\n$workflow = $swf-&gt;terminate_workflow_execution(array(\n\t'domain'      =&gt; $workflow_domain,\n\t'workflowId'  =&gt; 'my-workflow-execution',\n\t'runId'       =&gt; $run_id,\n\t'childPolicy' =&gt; AmazonSWF::POLICY_TERMINATE,\n\t'reason'      =&gt; 'We\\'re done with this workflow now.',\n\t'details'     =&gt; 'No really, we\\'re done.',\n));"}}}]},"constants":{"@attributes":{"count":"12"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"swf.us-east-1.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"POLICY_ABANDON","value":"ABANDON"},{"name":"POLICY_REQUEST_CANCEL","value":"REQUEST_CANCEL"},{"name":"POLICY_TERMINATE","value":"TERMINATE"},{"name":"REGION_US_E1","value":"swf.us-east-1.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"swf.us-east-1.amazonaws.com"},{"name":"STATUS_DEPRECATED","value":"DEPRECATED"},{"name":"STATUS_REGISTERED","value":"REGISTERED"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazonswf\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonswf\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}