{"file":{},"class":{"name":"AmazonStorageGateway","file":"services\/storagegateway.class.php","url":"..\/amazonstoragegateway\/index.html","description":"<p>AWS Storage Gateway is a service that connects an on-premises software appliance with\ncloud-based storage to provide seamless and secure integration between an organization&#8217;s\non-premises IT environment and AWS&#8217;s storage infrastructure. The service enables you to\nsecurely upload data to the AWS cloud for cost effective backup and rapid disaster recovery.<\/p>\n\n<p>Use the following links to get started using the <em>AWS Storage Gateway Service API\nReference<\/em>:<\/p>\n\n<ul><li><a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/AWSStorageGatewayHTTPRequestsHeaders.html\">\nAWS Storage Gateway Required Request Headers<\/a>: Describes the required headers that you\nmust send with every POST request to AWS Storage Gateway.<\/li><li><a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/AWSStorageGatewaySigningRequests.html\">\nSigning Requests<\/a>: AWS Storage Gateway requires that you authenticate every request you\nsend; this topic describes how sign such a request.<\/li><li><a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/APIErrorResponses.html\">Error\nResponses<\/a>: Provides reference information about AWS Storage Gateway errors.<\/li><li><a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/AWSStorageGatewayAPIOperations.html\">\nOperations in AWS Storage Gateway<\/a>: Contains detailed descriptions of all AWS Storage\nGateway operations, their request parameters, response elements, possible errors, and\nexamples of requests and responses.<\/li><li><a href=\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/index.html?rande.html\">AWS\nStorage Gateway Regions and Endpoints<\/a>: Provides a list of each of the regions and\nendpoints available for use with AWS Storage Gateway.<\/li><\/ul>","metadata":{"version":"2013.01.14","license":"See the included NOTICE.md file for complete information.","copyright":"See the included NOTICE.md file for complete information.","link":["http:\/\/aws.amazon.com\/storagegateway\/ AWS Storage Gateway","http:\/\/aws.amazon.com\/storagegateway\/documentation\/ AWS Storage Gateway documentation"]},"inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}},"methods":{"@attributes":{"count":"66"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of <a href=\"..\/amazonstoragegateway\/index.html\" rel=\"..\/..\/index.html#i=amazonstoragegateway\"><code>AmazonStorageGateway<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonstoragegateway\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;api_version = '2012-06-30';\n    $this-&gt;hostname = self::DEFAULT_URL;\n    $this-&gt;auth_class = 'AuthV4JSON';\n    $this-&gt;operation_prefix = &quot;x-amz-target:StorageGateway_20120630.&quot;;\n\n    parent::__construct($options);\n}"},{"name":"acquire_activation_code","modifier":"public","description":"<p>Fetches the activation code for a gateway using its public URL.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"gateway_url","type":"string","description":"<p>The public URL to a gateway.<\/p>"}},"returnvalue":"<p>The activation key for the gateway, or false if it could not be determined.<\/p>","source":"public function acquire_activation_code($gateway_url)\n{\n    \/\/ Send a request to the gateway's URL\n    $request = new RequestCore($gateway_url);\n    $request-&gt;ssl_verification = false;\n    $request-&gt;set_curlopts(array(CURLOPT_FOLLOWLOCATION =&gt; false));\n    $response = $request-&gt;send_request(true);\n\n    \/\/ Parse the query string from the URL in the location header to get the activation key\n    if (isset($response-&gt;header['location']))\n    {\n        $url = $response-&gt;header['location'];\n        $query = parse_url($url, PHP_URL_QUERY);\n        parse_str($query, $params);\n\n        if (isset($params['activationKey']))\n        {\n            return $params['activationKey'];\n        }\n    }\n\n    return false;\n}"},{"name":"activate_gateway","modifier":"public","description":"<p>This operation activates the gateway you previously deployed on your VMware host. For more\ninformation, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/DownloadAndDeploy.html\">Downloading\nand Deploying AWS Storage Gateway VM<\/a>. In the activation process you specify information\nsuch as the region you want to use for storing snapshots, the time zone for scheduled snapshots\nand the gateway schedule window, an activation key, and a name for your gateway. The activation\nprocess also associates your gateway with your account (see\n<code>UpdateGatewayInformation<\/code>).<\/p>\n\n<p class=\"note\">\nYou must power on the gateway VM before you can activate your gateway.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ActivationKey<\/code> - <code>string<\/code> - Required - Your gateway activation key. You can obtain the activation key by sending an HTTP GET request with redirects enabled to the gateway IP address (port 80). The redirect URL returned in the response provides you the activation key for your gateway in the query string parameter <code>activationKey<\/code>. It may also include other activation-related parameters, however, these are merely defaults &#8212; the arguments you pass to the <code>ActivateGateway<\/code> API call determine the actual configuration of your gateway.<\/li><li><code>GatewayName<\/code> - <code>string<\/code> - Required - A unique identifier for your gateway. This name becomes part of the gateway Amazon Resources Name (ARN) which is what you use as an input to other operations. [Constraints: The value must be between 2 and 255 characters, and must match the following regular expression pattern: <code>^[ -\\.0-\\[\\]-~]*[!-\\.0-\\[\\]-~][ -\\.0-\\[\\]-~]*$<\/code>]<\/li><li><code>GatewayTimezone<\/code> - <code>string<\/code> - Required - One of the values that indicates the time zone you want to set for the gateway. The time zone is used, for example, for scheduling snapshots and your gateway&#8217;s maintenance schedule. [Allowed values: <code>GMT-12:00<\/code>, <code>GMT-11:00<\/code>, <code>GMT-10:00<\/code>, <code>GMT-9:00<\/code>, <code>GMT-8:00<\/code>, <code>GMT-7:00<\/code>, <code>GMT-6:00<\/code>, <code>GMT-5:00<\/code>, <code>GMT-4:00<\/code>, <code>GMT-3:30<\/code>, <code>GMT-3:00<\/code>, <code>GMT-2:00<\/code>, <code>GMT-1:00<\/code>, <code>GMT<\/code>, <code>GMT+1:00<\/code>, <code>GMT+2:00<\/code>, <code>GMT+3:00<\/code>, <code>GMT+3:30<\/code>, <code>GMT+4:00<\/code>, <code>GMT+4:30<\/code>, <code>GMT+5:00<\/code>, <code>GMT+5:30<\/code>, <code>GMT+5:45<\/code>, <code>GMT+6:00<\/code>, <code>GMT+7:00<\/code>, <code>GMT+8:00<\/code>, <code>GMT+9:00<\/code>, <code>GMT+9:30<\/code>, <code>GMT+10:00<\/code>, <code>GMT+11:00<\/code>, <code>GMT+12:00<\/code>]<\/li><li><code>GatewayRegion<\/code> - <code>string<\/code> - Required - One of the values that indicates the region where you want to store the snapshot backups. The gateway region specified must be the same region as the region in your <code>Host<\/code> header in the request. For more information about available regions and endpoints for AWS Storage Gateway, see <a href=\"http:\/\/docs.amazonwebservices.com\/general\/latest\/gr\/rande.html#sg_region\">Regions and Endpoints<\/a> in the <strong>Amazon Web Services Glossary<\/strong>. <em>Valid Values<\/em>: &#8220;us-east-1&#8221;, &#8220;us-west-1&#8221;, &#8220;us-west-2&#8221;, &#8220;eu-west-1&#8221;, &#8220;ap-northeast-1&#8221;, &#8220;ap-southest-1&#8221;, &#8220;sa-east-1&#8221;<\/li><li><code>GatewayType<\/code> - <code>string<\/code> - Optional - One of the values that defines the type of gateway to activate. The type specified is critical to all later functions of the gateway and cannot be changed after activation. The default value is <code>STORED<\/code>. [Allowed values: <code>STORED<\/code>, <code>CACHED<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function activate_gateway($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ActivateGateway', $opt);\n}","examples":{"example":{"title":"<p>Activate a Storage Gateway<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Acquire activation key\n$activation_key = $sg-&gt;acquire_activation_code($gateway_url);\nvar_dump($activation_key);\nif (!$activation_key) die('Activation key could not be retrieved.');\n\n\/\/ Activate the gateway\n$response = $sg-&gt;activate_gateway(array(\n\t'ActivationKey'   =&gt; $activation_key,\n\t'GatewayName'     =&gt; 'example-gateway',\n\t'GatewayTimezone' =&gt; 'GMT-8:00',\n\t'GatewayRegion'   =&gt; 'us-east-1',\n));\nvar_dump($response-&gt;isOK());\n\n$gateway_arn = (string) $response-&gt;body-&gt;GatewayARN;\n\n\/\/ Update gateway information\n$response = $sg-&gt;update_gateway_information(array(\n\t'GatewayARN'      =&gt; $gateway_arn,\n\t'GatewayTimezone' =&gt; 'GMT-7:00',\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"add_cache","modifier":"public","description":"<p>This operation configures one or more gateway local disks as cache for a cached-volume gateway.\nThis operation is supported only for the gateway-cached volume architecture (see <a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/StorageGatewayConcepts.html\">\nStorage Gateway Concepts<\/a>).<\/p>\n\n<p>In the request, you specify the gateway Amazon Resource Name (ARN) to which you want to add\ncache, and one or more disk IDs that you want to configure as cache.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the ListGateways operation to return a list of gateways for your account and region.<\/li><li><code>DiskIds<\/code> - <code>string|array<\/code> - Required - An array of strings that identify disks that are to be configured as cache. Each string in the array must be minimum length of 1 and maximum length of 300. You can get the disk IDs from the ListLocalDisks API. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_cache($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['DiskIds']))\n    {\n        $opt['DiskIds'] = (is_array($opt['DiskIds']) ? $opt['DiskIds'] : array($opt['DiskIds']));\n    }\n\n    return $this-&gt;authenticate('AddCache', $opt);\n}"},{"name":"add_upload_buffer","modifier":"public","description":"<p>This operation configures one or more gateway local disks as upload buffer for a specified\ngateway. This operation is supported for both the gateway-stored and gateway-cached volume\narchitectures.<\/p>\n\n<p>In the request, you specify the gateway Amazon Resource Name (ARN) to which you want to add\nupload buffer, and one or more disk IDs that you want to configure as upload buffer.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>DiskIds<\/code> - <code>string|array<\/code> - Required - An array of strings that identify disks that are to be configured as upload buffer. Each string in the array must be minimum length of 1 and maximum length of 300. You can get disk IDs from the <code>ListLocalDisks<\/code> API. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_upload_buffer($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['DiskIds']))\n    {\n        $opt['DiskIds'] = (is_array($opt['DiskIds']) ? $opt['DiskIds'] : array($opt['DiskIds']));\n    }\n\n    return $this-&gt;authenticate('AddUploadBuffer', $opt);\n}"},{"name":"add_working_storage","modifier":"public","description":"<p>This operation configures one or more gateway local disks as working storage for a gateway.\nThis operation is supported only for the gateway-stored volume architecture.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>Working storage is also referred to as upload buffer. You can also use the\n<code>AddUploadBuffer<\/code> operation to add upload buffer to a stored-volume gateway.<\/p>\n\n<p>In the request, you specify the gateway Amazon Resource Name (ARN) to which you want to add\nworking storage, and one or more disk IDs that you want to configure as working storage.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>DiskIds<\/code> - <code>string|array<\/code> - Required - An array of strings that identify disks that are to be configured as working storage. Each string have a minimum length of 1 and maximum length of 300. You can get the disk IDs from the <code>ListLocalDisks<\/code> API. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function add_working_storage($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['DiskIds']))\n    {\n        $opt['DiskIds'] = (is_array($opt['DiskIds']) ? $opt['DiskIds'] : array($opt['DiskIds']));\n    }\n\n    return $this-&gt;authenticate('AddWorkingStorage', $opt);\n}","examples":{"example":{"title":"<p>Working Storage.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[0];\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add working storage\n$response = $sg-&gt;add_working_storage(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n\t'DiskIds'    =&gt; array($disk_id),\n));\nvar_dump($response-&gt;isOK());\n\nsleep(10);\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/amazonstoragegateway\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/amazonstoragegateway\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/amazonstoragegateway\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Default, shared method for authenticating a connection to AWS.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>Indicates the operation to perform.<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.<\/p>"}]},"returnvalue":"<p>Object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    $original_payload = $payload;\n    $method_arguments = func_get_args();\n    $curlopts = array();\n    $return_curl_handle = false;\n\n    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)\n    {\n        $operation = $this-&gt;operation_prefix . $operation;\n    }\n\n    \/\/ Extract the custom CURLOPT settings from the payload\n    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))\n    {\n        $curlopts = $payload['curlopts'];\n        unset($payload['curlopts']);\n    }\n\n    \/\/ Determine whether the response or curl handle should be returned\n    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))\n    {\n        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;\n        unset($payload['returnCurlHandle']);\n    }\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        \/\/ Parse the XML body\n        $data = $this-&gt;parse_callback($data);\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Signer\n    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);\n    $signer-&gt;key = $this-&gt;key;\n    $signer-&gt;secret_key = $this-&gt;secret_key;\n    $signer-&gt;auth_token = $this-&gt;auth_token;\n    $signer-&gt;api_version = $this-&gt;api_version;\n    $signer-&gt;utilities_class = $this-&gt;utilities_class;\n    $signer-&gt;request_class = $this-&gt;request_class;\n    $signer-&gt;response_class = $this-&gt;response_class;\n    $signer-&gt;use_ssl = $this-&gt;use_ssl;\n    $signer-&gt;proxy = $this-&gt;proxy;\n    $signer-&gt;util = $this-&gt;util;\n    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;\n    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;\n    $request = $signer-&gt;authenticate();\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $request-&gt;debug_mode = $this-&gt;debug_mode;\n    }\n\n    \/\/ Set custom CURLOPT settings\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif ($return_curl_handle)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response.\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;\n\n    if (isset($signer-&gt;canonical_request))\n    {\n        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;\n    }\n\n    $headers['x-aws-request-headers'] = $request-&gt;request_headers;\n    $headers['x-aws-body'] = $signer-&gt;querystring;\n\n    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());\n\n    $response_body = (string) $request-&gt;get_response_body();\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    if (\n        (integer) $request-&gt;get_response_code() === 500 || \/\/ Internal Error (presumably transient)\n        (integer) $request-&gt;get_response_code() === 503)   \/\/ Service Unavailable (presumably transient)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($operation, $original_payload);\n        }\n    }\n\n    \/\/ DynamoDB has additional, custom logic for retrying requests\n    else\n    {\n        \/\/ If the request to DynamoDB was throttled, we need to retry\n        $need_to_retry_dynamodb_request = (\n            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;\n            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;\n            stripos($response_body, 'ProvisionedThroughputExceededException') !== false\n        );\n\n        \/\/ If the CRC32 of the response does not match the expected value, we need to retry\n        $response_headers = $request-&gt;get_response_header();\n        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))\n        {\n            $crc32_expected = $response_headers['x-amz-crc32'];\n            $crc32_actual = hexdec(hash('crc32b', $response_body));\n            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);\n        }\n\n        \/\/ Perform retry if necessary using a more aggressive exponential backoff\n        if ($need_to_retry_dynamodb_request)\n        {\n            if ($this-&gt;redirects === 0)\n            {\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))\n            {\n                \/\/ Exponential backoff\n                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);\n                usleep($delay);\n                $this-&gt;redirects++;\n                $data = $this-&gt;authenticate($operation, $original_payload);\n            }\n        }\n    }\n\n    $this-&gt;redirects = 0;\n    return $data;\n}"},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/amazonstoragegateway\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"create_cached_iscsi_volume","modifier":"public","description":"<p>This operation creates a cached volume on a specified cached gateway. This operation is\nsupported only for the gateway-cached volume architecture.<\/p>\n\n<p class=\"note\">\nCache storage must be allocated to the gateway before you can create a cached volume. Use the\n<code>AddCache<\/code> operation to add cache storage to a gateway.\n<\/p>\n\n<p>In the request, you must specify the gateway, size of the volume in bytes, the iSCSI target\nname, an IP address on which to expose the target, and a unique client token. In response, AWS\nStorage Gateway creates the volume and returns information about it such as the volume Amazon\nResource Name (ARN), its size, and the iSCSI target ARN that initiators can use to connect to\nthe volume target.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>VolumeSizeInBytes<\/code> - <code>long<\/code> - Required - The size of the cached volume.<\/li><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The snapshot ID (e.g., &#8220;snap-1122aabb&#8221;) of the snapshot to restore as the new stored volume. Specify this field if you want to create the iSCSI cached volume from a snapshot; otherwise, do not include this field. To list snapshots for your account, use <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">DescribeSnapshots<\/a> in Amazon Elastic Compute Cloud API Reference. [Constraints: The value must match the following regular expression pattern: <code>\\Asnap-[0-9a-fA-F]{8}\\z<\/code>]<\/li><li><code>TargetName<\/code> - <code>string<\/code> - Required - The name of the iSCSI target used by initiators to connect to the target and as a suffix for the target ARN. For example, specifying <strong>TargetName<\/strong> as <em>myvolume<\/em> results in the target ARN of <em>arn:aws:storagegateway:us-east-1:111122223333:gateway\/mygateway\/target\/iqn.1997-05.com.amazon:myvolume<\/em>. The target name must be unique across all volumes of a gateway. [Constraints: The value must be between 1 and 200 characters, and must match the following regular expression pattern: <code>^[-\\.;a-z0-9]+$<\/code>]<\/li><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Required - The network interface of the gateway on which to expose the iSCSI target. Only IPv4 addresses are accepted. Use the <code>DescribeGatewayInformation<\/code> operation to get a list of the network interfaces available on the gateway. [Constraints: The value must match the following regular expression pattern: <code>\\A(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)(\\.(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)){3}\\z<\/code>]<\/li><li><code>ClientToken<\/code> - <code>string<\/code> - Required - A unique identifying string for the cached volume.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_cached_iscsi_volume($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CreateCachediSCSIVolume', $opt);\n}"},{"name":"create_snapshot","modifier":"public","description":"<p>This operation initiates a snapshot of a volume.<\/p>\n\n<p>AWS Storage Gateway provides the ability to back up point-in-time snapshots of your data to\nAmazon Simple Storage (S3) for durable off-site recovery, as well as import the data to an\nAmazon Elastic Block Store (EBS) volume in Amazon Elastic Compute Cloud (EC2). You can take\nsnapshots of your gateway volume on a scheduled or ad-hoc basis. This API enables you to take\nad-hoc snapshot. For more information, see <a href=\"TBD\">Working With Snapshots in the AWS\nStorage Gateway Console<\/a>.<\/p>\n\n<p>In the CreateSnapshot request you identify the volume by providing its Amazon Resource Name\n(ARN). You must also provide description for the snapshot. When AWS Storage Gateway takes the\nsnapshot of specified volume, the snapshot and description appears in the AWS Storage Gateway\nConsole. In response, AWS Storage Gateway returns you a snapshot ID. You can use this snapshot\nID to check the snapshot progress or later use it when you want to create a volume from a\nsnapshot.<\/p>\n\n<p class=\"note\">\nTo list or delete a snapshot, you must use the Amazon EC2 API. For more information, go to\n<a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DeleteSnapshot.html\">\nDeleteSnapshot<\/a> and <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">\nDescribeSnapshots<\/a> in the <em>Amazon Elastic Compute Cloud API Reference<\/em>.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>SnapshotDescription<\/code> - <code>string<\/code> - Required - Textual description of the snapshot that appears in the Amazon EC2 console, Elastic Block Store snapshots panel in the <strong>Description<\/strong> field, and in the AWS Storage Gateway snapshot <strong>Details<\/strong> pane, <strong>Description<\/strong> field<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_snapshot($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CreateSnapshot', $opt);\n}","examples":{"example":{"title":"<p>Create a Snapshot<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Create a Snapshot\n$response = $sg-&gt;create_snapshot(array(\n\t'VolumeARN'           =&gt; $volume_arn,\n\t'SnapshotDescription' =&gt; 'example-snapshot',\n));\nvar_dump($response-&gt;isOK());\n$snapshot_id = (string) $response-&gt;body-&gt;SnapshotId;\n\nsleep(10);\n\n\/\/ Check if snapshot is complete\n$response = $ec2-&gt;describe_snapshots(array(\n\t'SnapshotId' =&gt; $snapshot_id,\n\t'Filter'     =&gt; array(\n\t\tarray('Name' =&gt; 'status', 'Value' =&gt; array('completed'))\n\t),\n));\nvar_dump($response-&gt;body);"}}},{"name":"create_snapshot_from_volume_recovery_point","modifier":"public","description":"<p>This operation initiates a snapshot of a gateway from a volume recovery point. This operation\nis supported only for the gateway-cached volume architecture (see\n<code>StorageGatewayConcepts<\/code>).<\/p>\n\n<p>A volume recovery point is a point in time at which all data of the volume is consistent and\nfrom which you can create a snapshot. To get a list of volume recovery point for gateway-cached\nvolumes, use <code>ListVolumeRecoveryPoints<\/code>.<\/p>\n\n<p>In the <code>CreateSnapshotFromVolumeRecoveryPoint<\/code> request, you identify the volume by\nproviding its Amazon Resource Name (ARN). You must also provide a description for the snapshot.\nWhen AWS Storage Gateway takes a snapshot of the specified volume, the snapshot and its\ndescription appear in the AWS Storage Gateway console. In response, AWS Storage Gateway returns\nyou a snapshot ID. You can use this snapshot ID to check the snapshot progress or later use it\nwhen you want to create a volume from a snapshot.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>To list or delete a snapshot, you must use the Amazon EC2 API. For more information, go to\n<a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DeleteSnapshot.html\">\nDeleteSnapshot<\/a> and <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">\nDescribeSnapshots<\/a> in <em>Amazon Elastic Compute Cloud API Reference<\/em>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>SnapshotDescription<\/code> - <code>string<\/code> - Required - A textual description of the snapshot that appears in the Amazon EC2 console, Elastic Block Store snapshots panel in the <strong>Description<\/strong> field, and in the AWS Storage Gateway snapshot <strong>Details<\/strong> pane, <strong>Description<\/strong> field. <em>Length<\/em>: Minimum length of 1. Maximum length of 255.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_snapshot_from_volume_recovery_point($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CreateSnapshotFromVolumeRecoveryPoint', $opt);\n}"},{"name":"create_stored_iscsi_volume","modifier":"public","description":"<p>This operation creates a volume on a specified gateway. This operation is supported only for\nthe gateway-cached volume architecture.<\/p>\n\n<p>The size of the volume to create is inferred from the disk size. You can choose to preserve\nexisting data on the disk, create volume from an existing snapshot, or create an empty volume.\nIf you choose to create an empty gateway volume, then any existing data on the disk is erased.<\/p>\n\n<p>In the request you must specify the gateway and the disk information on which you are creating\nthe volume. In response, AWS Storage Gateway creates the volume and returns volume information\nsuch as the volume Amazon Resource Name (ARN), its size, and the iSCSI target ARN that\ninitiators can use to connect to the volume target.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>DiskId<\/code> - <code>string<\/code> - Required - The unique identifier for the gateway local disk that is configured as a stored volume. Use <a href=\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/API_ListLocalDisks.html\">ListLocalDisks<\/a> to list disk IDs for a gateway.<\/li><li><code>SnapshotId<\/code> - <code>string<\/code> - Optional - The snapshot ID (e.g. &#8220;snap-1122aabb&#8221;) of the snapshot to restore as the new stored volume. Specify this field if you want to create the iSCSI storage volume from a snapshot otherwise do not include this field. To list snapshots for your account use <a href=\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">DescribeSnapshots<\/a> in the <em>Amazon Elastic Compute Cloud API Reference<\/em>. [Constraints: The value must match the following regular expression pattern: <code>\\Asnap-[0-9a-fA-F]{8}\\z<\/code>]<\/li><li><code>PreserveExistingData<\/code> - <code>boolean<\/code> - Required - Specify this field as true if you want to preserve the data on the local disk. Otherwise, specifying this field as false creates an empty volume. <em>Valid Values<\/em>: true, false<\/li><li><code>TargetName<\/code> - <code>string<\/code> - Required - The name of the iSCSI target used by initiators to connect to the target and as a suffix for the target ARN. For example, specifying <code>TargetName<\/code> as <em>myvolume<\/em> results in the target ARN of arn:aws:storagegateway:us-east-1:111122223333:gateway\/mygateway\/target\/iqn.1997-05.com.amazon:myvolume. The target name must be unique across all volumes of a gateway. [Constraints: The value must be between 1 and 200 characters, and must match the following regular expression pattern: <code>^[-\\.;a-z0-9]+$<\/code>]<\/li><li><code>NetworkInterfaceId<\/code> - <code>string<\/code> - Required - The network interface of the gateway on which to expose the iSCSI target. Only IPv4 addresses are accepted. Use <code>DescribeGatewayInformation<\/code> to get a list of the network interfaces available on a gateway. <em>Valid Values<\/em>: A valid IP address. [Constraints: The value must match the following regular expression pattern: <code>\\A(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)(\\.(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)){3}\\z<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_stored_iscsi_volume($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('CreateStorediSCSIVolume', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"delete_bandwidth_rate_limit","modifier":"public","description":"<p>This operation deletes the bandwidth rate limits of a gateway. You can delete either the upload\nand download bandwidth rate limit, or you can delete both. If you delete only one of the\nlimits, the other limit remains unchanged. To specify which gateway to work with, use the\nAmazon Resource Name (ARN) of the gateway in your request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>BandwidthType<\/code> - <code>string<\/code> - Required - One of the <code>BandwidthType<\/code> values that indicates the gateway bandwidth rate limit to delete. <em>Valid Values<\/em>: <code>Upload<\/code>, <code>Download<\/code>, <code>All<\/code> [Allowed values: <code>UPLOAD<\/code>, <code>DOWNLOAD<\/code>, <code>ALL<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_bandwidth_rate_limit($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteBandwidthRateLimit', $opt);\n}","examples":{"example":{"title":"<p>Bandwidth Rate Limit<\/p>","code":"$sg = new AmazonStorageGateway();\n\n$response = $sg-&gt;update_bandwidth_rate_limit(array(\n\t'GatewayARN'                           =&gt; $gateway_arn,\n\t'AverageUploadRateLimitInBitsPerSec'   =&gt; 51200,\n\t'AverageDownloadRateLimitInBitsPerSec' =&gt; 102400,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;describe_bandwidth_rate_limit(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;delete_bandwidth_rate_limit(array(\n\t'GatewayARN'    =&gt; $gateway_arn,\n\t'BandwidthType' =&gt; 'ALL',\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_chap_credentials","modifier":"public","description":"<p>This operation deletes Challenge-Handshake Authentication Protocol (CHAP) credentials for a\nspecified iSCSI target and initiator pair.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TargetARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the iSCSI volume target. Use the <code>DescribeStorediSCSIVolumes<\/code> operation to return to retrieve the TargetARN for specified VolumeARN.<\/li><li><code>InitiatorName<\/code> - <code>string<\/code> - Required - The iSCSI initiator that connects to the target. [Constraints: The value must be between 1 and 255 characters, and must match the following regular expression pattern: <code>[0-9a-z:.-]+<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_chap_credentials($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteChapCredentials', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"delete_gateway","modifier":"public","description":"<p>This operation deletes a gateway. To specify which gateway to delete, use the Amazon Resource\nName (ARN) of the gateway in your request. The operation deletes the gateway; however, it does\nnot delete the gateway virtual machine (VM) from your host computer.<\/p>\n\n<p>After you delete a gateway, you cannot reactivate it. Completed snapshots of the gateway\nvolumes are not deleted upon deleting the gateway, however, pending snapshots will not\ncomplete. After you delete a gateway, your next step is to remove it from your environment.<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>You no longer pay software charges after the gateway is deleted; however, your existing Amazon\nEBS snapshots persist and you will continue to be billed for these snapshots.&Acirc;&nbsp;You\ncan choose to remove all remaining Amazon EBS snapshots by canceling your Amazon EC2\nsubscription.&Acirc;&nbsp; If you prefer not to cancel your Amazon EC2 subscription, you can\ndelete your snapshots using the Amazon EC2 console. For more information, see the <a href=\n\"http:\/\/aws.amazon.com\/storagegateway\">AWS Storage Gateway Detail Page<\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_gateway($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteGateway', $opt);\n}","examples":{"example":{"title":"<p>Teardown a Storage Gateway<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Delete the gateway\n$response = $sg-&gt;delete_gateway(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\nsleep(20);\n\n\/\/ Detach EBS volume\n$response = $ec2-&gt;detach_volume($volume_id, array(\n\t'InstanceId' =&gt; $instance_id,\n\t'Device'     =&gt; '\/dev\/sdk',\n));\nvar_dump($response-&gt;isOK());\n\nsleep(20);\n\n\/\/ Delete EBS volume\n$response = $ec2-&gt;delete_volume($volume_id);\nvar_dump($response-&gt;isOK());\n\nsleep(20);\n\n\/\/ Terminate EC2 instance\n$response = $ec2-&gt;terminate_instances($instance_id);\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}}},{"name":"delete_snapshot_schedule","modifier":"public","description":"<p>This operation deletes a snapshot of a volume.<\/p>\n\n<p>You can take snapshots of your gateway volumes on a scheduled or ad-hoc basis. This API enables\nyou to delete a snapshot schedule for a volume. For more information, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/WorkingWithSnapshots.html\">Working\nwith Snapshots<\/a>. In the <code>DeleteSnapshotSchedule<\/code> request, you identify the volume\nby providing its Amazon Resource Name (ARN).<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>To list or delete a snapshot, you must use the Amazon EC2 API. For more information, go to\n<a url=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DeleteSnapshot.html\">\nDeleteSnapshot<\/a> and <a url=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">\nDescribeSnapshots<\/a> in <em>Amazon Elastic Compute Cloud API Reference<\/em>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_snapshot_schedule($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteSnapshotSchedule', $opt);\n}"},{"name":"delete_volume","modifier":"public","description":"<p>This operation delete the specified gateway volume that you previously created using the\n<code>CreateStorediSCSIVolume<\/code> API. For gateway-stored volumes, the local disk that was\nconfigured as the storage volume is not deleted. You can reuse the local disk to create another\nstorage volume.<\/p>\n\n<p>Before you delete a gateway volume, make sure there are no iSCSI connections to the volume you\nare deleting. You should also make sure there is no snapshot in progress. You can use the\nAmazon Elastic Compute Cloud (Amazon EC2) API to query snapshots on the volume you are deleting\nand check the snapshot status. For more information, go to <a href=\n\"http:\/\/docs.amazonwebservices.com\/AWSEC2\/latest\/APIReference\/ApiReference-query-DescribeSnapshots.html\">\nDescribeSnapshots<\/a> in the <em>Amazon Elastic Compute Cloud API Reference<\/em>.<\/p>\n\n<p>In the request, you must provide the Amazon Resource Name (ARN) of the storage volume you want\nto delete.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_volume($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DeleteVolume', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_bandwidth_rate_limit","modifier":"public","description":"<p>This operation returns the bandwidth rate limits of a gateway. By default, these limits are not\nset, which means no bandwidth rate limiting is in effect.<\/p>\n\n<p>This operation only returns a value for a bandwidth rate limit only if the limit is set. If no\nlimits are set for the gateway, then this operation returns only the gateway ARN in the\nresponse body. To specify which gateway to describe, use the Amazon Resource Name (ARN) of the\ngateway in your request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_bandwidth_rate_limit($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeBandwidthRateLimit', $opt);\n}","examples":{"example":{"title":"<p>Bandwidth Rate Limit<\/p>","code":"$sg = new AmazonStorageGateway();\n\n$response = $sg-&gt;update_bandwidth_rate_limit(array(\n\t'GatewayARN'                           =&gt; $gateway_arn,\n\t'AverageUploadRateLimitInBitsPerSec'   =&gt; 51200,\n\t'AverageDownloadRateLimitInBitsPerSec' =&gt; 102400,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;describe_bandwidth_rate_limit(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;delete_bandwidth_rate_limit(array(\n\t'GatewayARN'    =&gt; $gateway_arn,\n\t'BandwidthType' =&gt; 'ALL',\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_cache","modifier":"public","description":"<p>This operation returns information about the cache of a gateway. This operation is supported\nonly for the gateway-cached volume architecture.<\/p>\n\n<p>The response includes disk IDs that are configured as cache, and it includes the amount of\ncache allocated and used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_cache($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeCache', $opt);\n}"},{"name":"describe_cached_iscsi_volumes","modifier":"public","description":"<p>This operation returns a description of the gateway volumes specified in the request. This\noperation is supported only for the gateway-cached volume architecture.<\/p>\n\n<p>The list of gateway volumes in the request must be from one gateway. In the response Amazon\nStorage Gateway returns volume information sorted by volume Amazon Resource Name (ARN).<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARNs<\/code> - <code>string|array<\/code> - Required - An array of strings, where each string represents the Amazon Resource Name (ARN) of a cached volume. All of the specified cached volumes must be from the same gateway. Use <code>ListVolumes<\/code> to get volume ARNs of a gateway. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_cached_iscsi_volumes($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['VolumeARNs']))\n    {\n        $opt['VolumeARNs'] = (is_array($opt['VolumeARNs']) ? $opt['VolumeARNs'] : array($opt['VolumeARNs']));\n    }\n\n    return $this-&gt;authenticate('DescribeCachediSCSIVolumes', $opt);\n}"},{"name":"describe_chap_credentials","modifier":"public","description":"<p>This operation returns an array of Challenge-Handshake Authentication Protocol (CHAP)\ncredentials information for a specified iSCSI target, one for each target-initiator pair.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TargetARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the iSCSI volume target. Use the <code>DescribeStorediSCSIVolumes<\/code> operation to return to retrieve the TargetARN for specified VolumeARN.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_chap_credentials($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeChapCredentials', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_gateway_information","modifier":"public","description":"<p>This operation returns metadata about a gateway such as its name, network interfaces,\nconfigured time zone, and the state (whether the gateway is running or not). To specify which\ngateway to describe, use the Amazon Resource Name (ARN) of the gateway in your request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_gateway_information($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeGatewayInformation', $opt);\n}","examples":{"example":{"title":"<p>Shutdown and start a gateway.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Shutdown the gateway\n$response = $sg-&gt;shutdown_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\nsleep(10);\n\n\/\/ Wait until shutdown\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'SHUTDOWN');\n\n\/\/ Start the gateway\n$response = $sg-&gt;start_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\n\/\/ Wait until running\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'RUNNING');"}}},{"name":"describe_maintenance_start_time","modifier":"public","description":"<p>This operation returns your gateway&#8217;s weekly maintenance start time including the day and time\nof the week. Note that values are in terms of the gateway&#8217;s time zone.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_maintenance_start_time($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeMaintenanceStartTime', $opt);\n}","examples":{"example":{"title":"<p>Maintenance Start Time<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Update maintenance start time\n$response = $sg-&gt;update_maintenance_start_time(array(\n\t'GatewayARN'   =&gt; $gateway_arn,\n\t&quot;HourOfDay&quot;    =&gt; 0,\n\t&quot;MinuteOfHour&quot; =&gt; 30,\n\t&quot;DayOfWeek&quot;    =&gt; 2,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n\/\/ Describe maintenance start time\n$response = $sg-&gt;describe_maintenance_start_time(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_snapshot_schedule","modifier":"public","description":"<p>This operation describes the snapshot schedule for the specified gateway volume. The snapshot\nschedule information includes intervals at which snapshots are automatically initiated on the\nvolume.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_snapshot_schedule($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeSnapshotSchedule', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_stored_iscsi_volumes","modifier":"public","description":"<p>This operation returns description of the gateway volumes specified in the request. The list of\ngateway volumes in the request must be from one gateway. In the response Amazon Storage Gateway\nreturns volume information sorted by volume ARNs.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARNs<\/code> - <code>string|array<\/code> - Required - An array of strings where each string represents the Amazon Resource Name (ARN) of a stored volume. All of the specified stored volumes must from the same gateway. Use <code>ListVolumes<\/code> to get volume ARNs for a gateway. Pass a string for a single value, or an indexed array for multiple values.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_stored_iscsi_volumes($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    \/\/ List (non-map)\n    if (isset($opt['VolumeARNs']))\n    {\n        $opt['VolumeARNs'] = (is_array($opt['VolumeARNs']) ? $opt['VolumeARNs'] : array($opt['VolumeARNs']));\n    }\n\n    return $this-&gt;authenticate('DescribeStorediSCSIVolumes', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"describe_upload_buffer","modifier":"public","description":"<p>This operation returns information about the upload buffer of a gateway. This operation is\nsupported for both the gateway-stored and gateway-cached volume architectures.<\/p>\n\n<p>The response includes disk IDs that are configured as upload buffer space, and it includes the\namount of upload buffer space allocated and used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_upload_buffer($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeUploadBuffer', $opt);\n}"},{"name":"describe_working_storage","modifier":"public","description":"<p>This operation returns information about the working storage of a gateway. This operation is\nsupported only for the gateway-stored volume architecture.<\/p>\n\n<p class=\"note\"><\/p>\n\n<p>Working storage is also referred to as upload buffer. You can also use the\n<code>DescribeUploadBuffer<\/code> operation to add upload buffer to a stored-volume gateway.<\/p>\n\n<p>The response includes disk IDs that are configured as working storage, and it includes the\namount of working storage allocated and used.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function describe_working_storage($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('DescribeWorkingStorage', $opt);\n}","examples":{"example":{"title":"<p>Working Storage.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[0];\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add working storage\n$response = $sg-&gt;add_working_storage(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n\t'DiskIds'    =&gt; array($disk_id),\n));\nvar_dump($response-&gt;isOK());\n\nsleep(10);\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/amazonstoragegateway\/set_cache_config.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"list_gateways","modifier":"public","description":"<p>This operation lists gateways owned by an AWS account in a region specified in the request. The\nreturned list is ordered by gateway Amazon Resource Name (ARN).<\/p>\n\n<p>By default, the operation returns a maximum of 100 gateways. This operation supports pagination\nthat allows you to optionally reduce the number of gateways returned in a response.<\/p>\n\n<p>If you have more gateways than are returned in a response-that is, the response returns only a\ntruncated list of your gateways-the response contains a marker that you can specify in your\nnext request to fetch the next page of gateways.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>Marker<\/code> - <code>string<\/code> - Optional - An opaque string that indicates the position at which to begin the returned list of gateways.<\/li><li><code>Limit<\/code> - <code>integer<\/code> - Optional - Specifies that the list of gateways returned be limited to the specified number of items.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_gateways($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListGateways', $opt);\n}","examples":{"example":{"title":"<p>List Gateways.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ List gateways\n$response = $sg-&gt;list_gateways();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());"}}},{"name":"list_local_disks","modifier":"public","description":"<p>This operation returns a list of the local disks of a gateway. To specify which gateway to\ndescribe you use the Amazon Resource Name (ARN) of the gateway in the body of the request.<\/p>\n\n<p>The request returns all disks, specifying which are configured as working storage, stored\nvolume or not configured at all.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_local_disks($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListLocalDisks', $opt);\n}","examples":{"example":{"title":"<p>Working Storage.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[0];\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add working storage\n$response = $sg-&gt;add_working_storage(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n\t'DiskIds'    =&gt; array($disk_id),\n));\nvar_dump($response-&gt;isOK());\n\nsleep(10);\n\n\/\/ Describe working storage\n$response = $sg-&gt;describe_working_storage(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"list_volume_recovery_points","modifier":"public","description":"<p>This operation lists the recovery points for a specified gateway. This operation is supported\nonly for the gateway-cached volume architecture.<\/p>\n\n<p>Each gateway-cached volume has one recovery point. A volume recovery point is a point in time\nat which all data of the volume is consistent and from which you can create a snapshot. To\ncreate a snapshot from a volume recovery point use the\n<code>CreateSnapshotFromVolumeRecoveryPoint<\/code> operation.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_volume_recovery_points($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListVolumeRecoveryPoints', $opt);\n}"},{"name":"list_volumes","modifier":"public","description":"<p>This operation lists the iSCSI stored volumes of a gateway. Results are sorted by volume ARN.\nThe response includes only the volume ARNs. If you want additional volume information, use the\n<code>DescribeStorediSCSIVolumes<\/code> API.<\/p>\n\n<p>The operation supports pagination. By default, the operation returns a maximum of up to 100\nvolumes. You can optionally specify the <code>Limit<\/code> field in the body to limit the\nnumber of volumes in the response. If the number of volumes returned in the response is\ntruncated, the response includes a Marker field. You can use this Marker value in your\nsubsequent request to retrieve the next set of volumes.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>Marker<\/code> - <code>string<\/code> - Optional - A string that indicates the position at which to begin the returned list of volumes. Obtain the marker from the response of a previous List iSCSI Volumes request.<\/li><li><code>Limit<\/code> - <code>integer<\/code> - Optional - Specifies that the list of volumes returned be limited to the specified number of items.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_volumes($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ListVolumes', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","description":"<p>This allows you to explicitly sets the region for the service to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to explicitly set. Available options are <a href=\"..\/amazonstoragegateway\/constants.html#region_us_e1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_us_e1\"><code>REGION_US_E1<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_us_w1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_us_w1\"><code>REGION_US_W1<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_us_w2\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_us_w2\"><code>REGION_US_W2<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_eu_w1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_eu_w1\"><code>REGION_EU_W1<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_apac_se1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_apac_se1\"><code>REGION_APAC_SE1<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_apac_se2\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_apac_se2\"><code>REGION_APAC_SE2<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_apac_ne1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_apac_ne1\"><code>REGION_APAC_NE1<\/code><\/a>, <a href=\"..\/amazonstoragegateway\/constants.html#region_sa_e1\" rel=\"..\/..\/index.html#c=amazonstoragegateway\/region_sa_e1\"><code>REGION_SA_E1<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n    return $this;\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"shutdown_gateway","modifier":"public","description":"<p>This operation shuts down a gateway. To specify which gateway to shut down, use the Amazon\nResource Name (ARN) of the gateway in the body of your request.<\/p>\n\n<p>The operation shuts down the gateway service component running in the storage gateway&#8217;s virtual\nmachine (VM) and not the VM.<\/p>\n\n<p class=\"note\">\nIf you want to shut down the VM, it is recommended that you first shut down the gateway\ncomponent in the VM to avoid unpredictable conditions.\n<\/p>\n\n<p>After the gateway is shutdown, you cannot call any other API except <code>StartGateway<\/code>,\n<code>DescribeGatewayInformation<\/code>, and <code>ListGateways<\/code>. For more information,\nsee <code>ActivateGateway<\/code>. Your applications cannot read from or write to the gateway&#8217;s\nstorage volumes, and there are no snapshots taken.<\/p>\n\n<p class=\"note\">\nWhen you make a shutdown request, you will get a <code>200 OK<\/code> success response\nimmediately. However, it might take some time for the gateway to shut down. You can call the\n<code>DescribeGatewayInformation<\/code> API to check the status. For more information, see\n<code>ActivateGateway<\/code>.\n<\/p>\n\n<p>If do not intend to use the gateway again, you must delete the gateway (using\n<code>DeleteGateway<\/code>) to no longer pay software charges associated with the gateway.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function shutdown_gateway($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('ShutdownGateway', $opt);\n}","examples":{"example":{"title":"<p>Shutdown and start a gateway.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Shutdown the gateway\n$response = $sg-&gt;shutdown_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\nsleep(10);\n\n\/\/ Wait until shutdown\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'SHUTDOWN');\n\n\/\/ Start the gateway\n$response = $sg-&gt;start_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\n\/\/ Wait until running\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'RUNNING');"}}},{"name":"start_gateway","modifier":"public","description":"<p>This operation starts a gateway that you previously shut down (see\n<code>ShutdownGateway<\/code>). After the gateway starts, you can then make other API calls,\nyour applications can read from or write to the gateway&#8217;s storage volumes and you will be able\nto take snapshot backups.<\/p>\n\n<p class=\"note\">\nWhen you make a request, you will get a 200 OK success response immediately. However, it might\ntake some time for the gateway to be ready. You should call\n<code>DescribeGatewayInformation<\/code> and check the status before making any additional API\ncalls. For more information, see <code>ActivateGateway<\/code>.\n<\/p>\n\n<p>To specify which gateway to start, use the Amazon Resource Name (ARN) of the gateway in your\nrequest.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function start_gateway($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('StartGateway', $opt);\n}","examples":{"example":{"title":"<p>Shutdown and start a gateway.<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Shutdown the gateway\n$response = $sg-&gt;shutdown_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\nsleep(10);\n\n\/\/ Wait until shutdown\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'SHUTDOWN');\n\n\/\/ Start the gateway\n$response = $sg-&gt;start_gateway(array('GatewayARN' =&gt; $gateway_arn));\n\n\/\/ Wait until running\ndo\n{\n\tsleep(10); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'RUNNING');"}}},{"name":"update_bandwidth_rate_limit","modifier":"public","description":"<p>This operation updates the bandwidth rate limits of a gateway. You can update both the upload\nand download bandwidth rate limit or specify only one of the two. If you don&#8217;t set a bandwidth\nrate limit, the existing rate limit remains.<\/p>\n\n<p>By default, a gateway&#8217;s bandwidth rate limits are not set. If you don&#8217;t set any limit, the\ngateway does not have any limitations on its bandwidth usage and could potentially use the\nmaximum available bandwidth.<\/p>\n\n<p>To specify which gateway to update, use the Amazon Resource Name (ARN) of the gateway in your\nrequest.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>AverageUploadRateLimitInBitsPerSec<\/code> - <code>long<\/code> - Optional - The average upload bandwidth rate limit in bits per second.<\/li><li><code>AverageDownloadRateLimitInBitsPerSec<\/code> - <code>long<\/code> - Optional - The average download bandwidth rate limit in bits per second.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_bandwidth_rate_limit($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateBandwidthRateLimit', $opt);\n}","examples":{"example":{"title":"<p>Bandwidth Rate Limit<\/p>","code":"$sg = new AmazonStorageGateway();\n\n$response = $sg-&gt;update_bandwidth_rate_limit(array(\n\t'GatewayARN'                           =&gt; $gateway_arn,\n\t'AverageUploadRateLimitInBitsPerSec'   =&gt; 51200,\n\t'AverageDownloadRateLimitInBitsPerSec' =&gt; 102400,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;describe_bandwidth_rate_limit(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n$response = $sg-&gt;delete_bandwidth_rate_limit(array(\n\t'GatewayARN'    =&gt; $gateway_arn,\n\t'BandwidthType' =&gt; 'ALL',\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"update_chap_credentials","modifier":"public","description":"<p>This operation updates the Challenge-Handshake Authentication Protocol (CHAP) credentials for a\nspecified iSCSI target. By default, a gateway does not have CHAP enabled; however, for added\nsecurity, you might use it.<\/p>\n\n<p class=\"important\"><\/p>\n\n<p>When you update CHAP credentials, all existing connections on the target are closed and\ninitiators must reconnect with the new credentials.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>TargetARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the iSCSI volume target. Use the <code>DescribeStorediSCSIVolumes<\/code> operation to return to retrieve the TargetARN for specified VolumeARN.<\/li><li><code>SecretToAuthenticateInitiator<\/code> - <code>string<\/code> - Required - The secret key that the initiator (e.g. Windows client) must provide to participate in mutual CHAP with the target.<\/li><li><code>InitiatorName<\/code> - <code>string<\/code> - Required - The iSCSI initiator that connects to the target. [Constraints: The value must be between 1 and 255 characters, and must match the following regular expression pattern: <code>[0-9a-z:.-]+<\/code>]<\/li><li><code>SecretToAuthenticateTarget<\/code> - <code>string<\/code> - Optional - The secret key that the target must provide to participate in mutual CHAP with the initiator (e.g. Windows client).<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_chap_credentials($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateChapCredentials', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}},{"name":"update_gateway_information","modifier":"public","description":"<p>This operation updates a gateway&#8217;s metadata, which includes the gateway&#8217;s name and time zone.\nTo specify which gateway to update, use the Amazon Resource Name (ARN) of the gateway in your\nrequest.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>GatewayName<\/code> - <code>string<\/code> - Optional - A unique identifier for your gateway. This name becomes part of the gateway Amazon Resources Name (ARN) which is what you use as an input to other operations. [Constraints: The value must be between 2 and 255 characters, and must match the following regular expression pattern: <code>^[ -\\.0-\\[\\]-~]*[!-\\.0-\\[\\]-~][ -\\.0-\\[\\]-~]*$<\/code>]<\/li><li><code>GatewayTimezone<\/code> - <code>string<\/code> - Optional - One of the <code>GatewayTimezone<\/code> values that represents the time zone for your gateway. The time zone is used, for example, when a time stamp is given to a snapshot. [Allowed values: <code>GMT-12:00<\/code>, <code>GMT-11:00<\/code>, <code>GMT-10:00<\/code>, <code>GMT-9:00<\/code>, <code>GMT-8:00<\/code>, <code>GMT-7:00<\/code>, <code>GMT-6:00<\/code>, <code>GMT-5:00<\/code>, <code>GMT-4:00<\/code>, <code>GMT-3:30<\/code>, <code>GMT-3:00<\/code>, <code>GMT-2:00<\/code>, <code>GMT-1:00<\/code>, <code>GMT<\/code>, <code>GMT+1:00<\/code>, <code>GMT+2:00<\/code>, <code>GMT+3:00<\/code>, <code>GMT+3:30<\/code>, <code>GMT+4:00<\/code>, <code>GMT+4:30<\/code>, <code>GMT+5:00<\/code>, <code>GMT+5:30<\/code>, <code>GMT+5:45<\/code>, <code>GMT+6:00<\/code>, <code>GMT+7:00<\/code>, <code>GMT+8:00<\/code>, <code>GMT+9:00<\/code>, <code>GMT+9:30<\/code>, <code>GMT+10:00<\/code>, <code>GMT+11:00<\/code>, <code>GMT+12:00<\/code>]<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_gateway_information($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateGatewayInformation', $opt);\n}","examples":{"example":{"title":"<p>Activate a Storage Gateway<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Acquire activation key\n$activation_key = $sg-&gt;acquire_activation_code($gateway_url);\nvar_dump($activation_key);\nif (!$activation_key) die('Activation key could not be retrieved.');\n\n\/\/ Activate the gateway\n$response = $sg-&gt;activate_gateway(array(\n\t'ActivationKey'   =&gt; $activation_key,\n\t'GatewayName'     =&gt; 'example-gateway',\n\t'GatewayTimezone' =&gt; 'GMT-8:00',\n\t'GatewayRegion'   =&gt; 'us-east-1',\n));\nvar_dump($response-&gt;isOK());\n\n$gateway_arn = (string) $response-&gt;body-&gt;GatewayARN;\n\n\/\/ Update gateway information\n$response = $sg-&gt;update_gateway_information(array(\n\t'GatewayARN'      =&gt; $gateway_arn,\n\t'GatewayTimezone' =&gt; 'GMT-7:00',\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"update_gateway_software_now","modifier":"public","description":"<p>This operation updates the gateway virtual machine (VM) software. The request immediately\ntriggers the software update.<\/p>\n\n<p class=\"note\">\nWhen you make this request, you get a <code>200 OK<\/code> success response immediately.\nHowever, it might take some time for the update to complete. You can call\n<code>DescribeGatewayInformation<\/code> to verify the gateway is in the\n<code>STATE_RUNNING<\/code> state.\n<\/p>\n\n<p class=\"important\">\nA software update forces a system restart of your gateway. You can minimize the chance of any\ndisruption to your applications by increasing your iSCSI Initiators&#8217; timeouts. For more\ninformation about increasing iSCSI Initiator timeouts for Windows and Linux, see <a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/ConfiguringiSCSIClientInitiatorWindowsClient.html#CustomizeWindowsiSCSISettings\">\nCustomizing Your Windows iSCSI Settings<\/a> and <a href=\n\"http:\/\/docs.amazonwebservices.com\/storagegateway\/latest\/userguide\/ConfiguringiSCSIClientInitiatorRedHatClient.html#CustomizeLinuxiSCSISettings\">\nCustomizing Your Linux iSCSI Settings<\/a>, respectively.\n<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_gateway_software_now($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateGatewaySoftwareNow', $opt);\n}","examples":{"example":{"title":"<p>Update gateway software now<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Update gateway software\n$response = $sg-&gt;update_gateway_software_now(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Wait until complete\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\n\t$status = (string) $response-&gt;body-&gt;GatewayState;\n} while ($status !== 'RUNNING');"}}},{"name":"update_maintenance_start_time","modifier":"public","description":"<p>This operation updates a gateway&#8217;s weekly maintenance start time information, including day and\ntime of the week. The maintenance time is the time in your gateway&#8217;s time zone.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>GatewayARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the gateway. Use the <code>ListGateways<\/code> operation to return a list of gateways for your account and region.<\/li><li><code>HourOfDay<\/code> - <code>integer<\/code> - Required - The hour component of the maintenance start time represented as <emphasis>hh<\/emphasis>, where<em>hh<\/em> is the hour (00 to 23). The hour of the day is in the time zone of the gateway.<\/li><li><code>MinuteOfHour<\/code> - <code>integer<\/code> - Required - The minute component of the maintenance start time represented as <em>mm<\/em>, where <em>mm<\/em> is the minute (00 to 59). The minute of the hour is in the time zone of the gateway.<\/li><li><code>DayOfWeek<\/code> - <code>integer<\/code> - Required - The maintenance start time day of the week.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_maintenance_start_time($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateMaintenanceStartTime', $opt);\n}","examples":{"example":{"title":"<p>Maintenance Start Time<\/p>","code":"$sg = new AmazonStorageGateway();\n\n\/\/ Update maintenance start time\n$response = $sg-&gt;update_maintenance_start_time(array(\n\t'GatewayARN'   =&gt; $gateway_arn,\n\t&quot;HourOfDay&quot;    =&gt; 0,\n\t&quot;MinuteOfHour&quot; =&gt; 30,\n\t&quot;DayOfWeek&quot;    =&gt; 2,\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n\n\/\/ Describe maintenance start time\n$response = $sg-&gt;describe_maintenance_start_time(array(\n\t'GatewayARN' =&gt; $gateway_arn,\n));\nvar_dump($response-&gt;isOK());"}}},{"name":"update_snapshot_schedule","modifier":"public","description":"<p>This operation updates a snapshot schedule configured for a gateway volume.<\/p>\n\n<p>The default snapshot schedule for volume is once every 24 hours, starting at the creation time\nof the volume. You can use this API to change the shapshot schedule configured for the volume.<\/p>\n\n<p>In the request you must identify the gateway volume whose snapshot schedule you want to update,\nand the schedule information, including when you want the snapshot to begin on a day and the\nfrequency (in hours) of snapshots.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>VolumeARN<\/code> - <code>string<\/code> - Required - The Amazon Resource Name (ARN) of the volume. Use the <code>ListVolumes<\/code> operation to return a list of gateway volumes.<\/li><li><code>StartAt<\/code> - <code>integer<\/code> - Required - The hour of the day at which the snapshot schedule begins represented as <em>hh<\/em>, where <em>hh<\/em> is the hour (0 to 23). The hour of the day is in the time zone of the gateway.<\/li><li><code>RecurrenceInHours<\/code> - <code>integer<\/code> - Required - Frequency of snapshots. Specify the number of hours between snapshots.<\/li><li><code>Description<\/code> - <code>string<\/code> - Optional - Optional description of the snapshot that overwrites the existing description.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_snapshot_schedule($opt = null)\n{\n    if (!$opt) $opt = array();\n    \n    return $this-&gt;authenticate('UpdateSnapshotSchedule', $opt);\n}","examples":{"example":{"title":"<p>Volumes and Snapshots<\/p>","code":"$ec2 = new AmazonEC2();\n$sg = new AmazonStorageGateway();\n\n\/\/ Get network interface ID\n$response = $sg-&gt;describe_gateway_information(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$network_interface_id = (string) $response-&gt;body-&gt;GatewayNetworkInterfaces-&gt;Ipv4Address;\n\n\/\/ Get local disk\n$response = $sg-&gt;list_local_disks(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n$disks = $response-&gt;body-&gt;DiskId()-&gt;map_string();\n$disk_id = $disks[1];\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Add iSCSI volume\n$response = $sg-&gt;create_stored_iscsi_volume(array(\n\t'GatewayARN'           =&gt; $gateway_arn,\n\t'DiskId'               =&gt; $disk_id,\n\t'NetworkInterfaceId'   =&gt; $network_interface_id,\n\t'PreserveExistingData' =&gt; true,\n\t'TargetName'           =&gt; 'aws-sdk-php-test-volume-01',\n));\nvar_dump($response-&gt;isOK());\n$volume_arn = (string) $response-&gt;body-&gt;VolumeARN;\n$target_arn = (string) $response-&gt;body-&gt;TargetARN;\n\n\/\/ Wait until volume is available\ndo\n{\n\tsleep(20); echo '.';\n\t$response = $sg-&gt;describe_stored_iscsi_volumes(array('VolumeARNs' =&gt; array($volume_arn)));\n\t$status = $response-&gt;body-&gt;VolumeStatus()-&gt;map_string();\n\t$status = (string) reset($status);\n} while ($status !== 'AVAILABLE');\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update snapshot schedule\n$response = $sg-&gt;update_snapshot_schedule(array(\n\t'VolumeARN'         =&gt; $volume_arn,\n\t'StartAt'           =&gt; 0,\n\t'RecurrenceInHours' =&gt; 24,\n\t&quot;Description&quot;       =&gt; 'daily snapshot',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe snapshot schedule\n$response = $sg-&gt;describe_snapshot_schedule(array(\n\t'VolumeARN' =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Update chap credentials\n$response = $sg-&gt;update_chap_credentials(array(\n\t'TargetARN'                     =&gt; $target_arn,\n\t'SecretToAuthenticateInitiator' =&gt; '111111111111',\n\t'InitiatorName'                 =&gt; 'example-initiator',\n\t'SecretToAuthenticateTarget'    =&gt; '222222222222',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Describe chap credentials\n$response = $sg-&gt;describe_chap_credentials(array(\n\t'TargetARN' =&gt; $target_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete chap credentials\n$response = $sg-&gt;delete_chap_credentials(array(\n\t'TargetARN'     =&gt; $target_arn,\n\t'InitiatorName' =&gt; 'example-initiator',\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ Delete iSCSI volume\n$response = $sg-&gt;delete_volume(array(\n\t'VolumeARN'  =&gt; $volume_arn,\n));\nvar_dump($response-&gt;isOK());\n\n\/\/ List iSCSI volumes\n$response = $sg-&gt;list_volumes(array('GatewayARN' =&gt; $gateway_arn));\nvar_dump($response-&gt;isOK());"}}}]},"constants":{"@attributes":{"count":"21"},"constant":[{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"storagegateway.us-east-1.amazonaws.com"},{"name":"NAME","value":"aws-sdk-php"},{"name":"REGION_APAC_NE1","value":"storagegateway.ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1","value":"storagegateway.ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE2","value":"storagegateway.ap-southeast-2.amazonaws.com"},{"name":"REGION_CALIFORNIA","value":"storagegateway.us-west-1.amazonaws.com"},{"name":"REGION_EU_W1","value":"storagegateway.eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND","value":"storagegateway.eu-west-1.amazonaws.com"},{"name":"REGION_OREGON","value":"storagegateway.us-west-2.amazonaws.com"},{"name":"REGION_SAO_PAULO","value":"storagegateway.sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1","value":"storagegateway.sa-east-1.amazonaws.com"},{"name":"REGION_SINGAPORE","value":"storagegateway.ap-southeast-1.amazonaws.com"},{"name":"REGION_SYDNEY","value":"storagegateway.ap-southeast-2.amazonaws.com"},{"name":"REGION_TOKYO","value":"storagegateway.ap-northeast-1.amazonaws.com"},{"name":"REGION_US_E1","value":"storagegateway.us-east-1.amazonaws.com"},{"name":"REGION_US_W1","value":"storagegateway.us-west-1.amazonaws.com"},{"name":"REGION_US_W2","value":"storagegateway.us-west-2.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"storagegateway.us-east-1.amazonaws.com"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"40"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/amazonstoragegateway\/set_hostname.html\" rel=\"..\/..\/index.html#m=amazonstoragegateway\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"}]}}}