{"file":{},"class":{"name":"CFCredential","file":"utilities\/credential.class.php","url":"..\/cfcredential\/index.html","description":"<p>The <a href=\"..\/cfcredential\/index.html\" rel=\"..\/..\/index.html#i=cfcredential\"><code>CFCredential<\/code><\/a> class represents an individual credential set.<\/p>","metadata":{"version":"2011.11.15","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"implements":{"interface":{"name":"ArrayAccess","url":"http:\/\/php.net\/arrayaccess"}},"methods":{"@attributes":{"count":"10"},"method":[{"name":"__clone","modifier":"public","description":"<p>Create a clone of the object.<\/p>","returnvalue":"<p>A clone of the current instance.<\/p>","source":"public function __clone()\n{\n    $this-&gt;collection = clone $this-&gt;collection;\n}"},{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of the <a href=\"..\/cfcredential\/index.html\" rel=\"..\/..\/index.html#i=cfcredential\"><code>CFCredential<\/code><\/a> class.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"value"}},"returnvalue":{},"source":"public function __construct($value = array())\n{\n    $this-&gt;collection = new ArrayObject($value, ArrayObject::ARRAY_AS_PROPS);\n}"},{"name":"__get","modifier":"public","description":"<p>Default getter. Enables syntax such as $object->method->chained_method();. Also supports\n$object->key. Matching methods are prioritized over matching keys.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"name","type":"string","description":"<p>The name of the method to execute or key to retrieve.<\/p>"}},"returnvalue":"<p>The results of calling the function <code>$name()<\/code>, or the value of the key <code>$object[$name]<\/code>.<\/p>","source":"public function __get($name)\n{\n    return $this[$name];\n}"},{"name":"__set","modifier":"public","description":"<p>Default setter.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"name","type":"string","description":"<p>The name of the method to execute.<\/p>"},{"@attributes":{"choice":"req"},"name":"value","type":"string","description":"<p>The value to pass to the method.<\/p>"}]},"returnvalue":"<p>The results of calling the function, <code>$name<\/code>.<\/p>","source":"public function __set($name, $value)\n{\n    $this[$name] = $value;\n    return $this;\n}"},{"name":"merge","modifier":"public","description":"<p>Merge another instance of <a href=\"..\/cfcredential\/index.html\" rel=\"..\/..\/index.html#i=cfcredential\"><code>CFCredential<\/code><\/a> onto this one.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"credential","type":"CFCredential","description":"<p>Another instance of <a href=\"..\/cfcredential\/index.html\" rel=\"..\/..\/index.html#i=cfcredential\"><code>CFCredential<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current collection.<\/p>","source":"public function merge(CFCredential $credential)\n{\n    $merged = array_merge($this-&gt;to_array(), $credential-&gt;to_array());\n    $this-&gt;collection-&gt;exchangeArray($merged);\n    return $this;\n}"},{"name":"offsetExists","modifier":"public","description":"<p>Check whether or not a specific offset exists.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"offset","type":"integer","description":"<p>The location in the collection to verify the existence of.<\/p>"}},"returnvalue":"<p>A value of <code>true<\/code> indicates that the collection offset exists. A value of <code>false<\/code> indicates that it does not.<\/p>","source":"public function offsetExists($offset)\n{\n    return $this-&gt;collection-&gt;offsetExists($offset);\n}"},{"name":"offsetGet","modifier":"public","description":"<p>Get the value for a specific offset.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"offset","type":"integer","description":"<p>The location in the collection to retrieve the value for.<\/p>"}},"returnvalue":"<p>The value of the collection offset. <code>NULL<\/code> is returned if the offset does not exist.<\/p>","source":"public function offsetGet($offset)\n{\n    if ($this-&gt;collection-&gt;offsetExists($offset))\n    {\n        return $this-&gt;collection-&gt;offsetGet($offset);\n    }\n\n    return null;\n}"},{"name":"offsetSet","modifier":"public","description":"<p>Set the value for a specific offset.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"offset","type":"integer","description":"<p>The location in the collection to set a new value for.<\/p>"},{"@attributes":{"choice":"req"},"name":"value","type":"mixed","description":"<p>The new value for the collection location.<\/p>"}]},"returnvalue":"<p>A reference to the current collection.<\/p>","source":"public function offsetSet($offset, $value)\n{\n    $this-&gt;collection-&gt;offsetSet($offset, $value);\n    return $this;\n}"},{"name":"offsetUnset","modifier":"public","description":"<p>Unset the value for a specific offset.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"offset","type":"integer","description":"<p>The location in the collection to unset.<\/p>"}},"returnvalue":"<p>A reference to the current collection.<\/p>","source":"public function offsetUnset($offset)\n{\n    $this-&gt;collection-&gt;offsetUnset($offset);\n    return $this;\n}"},{"name":"to_array","modifier":"public","description":"<p>Retrieves the data as a standard array.<\/p>","returnvalue":"<p>The data as an array.<\/p>","source":"public function to_array()\n{\n    return $this-&gt;collection-&gt;getArrayCopy();\n}"}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"1"},"property":{"name":"collection","modifier":"private","description":"<p>Stores the internal <a href=\"http:\/\/php.net\/arrayobject\"><code>ArrayObject<\/code><\/a> representation of the collection.<\/p>"}}}}