{"file":{},"class":{"name":"CFGzipDecode","file":"utilities\/gzipdecode.class.php","url":"..\/cfgzipdecode\/index.html","description":"<p>Handles a variety of primary and edge cases around gzip\/deflate decoding in PHP.<\/p>","metadata":{"version":"2011.02.21","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":["http:\/\/aws.amazon.com\/php\/ PHP Developer Center","https:\/\/github.com\/simplepie\/simplepie\/blob\/master\/SimplePie\/gzdecode.php SimplePie_gzdecode"]},"methods":{"@attributes":{"count":"3"},"method":[{"name":"__construct","modifier":"public","description":"<p>Set the compressed string and related properties<\/p>","metadata":{"access":"public"},"parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"data"}},"returnvalue":{},"source":"public function __construct($data)\n{\n    $this-&gt;compressed_data = $data;\n    $this-&gt;compressed_size = strlen($data);\n}"},{"name":"__set","modifier":"public","description":"<p>Don&#8217;t allow anything to be set<\/p>","metadata":{"access":"public"},"parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"name"},{"@attributes":{"choice":"req"},"name":"value"}]},"returnvalue":{},"source":"public function __set($name, $value)\n{\n    trigger_error(&quot;Cannot write property $name&quot;, E_USER_ERROR);\n}"},{"name":"parse","modifier":"public","description":"<p>Decode the GZIP stream<\/p>","metadata":{"access":"public"},"returnvalue":{},"source":"public function parse()\n{\n    if ($this-&gt;compressed_size &gt;= $this-&gt;min_compressed_size)\n    {\n        \/\/ Check ID1, ID2, and CM\n        if (substr($this-&gt;compressed_data, 0, 3) !== &quot;\\x1F\\x8B\\x08&quot;)\n        {\n            return false;\n        }\n\n        \/\/ Get the FLG (FLaGs)\n        $this-&gt;flags = ord($this-&gt;compressed_data[3]);\n\n        \/\/ FLG bits above (1 &lt;&lt; 4) are reserved\n        if ($this-&gt;flags &gt; 0x1F)\n        {\n            return false;\n        }\n\n        \/\/ Advance the pointer after the above\n        $this-&gt;position += 4;\n\n        \/\/ MTIME\n        $mtime = substr($this-&gt;compressed_data, $this-&gt;position, 4);\n        \/\/ Reverse the string if we're on a big-endian arch because l is the only signed long and is machine endianness\n        if (current(unpack('S', &quot;\\x00\\x01&quot;)) === 1)\n        {\n            $mtime = strrev($mtime);\n        }\n        $this-&gt;MTIME = current(unpack('l', $mtime));\n        $this-&gt;position += 4;\n\n        \/\/ Get the XFL (eXtra FLags)\n        $this-&gt;XFL = ord($this-&gt;compressed_data[$this-&gt;position++]);\n\n        \/\/ Get the OS (Operating System)\n        $this-&gt;OS = ord($this-&gt;compressed_data[$this-&gt;position++]);\n\n        \/\/ Parse the FEXTRA\n        if ($this-&gt;flags &amp; 4)\n        {\n            \/\/ Read subfield IDs\n            $this-&gt;SI1 = $this-&gt;compressed_data[$this-&gt;position++];\n            $this-&gt;SI2 = $this-&gt;compressed_data[$this-&gt;position++];\n\n            \/\/ SI2 set to zero is reserved for future use\n            if ($this-&gt;SI2 === &quot;\\x00&quot;)\n            {\n                return false;\n            }\n\n            \/\/ Get the length of the extra field\n            $len = current(unpack('v', substr($this-&gt;compressed_data, $this-&gt;position, 2)));\n            $position += 2;\n\n            \/\/ Check the length of the string is still valid\n            $this-&gt;min_compressed_size += $len + 4;\n            if ($this-&gt;compressed_size &gt;= $this-&gt;min_compressed_size)\n            {\n                \/\/ Set the extra field to the given data\n                $this-&gt;extra_field = substr($this-&gt;compressed_data, $this-&gt;position, $len);\n                $this-&gt;position += $len;\n            }\n            else\n            {\n                return false;\n            }\n        }\n\n        \/\/ Parse the FNAME\n        if ($this-&gt;flags &amp; 8)\n        {\n            \/\/ Get the length of the filename\n            $len = strcspn($this-&gt;compressed_data, &quot;\\x00&quot;, $this-&gt;position);\n\n            \/\/ Check the length of the string is still valid\n            $this-&gt;min_compressed_size += $len + 1;\n            if ($this-&gt;compressed_size &gt;= $this-&gt;min_compressed_size)\n            {\n                \/\/ Set the original filename to the given string\n                $this-&gt;filename = substr($this-&gt;compressed_data, $this-&gt;position, $len);\n                $this-&gt;position += $len + 1;\n            }\n            else\n            {\n                return false;\n            }\n        }\n\n        \/\/ Parse the FCOMMENT\n        if ($this-&gt;flags &amp; 16)\n        {\n            \/\/ Get the length of the comment\n            $len = strcspn($this-&gt;compressed_data, &quot;\\x00&quot;, $this-&gt;position);\n\n            \/\/ Check the length of the string is still valid\n            $this-&gt;min_compressed_size += $len + 1;\n            if ($this-&gt;compressed_size &gt;= $this-&gt;min_compressed_size)\n            {\n                \/\/ Set the original comment to the given string\n                $this-&gt;comment = substr($this-&gt;compressed_data, $this-&gt;position, $len);\n                $this-&gt;position += $len + 1;\n            }\n            else\n            {\n                return false;\n            }\n        }\n\n        \/\/ Parse the FHCRC\n        if ($this-&gt;flags &amp; 2)\n        {\n            \/\/ Check the length of the string is still valid\n            $this-&gt;min_compressed_size += $len + 2;\n            if ($this-&gt;compressed_size &gt;= $this-&gt;min_compressed_size)\n            {\n                \/\/ Read the CRC\n                $crc = current(unpack('v', substr($this-&gt;compressed_data, $this-&gt;position, 2)));\n\n                \/\/ Check the CRC matches\n                if ((crc32(substr($this-&gt;compressed_data, 0, $this-&gt;position)) &amp; 0xFFFF) === $crc)\n                {\n                    $this-&gt;position += 2;\n                }\n                else\n                {\n                    return false;\n                }\n            }\n            else\n            {\n                return false;\n            }\n        }\n\n        \/\/ Decompress the actual data\n        if (($this-&gt;data = gzinflate(substr($this-&gt;compressed_data, $this-&gt;position, -8))) === false)\n        {\n            return false;\n        }\n        else\n        {\n            $this-&gt;position = $this-&gt;compressed_size - 8;\n        }\n\n        \/\/ Check CRC of data\n        $crc = current(unpack('V', substr($this-&gt;compressed_data, $this-&gt;position, 4)));\n        $this-&gt;position += 4;\n        \/*if (extension_loaded('hash') &amp;&amp; sprintf('%u', current(unpack('V', hash('crc32b', $this-&gt;data)))) !== sprintf('%u', $crc))\n        {\n            return false;\n        }*\/\n\n        \/\/ Check ISIZE of data\n        $isize = current(unpack('V', substr($this-&gt;compressed_data, $this-&gt;position, 4)));\n        $this-&gt;position += 4;\n        if (sprintf('%u', strlen($this-&gt;data) &amp; 0xFFFFFFFF) !== sprintf('%u', $isize))\n        {\n            return false;\n        }\n\n        \/\/ Wow, against all odds, we've actually got a valid gzip string\n        return true;\n    }\n    else\n    {\n        return false;\n    }\n}"}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"14"},"property":[{"name":"MTIME","modifier":"public","metadata":{"access":"public"},"description":"<p>Modified time<\/p>"},{"name":"OS","modifier":"public","metadata":{"access":"public"},"description":"<p>Operating System<\/p>"},{"name":"SI1","modifier":"public","metadata":{"access":"public","see":["gzdecode::$extra_field","gzdecode::$SI2"]},"description":"<p>Subfield ID 1<\/p>"},{"name":"SI2","modifier":"public","metadata":{"access":"public","see":["gzdecode::$extra_field","gzdecode::$SI1"]},"description":"<p>Subfield ID 2<\/p>"},{"name":"XFL","modifier":"public","metadata":{"access":"public"},"description":"<p>Extra Flags<\/p>"},{"name":"comment","modifier":"public","metadata":{"access":"public"},"description":"<p>Human readable comment<\/p>"},{"name":"compressed_data","modifier":"public","metadata":{"access":"private","see":"gzdecode::$data"},"description":"<p>Compressed data<\/p>"},{"name":"compressed_size","modifier":"public","metadata":{"access":"private"},"description":"<p>Size of compressed data<\/p>"},{"name":"data","modifier":"public","metadata":{"access":"public","see":"gzdecode::$compressed_data"},"description":"<p>Uncompressed data<\/p>"},{"name":"extra_field","modifier":"public","metadata":{"access":"public","see":["gzdecode::$SI1","gzdecode::$SI2"]},"description":"<p>Extra field content<\/p>"},{"name":"filename","modifier":"public","metadata":{"access":"public"},"description":"<p>Original filename<\/p>"},{"name":"flags","modifier":"public","metadata":{"access":"private"},"description":"<p>Flags (FLG)<\/p>"},{"name":"min_compressed_size","modifier":"public","initializer":{"@attributes":{"type":"integer","value":"18"}},"metadata":{"access":"private"},"description":"<p>Minimum size of a valid gzip string<\/p>"},{"name":"position","modifier":"public","metadata":{"access":"private"},"description":"<p>Current position of pointer<\/p>"}]}}}