{"file":{},"class":{"name":"CFHadoopBase","file":"utilities\/hadoopbase.class.php","url":"..\/cfhadoopbase\/index.html","description":"<p>Contains core functionality for Hadoop helpers.<\/p>","metadata":{"version":"2012.07.24","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":["http:\/\/aws.amazon.com\/php\/ PHP Developer Center","http:\/\/hadoop.apache.org Apache Hadoop"]},"methods":{"@attributes":{"count":"2"},"method":[{"name":"hive_pig_script","modifier":"public static","description":"<p>Prepares a Hive or Pig script before passing it to the script runner.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of script to run. [Allowed values: <code>hive<\/code>, <code>pig<\/code>].<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function hive_pig_script($type, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n    $args = array_merge(array('--base-path', 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/'), $args);\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/' . $type . '-script', $args);\n}","seealso":{"link":["<a href=\"http:\/\/hive.apache.org\">Apache Hive<\/a>","<a href=\"http:\/\/pig.apache.org\">Apache Pig<\/a>"]}},{"name":"script_runner","modifier":"public static","description":"<p>Runs a specified script on the master node of your cluster.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"script","type":"string","description":"<p>The script to run with <code>script-runner.jar<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function script_runner($script, $args = null)\n{\n    if (!$args) $args = array();\n    array_unshift($args, $script);\n\n    return array(\n        'Jar' =&gt; 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/script-runner\/script-runner.jar',\n        'Args' =&gt; $args\n    );\n}"}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"1"},"property":{"name":"region","modifier":"public static","initializer":{"@attributes":{"type":"string","value":"us-east-1"}}}}}}