{"file":{},"class":{"name":"CFHadoopBootstrap","file":"utilities\/hadoopbootstrap.class.php","url":"..\/cfhadoopbootstrap\/index.html","description":"<p>Contains a set of pre-built Amazon EMR Hadoop Bootstrap Actions.<\/p>","metadata":{"version":"2012.07.24","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":["http:\/\/aws.amazon.com\/php\/ PHP Developer Center","http:\/\/hadoop.apache.org Apache Hadoop"]},"inheritance":{"class":{"name":"CFHadoopBase","file":"utilities\/hadoopbase.class.php","url":"..\/cfhadoopbase\/index.html"}},"methods":{"@attributes":{"count":"5"},"method":[{"name":"configure","modifier":"public static","description":"<p>Specify options to merge with Hadoop&#8217;s default configuration.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"file","type":"string","description":"<p>The Hadoop configuration file to merge with. [Allowed values: <code>CFHadoopBootstrap::CONFIG_SITE<\/code>, <code>CFHadoopBootstrap::CONFIG_DEFAULT<\/code>, <code>CFHadoopBootstrap::CONFIG_CORE<\/code>, <code>CFHadoopBootstrap::CONFIG_HDFS<\/code>, <code>CFHadoopBootstrap::CONFIG_MAPREDUCE<\/code>]<\/p>"},{"@attributes":{"choice":"req"},"name":"config","type":"string|array","description":"<p>This can either be an XML file in S3 (as <code>s3:\/\/bucket\/path<\/code>), or an associative array of key-value pairs.<\/p>"}]},"returnvalue":"<p>A configuration set to be provided when running a job flow.<\/p>","source":"public static function configure($file, $config)\n{\n    $args = array();\n    $file_arg = '-' . $file;\n\n    if (is_string($config))\n    {\n        $args[] = $file_arg;\n        $args[] = $config;\n    }\n    elseif (is_array($config))\n    {\n        foreach ($config as $key =&gt; $value)\n        {\n            $args[] = $file_arg;\n            $args[] = $key . '=' . $value;\n        }\n    }\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/bootstrap-actions\/configure-hadoop', $args);\n}"},{"name":"daemon","modifier":"public static","description":"<p>Create a new bootstrap action which lets you configure Hadoop&#8217;s daemons. The options are written to\nthe <code>hadoop-user-env.sh<\/code> file.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"daemon_type","type":"string","description":"<p>The Hadoop daemon to configure.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>HeapSize<\/code> - <code>integer<\/code> - Optional - The requested heap size of the daemon, in megabytes.<\/li><li><code>CLIOptions<\/code> - <code>string<\/code> - Optional - Additional Java command line arguments to pass to the daemon.<\/li><li><code>Replace<\/code> - <code>boolean<\/code> - Optional - Whether or not the file should be replaced. A value of <code>true<\/code> will replace the existing configuration file. A value of <code>false<\/code> will append the options to the configuration file.<\/li><\/ul>"}]},"returnvalue":"<p>A configuration set to be provided when running a job flow.<\/p>","source":"public static function daemon($daemon_type, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $args = array();\n\n    foreach ($opt as $key =&gt; $value)\n    {\n        switch ($key)\n        {\n            case 'HeapSize':\n                $args[] = '--' . $daemon_type . '-heap-size=' . $value;\n                break;\n            case 'CLIOptions':\n                $args[] = '--' . $daemon_type . '-opts=&quot;' . $value . '&quot;';\n                break;\n            case 'Replace':\n                if ((is_string($value) &amp;&amp; $value === 'true') || (is_bool($value) &amp;&amp; $value === true))\n                {\n                    $args[] = '--replace';\n                }\n                break;\n        }\n    }\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/bootstrap-actions\/configure-daemons', $args);\n}"},{"name":"hive_pig_script","modifier":"public static","inheritance":{"class":{"name":"CFHadoopBase"}},"description":"<p>Prepares a Hive or Pig script before passing it to the script runner.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of script to run. [Allowed values: <code>hive<\/code>, <code>pig<\/code>].<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function hive_pig_script($type, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n    $args = array_merge(array('--base-path', 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/'), $args);\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/' . $type . '-script', $args);\n}","seealso":{"link":["<a href=\"http:\/\/hive.apache.org\">Apache Hive<\/a>","<a href=\"http:\/\/pig.apache.org\">Apache Pig<\/a>"]}},{"name":"run_if","modifier":"public static","description":"<p>Create a new run-if bootstrap action which lets you conditionally run bootstrap actions.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"condition","type":"string","description":"<p>The condition to evaluate. If <code>true<\/code>, the bootstrap action executes.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A configuration set to be provided when running a job flow.<\/p>","source":"public static function run_if($condition, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/bootstrap-actions\/run-if', $args);\n}"},{"name":"script_runner","modifier":"public static","inheritance":{"class":{"name":"CFHadoopBase"}},"description":"<p>Runs a specified script on the master node of your cluster.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"script","type":"string","description":"<p>The script to run with <code>script-runner.jar<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function script_runner($script, $args = null)\n{\n    if (!$args) $args = array();\n    array_unshift($args, $script);\n\n    return array(\n        'Jar' =&gt; 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/script-runner\/script-runner.jar',\n        'Args' =&gt; $args\n    );\n}"}]},"constants":{"@attributes":{"count":"10"},"constant":[{"name":"CONFIG_CORE","value":"C"},{"name":"CONFIG_DEFAULT","value":"D"},{"name":"CONFIG_HDFS","value":"H"},{"name":"CONFIG_MAPREDUCE","value":"M"},{"name":"CONFIG_SITE","value":"S"},{"name":"DAEMON_CLIENT","value":"client"},{"name":"DAEMON_DATA_NODE","value":"datanode"},{"name":"DAEMON_JOB_TRACKER","value":"jobtracker"},{"name":"DAEMON_NAME_NODE","value":"namenode"},{"name":"DAEMON_TASK_TRACKER","value":"tasktracker"}]},"properties":{"@attributes":{"count":"1"},"property":{"name":"region","inheritance":{"class":{"name":"CFHadoopBase","file":"utilities\/hadoopbase.class.php"}},"modifier":"public static","initializer":{"@attributes":{"type":"string","value":"us-east-1"}}}}}}