{"file":{},"class":{"name":"CFHadoopStep","file":"utilities\/hadoopstep.class.php","url":"..\/cfhadoopstep\/index.html","description":"<p>Contains a set of pre-built Amazon EMR Hadoop steps.<\/p>","metadata":{"version":"2012.07.24","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":["http:\/\/aws.amazon.com\/php\/ PHP Developer Center","http:\/\/hadoop.apache.org Apache Hadoop"]},"inheritance":{"class":{"name":"CFHadoopBase","file":"utilities\/hadoopbase.class.php","url":"..\/cfhadoopbase\/index.html"}},"methods":{"@attributes":{"count":"7"},"method":[{"name":"enable_debugging","modifier":"public static","description":"<p>When ran as the first step in your job flow, enables the Hadoop debugging UI in the AWS\nManagement Console.<\/p>","returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function enable_debugging()\n{\n    return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/libs\/state-pusher\/0.1\/fetch');\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfstepconfig\/get_config.html\" rel=\"..\/..\/index.html#m=cfstepconfig\/get_config\"><code>CFStepConfig::get_config()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_hive.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_hive\"><code>install_hive()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_pig.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_pig\"><code>install_pig()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_hive_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_hive_script\"><code>run_hive_script()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_pig_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_pig_script\"><code>run_pig_script()<\/code><\/a>"]}},{"name":"hive_pig_script","modifier":"public static","inheritance":{"class":{"name":"CFHadoopBase"}},"description":"<p>Prepares a Hive or Pig script before passing it to the script runner.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"type","type":"string","description":"<p>The type of script to run. [Allowed values: <code>hive<\/code>, <code>pig<\/code>].<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function hive_pig_script($type, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n    $args = array_merge(array('--base-path', 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/'), $args);\n\n        return self::script_runner('s3:\/\/' . self::$region . '.elasticmapreduce\/libs\/' . $type . '\/' . $type . '-script', $args);\n}","seealso":{"link":["<a href=\"http:\/\/hive.apache.org\">Apache Hive<\/a>","<a href=\"http:\/\/pig.apache.org\">Apache Pig<\/a>"]}},{"name":"install_hive","modifier":"public static","description":"<p>Step that installs Hive on your job flow.<\/p>","returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function install_hive()\n{\n    return self::hive_pig_script('hive', '--install-hive');\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfstepconfig\/get_config.html\" rel=\"..\/..\/index.html#m=cfstepconfig\/get_config\"><code>CFStepConfig::get_config()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/enable_debugging.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/enable_debugging\"><code>enable_debugging()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_pig.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_pig\"><code>install_pig()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_hive_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_hive_script\"><code>run_hive_script()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_pig_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_pig_script\"><code>run_pig_script()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/hive.apache.org\">Apache Hive<\/a>"}},{"name":"install_pig","modifier":"public static","description":"<p>Step that installs Pig on your job flow.<\/p>","returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function install_pig()\n{\n    return self::hive_pig_script('pig', array('--install-pig', '--pig-versions', 'latest'));\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfstepconfig\/get_config.html\" rel=\"..\/..\/index.html#m=cfstepconfig\/get_config\"><code>CFStepConfig::get_config()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/enable_debugging.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/enable_debugging\"><code>enable_debugging()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_hive.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_hive\"><code>install_hive()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_hive_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_hive_script\"><code>run_hive_script()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_pig_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_pig_script\"><code>run_pig_script()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/pig.apache.org\">Apache Pig<\/a>"}},{"name":"run_hive_script","modifier":"public static","description":"<p>Step that runs a Hive script on your job flow.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"script","type":"string","description":"<p>The script to run with <code>script-runner.jar<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function run_hive_script($script, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n    $args = array_merge(array('--run-hive-script', '--args', '-f', $script), $args);\n\n        return self::hive_pig_script('hive', $args);\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfstepconfig\/get_config.html\" rel=\"..\/..\/index.html#m=cfstepconfig\/get_config\"><code>CFStepConfig::get_config()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/enable_debugging.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/enable_debugging\"><code>enable_debugging()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_hive.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_hive\"><code>install_hive()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_pig.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_pig\"><code>install_pig()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_pig_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_pig_script\"><code>run_pig_script()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/hive.apache.org\">Apache Hive<\/a>"}},{"name":"run_pig_script","modifier":"public static","description":"<p>Step that runs a Pig script on your job flow.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"script","type":"string","description":"<p>The script to run with <code>script-runner.jar<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function run_pig_script($script, $args = null)\n{\n    if (!$args) $args = array();\n    $args = is_array($args) ? $args : array($args);\n    $args = array_merge(array('--run-pig-script', '--args', '-f', $script), $args);\n\n        return self::hive_pig_script('pig', $args);\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfstepconfig\/get_config.html\" rel=\"..\/..\/index.html#m=cfstepconfig\/get_config\"><code>CFStepConfig::get_config()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/enable_debugging.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/enable_debugging\"><code>enable_debugging()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_hive.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_hive\"><code>install_hive()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_pig.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_pig\"><code>install_pig()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_hive_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_hive_script\"><code>run_hive_script()<\/code><\/a>"]},"seealso":{"link":"<a href=\"http:\/\/pig.apache.org\">Apache Pig<\/a>"}},{"name":"script_runner","modifier":"public static","inheritance":{"class":{"name":"CFHadoopBase"}},"description":"<p>Runs a specified script on the master node of your cluster.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"script","type":"string","description":"<p>The script to run with <code>script-runner.jar<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"args","type":"array","description":"<p>An indexed array of arguments to pass to the script.<\/p>"}]},"returnvalue":"<p>A standard array that is intended to be passed into a <a href=\"..\/cfstepconfig\/index.html\" rel=\"..\/..\/index.html#i=cfstepconfig\"><code>CFStepConfig<\/code><\/a> object.<\/p>","source":"public static function script_runner($script, $args = null)\n{\n    if (!$args) $args = array();\n    array_unshift($args, $script);\n\n    return array(\n        'Jar' =&gt; 's3:\/\/' . self::$region . '.elasticmapreduce\/libs\/script-runner\/script-runner.jar',\n        'Args' =&gt; $args\n    );\n}"}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"1"},"property":{"name":"region","inheritance":{"class":{"name":"CFHadoopBase","file":"utilities\/hadoopbase.class.php"}},"modifier":"public static","initializer":{"@attributes":{"type":"string","value":"us-east-1"}}}}}}