{"file":{},"class":{"name":"CFInfo","file":"utilities\/info.class.php","url":"..\/cfinfo\/index.html","description":"<p>Contains a series of methods that provide information about the SDK.<\/p>","metadata":{"version":"2010.10.01","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"methods":{"@attributes":{"count":"1"},"method":{"name":"api_support","modifier":"public static","description":"<p>Gets information about the web service APIs that the SDK supports.<\/p>","returnvalue":"<p>An associative array containing service classes and API versions.<\/p>","source":"public static function api_support()\n{\n    $existing_classes = get_declared_classes();\n\n    foreach (glob(dirname(dirname(__FILE__)) . '\/services\/*.class.php') as $file)\n    {\n        include $file;\n    }\n\n    $with_sdk_classes = get_declared_classes();\n    $new_classes = array_diff($with_sdk_classes, $existing_classes);\n    $filtered_classes = array();\n    $collect = array();\n\n    foreach ($new_classes as $class)\n    {\n        if (strpos($class, 'Amazon') !== false)\n        {\n            $filtered_classes[] = $class;\n        }\n    }\n\n    $filtered_classes = array_values($filtered_classes);\n\n    foreach ($filtered_classes as $class)\n    {\n        $obj = new $class();\n        $collect[get_class($obj)] = $obj-&gt;api_version;\n        unset($obj);\n    }\n\n    return $collect;\n}"}},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"0"}}}}