{"file":{},"class":{"name":"CFJSON","file":"utilities\/json.class.php","url":"..\/cfjson\/index.html","description":"<p>Handles the conversion of data from JSON to other formats.<\/p>","metadata":{"version":"2012.07.27","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"methods":{"@attributes":{"count":"1"},"method":{"name":"to_xml","modifier":"public static","description":"<p>Converts a JSON string to a CFSimpleXML object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"json","type":"string|array","description":"<p>Pass either a valid JSON-formatted string, or an associative array.<\/p>"},{"@attributes":{"choice":"opt"},"name":"parser","type":"string","description":"<p>The name of the class to use to parse the XML. This class should extend <code>SimpleXMLElement<\/code>. Has a default value of <code>CFSimpleXML<\/code>.<\/p>"}]},"returnvalue":"<p>An XML representation of the data.<\/p>","source":"public static function to_xml($json, $parser = 'CFSimpleXML')\n{\n    \/\/ If we haven't parsed the JSON, do it\n    if (!is_array($json))\n    {\n        \/\/ Handle the case of JSON-encoded NULL value\n        if ($json === 'null')\n        {\n            $json = null;\n        }\n        else\n        {\n            $json = json_decode($json, true);\n\n            if (function_exists('json_last_error'))\n            {\n                \/\/ Did we encounter an error?\n                switch (json_last_error())\n                {\n                    case JSON_ERROR_DEPTH:\n                        throw new JSON_Exception('Maximum stack depth exceeded.');\n\n                    case JSON_ERROR_CTRL_CHAR:\n                        throw new JSON_Exception('Unexpected control character found.');\n\n                    case JSON_ERROR_SYNTAX:\n                        throw new JSON_Exception('Syntax error; Malformed JSON.');\n\n                    case JSON_ERROR_STATE_MISMATCH:\n                        throw new JSON_Exception('Invalid or malformed JSON.');\n                }\n            }\n            \/\/ json_last_error() not available?\n            elseif ($json === null)\n            {\n                throw new JSON_Exception('Unknown JSON error. Be sure to validate your JSON and read the notes on http:\/\/php.net\/json_decode.');\n            }\n        }\n    }\n\n    \/\/ Hand off for the recursive work\n    $string = Transmogrifier::to_xml($json, 'rootElement');\n\n    return simplexml_load_string($string, $parser, LIBXML_NOCDATA);\n}"}},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"0"}}}}