{"file":{},"class":{"name":"CFLoader","file":"sdk.class.php","url":"..\/cfloader\/index.html","description":"<p>Contains the functionality for auto-loading service classes.<\/p>","methods":{"@attributes":{"count":"1"},"method":{"name":"autoloader","modifier":"public static","description":"<p>Automatically load classes that aren&#8217;t included.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"class","type":"string","description":"<p>The classname to load.<\/p>"}},"returnvalue":"<p>Whether or not the file was successfully loaded.<\/p>","source":"public static function autoloader($class)\n{\n    $path = dirname(__FILE__) . DIRECTORY_SEPARATOR;\n\n    \/\/ Amazon SDK classes\n    if (strstr($class, 'Amazon'))\n    {\n        if (file_exists($require_this = $path . 'services' . DIRECTORY_SEPARATOR . str_ireplace('Amazon', '', strtolower($class)) . '.class.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Utility classes\n    elseif (strstr($class, 'CF'))\n    {\n        if (file_exists($require_this = $path . 'utilities' . DIRECTORY_SEPARATOR . str_ireplace('CF', '', strtolower($class)) . '.class.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load CacheCore\n    elseif (strstr($class, 'Cache'))\n    {\n        if (file_exists($require_this = $path . 'lib' . DIRECTORY_SEPARATOR . 'cachecore' . DIRECTORY_SEPARATOR . strtolower($class) . '.class.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load RequestCore\n    elseif (strstr($class, 'RequestCore') || strstr($class, 'ResponseCore'))\n    {\n        if (file_exists($require_this = $path . 'lib' . DIRECTORY_SEPARATOR . 'requestcore' . DIRECTORY_SEPARATOR . 'requestcore.class.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load Transmogrifier\n    elseif (strstr($class, 'Transmogrifier'))\n    {\n        if (file_exists($require_this = $path . 'lib' . DIRECTORY_SEPARATOR . 'dom' . DIRECTORY_SEPARATOR . 'Transmogrifier.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load Authentication Signers\n    elseif (strstr($class, 'Auth'))\n    {\n        if (file_exists($require_this = $path . 'authentication' . DIRECTORY_SEPARATOR . str_replace('auth', 'signature_', strtolower($class)) . '.class.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load Signer interface\n    elseif ($class === 'Signer')\n    {\n        if (!interface_exists('Signable', false) &amp;&amp;\n            file_exists($require_this = $path . 'authentication' . DIRECTORY_SEPARATOR . 'signable.interface.php'))\n        {\n            require_once $require_this;\n        }\n\n        if (file_exists($require_this = $path . 'authentication' . DIRECTORY_SEPARATOR . 'signer.abstract.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    \/\/ Load Symfony YAML classes\n    elseif (strstr($class, 'sfYaml'))\n    {\n        if (file_exists($require_this = $path . 'lib' . DIRECTORY_SEPARATOR . 'yaml' . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR . 'sfYaml.php'))\n        {\n            require_once $require_this;\n            return true;\n        }\n\n        return false;\n    }\n\n    return false;\n}"}},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"0"}}}}