{"file":{},"class":{"name":"CFResponse","file":"utilities\/response.class.php","url":"..\/cfresponse\/index.html","description":"<p>Wraps the underlying <code>ResponseCore<\/code> class with some AWS-specific customizations. Response\nbodies are typically represented as CFSimpleXML objects.<\/p>","metadata":{"version":"2010.10.11","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"inheritance":{"class":{"name":"ResponseCore","file":"lib\/requestcore\/requestcore.class.php"}},"methods":{"@attributes":{"count":"2"},"method":[{"name":"__construct","modifier":"public","inheritance":{"class":{"name":"ResponseCore"}},"description":"<p>Constructs a new instance of this class.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"header","type":"array","description":"<p>Associative array of HTTP headers (typically returned by &lt;RequestCore::get_response_header()>).<\/p>"},{"@attributes":{"choice":"req"},"name":"body","type":"string","description":"<p>XML-formatted response from AWS.<\/p>"},{"@attributes":{"choice":"opt"},"name":"status","type":"integer","description":"<p>HTTP response status code from the request.<\/p>"}]},"returnvalue":"<p>Contains an <a href=\"http:\/\/php.net\/array\"><code>array<\/code><\/a> <code>header<\/code> property (HTTP headers as an associative array), a <a href=\"http:\/\/php.net\/simplexmlelement\"><code>SimpleXMLElement<\/code><\/a> or <a href=\"http:\/\/php.net\/string\"><code>string<\/code><\/a> <code>body<\/code> property, and an <a href=\"http:\/\/php.net\/integer\"><code>integer<\/code><\/a> <code>status<\/code> code.<\/p>","source":{"@attributes":{"file":"lib\/requestcore\/requestcore.class.php","start":"1027","end":"1034","lines":"8"}}},{"name":"isOK","modifier":"public","inheritance":{"class":{"name":"ResponseCore"}},"description":"<p>Did we receive the status code we expected?<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"codes","type":"integer|array","description":"<p>The status code(s) to expect. Pass an <a href=\"http:\/\/php.net\/integer\"><code>integer<\/code><\/a> for a single acceptable value, or an <a href=\"http:\/\/php.net\/array\"><code>array<\/code><\/a> of integers for multiple acceptable values.<\/p>"}},"returnvalue":"<p>Whether we received the expected status code or not.<\/p>","source":{"@attributes":{"file":"lib\/requestcore\/requestcore.class.php","start":"1042","end":"1050","lines":"9"}},"examples":{"example":[{"title":"<p>Successful response code should make isOK() return true.<\/p>","code":"$http = new RequestCore('http:\/\/github.com\/skyzyx\/requestcore\/raw\/master\/_tests\/test_request.txt');\n$http-&gt;send_request();\n\n$response = new ResponseCore(\n\t$http-&gt;get_response_header(),\n\t$http-&gt;get_response_body(),\n\t$http-&gt;get_response_code()\n);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Invalid response code (e.g. 999) should make isOK() fail.<\/p>","code":"$http = new RequestCore('http:\/\/github.com\/skyzyx\/requestcore\/raw\/master\/_tests\/test_request.txt');\n$http-&gt;send_request();\n\n$response = new ResponseCore(\n\t$http-&gt;get_response_header(),\n\t$http-&gt;get_response_body(),\n\t999\n);\n\nvar_dump($response-&gt;isOK());","result":"bool(false)"},{"title":"<p>Standard request with a standard (successful) response code.<\/p>","code":"$http = new RequestCore('http:\/\/github.com\/skyzyx\/requestcore\/raw\/master\/_tests\/test_request.txt');\n$http-&gt;set_method($http::HTTP_PUT);\n$response = $http-&gt;send_request(true);\n\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Test response code 200 explicitly, excluding other valid response codes.<\/p>","code":"$http = new RequestCore('http:\/\/github.com\/skyzyx\/requestcore\/raw\/master\/_tests\/test_request.txt');\n$http-&gt;set_method($http::HTTP_PUT);\n$response = $http-&gt;send_request(true);\n\nvar_dump($response-&gt;isOK(200));","result":"bool(true)"}]}}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"3"},"property":[{"name":"body","inheritance":{"class":{"name":"ResponseCore","file":"lib\/requestcore\/requestcore.class.php"}},"modifier":"public","description":"<p>Stores the SimpleXML response.<\/p>"},{"name":"header","inheritance":{"class":{"name":"ResponseCore","file":"lib\/requestcore\/requestcore.class.php"}},"modifier":"public","description":"<p>Stores the HTTP header information.<\/p>"},{"name":"status","inheritance":{"class":{"name":"ResponseCore","file":"lib\/requestcore\/requestcore.class.php"}},"modifier":"public","description":"<p>Stores the HTTP response code.<\/p>"}]}}}