{"file":{},"class":{"name":"CFStackTemplate","file":"utilities\/stacktemplate.class.php","url":"..\/cfstacktemplate\/index.html","description":"<p>Simplifies the process of preparing JSON stack templates.<\/p>","metadata":{"version":"2011.02.03","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"methods":{"@attributes":{"count":"2"},"method":[{"name":"json","modifier":"public static","description":"<p>Removes whitespace from a JSON template.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"template","type":"string","description":"<p>A JSON representation of the stack template. Must have <a href=\"http:\/\/docs.php.net\/manual\/en\/function.json-decode.php#refsect1-function.json-decode-examples\">strict JSON-specific formatting<\/a>.<\/p>"}},"returnvalue":"<p>A JSON representation of the template.<\/p>","source":"public static function json($template)\n{\n    return json_encode(json_decode($template, true));\n}","examples":{"example":{"title":"<p>Handle JSON version of the template.<\/p>","code":"$template = CFStackTemplate::json('{\n\t&quot;AWSTemplateFormatVersion&quot; : &quot;2010-09-09&quot;,\n\t&quot;Description&quot; : &quot;Create an EC2 instance running the Amazon Linux 32 bit AMI.&quot;,\n\t&quot;Parameters&quot; : {\n\t\t&quot;KeyPair&quot; : {\n\t\t\t&quot;Description&quot; : &quot;The EC2 Key Pair to allow SSH access to the instance&quot;,\n\t\t\t&quot;Type&quot; : &quot;String&quot;\n\t\t}\n\t},\n\t&quot;Mappings&quot; : {\n\t\t&quot;RegionMap&quot; : {\n\t\t\t&quot;us-east-1&quot; : { &quot;AMI&quot; : &quot;ami-76f0061f&quot; },\n\t\t\t&quot;us-west-1&quot; : { &quot;AMI&quot; : &quot;ami-655a0a20&quot; },\n\t\t\t&quot;eu-west-1&quot; : {\t&quot;AMI&quot; : &quot;ami-7fd4e10b&quot; },\n\t\t\t&quot;ap-southeast-1&quot; : { &quot;AMI&quot; : &quot;ami-72621c20&quot; }\n\t\t}\n\t},\n\t&quot;Resources&quot; : {\n\t\t&quot;Ec2Instance&quot; : {\n\t\t\t&quot;Type&quot; : &quot;AWS::EC2::Instance&quot;,\n\t\t\t&quot;Properties&quot; : {\n\t\t\t\t&quot;KeyName&quot; : { &quot;Ref&quot; : &quot;KeyPair&quot; },\n\t\t\t\t&quot;ImageId&quot; : { &quot;Fn::FindInMap&quot; : [ &quot;RegionMap&quot;, { &quot;Ref&quot; : &quot;AWS::Region&quot; }, &quot;AMI&quot; ]}\n\t\t\t}\n\t\t}\n\t},\n\t&quot;Outputs&quot; : {\n\t\t&quot;InstanceId&quot; : {\n\t\t\t&quot;Description&quot; : &quot;The InstanceId of the newly created EC2 instance&quot;,\n\t\t\t&quot;Value&quot; : { &quot;Ref&quot; : &quot;Ec2Instance&quot; }\n\t\t},\n\t\t&quot;AZ&quot; : {\n\t\t\t&quot;Description&quot; : &quot;The Availability Zone of the newly created EC2 instance&quot;,\n\t\t\t&quot;Value&quot; : { &quot;Fn::GetAtt&quot; : [ &quot;Ec2Instance&quot;, &quot;AvailabilityZone&quot; ] }\n\t\t},\n\t\t&quot;PublicIP&quot; : {\n\t\t\t&quot;Description&quot; : &quot;The Public IP address of the newly created EC2 instance&quot;,\n\t\t\t&quot;Value&quot; : { &quot;Fn::GetAtt&quot; : [ &quot;Ec2Instance&quot;, &quot;PublicIp&quot; ] }\n\t\t}\n\t}\n}');\n\nvar_dump(sha1($template));","result":"string(40) \"9424c0db71fca8b6e0200d77571e41bb867d7f4b\""}},"related":{"method":["<a href=\"..\/amazoncloudformation\/get_template.html\" rel=\"..\/..\/index.html#m=amazoncloudformation\/get_template\"><code>AmazonCloudFormation::get_template()<\/code><\/a>","<a href=\"..\/amazoncloudformation\/validate_template.html\" rel=\"..\/..\/index.html#m=amazoncloudformation\/validate_template\"><code>AmazonCloudFormation::validate_template()<\/code><\/a>","<a href=\"..\/cfstacktemplate\/map.html\" rel=\"..\/..\/index.html#m=cfstacktemplate\/map\"><code>map()<\/code><\/a>"]}},{"name":"map","modifier":"public static","description":"<p>Converts an associative array (map) of the template into a JSON string.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"template","type":"array","description":"<p>An associative array that maps directly to its JSON counterpart.<\/p>"}},"returnvalue":"<p>A JSON representation of the template.<\/p>","source":"public static function map($template)\n{\n    return json_encode($template);\n}","examples":{"example":{"title":"<p>Handle associative array (map) version of the template.<\/p>","code":"$template = CFStackTemplate::map(array(\n\t'AWSTemplateFormatVersion' =&gt; '2010-09-09',\n\t'Description' =&gt; 'Create an EC2 instance running the Amazon Linux 32 bit AMI.',\n\t'Parameters' =&gt; array(\n\t\t'KeyPair' =&gt; array(\n\t\t\t'Description' =&gt; 'The EC2 Key Pair to allow SSH access to the instance',\n\t\t\t'Type' =&gt; 'String'\n\t\t)\n\t),\n\t'Mappings' =&gt; array(\n\t\t'RegionMap' =&gt; array(\n\t\t\t'us-east-1' =&gt; array( 'AMI' =&gt; 'ami-76f0061f' ),\n\t\t\t'us-west-1' =&gt; array( 'AMI' =&gt; 'ami-655a0a20' ),\n\t\t\t'eu-west-1' =&gt; array(\t'AMI' =&gt; 'ami-7fd4e10b' ),\n\t\t\t'ap-southeast-1' =&gt; array( 'AMI' =&gt; 'ami-72621c20' )\n\t\t)\n\t),\n\t'Resources' =&gt; array(\n\t\t'Ec2Instance' =&gt; array(\n\t\t\t'Type' =&gt; 'AWS::EC2::Instance',\n\t\t\t'Properties' =&gt; array(\n\t\t\t\t'KeyName' =&gt; array( 'Ref' =&gt; 'KeyPair' ),\n\t\t\t\t'ImageId' =&gt; array( 'Fn::FindInMap' =&gt; array( 'RegionMap', array( 'Ref' =&gt; 'AWS::Region' ), 'AMI' ))\n\t\t\t)\n\t\t)\n\t),\n\t'Outputs' =&gt; array(\n\t\t'InstanceId' =&gt; array(\n\t\t\t'Description' =&gt; 'The InstanceId of the newly created EC2 instance',\n\t\t\t'Value' =&gt; array( 'Ref' =&gt; 'Ec2Instance' )\n\t\t),\n\t\t'AZ' =&gt; array(\n\t\t\t'Description' =&gt; 'The Availability Zone of the newly created EC2 instance',\n\t\t\t'Value' =&gt; array( 'Fn::GetAtt' =&gt; array( 'Ec2Instance', 'AvailabilityZone' ) )\n\t\t),\n\t\t'PublicIP' =&gt; array(\n\t\t\t'Description' =&gt; 'The Public IP address of the newly created EC2 instance',\n\t\t\t'Value' =&gt; array( 'Fn::GetAtt' =&gt; array( 'Ec2Instance', 'PublicIp' ) )\n\t\t)\n\t)\n));\n\nvar_dump(sha1($template));","result":"string(40) \"9424c0db71fca8b6e0200d77571e41bb867d7f4b\""}},"related":{"method":["<a href=\"..\/amazoncloudformation\/get_template.html\" rel=\"..\/..\/index.html#m=amazoncloudformation\/get_template\"><code>AmazonCloudFormation::get_template()<\/code><\/a>","<a href=\"..\/amazoncloudformation\/validate_template.html\" rel=\"..\/..\/index.html#m=amazoncloudformation\/validate_template\"><code>AmazonCloudFormation::validate_template()<\/code><\/a>","<a href=\"..\/cfstacktemplate\/json.html\" rel=\"..\/..\/index.html#m=cfstacktemplate\/json\"><code>json()<\/code><\/a>"]}}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"0"}}}}