{"file":{},"class":{"name":"CFStepConfig","file":"utilities\/stepconfig.class.php","url":"..\/cfstepconfig\/index.html","description":"<p>Contains functionality for simplifying Amazon EMR Hadoop steps.<\/p>","metadata":{"version":"2010.11.16","license":"See the included NOTICE.md file for more information.","copyright":"See the included NOTICE.md file for more information.","link":"http:\/\/aws.amazon.com\/php\/ PHP Developer Center"},"methods":{"@attributes":{"count":"4"},"method":[{"name":"__construct","modifier":"public","description":"<p>Constructs a new instance of this class.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"config","type":"array","description":"<p>An associative array representing the Hadoop step configuration.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function __construct($config)\n{\n    \/\/ Handle Hadoop jar arguments\n    if (isset($config['HadoopJarStep']['Args']) &amp;&amp; $args = $config['HadoopJarStep']['Args'])\n    {\n        $config['HadoopJarStep']['Args'] = is_array($args) ? $args : array($args);\n    }\n\n    $this-&gt;config = $config;\n}"},{"name":"__toString","modifier":"public","description":"<p>Returns a JSON representation of the object when typecast as a string.<\/p>","returnvalue":"<p>A JSON representation of the object.<\/p>","source":"public function __toString()\n{\n    return json_encode($this-&gt;config);\n}","seealso":{"link":"<a href=\"http:\/\/www.php.net\/manual\/en\/language.oop5.magic.php#language.oop5.magic.tostring\">PHP Magic Methods<\/a>"}},{"name":"get_config","modifier":"public","description":"<p>Returns the configuration data.<\/p>","returnvalue":"<p>The configuration data.<\/p>","source":"public function get_config()\n{\n    return $this-&gt;config;\n}","related":{"method":["<a href=\"..\/amazonemr\/add_job_flow_steps.html\" rel=\"..\/..\/index.html#m=amazonemr\/add_job_flow_steps\"><code>AmazonEMR::add_job_flow_steps()<\/code><\/a>","<a href=\"..\/amazonemr\/describe_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/describe_job_flows\"><code>AmazonEMR::describe_job_flows()<\/code><\/a>","<a href=\"..\/amazonemr\/run_job_flow.html\" rel=\"..\/..\/index.html#m=amazonemr\/run_job_flow\"><code>AmazonEMR::run_job_flow()<\/code><\/a>","<a href=\"..\/amazonemr\/terminate_job_flows.html\" rel=\"..\/..\/index.html#m=amazonemr\/terminate_job_flows\"><code>AmazonEMR::terminate_job_flows()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/enable_debugging.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/enable_debugging\"><code>CFHadoopStep::enable_debugging()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_hive.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_hive\"><code>CFHadoopStep::install_hive()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/install_pig.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/install_pig\"><code>CFHadoopStep::install_pig()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_hive_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_hive_script\"><code>CFHadoopStep::run_hive_script()<\/code><\/a>","<a href=\"..\/cfhadoopstep\/run_pig_script.html\" rel=\"..\/..\/index.html#m=cfhadoopstep\/run_pig_script\"><code>CFHadoopStep::run_pig_script()<\/code><\/a>"]}},{"name":"init","modifier":"public static","description":"<p>Constructs a new instance of this class, and allows chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"config","type":"array","description":"<p>An associative array representing the Hadoop step configuration.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public static function init($config)\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::init().');\n    }\n\n    $self = get_called_class();\n    return new $self($config);\n}"}]},"constants":{"@attributes":{"count":"0"}},"properties":{"@attributes":{"count":"1"},"property":{"name":"config","modifier":"public","description":"<p>Stores the configuration map.<\/p>"}}}}