{"file":{},"class":{"name":"S3BrowserUpload","file":"extensions\/s3browserupload.class.php","url":"..\/s3browserupload\/index.html","description":{},"inheritance":{"class":[{"name":"AmazonS3","file":"services\/s3.class.php","url":"..\/amazons3\/index.html"},{"name":"CFRuntime","file":"sdk.class.php","url":"..\/cfruntime\/index.html"}]},"methods":{"@attributes":{"count":"113"},"method":[{"name":"__construct","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Constructs a new instance of <a href=\"..\/amazons3\/index.html\" rel=\"..\/..\/index.html#i=amazons3\"><code>AmazonS3<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/s3browserupload\/set_cache_config.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public function __construct(array $options = array())\n{\n    $this-&gt;vhost = null;\n    $this-&gt;api_version = '2006-03-01';\n    $this-&gt;hostname = self::DEFAULT_URL;\n\n    $this-&gt;base_acp_xml             = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;&lt;AccessControlPolicy xmlns=&quot;http:\/\/s3.amazonaws.com\/doc\/latest\/&quot;\/&gt;';\n    $this-&gt;base_location_constraint = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;&lt;CreateBucketConfiguration xmlns=&quot;http:\/\/s3.amazonaws.com\/doc\/' . $this-&gt;api_version . '\/&quot;&gt;&lt;LocationConstraint\/&gt;&lt;\/CreateBucketConfiguration&gt;';\n    $this-&gt;base_logging_xml         = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;BucketLoggingStatus xmlns=&quot;http:\/\/doc.s3.amazonaws.com\/' . $this-&gt;api_version . '&quot;\/&gt;';\n    $this-&gt;base_notification_xml    = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;NotificationConfiguration\/&gt;';\n    $this-&gt;base_versioning_xml      = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;VersioningConfiguration xmlns=&quot;http:\/\/s3.amazonaws.com\/doc\/' . $this-&gt;api_version . '\/&quot;\/&gt;';\n    $this-&gt;complete_mpu_xml         = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;CompleteMultipartUpload\/&gt;';\n    $this-&gt;website_config_xml       = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;WebsiteConfiguration xmlns=&quot;http:\/\/s3.amazonaws.com\/doc\/' . $this-&gt;api_version . '\/&quot;&gt;&lt;IndexDocument&gt;&lt;Suffix&gt;index.html&lt;\/Suffix&gt;&lt;\/IndexDocument&gt;&lt;ErrorDocument&gt;&lt;Key&gt;error.html&lt;\/Key&gt;&lt;\/ErrorDocument&gt;&lt;\/WebsiteConfiguration&gt;';\n    $this-&gt;multi_object_delete_xml  = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;Delete\/&gt;';\n    $this-&gt;object_expiration_xml    = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;LifecycleConfiguration\/&gt;';\n    $this-&gt;bucket_tagging_xml       = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;Tagging&gt;&lt;TagSet\/&gt;&lt;\/Tagging&gt;';\n    $this-&gt;cors_config_xml          = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;CORSConfiguration \/&gt;';\n    $this-&gt;restore_request_xml      = '&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;&lt;RestoreRequest xmlns=&quot;http:\/\/s3.amazonaws.com\/doc\/' . $this-&gt;api_version . '&quot;\/&gt;';\n\n    parent::__construct($options);\n}"},{"name":"abort_multipart_upload","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Aborts an in-progress multipart upload. This operation cannot be reversed.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"upload_id","type":"string","description":"<p>The upload ID identifying the multipart upload whose parts are being listed. The upload ID is retrieved from a call to <a href=\"..\/s3browserupload\/initiate_multipart_upload.html\" rel=\"..\/..\/index.html#m=s3browserupload\/initiate_multipart_upload\"><code>initiate_multipart_upload()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function abort_multipart_upload($bucket, $filename, $upload_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'DELETE';\n    $opt['resource'] = $filename;\n    $opt['uploadId'] = $upload_id;\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Abort a multipart upload. This will delete all completed parts for this multipart upload.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Abort an in-progress multipart upload\n$response = $s3-&gt;abort_multipart_upload($bucket, 'tv_episode.mp4', 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"abort_multipart_uploads_by_date","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Aborts all multipart uploads initiated before the specified date. This operation cannot be reversed.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"when","type":"string|integer","description":"<p>The time and date to use for comparison. Accepts any value that <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> understands.<\/p>"}]},"returnvalue":"<p>A <a href=\"..\/cfarray\/index.html\" rel=\"..\/..\/index.html#i=cfarray\"><code>CFArray<\/code><\/a> containing a series of 0 or more <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects, containing a parsed HTTP response.<\/p>","source":"public function abort_multipart_uploads_by_date($bucket, $when = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ @codeCoverageIgnoreStart\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n        \/\/ @codeCoverageIgnoreEnd\n    }\n\n    $when = $when ? $when : time();\n    $handles = array();\n    $data = $this-&gt;list_multipart_uploads($bucket)-&gt;body;\n    $when = is_int($when) ? $when : strtotime($when);\n\n    if (!($data instanceof CFSimpleXML))\n    {\n        return false;\n    }\n\n    $list = $data-&gt;query('descendant-or-self::Upload\/Initiated');\n\n    if (count($list) &gt; 0)\n    {\n        foreach ($list as $node)\n        {\n            if (strtotime((string) $node) &lt; $when)\n            {\n                $q = new CFBatchRequest();\n                $parent = $node-&gt;parent();\n\n                $upload_id = $parent\n                    -&gt;query('descendant-or-self::UploadId')\n                    -&gt;first()\n                    -&gt;to_string();\n\n                $filename = $parent\n                    -&gt;query('descendant-or-self::Key')\n                    -&gt;first()\n                    -&gt;to_string();\n\n                $handles[] = $this-&gt;abort_multipart_upload($bucket, $filename, $upload_id, array(\n                    'returnCurlHandle' =&gt; true\n                ));\n            }\n        }\n\n        $http = new CFRequest();\n        $responses = $http-&gt;send_multi_request($handles);\n\n        if (is_array($responses) &amp;&amp; count($responses) &gt; 0)\n        {\n            return new CFArray($responses);\n        }\n    }\n\n    return new CFArray();\n}","examples":{"example":{"title":"<p>Abort all multipart uploads that were initiated before a given date.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Delete everything before right now.\n$response = $s3-&gt;abort_multipart_uploads_by_date($bucket);\n\n\/\/ Delete everything before 20 minutes ago\n$response = $s3-&gt;abort_multipart_uploads_by_date($bucket, '20 minutes ago');\n\n\/\/ Delete everything before yesterday\n$response = $s3-&gt;abort_multipart_uploads_by_date($bucket, 'yesterday');\n\n\/\/ Delete everything before a specific date.\n$response = $s3-&gt;abort_multipart_uploads_by_date($bucket, '1 November 2010');\n\n\/\/ Delete everything before a specific date.\n$response = $s3-&gt;abort_multipart_uploads_by_date('my-bucket-doesnotexist', '1 November 2010');\n\n\/\/ Success?\nvar_dump($response-&gt;areOK());","result":"bool(true)"}}},{"name":"allow_hostname_override","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables any subsequent use of the <a href=\"..\/s3browserupload\/set_hostname.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_hostname\"><code>set_hostname()<\/code><\/a> method.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"override","type":"boolean","description":"<p>Whether or not subsequent calls to <a href=\"..\/s3browserupload\/set_hostname.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_hostname\"><code>set_hostname()<\/code><\/a> should be obeyed. A <code>false<\/code> value disables the further effectiveness of <a href=\"..\/s3browserupload\/set_hostname.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_hostname\"><code>set_hostname()<\/code><\/a>. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function allow_hostname_override($override = true)\n{\n    $this-&gt;override_hostname = $override;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"authenticate","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Authenticates a connection to Amazon S3. Do not use directly unless implementing custom methods for\nthis class.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"operation","type":"string","description":"<p>The name of the bucket to operate on (S3 Only).<\/p>"},{"@attributes":{"choice":"req"},"name":"payload","type":"array","description":"<p>An associative array of parameters for authenticating. See inline comments for allowed keys.<\/p>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function authenticate($operation, $payload)\n{\n    \/*\n     * Overriding or extending this class? You can pass the following &quot;magic&quot; keys into $opt.\n     *\n     * ## verb, resource, sub_resource and query_string ##\n     *     &lt;verb&gt; \/&lt;resource&gt;?&lt;sub_resource&gt;&amp;&lt;query_string&gt;\n     *     GET \/filename.txt?versions&amp;prefix=abc&amp;max-items=1\n     *\n     * ## versionId, uploadId, partNumber, response-* ##\n     *     These don't follow the same rules as above, in that the they needs to be signed, while\n     *     other query_string values do not.\n     *\n     * ## curlopts ##\n     *     These values get passed directly to the cURL methods in RequestCore.\n     *\n     * ## fileUpload, fileDownload, seekTo ##\n     *     These are slightly modified and then passed to the cURL methods in RequestCore.\n     *\n     * ## headers ##\n     *     $opt['headers'] is an array, whose keys are HTTP headers to be sent.\n     *\n     * ## body ##\n     *     This is the request body that is sent to the server via PUT\/POST.\n     *\n     * ## preauth ##\n     *     This is a hook that tells authenticate() to generate a pre-authenticated URL.\n     *\n     * ## returnCurlHandle ##\n     *     Tells authenticate() to return the cURL handle for the request instead of executing it.\n     *\/\n\n    \/\/ Rename variables (to overcome inheritence issues)\n    $bucket = $operation;\n    $opt = $payload;\n\n    \/\/ Validate the S3 bucket name\n    if (!$this-&gt;validate_bucketname_support($bucket))\n    {\n        \/\/ @codeCoverageIgnoreStart\n        throw new S3_Exception('S3 does not support &quot;' . $bucket . '&quot; as a valid bucket name. Review &quot;Bucket Restrictions and Limitations&quot; in the S3 Developer Guide for more information.');\n        \/\/ @codeCoverageIgnoreEnd\n    }\n\n    \/\/ Die if $opt isn't set.\n    if (!$opt) return false;\n\n    $method_arguments = func_get_args();\n\n    \/\/ Use the caching flow to determine if we need to do a round-trip to the server.\n    if ($this-&gt;use_cache_flow)\n    {\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $bucket . '_' . sha1(serialize($method_arguments));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);\n\n        if ($this-&gt;parse_the_response)\n        {\n            \/\/ Parse the XML body\n            $data = $this-&gt;parse_callback($data);\n        }\n\n        \/\/ End!\n        return $data;\n    }\n\n    \/\/ If we haven't already set a resource prefix and the bucket name isn't DNS-valid...\n    if ((!$this-&gt;resource_prefix &amp;&amp; !$this-&gt;validate_bucketname_create($bucket)) || $this-&gt;path_style)\n    {\n        \/\/ Fall back to the older path-style URI\n        $this-&gt;set_resource_prefix('\/' . $bucket);\n        $this-&gt;temporary_prefix = true;\n    }\n\n    \/\/ If the bucket name has periods and we are using SSL, we need to switch to path style URLs\n    $bucket_name_may_cause_ssl_wildcard_failures = false;\n    if ($this-&gt;use_ssl &amp;&amp; strpos($bucket, '.') !== false)\n    {\n        $bucket_name_may_cause_ssl_wildcard_failures = true;\n    }\n\n    \/\/ Determine hostname\n    $scheme = $this-&gt;use_ssl ? 'https:\/\/' : 'http:\/\/';\n    if ($bucket_name_may_cause_ssl_wildcard_failures || $this-&gt;resource_prefix || $this-&gt;path_style)\n    {\n        \/\/ Use bucket-in-path method\n        $hostname = $this-&gt;hostname . $this-&gt;resource_prefix . (($bucket === '' || $this-&gt;resource_prefix === '\/' . $bucket) ? '' : ('\/' . $bucket));\n    }\n    else\n    {\n        $hostname = $this-&gt;vhost ? $this-&gt;vhost : (($bucket === '') ? $this-&gt;hostname : ($bucket . '.') . $this-&gt;hostname);\n    }\n\n    \/\/ Get the UTC timestamp in RFC 2616 format\n    $date = gmdate(CFUtilities::DATE_FORMAT_RFC2616, time());\n\n    \/\/ Storage for request parameters.\n    $resource = '';\n    $sub_resource = '';\n    $querystringparams = array();\n    $signable_querystringparams = array();\n    $string_to_sign = '';\n    $headers = array(\n        'Content-MD5' =&gt; '',\n        'Content-Type' =&gt; 'application\/x-www-form-urlencoded',\n        'Date' =&gt; $date\n    );\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ Do we have an authentication token?\n    if ($this-&gt;auth_token)\n    {\n        $headers['X-Amz-Security-Token'] = $this-&gt;auth_token;\n    }\n\n    \/\/ Handle specific resources\n    if (isset($opt['resource']))\n    {\n        $resource .= $opt['resource'];\n    }\n\n    \/\/ Merge query string values\n    if (isset($opt['query_string']))\n    {\n        $querystringparams = array_merge($querystringparams, $opt['query_string']);\n    }\n    $query_string = $this-&gt;util-&gt;to_query_string($querystringparams);\n\n    \/\/ Merge the signable query string values. Must be alphabetical.\n    $signable_list = array(\n        'partNumber',\n        'response-cache-control',\n        'response-content-disposition',\n        'response-content-encoding',\n        'response-content-language',\n        'response-content-type',\n        'response-expires',\n        'uploadId',\n        'versionId'\n    );\n    foreach ($signable_list as $item)\n    {\n        if (isset($opt[$item]))\n        {\n            $signable_querystringparams[$item] = $opt[$item];\n        }\n    }\n    $signable_query_string = $this-&gt;util-&gt;to_query_string($signable_querystringparams);\n\n    \/\/ Merge the HTTP headers\n    if (isset($opt['headers']))\n    {\n        $headers = array_merge($headers, $opt['headers']);\n    }\n\n    \/\/ Compile the URI to request\n    $conjunction = '?';\n    $signable_resource = '\/' . str_replace('%2F', '\/', rawurlencode($resource));\n    $non_signable_resource = '';\n\n    if (isset($opt['sub_resource']))\n    {\n        $signable_resource .= $conjunction . rawurlencode($opt['sub_resource']);\n        $conjunction = '&amp;';\n    }\n    if ($signable_query_string !== '')\n    {\n        $signable_query_string = $conjunction . $signable_query_string;\n        $conjunction = '&amp;';\n    }\n    if ($query_string !== '')\n    {\n        $non_signable_resource .= $conjunction . $query_string;\n        $conjunction = '&amp;';\n    }\n    if (substr($hostname, -1) === substr($signable_resource, 0, 1))\n    {\n        $signable_resource = ltrim($signable_resource, '\/');\n    }\n\n    $this-&gt;request_url = $scheme . $hostname . $signable_resource . $signable_query_string . $non_signable_resource;\n\n    if (isset($opt['location']))\n    {\n        $this-&gt;request_url = $opt['location'];\n    }\n\n    \/\/ Gather information to pass along to other classes.\n    $helpers = array(\n        'utilities' =&gt; $this-&gt;utilities_class,\n        'request' =&gt; $this-&gt;request_class,\n        'response' =&gt; $this-&gt;response_class,\n    );\n\n    \/\/ Instantiate the request class\n    $request = new $this-&gt;request_class($this-&gt;request_url, $this-&gt;proxy, $helpers, $this-&gt;credentials);\n\n    \/\/ Update RequestCore settings\n    $request-&gt;request_class = $this-&gt;request_class;\n    $request-&gt;response_class = $this-&gt;response_class;\n    $request-&gt;ssl_verification = $this-&gt;ssl_verification;\n\n    \/\/ Pass along registered stream callbacks\n    if ($this-&gt;registered_streaming_read_callback)\n    {\n        $request-&gt;register_streaming_read_callback($this-&gt;registered_streaming_read_callback);\n    }\n\n    if ($this-&gt;registered_streaming_write_callback)\n    {\n        $request-&gt;register_streaming_write_callback($this-&gt;registered_streaming_write_callback);\n    }\n\n    \/\/ Streaming uploads\n    if (isset($opt['fileUpload']))\n    {\n        if (is_resource($opt['fileUpload']))\n        {\n            \/\/ Determine the length to read from the stream\n            $length = null; \/\/ From current position until EOF by default, size determined by set_read_stream()\n\n            if (isset($headers['Content-Length']))\n            {\n                $length = $headers['Content-Length'];\n            }\n            elseif (isset($opt['seekTo']))\n            {\n                \/\/ Read from seekTo until EOF by default\n                $stats = fstat($opt['fileUpload']);\n\n                if ($stats &amp;&amp; $stats['size'] &gt;= 0)\n                {\n                    $length = $stats['size'] - (integer) $opt['seekTo'];\n                }\n            }\n\n            $request-&gt;set_read_stream($opt['fileUpload'], $length);\n\n            if ($headers['Content-Type'] === 'application\/x-www-form-urlencoded')\n            {\n                $headers['Content-Type'] = 'application\/octet-stream';\n            }\n        }\n        else\n        {\n            $request-&gt;set_read_file($opt['fileUpload']);\n\n            \/\/ Determine the length to read from the file\n            $length = $request-&gt;read_stream_size; \/\/ The file size by default\n\n            if (isset($headers['Content-Length']))\n            {\n                $length = $headers['Content-Length'];\n            }\n            elseif (isset($opt['seekTo']) &amp;&amp; isset($length))\n            {\n                \/\/ Read from seekTo until EOF by default\n                $length -= (integer) $opt['seekTo'];\n            }\n\n            $request-&gt;set_read_stream_size($length);\n\n            \/\/ Attempt to guess the correct mime-type\n            if ($headers['Content-Type'] === 'application\/x-www-form-urlencoded')\n            {\n                $extension = explode('.', $opt['fileUpload']);\n                $extension = array_pop($extension);\n                $mime_type = CFMimeTypes::get_mimetype($extension);\n                $headers['Content-Type'] = $mime_type;\n            }\n        }\n\n        $headers['Content-Length'] = $request-&gt;read_stream_size;\n        $headers['Content-MD5'] = '';\n    }\n\n    \/\/ Handle streaming file offsets\n    if (isset($opt['seekTo']))\n    {\n        \/\/ Pass the seek position to RequestCore\n        $request-&gt;set_seek_position((integer) $opt['seekTo']);\n    }\n\n    \/\/ Streaming downloads\n    if (isset($opt['fileDownload']))\n    {\n        if (is_resource($opt['fileDownload']))\n        {\n            $request-&gt;set_write_stream($opt['fileDownload']);\n        }\n        else\n        {\n            $request-&gt;set_write_file($opt['fileDownload']);\n        }\n    }\n\n    $curlopts = array();\n\n    \/\/ Set custom CURLOPT settings\n    if (isset($opt['curlopts']))\n    {\n        $curlopts = $opt['curlopts'];\n    }\n\n    \/\/ Debug mode\n    if ($this-&gt;debug_mode)\n    {\n        $curlopts[CURLOPT_VERBOSE] = true;\n    }\n\n    \/\/ Set the curl options.\n    if (count($curlopts))\n    {\n        $request-&gt;set_curlopts($curlopts);\n    }\n\n    \/\/ Do we have a verb?\n    if (isset($opt['verb']))\n    {\n        $request-&gt;set_method($opt['verb']);\n        $string_to_sign .= $opt['verb'] . &quot;\\n&quot;;\n    }\n\n    \/\/ Add headers and content when we have a body\n    if (isset($opt['body']))\n    {\n        $request-&gt;set_body($opt['body']);\n        $headers['Content-Length'] = strlen($opt['body']);\n\n        if ($headers['Content-Type'] === 'application\/x-www-form-urlencoded')\n        {\n            $headers['Content-Type'] = 'application\/octet-stream';\n        }\n\n        if (!isset($opt['NoContentMD5']) || $opt['NoContentMD5'] !== true)\n        {\n            $headers['Content-MD5'] = $this-&gt;util-&gt;hex_to_base64(md5($opt['body']));\n        }\n    }\n\n    \/\/ Handle query-string authentication\n    if (isset($opt['preauth']) &amp;&amp; (integer) $opt['preauth'] &gt; 0)\n    {\n        unset($headers['Date']);\n        $headers['Content-Type'] = '';\n        $headers['Expires'] = is_int($opt['preauth']) ? $opt['preauth'] : strtotime($opt['preauth']);\n    }\n\n    \/\/ Sort headers\n    uksort($headers, 'strnatcasecmp');\n\n    \/\/ Add headers to request and compute the string to sign\n    foreach ($headers as $header_key =&gt; $header_value)\n    {\n        \/\/ Strip linebreaks from header values as they're illegal and can allow for security issues\n        $header_value = str_replace(array(&quot;\\r&quot;, &quot;\\n&quot;), '', $header_value);\n\n        \/\/ Add the header if it has a value\n        if ($header_value !== '')\n        {\n            $request-&gt;add_header($header_key, $header_value);\n        }\n\n        \/\/ Generate the string to sign\n        if (\n            strtolower($header_key) === 'content-md5' ||\n            strtolower($header_key) === 'content-type' ||\n            strtolower($header_key) === 'date' ||\n            (strtolower($header_key) === 'expires' &amp;&amp; isset($opt['preauth']) &amp;&amp; (integer) $opt['preauth'] &gt; 0)\n        )\n        {\n            $string_to_sign .= $header_value . &quot;\\n&quot;;\n        }\n        elseif (substr(strtolower($header_key), 0, 6) === 'x-amz-')\n        {\n            $string_to_sign .= strtolower($header_key) . ':' . $header_value . &quot;\\n&quot;;\n        }\n    }\n\n    \/\/ Add the signable resource location\n    $string_to_sign .= ($this-&gt;resource_prefix ? $this-&gt;resource_prefix : '');\n    $string_to_sign .= (($bucket === '' || $this-&gt;resource_prefix === '\/' . $bucket) ? '' : ('\/' . $bucket)) . $signable_resource . urldecode($signable_query_string);\n\n    \/\/ Hash the AWS secret key and generate a signature for the request.\n    $signature = base64_encode(hash_hmac('sha1', $string_to_sign, $this-&gt;secret_key, true));\n    $request-&gt;add_header('Authorization', 'AWS ' . $this-&gt;key . ':' . $signature);\n\n    \/\/ If we're generating a URL, return the URL to the calling method.\n    if (isset($opt['preauth']) &amp;&amp; (integer) $opt['preauth'] &gt; 0)\n    {\n        $query_params = array(\n            'AWSAccessKeyId' =&gt; $this-&gt;key,\n            'Expires' =&gt; $headers['Expires'],\n            'Signature' =&gt; $signature,\n        );\n\n        \/\/ If using short-term credentials, add the token to the query string\n        if ($this-&gt;auth_token)\n        {\n            $query_params['x-amz-security-token'] = $this-&gt;auth_token;\n        }\n\n        return $this-&gt;request_url . $conjunction . http_build_query($query_params, '', '&amp;');\n    }\n    elseif (isset($opt['preauth']))\n    {\n        return $this-&gt;request_url;\n    }\n\n    \/*%******************************************************************************************%*\/\n\n    \/\/ If our changes were temporary, reset them.\n    if ($this-&gt;temporary_prefix)\n    {\n        $this-&gt;temporary_prefix = false;\n        $this-&gt;resource_prefix = null;\n    }\n\n    \/\/ Manage the (newer) batch request API or the (older) returnCurlHandle setting.\n    if ($this-&gt;use_batch_flow)\n    {\n        $handle = $request-&gt;prep_request();\n        $this-&gt;batch_object-&gt;add($handle);\n        $this-&gt;use_batch_flow = false;\n\n        return $handle;\n    }\n    elseif (isset($opt['returnCurlHandle']) &amp;&amp; $opt['returnCurlHandle'] === true)\n    {\n        return $request-&gt;prep_request();\n    }\n\n    \/\/ Send!\n    $request-&gt;send_request();\n\n    \/\/ Prepare the response\n    $headers = $request-&gt;get_response_header();\n    $headers['x-aws-request-url'] = $this-&gt;request_url;\n    $headers['x-aws-redirects'] = $this-&gt;redirects;\n    $headers['x-aws-stringtosign'] = $string_to_sign;\n    $headers['x-aws-requestheaders'] = $request-&gt;request_headers;\n\n    \/\/ Did we have a request body?\n    if (isset($opt['body']))\n    {\n        $headers['x-aws-requestbody'] = $opt['body'];\n    }\n\n    $data = new $this-&gt;response_class($headers, $this-&gt;parse_callback($request-&gt;get_response_body()), $request-&gt;get_response_code());\n\n    \/\/ Did Amazon tell us to redirect? Typically happens for multiple rapid requests EU datacenters.\n    \/\/ @see: http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/Redirects.html\n    \/\/ @codeCoverageIgnoreStart\n    if ((integer) $request-&gt;get_response_code() === 307) \/\/ Temporary redirect to new endpoint.\n    {\n        $this-&gt;redirects++;\n        $opt['location'] = $headers['location'];\n        $data = $this-&gt;authenticate($bucket, $opt);\n    }\n\n    \/\/ Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.\n    elseif ((integer) $request-&gt;get_response_code() === 500 || (integer) $request-&gt;get_response_code() === 503)\n    {\n        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)\n        {\n            \/\/ Exponential backoff\n            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);\n            usleep($delay);\n            $this-&gt;redirects++;\n            $data = $this-&gt;authenticate($bucket, $opt);\n        }\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    \/\/ Return!\n    $this-&gt;redirects = 0;\n    return $data;\n}","seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/S3_Authentication.html\">REST authentication<\/a>"}},{"name":"batch","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the intended request should be queued for a later batch request.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"queue","type":"CFBatchRequest","description":"<p>The <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a> instance to use for managing batch requests. If not available, it generates a new instance of <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function batch(CFBatchRequest &amp;$queue = null)\n{\n    if ($queue)\n    {\n        $this-&gt;batch_object = $queue;\n    }\n    elseif ($this-&gt;internal_batch_object)\n    {\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n    else\n    {\n        $this-&gt;internal_batch_object = new $this-&gt;batch_class();\n        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;\n    }\n\n    $this-&gt;use_batch_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Specifies that the resulting <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object should be cached according to the settings from\n<a href=\"..\/s3browserupload\/set_cache_config.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_cache_config\"><code>set_cache_config()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"expires","type":"string|integer","description":"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a> (e.g. &#8220;1 hour&#8221;).<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function cache($expires)\n{\n    \/\/ Die if they haven't used set_cache_config().\n    if (!$this-&gt;cache_class)\n    {\n        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');\n    }\n\n    if (is_string($expires))\n    {\n        $expires = strtotime($expires);\n        $this-&gt;cache_expires = $expires - time();\n    }\n    elseif (is_int($expires))\n    {\n        $this-&gt;cache_expires = $expires;\n    }\n\n    $this-&gt;use_cache_flow = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"},{"title":"<p>Batch several requests together, and then cache the responses to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Prepare for parallel requests\n$sdb-&gt;batch()-&gt;list_domains();\n$sdb-&gt;batch()-&gt;list_domains();\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);\nvar_dump($response[0]-&gt;isOK());\nvar_dump($response[1]-&gt;isOK());","result":"bool(true)\nbool(true)\nbool(true)\nbool(true)"}]}},{"name":"cache_instance_profile_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to\nbe manually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_instance_profile_credentials($cache, $options)\n{\n    $instance_profile_url = 'http:\/\/169.254.169.254\/latest\/meta-data\/iam\/security-credentials\/';\n    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;\n\n    try\n    {\n        \/\/ Make a call to the EC2 Metadata Service to find the available instance profile\n        $request = new RequestCore($instance_profile_url);\n        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n        $response = $request-&gt;send_request(true);\n\n        if ($response-&gt;isOK())\n        {\n            \/\/ Get the instance profile name\n            $profile = (string) $response-&gt;body;\n\n            \/\/ Make a call to the EC2 Metadata Service to get the instance profile credentials\n            $request = new RequestCore($instance_profile_url . $profile);\n            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));\n            $response = $request-&gt;send_request(true);\n\n            if ($response-&gt;isOK())\n            {\n                \/\/ Get the credentials\n                $credentials = json_decode($response-&gt;body, true);\n\n                if ($credentials['Code'] === 'Success')\n                {\n                    \/\/ Determine the expiration time\n                    $expiration_time = strtotime((string) $credentials['Expiration']);\n                    $expiration_duration = round(($expiration_time - time()) * 0.85);\n                    $cache-&gt;expire_in($expiration_duration);\n\n                    \/\/ Return the credential information\n                    return array(\n                        'key'     =&gt; $credentials['AccessKeyId'],\n                        'secret'  =&gt; $credentials['SecretAccessKey'],\n                        'token'   =&gt; $credentials['Token'],\n                        'expires' =&gt; $credentials['Expiration'],\n                    );\n                }\n            }\n        }\n    }\n    catch (cURL_Exception $e)\n    {\n        \/\/ The EC2 Metadata Service does not exist or had timed out.\n        \/\/ An exception will be thrown on the next line.\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '\n        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '\n        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"cache_sts_credentials","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be\nmanually invoked.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"cache","type":"CacheCore","description":"<p>The a reference to the cache object that is being used to handle the caching.<\/p>"},{"@attributes":{"choice":"req"},"name":"options","type":"array","description":"<p>The options that were passed into the constructor.<\/p>"}]},"returnvalue":"<p>The data to be cached, or NULL.<\/p>","source":"public function cache_sts_credentials($cache, $options)\n{\n    $token = new AmazonSTS($options);\n    $response = $token-&gt;get_session_token();\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Update the expiration\n        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);\n        $expiration_duration = round(($expiration_time - time()) * 0.85);\n        $cache-&gt;expire_in($expiration_duration);\n\n        \/\/ Return the important data\n        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;\n\n        return array(\n            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,\n            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,\n            'token'   =&gt; (string) $credentials-&gt;SessionToken,\n            'expires' =&gt; (string) $credentials-&gt;Expiration,\n        );\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    throw new STS_Exception('Temporary credentials from the AWS Security '\n        . 'Token Service could not be retrieved using the provided long '\n        . 'term credentials. It\\'s possible that the provided long term '\n        . 'credentials were invalid.');\n    \/\/ @codeCoverageIgnoreEnd\n}"},{"name":"change_content_type","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Changes the content type for an existing Amazon S3 object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"contentType","type":"string","description":"<p>The content-type to apply to the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function change_content_type($bucket, $filename, $contentType, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Retrieve the original metadata\n    $metadata = $this-&gt;get_object_metadata($bucket, $filename);\n    if ($metadata &amp;&amp; isset($metadata['ACL']))\n    {\n        $opt['acl'] = $metadata['ACL'];\n    }\n    if ($metadata &amp;&amp; isset($metadata['StorageClass']))\n    {\n        $opt['headers']['x-amz-storage-class'] = $metadata['StorageClass'];\n    }\n\n    \/\/ Merge optional parameters\n    $opt = array_merge_recursive(array(\n        'headers' =&gt; array(\n            'Content-Type' =&gt; $contentType\n        ),\n        'metadataDirective' =&gt; 'REPLACE'\n    ), $opt);\n\n    return $this-&gt;copy_object(\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        $opt\n    );\n}","examples":{"example":{"title":"<p>Change the content type of an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$cct = $s3-&gt;change_content_type($bucket, 'test1.txt', 'text\/plain');\nsleep(5);\n$metadata = $s3-&gt;get_object_metadata($bucket, 'test1.txt');\n\n\/\/ Success?\nvar_dump($cct-&gt;isOK());\nvar_dump($metadata['ContentType']);","result":"bool(true)\nstring(10) \"text\/plain\""}}},{"name":"change_storage_redundancy","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Changes the storage redundancy for an existing object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"storage","type":"string","description":"<p>The storage setting to apply to the object. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function change_storage_redundancy($bucket, $filename, $storage, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Retrieve the original metadata\n    $metadata = $this-&gt;get_object_metadata($bucket, $filename);\n    if ($metadata &amp;&amp; isset($metadata['ACL']))\n    {\n        $opt['acl'] = $metadata['ACL'];\n    }\n    if ($metadata &amp;&amp; isset($metadata['StorageClass']))\n    {\n        $opt['headers']['x-amz-storage-class'] = $metadata['StorageClass'];\n    }\n\n    \/\/ Merge optional parameters\n    $opt = array_merge(array(\n        'storage' =&gt; $storage,\n        'metadataDirective' =&gt; 'COPY',\n    ), $opt);\n\n    return $this-&gt;copy_object(\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        $opt\n    );\n}","examples":{"example":{"title":"<p>Change the preferred storage redundancy.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$csr = $s3-&gt;change_storage_redundancy($bucket, 'test1.txt', AmazonS3::STORAGE_REDUCED);\nsleep(5);\n$metadata = $s3-&gt;get_object_metadata($bucket, 'test1.txt');\n\n\/\/ Success?\nvar_dump($csr-&gt;isOK());\nvar_dump($metadata['StorageClass']);","result":"bool(true)\nstring(18) \"REDUCED_REDUNDANCY\""}}},{"name":"complete_multipart_upload","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Completes an in-progress multipart upload. A multipart upload is completed by describing the part\nnumbers and corresponding ETag values in order, and submitting that data to Amazon S3 as an XML document.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"upload_id","type":"string","description":"<p>The upload ID identifying the multipart upload whose parts are being listed. The upload ID is retrieved from a call to <a href=\"..\/s3browserupload\/initiate_multipart_upload.html\" rel=\"..\/..\/index.html#m=s3browserupload\/initiate_multipart_upload\"><code>initiate_multipart_upload()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"parts","type":"string|array|SimpleXMLElement|CFResponse","description":"<p>The completion XML document. This document can be provided in multiple ways; as a string of XML, as a <a href=\"http:\/\/php.net\/simplexmlelement\"><code>SimpleXMLElement<\/code><\/a> object representing the XML document, as an indexed array of associative arrays where the keys are <code>PartNumber<\/code> and <code>ETag<\/code>, or as a <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object returned by <a href=\"..\/s3browserupload\/list_parts.html\" rel=\"..\/..\/index.html#m=s3browserupload\/list_parts\"><code>list_parts()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function complete_multipart_upload($bucket, $filename, $upload_id, $parts, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'POST';\n    $opt['resource'] = $filename;\n    $opt['uploadId'] = $upload_id;\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    \/\/ Disable Content-MD5 calculation for this operation\n    $opt['NoContentMD5'] = true;\n\n    if (is_string($parts))\n    {\n        \/\/ Assume it's the intended XML.\n        $opt['body'] = $parts;\n    }\n    elseif ($parts instanceof SimpleXMLElement)\n    {\n        \/\/ Assume it's a SimpleXMLElement object representing the XML.\n        $opt['body'] = $parts-&gt;asXML();\n    }\n    elseif (is_array($parts) || $parts instanceof CFResponse)\n    {\n        $xml = simplexml_load_string($this-&gt;complete_mpu_xml);\n\n        if (is_array($parts))\n        {\n            \/\/ Generate the appropriate XML.\n            foreach ($parts as $node)\n            {\n                $part = $xml-&gt;addChild('Part');\n                $part-&gt;addChild('PartNumber', $node['PartNumber']);\n                $part-&gt;addChild('ETag', $node['ETag']);\n            }\n\n        }\n        elseif ($parts instanceof CFResponse)\n        {\n            \/\/ Assume it's a response from list_parts().\n            foreach ($parts-&gt;body-&gt;Part as $node)\n            {\n                $part = $xml-&gt;addChild('Part');\n                $part-&gt;addChild('PartNumber', (string) $node-&gt;PartNumber);\n                $part-&gt;addChild('ETag', (string) $node-&gt;ETag);\n            }\n        }\n\n        $opt['body'] = $xml-&gt;asXML();\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Complete a multipart upload using a response from list_parts().<\/p>","description":"<ol>\n<li>Initiate a new multipart upload using <code>initiate_multipart_upload()<\/code>.<\/li>\n<li>Upload the parts using <code>upload_part()<\/code>.<\/li>\n<li>Complete the upload using <code>complete_multipart_upload()<\/code>.<\/li>\n<\/ol>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n$filename = 'movie.mp4';\n$upload_id = 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--';\n\n\/\/ Get a list of up to 1000 parts\n$parts = $s3-&gt;list_parts($bucket, $filename, $upload_id);\n\n\/\/ Initiate a new multipart upload\n$response = $s3-&gt;complete_multipart_upload($bucket, $filename, $upload_id, $parts);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Complete a multipart upload using a string.<\/p>","code":"$xml = &lt;&lt;&lt;HTML\n&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;\n&lt;CompleteMultipartUpload&gt;\n&lt;Part&gt;\n\t&lt;PartNumber&gt;1&lt;\/PartNumber&gt;\n\t&lt;ETag&gt;&quot;25e317773f308e446cc84c503a6d1f85&quot;&lt;\/ETag&gt;\n&lt;\/Part&gt;\n&lt;Part&gt;\n\t&lt;PartNumber&gt;2&lt;\/PartNumber&gt;\n\t&lt;ETag&gt;&quot;25e317773f308e446cc84c503a6d1f85&quot;&lt;\/ETag&gt;\n&lt;\/Part&gt;\n&lt;Part&gt;\n\t&lt;PartNumber&gt;3&lt;\/PartNumber&gt;\n\t&lt;ETag&gt;&quot;bed3c0a4a1407f584989b4009e9ce33f&quot;&lt;\/ETag&gt;\n&lt;\/Part&gt;\n&lt;\/CompleteMultipartUpload&gt;\nHTML;\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n$filename = 'movie.mp4';\n$upload_id = 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--';\n\n\/\/ Get a list of up to 1000 parts\n$parts = $s3-&gt;list_parts($bucket, $filename, $upload_id);\n\n\/\/ Initiate a new multipart upload\n$response = $s3-&gt;complete_multipart_upload($bucket, $filename, $upload_id, $xml);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Complete a multipart upload using an array.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n$filename = 'movie.mp4';\n$upload_id = 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--';\n\n\/\/ Get a list of up to 1000 parts\n$parts = $s3-&gt;list_parts($bucket, $filename, $upload_id);\n\n\/\/ Initiate a new multipart upload\n$response = $s3-&gt;complete_multipart_upload($bucket, $filename, $upload_id, array(\n\tarray('PartNumber' =&gt; 1, 'ETag' =&gt; '&quot;25e317773f308e446cc84c503a6d1f85&quot;'),\n\tarray('PartNumber' =&gt; 2, 'ETag' =&gt; '&quot;a6d1f85f58498973f308e446cc84c503&quot;'),\n\tarray('PartNumber' =&gt; 3, 'ETag' =&gt; '&quot;bed3c0a4a1407f584989b4009e9ce33f&quot;'),\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]}},{"name":"copy_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Copies an Amazon S3 object to a new location, whether in the same Amazon S3 region, bucket, or otherwise.<\/p>\n\n<p>NOTE: Object redirect locations are not carried over when an object is copied.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"source","type":"array","description":"<p>The bucket and file name to copy from. The following keys must be set:<\/p>\n\n<ul><li><code>bucket<\/code> - <code>string<\/code> - Required - Specifies the name of the bucket containing the source object.<\/li><li><code>filename<\/code> - <code>string<\/code> - Required - Specifies the file name of the source object to copy.<\/li><\/ul>"},{"@attributes":{"choice":"req"},"name":"dest","type":"array","description":"<p>The bucket and file name to copy to. The following keys must be set:<\/p>\n\n<ul><li><code>bucket<\/code> - <code>string<\/code> - Required - Specifies the name of the bucket to copy the object to.<\/li><li><code>filename<\/code> - <code>string<\/code> - Required - Specifies the file name to copy the object to.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>acl<\/code> - <code>string<\/code> - Optional - The ACL settings for the specified object. [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <code>ACL_PRIVATE<\/code>.<\/li><li><code>encryption<\/code> - <code>string<\/code> - Optional - The algorithm to use for encrypting the object. [Allowed values: <code>AES256<\/code>]<\/li><li><code>storage<\/code> - <code>string<\/code> - Optional - Whether to use Standard or Reduced Redundancy storage. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]. The default value is <code>STORAGE_STANDARD<\/code>.<\/li><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to copy. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>ifMatch<\/code> - <code>string<\/code> - Optional - The ETag header from a previous request. Copies the object if its entity tag (ETag) matches the specified tag; otherwise, the request returns a <code>412<\/code> HTTP status code error (precondition failed). Used in conjunction with <code>ifUnmodifiedSince<\/code>.<\/li><li><code>ifUnmodifiedSince<\/code> - <code>string<\/code> - Optional - The LastModified header from a previous request. Copies the object if it hasn&#8217;t been modified since the specified time; otherwise, the request returns a <code>412<\/code> HTTP status code error (precondition failed). Used in conjunction with <code>ifMatch<\/code>.<\/li><li><code>ifNoneMatch<\/code> - <code>string<\/code> - Optional - The ETag header from a previous request. Copies the object if its entity tag (ETag) is different than the specified ETag; otherwise, the request returns a <code>412<\/code> HTTP status code error (failed condition). Used in conjunction with <code>ifModifiedSince<\/code>.<\/li><li><code>ifModifiedSince<\/code> - <code>string<\/code> - Optional - The LastModified header from a previous request. Copies the object if it has been modified since the specified time; otherwise, the request returns a <code>412<\/code> HTTP status code error (failed condition). Used in conjunction with <code>ifNoneMatch<\/code>.<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>meta<\/code> - <code>array<\/code> - Optional - Associative array of key-value pairs. Represented by <code>x-amz-meta-:<\/code> Any header starting with this prefix is considered user metadata. It will be stored with the object and returned when you retrieve the object. The total size of the HTTP request, not including the body, must be less than 4 KB.<\/li><li><code>metadataDirective<\/code> - <code>string<\/code> - Optional - Accepts either COPY or REPLACE. You will likely never need to use this, as it manages itself with no issues.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function copy_object($source, $dest, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $batch = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['resource'] = $dest['filename'];\n    $opt['body'] = '';\n\n    \/\/ Handle copy source\n    if (isset($source['bucket']) &amp;&amp; isset($source['filename']))\n    {\n        $opt['headers']['x-amz-copy-source'] = '\/' . $source['bucket'] . '\/' . rawurlencode($source['filename'])\n            . (isset($opt['versionId']) ? ('?' . 'versionId=' . rawurlencode($opt['versionId'])) : ''); \/\/ Append the versionId to copy, if available\n        unset($opt['versionId']);\n    }\n\n    \/\/ Handle metadata directive\n    $opt['headers']['x-amz-metadata-directive'] = 'COPY';\n    if ($source['bucket'] === $dest['bucket'] &amp;&amp; $source['filename'] === $dest['filename'])\n    {\n        $opt['headers']['x-amz-metadata-directive'] = 'REPLACE';\n    }\n    if (isset($opt['metadataDirective']))\n    {\n        $opt['headers']['x-amz-metadata-directive'] = $opt['metadataDirective'];\n        unset($opt['metadataDirective']);\n    }\n\n    \/\/ Handle Access Control Lists. Can also pass canned ACLs as an HTTP header.\n    if (isset($opt['acl']) &amp;&amp; is_array($opt['acl']))\n    {\n        $batch[] = $this-&gt;set_object_acl($dest['bucket'], $dest['filename'], $opt['acl'], array(\n            'returnCurlHandle' =&gt; true\n        ));\n        unset($opt['acl']);\n    }\n    elseif (isset($opt['acl']))\n    {\n        $opt['headers']['x-amz-acl'] = $opt['acl'];\n        unset($opt['acl']);\n    }\n\n    \/\/ Handle storage settings. Can also be passed as an HTTP header.\n    if (isset($opt['storage']))\n    {\n        $opt['headers']['x-amz-storage-class'] = $opt['storage'];\n        unset($opt['storage']);\n    }\n\n    \/\/ Handle encryption settings. Can also be passed as an HTTP header.\n    if (isset($opt['encryption']))\n    {\n        $opt['headers']['x-amz-server-side-encryption'] = $opt['encryption'];\n        unset($opt['encryption']);\n    }\n\n    \/\/ Handle conditional-copy parameters\n    if (isset($opt['ifMatch']))\n    {\n        $opt['headers']['x-amz-copy-source-if-match'] = $opt['ifMatch'];\n        unset($opt['ifMatch']);\n    }\n    if (isset($opt['ifNoneMatch']))\n    {\n        $opt['headers']['x-amz-copy-source-if-none-match'] = $opt['ifNoneMatch'];\n        unset($opt['ifNoneMatch']);\n    }\n    if (isset($opt['ifUnmodifiedSince']))\n    {\n        $opt['headers']['x-amz-copy-source-if-unmodified-since'] = $opt['ifUnmodifiedSince'];\n        unset($opt['ifUnmodifiedSince']);\n    }\n    if (isset($opt['ifModifiedSince']))\n    {\n        $opt['headers']['x-amz-copy-source-if-modified-since'] = $opt['ifModifiedSince'];\n        unset($opt['ifModifiedSince']);\n    }\n\n    \/\/ Handle meta tags. Can also be passed as an HTTP header.\n    if (isset($opt['meta']))\n    {\n        foreach ($opt['meta'] as $meta_key =&gt; $meta_value)\n        {\n            \/\/ e.g., `My Meta Header` is converted to `x-amz-meta-my-meta-header`.\n            $opt['headers']['x-amz-meta-' . strtolower(str_replace(' ', '-', $meta_key))] = $meta_value;\n        }\n        unset($opt['meta']);\n    }\n\n    \/\/ Authenticate to S3\n    $response = $this-&gt;authenticate($dest['bucket'], $opt);\n\n    \/\/ Attempt to reset ACLs\n    $http = new CFRequest();\n    $http-&gt;send_multi_request($batch);\n\n    return $response;\n}","examples":{"example":[{"title":"<p>Copy an object by specifying a source and a destination.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test1.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test2.txt'\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Copy an object, setting the new object to use reduced redundancy.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'prefix\/one\/two\/test1.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'prefix\/one\/two\/test2.txt'\n\t),\n\tarray( \/\/ Optional parameters\n\t\t'storage' =&gt; AmazonS3::STORAGE_REDUCED\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Copy an object, setting other headers and settings.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test1.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test2.txt'\n\t),\n\tarray( \/\/ Optional parameters\n\t\t'acl'  =&gt; AmazonS3::ACL_PUBLIC,\n\t\t'meta' =&gt; array(\n\t\t\t'x-fake-header' =&gt; 'something awesome is happening'\n\t\t)\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Copy a specific version of an object.<\/p>","description":"<p><strong>Note:<\/strong> Requires versioning to be enabled on a bucket first.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test1.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test-version.txt'\n\t),\n\tarray( \/\/ Optional parameters\n\t\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie='\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Conditionally copy an object \u2014 only if the original is newer than what we have.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Store the `etag` and `last-modified` headers the first time we pull down an object.\n$head = $s3-&gt;get_object_headers($bucket, 'test1.txt');\n$etag = $head-&gt;header['etag'];\n$last_modified = $head-&gt;header['last-modified'];\n\n\/*---- Later... ----*\/\n\n\/\/ Copy, only if the original is newer than what we have\n$response = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test1.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'test2.txt'\n\t),\n\tarray( \/\/ Conditional Copy\n\t\t'ifNoneMatch'     =&gt; $etag,\n\t\t'ifModifiedSince' =&gt; $last_modified\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/API\/RESTObjectCOPY.html\">Copying Amazon S3 Objects<\/a>"}},{"name":"copy_part","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Since Amazon S3&#8217;s standard <a href=\"..\/s3browserupload\/copy_object.html\" rel=\"..\/..\/index.html#m=s3browserupload\/copy_object\"><code>copy_object()<\/code><\/a> operation only supports copying objects that are smaller than\n5 GB, the ability to copy large objects (greater than 5 GB) requires the use of &#8220;Multipart Copy&#8221;.<\/p>\n\n<p>Copying large objects requires the developer to initiate a new multipart &#8220;upload&#8221;, copy pieces of the\nlarge object (specifying a range of bytes up to 5 GB from the large source file), then complete the\nmultipart &#8220;upload&#8221;.<\/p>\n\n<p>NOTE: <strong>This is a synchronous operation<\/strong>, not an <em>asynchronous<\/em> operation, which means\nthat Amazon S3 will not return a response for this operation until the copy has completed across the Amazon\nS3 server fleet. Copying objects within a single region will complete more quickly than copying objects\n<em>across<\/em> regions. The synchronous nature of this operation is different from other services where\nresponses are typically returned immediately, even if the operation itself has not yet been completed on\nthe server-side.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"source","type":"array","description":"<p>The bucket and file name to copy from. The following keys must be set:<\/p>\n\n<ul><li><code>bucket<\/code> - <code>string<\/code> - Required - Specifies the name of the bucket containing the source object.<\/li><li><code>filename<\/code> - <code>string<\/code> - Required - Specifies the file name of the source object to copy.<\/li><\/ul>"},{"@attributes":{"choice":"req"},"name":"dest","type":"array","description":"<p>The bucket and file name to copy to. The following keys must be set:<\/p>\n\n<ul><li><code>bucket<\/code> - <code>string<\/code> - Required - Specifies the name of the bucket to copy the object to.<\/li><li><code>filename<\/code> - <code>string<\/code> - Required - Specifies the file name to copy the object to.<\/li><\/ul>"},{"@attributes":{"choice":"req"},"name":"upload_id","type":"string","description":"<p>The upload ID identifying the multipart upload whose parts are being listed. The upload ID is retrieved from a call to <a href=\"..\/s3browserupload\/initiate_multipart_upload.html\" rel=\"..\/..\/index.html#m=s3browserupload\/initiate_multipart_upload\"><code>initiate_multipart_upload()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"part_number","type":"integer","description":"<p>A part number uniquely identifies a part and defines its position within the destination object. When you complete a multipart upload, a complete object is created by concatenating parts in ascending order based on part number. If you copy a new part using the same part number as a previously copied\/uploaded part, the previously written part is overwritten.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>ifMatch<\/code> - <code>string<\/code> - Optional - The ETag header from a previous request. Copies the object if its entity tag (ETag) matches the specified tag; otherwise, the request returns a <code>412<\/code> HTTP status code error (precondition failed). Used in conjunction with <code>ifUnmodifiedSince<\/code>.<\/li><li><code>ifUnmodifiedSince<\/code> - <code>string<\/code> - Optional - The LastModified header from a previous request. Copies the object if it hasn&#8217;t been modified since the specified time; otherwise, the request returns a <code>412<\/code> HTTP status code error (precondition failed). Used in conjunction with <code>ifMatch<\/code>.<\/li><li><code>ifNoneMatch<\/code> - <code>string<\/code> - Optional - The ETag header from a previous request. Copies the object if its entity tag (ETag) is different than the specified ETag; otherwise, the request returns a <code>412<\/code> HTTP status code error (failed condition). Used in conjunction with <code>ifModifiedSince<\/code>.<\/li><li><code>ifModifiedSince<\/code> - <code>string<\/code> - Optional - The LastModified header from a previous request. Copies the object if it has been modified since the specified time; otherwise, the request returns a <code>412<\/code> HTTP status code error (failed condition). Used in conjunction with <code>ifNoneMatch<\/code>.<\/li><li><code>range<\/code> - <code>string<\/code> - Optional - The range of bytes to copy from the object. Specify this parameter when copying partial bits. The specified range must be notated with a hyphen (e.g., 0-10485759). Defaults to the byte range of the complete Amazon S3 object.<\/li><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to copy. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function copy_part($source, $dest, $upload_id, $part_number, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['resource'] = $dest['filename'];\n    $opt['uploadId'] = $upload_id;\n    $opt['partNumber'] = $part_number;\n\n    \/\/ Handle copy source\n    if (isset($source['bucket']) &amp;&amp; isset($source['filename']))\n    {\n        $opt['headers']['x-amz-copy-source'] = '\/' . $source['bucket'] . '\/' . rawurlencode($source['filename'])\n            . (isset($opt['versionId']) ? ('?' . 'versionId=' . rawurlencode($opt['versionId'])) : ''); \/\/ Append the versionId to copy, if available\n        unset($opt['versionId']);\n    }\n\n    \/\/ Handle conditional-copy parameters\n    if (isset($opt['ifMatch']))\n    {\n        $opt['headers']['x-amz-copy-source-if-match'] = $opt['ifMatch'];\n        unset($opt['ifMatch']);\n    }\n    if (isset($opt['ifNoneMatch']))\n    {\n        $opt['headers']['x-amz-copy-source-if-none-match'] = $opt['ifNoneMatch'];\n        unset($opt['ifNoneMatch']);\n    }\n    if (isset($opt['ifUnmodifiedSince']))\n    {\n        $opt['headers']['x-amz-copy-source-if-unmodified-since'] = $opt['ifUnmodifiedSince'];\n        unset($opt['ifUnmodifiedSince']);\n    }\n    if (isset($opt['ifModifiedSince']))\n    {\n        $opt['headers']['x-amz-copy-source-if-modified-since'] = $opt['ifModifiedSince'];\n        unset($opt['ifModifiedSince']);\n    }\n\n    \/\/ Partial content range\n    if (isset($opt['range']))\n    {\n        $opt['headers']['x-amz-copy-source-range'] = 'bytes=' . $opt['range'];\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($dest['bucket'], $opt);\n}","examples":{"example":{"title":"<p>Copying a large object (5+ GB) using the \"multipart\" flow. Objects smaller than 5 GB should use <a href=\"..\/s3browserupload\/copy_object.html\" rel=\"..\/..\/index.html#m=s3browserupload\/copy_object\"><code>copy_object()<\/code><\/a> instead.<\/p>","description":"<ol>\n<li>Initiate a new large object copy using <code>initiate_multipart_upload()<\/code>.<\/li>\n<li>Using the <code>copy_part()<\/code> method, copy the large object in 5 GB &#8220;parts&#8221; by specifying the <code>range<\/code> option. The final part can be any size smaller than 5 GB.<\/li>\n<li>Complete the large object copy using <code>complete_multipart_upload()<\/code>.<\/li>\n<\/ol>","code":"\/\/ Define a gigabyte\ndefine('GB', 1024 * 1024 * 1024);\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Copy a part. The source file MUST be larger than 5 GB.\n$response = $s3-&gt;copy_part(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'movie.mp4'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $bucket,\n\t\t'filename' =&gt; 'file2.junk'\n\t),\n\t'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--', \/\/ Upload ID\n\t1,          \/\/ Part Number\n\tarray(\n\t\t'range' =&gt; '0-' . 5*GB\n\t)\n);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"create_bucket","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Creates an Amazon S3 bucket.<\/p>\n\n<p>Every object stored in Amazon S3 is contained in a bucket. Buckets partition the namespace of\nobjects stored in Amazon S3 at the top level. in a bucket, any name can be used for objects.\nHowever, bucket names must be unique across all of Amazon S3.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to create.<\/p>"},{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The preferred geographical location for the bucket. [Allowed values: <code>AmazonS3::REGION_US_E1<\/code>, <code>AmazonS3::REGION_US_W1<\/code>, <code>AmazonS3::REGION_EU_W1<\/code>, <code>AmazonS3::REGION_APAC_SE1<\/code>, <code>AmazonS3::REGION_APAC_NE1<\/code>]<\/p>"},{"@attributes":{"choice":"opt"},"name":"acl","type":"string","description":"<p>The ACL settings for the specified object. Accepts any of the following constants: [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <code>ACL_PRIVATE<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_bucket($bucket, $region, $acl = self::ACL_PRIVATE, $opt = null)\n{\n    \/\/ If the bucket contains uppercase letters...\n    if (preg_match('\/[A-Z]\/', $bucket))\n    {\n        \/\/ Throw a warning\n        trigger_error('Since DNS-valid bucket names cannot contain uppercase characters, &quot;' . $bucket . '&quot; has been automatically converted to &quot;' . strtolower($bucket) . '&quot;', E_USER_WARNING);\n\n        \/\/ Force the bucketname to lowercase\n        $bucket = strtolower($bucket);\n    }\n\n    \/\/ Validate the S3 bucket name for creation\n    if (!$this-&gt;validate_bucketname_create($bucket))\n    {\n        \/\/ @codeCoverageIgnoreStart\n        throw new S3_Exception('&quot;' . $bucket . '&quot; is not DNS-valid (i.e., &lt;bucketname&gt;.s3.amazonaws.com), and cannot be used as an S3 bucket name. Review &quot;Bucket Restrictions and Limitations&quot; in the S3 Developer Guide for more information.');\n        \/\/ @codeCoverageIgnoreEnd\n    }\n\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    \/\/ Handle Access Control Lists. Can also be passed as an HTTP header.\n    if (isset($acl))\n    {\n        if (is_array($acl))\n        {\n            $opt['headers'] = array_merge($opt['headers'], $this-&gt;generate_access_policy_headers($acl));\n        }\n        else\n        {\n            $opt['headers']['x-amz-acl'] = $acl;\n        }\n    }\n\n    \/\/ Defaults\n    $this-&gt;set_region($region); \/\/ Also sets path-style\n    $xml = simplexml_load_string($this-&gt;base_location_constraint);\n\n    switch ($region)\n    {\n        case self::REGION_US_E1: \/\/ Northern Virginia\n            $opt['body'] = '';\n            break;\n\n        case self::REGION_EU_W1:    \/\/ Ireland\n            $xml-&gt;LocationConstraint = 'EU';\n            $opt['body'] = $xml-&gt;asXML();\n            break;\n\n        default:\n            $xml-&gt;LocationConstraint = str_replace(array('s3-', '.amazonaws.com'), '', $region);\n            $opt['body'] = $xml-&gt;asXML();\n            break;\n    }\n\n    $response = $this-&gt;authenticate($bucket, $opt);\n\n    \/\/ Make sure we're set back to DNS-style URLs\n    $this-&gt;enable_path_style(false);\n\n    return $response;\n}","examples":{"example":[{"title":"<p>Create a new bucket, setting the storage region.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new bucket, setting the storage region and ACL settings.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-us-east-acl' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD, AmazonS3::ACL_PUBLIC);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new bucket, setting the storage region and using Grants for permissions.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD, array(\n\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,                                               'permission' =&gt; AmazonS3::GRANT_READ        ),\n\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,                                               'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n\tarray( 'id' =&gt; AmazonS3::USERS_ALL,                                                'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n\tarray( 'id' =&gt; 'my-email-address@domain.com',                                      'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL),\n\tarray( 'id' =&gt; '41f37e4803dbae41aa52290608a037dcf2309199b81c6257fe5570098b9e55a9', 'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/UsingBucket.html\">Working with Amazon S3 Buckets<\/a>"}},{"name":"create_bucket_notification","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables notifications of specified events for an Amazon S3 bucket. Currently, the\n<code>s3:ReducedRedundancyLostObject<\/code> event is the only event supported for notifications. The\n<code>s3:ReducedRedundancyLostObject<\/code> event is triggered when Amazon S3 detects that it has lost all\ncopies of an Amazon S3 object and can no longer service requests for that object.<\/p>\n\n<p>If the bucket owner and Amazon SNS topic owner are the same, the bucket owner has permission to\npublish notifications to the topic by default. Otherwise, the owner of the topic must create a\npolicy to enable the bucket owner to publish to the topic.<\/p>\n\n<p>By default, only the bucket owner can configure notifications on a bucket. However, bucket owners\ncan use bucket policies to grant permission to other users to set this configuration with the\n<code>s3:PutBucketNotification<\/code> permission.<\/p>\n\n<p>After a PUT operation is called to configure notifications on a bucket, Amazon S3 publishes a test\nnotification to ensure that the topic exists and that the bucket owner has permission to publish\nto the specified topic. If the notification is successfully published to the SNS topic, the PUT\noperation updates the bucket configuration and returns the 200 OK responses with a\n<code>x-amz-sns-test-message-id<\/code> header containing the message ID of the test notification sent to topic.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to create bucket notifications for.<\/p>"},{"@attributes":{"choice":"req"},"name":"topic_arn","type":"string","description":"<p>The SNS topic ARN to send notifications to.<\/p>"},{"@attributes":{"choice":"req"},"name":"event","type":"string","description":"<p>The event type to listen for.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_bucket_notification($bucket, $topic_arn, $event, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'notification';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;base_notification_xml);\n    $topic_config = $xml-&gt;addChild('TopicConfiguration');\n    $topic_config-&gt;addChild('Topic', $topic_arn);\n    $topic_config-&gt;addChild('Event', $event);\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create bucket notification.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Create an SNS topic\n$sns = new AmazonSNS();\n$topic = $sns-&gt;create_topic('my-topic')-&gt;body-&gt;TopicArn()-&gt;first();\n\n$response = $s3-&gt;create_bucket_notification($bucket, $topic, 's3:ReducedRedundancyLostObject');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/NotificationHowTo.html\">Setting Up Notification of Bucket Events<\/a>"}},{"name":"create_bucket_tags","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Apply a set of tags to the specified bucket. Bucket Tags simplify the task of associating Amazon S3\ncosts with specific buckets.<\/p>\n\n<p>This operation requires permission to perform <code>s3:PutBucketTagging<\/code> actions. By default,\nthe bucket owner is permitted to perform these actions, and can grant permission to other users.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>tags<\/code> - <code>array<\/code> - Required - An associative array of custom key-value pairs. <ul><li><code>[custom-key]<\/code> - <code>string<\/code> - Optional - A custom key-value pair to tag the bucket with.<\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_bucket_tags($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'tagging';\n\n    $xml = simplexml_load_string($this-&gt;bucket_tagging_xml);\n    if (isset($opt['tags']) &amp;&amp; is_array($opt['tags']))\n    {\n        foreach ($opt['tags'] as $key =&gt; $value)\n        {\n            $xtag = $xml-&gt;TagSet-&gt;addChild('Tag');\n            $xtag-&gt;addChild('Key', $key);\n            $xtag-&gt;addChild('Value', $value);\n        }\n    }\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete bucket tags.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create new bucket tags\n\n$response = $s3-&gt;create_bucket_tags($bucket, array(\n\t'tags' =&gt; array(\n\t\t'project' =&gt; 'foo',\n\t\t'user'    =&gt; 'bar',\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_bucket_tags($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Retrieve the bucket tags\n\n$response = $s3-&gt;get_bucket_tags($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the bucket tags\n\n$response = $s3-&gt;delete_bucket_tags($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}}},{"name":"create_cors_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Create a new CORS configuration.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>cors_rule<\/code> - <code>array<\/code> - Required - One or more rule-sets. <ul><li><code>x<\/code> - <code>array<\/code> - Required - This represents a simple array index. <ul><li><code>allowed_header<\/code> - <code>array<\/code> - Required - Used in response to a preflight request to indicate which HTTP headers can be used when making the actual request.<\/li><li><code>allowed_method<\/code> - <code>array<\/code> - Required - An array of HTTP methods to allow. There must be at least one method set. [Allowed values: `GET`, `PUT`, `HEAD`, `POST`, `DELETE`]<\/li><li><code>allowed_origin<\/code> - <code>array<\/code> - Required - An array of hostnames to allow. This could be `*` to indicate it is open to all domains. If one of them contains the string `*`, then there can be exactly one.<\/li><li><code>expose_header<\/code> - <code>string<\/code> - Optional - Enable the browser to read this header.<\/li><li><code>id<\/code> - <code>string<\/code> - Optional - Unique identifier for the rule. The value cannot be longer than 255 characters.<\/li><li><code>max_age<\/code> - <code>integer<\/code> - Optional - Alter the client&#8217;s caching behavior for the pre-flight request.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_cors_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'cors';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;cors_config_xml, $this-&gt;parser_class);\n\n    if (isset($opt['cors_rule']) &amp;&amp; is_array($opt['cors_rule']))\n    {\n        foreach ($opt['cors_rule'] as $rule_set)\n        {\n            \/\/ New rule node\n            $xrule = $xml-&gt;addChild('CORSRule');\n\n            \/\/ ID node\n            if (isset($rule_set['id']))\n            {\n                $xrule-&gt;addChild('ID', $rule_set['id']);\n            }\n\n            \/\/ ExposeHeader node\n            if (isset($rule_set['expose_header']))\n            {\n                $xrule-&gt;addChild('ExposeHeader', $rule_set['expose_header']);\n            }\n\n            \/\/ MaxAgeSeconds node\n            if (isset($rule_set['max_age']))\n            {\n                $xrule-&gt;addChild('MaxAgeSeconds', $rule_set['max_age']);\n            }\n\n            \/\/ AllowedHeader node\n            if (isset($rule_set['allowed_header']))\n            {\n                if (!is_array($rule_set['allowed_header']))\n                {\n                    $rule_set['allowed_header'] = array($rule_set['allowed_header']);\n                }\n\n                foreach ($rule_set['allowed_header'] as $method)\n                {\n                    $xrule-&gt;addChild('AllowedHeader', $method);\n                }\n            }\n\n            \/\/ AllowedMethod node\n            if (isset($rule_set['allowed_method']))\n            {\n                if (!is_array($rule_set['allowed_method']))\n                {\n                    $rule_set['allowed_method'] = array($rule_set['allowed_method']);\n                }\n\n                foreach ($rule_set['allowed_method'] as $method)\n                {\n                    $xrule-&gt;addChild('AllowedMethod', $method);\n                }\n            }\n\n            \/\/ AllowedOrigin node\n            if (isset($rule_set['allowed_origin']))\n            {\n                if (!is_array($rule_set['allowed_origin']))\n                {\n                    $rule_set['allowed_origin'] = array($rule_set['allowed_origin']);\n                }\n\n                foreach ($rule_set['allowed_origin'] as $method)\n                {\n                    $xrule-&gt;addChild('AllowedOrigin', $method);\n                }\n            }\n        }\n    }\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"0":{}}},{"name":"create_lifecycle_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables the ability to specify a configuration that relates to the object&#8217;s <em>lifecycle<\/em>.<\/p>\n\n<p>**NOTE:*In cases where the lifecycle configuration dictates that an object should be deleted, Amazon S3\nguarantees that the object will be deleted when the expiration time is passed.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>rules<\/code> - <code>string<\/code> - Required - The object expiration rule-sets to apply to the bucket. <ul><li><code>x<\/code> - <code>array<\/code> - Required - This represents a simple array index. <ul><li><code>id<\/code> - <code>string<\/code> - Optional - Unique identifier for the rule. The value cannot be longer than 255 characters.<\/li><li><code>prefix<\/code> - <code>string<\/code> - Required - The Amazon S3 object prefix which targets the file(s) for expiration.<\/li><li><code>expiration<\/code> - <code>array<\/code> - Optional - The container for the unit of measurement by which the expiration time is calculated. At least one action (either <code>transition<\/code> or <code>expiration<\/code>) is required within one lifecycle rule. <ul><li><code>date<\/code> - <code>string<\/code> - Conditionally Required - The timestamp for when the targetted objects are to be moved or expired from the bucket. Should be in ISO 8601 Format. HH:MM:SS will be enforced as midnight GMT\/UTC.<\/li><li><code>days<\/code> - <code>integer<\/code> - Conditionally Required - The number of days until the targetted objects are to be moved or expired from the bucket. Must be a positive integer.<\/li><\/ul><\/li><li><code>transition<\/code> - <code>array<\/code> - Optional - The container for the element that describes a transition action. At least one action (either <code>transition<\/code> or <code>expiration<\/code>) is required within one lifecycle rule. <ul><li><code>date<\/code> - <code>string<\/code> - Conditionally Required - The timestamp for when the targetted objects are to be moved or expired from the bucket. Should be in ISO 8601 Format. HH:MM:SS will be enforced as midnight GMT\/UTC.<\/li><li><code>days<\/code> - <code>integer<\/code> - Conditionally Required - The number of days until the targetted objects are to be moved or expired from the bucket. Must be a positive integer.<\/li><li><code>storage<\/code> - <code>string<\/code> - Required - The storage setting of an object. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>, <code>STORAGE_GLACIER<\/code>]. The default value is <code>STORAGE_STANDARD<\/code>.<\/li><\/ul><\/li><li><code>enabled<\/code> - <code>boolean<\/code> - Optional - Whether or not to enable this rule-set. A value of <code>true<\/code> enables the rule-set. A value of <code>false<\/code> disables the rule-set. The default value is <code>true<\/code>.<\/li><\/ul><\/li><\/ul><\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_lifecycle_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'lifecycle';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;object_expiration_xml, $this-&gt;parser_class);\n\n    if (isset($opt['rules']) &amp;&amp; is_array($opt['rules']) &amp;&amp; count($opt['rules']))\n    {\n        foreach ($opt['rules'] as $rule)\n        {\n            $xrule = $xml-&gt;addChild('Rule');\n\n            \/\/ ID\n            if (isset($rule['id']))\n            {\n                if (strlen($rule['id']) &gt; 255)\n                {\n                    throw new S3_Exception('The &quot;id&quot; for a rule must not be more than 255 characters in the ' . __FUNCTION__ . ' method.');\n                }\n\n                $xrule-&gt;addChild('ID', $rule['id']);\n            }\n\n            \/\/ Prefix\n            if (isset($rule['prefix']))\n            {\n                $xrule-&gt;addChild('Prefix', $rule['prefix']);\n            }\n            else\n            {\n                throw new S3_Exception('Each rule requires a &quot;prefix&quot; in the ' . __FUNCTION__ . ' method.');\n            }\n\n            \/\/ Status\n            $enabled = 'Enabled';\n            if (isset($rule['enabled']))\n            {\n                if (is_bool($rule['enabled'])) \/\/ Boolean\n                {\n                    $enabled = $rule['enabled'] ? 'Enabled' : 'Disabled';\n                }\n                elseif (is_string($rule['enabled'])) \/\/ String\n                {\n                    $enabled = (strtolower($rule['enabled']) === 'true') ? 'Enabled' : 'Disabled';\n                }\n\n                $xrule-&gt;addChild('Status', $enabled);\n            }\n            else\n            {\n                $xrule-&gt;addChild('Status', 'Enabled');\n            }\n\n            \/\/ Expiration\n            if (isset($rule['expiration']))\n            {\n                $xexpiration = $xrule-&gt;addChild('Expiration');\n\n                if (isset($rule['expiration']['date']))\n                {\n                    $xexpiration-&gt;addChild('Date', $rule['expiration']['date']);\n                }\n                elseif (isset($rule['expiration']['days']))\n                {\n                    $xexpiration-&gt;addChild('Days', $rule['expiration']['days']);\n                }\n            }\n\n            \/\/ Transition\n            if (isset($rule['transition']))\n            {\n                $xtransition = $xrule-&gt;addChild('Transition');\n\n                if (isset($rule['transition']['date']))\n                {\n                    $xtransition-&gt;addChild('Date', $rule['transition']['date']);\n                }\n                elseif (isset($rule['transition']['days']))\n                {\n                    $xtransition-&gt;addChild('Days', $rule['transition']['days']);\n                }\n\n                if (isset($rule['transition']['storage']))\n                {\n                    $xtransition-&gt;addChild('StorageClass', $rule['transition']['storage']);\n                }\n            }\n\n            if (!isset($rule['expiration']) &amp;&amp; !isset($rule['transition']))\n            {\n                throw new S3_Exception('Each rule requires a either a &quot;transition&quot; or &quot;expiration&quot; entry in the ' . __FUNCTION__ . ' method.');\n            }\n        }\n    }\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}"},{"name":"create_mpu_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Creates an Amazon S3 object using the multipart upload APIs. It is analogous to <a href=\"..\/s3browserupload\/create_object.html\" rel=\"..\/..\/index.html#m=s3browserupload\/create_object\"><code>create_object()<\/code><\/a>.<\/p>\n\n<p>While each individual part of a multipart upload can hold up to 5 GB of data, this method limits the\npart size to a maximum of 500 MB. The combined size of all parts can not exceed 5 TB of data. When an\nobject is stored in Amazon S3, the data is streamed to multiple storage servers in multiple data\ncenters. This ensures the data remains available in the event of internal network or hardware failure.<\/p>\n\n<p>Amazon S3 charges for storage as well as requests to the service. Smaller part sizes (and more\nrequests) allow for faster failures and better upload reliability. Larger part sizes (and fewer\nrequests) costs slightly less but has lower upload reliability.<\/p>\n\n<p>In certain cases with large objects, it&#8217;s possible for this method to attempt to open more file system\nconnections than allowed by the OS. In this case, either\n<a href=\"https:\/\/forums.aws.amazon.com\/thread.jspa?threadID=70216\">increase the number of connections\nallowed<\/a> or increase the value of the <code>partSize<\/code> parameter to use a larger part size.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>fileUpload<\/code> - <code>string|resource<\/code> - Required - The URL\/path for the file to upload, or an open resource.<\/li><li><code>acl<\/code> - <code>string<\/code> - Optional - The ACL settings for the specified object. [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. The default value is <code>ACL_PRIVATE<\/code>.<\/li><li><code>contentType<\/code> - <code>string<\/code> - Optional - The type of content that is being sent in the body. The default value is <code>application\/octet-stream<\/code>.<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>length<\/code> - <code>integer<\/code> - Optional - The size of the object in bytes. For more information, see <a href=\"http:\/\/www.w3.org\/Protocols\/rfc2616\/rfc2616-sec14.html#sec14.13\">RFC 2616, section 14.13<\/a>. The value can also be passed to the <code>header<\/code> option as <code>Content-Length<\/code>.<\/li><li><code>limit<\/code> - <code>integer<\/code> - Optional - The maximum number of concurrent uploads done by cURL. Gets passed to <code>CFBatchRequest<\/code>.<\/li><li><code>meta<\/code> - <code>array<\/code> - Optional - An associative array of key-value pairs. Any header starting with <code>x-amz-meta-:<\/code> is considered user metadata. It will be stored with the object and returned when you retrieve the object. The total size of the HTTP request, not including the body, must be less than 4 KB.<\/li><li><code>partSize<\/code> - <code>integer<\/code> - Optional - The size of an individual part. The size may not be smaller than 5 MB or larger than 500 MB. The default value is 50 MB.<\/li><li><code>redirectTo<\/code> - <code>string<\/code> - Optional - The URI to send an HTTP 301 redirect to when accessing this object. Value must be prefixed either <code>\/<\/code>, <code>http:\/\/<\/code> or <code>https:\/\/<\/code>.<\/li><li><code>seekTo<\/code> - <code>integer<\/code> - Optional - The starting position in bytes for the first piece of the file\/stream to upload.<\/li><li><code>storage<\/code> - <code>string<\/code> - Optional - Whether to use Standard or Reduced Redundancy storage. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]. The default value is <code>STORAGE_STANDARD<\/code>.<\/li><li><code>uploadId<\/code> - <code>string<\/code> - Optional - An upload ID identifying an existing multipart upload to use. If this option is not set, one will be created automatically.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_mpu_object($bucket, $filename, $opt = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    if (!$opt) $opt = array();\n\n    \/\/ Handle content length. Can also be passed as an HTTP header.\n    if (isset($opt['length']))\n    {\n        $opt['headers']['Content-Length'] = $opt['length'];\n        unset($opt['length']);\n    }\n\n    \/\/ URI to redirect to. Can also be passed as an HTTP header.\n    if (isset($opt['redirectTo']))\n    {\n        $opt['headers']['x-amz-website-redirect-location'] = $opt['redirectTo'];\n        unset($opt['redirectTo']);\n    }\n\n    if (!isset($opt['fileUpload']))\n    {\n        throw new S3_Exception('The `fileUpload` option is required in ' . __FUNCTION__ . '().');\n    }\n    elseif (is_resource($opt['fileUpload']))\n    {\n        $opt['limit'] = 1; \/\/ We can only read from this one resource.\n        $upload_position = isset($opt['seekTo']) ? (integer) $opt['seekTo'] : ftell($opt['fileUpload']);\n        $upload_filesize = isset($opt['headers']['Content-Length']) ? (integer) $opt['headers']['Content-Length'] : null;\n\n        if (!isset($upload_filesize) &amp;&amp; $upload_position !== false)\n        {\n            $stats = fstat($opt['fileUpload']);\n\n            if ($stats &amp;&amp; $stats['size'] &gt;= 0)\n            {\n                $upload_filesize = $stats['size'] - $upload_position;\n            }\n        }\n    }\n    else\n    {\n        $upload_position = isset($opt['seekTo']) ? (integer) $opt['seekTo'] : 0;\n\n        if (isset($opt['headers']['Content-Length']))\n        {\n            $upload_filesize = (integer) $opt['headers']['Content-Length'];\n        }\n        else\n        {\n            $upload_filesize = filesize($opt['fileUpload']);\n\n            if ($upload_filesize !== false)\n            {\n                $upload_filesize -= $upload_position;\n            }\n        }\n    }\n\n    if ($upload_position === false || !isset($upload_filesize) || $upload_filesize === false || $upload_filesize &lt; 0)\n    {\n        throw new S3_Exception('The size of `fileUpload` cannot be determined in ' . __FUNCTION__ . '().');\n    }\n\n    \/\/ Handle part size\n    if (isset($opt['partSize']))\n    {\n        \/\/ If less that 5 MB...\n        if ((integer) $opt['partSize'] &lt; 5242880)\n        {\n            $opt['partSize'] = 5242880; \/\/ 5 MB\n        }\n        \/\/ If more than 500 MB...\n        elseif ((integer) $opt['partSize'] &gt; 524288000)\n        {\n            $opt['partSize'] = 524288000; \/\/ 500 MB\n        }\n    }\n    else\n    {\n        $opt['partSize'] = 52428800; \/\/ 50 MB\n    }\n\n    \/\/ If the upload size is smaller than the piece size, failover to create_object().\n    if ($upload_filesize &lt; $opt['partSize'] &amp;&amp; !isset($opt['uploadId']))\n    {\n        return $this-&gt;create_object($bucket, $filename, $opt);\n    }\n\n    \/\/ Initiate multipart upload\n    if (isset($opt['uploadId']))\n    {\n        $upload_id = $opt['uploadId'];\n    }\n    else\n    {\n        \/\/ Compose options for initiate_multipart_upload().\n        $_opt = array();\n        foreach (array('contentType', 'acl', 'storage', 'headers', 'meta') as $param)\n        {\n            if (isset($opt[$param]))\n            {\n                $_opt[$param] = $opt[$param];\n            }\n        }\n\n        $upload = $this-&gt;initiate_multipart_upload($bucket, $filename, $_opt);\n        if (!$upload-&gt;isOK())\n        {\n            return $upload;\n        }\n\n        \/\/ Fetch the UploadId\n        $upload_id = (string) $upload-&gt;body-&gt;UploadId;\n    }\n\n    \/\/ Get the list of pieces\n    $pieces = $this-&gt;get_multipart_counts($upload_filesize, (integer) $opt['partSize']);\n\n    \/\/ Queue batch requests\n    $batch = new CFBatchRequest(isset($opt['limit']) ? (integer) $opt['limit'] : null);\n    foreach ($pieces as $i =&gt; $piece)\n    {\n        $this-&gt;batch($batch)-&gt;upload_part($bucket, $filename, $upload_id, array(\n            'expect' =&gt; '100-continue',\n            'fileUpload' =&gt; $opt['fileUpload'],\n            'partNumber' =&gt; ($i + 1),\n            'seekTo' =&gt; $upload_position + (integer) $piece['seekTo'],\n            'length' =&gt; (integer) $piece['length'],\n        ));\n    }\n\n    \/\/ Send batch requests\n    $batch_responses = $this-&gt;batch($batch)-&gt;send();\n    if (!$batch_responses-&gt;areOK())\n    {\n        return $batch_responses;\n    }\n\n    \/\/ Compose completion XML\n    $parts = array();\n    foreach ($batch_responses as $i =&gt; $response)\n    {\n        $parts[] = array('PartNumber' =&gt; ($i + 1), 'ETag' =&gt; $response-&gt;header['etag']);\n    }\n\n    return $this-&gt;complete_multipart_upload($bucket, $filename, $upload_id, $parts);\n}","examples":{"example":{"title":"<p>Create a new object using the multipart upload APIs.<\/p>","code":"\/\/ Define a mebibyte\ndefine('MB', 1024 * 1024);\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Create a new multipart object. Set several optional parameters as well.\n$response = $s3-&gt;create_mpu_object($bucket, 'tv_episode.webm', array(\n\t'fileUpload'  =&gt; 'tv_episode.webm',\n\t'partSize'    =&gt; 40*MB,\n\t'contentType' =&gt; 'video\/webm',\n\t'acl'         =&gt; AmazonS3::ACL_PRIVATE,\n\t'storage'     =&gt; AmazonS3::STORAGE_STANDARD,\n\t'meta'        =&gt; array(\n\t\t'resolution' =&gt; '720p',\n\t\t'rating'     =&gt; 'US TV-14',\n\t\t'runtime'    =&gt; '42:42'\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"create_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Creates an Amazon S3 object. After an Amazon S3 bucket is created, objects can be stored in it.<\/p>\n\n<p>Each standard object can hold up to 5 GB of data. When an object is stored in Amazon S3, the data is streamed\nto multiple storage servers in multiple data centers. This ensures the data remains available in the\nevent of internal network or hardware failure.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>acl<\/code> - <code>string<\/code> - Optional - The ACL settings for the specified object. Accepts any of the following constants: [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <code>ACL_PRIVATE<\/code>.<\/li><li><code>body<\/code> - <code>string<\/code> - Required; Conditional - The data to be stored in the object. Either this parameter or <code>fileUpload<\/code> must be specified.<\/li><li><code>contentType<\/code> - <code>string<\/code> - Optional - The type of content that is being sent in the body. If a file is being uploaded via <code>fileUpload<\/code> as a file system path, it will attempt to determine the correct mime-type based on the file extension. The default value is <code>application\/octet-stream<\/code>.<\/li><li><code>encryption<\/code> - <code>string<\/code> - Optional - The algorithm to use for encrypting the object. [Allowed values: <code>AES256<\/code>]<\/li><li><code>fileUpload<\/code> - <code>string|resource<\/code> - Required; Conditional - The URL\/path for the file to upload, or an open resource. Either this parameter or <code>body<\/code> is required.<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>length<\/code> - <code>integer<\/code> - Optional - The size of the object in bytes. For more information, see <a href=\"http:\/\/www.w3.org\/Protocols\/rfc2616\/rfc2616-sec14.html#sec14.13\">RFC 2616, section 14.13<\/a>. The value can also be passed to the <code>header<\/code> option as <code>Content-Length<\/code>.<\/li><li><code>meta<\/code> - <code>array<\/code> - Optional - An associative array of key-value pairs. Represented by <code>x-amz-meta-:<\/code>. Any header starting with this prefix is considered user metadata. It will be stored with the object and returned when you retrieve the object. The total size of the HTTP request, not including the body, must be less than 4 KB.<\/li><li><code>redirectTo<\/code> - <code>string<\/code> - Optional - The URI to send an HTTP 301 redirect to when accessing this object. Value must be prefixed either <code>\/<\/code>, <code>http:\/\/<\/code> or <code>https:\/\/<\/code>.<\/li><li><code>seekTo<\/code> - <code>integer<\/code> - Optional - The starting position in bytes within the file\/stream to upload from.<\/li><li><code>storage<\/code> - <code>string<\/code> - Optional - Whether to use Standard or Reduced Redundancy storage. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]. The default value is <code>STORAGE_STANDARD<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_object($bucket, $filename, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['resource'] = $filename;\n\n    \/\/ Handle content length. Can also be passed as an HTTP header.\n    if (isset($opt['length']))\n    {\n        $opt['headers']['Content-Length'] = $opt['length'];\n        unset($opt['length']);\n    }\n\n    \/\/ Handle content type. Can also be passed as an HTTP header.\n    if (isset($opt['contentType']))\n    {\n        $opt['headers']['Content-Type'] = $opt['contentType'];\n        unset($opt['contentType']);\n    }\n\n    \/\/ Handle Access Control Lists. Can also be passed as an HTTP header.\n    if (isset($opt['acl']))\n    {\n        if (is_array($opt['acl']))\n        {\n            $opt['headers'] = array_merge($opt['headers'], $this-&gt;generate_access_policy_headers($opt['acl']));\n        }\n        else\n        {\n            $opt['headers']['x-amz-acl'] = $opt['acl'];\n        }\n    }\n\n    \/\/ Handle storage settings. Can also be passed as an HTTP header.\n    if (isset($opt['storage']))\n    {\n        $opt['headers']['x-amz-storage-class'] = $opt['storage'];\n        unset($opt['storage']);\n    }\n\n    \/\/ Handle encryption settings. Can also be passed as an HTTP header.\n    if (isset($opt['encryption']))\n    {\n        $opt['headers']['x-amz-server-side-encryption'] = $opt['encryption'];\n        unset($opt['encryption']);\n    }\n\n    \/\/ URI to redirect to. Can also be passed as an HTTP header.\n    if (isset($opt['redirectTo']))\n    {\n        $opt['headers']['x-amz-website-redirect-location'] = $opt['redirectTo'];\n        unset($opt['redirectTo']);\n    }\n\n    \/\/ Handle meta tags. Can also be passed as an HTTP header.\n    if (isset($opt['meta']))\n    {\n        foreach ($opt['meta'] as $meta_key =&gt; $meta_value)\n        {\n            \/\/ e.g., `My Meta Header` is converted to `x-amz-meta-my-meta-header`.\n            $opt['headers']['x-amz-meta-' . strtolower(str_replace(' ', '-', $meta_key))] = $meta_value;\n        }\n        unset($opt['meta']);\n    }\n\n    $opt['headers']['Expect'] = '100-continue';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Upload a string of content as a new object to S3.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_object($bucket, 'test1.txt', array(\n\t'body' =&gt; 'This is my body text.'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create an object with spaces, slashes, and UTF-8 characters in the filename.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt', array(\n\t'body' =&gt; 'This is my body text.'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Upload a file instead of a string, and tweak some optional settings.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;create_object($bucket, '&uuml;pl&oslash;&aring;d\/&icirc;\\'v&eacute; n&oslash;w b&eacute;&eacute;n &uuml;pl&oslash;&aring;d&eacute;d.txt', array(\n\t'fileUpload' =&gt; 'upload_me.txt',\n\t\/\/ 'acl' =&gt; AmazonS3::ACL_PUBLIC,\n\t'contentType' =&gt; 'text\/plain',\n\t'storage' =&gt; AmazonS3::STORAGE_REDUCED,\n\t'headers' =&gt; array(\n\t\t'Cache-Control'    =&gt; 'max-age',\n\t\t'Content-Encoding' =&gt; 'gzip',\n\t\t'Content-Language' =&gt; 'en-US',\n\t\t'Expires'          =&gt; 'Thu, 01 Dec 1994 16:00:00 GMT',\n\t),\n\t'grants' =&gt; array(\n\t\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,                                               'permission' =&gt; AmazonS3::GRANT_READ        ),\n\t\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,                                               'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n\t\tarray( 'id' =&gt; AmazonS3::USERS_ALL,                                                'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n\t\tarray( 'id' =&gt; 'my-email-address@domain.com',                                      'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL),\n\t\tarray( 'id' =&gt; '41f37e4803dbae41aa52290608a037dcf2309199b81c6257fe5570098b9e55a9', 'permission' =&gt; AmazonS3::GRANT_WRITE       ),\n\t),\n\t'meta' =&gt; array(\n\t\t'word'         =&gt; 'to your mother',    \/\/ x-amz-meta-word\n\t\t'ice-ice-baby' =&gt; 'too cold, too cold' \/\/ x-amz-meta-ice-ice-baby\n\t),\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Upload from an open file resource, leveraging seek position and upload length.<\/p>","code":"\/\/ Define a mebibyte\ndefine('MB', 1048576);\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Open a file resource\n$file_resource = fopen('large_video.mov', 'r');\n\n\/\/ Upload a partial file\n$response = $s3-&gt;create_object($bucket, 'large_video.mov', array(\n\t'fileUpload' =&gt; $file_resource,\n\t'seekTo' =&gt; 80*MB,\n\t'length' =&gt; 5*MB,\n\t'acl' =&gt; AmazonS3::ACL_PUBLIC\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"create_object_expiration_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>@deprecated<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket"},{"@attributes":{"choice":"opt"},"name":"opt"}]},"returnvalue":{},"source":"public function create_object_expiration_config($bucket, $opt = null)\n{\n    return $this-&gt;create_lifecycle_config($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete an object expiration configuration.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create some files in the bucket\n\nfor ($i = 0; $i &lt; 10; $i++)\n{\n\t$even = ($i % 2) ? 'odd' : 'even';\n\n\t$s3-&gt;batch()-&gt;create_object($bucket, ($even . '\/&aring;&eacute;&icirc;&oslash;&uuml;' . $i), array(\n\t\t'body' =&gt; 'sample text',\n\t\t'contentType' =&gt; 'text\/plain; charset=utf-8'\n\t));\n}\n\n$responses = $s3-&gt;batch()-&gt;send();\n\nif ($responses-&gt;areOK())\n{\n\tprint_r($s3-&gt;get_object_list($bucket));\n\techo PHP_EOL;\n}\n\n#--------------------------------------------------------------------#\n# Create an object expiration configuration\n\n$response = $s3-&gt;create_object_expiration_config($bucket, array(\n\t'rules' =&gt; array(\n\t\tarray(\n\t\t\t'id' =&gt; 'unique-rule-identifier',\n\t\t\t'prefix' =&gt; 'even\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 3\n\t\t\t)\n\t\t),\n\t\tarray(\n\t\t\t'prefix' =&gt; 'odd\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 1\n\t\t\t)\n\t\t)\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_object_expiration_config($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Lookup the configuration\n\n$response = $s3-&gt;get_object_expiration_config($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the configuration\n\n$response = $s3-&gt;delete_object_expiration_config($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}},"related":{}},{"name":"create_website_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables and configures an Amazon S3 website using the corresponding bucket as the content source.\nThe website will have one default domain name associated with it, which is the bucket name. If you\nattempt to configure an Amazon S3 website for a bucket whose name is not compatible with DNS,\nAmazon S3 returns an <code>InvalidBucketName<\/code> error. For more information on bucket names and DNS,\nrefer to <a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/BucketRestrictions.html\">Bucket Restrictions and Limitations.<\/a><\/p>\n\n<p>To visit the bucket as a website a new endpoint is created in the following pattern:\n<code>http:\/\/&lt;bucketName&gt;.s3-website-&lt;region&gt;.amazonaws.com<\/code>. This is a sample URL\nfor a bucket called <code>example-bucket<\/code> in the <code>us-east-1<\/code> region.\n(e.g., <code>http:\/\/example-bucket.s3-website-us-east-1.amazonaws.com<\/code>)<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>indexDocument<\/code> - <code>string<\/code> - Optional - The file path to use as the root document. The default value is <code>index.html<\/code>.<\/li><li><code>errorDocument<\/code> - <code>string<\/code> - Optional - The file path to use as the error document. The default value is <code>error.html<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function create_website_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'website';\n\n    $xml = simplexml_load_string($this-&gt;website_config_xml);\n    if (isset($opt['indexDocument']))\n    {\n        $xml-&gt;IndexDocument-&gt;Suffix = $opt['indexDocument'];\n    }\n    if (isset($opt['errorDocument']))\n    {\n        $xml-&gt;ErrorDocument-&gt;Key = $opt['errorDocument'];\n    }\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Create a new website configuration.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Create a website, using index.html as the root document and error.html as the error document.\n$response = $s3-&gt;create_website_config($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Create a new website configuration.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Create a website, using home.html as the root document and 404.html as the error document.\n$response = $s3-&gt;create_website_config($bucket, array(\n\t'indexDocument' =&gt; 'home.html',\n\t'errorDocument' =&gt; '404.html'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]}},{"name":"current_uri","modifier":"public static","description":"<p>Returns the URI of the web page that this script is currently running on. This method only works\ncorrectly when run from a publicly-accessible web page.<\/p>","returnvalue":{},"source":"public static function current_uri()\n{\n    if (isset($_SERVER['REQUEST_URI']))\n    {\n        $uri = self::protocol();\n        $uri .= self::domain();\n        $uri .= $_SERVER['REQUEST_URI'];\n        return $uri;\n    }\n\n    return null;\n}"},{"name":"delete_all_object_versions","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes all of the versions of all Amazon S3 objects inside the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the names against. The default value is <a href=\"..\/s3browserupload\/constants.html#pcre_all\" rel=\"..\/..\/index.html#c=s3browserupload\/pcre_all\"><code>PCRE_ALL<\/code><\/a>.<\/p>"}]},"returnvalue":"<p>A value of <code>true<\/code> means that all object versions were successfully deleted. A value of <code>false<\/code> means that at least one object\/version failed to delete.<\/p>","source":"public function delete_all_object_versions($bucket, $pcre = null)\n{\n    \/\/ Instantiate\n    $versions = $this-&gt;list_bucket_object_versions($bucket);\n\n    \/\/ Gather all nodes together into a single array\n    if ($versions-&gt;body-&gt;DeleteMarker() &amp;&amp; $versions-&gt;body-&gt;Version())\n    {\n        $markers = array_merge($versions-&gt;body-&gt;DeleteMarker()-&gt;getArrayCopy(), $versions-&gt;body-&gt;Version()-&gt;getArrayCopy());\n    }\n    elseif ($versions-&gt;body-&gt;DeleteMarker())\n    {\n        $markers = $versions-&gt;body-&gt;DeleteMarker()-&gt;getArrayCopy();\n    }\n    elseif ($versions-&gt;body-&gt;Version())\n    {\n        $markers = $versions-&gt;body-&gt;Version()-&gt;getArrayCopy();\n    }\n    else\n    {\n        $markers = array();\n    }\n\n    while ((string) $versions-&gt;body-&gt;IsTruncated === 'true')\n    {\n        $versions = $this-&gt;list_bucket_object_versions($bucket, array(\n            'key-marker' =&gt; (string) $versions-&gt;body-&gt;NextKeyMarker\n        ));\n\n        \/\/ Gather all nodes together into a single array\n        if ($versions-&gt;body-&gt;DeleteMarker() &amp;&amp; $versions-&gt;body-&gt;Version())\n        {\n            $markers = array_merge($markers, $versions-&gt;body-&gt;DeleteMarker()-&gt;getArrayCopy(), $versions-&gt;body-&gt;Version()-&gt;getArrayCopy());\n        }\n        elseif ($versions-&gt;body-&gt;DeleteMarker())\n        {\n            $markers = array_merge($markers, $versions-&gt;body-&gt;DeleteMarker()-&gt;getArrayCopy());\n        }\n        elseif ($versions-&gt;body-&gt;Version())\n        {\n            $markers = array_merge($markers, $versions-&gt;body-&gt;Version()-&gt;getArrayCopy());\n        }\n    }\n\n    $objects = array();\n\n    \/\/ Loop through markers\n    foreach ($markers as $marker)\n    {\n        if ($pcre)\n        {\n            if (preg_match($pcre, (string) $marker-&gt;Key))\n            {\n                $xx = array('key' =&gt; (string) $marker-&gt;Key);\n                if ((string) $marker-&gt;VersionId !== 'null')\n                {\n                    $xx['version_id'] = (string) $marker-&gt;VersionId;\n                }\n                $objects[] = $xx;\n                unset($xx);\n            }\n        }\n        else\n        {\n            $xx = array('key' =&gt; (string) $marker-&gt;Key);\n            if ((string) $marker-&gt;VersionId !== 'null')\n            {\n                $xx['version_id'] = (string) $marker-&gt;VersionId;\n            }\n            $objects[] = $xx;\n            unset($xx);\n        }\n    }\n\n    $batch = new CFBatchRequest();\n    $batch-&gt;use_credentials($this-&gt;credentials);\n\n    foreach (array_chunk($objects, 1000) as $object_set)\n    {\n        $this-&gt;batch($batch)-&gt;delete_objects($bucket, array(\n            'objects' =&gt; $object_set\n        ));\n    }\n\n    $responses = $this-&gt;batch($batch)-&gt;send();\n    $is_ok = true;\n\n    foreach ($responses as $response)\n    {\n        if (!$response-&gt;isOK() || isset($response-&gt;body-&gt;Error))\n        {\n            $is_ok = false;\n        }\n    }\n\n    return $is_ok;\n}","examples":{"example":[{"title":"<p>Delete ALL versions of ALL objects within a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_all_object_versions($bucket);\n\n\/\/ Success?\nvar_dump($response !== false);","result":"bool(true)"},{"title":"<p>Delete ALL versions of objects within a bucket that match the PCRE regular expression.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_all_object_versions($bucket, '\/abc.txt\/i');\n\n\/\/ Success?\nvar_dump($response !== false);","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/php.net\/pcre\">Regular Expressions (Perl-Compatible)<\/a>"}},{"name":"delete_all_objects","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes all Amazon S3 objects inside the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the names against. The default value is <a href=\"..\/s3browserupload\/constants.html#pcre_all\" rel=\"..\/..\/index.html#c=s3browserupload\/pcre_all\"><code>PCRE_ALL<\/code><\/a>.<\/p>"}]},"returnvalue":"<p>A value of <code>true<\/code> means that all objects were successfully deleted. A value of <code>false<\/code> means that at least one object failed to delete.<\/p>","source":"public function delete_all_objects($bucket, $pcre = self::PCRE_ALL)\n{\n    \/\/ Collect all matches\n    $list = $this-&gt;get_object_list($bucket, array('pcre' =&gt; $pcre));\n\n    \/\/ As long as we have at least one match...\n    if (count($list) &gt; 0)\n    {\n        $objects = array();\n\n        foreach ($list as $object)\n        {\n            $objects[] = array('key' =&gt; $object);\n        }\n\n        $batch = new CFBatchRequest();\n        $batch-&gt;use_credentials($this-&gt;credentials);\n\n        foreach (array_chunk($objects, 1000) as $object_set)\n        {\n            $this-&gt;batch($batch)-&gt;delete_objects($bucket, array(\n                'objects' =&gt; $object_set\n            ));\n        }\n\n        $responses = $this-&gt;batch($batch)-&gt;send();\n        $is_ok = true;\n\n        foreach ($responses as $response)\n        {\n            if (!$response-&gt;isOK() || isset($response-&gt;body-&gt;Error))\n            {\n                $is_ok = false;\n            }\n        }\n\n        return $is_ok;\n    }\n\n    \/\/ If there are no matches, return true\n    return true;\n}","examples":{"example":{"title":"<p>Delete ALL objects within a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_all_objects($bucket);\n\n\/\/ Success?\nvar_dump($response);","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/php.net\/pcre\">Regular Expressions (Perl-Compatible)<\/a>"}},{"name":"delete_bucket","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes a bucket from an Amazon S3 account. A bucket must be empty before the bucket itself can be deleted.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"force","type":"boolean","description":"<p>Whether to force-delete the bucket and all of its contents. The default value is <code>false<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object if the bucket was deleted successfully. Returns boolean <code>false<\/code> if otherwise.<\/p>","source":"public function delete_bucket($bucket, $force = false, $opt = null)\n{\n    \/\/ Set default value\n    $success = true;\n\n    if ($force)\n    {\n        \/\/ Delete all of the items from the bucket.\n        $success = $this-&gt;delete_all_object_versions($bucket);\n    }\n\n    \/\/ As long as we were successful...\n    if ($success)\n    {\n        if (!$opt) $opt = array();\n        $opt['verb'] = 'DELETE';\n\n        return $this-&gt;authenticate($bucket, $opt);\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    return false;\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"0":{}}},{"name":"delete_bucket_notification","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Empties the list of SNS topics to send notifications to.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_bucket_notification($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'notification';\n    $opt['body'] = $this-&gt;base_notification_xml;\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Delete bucket notifications.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_bucket_notification($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/NotificationHowTo.html\">Setting Up Notification of Bucket Events<\/a>"}},{"name":"delete_bucket_policy","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes the bucket policy for the specified Amazon S3 bucket. To delete the policy, the caller must\nbe the bucket owner and have <code>DeletePolicy<\/code> permissions for the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response. If you do not have <code>DeletePolicy<\/code> permissions, Amazon S3 returns a <code>403 Access Denied<\/code> error. If you have the correct permissions, but are not the bucket owner, Amazon S3 returns a <code>405 Method Not Allowed<\/code> error. If the bucket doesn&#8217;t have a policy, Amazon S3 returns a <code>204 No Content<\/code> error.<\/p>","source":"public function delete_bucket_policy($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['sub_resource'] = 'policy';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Delete a bucket policy.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Delete the bucket policy\n$response = $s3-&gt;delete_bucket_policy($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"delete_bucket_tags","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Delete all associated tags from the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_bucket_tags($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['sub_resource'] = 'tagging';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete bucket tags.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create new bucket tags\n\n$response = $s3-&gt;create_bucket_tags($bucket, array(\n\t'tags' =&gt; array(\n\t\t'project' =&gt; 'foo',\n\t\t'user'    =&gt; 'bar',\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_bucket_tags($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Retrieve the bucket tags\n\n$response = $s3-&gt;get_bucket_tags($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the bucket tags\n\n$response = $s3-&gt;delete_bucket_tags($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}}},{"name":"delete_cache","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Deletes a cached <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object using the specified cache storage type.<\/p>","returnvalue":"<p>A value of <code>true<\/code> if cached object exists and is successfully deleted, otherwise <code>false<\/code>.<\/p>","source":"public function delete_cache()\n{\n    $this-&gt;use_cache_flow = true;\n    $this-&gt;delete_cache = true;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Delete a cached response from APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(false)"},{"title":"<p>Delete a cached response from the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"},{"title":"<p>Delete a cached response from Memcache.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config(array(\n\tarray('host' =&gt; '127.0.0.1')\n));\n\n\/\/ Delete the data\n$response = $sdb-&gt;delete_cache()-&gt;list_domains();\nvar_dump($response);","result":"bool(true)"}]}},{"name":"delete_cors_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes the CORS configuration.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_cors_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['sub_resource'] = 'cors';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"0":{}}},{"name":"delete_lifecycle_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes the configuration that relates to the object&#8217;s <em>lifecycle<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_lifecycle_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['sub_resource'] = 'lifecycle';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}"},{"name":"delete_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes an Amazon S3 object from the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to delete. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>MFASerial<\/code> - <code>string<\/code> - Optional - The serial number on the back of the Gemalto device. <code>MFASerial<\/code> and <code>MFAToken<\/code> must both be set for MFA to work.<\/li><li><code>MFAToken<\/code> - <code>string<\/code> - Optional - The current token displayed on the Gemalto device. <code>MFASerial<\/code> and <code>MFAToken<\/code> must both be set for MFA to work.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_object($bucket, $filename, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['resource'] = $filename;\n\n    \/\/ Enable MFA delete?\n    \/\/ @codeCoverageIgnoreStart\n    if (isset($opt['MFASerial']) &amp;&amp; isset($opt['MFAToken']))\n    {\n        $opt['headers'] = array(\n            'x-amz-mfa' =&gt; ($opt['MFASerial'] . ' ' . $opt['MFAToken'])\n        );\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Delete an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Delete a specific version of an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Delete a specific version\n$response = $s3-&gt;delete_object($bucket, 'test1.txt', array(\n\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie='\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strpos((string) $response-&gt;header['_info']['url'], 'versionId=' . $version_id) !== false);","result":"bool(true)\nbool(true)"},{"title":"<p>Delete a specific version of an object from an MFA-protected bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;delete_object('my-bucket', 'test1.txt', array(\n\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie=',\n\t'MFASerial' =&gt; CFCredentials::get()-&gt;mfa_serial, \/\/ Custom property in the config file.\n\t'MFAToken' =&gt; '12345678'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strpos((string) $response-&gt;header['_info']['url'], 'versionId=' . $version_id) !== false);","result":"bool(true)\nbool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/aws.amazon.com\/mfa\/\">Multi-Factor Authentication<\/a>"}},{"name":"delete_object_expiration_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>@deprecated<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket"},{"@attributes":{"choice":"opt"},"name":"opt"}]},"returnvalue":{},"source":"public function delete_object_expiration_config($bucket, $opt = null)\n{\n    return $this-&gt;delete_lifecycle_config($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete an object expiration configuration.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create some files in the bucket\n\nfor ($i = 0; $i &lt; 10; $i++)\n{\n\t$even = ($i % 2) ? 'odd' : 'even';\n\n\t$s3-&gt;batch()-&gt;create_object($bucket, ($even . '\/&aring;&eacute;&icirc;&oslash;&uuml;' . $i), array(\n\t\t'body' =&gt; 'sample text',\n\t\t'contentType' =&gt; 'text\/plain; charset=utf-8'\n\t));\n}\n\n$responses = $s3-&gt;batch()-&gt;send();\n\nif ($responses-&gt;areOK())\n{\n\tprint_r($s3-&gt;get_object_list($bucket));\n\techo PHP_EOL;\n}\n\n#--------------------------------------------------------------------#\n# Create an object expiration configuration\n\n$response = $s3-&gt;create_object_expiration_config($bucket, array(\n\t'rules' =&gt; array(\n\t\tarray(\n\t\t\t'id' =&gt; 'unique-rule-identifier',\n\t\t\t'prefix' =&gt; 'even\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 3\n\t\t\t)\n\t\t),\n\t\tarray(\n\t\t\t'prefix' =&gt; 'odd\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 1\n\t\t\t)\n\t\t)\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_object_expiration_config($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Lookup the configuration\n\n$response = $s3-&gt;get_object_expiration_config($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the configuration\n\n$response = $s3-&gt;delete_object_expiration_config($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}},"related":{}},{"name":"delete_objects","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Deletes one or more specified Amazon S3 objects from the specified bucket.<\/p>\n\n<p>Since <code>delete_object()<\/code> is designed for deleting a single object, this method is intended to be used\nwhen there are two or more objects to delete.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>objects<\/code> - <code>array<\/code> - Required - The object references to delete from the bucket. <ul><li><code>key<\/code> - <code>string<\/code> - Required - The name of the object (e.g., the &#8220;key&#8221;) to delete. This should include the entire file path including all &#8220;subdirectories&#8221;.<\/li><li><code>version_id<\/code> - <code>string<\/code> - Optional - If the object is versioned, include the version ID to delete.<\/li><\/ul><\/li><li><code>quiet<\/code> - <code>boolean<\/code> - Optional - Whether or not Amazon S3 should use &#8220;Quiet&#8221; mode for this operation. A value of <code>true<\/code> will enable Quiet mode. A value of <code>false<\/code> will use Verbose mode. The default value is <code>false<\/code>.<\/li><li><code>MFASerial<\/code> - <code>string<\/code> - Optional - The serial number on the back of the Gemalto device. <code>MFASerial<\/code> and <code>MFAToken<\/code> must both be set for MFA to work.<\/li><li><code>MFAToken<\/code> - <code>string<\/code> - Optional - The current token displayed on the Gemalto device. <code>MFASerial<\/code> and <code>MFAToken<\/code> must both be set for MFA to work.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_objects($bucket, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'POST';\n    $opt['sub_resource'] = 'delete';\n    $opt['body'] = '';\n\n    \/\/ Bail out\n    if (!isset($opt['objects']) || !is_array($opt['objects']))\n    {\n        throw new S3_Exception('The ' . __FUNCTION__ . ' method requires the &quot;objects&quot; option to be set as an array.');\n    }\n\n    $xml = new SimpleXMLElement($this-&gt;multi_object_delete_xml);\n\n    \/\/ Add the objects\n    foreach ($opt['objects'] as $object)\n    {\n        $xobject = $xml-&gt;addChild('Object');\n        $node = $xobject-&gt;addChild('Key');\n        $node[0] = $object['key'];\n\n        if (isset($object['version_id']))\n        {\n            $xobject-&gt;addChild('VersionId', $object['version_id']);\n        }\n    }\n\n    \/\/ Quiet mode?\n    if (isset($opt['quiet']))\n    {\n        $quiet = 'false';\n        if (is_bool($opt['quiet'])) \/\/ Boolean\n        {\n            $quiet = $opt['quiet'] ? 'true' : 'false';\n        }\n        elseif (is_string($opt['quiet'])) \/\/ String\n        {\n            $quiet = ($opt['quiet'] === 'true') ? 'true' : 'false';\n        }\n\n        $xml-&gt;addChild('Quiet', $quiet);\n    }\n\n    \/\/ Enable MFA delete?\n    \/\/ @codeCoverageIgnoreStart\n    if (isset($opt['MFASerial']) &amp;&amp; isset($opt['MFAToken']))\n    {\n        $opt['headers'] = array(\n            'x-amz-mfa' =&gt; ($opt['MFASerial'] . ' ' . $opt['MFAToken'])\n        );\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","seealso":{"link":"<a href=\"http:\/\/aws.amazon.com\/mfa\/\">Multi-Factor Authentication<\/a>"}},{"name":"delete_website_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Removes the website configuration for a bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function delete_website_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'DELETE';\n    $opt['sub_resource'] = 'website';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Delete website configuration.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;delete_website_config($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"disable_logging","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Disables access logging for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use. Pass <code>null<\/code> if using <a href=\"..\/s3browserupload\/set_vhost.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_vhost\"><code>set_vhost()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function disable_logging($bucket, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'logging';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n    $opt['body'] = $this-&gt;base_logging_xml;\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Disable logging for a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$logging_bucket = 'my-bucket-logs' . strtolower($s3-&gt;key);\n$logged_bucket = 'my-bucket-test' . strtolower($s3-&gt;key);\n\n\/\/ Disable logging for a given bucket\n$response = $s3-&gt;disable_logging($logged_bucket);\n\n\/\/ Delete bucket that contained the logs\n$s3-&gt;delete_bucket($logging_bucket, true);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/LoggingAPI.html\">Server Access Logging Configuration API<\/a>"}},{"name":"disable_ssl","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables SSL\/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still\nrequire SSL support.<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl()\n{\n    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;use_ssl = false;\n    return $this;\n}","examples":{"example":{"title":"<p>Disable SSL for the service.<\/p>","description":"<ul>\n<li><strong>Note:<\/strong> It is not recommended to disable SSL.<\/li>\n<li><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/li>\n<\/ul>","code":"\/\/ Disable SSL (Using @ to suppress the warning from the output)\n$sdb = new AmazonSDB();\n@$sdb-&gt;disable_ssl(true);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;use_ssl);","result":"bool(false)"}}},{"name":"disable_ssl_verification","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry\nout a man-in-the-middle attack.<\/p>\n\n<p>https:\/\/secure.wikimedia.org\/wikipedia\/en\/wiki\/Man-in-the-middle_attack<\/p>\n\n<p>This method will throw a user warning when invoked, which can be hidden by changing your\n<a href=\"http:\/\/php.net\/error_reporting\"><code>error_reporting()<\/code><\/a> settings.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"ssl_verification"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function disable_ssl_verification($ssl_verification = false)\n{\n    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);\n    $this-&gt;ssl_verification = $ssl_verification;\n    return $this;\n}"},{"name":"disable_versioning","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Disables versioning support for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>MFASerial<\/code> - <code>string<\/code> - Optional - The serial number on the back of the Gemalto device. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>MFAToken<\/code> - <code>string<\/code> - Optional - The current token displayed on the Gemalto device. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>MFAStatus<\/code> - <code>string<\/code> - Optional - The MFA Delete status. Can be <code>Enabled<\/code> or <code>Disabled<\/code>. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function disable_versioning($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'versioning';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;base_versioning_xml);\n    $xml-&gt;addChild('Status', 'Suspended');\n\n    \/\/ Enable MFA delete?\n    \/\/ @codeCoverageIgnoreStart\n    if (isset($opt['MFASerial']) &amp;&amp; isset($opt['MFAToken']) &amp;&amp; isset($opt['MFAStatus']))\n    {\n        $xml-&gt;addChild('MfaDelete', $opt['MFAStatus']);\n        $opt['headers']['x-amz-mfa'] = ($opt['MFASerial'] . ' ' . $opt['MFAToken']);\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Disable the versioning on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;disable_versioning($bucket);\nvar_dump($response-&gt;isOK());\n\n$status = $s3-&gt;get_versioning_status($bucket);\nvar_dump((string) $status-&gt;body-&gt;Status);","result":"bool(true)\nstring(9) \"Suspended\""},{"title":"<p>Disable the versioning on an MFA-enabled bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;disable_versioning('my-bucket', array(\n\t'MFASerial' =&gt; CFCredentials::get()-&gt;mfa_serial, \/\/ Custom property in the config file.\n\t'MFAToken' =&gt; '12345678',\n\t'MFAStatus' =&gt; 'Disabled'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/aws.amazon.com\/mfa\/\">Multi-Factor Authentication<\/a>"}},{"name":"domain","modifier":"public static","description":"<p>Returns the domain (and port) of the web page that this script is currently running on. This method\nonly works correctly when run from a publicly-accessible web page.<\/p>","returnvalue":{},"source":"public static function domain()\n{\n    if (isset($_SERVER['SERVER_NAME']) &amp;&amp; isset($_SERVER['SERVER_PORT']))\n    {\n        return $_SERVER['SERVER_NAME'] . ((integer) $_SERVER['SERVER_PORT'] === 80 ? '' : ':' . $_SERVER['SERVER_PORT']);\n    }\n\n    return null;\n}"},{"name":"enable_debug_mode","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Enables HTTP request\/response header logging to <code>STDERR<\/code>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"enabled","type":"boolean","description":"<p>Whether or not to enable debug mode. Defaults to <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_debug_mode($enabled = true)\n{\n    $this-&gt;debug_mode = $enabled;\n    return $this;\n}","examples":{"example":{"title":"<p>Enable the logging of HTTP request\/response headers to <code>STDERR<\/code>.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;enable_debug_mode();\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;debug_mode);","result":"bool(true)"}}},{"name":"enable_logging","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables access logging for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to enable logging for. Pass a <code>null<\/code> value when using the <a href=\"..\/s3browserupload\/set_vhost.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_vhost\"><code>set_vhost()<\/code><\/a> method.<\/p>"},{"@attributes":{"choice":"req"},"name":"target_bucket","type":"string","description":"<p>The name of the bucket to store the logs in.<\/p>"},{"@attributes":{"choice":"req"},"name":"target_prefix","type":"string","description":"<p>The prefix to give to the log file names.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>users<\/code> - <code>array<\/code> - Optional - An array of associative arrays specifying any user to give access to. Each associative array contains an <code>id<\/code> and <code>permission<\/code> value.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function enable_logging($bucket, $target_bucket, $target_prefix, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'logging';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;base_logging_xml);\n    $LoggingEnabled = $xml-&gt;addChild('LoggingEnabled');\n    $LoggingEnabled-&gt;addChild('TargetBucket', $target_bucket);\n    $LoggingEnabled-&gt;addChild('TargetPrefix', $target_prefix);\n    $TargetGrants = $LoggingEnabled-&gt;addChild('TargetGrants');\n\n    if (isset($opt['users']) &amp;&amp; is_array($opt['users']))\n    {\n        foreach ($opt['users'] as $user)\n        {\n            $grant = $TargetGrants-&gt;addChild('Grant');\n            $grantee = $grant-&gt;addChild('Grantee');\n\n            switch ($user['id'])\n            {\n                \/\/ Authorized Users\n                case self::USERS_AUTH:\n                    $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                    $grantee-&gt;addChild('URI', self::USERS_AUTH);\n                    break;\n\n                \/\/ All Users\n                case self::USERS_ALL:\n                    $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                    $grantee-&gt;addChild('URI', self::USERS_ALL);\n                    break;\n\n                \/\/ The Logging User\n                case self::USERS_LOGGING:\n                    $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                    $grantee-&gt;addChild('URI', self::USERS_LOGGING);\n                    break;\n\n                \/\/ Email Address or Canonical Id\n                default:\n                    if (strpos($user['id'], '@'))\n                    {\n                        $grantee-&gt;addAttribute('xsi:type', 'AmazonCustomerByEmail', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                        $grantee-&gt;addChild('EmailAddress', $user['id']);\n                    }\n                    else\n                    {\n                        \/\/ Assume Canonical Id\n                        $grantee-&gt;addAttribute('xsi:type', 'CanonicalUser', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                        $grantee-&gt;addChild('ID', $user['id']);\n                    }\n                    break;\n            }\n\n            $grant-&gt;addChild('Permission', $user['permission']);\n        }\n    }\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Enable logging on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$logged_bucket = 'my-bucket-test' . strtolower($s3-&gt;key);\n$logging_bucket = 'my-bucket-logs' . strtolower($s3-&gt;key);\n\n\/\/ Create bucket for storing logs\n$bucket = $s3-&gt;create_bucket($logging_bucket, AmazonS3::REGION_US_STANDARD);\n\n\/\/ Ensure that the bucket was created successfully...\nif ($bucket-&gt;isOK())\n{\n\t\/\/ Enable READ_ACP and WRITE permissions for the system-wide &quot;logging&quot; user.\n\t$acl = $s3-&gt;set_bucket_acl($logging_bucket, array(\n\t\tarray( 'id' =&gt; AmazonS3::USERS_LOGGING,            'permission' =&gt; AmazonS3::GRANT_READ_ACP     ), \/\/ Logging user, READ_ACP\n\t\tarray( 'id' =&gt; AmazonS3::USERS_LOGGING,            'permission' =&gt; AmazonS3::GRANT_WRITE        ), \/\/ Logging user, WRITE\n\t\tarray( 'id' =&gt; CFCredentials::get()-&gt;canonical_id, 'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL ), \/\/ Self, FULL_CONTROL\n\t));\n\n\t\/\/ Ensure that the ACL was set correctly...\n\tif ($acl-&gt;isOK())\n\t{\n\t\t\/\/ Enable logging on the bucket\n\t\t$response = $s3-&gt;enable_logging($logged_bucket, $logging_bucket, 'log_', array(\n\t\t\t'users' =&gt; array(\n\t\t\t\tarray('id' =&gt; AmazonS3::USERS_AUTH,    'permission' =&gt; AmazonS3::GRANT_READ),\n\t\t\t\tarray('id' =&gt; AmazonS3::USERS_ALL,     'permission' =&gt; AmazonS3::GRANT_READ),\n\t\t\t\tarray('id' =&gt; AmazonS3::USERS_LOGGING, 'permission' =&gt; AmazonS3::GRANT_READ),\n\t\t\t\tarray('id' =&gt; 'email@domain.com', 'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL),\n\t\t\t)\n\t\t));\n\n\t\t\/\/ Success?\n\t\tvar_dump($response-&gt;isOK());\n\t}\n}","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/LoggingAPI.html\">Server Access Logging Configuration API<\/a>"}},{"name":"enable_path_style","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables the use of the older path-style URI access for all requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"style","type":"string","description":"<p>Whether or not to enable path-style URI access for all requests. The default value is <code>true<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function enable_path_style($style = true)\n{\n    $this-&gt;path_style = $style;\n    return $this;\n}"},{"name":"enable_versioning","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Enables versioning support for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>MFASerial<\/code> - string (Optional) The serial number on the back of the Gemalto device. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>MFAToken<\/code> - string (Optional) The current token displayed on the Gemalto device. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>MFAStatus<\/code> - string (Optional) The MFA Delete status. Can be <code>Enabled<\/code> or <code>Disabled<\/code>. <code>MFASerial<\/code>, <code>MFAToken<\/code> and <code>MFAStatus<\/code> must all be set for MFA to work.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function enable_versioning($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'versioning';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;base_versioning_xml);\n    $xml-&gt;addChild('Status', 'Enabled');\n\n    \/\/ Enable MFA delete?\n    \/\/ @codeCoverageIgnoreStart\n    if (isset($opt['MFASerial']) &amp;&amp; isset($opt['MFAToken']) &amp;&amp; isset($opt['MFAStatus']))\n    {\n        $xml-&gt;addChild('MfaDelete', $opt['MFAStatus']);\n        $opt['headers']['x-amz-mfa'] = ($opt['MFASerial'] . ' ' . $opt['MFAToken']);\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Enable versioning on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;enable_versioning($bucket);\nsleep(1);\n$status = $s3-&gt;get_versioning_status($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump((string) $status-&gt;body-&gt;Status);","result":"bool(true)\nstring(7) \"Enabled\""},{"title":"<p>Enable versioning and Multi-Factor Authentication on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;enable_versioning('my-bucket', array(\n\t'MFASerial' =&gt; CFCredentials::get()-&gt;mfa_serial, \/\/ Custom property in the config file.\n\t'MFAToken' =&gt; '12345678',\n\t'MFAStatus' =&gt; 'Enabled'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/aws.amazon.com\/mfa\/\">Multi-Factor Authentication<\/a>"}},{"name":"factory","modifier":"public static","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Alternate approach to constructing a new instance. Supports chaining.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"options","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>certificate_authority<\/code> - <code>boolean<\/code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false<\/code> will use the Certificate Authority file available on the system. A value of boolean <code>true<\/code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755<\/code>) will use that. Leave this set to <code>false<\/code> if you&#8217;re not sure.<\/li><li><code>credentials<\/code> - <code>string<\/code> - Optional - The name of the credential set to use for authentication.<\/li><li><code>default_cache_config<\/code> - <code>string<\/code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href=\"..\/s3browserupload\/set_cache_config.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_cache_config\"><code>set_cache_config()<\/code><\/a> method. Valid values are: <code>apc<\/code>, <code>xcache<\/code>, or a file system path such as <code>.\/cache<\/code> or <code>\/tmp\/cache\/<\/code>.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.<\/li><li><code>secret<\/code> - <code>string<\/code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.<\/li><li><code>token<\/code> - <code>string<\/code> - Optional - An AWS session token.<\/li><\/ul>"}},"returnvalue":{"@attributes":{"type":"void"}},"source":"public static function factory(array $options = array())\n{\n    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))\n    {\n        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');\n    }\n\n    $self = get_called_class();\n    return new $self($options);\n}"},{"name":"generate_access_policy","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Generates the XML to be used for the Access Control Policy.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"canonical_id","type":"string","description":"<p>The canonical ID for the bucket owner. This is provided as the <code>id<\/code> return value from <a href=\"..\/s3browserupload\/get_canonical_user_id.html\" rel=\"..\/..\/index.html#m=s3browserupload\/get_canonical_user_id\"><code>get_canonical_user_id()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"canonical_name","type":"string","description":"<p>The canonical display name for the bucket owner. This is provided as the <code>display_name<\/code> value from <a href=\"..\/s3browserupload\/get_canonical_user_id.html\" rel=\"..\/..\/index.html#m=s3browserupload\/get_canonical_user_id\"><code>get_canonical_user_id()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"req"},"name":"users","type":"array","description":"<p>An array of associative arrays. Each associative array contains an <code>id<\/code> value and a <code>permission<\/code> value.<\/p>"}]},"returnvalue":"<p>Access Control Policy XML.<\/p>","source":"public function generate_access_policy($canonical_id, $canonical_name, $users)\n{\n    $xml = simplexml_load_string($this-&gt;base_acp_xml);\n    $owner = $xml-&gt;addChild('Owner');\n    $owner-&gt;addChild('ID', $canonical_id);\n    $owner-&gt;addChild('DisplayName', $canonical_name);\n    $acl = $xml-&gt;addChild('AccessControlList');\n\n    foreach ($users as $user)\n    {\n        $grant = $acl-&gt;addChild('Grant');\n        $grantee = $grant-&gt;addChild('Grantee');\n\n        switch ($user['id'])\n        {\n            \/\/ Authorized Users\n            case self::USERS_AUTH:\n                $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                $grantee-&gt;addChild('URI', self::USERS_AUTH);\n                break;\n\n            \/\/ All Users\n            case self::USERS_ALL:\n                $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                $grantee-&gt;addChild('URI', self::USERS_ALL);\n                break;\n\n            \/\/ The Logging User\n            case self::USERS_LOGGING:\n                $grantee-&gt;addAttribute('xsi:type', 'Group', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                $grantee-&gt;addChild('URI', self::USERS_LOGGING);\n                break;\n\n            \/\/ Email Address or Canonical Id\n            default:\n                if (strpos($user['id'], '@'))\n                {\n                    $grantee-&gt;addAttribute('xsi:type', 'AmazonCustomerByEmail', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                    $grantee-&gt;addChild('EmailAddress', $user['id']);\n                }\n                else\n                {\n                    \/\/ Assume Canonical Id\n                    $grantee-&gt;addAttribute('xsi:type', 'CanonicalUser', 'http:\/\/www.w3.org\/2001\/XMLSchema-instance');\n                    $grantee-&gt;addChild('ID', $user['id']);\n                }\n                break;\n        }\n\n        $grant-&gt;addChild('Permission', $user['permission']);\n    }\n\n    return $xml-&gt;asXML();\n}","seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/ACLOverview.html\">Access Control Lists<\/a>"}},{"name":"generate_access_policy_headers","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Generates the HTTP headers to be used for the Access Control Policy Grants.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"users","type":"array","description":"<p>An array of associative arrays. Each associative array contains an <code>id<\/code> value and a <code>permission<\/code> value.<\/p>"}},"returnvalue":"<p>HTTP headers to be applied to the request.<\/p>","source":"public function generate_access_policy_headers($users)\n{\n    $headers = array();\n\n    foreach ($users as $user)\n    {\n        \/\/ Determine permission. If doesn't exist, create it.\n        $permission = 'x-amz-grant-' . str_replace('_', '-', strtolower($user['permission']));\n        if (!isset($headers[$permission]))\n        {\n            $headers[$permission] = array();\n        }\n\n        \/\/ Handle the IDs\n        switch ($user['id'])\n        {\n            case self::USERS_AUTH:    \/\/ Authorized Users\n            case self::USERS_ALL:     \/\/ All Users\n            case self::USERS_LOGGING: \/\/ The Logging User\n                $headers[$permission][] = 'uri=&quot;' . $user['id'] . '&quot;';\n                break;\n\n            \/\/ Email Address or Canonical Id\n            default:\n                if (strpos($user['id'], '@'))\n                {\n                    \/\/ Treat as email address\n                    $headers[$permission][] = 'emailAddress=&quot;' . $user['id'] . '&quot;';\n                }\n                else\n                {\n                    \/\/ Assume Canonical Id\n                    $headers[$permission][] = 'id=&quot;' . $user['id'] . '&quot;';\n                }\n                break;\n        }\n    }\n\n    foreach ($headers as &amp;$permission)\n    {\n        $permission = implode(', ', $permission);\n    }\n\n    return $headers;\n}","seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/ACLOverview.html\">Access Control Lists<\/a>"}},{"name":"generate_upload_parameters","modifier":"public","description":"<p>The <code>POST<\/code> operation adds an object to a specified bucket using HTML forms. POST is an alternate\nform of <code>PUT<\/code> that enables browser-based uploads as a way of putting objects in buckets.\nParameters that are passed to <code>PUT<\/code> via HTTP headers are instead passed as form fields to\n<code>POST<\/code> in the <code>multipart\/form-data<\/code> encoded message body. You must have\n<code>WRITE<\/code> access on a bucket to add an object to it. Amazon S3 never stores partial objects: if\nyou receive a successful response, you can be confident the entire object was stored.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"expires","type":"string|integer","description":"<p>The point in time when the upload form field should expire. The default value is <code>+1 hour<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>acl<\/code> - <code>string<\/code> - Optional - The access control setting to apply to the uploaded file. Accepts any of the following constants: [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>].<\/li><li><code>Cache-Control<\/code> - <code>string<\/code> - Optional - The Cache-Control HTTP header value to apply to the uploaded file. To use a <code>starts-with<\/code> comparison instead of an <code>equals<\/code> comparison, prefix the value with a <code>^<\/code> (carat) character.<\/li><li><code>Content-Disposition<\/code> - <code>string<\/code> - Optional - The Content-Disposition HTTP header value to apply to the uploaded file. To use a <code>starts-with<\/code> comparison instead of an <code>equals<\/code> comparison, prefix the value with a <code>^<\/code> (carat) character.<\/li><li><code>Content-Encoding<\/code> - <code>string<\/code> - Optional - The Content-Encoding HTTP header value to apply to the uploaded file. To use a <code>starts-with<\/code> comparison instead of an <code>equals<\/code> comparison, prefix the value with a <code>^<\/code> (carat) character.<\/li><li><code>Content-Type<\/code> - <code>string<\/code> - Optional - The Content-Type HTTP header value to apply to the uploaded file. The default value is <code>application\/octet-stream<\/code>. To use a <code>starts-with<\/code> comparison instead of an <code>equals<\/code> comparison, prefix the value with a <code>^<\/code> (carat) character.<\/li><li><code>Expires<\/code> - <code>string<\/code> - Optional - The Expires HTTP header value to apply to the uploaded file. To use a <code>starts-with<\/code> comparison instead of an <code>equals<\/code> comparison, prefix the value with a <code>^<\/code> (carat) character.<\/li><li><code>key<\/code> - <code>string<\/code> - Optional - The location where the file should be uploaded to. The default value is <code>${filename}<\/code>.<\/li><li><code>success_action_redirect<\/code> - <code>string<\/code> - Optional - The URI for Amazon S3 to redirect to upon successful upload.<\/li><li><code>success_action_status<\/code> - <code>integer<\/code> - Optional - The status code for Amazon S3 to return upon successful upload.<\/li><li><code>x-amz-server-side-encryption<\/code> - <code>string<\/code> - Optional - The server-side encryption mechanism to use. [Allowed values: <code>AES256<\/code>].<\/li><li><code>x-amz-storage-class<\/code> - <code>string<\/code> - Optional - The storage setting to apply to the object. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]. The default value is <code>AmazonS3::STORAGE_STANDARD<\/code>.<\/li><li><code>x-amz-website-redirect-location<\/code> - <code>string<\/code> - Optional - The URI to send an HTTP 301 redirect to when accessing this object. Value must be prefixed either <code>\/<\/code>, <code>http:\/\/<\/code> or <code>https:\/\/<\/code>.<\/li><li><code>x-amz-meta-*<\/code> - <code>mixed<\/code> - Optional - Any custom meta tag that should be set to the object.<\/li><\/ul>"}]},"returnvalue":"<p>An array of fields that can be converted into markup.<\/p>","source":"public function generate_upload_parameters($bucket, $expires = '+1 hour', $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Policy document\n    $policy = array(\n        'conditions' =&gt; array(\n            array('bucket' =&gt; $bucket),\n        )\n    );\n\n    \/\/ Basic form\n    $form = array();\n    $form['form'] = array(\n        'action' =&gt; $bucket . '.s3.amazonaws.com',\n        'method' =&gt; 'POST',\n        'enctype' =&gt; 'multipart\/form-data'\n    );\n\n    \/\/ Inputs\n    $form['inputs'] = array(\n        'AWSAccessKeyId' =&gt; $this-&gt;key\n    );\n\n    \/\/ Expires\n    if ($expires)\n    {\n        if (is_numeric($expires))\n        {\n            $expires = gmdate('j M Y, g:i a Z', (integer) $expires);\n        }\n\n        $expires = $this-&gt;util-&gt;convert_date_to_iso8601($expires);\n        $policy['expiration'] = (string) $expires;\n    }\n\n    \/\/ Default values\n    if (!isset($opt['key']))\n    {\n        $opt['key'] = '${filename}';\n    }\n\n    \/\/ Success Action Status\n    if (isset($opt['success_action_status']) &amp;&amp; !empty($opt['success_action_status']))\n    {\n        $form['inputs']['success_action_status'] = (string) $opt['success_action_status'];\n        $policy['conditions'][] = array(\n            'success_action_status' =&gt; (string) $opt['success_action_status']\n        );\n        unset($opt['success_action_status']);\n    }\n\n    \/\/ Other parameters\n    foreach ($opt as $param_key =&gt; $param_value)\n    {\n        if ($param_value[0] === '^')\n        {\n            $form['inputs'][$param_key] = substr((string) $param_value, 1);\n            $param_value = preg_replace('\/\\$\\{(\\w*)\\}\/', '', (string) $param_value);\n            $policy['conditions'][] = array('starts-with', '$' . $param_key, (substr((string) $param_value, 1) ? substr((string) $param_value, 1) : ''));\n        }\n        else\n        {\n            $form['inputs'][$param_key] = (string) $param_value;\n            $policy['conditions'][] = array(\n                $param_key =&gt; (string) $param_value\n            );\n        }\n    }\n\n    \/\/ Add policy\n    $json_policy = json_encode($policy);\n    $json_policy_b64 = base64_encode($json_policy);\n    $form['inputs']['policy'] = $json_policy_b64;\n    $form['metadata']['json_policy'] = $json_policy;\n\n    \/\/ Add signature\n    $form['inputs']['signature'] = base64_encode(hash_hmac('sha1', $json_policy_b64, $this-&gt;secret_key, true));\n\n    return $form;\n}","examples":{"example":{"title":"<p>Generate the parameters for a browser-based POST upload.<\/p>","description":"<p>This example shows how to construct the data object that is then used to generate HTML.<\/p>","code":"$upload = new S3BrowserUpload();\n\n\/\/ Generate the parameters for the upload.\n$html_parameters = $upload-&gt;generate_upload_parameters('my-upload-bucket', '15 minutes', array(\n\n\t\/\/ Set permissions to private.\n\t'acl' =&gt; AmazonS3::ACL_PRIVATE,\n\n\t\/\/ Set various HTTP headers on the uploaded file.\n\t'Content-Disposition' =&gt; 'attachment; filename=information.txt',\n\t'Content-Encoding' =&gt; 'gzip',\n\t'Content-Type' =&gt; '^text\/',\n\t'Expires' =&gt; gmdate(DATE_RFC1123, strtotime('January 1, 1970, midnight GMT')), \/\/ Format for the HTTP Expires header\n\n\t\/\/ The S3 Key to upload to. ${filename} is an S3 variable that equals the name of the file being uploaded.\n\t\/\/ We're also using PHP's built-in Filter extension in this example.\n\t'key' =&gt; '^user\/' . filter_var($_POST['user_id'], FILTER_VALIDATE_INT) . '\/${filename}',\n\n\t\/\/ Where should S3 redirect to after the upload completes? The current page.\n\t'success_action_redirect' =&gt; S3BrowserUpload::current_uri(),\n\n\t\/\/ Status code to send back on success. This is primarily to work around issues in Adobe&reg; Flash&reg;.\n\t'success_action_status' =&gt; 201,\n\n\t\/\/ Use reduced redundancy storage.\n\t'x-amz-storage-class' =&gt; AmazonS3::STORAGE_REDUCED\n));\n\n\n\n&lt;form action=&quot;&lt;?= $html_parameters['form']['action'] &quot;\n      method=&quot;&lt;?= $html_parameters['form']['method'] &quot;\n      enctype=&quot;&lt;?= $html_parameters['form']['enctype'] &quot;&gt;\n\n&lt;? foreach ($html_parameters['inputs'] as $name =&gt; $value): \n&lt;input type=&quot;hidden&quot; name=&quot;&lt;?= $name; &quot; value=&quot;&lt;?= $value; &quot;&gt;\n&lt;? endforeach; \n\n&lt;input type=&quot;file&quot; name=&quot;file&quot;&gt;\n&lt;input type=&quot;submit&quot; name=&quot;upload&quot; value=&quot;Upload&quot;&gt;\n&lt;\/form&gt;"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/API\/RESTObjectPOST.html\">POST Object<\/a>"}},{"name":"get_bucket_acl","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the access control list (ACL) settings for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_acl($bucket, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'acl';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get the ACL settings for a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-us-east-acl' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_acl($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"get_bucket_filesize","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the cumulative file size of the contents of the Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"friendly_format","type":"boolean","description":"<p>A value of <code>true<\/code> will format the return value to 2 decimal points using the largest possible unit (i.e., 3.42 GB). A value of <code>false<\/code> will format the return value as the raw number of bytes.<\/p>"}]},"returnvalue":"<p>The number of bytes as an integer, or the friendly format as a string.<\/p>","source":"public function get_bucket_filesize($bucket, $friendly_format = false)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $filesize = 0;\n    $list = $this-&gt;list_objects($bucket);\n\n    foreach ($list-&gt;body-&gt;Contents as $filename)\n    {\n        $filesize += (integer) $filename-&gt;Size;\n    }\n\n    while ((string) $list-&gt;body-&gt;IsTruncated === 'true')\n    {\n        $body = (array) $list-&gt;body;\n        $list = $this-&gt;list_objects($bucket, array(\n            'marker' =&gt; (string) end($body['Contents'])-&gt;Key\n        ));\n\n        foreach ($list-&gt;body-&gt;Contents as $object)\n        {\n            $filesize += (integer) $object-&gt;Size;\n        }\n    }\n\n    if ($friendly_format)\n    {\n        $filesize = $this-&gt;util-&gt;size_readable($filesize);\n    }\n\n    return $filesize;\n}","examples":{"example":[{"title":"<p>Get the size of the contents of a bucket, in bytes.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_filesize($bucket);\n\n\/\/ Success?\nvar_dump($response);"},{"title":"<p>Get the size of the contents of a bucket, measured in the largest reasonable unit.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_filesize($bucket, true);\n\n\/\/ Success?\nvar_dump($response);"}]}},{"name":"get_bucket_headers","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the HTTP headers for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_headers($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'HEAD';\n\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get the headers for a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_headers($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_bucket_list","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets a simplified list of bucket names on an Amazon S3 account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"pcre","type":"string","description":"<p>A Perl-Compatible Regular Expression (PCRE) to filter the bucket names against.<\/p>"}},"returnvalue":"<p>The list of matching bucket names. If there are no results, the method will return an empty array.<\/p>","source":"public function get_bucket_list($pcre = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    \/\/ Get a list of buckets.\n    $list = $this-&gt;list_buckets();\n    if ($list = $list-&gt;body-&gt;query('descendant-or-self::Name'))\n    {\n        $list = $list-&gt;map_string($pcre);\n        return $list;\n    }\n\n    \/\/ @codeCoverageIgnoreStart\n    return array();\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"example":[{"title":"<p>Get the list of buckets in your account.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;get_bucket_list();\n\n\/\/ Success?\nprint_r($response);"},{"title":"<p>Get the list of buckets in your account that match a PCRE regular expression pattern.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n\/\/ Only return the buckets with 'my-' in the name\n$response = $s3-&gt;get_bucket_list('\/my-\/i');\n\n\/\/ Success?\nprint_r($response);"}]},"seealso":{"link":"<a href=\"http:\/\/php.net\/pcre\">Regular Expressions (Perl-Compatible)<\/a>"}},{"name":"get_bucket_notifications","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the notification configuration of a bucket. Currently, the <code>s3:ReducedRedundancyLostObject<\/code> event\nis the only event supported for notifications. The <code>s3:ReducedRedundancyLostObject<\/code> event is triggered\nwhen Amazon S3 detects that it has lost all replicas of a Reduced Redundancy Storage object and can no\nlonger service requests for that object.<\/p>\n\n<p>If notifications are not enabled on the bucket, the operation returns an empty\n<code>NotificatonConfiguration<\/code> element.<\/p>\n\n<p>By default, you must be the bucket owner to read the notification configuration of a bucket. However,\nthe bucket owner can use a bucket policy to grant permission to other users to read this configuration\nwith the <code>s3:GetBucketNotification<\/code> permission.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_notifications($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'notification';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get bucket notifications.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_notifications($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/NotificationHowTo.html\">Setting Up Notification of Bucket Events<\/a>"}},{"name":"get_bucket_object_count","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the number of Amazon S3 objects in the specified bucket.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"}},"returnvalue":"<p>The number of Amazon S3 objects in the bucket.<\/p>","source":"public function get_bucket_object_count($bucket)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ @codeCoverageIgnoreStart\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n        \/\/ @codeCoverageIgnoreEnd\n    }\n\n    return count($this-&gt;get_object_list($bucket));\n}","examples":{"example":{"title":"<p>Get the number of objects inside the bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_object_count($bucket);\n\n\/\/ Success?\nvar_dump($response);"}}},{"name":"get_bucket_policy","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the policy of the specified Amazon S3 bucket.<\/p>\n\n<p>To use this operation, the caller must have GetPolicy permissions for the specified bucket and must be\nthe bucket owner. If the caller does not have GetPolicy permissions, this method will generate a\n<code>403 Access Denied<\/code> error. If the caller has the correct permissions but is not the bucket owner, this\nmethod will generate a <code>405 Method Not Allowed<\/code> error. If the bucket does not have a policy defined for\nit, this method will generate a <code>404 Policy Not Found<\/code> error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_policy($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'policy';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get the bucket policy for a given bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get the bucket policy\n$response = $s3-&gt;get_bucket_policy($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_bucket_region","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the region in which the specified Amazon S3 bucket is located.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_region($bucket, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'location';\n\n    \/\/ Authenticate to S3\n    $response = $this-&gt;authenticate($bucket, $opt);\n\n    if ($response-&gt;isOK())\n    {\n        \/\/ Handle body\n        $response-&gt;body = (string) $response-&gt;body;\n    }\n\n    return $response;\n}","examples":{"example":{"title":"<p>Get the region code that the bucket is contained in.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-us-east' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_bucket_region($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump($response-&gt;body === ''); \/\/ U.S. Standard Region is an empty string.","result":"bool(true)\nbool(true)"}}},{"name":"get_bucket_tags","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Retrieve all associated tags for the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_bucket_tags($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'tagging';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete bucket tags.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create new bucket tags\n\n$response = $s3-&gt;create_bucket_tags($bucket, array(\n\t'tags' =&gt; array(\n\t\t'project' =&gt; 'foo',\n\t\t'user'    =&gt; 'bar',\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_bucket_tags($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Retrieve the bucket tags\n\n$response = $s3-&gt;get_bucket_tags($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the bucket tags\n\n$response = $s3-&gt;delete_bucket_tags($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}}},{"name":"get_canonical_user_id","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the canonical user ID and display name from the Amazon S3 server.<\/p>","returnvalue":"<p>An associative array containing the <code>id<\/code> and <code>display_name<\/code> values.<\/p>","source":"public function get_canonical_user_id()\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $id = $this-&gt;list_buckets();\n\n    return array(\n        'id' =&gt; (string) $id-&gt;body-&gt;Owner-&gt;ID,\n        'display_name' =&gt; (string) $id-&gt;body-&gt;Owner-&gt;DisplayName\n    );\n}"},{"name":"get_cors_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Retrieves the CORS configuration.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_cors_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'cors';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"0":{}}},{"name":"get_lifecycle_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Retrieves the configuration that relates to the object&#8217;s <em>lifecycle<\/em>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_lifecycle_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'lifecycle';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}"},{"name":"get_logs","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the access logs associated with the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use. Pass a <code>null<\/code> value when using the <a href=\"..\/s3browserupload\/set_vhost.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_vhost\"><code>set_vhost()<\/code><\/a> method.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_logs($bucket, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'logging';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get the logs associated with a given bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_logs($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/ServerLogs.html\">Server Access Logging<\/a>"}},{"name":"get_multipart_counts","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Calculates the correct values for sequentially reading a file for multipart upload. This method should\nbe used in conjunction with <a href=\"..\/s3browserupload\/upload_part.html\" rel=\"..\/..\/index.html#m=s3browserupload\/upload_part\"><code>upload_part()<\/code><\/a>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"filesize","type":"integer","description":"<p>The size in bytes of the entire file.<\/p>"},{"@attributes":{"choice":"req"},"name":"part_size","type":"integer","description":"<p>The size in bytes of the part of the file to send.<\/p>"}]},"returnvalue":"<p>An array containing key-value pairs. The keys are <code>seekTo<\/code> and <code>length<\/code>.<\/p>","source":"public function get_multipart_counts($filesize, $part_size)\n{\n    $i = 0;\n    $sizecount = $filesize;\n    $values = array();\n\n    while ($sizecount &gt; 0)\n    {\n        $sizecount -= $part_size;\n        $values[] = array(\n            'seekTo' =&gt; ($part_size * $i),\n            'length' =&gt; (($sizecount &gt; 0) ? $part_size : ($sizecount + $part_size)),\n        );\n        $i++;\n    }\n\n    return $values;\n}","examples":{"example":{"title":"<p>Get the seek position and length values for a multipart upload.<\/p>","code":"define('MB', 1048576);\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;get_multipart_counts(125*MB, 40*MB);\n\n\/\/ Success?\nvar_dump($response);","result":"array(4) {\n  [0]=&gt;\n  array(2) {\n    [\"seekTo\"]=&gt;\n    int(0)\n    [\"length\"]=&gt;\n    int(41943040)\n  }\n  [1]=&gt;\n  array(2) {\n    [\"seekTo\"]=&gt;\n    int(41943040)\n    [\"length\"]=&gt;\n    int(41943040)\n  }\n  [2]=&gt;\n  array(2) {\n    [\"seekTo\"]=&gt;\n    int(83886080)\n    [\"length\"]=&gt;\n    int(41943040)\n  }\n  [3]=&gt;\n  array(2) {\n    [\"seekTo\"]=&gt;\n    int(125829120)\n    [\"length\"]=&gt;\n    int(5242880)\n  }\n}"}}},{"name":"get_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the contents of an Amazon S3 object in the specified bucket.<\/p>\n\n<p>The MD5 value for an object can be retrieved from the ETag HTTP header for any object that was uploaded\nwith a normal PUT\/POST. This value is incorrect for multipart uploads.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>etag<\/code> - <code>string<\/code> - Optional - The <code>ETag<\/code> header passed in from a previous request. If specified, request <code>LastModified<\/code> option must be specified as well. Will trigger a <code>304 Not Modified<\/code> status code if the file hasn&#8217;t changed.<\/li><li><code>fileDownload<\/code> - <code>string|resource<\/code> - Optional - The file system location to download the file to, or an open file resource. Must be a server-writable location.<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>lastmodified<\/code> - <code>string<\/code> - Optional - The <code>LastModified<\/code> header passed in from a previous request. If specified, request <code>ETag<\/code> option must be specified as well. Will trigger a <code>304 Not Modified<\/code> status code if the file hasn&#8217;t changed.<\/li><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>range<\/code> - <code>string<\/code> - Optional - The range of bytes to fetch from the object. Specify this parameter when downloading partial bits or completing incomplete object downloads. The specified range must be notated with a hyphen (e.g., 0-10485759). Defaults to the byte range of the complete Amazon S3 object.<\/li><li><code>response<\/code> - <code>array<\/code> - Optional - Allows adjustments to specific response headers. Pass an associative array where each key is one of the following: <code>cache-control<\/code>, <code>content-disposition<\/code>, <code>content-encoding<\/code>, <code>content-language<\/code>, <code>content-type<\/code>, <code>expires<\/code>. The <code>expires<\/code> value should use <a href=\"http:\/\/php.net\/gmdate\"><code>gmdate()<\/code><\/a> and be formatted with the <code>DATE_RFC2822<\/code> constant.<\/li><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to retrieve. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_object($bucket, $filename, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'GET';\n    $opt['resource'] = $filename;\n\n    if (!isset($opt['headers']) || !is_array($opt['headers']))\n    {\n        $opt['headers'] = array();\n    }\n\n    if (isset($opt['lastmodified']))\n    {\n        $opt['headers']['If-Modified-Since'] = $opt['lastmodified'];\n    }\n\n    if (isset($opt['etag']))\n    {\n        $opt['headers']['If-None-Match'] = $opt['etag'];\n    }\n\n    \/\/ Partial content range\n    if (isset($opt['range']))\n    {\n        $opt['headers']['Range'] = 'bytes=' . $opt['range'];\n    }\n\n    \/\/ GET responses\n    if (isset($opt['response']))\n    {\n        foreach ($opt['response'] as $key =&gt; $value)\n        {\n            $opt['response-' . $key] = $value;\n            unset($opt['response'][$key]);\n        }\n    }\n\n    \/\/ Authenticate to S3\n    $this-&gt;parse_the_response = false;\n    $response = $this-&gt;authenticate($bucket, $opt);\n    $this-&gt;parse_the_response = true;\n\n    return $response;\n}","examples":{"example":[{"title":"<p>Get an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Get an object in pieces by specifying byte ranges.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Empty response\n$response = '';\n\n\/\/ Read the first chunk\n$response .= $s3-&gt;get_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt', array(\n\t'range' =&gt; '0-10'\n))-&gt;body;\n\n\/\/ Read the second chunk\n$response .= $s3-&gt;get_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt', array(\n\t'range' =&gt; '11-21'\n))-&gt;body;\n\n\/\/ Success?\nvar_dump($response);","result":"string(21) \"This is my body text.\""},{"title":"<p>Conditionally get an object if the object has changed since we last pulled it.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get the file once\n$response = $s3-&gt;get_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt');\n\n\/\/ Store the ETag and Last-Modified headers\n$etag = $response-&gt;header['etag'];\n$last_modified = $response-&gt;header['last-modified'];\n\n\/*---- Later... ----*\/\n\n\/\/ Ask the server if the file has changed\n$new_response = $s3-&gt;get_object($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt', array(\n\t'lastmodified' =&gt; $last_modified,\n\t'etag' =&gt; $etag\n));\n\nif ($new_response-&gt;isOK())\n{\n\t\/\/ The server replied with &quot;Yes, the file HAS changed. Here you go.&quot; (200)\n\t\/\/ Do something awesome with the updated data.\n}\nelseif ($new_response-&gt;isOK(304))\n{\n\t\/\/ The server replied with &quot;Dude, you've already got it.&quot; (304)\n\t\/\/ Do nothing because you're already awesome.\n}\n\n\/\/ Success?\nvar_dump($new_response-&gt;status);","result":"int(304)"},{"title":"<p>Get a specific version of an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get a specific version\n$response = $s3-&gt;get_object($bucket, 'test1.txt', array(\n\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie='\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strpos((string) $response-&gt;header['_info']['url'], 'versionId=' . $version_id) !== false);","result":"bool(true)\nbool(true)"},{"title":"<p>Download an object to the file system.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object($bucket, 'large_video.mov', array(\n\t'fileDownload' =&gt; 'large_video.mov'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Download to an open file resource.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$file_resource = fopen('large_video.mov', 'w+');\n\n$response = $s3-&gt;get_object($bucket, 'large_video.mov', array(\n\t'fileDownload' =&gt; $file_resource\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Override specific response headers.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object($bucket, 'm&aring;rk&eacute;r w&icirc;th sp&aring;c&eacute;s &aring;nd &icirc;ntl\/&aring;&eacute;&icirc;&oslash;&uuml;.txt', array(\n\t'response' =&gt; array(\n\t\t'content-type'     =&gt; 'text\/plain',\n\t\t'content-language' =&gt; 'en-US',\n\t\t'expires'          =&gt; gmdate(DATE_RFC2822, strtotime('1 January 1980'))\n\t)\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\n\n\/\/ Check that we got back what we asked for\nvar_dump($response-&gt;header['content-language']);\nvar_dump($response-&gt;header['content-type']);\nvar_dump($response-&gt;header['expires']);","result":"bool(true)\nstring(5) \"en-US\"\nstring(10) \"text\/plain\"\nstring(31) \"Tue, 01 Jan 1980 08:00:00 +0000\""}]}},{"name":"get_object_acl","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the access control list (ACL) settings for the specified Amazon S3 object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to retrieve. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_object_acl($bucket, $filename, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['resource'] = $filename;\n    $opt['sub_resource'] = 'acl';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Get the ACL settings for an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_acl($bucket, 'test1.txt');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Get the ACL settings for a specific version of an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get a specific version\n$response = $s3-&gt;get_object_acl($bucket, 'test1.txt', array(\n\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie='\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strpos((string) $response-&gt;header['_info']['url'], 'versionId=' . '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie=') !== false);","result":"bool(true)\nbool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"get_object_expiration_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>@deprecated<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket"},{"@attributes":{"choice":"opt"},"name":"opt"}]},"returnvalue":{},"source":"public function get_object_expiration_config($bucket, $opt = null)\n{\n    return $this-&gt;get_lifecycle_config($bucket, $opt);\n}","examples":{"example":{"title":"<p>Create, get and delete an object expiration configuration.<\/p>","code":"$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n#--------------------------------------------------------------------#\n# Create a new bucket\n\n$response = $s3-&gt;create_bucket($bucket, AmazonS3::REGION_US_STANDARD);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the bucket a moment to create\n\twhile (!$s3-&gt;if_bucket_exists($bucket))\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Create some files in the bucket\n\nfor ($i = 0; $i &lt; 10; $i++)\n{\n\t$even = ($i % 2) ? 'odd' : 'even';\n\n\t$s3-&gt;batch()-&gt;create_object($bucket, ($even . '\/&aring;&eacute;&icirc;&oslash;&uuml;' . $i), array(\n\t\t'body' =&gt; 'sample text',\n\t\t'contentType' =&gt; 'text\/plain; charset=utf-8'\n\t));\n}\n\n$responses = $s3-&gt;batch()-&gt;send();\n\nif ($responses-&gt;areOK())\n{\n\tprint_r($s3-&gt;get_object_list($bucket));\n\techo PHP_EOL;\n}\n\n#--------------------------------------------------------------------#\n# Create an object expiration configuration\n\n$response = $s3-&gt;create_object_expiration_config($bucket, array(\n\t'rules' =&gt; array(\n\t\tarray(\n\t\t\t'id' =&gt; 'unique-rule-identifier',\n\t\t\t'prefix' =&gt; 'even\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 3\n\t\t\t)\n\t\t),\n\t\tarray(\n\t\t\t'prefix' =&gt; 'odd\/',\n\t\t\t'expiration' =&gt; array(\n\t\t\t\t'days' =&gt; 1\n\t\t\t)\n\t\t)\n\t)\n));\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Give the configuration a moment to settle in\n\twhile (!$s3-&gt;get_object_expiration_config($bucket)-&gt;isOK())\n\t{\n\t\tsleep(1);\n\t}\n}\n\n#--------------------------------------------------------------------#\n# Lookup the configuration\n\n$response = $s3-&gt;get_object_expiration_config($bucket);\nprint_r($response-&gt;body);\necho PHP_EOL;\n\n#--------------------------------------------------------------------#\n# Delete the configuration\n\n$response = $s3-&gt;delete_object_expiration_config($bucket);\n\nif ($response-&gt;isOK())\n{\n\t\/\/ Delete the bucket\n\t$response = $s3-&gt;delete_bucket($bucket, true);\n\n\tif ($response-&gt;isOK())\n\t{\n\t\techo 'Bucket was deleted!' . PHP_EOL;\n\t}\n\telse\n\t{\n\t\techo 'Bucket deletion failed. #sadtromboneissad' . PHP_EOL;\n\t}\n}"}},"related":{}},{"name":"get_object_filesize","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the file size of the specified Amazon S3 object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"friendly_format","type":"boolean","description":"<p>A value of <code>true<\/code> will format the return value to 2 decimal points using the largest possible unit (i.e., 3.42 GB). A value of <code>false<\/code> will format the return value as the raw number of bytes.<\/p>"}]},"returnvalue":"<p>The number of bytes as an integer, or the friendly format as a string. Returns false if the request failed.<\/p>","source":"public function get_object_filesize($bucket, $filename, $friendly_format = false)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $response = $this-&gt;get_object_headers($bucket, $filename);\n    if (!$response-&gt;isOK()) {\n        return false;\n    }\n\n    $filesize = (integer) $response-&gt;header['content-length'];\n\n    if ($friendly_format)\n    {\n        $filesize = $this-&gt;util-&gt;size_readable($filesize);\n    }\n\n    return $filesize;\n}","examples":{"example":[{"title":"<p>Get the size of the object, in bytes.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_filesize($bucket, 'video\/sample.mp4');\n\n\/\/ Success?\nvar_dump($response);"},{"title":"<p>Get the size of the object, measured in the largest reasonable unit.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_filesize($bucket, 'video\/sample.mp4', true);\n\n\/\/ Success?\nvar_dump($response);"}]}},{"name":"get_object_headers","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the HTTP headers for the specified Amazon S3 object.<\/p>\n\n<p>The MD5 value for an object can be retrieved from the ETag HTTP header for any object that was uploaded\nwith a normal PUT\/POST. This value is incorrect for multipart uploads.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to retrieve. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_object_headers($bucket, $filename, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'HEAD';\n    $opt['resource'] = $filename;\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Get the headers for an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_headers($bucket, 'prefix with spaces\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml;\/&aring;&eacute;&icirc;&oslash;&uuml; with spaces.txt');\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Get the headers for a specific version of an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ HEAD a specific version\n$response = $s3-&gt;get_object_headers($bucket, 'test1.txt', array(\n\t'versionId' =&gt; '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie='\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(strpos((string) $response-&gt;header['_info']['url'], 'versionId=' . '0NNAq8PwvXvg8EfAYG9sSmwKTZeixZgZNE6PbodG8td0DJ3gVOmjI2Gh\/oFnb0Ie=') !== false);","result":"bool(true)\nbool(true)"}]}},{"name":"get_object_list","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets a simplified list of Amazon S3 object file names contained in a bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<p>&lt;<\/p>\n\n<p>ul><li><code>delimiter<\/code> - <code>string<\/code> - Optional - Keys that contain the same string between the prefix and the first occurrence of the delimiter will be rolled up into a single result element in the CommonPrefixes collection.<\/li><li><code>marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the marker.<\/li><li><code>max-keys<\/code> - <code>integer<\/code> - Optional - The maximum number of results returned by the method call. The returned list will contain no more results than the specified value, but may return less. A value of zero is treated as if you did not specify max-keys.<\/li><li><code>pcre<\/code> - <code>string<\/code> - Optional - A Perl-Compatible Regular Expression (PCRE) to filter the names against. This is applied only AFTER any native Amazon S3 filtering from specified <code>prefix<\/code>, <code>marker<\/code>, <code>max-keys<\/code>, or <code>delimiter<\/code> values are applied.<\/li><li><code>prefix<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that begin only with the specified prefix.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><\/p>"}]},"returnvalue":"<p>The list of matching object names. If there are no results, the method will return an empty array.<\/p>","source":"public function get_object_list($bucket, $opt = null)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    if (!$opt) $opt = array();\n    unset($opt['returnCurlHandle']); \/\/ This would cause problems\n\n    \/\/ Set some default values\n    $pcre = isset($opt['pcre']) ? $opt['pcre'] : null;\n    $max_keys = (isset($opt['max-keys']) &amp;&amp; is_int($opt['max-keys'])) ? $opt['max-keys'] : null;\n    $objects = array();\n\n    if (!$max_keys)\n    {\n        \/\/ No max-keys specified. Get everything.\n        do\n        {\n            $list = $this-&gt;list_objects($bucket, $opt);\n            if (is_string($list-&gt;body))\n            {\n                $list-&gt;body = new CFSimpleXML($list-&gt;body);\n            }\n            if ($keys = $list-&gt;body-&gt;query('descendant-or-self::Key')-&gt;map_string($pcre))\n            {\n                $objects = array_merge($objects, $keys);\n            }\n\n            $body = (array) $list-&gt;body;\n            $opt = array_merge($opt, array(\n                'marker' =&gt; (isset($body['Contents']) &amp;&amp; is_array($body['Contents'])) ?\n                    ((string) end($body['Contents'])-&gt;Key) :\n                    ((string) $list-&gt;body-&gt;Contents-&gt;Key)\n            ));\n        }\n        while ((string) $list-&gt;body-&gt;IsTruncated === 'true');\n    }\n    else\n    {\n        \/\/ Max-keys specified. Approximate number of loops and make the requests.\n\n        $max_keys = $opt['max-keys'];\n        $loops = ceil($max_keys \/ 1000);\n\n        do\n        {\n            $list = $this-&gt;list_objects($bucket, $opt);\n            if (is_string($list-&gt;body))\n            {\n                $list-&gt;body = new CFSimpleXML($list-&gt;body);\n            }\n            $keys = $list-&gt;body-&gt;query('descendant-or-self::Key')-&gt;map_string($pcre);\n\n            if ($count = count($keys))\n            {\n                $objects = array_merge($objects, $keys);\n\n                if ($count &lt; 1000)\n                {\n                    break;\n                }\n            }\n\n            if ($max_keys &gt; 1000)\n            {\n                $max_keys -= 1000;\n            }\n\n            $body = (array) $list-&gt;body;\n            $opt = array_merge($opt, array(\n                'max-keys' =&gt; $max_keys,\n                'marker' =&gt; (isset($body['Contents']) &amp;&amp; is_array($body['Contents'])) ?\n                    ((string) end($body['Contents'])-&gt;Key) :\n                    ((string) $list-&gt;body-&gt;Contents-&gt;Key)\n            ));\n        }\n        while (--$loops);\n    }\n\n    return $objects;\n}","examples":{"example":[{"title":"<p>Get a list of all filenames in a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_list($bucket);\n\n\/\/ Success?\nvar_dump(gettype($response) === 'array');","result":"bool(true)"},{"title":"<p>Get a list of all filenames in a bucket that match a given PCRE regular expression pattern.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get all filenames that match this pattern\n$response = $s3-&gt;get_object_list($bucket, array(\n\t'pcre' =&gt; '\/pdf\/i'\n));\n\n\/\/ Success?\nvar_dump(gettype($response) === 'array');","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/php.net\/pcre\">Regular Expressions (Perl-Compatible)<\/a>"}},{"name":"get_object_metadata","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the collective metadata for the given Amazon S3 object.<\/p>\n\n<p>The MD5 value for an object can be retrieved from the ETag HTTP header for any object that was uploaded\nwith a normal PUT\/POST. This value is incorrect for multipart uploads.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the Amazon S3 object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object to retrieve. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>If the object exists, the method returns the collective metadata for the Amazon S3 object. If the object does not exist, the method returns boolean <code>false<\/code>.<\/p>","source":"public function get_object_metadata($bucket, $filename, $opt = null)\n{\n    $batch = new CFBatchRequest();\n    $this-&gt;batch($batch)-&gt;get_object_acl($bucket, $filename); \/\/ Get ACL info\n    $this-&gt;batch($batch)-&gt;get_object_headers($bucket, $filename); \/\/ Get content-type\n    $this-&gt;batch($batch)-&gt;list_objects($bucket, array( \/\/ Get other metadata\n        'max-keys' =&gt; 1,\n        'prefix' =&gt; $filename\n    ));\n    $response = $this-&gt;batch($batch)-&gt;send();\n\n    \/\/ Fail if any requests were unsuccessful\n    if (!$response-&gt;areOK())\n    {\n        return false;\n    }\n\n    $data = array(\n        'ACL'          =&gt; array(),\n        'ContentType'  =&gt; null,\n        'ETag'         =&gt; null,\n        'Headers'      =&gt; null,\n        'Key'          =&gt; null,\n        'LastModified' =&gt; null,\n        'Owner'        =&gt; array(),\n        'Size'         =&gt; null,\n        'StorageClass' =&gt; null,\n    );\n\n    \/\/ Add the content type\n    $data['ContentType'] = (string) $response[1]-&gt;header['content-type'];\n\n    \/\/ Add the other metadata (including storage type)\n    $contents = json_decode(json_encode($response[2]-&gt;body-&gt;query('descendant-or-self::Contents')-&gt;first()), true);\n    $data = array_merge($data, (is_array($contents) ? $contents : array()));\n\n    \/\/ Add ACL info\n    $grants = $response[0]-&gt;body-&gt;query('descendant-or-self::Grant');\n    $max = count($grants);\n\n    \/\/ Add raw header info\n    $data['Headers'] = $response[1]-&gt;header;\n    foreach (array('_info', 'x-amz-id-2', 'x-amz-request-id', 'cneonction', 'server', 'content-length', 'content-type', 'etag') as $header)\n    {\n        unset($data['Headers'][$header]);\n    }\n    ksort($data['Headers']);\n\n    if (count($grants) &gt; 0)\n    {\n        foreach ($grants as $grant)\n        {\n            $dgrant = array(\n                'id' =&gt; (string) $this-&gt;util-&gt;try_these(array('ID', 'URI'), $grant-&gt;Grantee),\n                'permission' =&gt; (string) $grant-&gt;Permission\n            );\n\n            $data['ACL'][] = $dgrant;\n        }\n    }\n\n    return $data;\n}","examples":{"example":{"title":"<p>Get the metadata for an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_object_metadata($bucket, '&uuml;pl&oslash;&aring;d\/&icirc;\\'v&eacute; n&oslash;w b&eacute;&eacute;n &uuml;pl&oslash;&aring;d&eacute;d.txt');\n\n\/\/ Success?\nvar_dump($response['ContentType']);\nvar_dump($response['Headers']['content-language']);\nvar_dump($response['Headers']['x-amz-meta-ice-ice-baby']);","result":"string(10) \"text\/plain\"\nstring(5) \"en-US\"\nstring(18) \"too cold, too cold\""}}},{"name":"get_object_url","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the web-accessible URL for the Amazon S3 object or generates a time-limited signed request for\na private file.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the Amazon S3 object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"preauth","type":"integer|string","description":"<p>Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>https<\/code> - <code>boolean<\/code> - Optional - Set to <code>true<\/code> if you would like the URL be in https mode. Otherwise, the default behavior is always to use http regardless of your SSL settings.<\/li><li><code>method<\/code> - <code>string<\/code> - Optional - The HTTP method to use for the request. Defaults to a value of <code>GET<\/code>.<\/li><li><code>response<\/code> - <code>array<\/code> - Optional - Allows adjustments to specific response headers. Pass an associative array where each key is one of the following: <code>cache-control<\/code>, <code>content-disposition<\/code>, <code>content-encoding<\/code>, <code>content-language<\/code>, <code>content-type<\/code>, <code>expires<\/code>. The <code>expires<\/code> value should use <a href=\"http:\/\/php.net\/gmdate\"><code>gmdate()<\/code><\/a> and be formatted with the <code>DATE_RFC2822<\/code> constant.<\/li><li><code>torrent<\/code> - <code>boolean<\/code> - Optional - A value of <code>true<\/code> will return a URL to a torrent of the Amazon S3 object. A value of <code>false<\/code> will return a non-torrent URL. Defaults to <code>false<\/code>.<\/li><li><code>versionId<\/code> - <code>string<\/code> - Optional - The version of the object. Version IDs are returned in the <code>x-amz-version-id<\/code> header of any previous object-related request.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>The file URL, with authentication and\/or torrent parameters if requested.<\/p>","source":"public function get_object_url($bucket, $filename, $preauth = 0, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = isset($opt['method']) ? $opt['method'] : 'GET';\n    $opt['resource'] = $filename;\n    $opt['preauth'] = $preauth;\n\n    if (isset($opt['torrent']) &amp;&amp; $opt['torrent'])\n    {\n        $opt['sub_resource'] = 'torrent';\n        unset($opt['torrent']);\n    }\n\n    \/\/ GET responses\n    if (isset($opt['response']))\n    {\n        foreach ($opt['response'] as $key =&gt; $value)\n        {\n            $opt['response-' . $key] = $value;\n            unset($opt['response'][$key]);\n        }\n    }\n\n    \/\/ Determine whether or not to use SSL\n    $use_ssl = isset($opt['https']) ? (bool) $opt['https'] : false;\n    unset($opt['https']);\n    $current_use_ssl_setting = $this-&gt;use_ssl;\n\n    \/\/ Authenticate to S3\n    $this-&gt;use_ssl = $use_ssl;\n    $response = $this-&gt;authenticate($bucket, $opt);\n    $this-&gt;use_ssl = $current_use_ssl_setting;\n\n    return $response;\n}","examples":{"example":[{"title":"<p>Get the URL for a given object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n\/\/ Get the URL\n$url = $s3-&gt;get_object_url('my-bucket', 'video\/sample_public.mp4');\n\n\/\/ Success?\nvar_dump($url);","result":"string(57) \"http:\/\/my-bucket.s3.amazonaws.com\/video\/sample_public.mp4\""},{"title":"<p>Get an object URL that will return requested response headers.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get the URL\n$url = $s3-&gt;get_object_url($bucket, 'm&aring;rk&eacute;r w&icirc;th sp&aring;c&eacute;s &aring;nd &icirc;ntl\/&aring;&eacute;&icirc;&oslash;&uuml;.txt', '5 minutes', array(\n\t'response' =&gt; array(\n\t\t'content-type'     =&gt; 'text\/plain',\n\t\t'content-language' =&gt; 'en-US',\n\t\t'expires'          =&gt; gmdate(DATE_RFC2822, strtotime('1 January 1980'))\n\t)\n));\n\n\/\/ Try to fetch the URL so we can get the status code\n$http = new CFRequest($url);\n$http-&gt;add_header('Content-Type', ''); # Simulate a web browser\n$http-&gt;send_request(true);\n$code = $http-&gt;get_response_code();\n$headers = $http-&gt;get_response_header();\n\n\/\/ Success?\nvar_dump($url);\nvar_dump($code);\nvar_dump($headers['content-language']);\nvar_dump($headers['content-type']);\nvar_dump($headers['expires']);"},{"title":"<p>AmazonS3 - Get Object URL with temporary credentials<\/p>","code":"\/\/ Dependencies\nrequire_once dirname(__FILE__) . '\/..\/..\/sdk.class.php';\nrequire_once dirname(__FILE__) . '\/..\/testutil.inc.php';\n\n\/\/ Instantiate STS and get temporary credentials\n$sts = new AmazonSTS();\n$response = $sts-&gt;get_session_token();\n\nif ($response-&gt;isOK())\n{\n\t$credentials = array(\n\t\t'key'    =&gt; (string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;AccessKeyId,\n\t\t'secret' =&gt; (string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;SecretAccessKey,\n\t\t'token'  =&gt; (string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;SessionToken,\n\t);\n}\nelse\n{\n\tdie('Temporary credentials could not retrieved.');\n}\n\n\/\/ Instantiate S3\n$s3 = new AmazonS3($credentials);\n$source_bucket = 'my-bucket' . strtolower(CFCredentials::get()-&gt;key);\n$dest_bucket = 'my-bucket' . strtolower(CFCredentials::get()-&gt;key);\n\n\/\/ Pull over an object that we want to get the URL for.\n$copy = $s3-&gt;copy_object(\n\tarray( \/\/ Source\n\t\t'bucket'   =&gt; $source_bucket,\n\t\t'filename' =&gt; 'text\/sample.txt'\n\t),\n\tarray( \/\/ Destination\n\t\t'bucket'   =&gt; $dest_bucket,\n\t\t'filename' =&gt; 'text\/sample_private.txt'\n\t),\n\tarray( \/\/ Optional parameters\n\t\t'acl' =&gt; AmazonS3::ACL_PRIVATE \/\/ Let's explicitly set it to private.\n\t)\n);\n\n\/\/ Ensure that the copy was successful\nif ($copy-&gt;isOK())\n{\n\t\/\/ Get the URL\n\t$url = $s3-&gt;get_object_url($dest_bucket, 'text\/sample_private.txt', '5 minutes');\n\n\t\/\/ Try to fetch the URL so we can get the status code\n\t$http = new RequestCore($url);\n\t$http-&gt;add_header('Content-Type', ''); # Simulate a web browser\n\t$http-&gt;send_request(true);\n\t$code = $http-&gt;get_response_code();\n\n\t\/\/ Success?\n\tvar_dump($url);\n\tvar_dump($code);\n}\nelse\n{\n\tdie('S3 object for test was not copied.');\n}"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/S3_QSAuth.html\">Using Query String Authentication<\/a>"}},{"name":"get_torrent_url","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets the web-accessible URL to a torrent of the Amazon S3 object. The Amazon S3 object&#8217;s access\ncontrol list settings (ACL) MUST be set to <a href=\"..\/s3browserupload\/constants.html#acl_public\" rel=\"..\/..\/index.html#c=s3browserupload\/acl_public\"><code>ACL_PUBLIC<\/code><\/a> for a valid URL to be returned.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"preauth","type":"integer|string","description":"<p>Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/p>"}]},"returnvalue":"<p>The torrent URL, with authentication parameters if requested.<\/p>","source":"public function get_torrent_url($bucket, $filename, $preauth = 0)\n{\n    return $this-&gt;get_object_url($bucket, $filename, $preauth, array(\n        'torrent' =&gt; true\n    ));\n}","examples":{"example":{"title":"<p>Get the torrent URL for an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n\/\/ Get the URL\n$url = $s3-&gt;get_torrent_url('my-bucket', 'video\/sample_public.mp4');\n\n\/\/ Success?\nvar_dump($url);","result":"string(65) \"http:\/\/my-bucket.s3.amazonaws.com\/video\/sample_public.mp4?torrent\""}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/index.html?S3TorrentRetrieve.html\">Using BitTorrent to Retrieve Objects Stored in Amazon S3<\/a>"}},{"name":"get_versioning_status","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets an Amazon S3 bucket&#8217;s versioning status.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_versioning_status($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'versioning';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get the versioning status of a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get the full status\n$response = $s3-&gt;get_versioning_status($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"get_website_config","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Retrieves the website configuration for a bucket. The contents of this response are identical to the\ncontent submitted by the user during the website creation operation. If a website configuration has\nnever been set, Amazon S3 will return a 404 error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function get_website_config($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'website';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Get an existing website configuration.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;get_website_config($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"if_bucket_exists","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets whether or not the specified Amazon S3 bucket exists in Amazon S3. This includes buckets\nthat do not belong to the caller.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"}},"returnvalue":"<p>A value of <code>true<\/code> if the bucket exists, or a value of <code>false<\/code> if it does not.<\/p>","source":"public function if_bucket_exists($bucket)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $header = $this-&gt;get_bucket_headers($bucket);\n    return (integer) $header-&gt;status !== 404;\n}","examples":{"example":{"title":"<p>Check if a bucket exists in the S3 system.<\/p>","description":"<p><strong>Note:<\/strong> A successful response does NOT mean that you own the bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;if_bucket_exists($bucket);\n\n\/\/ Success? (Boolean, not a CFResponse object)\nvar_dump($response);","result":"bool(true)"}}},{"name":"if_bucket_policy_exists","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets whether or not the specified Amazon S3 bucket has a bucket policy associated with it.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"}},"returnvalue":"<p>A value of <code>true<\/code> if a bucket policy exists, or a value of <code>false<\/code> if one does not.<\/p>","source":"public function if_bucket_policy_exists($bucket)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ @codeCoverageIgnoreStart\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n        \/\/ @codeCoverageIgnoreEnd\n    }\n\n    $response = $this-&gt;get_bucket_policy($bucket);\n\n    if ($response-&gt;isOK()) { return true; }\n    elseif ($response-&gt;status === 404) { return false; }\n\n    \/\/ @codeCoverageIgnoreStart\n    return null;\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"example":{"title":"<p>Check if a bucket policy exists.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;if_bucket_policy_exists($bucket);\n\n\/\/ Success? (Boolean, not a CFResponse object)\nvar_dump($response);","result":"bool(true)"}}},{"name":"if_object_exists","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets whether or not the specified Amazon S3 object exists in the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"}]},"returnvalue":"<p>A value of <code>true<\/code> if the object exists, or a value of <code>false<\/code> if it does not.<\/p>","source":"public function if_object_exists($bucket, $filename)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        throw new S3_Exception(__FUNCTION__ . '() cannot be batch requested');\n    }\n\n    $header = $this-&gt;get_object_headers($bucket, $filename);\n\n    if ($header-&gt;isOK()) { return true; }\n    elseif ($header-&gt;status === 404) { return false; }\n\n    \/\/ @codeCoverageIgnoreStart\n    return null;\n    \/\/ @codeCoverageIgnoreEnd\n}","examples":{"example":{"title":"<p>Check to see if an object exists.<\/p>","description":"<p><strong>Note:<\/strong> This does not check whether you can read the object \u2014 only if it exists.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;if_object_exists($bucket, 'test1.txt');\n\n\/\/ Success? (Boolean, not a CFResponse object)\nvar_dump($response);","result":"bool(true)"}}},{"name":"initiate_multipart_upload","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Initiates a multipart upload and returns an <code>UploadId<\/code>.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>acl<\/code> - <code>string<\/code> - Optional - The ACL settings for the specified object. Accepts any of the following constants: [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <code>ACL_PRIVATE<\/code>.<\/li><li><code>contentType<\/code> - <code>string<\/code> - Optional - The type of content that is being sent. The default value is <code>application\/octet-stream<\/code>.<\/li><li><code>encryption<\/code> - <code>string<\/code> - Optional - The algorithm to use for encrypting the object. [Allowed values: <code>AES256<\/code>]<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>meta<\/code> - <code>array<\/code> - Optional - An associative array of key-value pairs. Any header starting with <code>x-amz-meta-:<\/code> is considered user metadata. It will be stored with the object and returned when you retrieve the object. The total size of the HTTP request, not including the body, must be less than 4 KB.<\/li><li><code>storage<\/code> - <code>string<\/code> - Optional - Whether to use Standard or Reduced Redundancy storage. [Allowed values: <code>AmazonS3::STORAGE_STANDARD<\/code>, <code>AmazonS3::STORAGE_REDUCED<\/code>]. The default value is <code>STORAGE_STANDARD<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function initiate_multipart_upload($bucket, $filename, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'POST';\n    $opt['resource'] = $filename;\n    $opt['sub_resource'] = 'uploads';\n    $opt['body'] = '';\n\n    \/\/ Handle content type. Can also be passed as an HTTP header.\n    if (isset($opt['contentType']))\n    {\n        $opt['headers']['Content-Type'] = $opt['contentType'];\n        unset($opt['contentType']);\n    }\n\n    \/\/ Set a default content type.\n    if (!isset($opt['headers']['Content-Type']))\n    {\n        $opt['headers']['Content-Type'] = 'application\/octet-stream';\n    }\n\n    \/\/ Handle Access Control Lists. Can also be passed as an HTTP header.\n    if (isset($opt['acl']))\n    {\n        if (is_array($opt['acl']))\n        {\n            $opt['headers'] = array_merge($opt['headers'], $this-&gt;generate_access_policy_headers($opt['acl']));\n        }\n        else\n        {\n            $opt['headers']['x-amz-acl'] = $opt['acl'];\n        }\n    }\n\n    \/\/ Handle storage settings. Can also be passed as an HTTP header.\n    if (isset($opt['storage']))\n    {\n        $opt['headers']['x-amz-storage-class'] = $opt['storage'];\n        unset($opt['storage']);\n    }\n\n    \/\/ Handle encryption settings. Can also be passed as an HTTP header.\n    if (isset($opt['encryption']))\n    {\n        $opt['headers']['x-amz-server-side-encryption'] = $opt['encryption'];\n        unset($opt['encryption']);\n    }\n\n    \/\/ Handle meta tags. Can also be passed as an HTTP header.\n    if (isset($opt['meta']))\n    {\n        foreach ($opt['meta'] as $meta_key =&gt; $meta_value)\n        {\n            \/\/ e.g., `My Meta Header` is converted to `x-amz-meta-my-meta-header`.\n            $opt['headers']['x-amz-meta-' . strtolower(str_replace(' ', '-', $meta_key))] = $meta_value;\n        }\n        unset($opt['meta']);\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Initiate a new multipart upload.<\/p>","description":"<ol>\n<li>Initiate a new multipart upload using <code>initiate_multipart_upload()<\/code>.<\/li>\n<li>Upload the parts using <code>upload_part()<\/code>.<\/li>\n<li>Complete the upload using <code>complete_multipart_upload()<\/code>.<\/li>\n<\/ol>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Initiate a new multipart upload\n$response = $s3-&gt;initiate_multipart_upload($bucket, 'movie.mp4', array(\n\t'contentType' =&gt; 'video\/mp4',\n\t'acl'         =&gt; AmazonS3::ACL_PUBLIC,\n\t'storage'     =&gt; AmazonS3::STORAGE_STANDARD,\n\t'meta'        =&gt; array(\n\t\t'resolution' =&gt; '720p',\n\t\t'rating'     =&gt; 'US PG-13',\n\t\t'runtime'    =&gt; '2:04:37'\n\t)\n));\n\n\/\/ Get the Upload ID\n$upload_id = (string) $response-&gt;body-&gt;UploadId;\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"list_bucket_object_versions","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets a list of all the versions of Amazon S3 objects in the specified bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>delimiter<\/code> - <code>string<\/code> - Optional - Unicode string parameter. Keys that contain the same string between the prefix and the first occurrence of the delimiter will be rolled up into a single result element in the CommonPrefixes collection.<\/li><li><code>key-marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the <code>key-marker<\/code>.<\/li><li><code>max-keys<\/code> - <code>string<\/code> - Optional - Limits the number of results returned in response to your query. Will return no more than this number of results, but possibly less.<\/li><li><code>prefix<\/code> - <code>string<\/code> - Optional - Restricts the response to only contain results that begin with the specified prefix.<\/li><li><code>version-id-marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the <code>version-id-marker<\/code>.<\/li><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_bucket_object_versions($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'versions';\n\n    foreach (array('delimiter', 'key-marker', 'max-keys', 'prefix', 'version-id-marker') as $param)\n    {\n        if (isset($opt[$param]))\n        {\n            $opt['query_string'][$param] = $opt[$param];\n            unset($opt[$param]);\n        }\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>List all object versions in a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_bucket_object_versions($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>List all object versions in a bucket that match the provided parameters.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_bucket_object_versions($bucket, array(\n\t'prefix' =&gt; 'test1.txt',\n\t'max-keys' =&gt; 1\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump((string) $response-&gt;body-&gt;Prefix);\nvar_dump((string) $response-&gt;body-&gt;MaxKeys);","result":"bool(true)\nstring(9) \"test1.txt\"\nstring(1) \"1\""}]}},{"name":"list_buckets","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets a list of all buckets contained in the caller&#8217;s Amazon S3 account.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_buckets($opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'GET';\n\n    return $this-&gt;authenticate('', $opt);\n}","examples":{"example":{"title":"<p>List all buckets under your account.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n\n$response = $s3-&gt;list_buckets();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"list_multipart_uploads","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Lists the in-progress multipart uploads.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>delimiter<\/code> - <code>string<\/code> - Optional - Keys that contain the same string between the prefix and the first occurrence of the delimiter will be rolled up into a single result element in the CommonPrefixes collection.<\/li><li><code>key-marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the <code>key-marker<\/code>. If used in conjunction with <code>upload-id-marker<\/code>, the results will be filtered to include keys whose upload ID is alphabetically after the value of <code>upload-id-marker<\/code>.<\/li><li><code>upload-id-marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the <code>upload-id-marker<\/code>. Must be used in conjunction with <code>key-marker<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_multipart_uploads($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'GET';\n    $opt['sub_resource'] = 'uploads';\n\n    foreach (array('key-marker', 'max-uploads', 'upload-id-marker') as $param)\n    {\n        if (isset($opt[$param]))\n        {\n            $opt['query_string'][$param] = $opt[$param];\n            unset($opt[$param]);\n        }\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>List all in-progress multipart uploads.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_multipart_uploads($bucket, array(\n\t'max-uploads' =&gt; 1,\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"list_objects","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Gets a list of all Amazon S3 objects in the specified bucket.<\/p>\n\n<p>NOTE: <strong>This method is paginated<\/strong>, and will not return more than <code>max-keys<\/code> keys. If you want to retrieve a list of all keys, you will need to make multiple calls to this function using the <code>marker<\/code> option to specify the pagination offset (the key of the last processed key&#8212;lexically ordered) and the <code>IsTruncated<\/code> response key to detect when all results have been processed. See: <a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/API\/index.html?RESTBucketGET.html\">the S3 REST documentation for get_bucket<\/a> for more information.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>delimiter<\/code> - <code>string<\/code> - Optional - Keys that contain the same string between the prefix and the first occurrence of the delimiter will be rolled up into a single result element in the CommonPrefixes collection.<\/li><li><code>marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur alphabetically after the value of the marker.<\/li><li><code>max-keys<\/code> - <code>string<\/code> - Optional - The maximum number of results returned by the method call. The returned list will contain no more results than the specified value, but may return fewer. The default value is 1000.<\/li><li><code>preauth<\/code> - <code>integer|string<\/code> - Optional - Specifies that a presigned URL for this request should be returned. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href=\"http:\/\/php.net\/strtotime\"><code>strtotime()<\/code><\/a>.<\/li><li><code>prefix<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that begin only with the specified prefix.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_objects($bucket, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'GET';\n\n    foreach (array('delimiter', 'marker', 'max-keys', 'prefix') as $param)\n    {\n        if (isset($opt[$param]))\n        {\n            $opt['query_string'][$param] = $opt[$param];\n            unset($opt[$param]);\n        }\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>List all objects inside a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_objects($bucket);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>List all objects inside a bucket that match the parameters given.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_objects($bucket, array(\n\t'prefix' =&gt; 'word\/',\n\t'max-keys' =&gt; 1\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());\nvar_dump(count($response-&gt;body-&gt;Contents))","result":"bool(true)\nint(1)"},{"title":"<p>List all objects inside a bucket that match the parameters given. Supports UTF-8 characters.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_objects($bucket, array(\n\t'delimiter' =&gt; '\/',\n\t'marker' =&gt; 'm&aring;rk&eacute;r w&icirc;th sp&aring;c&eacute;s &aring;nd &icirc;ntl'\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]}},{"name":"list_parts","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Lists the completed parts of an in-progress multipart upload.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"upload_id","type":"string","description":"<p>The upload ID identifying the multipart upload whose parts are being listed. The upload ID is retrieved from a call to <a href=\"..\/s3browserupload\/initiate_multipart_upload.html\" rel=\"..\/..\/index.html#m=s3browserupload\/initiate_multipart_upload\"><code>initiate_multipart_upload()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>max-parts<\/code> - <code>integer<\/code> - Optional - The maximum number of parts to return in the response body.<\/li><li><code>part-number-marker<\/code> - <code>string<\/code> - Optional - Restricts the response to contain results that only occur numerically after the value of the <code>part-number-marker<\/code>.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function list_parts($bucket, $filename, $upload_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'GET';\n    $opt['resource'] = $filename;\n    $opt['uploadId'] = $upload_id;\n    $opt['query_string'] = array();\n\n    foreach (array('max-parts', 'part-number-marker') as $param)\n    {\n        if (isset($opt[$param]))\n        {\n            $opt['query_string'][$param] = $opt[$param];\n            unset($opt[$param]);\n        }\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>List all of the completed parts of a multipart upload.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;list_parts($bucket, 'movie.mp4', 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--', array(\n\t'max-parts' =&gt; 10\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"protocol","modifier":"public static","description":"<p>Returns the protocol of the web page that this script is currently running on. This method only works\ncorrectly when run from a publicly-accessible web page.<\/p>","returnvalue":{},"source":"public static function protocol()\n{\n    return (isset($_SERVER['HTTPS']) &amp;&amp; strtolower($_SERVER['HTTPS']) === 'on') ? 'https:\/\/' : 'http:\/\/';\n}"},{"name":"register_stream_wrapper","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Loads and registers the S3StreamWrapper class as a stream wrapper.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"protocol","type":"string","description":"<p>The name of the protocol to register.<\/p>"}},"returnvalue":"<p>Whether or not the registration succeeded.<\/p>","source":"public function register_stream_wrapper($protocol = 's3')\n{\n    require_once dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'extensions'\n        . DIRECTORY_SEPARATOR . 's3streamwrapper.class.php';\n\n    return S3StreamWrapper::register($this, $protocol);\n}"},{"name":"register_streaming_read_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is read from using\n<a href=\"..\/cfrequest\/streaming_read_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_read_callback\"><code>CFRequest::streaming_read_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept three arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$file_handle<\/code> - <code>resource<\/code> - Required - The file handle resource that represents the file on the local file system.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_read_callback($callback)\n{\n    $this-&gt;registered_streaming_read_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is read from an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $file_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is read locally.\n$s3-&gt;register_streaming_read_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileUpload' =&gt; '.\/uploads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"register_streaming_write_callback","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Register a callback function to execute whenever a data stream is written to using\n<a href=\"..\/cfrequest\/streaming_write_callback.html\" rel=\"..\/..\/index.html#m=cfrequest\/streaming_write_callback\"><code>CFRequest::streaming_write_callback()<\/code><\/a>.<\/p>\n\n<p>The user-defined callback function should accept two arguments:<\/p>\n\n<ul><li><code>$curl_handle<\/code> - <code>resource<\/code> - Required - The cURL handle resource that represents the in-progress transfer.<\/li><li><code>$length<\/code> - <code>integer<\/code> - Required - The length in kilobytes of the data chunk that was transferred.<\/li><\/ul>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"callback","type":"string|array|function","description":"<p>The callback function is called by <a href=\"http:\/\/php.net\/call_user_func\"><code>call_user_func()<\/code><\/a>, so you can pass the following values:<\/p>\n\n<ul><li>The name of a global function to execute, passed as a string.<\/li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')<\/code>.<\/li><li>An anonymous function (PHP 5.3+).<\/li><\/ul>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function register_streaming_write_callback($callback)\n{\n    $this-&gt;registered_streaming_write_callback = $callback;\n    return $this;\n}","examples":{"example":{"title":"<p>Register a callback function to execute when data is written to an open stream.<\/p>","code":"$s3 = new AmazonS3();\n\n\/\/ Define callback function\nfunction callback($curl_handle, $length)\n{\n\t$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);\n\t$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);\n\t$percentage = floor(($transferred \/ $total) * 100);\n\n\techo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;\n}\n\n\/\/ Register a callback function to execute when a stream is written locally.\n$s3-&gt;register_streaming_write_callback('callback');\n\n\/\/ Download a public object.\n$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(\n\t'fileDownload' =&gt; '.\/downloads\/my-large-file.mp4'\n));","result":"Transferred 7200 bytes out of 9000000 (0%)\n...\nTransferred 9000000 bytes out of 9000000 (100%)"}}},{"name":"restore_archived_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Restore an object archived in Amazon Glacier back to Amazon S3.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"days","type":"integer","description":"<p>The number of days until the targeted objects are to be moved or expired from the bucket. Must be a positive integer.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function restore_archived_object($bucket, $filename, $days, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'POST';\n    $opt['resource'] = $filename;\n    $opt['sub_resource'] = 'restore';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    $xml = simplexml_load_string($this-&gt;restore_request_xml, $this-&gt;parser_class);\n    $xml-&gt;addChild('Days', (integer) $days);\n\n    $opt['body'] = $xml-&gt;asXML();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}"},{"name":"send","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Executes the batch request queue by sending all queued requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"clear_after_send","type":"boolean","description":"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true<\/code>. Set this to <code>false<\/code> if you are caching batch responses and want to retrieve results later.<\/p>"}},"returnvalue":"<p>An array of <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> objects.<\/p>","source":"public function send($clear_after_send = true)\n{\n    if ($this-&gt;use_batch_flow)\n    {\n        \/\/ When we send the request, disable batch flow.\n        $this-&gt;use_batch_flow = false;\n\n        \/\/ If we're not caching, simply send the request.\n        if (!$this-&gt;use_cache_flow)\n        {\n            $response = $this-&gt;batch_object-&gt;send();\n            $parsed_data = array_map(array($this, 'parse_callback'), $response);\n            $parsed_data = new CFArray($parsed_data);\n\n            \/\/ Clear the queue\n            if ($clear_after_send)\n            {\n                $this-&gt;batch_object-&gt;queue = array();\n            }\n\n            return $parsed_data;\n        }\n\n        \/\/ Generate an identifier specific to this particular set of arguments.\n        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));\n\n        \/\/ Instantiate the appropriate caching object.\n        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);\n\n        if ($this-&gt;delete_cache)\n        {\n            $this-&gt;use_cache_flow = false;\n            $this-&gt;delete_cache = false;\n            return $this-&gt;cache_object-&gt;delete();\n        }\n\n        \/\/ Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.\n        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));\n        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);\n        $parsed_data = new CFArray($parsed_data);\n\n        \/\/ Clear the queue\n        if ($clear_after_send)\n        {\n            $this-&gt;batch_object-&gt;queue = array();\n        }\n\n        \/\/ End!\n        return $parsed_data;\n    }\n\n    \/\/ Load the class\n    $null = new CFBatchRequest();\n    unset($null);\n\n    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');\n}"},{"name":"set_batch_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_batch_class($class = 'CFBatchRequest')\n{\n    $this-&gt;batch_class = $class;\n    return $this;\n}"},{"name":"set_bucket_acl","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Sets the access control list (ACL) settings for the specified Amazon S3 bucket.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"acl","type":"string","description":"<p>The ACL settings for the specified bucket. [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <a href=\"..\/s3browserupload\/constants.html#acl_private\" rel=\"..\/..\/index.html#c=s3browserupload\/acl_private\"><code>ACL_PRIVATE<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_bucket_acl($bucket, $acl = self::ACL_PRIVATE, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'acl';\n    $opt['headers'] = array(\n        'Content-Type' =&gt; 'application\/xml'\n    );\n\n    \/\/ Make sure these are defined.\n    \/\/ @codeCoverageIgnoreStart\n    if (!$this-&gt;credentials-&gt;canonical_id || !$this-&gt;credentials-&gt;canonical_name)\n    {\n        \/\/ Fetch the data live.\n        $canonical = $this-&gt;get_canonical_user_id();\n        $this-&gt;credentials-&gt;canonical_id = $canonical['id'];\n        $this-&gt;credentials-&gt;canonical_name = $canonical['display_name'];\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    if (is_array($acl))\n    {\n        $opt['headers'] = array_merge($opt['headers'], $this-&gt;generate_access_policy_headers($acl));\n    }\n    else\n    {\n        $opt['body'] = '';\n        $opt['headers']['x-amz-acl'] = $acl;\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Set a canned ACL setting on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-us-east-acl' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;set_bucket_acl($bucket, AmazonS3::ACL_PRIVATE);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Set a custom ACL setting on a bucket.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-us-east-acl' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;set_bucket_acl($bucket, array(\n\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,               'permission' =&gt; AmazonS3::GRANT_READ         ), \/\/ Authenticated users, READ\n\tarray( 'id' =&gt; CFCredentials::get()-&gt;canonical_id, 'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL )  \/\/ Self, FULL_CONTROL\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"set_bucket_policy","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Sets the policy sub-resource for the specified Amazon S3 bucket. The specified policy replaces any\npolicy the bucket already has.<\/p>\n\n<p>To perform this operation, the caller must be authorized to set a policy for the bucket and have\nPutPolicy permissions. If the caller does not have PutPolicy permissions for the bucket, Amazon S3\nreturns a <code>403 Access Denied<\/code> error. If the caller has the correct permissions but has not been\nauthorized by the bucket owner, Amazon S3 returns a <code>405 Method Not Allowed<\/code> error.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"policy","type":"CFPolicy","description":"<p>The JSON policy to use.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_bucket_policy($bucket, CFPolicy $policy, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['sub_resource'] = 'policy';\n    $opt['body'] = $policy-&gt;get_json();\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Set a bucket-wide policy.<\/p>","description":"<p>See <a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/AccessPolicyLanguage.html\">Access Policy Language<\/a> for more information about writing S3 policies.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket-test' . strtolower($s3-&gt;key);\n\n\/\/ Generate a new policy object\n$policy = new CFPolicy($s3, array(\n\t'Version' =&gt; '2008-10-17',\n\t'Statement' =&gt; array(\n\t\tarray( \/\/ Statement #1\n\t\t\t'Sid' =&gt; 'AddPerm',\n\t\t\t'Effect' =&gt; 'Allow',\n\t\t\t'Principal' =&gt; array(\n\t\t\t\t'AWS' =&gt; '*'\n\t\t\t),\n\t\t\t'Action' =&gt; array('s3:*'),\n\t\t\t'Resource' =&gt; array(&quot;arn:aws:s3:::${bucket}\/*&quot;)\n\t\t)\n\t)\n));\n\n\/\/ Set the bucket policy\n$response = $s3-&gt;set_bucket_policy($bucket, $policy);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/AccessPolicyLanguage.html\">Appendix: The Access Policy Language<\/a>"}},{"name":"set_cache_config","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the caching configuration to use for response caching.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"location","type":"string","description":"<p>The location to store the cache object in. This may vary by cache method.<\/p><ul><li>File - The local file system paths such as <code>.\/cache<\/code> (relative) or <code>\/tmp\/cache\/<\/code> (absolute). The location must be server-writable.<\/li><li>APC - Pass in <code>apc<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/php.net\/apc\">APC extension<\/a> installed.<\/li><li>XCache - Pass in <code>xcache<\/code> to use this lightweight cache. You must have the <a href=\"http:\/\/xcache.lighttpd.net\">XCache<\/a> extension installed.<\/li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host<\/code> and a <code>port<\/code> value representing a <a href=\"http:\/\/php.net\/memcached\">Memcached<\/a> server to connect to.<\/li><li>PDO - A URL-style string (e.g. <code>pdo.mysql:\/\/user:pass@localhost\/cache<\/code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:\/sqlite\/cache.db<\/code>). MUST be prefixed with <code>pdo.<\/code>. See <code>CachePDO<\/code> and <a href=\"http:\/\/php.net\/pdo\">PDO<\/a> for more details.<\/li><\/ul>"},{"@attributes":{"choice":"opt"},"name":"gzip","type":"boolean","description":"<p>Whether or not data should be gzipped before being stored. A value of <code>true<\/code> will compress the contents before caching them. A value of <code>false<\/code> will leave the contents uncompressed. Defaults to <code>true<\/code>.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_cache_config($location, $gzip = true)\n{\n    \/\/ If location is empty, don't do anything.\n    if (empty($location))\n    {\n        return $this;\n    }\n\n    \/\/ If we have an array, we're probably passing in Memcached servers and ports.\n    if (is_array($location))\n    {\n        $this-&gt;cache_class = 'CacheMC';\n    }\n    else\n    {\n        \/\/ I would expect locations like `\/tmp\/cache`, `pdo.mysql:\/\/user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.\n        $type = strtolower(substr($location, 0, 3));\n        switch ($type)\n        {\n            case 'apc':\n                $this-&gt;cache_class = 'CacheAPC';\n                break;\n\n            case 'xca': \/\/ First three letters of `xcache`\n                $this-&gt;cache_class = 'CacheXCache';\n                break;\n\n            case 'pdo':\n                $this-&gt;cache_class = 'CachePDO';\n                $location = substr($location, 4);\n                break;\n\n            default:\n                $this-&gt;cache_class = 'CacheFile';\n                break;\n        }\n    }\n\n    \/\/ Set the remaining cache information.\n    $this-&gt;cache_location = $location;\n    $this-&gt;cache_compress = $gzip;\n\n    return $this;\n}","examples":{"example":[{"title":"<p>Fire a single request, and then cache the response to APC.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('apc');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"},{"title":"<p>Fire a single request, and then cache the response to the file system.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Instantiate\n$sdb = new AmazonSDB();\n$sdb-&gt;set_cache_config('.\/cache');\n\n\/\/ First time pulls live data\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());\n\n\/\/ Second time pulls from cache\n$response = $sdb-&gt;cache(10)-&gt;list_domains();\nvar_dump($response-&gt;isOK());","result":"bool(true)\nbool(true)"}]}},{"name":"set_hostname","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with\nAWS, but run from a different hostname.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"hostname","type":"string","description":"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.<\/p>"},{"@attributes":{"choice":"opt"},"name":"port_number","type":"integer","description":"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.<\/p>"}]},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_hostname($hostname, $port_number = null)\n{\n    if ($this-&gt;override_hostname)\n    {\n        $this-&gt;hostname = $hostname;\n\n        if ($port_number)\n        {\n            $this-&gt;port_number = $port_number;\n            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;\n        }\n    }\n\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_max_retries","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Sets the maximum number of times to retry failed requests.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"retries","type":"integer","description":"<p>The maximum number of times to retry failed requests. Defaults to <code>3<\/code>.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_max_retries($retries = 3)\n{\n    $this-&gt;max_retries = $retries;\n    return $this;\n}","examples":{"example":{"title":"<p>Sets the maximum number of times to retry failed requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_max_retries(3);\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;max_retries);","result":"int(3)"}}},{"name":"set_object_acl","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Sets the access control list (ACL) settings for the specified Amazon S3 object.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"opt"},"name":"acl","type":"string","description":"<p>The ACL settings for the specified object. Accepts any of the following constants: [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. Alternatively, an array of associative arrays. Each associative array contains an <code>id<\/code> and a <code>permission<\/code> key. The default value is <code>ACL_PRIVATE<\/code>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function set_object_acl($bucket, $filename, $acl = self::ACL_PRIVATE, $opt = null)\n{\n    \/\/ Add this to our request\n    if (!$opt) $opt = array();\n    $opt['verb'] = 'PUT';\n    $opt['resource'] = $filename;\n    $opt['sub_resource'] = 'acl';\n    \/\/ Retrieve the original metadata\n    $metadata = $this-&gt;get_object_metadata($bucket, $filename);\n    if ($metadata &amp;&amp; $metadata['ContentType'])\n    {\n        $opt['headers']['Content-Type'] = $metadata['ContentType'];\n    }\n    if ($metadata &amp;&amp; $metadata['StorageClass'])\n    {\n        $opt['headers']['x-amz-storage-class'] = $metadata['StorageClass'];\n    }\n\n    \/\/ Make sure these are defined.\n    \/\/ @codeCoverageIgnoreStart\n    if (!$this-&gt;credentials-&gt;canonical_id || !$this-&gt;credentials-&gt;canonical_name)\n    {\n        \/\/ Fetch the data live.\n        $canonical = $this-&gt;get_canonical_user_id();\n        $this-&gt;credentials-&gt;canonical_id = $canonical['id'];\n        $this-&gt;credentials-&gt;canonical_name = $canonical['display_name'];\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    if (is_array($acl))\n    {\n        $opt['headers'] = array_merge($opt['headers'], $this-&gt;generate_access_policy_headers($acl));\n    }\n    else\n    {\n        $opt['body'] = '';\n        $opt['headers']['x-amz-acl'] = $acl;\n    }\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":[{"title":"<p>Set a canned ACL setting on an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;set_object_acl($bucket, 'test1.txt', AmazonS3::ACL_PUBLIC);\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"},{"title":"<p>Set a custom ACL setting on an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$response = $s3-&gt;set_object_acl($bucket, 'test1.txt', array(\n\tarray( 'id' =&gt; AmazonS3::USERS_AUTH,               'permission' =&gt; AmazonS3::GRANT_READ         ), \/\/ Authenticated users, READ\n\tarray( 'id' =&gt; CFCredentials::get()-&gt;canonical_id, 'permission' =&gt; AmazonS3::GRANT_FULL_CONTROL )  \/\/ Self, FULL_CONTROL\n));\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}]},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/RESTAccessPolicy.html\">REST Access Control Policy<\/a>"}},{"name":"set_parser_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_parser_class($class = 'CFSimpleXML')\n{\n    $this-&gt;parser_class = $class;\n    return $this;\n}"},{"name":"set_proxy","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the proxy settings to use.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"proxy","type":"string","description":"<p>Accepts proxy credentials in the following format: <code>proxy:\/\/user:pass@hostname:port<\/code><\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_proxy($proxy)\n{\n    $this-&gt;proxy = $proxy;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the proxy server to use for requests.<\/p>","description":"<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Adjust offset\n$sdb = new AmazonSDB();\n$sdb-&gt;set_proxy('proxy:\/\/user:pass@hostname:port');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;proxy);","result":"string(31) \"proxy:\/\/user:pass@hostname:port\""}}},{"name":"set_region","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Sets the region to use for subsequent Amazon S3 operations. This will also reset any prior use of\n<a href=\"..\/s3browserupload\/enable_path_style.html\" rel=\"..\/..\/index.html#m=s3browserupload\/enable_path_style\"><code>enable_path_style()<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"region","type":"string","description":"<p>The region to use for subsequent Amazon S3 operations. For a complete list of REGION constants, see the <code>AmazonS3<\/code> Constants page in the API reference.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_region($region)\n{\n    \/\/ @codeCoverageIgnoreStart\n    $this-&gt;set_hostname($region);\n\n    switch ($region)\n    {\n        case self::REGION_US_E1: \/\/ Northern Virginia\n            $this-&gt;enable_path_style(false);\n            break;\n\n        case self::REGION_EU_W1: \/\/ Ireland\n            $this-&gt;enable_path_style(); \/\/ Always use path-style access for EU endpoint.\n            break;\n\n        default:\n            $this-&gt;enable_path_style(false);\n            break;\n\n    }\n    \/\/ @codeCoverageIgnoreEnd\n\n    return $this;\n}"},{"name":"set_request_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":{},"source":"public function set_request_class($class = 'CFRequest')\n{\n    $this-&gt;request_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the request class to use in the toolkit.<\/p>","description":"<p>The new request class must extend from <code>CFRequest<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend RequestCore\nclass TestRequestCore extends RequestCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_request_class('TestRequestCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;request_class);","result":"string(15) \"TestRequestCore\""}}},{"name":"set_resource_prefix","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible\nwith AWS.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"prefix","type":"string","description":"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_resource_prefix($prefix)\n{\n    $this-&gt;resource_prefix = $prefix;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure hostname and resource prefix.<\/p>","code":"\/\/ Instantiate the class\n$ec2 = new AmazonEC2();\n\n\/\/ Point to the new endpoint\n$ec2-&gt;set_hostname('localhost', '3000');\n$ec2-&gt;set_resource_prefix('\/services\/mock');\n$ec2-&gt;allow_hostname_override(false);\n\n\/\/ Describe images\n$response = $ec2-&gt;describe_images();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}}},{"name":"set_response_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_response_class($class = 'CFResponse')\n{\n    $this-&gt;response_class = $class;\n    return $this;\n}","examples":{"example":{"title":"<p>Set the response class to use in the toolkit.<\/p>","description":"<p>The new response class must extend from <code>CFResponse<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend ResponseCore\nclass TestResponseCore extends ResponseCore\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_response_class('TestResponseCore');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;response_class);","result":"string(16) \"TestResponseCore\""}}},{"name":"set_utilities_class","modifier":"public","inheritance":{"class":{"name":"CFRuntime"}},"description":"<p>Set a custom class for this functionality. Use this method when extending\/overriding existing classes\nwith new functionality.<\/p>\n\n<p>The replacement class must extend from <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"opt"},"name":"class","type":"string","description":"<p>The name of the new class to use for this functionality.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_utilities_class($class = 'CFUtilities')\n{\n    $this-&gt;utilities_class = $class;\n    $this-&gt;util = new $this-&gt;utilities_class();\n    return $this;\n}","examples":{"example":{"title":"<p>Set the utilities class to use in the toolkit.<\/p>","description":"<p>The new utilities class must extend from <code>CFUtilities<\/code>.<\/p>\n\n<p><strong>Note:<\/strong> This method is inherited by all service-specific classes.<\/p>","code":"\/\/ Custom class to extend CFUtilities\nclass TestUtilities extends CFUtilities\n{\n\tpublic function test_method()\n\t{\n\t\treturn true;\n\t}\n}\n\n\/\/ Instantiate class and set new class\n$sdb = new AmazonSDB();\n$sdb-&gt;set_utilities_class('TestUtilities');\n\n\/\/ Test if the value was set\nvar_dump($sdb-&gt;util-&gt;test_method());","result":"bool(true)"}}},{"name":"set_vhost","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Sets the virtual host to use in place of the default <code>bucket.s3.amazonaws.com<\/code> domain.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"vhost","type":"string","description":"<p>The virtual host to use in place of the default <code>bucket.s3.amazonaws.com<\/code> domain.<\/p>"}},"returnvalue":"<p>A reference to the current instance.<\/p>","source":"public function set_vhost($vhost)\n{\n    $this-&gt;vhost = $vhost;\n    return $this;\n}","examples":{"example":{"title":"<p>Configure a virtual host to use for requests.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$s3-&gt;set_vhost('cname.example.com');\n\n$response = $s3-&gt;list_buckets();\n\n\/\/ Success?\nvar_dump($response-&gt;isOK());","result":"bool(true)"}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/VirtualHosting.html\">Virtual Hosting of Buckets<\/a>"}},{"name":"update_object","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Updates an Amazon S3 object with new headers or other metadata. To replace the content of the\nspecified Amazon S3 object, call <a href=\"..\/s3browserupload\/create_object.html\" rel=\"..\/..\/index.html#m=s3browserupload\/create_object\"><code>create_object()<\/code><\/a> with the same bucket and file name parameters.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket that contains the source file.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The source file name that you want to update.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>acl<\/code> - <code>string<\/code> - Optional - The ACL settings for the specified object. [Allowed values: <code>AmazonS3::ACL_PRIVATE<\/code>, <code>AmazonS3::ACL_PUBLIC<\/code>, <code>AmazonS3::ACL_OPEN<\/code>, <code>AmazonS3::ACL_AUTH_READ<\/code>, <code>AmazonS3::ACL_OWNER_READ<\/code>, <code>AmazonS3::ACL_OWNER_FULL_CONTROL<\/code>]. The default value is <a href=\"..\/s3browserupload\/constants.html#acl_private\" rel=\"..\/..\/index.html#c=s3browserupload\/acl_private\"><code>ACL_PRIVATE<\/code><\/a>.<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>meta<\/code> - <code>array<\/code> - Optional - An associative array of key-value pairs. Any header with the <code>x-amz-meta-<\/code> prefix is considered user metadata and is stored with the Amazon S3 object. It will be stored with the object and returned when you retrieve the object. The total size of the HTTP request, not including the body, must be less than 4 KB.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function update_object($bucket, $filename, $opt = null)\n{\n    if (!$opt) $opt = array();\n    $opt['metadataDirective'] = 'REPLACE';\n\n    \/\/ Retrieve the original metadata\n    if ($metadata = $this-&gt;get_object_metadata($bucket, $filename))\n    {\n        if (isset($metadata['ACL']))\n        {\n            $opt['acl'] = isset($opt['acl']) ? $opt['acl'] : $metadata['ACL'];\n        }\n        if (isset($metadata['StorageClass']))\n        {\n            $opt['headers']['x-amz-storage-class'] = $metadata['StorageClass'];\n        }\n        if (isset($metadata['ContentType']))\n        {\n            $opt['headers']['Content-Type'] = $metadata['ContentType'];\n        }\n    }\n\n    \/\/ Remove a header\n    unset($metadata['Headers']['date']);\n\n    \/\/ Merge headers\n    $opt['headers'] = array_merge($opt['headers'], $metadata['Headers']);\n\n    \/\/ Authenticate to S3\n    return $this-&gt;copy_object(\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        array('bucket' =&gt; $bucket, 'filename' =&gt; $filename),\n        $opt\n    );\n}","examples":{"example":{"title":"<p>Update an object.<\/p>","code":"\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n$headers = $s3-&gt;get_object_headers($bucket, 'test1.txt');\nvar_dump($headers-&gt;header['content-type']);\n\n$response = $s3-&gt;update_object($bucket, 'test1.txt', array(\n\t'acl' =&gt; AmazonS3::ACL_PUBLIC,\n\t'headers' =&gt; array(\n\t\t'Content-Encoding' =&gt; 'UTF-8'\n\t),\n\t'meta' =&gt; array(\n\t\t'Cache-Control' =&gt; 'Public',\n\t\t'Max-Age' =&gt; '604800',\n\t),\n));\nvar_dump($response-&gt;isOK());\n\nsleep(2);\n$headers = $s3-&gt;get_object_headers($bucket, 'test1.txt');\nvar_dump($headers-&gt;header['content-type']);","result":"string(10) \"text\/plain\"\nbool(true)\nstring(10) \"text\/plain\""}},"seealso":{"link":"<a href=\"http:\/\/docs.amazonwebservices.com\/AmazonS3\/latest\/dev\/API\/RESTObjectCOPY.html\">Copying Amazon S3 Objects<\/a>"}},{"name":"upload_part","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Uploads a single part of a multipart upload. The part size cannot be smaller than 5 MB\nor larger than 5 TB. A multipart upload can have no more than 10,000 parts.<\/p>\n\n<p>Amazon S3 charges for storage as well as requests to the service. Smaller part sizes (and more\nrequests) allow for faster failures and better upload reliability. Larger part sizes (and fewer\nrequests) costs slightly less but has lower upload reliability.<\/p>","parameters":{"parameter":[{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to use.<\/p>"},{"@attributes":{"choice":"req"},"name":"filename","type":"string","description":"<p>The file name for the object.<\/p>"},{"@attributes":{"choice":"req"},"name":"upload_id","type":"string","description":"<p>The upload ID identifying the multipart upload whose parts are being listed. The upload ID is retrieved from a call to <a href=\"..\/s3browserupload\/initiate_multipart_upload.html\" rel=\"..\/..\/index.html#m=s3browserupload\/initiate_multipart_upload\"><code>initiate_multipart_upload()<\/code><\/a>.<\/p>"},{"@attributes":{"choice":"opt"},"name":"opt","type":"array","description":"<p>An associative array of parameters that can have the following keys:<\/p>\n\n<ul><li><code>fileUpload<\/code> - <code>string|resource<\/code> - Required - The URL\/path for the file to upload or an open resource.<\/li><li><code>partNumber<\/code> - <code>integer<\/code> - Required - The part number order of the multipart upload.<\/li><li><code>expect<\/code> - <code>string<\/code> - Optional - Specifies that the SDK not send the request body until it receives an acknowledgement. If the message is rejected based on the headers, the body of the message is not sent. For more information, see <a href=\"http:\/\/www.w3.org\/Protocols\/rfc2616\/rfc2616-sec14.html#sec14.20\">RFC 2616, section 14.20<\/a>. The value can also be passed to the <code>header<\/code> option as <code>Expect<\/code>. [Allowed values: <code>100-continue<\/code>]<\/li><li><code>headers<\/code> - <code>array<\/code> - Optional - Standard HTTP headers to send along in the request. Accepts an associative array of key-value pairs.<\/li><li><code>length<\/code> - <code>integer<\/code> - Optional - The size of the part in bytes. For more information, see <a href=\"http:\/\/www.w3.org\/Protocols\/rfc2616\/rfc2616-sec14.html#sec14.13\">RFC 2616, section 14.13<\/a>. The value can also be passed to the <code>header<\/code> option as <code>Content-Length<\/code>.<\/li><li><code>md5<\/code> - <code>string<\/code> - Optional - The base64 encoded 128-bit MD5 digest of the part data. This header can be used as a message integrity check to verify that the part data is the same data that was originally sent. Although it is optional, we recommend using this mechanism as an end-to-end integrity check. For more information, see <a href=\"http:\/\/www.ietf.org\/rfc\/rfc1864.txt\">RFC 1864<\/a>. The value can also be passed to the <code>header<\/code> option as <code>Content-MD5<\/code>.<\/li><li><code>seekTo<\/code> - <code>integer<\/code> - Optional - The starting position in bytes for the piece of the file\/stream to upload.<\/li><li><code>curlopts<\/code> - <code>array<\/code> - Optional - A set of values to pass directly into <code>curl_setopt()<\/code>, where the key is a pre-defined <code>CURLOPT_*<\/code> constant.<\/li><li><code>returnCurlHandle<\/code> - <code>boolean<\/code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.<\/li><\/ul>"}]},"returnvalue":"<p>A <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a> object containing a parsed HTTP response.<\/p>","source":"public function upload_part($bucket, $filename, $upload_id, $opt = null)\n{\n    if (!$opt) $opt = array();\n\n    \/\/ Add this to our request\n    $opt['verb'] = 'PUT';\n    $opt['resource'] = $filename;\n    $opt['uploadId'] = $upload_id;\n\n    if (!isset($opt['fileUpload']) || !isset($opt['partNumber']))\n    {\n        throw new S3_Exception('The `fileUpload` and `partNumber` options are both required in ' . __FUNCTION__ . '().');\n    }\n\n    \/\/ Handle expectation. Can also be passed as an HTTP header.\n    if (isset($opt['expect']))\n    {\n        $opt['headers']['Expect'] = $opt['expect'];\n        unset($opt['expect']);\n    }\n\n    \/\/ Handle content length. Can also be passed as an HTTP header.\n    if (isset($opt['length']))\n    {\n        $opt['headers']['Content-Length'] = $opt['length'];\n        unset($opt['length']);\n    }\n\n    \/\/ Handle content md5. Can also be passed as an HTTP header.\n    if (isset($opt['md5']))\n    {\n        $opt['headers']['Content-MD5'] = $opt['md5'];\n        unset($opt['md5']);\n    }\n\n    $opt['headers']['Expect'] = '100-continue';\n\n    \/\/ Authenticate to S3\n    return $this-&gt;authenticate($bucket, $opt);\n}","examples":{"example":{"title":"<p>Upload parts of a file in sequence.<\/p>","description":"<ol>\n<li>Initiate a new multipart upload using <code>initiate_multipart_upload()<\/code>.<\/li>\n<li>Upload the parts using <code>upload_part()<\/code>.<\/li>\n<li>Complete the upload using <code>complete_multipart_upload()<\/code>.<\/li>\n<\/ol>","code":"\/\/ Define a mebibyte\ndefine('MB', 1024 * 1024);\n\n\/\/ Instantiate the class\n$s3 = new AmazonS3();\n$bucket = 'my-bucket' . strtolower($s3-&gt;key);\n\n\/\/ Get the list of pieces\n$parts = $s3-&gt;get_multipart_counts(filesize('movie.mp4'), 50*MB);\n\n\/\/ Queue batch requests\nforeach ($parts as $i =&gt; $part)\n{\n\t$s3-&gt;batch()-&gt;upload_part($bucket, 'movie.mp4', 'f_JM_zwhU37pj1tS.F2BXVWUJtGcNso1WEikZImjrBCYUbUQwNnOUwX.Z00O1QmKQXAjqQBD4BVZRGmEXAMPLE--', array(\n\t\t'expect'     =&gt; '100-continue',\n\t\t'fileUpload' =&gt; 'movie.mp4',\n\t\t'partNumber' =&gt; ($i + 1),\n\t\t'seekTo'     =&gt; (integer) $part['seekTo'],\n\t\t'length'     =&gt; (integer) $part['length'],\n\t));\n}\n\n\/\/ Send batch requests\n$batch_responses = $s3-&gt;batch()-&gt;send();\n\n\/\/ Success?\nvar_dump($batch_responses-&gt;areOK());","result":"bool(true)"}}},{"name":"validate_bucketname_create","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Validates whether or not the specified Amazon S3 bucket name is valid for DNS-style access. This\nmethod is leveraged by any method that creates buckets.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to validate.<\/p>"}},"returnvalue":"<p>Whether or not the specified Amazon S3 bucket name is valid for DNS-style access. A value of <code>true<\/code> means that the bucket name is valid. A value of <code>false<\/code> means that the bucket name is invalid.<\/p>","source":"public function validate_bucketname_create($bucket)\n{\n    \/\/ list_buckets() uses this. Let it pass.\n    if ($bucket === '') return true;\n\n    if (\n        ($bucket === null || $bucket === false) ||                  \/\/ Must not be null or false\n        preg_match('\/[^(a-z0-9\\-\\.)]\/', $bucket) ||                 \/\/ Must be in the lowercase Roman alphabet, period or hyphen\n        !preg_match('\/^([a-z]|\\d)\/', $bucket) ||                    \/\/ Must start with a number or letter\n        !(strlen($bucket) &gt;= 3 &amp;&amp; strlen($bucket) &lt;= 63) ||         \/\/ Must be between 3 and 63 characters long\n        (strpos($bucket, '..') !== false) ||                        \/\/ Bucket names cannot contain two, adjacent periods\n        (strpos($bucket, '-.') !== false) ||                        \/\/ Bucket names cannot contain dashes next to periods\n        (strpos($bucket, '.-') !== false) ||                        \/\/ Bucket names cannot contain dashes next to periods\n        preg_match('\/(-|\\.)$\/', $bucket) ||                         \/\/ Bucket names should not end with a dash or period\n        preg_match('\/^(?:[0-9]{1,3}\\.){3}[0-9]{1,3}$\/', $bucket)    \/\/ Must not be formatted as an IP address\n    ) return false;\n\n    return true;\n}"},{"name":"validate_bucketname_support","modifier":"public","inheritance":{"class":{"name":"AmazonS3"}},"description":"<p>Validates whether or not the specified Amazon S3 bucket name is valid for path-style access. This\nmethod is leveraged by any method that reads from buckets.<\/p>","parameters":{"parameter":{"@attributes":{"choice":"req"},"name":"bucket","type":"string","description":"<p>The name of the bucket to validate.<\/p>"}},"returnvalue":"<p>Whether or not the bucket name is valid. A value of <code>true<\/code> means that the bucket name is valid. A value of <code>false<\/code> means that the bucket name is invalid.<\/p>","source":"public function validate_bucketname_support($bucket)\n{\n    \/\/ list_buckets() uses this. Let it pass.\n    if ($bucket === '') return true;\n\n    \/\/ Validate\n    if (\n        ($bucket === null || $bucket === false) ||                  \/\/ Must not be null or false\n        preg_match('\/[^(a-z0-9_\\-\\.)]\/i', $bucket) ||               \/\/ Must be in the Roman alphabet, period, hyphen or underscore\n        !preg_match('\/^([a-z]|\\d)\/i', $bucket) ||                   \/\/ Must start with a number or letter\n        !(strlen($bucket) &gt;= 3 &amp;&amp; strlen($bucket) &lt;= 255) ||        \/\/ Must be between 3 and 255 characters long\n        preg_match('\/^(?:[0-9]{1,3}\\.){3}[0-9]{1,3}$\/', $bucket)    \/\/ Must not be formatted as an IP address\n    ) return false;\n\n    return true;\n}"}]},"constants":{"@attributes":{"count":"60"},"constant":[{"name":"ACL_AUTH_READ","value":"authenticated-read"},{"name":"ACL_OPEN","value":"public-read-write"},{"name":"ACL_OWNER_FULL_CONTROL","value":"bucket-owner-full-control"},{"name":"ACL_OWNER_READ","value":"bucket-owner-read"},{"name":"ACL_PRIVATE","value":"private"},{"name":"ACL_PUBLIC","value":"public-read"},{"name":"BUILD","value":"20130314130000"},{"name":"DEFAULT_URL","value":"s3.amazonaws.com"},{"name":"GRANT_FULL_CONTROL","value":"FULL_CONTROL"},{"name":"GRANT_READ","value":"READ"},{"name":"GRANT_READ_ACP","value":"READ_ACP"},{"name":"GRANT_WRITE","value":"WRITE"},{"name":"GRANT_WRITE_ACP","value":"WRITE_ACP"},{"name":"NAME","value":"aws-sdk-php"},{"name":"PCRE_ALL","value":"\/.*\/i"},{"name":"REGION_APAC_NE1","value":"s3-ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_NE1_WEBSITE","value":"s3-website-ap-northeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1","value":"s3-ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE1_WEBSITE","value":"s3-website-ap-southeast-1.amazonaws.com"},{"name":"REGION_APAC_SE2","value":"s3-ap-southeast-2.amazonaws.com"},{"name":"REGION_APAC_SE2_WEBSITE","value":"s3-website-ap-southeast-2.amazonaws.com"},{"name":"REGION_CALIFORNIA","value":"s3-us-west-1.amazonaws.com"},{"name":"REGION_CALIFORNIA_WEBSITE","value":"s3-website-us-west-1.amazonaws.com"},{"name":"REGION_EU_W1","value":"s3-eu-west-1.amazonaws.com"},{"name":"REGION_EU_W1_WEBSITE","value":"s3-website-eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND","value":"s3-eu-west-1.amazonaws.com"},{"name":"REGION_IRELAND_WEBSITE","value":"s3-website-eu-west-1.amazonaws.com"},{"name":"REGION_OREGON","value":"s3-us-west-2.amazonaws.com"},{"name":"REGION_OREGON_WEBSITE","value":"s3-website-us-west-2.amazonaws.com"},{"name":"REGION_SAO_PAULO","value":"s3-sa-east-1.amazonaws.com"},{"name":"REGION_SAO_PAULO_WEBSITE","value":"s3-website-sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1","value":"s3-sa-east-1.amazonaws.com"},{"name":"REGION_SA_E1_WEBSITE","value":"s3-website-sa-east-1.amazonaws.com"},{"name":"REGION_SINGAPORE","value":"s3-ap-southeast-1.amazonaws.com"},{"name":"REGION_SINGAPORE_WEBSITE","value":"s3-website-ap-southeast-1.amazonaws.com"},{"name":"REGION_SYDNEY","value":"s3-ap-southeast-2.amazonaws.com"},{"name":"REGION_SYDNEY_WEBSITE","value":"s3-website-ap-southeast-2.amazonaws.com"},{"name":"REGION_TOKYO","value":"s3-ap-northeast-1.amazonaws.com"},{"name":"REGION_TOKYO_WEBSITE","value":"s3-website-ap-northeast-1.amazonaws.com"},{"name":"REGION_US_E1","value":"s3.amazonaws.com"},{"name":"REGION_US_E1_WEBSITE","value":"s3-website-us-east-1.amazonaws.com"},{"name":"REGION_US_GOV1","value":"s3-us-gov-west-1.amazonaws.com"},{"name":"REGION_US_GOV1_FIPS","value":"s3-fips-us-gov-west-1.amazonaws.com"},{"name":"REGION_US_GOV1_WEBSITE","value":"s3-website-us-gov-west-1.amazonaws.com"},{"name":"REGION_US_STANDARD","value":"s3.amazonaws.com"},{"name":"REGION_US_STANDARD_WEBSITE","value":"s3-website-us-east-1.amazonaws.com"},{"name":"REGION_US_W1","value":"s3-us-west-1.amazonaws.com"},{"name":"REGION_US_W1_WEBSITE","value":"s3-website-us-west-1.amazonaws.com"},{"name":"REGION_US_W2","value":"s3-us-west-2.amazonaws.com"},{"name":"REGION_US_W2_WEBSITE","value":"s3-website-us-west-2.amazonaws.com"},{"name":"REGION_VIRGINIA","value":"s3.amazonaws.com"},{"name":"REGION_VIRGINIA_WEBSITE","value":"s3-website-us-east-1.amazonaws.com"},{"name":"STORAGE_GLACIER","value":"GLACIER"},{"name":"STORAGE_REDUCED","value":"REDUCED_REDUNDANCY"},{"name":"STORAGE_STANDARD","value":"STANDARD"},{"name":"USERAGENT","value":"aws-sdk-php\/1.6.2 PHP\/5.4.9 curl\/7.15.5 openssl\/0.9.8e-fips-rhel5"},{"name":"USERS_ALL","value":"http:\/\/acs.amazonaws.com\/groups\/global\/AllUsers"},{"name":"USERS_AUTH","value":"http:\/\/acs.amazonaws.com\/groups\/global\/AuthenticatedUsers"},{"name":"USERS_LOGGING","value":"http:\/\/acs.amazonaws.com\/groups\/s3\/LogDelivery"},{"name":"VERSION","value":"1.6.2"}]},"properties":{"@attributes":{"count":"56"},"property":[{"name":"api_version","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The supported API version.<\/p>"},{"name":"auth_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The authentication class to use.<\/p>"},{"name":"auth_token","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon Authentication Token.<\/p>"},{"name":"base_acp_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for access control policy methods.<\/p>"},{"name":"base_location_constraint","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for creating buckets in regions.<\/p>"},{"name":"base_logging_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for logging methods.<\/p>"},{"name":"base_notification_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for notifications.<\/p>"},{"name":"base_versioning_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for versioning.<\/p>"},{"name":"batch_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFBatchRequest"}},"description":"<p>The default class to use for handling batch requests (defaults to <a href=\"..\/cfbatchrequest\/index.html\" rel=\"..\/..\/index.html#i=cfbatchrequest\"><code>CFBatchRequest<\/code><\/a>).<\/p>"},{"name":"batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated batch request object.<\/p>"},{"name":"bucket_tagging_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for bucket tagging.<\/p>"},{"name":"cache_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching class to use.<\/p>"},{"name":"cache_compress","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache compression.<\/p>"},{"name":"cache_expires","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>When the cache should be considered stale.<\/p>"},{"name":"cache_location","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The caching location to use.<\/p>"},{"name":"cache_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The current instantiated cache object.<\/p>"},{"name":"complete_mpu_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for completing a multipart upload.<\/p>"},{"name":"cors_config_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for CORS support.<\/p>"},{"name":"credentials","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The credentials to use for authentication.<\/p>"},{"name":"debug_mode","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the debug mode setting.<\/p>"},{"name":"delete_cache","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of the cache deletion setting.<\/p>"},{"name":"hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate hostname to use, if any.<\/p>"},{"name":"internal_batch_object","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The internally instantiated batch request object.<\/p>"},{"name":"key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Key.<\/p>"},{"name":"max_retries","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"integer","value":"3"}},"description":"<p>The number of times to retry failed requests.<\/p>"},{"name":"multi_object_delete_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for multi-object delete support.<\/p>"},{"name":"object_expiration_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for object expiration support.<\/p>"},{"name":"operation","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The operation to execute.<\/p>"},{"name":"operation_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The string prefix to prepend to the operation name.<\/p>"},{"name":"override_hostname","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of the capability to override the hostname with <a href=\"..\/s3browserupload\/set_hostname.html\" rel=\"..\/..\/index.html#m=s3browserupload\/set_hostname\"><code>set_hostname()<\/code><\/a>.<\/p>"},{"name":"parse_the_response","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether the response should be parsed or not.<\/p>"},{"name":"parser_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFSimpleXML"}},"description":"<p>The default class to use for parsing XML (defaults to <a href=\"..\/cfsimplexml\/index.html\" rel=\"..\/..\/index.html#i=cfsimplexml\"><code>CFSimpleXML<\/code><\/a>).<\/p>"},{"name":"path_style","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The DNS vs. Path-style setting.<\/p>"},{"name":"payload","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The payload to send.<\/p>"},{"name":"port_number","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate port number to use, if any.<\/p>"},{"name":"proxy","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The proxy to use for connecting.<\/p>"},{"name":"redirects","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The number of times a request has been retried.<\/p>"},{"name":"registered_streaming_read_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is read from.<\/p>"},{"name":"registered_streaming_write_callback","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The user-defined callback function to call when a stream is written to.<\/p>"},{"name":"request_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFRequest"}},"description":"<p>The default class to use for HTTP requests (defaults to <a href=\"..\/cfrequest\/index.html\" rel=\"..\/..\/index.html#i=cfrequest\"><code>CFRequest<\/code><\/a>).<\/p>"},{"name":"request_url","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The request URL.<\/p>"},{"name":"resource_prefix","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The alternate resource prefix to use, if any.<\/p>"},{"name":"response_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFResponse"}},"description":"<p>The default class to use for HTTP responses (defaults to <a href=\"..\/cfresponse\/index.html\" rel=\"..\/..\/index.html#i=cfresponse\"><code>CFResponse<\/code><\/a>).<\/p>"},{"name":"restore_request_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for restoration requests.<\/p>"},{"name":"secret_key","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The Amazon API Secret Key.<\/p>"},{"name":"service","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>An identifier for the current AWS service.<\/p>"},{"name":"ssl_verification","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL certificate verification.<\/p>"},{"name":"temporary_prefix","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The state of whether the prefix change is temporary or permanent.<\/p>"},{"name":"use_aws_query","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of whether auth should be handled as AWS Query.<\/p>"},{"name":"use_batch_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of batch flow usage.<\/p>"},{"name":"use_cache_flow","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>The state of cache flow usage.<\/p>"},{"name":"use_ssl","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"boolean","value":"true"}},"description":"<p>The state of SSL\/HTTPS use.<\/p>"},{"name":"util","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","description":"<p>Handle for the utility functions.<\/p>"},{"name":"utilities_class","inheritance":{"class":{"name":"CFRuntime","file":"sdk.class.php"}},"modifier":"public","initializer":{"@attributes":{"type":"string","value":"CFUtilities"}},"description":"<p>The default class to use for utilities (defaults to <a href=\"..\/cfutilities\/index.html\" rel=\"..\/..\/index.html#i=cfutilities\"><code>CFUtilities<\/code><\/a>).<\/p>"},{"name":"vhost","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The virtual host setting.<\/p>"},{"name":"website_config_xml","inheritance":{"class":{"name":"AmazonS3","file":"services\/s3.class.php"}},"modifier":"public","description":"<p>The base XML elements to use for website support.<\/p>"}]}}}