a:2:{s:4:"file";a:0:{}s:5:"class";a:9:{s:4:"name";s:9:"AmazonEC2";s:4:"file";s:22:"services/ec2.class.php";s:3:"url";s:23:"../amazonec2/index.html";s:11:"description";s:975:"<p>Amazon Elastic Compute Cloud (Amazon EC2) is a web service that provides resizable compute
capacity in the cloud. It is designed to make web-scale computing easier for developers.</p>

<p>Amazon EC2&#8217;s simple web service interface allows you to obtain and configure capacity with
minimal friction. It provides you with complete control of your computing resources and lets
you run on Amazon&#8217;s proven computing environment. Amazon EC2 reduces the time required to
obtain and boot new server instances to minutes, allowing you to quickly scale capacity, both
up and down, as your computing requirements change. Amazon EC2 changes the economics of
computing by allowing you to pay only for capacity that you actually use. Amazon EC2 provides
developers the tools to build failure resilient applications and isolate themselves from common
failure scenarios.</p>

<p>Visit <a href="http://aws.amazon.com/ec2/">http://aws.amazon.com/ec2/</a> for more information.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2013.03.14";s:7:"license";s:57:"See the included NOTICE.md file for complete information.";s:9:"copyright";s:57:"See the included NOTICE.md file for complete information.";s:4:"link";a:2:{i:0;s:37:"http://aws.amazon.com/ec2/ Amazon EC2";i:1;s:65:"http://aws.amazon.com/ec2/documentation/ Amazon EC2 documentation";}}s:11:"inheritance";a:1:{s:5:"class";a:3:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";s:3:"url";s:23:"../cfruntime/index.html";}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:3:"179";}s:6:"method";a:175:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:132:"<p>Constructs a new instance of <a href="../amazonec2/index.html" rel="../../index.html#i=amazonec2"><code>AmazonEC2</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1569:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonec2/set_cache_config.html" rel="../../index.html#m=amazonec2/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:228:"public function __construct(array $options = array())
{
    $this-&gt;api_version = '2013-02-01';
    $this-&gt;hostname = self::DEFAULT_URL;
    $this-&gt;auth_class = 'AuthV2Query';

    return parent::__construct($options);
}";}i:1;a:8:{s:4:"name";s:16:"activate_license";s:8:"modifier";s:6:"public";s:11:"description";s:122:"<p>Activates a specific number of licenses for a 90-day period. Activations can be done against a
specific license ID.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"license_id";s:4:"type";s:6:"string";s:11:"description";s:69:"<p>Specifies the ID for the specific license to activate against.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"capacity";s:4:"type";s:7:"integer";s:11:"description";s:63:"<p>Specifies the additional number of licenses to activate.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:240:"public function activate_license($license_id, $capacity, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LicenseId'] = $license_id;
    $opt['Capacity'] = $capacity;
    
    return $this-&gt;authenticate('ActivateLicense', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:48:"<p>Activate a Microsoft® Windows® license.</p>";s:4:"code";s:115:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;activate_license('lic-1234abcd', 1);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:129:"<a href="../amazonec2/bundle_instance.html" rel="../../index.html#m=amazonec2/bundle_instance"><code>bundle_instance()</code></a>";i:1;s:138:"<a href="../amazonec2/cancel_bundle_task.html" rel="../../index.html#m=amazonec2/cancel_bundle_task"><code>cancel_bundle_task()</code></a>";i:2;s:138:"<a href="../amazonec2/deactivate_license.html" rel="../../index.html#m=amazonec2/deactivate_license"><code>deactivate_license()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_bundle_tasks.html" rel="../../index.html#m=amazonec2/describe_bundle_tasks"><code>describe_bundle_tasks()</code></a>";i:4;s:135:"<a href="../amazonec2/get_password_data.html" rel="../../index.html#m=amazonec2/get_password_data"><code>get_password_data()</code></a>";}}}i:2;a:8:{s:4:"name";s:16:"allocate_address";s:8:"modifier";s:6:"public";s:11:"description";s:94:"<p>The AllocateAddress operation acquires an elastic IP address for use with your account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:735:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Domain</code> - <code>string</code> - Optional - Set to <code>vpc</code> to allocate the address to your VPC. By default, will allocate to EC2. [Allowed values: <code>vpc</code>, <code>standard</code>]</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:153:"public function allocate_address($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('AllocateAddress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Allocate a new Elastic IP address.</p>";s:4:"code";s:135:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;allocate_address();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:135:"<a href="../amazonec2/associate_address.html" rel="../../index.html#m=amazonec2/associate_address"><code>associate_address()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_addresses.html" rel="../../index.html#m=amazonec2/describe_addresses"><code>describe_addresses()</code></a>";i:2;s:144:"<a href="../amazonec2/disassociate_address.html" rel="../../index.html#m=amazonec2/disassociate_address"><code>disassociate_address()</code></a>";i:3;s:129:"<a href="../amazonec2/release_address.html" rel="../../index.html#m=amazonec2/release_address"><code>release_address()</code></a>";}}}i:3;a:8:{s:4:"name";s:23:"allow_hostname_override";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:170:"<p>Disables any subsequent use of the <a href="../amazonec2/set_hostname.html" rel="../../index.html#m=amazonec2/set_hostname"><code>set_hostname()</code></a> method.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"override";s:4:"type";s:7:"boolean";s:11:"description";s:398:"<p>Whether or not subsequent calls to <a href="../amazonec2/set_hostname.html" rel="../../index.html#m=amazonec2/set_hostname"><code>set_hostname()</code></a> should be obeyed. A <code>false</code> value disables the further effectiveness of <a href="../amazonec2/set_hostname.html" rel="../../index.html#m=amazonec2/set_hostname"><code>set_hostname()</code></a>. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:124:"public function allow_hostname_override($override = true)
{
    $this-&gt;override_hostname = $override;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:4;a:5:{s:4:"name";s:27:"assign_private_ip_addresses";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:839:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PrivateIpAddress</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>SecondaryPrivateIpAddressCount</code> - <code>integer</code> - Optional - </li><li><code>AllowReassignment</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:577:"public function assign_private_ip_addresses($network_interface_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    // Optional list (non-map)
    if (isset($opt['PrivateIpAddress']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PrivateIpAddress' =&gt; (is_array($opt['PrivateIpAddress']) ? $opt['PrivateIpAddress'] : array($opt['PrivateIpAddress']))
        )));
        unset($opt['PrivateIpAddress']);
    }

    return $this-&gt;authenticate('AssignPrivateIpAddresses', $opt);
}";}i:5;a:8:{s:4:"name";s:17:"associate_address";s:8:"modifier";s:6:"public";s:11:"description";s:307:"<p>The AssociateAddress operation associates an elastic IP address with an instance.</p>

<p>If the IP address is currently assigned to another instance, the IP address is assigned to the
new instance. This is an idempotent operation. If you enter it more than once, Amazon EC2 does
not return an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:53:"<p>The instance to associate with the IP address.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"public_ip";s:4:"type";s:6:"string";s:11:"description";s:57:"<p>IP address that you are assigning to the instance.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:918:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AllocationId</code> - <code>string</code> - Optional - The allocation ID that AWS returned when you allocated the elastic IP address for use with Amazon VPC.</li><li><code>NetworkInterfaceId</code> - <code>string</code> - Optional - </li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - </li><li><code>AllowReassociation</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:247:"public function associate_address($instance_id, $public_ip, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    $opt['PublicIp'] = $public_ip;
    
    return $this-&gt;authenticate('AssociateAddress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:36:"<p>AmazonEC2 - Associate Address</p>";s:4:"code";s:165:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;associate_address('i-1f549375', '184.73.247.11');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:132:"<a href="../amazonec2/allocate_address.html" rel="../../index.html#m=amazonec2/allocate_address"><code>allocate_address()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_addresses.html" rel="../../index.html#m=amazonec2/describe_addresses"><code>describe_addresses()</code></a>";i:2;s:144:"<a href="../amazonec2/disassociate_address.html" rel="../../index.html#m=amazonec2/disassociate_address"><code>disassociate_address()</code></a>";i:3;s:129:"<a href="../amazonec2/release_address.html" rel="../../index.html#m=amazonec2/release_address"><code>release_address()</code></a>";}}}i:6;a:8:{s:4:"name";s:22:"associate_dhcp_options";s:8:"modifier";s:6:"public";s:11:"description";s:594:"<p>Associates a set of DHCP options (that you&#8217;ve previously created) with the specified VPC. Or,
associates the default DHCP options with the VPC. The default set consists of the standard EC2
host name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type.
After you associate the options with the VPC, any existing instances and all new instances that
you launch in that VPC use the options. For more information about the supported DHCP options
and using them with Amazon VPC, go to Using DHCP Options in the Amazon Virtual Private Cloud
Developer Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"dhcp_options_id";s:4:"type";s:6:"string";s:11:"description";s:142:"<p>The ID of the DHCP options to associate with the VPC. Specify &#8220;default&#8221; to associate the default DHCP options with the VPC.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>The ID of the VPC to associate the DHCP options with.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:258:"public function associate_dhcp_options($dhcp_options_id, $vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['DhcpOptionsId'] = $dhcp_options_id;
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('AssociateDhcpOptions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:50:"<p>Associate a set of DHCP options with a VPC.</p>";s:4:"code";s:135:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;associate_dhcp_options('dopt-2a7ad743', 'vpc-abcd1234');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:141:"<a href="../amazonec2/create_dhcp_options.html" rel="../../index.html#m=amazonec2/create_dhcp_options"><code>create_dhcp_options()</code></a>";i:1;s:141:"<a href="../amazonec2/delete_dhcp_options.html" rel="../../index.html#m=amazonec2/delete_dhcp_options"><code>delete_dhcp_options()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_dhcp_options.html" rel="../../index.html#m=amazonec2/describe_dhcp_options"><code>describe_dhcp_options()</code></a>";}}}i:7;a:8:{s:4:"name";s:21:"associate_route_table";s:8:"modifier";s:6:"public";s:11:"description";s:604:"<p>Associates a subnet with a route table. The subnet and route table must be in the same VPC.
This association causes traffic originating from the subnet to be routed according to the
routes in the route table. The action returns an association ID, which you need if you want to
disassociate the route table from the subnet later. A route table can be associated with
multiple subnets.</p>

<p>For more information about route tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"subnet_id";s:4:"type";s:6:"string";s:11:"description";s:28:"<p>The ID of the subnet.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:33:"<p>The ID of the route table.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:262:"public function associate_route_table($subnet_id, $route_table_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SubnetId'] = $subnet_id;
    $opt['RouteTableId'] = $route_table_id;
    
    return $this-&gt;authenticate('AssociateRouteTable', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:49:"<p>Associate a VPC route table with a subnet.</p>";s:4:"code";s:136:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;associate_route_table('subnet-cd8a0aa4', 'rtb-2c8a0a45');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:1;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:2;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:3;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:8;a:8:{s:4:"name";s:23:"attach_internet_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:210:"<p>Attaches an Internet gateway to a VPC, enabling connectivity between the Internet and the VPC.
For more information about your VPC and Internet gateway, go to the Amazon Virtual Private
Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"internet_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:48:"<p>The ID of the Internet gateway to attach.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:25:"<p>The ID of the VPC.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:272:"public function attach_internet_gateway($internet_gateway_id, $vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InternetGatewayId'] = $internet_gateway_id;
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('AttachInternetGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Attach an internet gateway to a running VPC.</p>";s:11:"description";s:941:"<p>Here is the flow:</p>

<ol>
<li>Create a new VPC with <a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a> and a CIDR block.</li>
<li>Create a new Route Table with <a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>.</li>
<li>Create a new Internet Gateway with <a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>.</li>
<li>Attach the Internet Gateway to the VPC with <a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>.</li>
<li>Create a new Route with <a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>.</li>
</ol>";s:4:"code";s:135:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;attach_internet_gateway('igw-be7cfdd7', 'vpc-7e7dfc17');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:153:"<a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/delete_internet_gateway.html" rel="../../index.html#m=amazonec2/delete_internet_gateway"><code>delete_internet_gateway()</code></a>";i:2;s:162:"<a href="../amazonec2/describe_internet_gateways.html" rel="../../index.html#m=amazonec2/describe_internet_gateways"><code>describe_internet_gateways()</code></a>";i:3;s:153:"<a href="../amazonec2/detach_internet_gateway.html" rel="../../index.html#m=amazonec2/detach_internet_gateway"><code>detach_internet_gateway()</code></a>";}}}i:9;a:6:{s:4:"name";s:24:"attach_network_interface";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"device_index";s:4:"type";s:7:"integer";s:11:"description";a:0:{}}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:348:"public function attach_network_interface($network_interface_id, $instance_id, $device_index, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    $opt['InstanceId'] = $instance_id;
    $opt['DeviceIndex'] = $device_index;
    
    return $this-&gt;authenticate('AttachNetworkInterface', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Attach a network interface to a subnet.</p>";s:4:"code";s:144:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;attach_network_interface($network_interface_id, $instance_id, 1);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:10;a:8:{s:4:"name";s:13:"attach_volume";s:8:"modifier";s:6:"public";s:11:"description";s:64:"<p>Attach a previously created volume to a running instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";s:139:"<p>The ID of the Amazon EBS volume. The volume and instance must be within the same Availability Zone and the instance must be running.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:159:"<p>The ID of the instance to which the volume attaches. The volume and instance must be within the same Availability Zone and the instance must be running.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"device";s:4:"type";s:6:"string";s:11:"description";s:89:"<p>Specifies how the device is exposed to the instance (e.g., <code>/dev/sdh</code>).</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:278:"public function attach_volume($volume_id, $instance_id, $device, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    $opt['InstanceId'] = $instance_id;
    $opt['Device'] = $device;
    
    return $this-&gt;authenticate('AttachVolume', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:50:"<p>Attach an EBS volume to a running instance.</p>";s:4:"code";s:193:"// Instantiate the class
$ec2 = new AmazonEC2();

// Attach the volume
$response = $ec2-&gt;attach_volume('vol-fc482995', 'i-1f549375', '/dev/sdg');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:1;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:2;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:3;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:11;a:8:{s:4:"name";s:18:"attach_vpn_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:266:"<p>Attaches a VPN gateway to a VPC. This is the last step required to get your VPC fully connected
to your data center before launching instances in it. For more information, go to Process for
Using Amazon VPC in the Amazon Virtual Private Cloud Developer Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"vpn_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:54:"<p>The ID of the VPN gateway to attach to the VPC.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:54:"<p>The ID of the VPC to attach to the VPN gateway.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:247:"public function attach_vpn_gateway($vpn_gateway_id, $vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnGatewayId'] = $vpn_gateway_id;
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('AttachVpnGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:47:"<p>Attach a VPN gateway to an existing VPC.</p>";s:4:"code";s:130:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;attach_vpn_gateway('vgw-9aa347f3', 'vpc-fd7cd194');

var_dump($response-&gt;isOK());";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:138:"<a href="../amazonec2/create_vpn_gateway.html" rel="../../index.html#m=amazonec2/create_vpn_gateway"><code>create_vpn_gateway()</code></a>";i:1;s:138:"<a href="../amazonec2/delete_vpn_gateway.html" rel="../../index.html#m=amazonec2/delete_vpn_gateway"><code>delete_vpn_gateway()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_vpn_gateways.html" rel="../../index.html#m=amazonec2/describe_vpn_gateways"><code>describe_vpn_gateways()</code></a>";i:3;s:138:"<a href="../amazonec2/detach_vpn_gateway.html" rel="../../index.html#m=amazonec2/detach_vpn_gateway"><code>detach_vpn_gateway()</code></a>";}}}i:12;a:7:{s:4:"name";s:12:"authenticate";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:69:"<p>Default, shared method for authenticating a connection to AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"operation";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>Indicates the operation to perform.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"payload";s:4:"type";s:5:"array";s:11:"description";s:106:"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.</p>";}}}s:11:"returnvalue";s:48:"<p>Object containing a parsed HTTP response.</p>";s:6:"source";s:6988:"public function authenticate($operation, $payload)
{
    $original_payload = $payload;
    $method_arguments = func_get_args();
    $curlopts = array();
    $return_curl_handle = false;

    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)
    {
        $operation = $this-&gt;operation_prefix . $operation;
    }

    // Extract the custom CURLOPT settings from the payload
    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))
    {
        $curlopts = $payload['curlopts'];
        unset($payload['curlopts']);
    }

    // Determine whether the response or curl handle should be returned
    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))
    {
        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;
        unset($payload['returnCurlHandle']);
    }

    // Use the caching flow to determine if we need to do a round-trip to the server.
    if ($this-&gt;use_cache_flow)
    {
        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);

        // Parse the XML body
        $data = $this-&gt;parse_callback($data);

        // End!
        return $data;
    }

    /*%******************************************************************************************%*/

    // Signer
    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);
    $signer-&gt;key = $this-&gt;key;
    $signer-&gt;secret_key = $this-&gt;secret_key;
    $signer-&gt;auth_token = $this-&gt;auth_token;
    $signer-&gt;api_version = $this-&gt;api_version;
    $signer-&gt;utilities_class = $this-&gt;utilities_class;
    $signer-&gt;request_class = $this-&gt;request_class;
    $signer-&gt;response_class = $this-&gt;response_class;
    $signer-&gt;use_ssl = $this-&gt;use_ssl;
    $signer-&gt;proxy = $this-&gt;proxy;
    $signer-&gt;util = $this-&gt;util;
    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;
    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;
    $request = $signer-&gt;authenticate();

    // Update RequestCore settings
    $request-&gt;request_class = $this-&gt;request_class;
    $request-&gt;response_class = $this-&gt;response_class;
    $request-&gt;ssl_verification = $this-&gt;ssl_verification;

    /*%******************************************************************************************%*/

    // Debug mode
    if ($this-&gt;debug_mode)
    {
        $request-&gt;debug_mode = $this-&gt;debug_mode;
    }

    // Set custom CURLOPT settings
    if (count($curlopts))
    {
        $request-&gt;set_curlopts($curlopts);
    }

    // Manage the (newer) batch request API or the (older) returnCurlHandle setting.
    if ($this-&gt;use_batch_flow)
    {
        $handle = $request-&gt;prep_request();
        $this-&gt;batch_object-&gt;add($handle);
        $this-&gt;use_batch_flow = false;

        return $handle;
    }
    elseif ($return_curl_handle)
    {
        return $request-&gt;prep_request();
    }

    // Send!
    $request-&gt;send_request();

    // Prepare the response.
    $headers = $request-&gt;get_response_header();
    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;

    if (isset($signer-&gt;canonical_request))
    {
        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;
    }

    $headers['x-aws-request-headers'] = $request-&gt;request_headers;
    $headers['x-aws-body'] = $signer-&gt;querystring;

    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());

    $response_body = (string) $request-&gt;get_response_body();

    // Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.
    if (
        (integer) $request-&gt;get_response_code() === 500 || // Internal Error (presumably transient)
        (integer) $request-&gt;get_response_code() === 503)   // Service Unavailable (presumably transient)
    {
        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)
        {
            // Exponential backoff
            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);
            usleep($delay);
            $this-&gt;redirects++;
            $data = $this-&gt;authenticate($operation, $original_payload);
        }
    }

    // DynamoDB has additional, custom logic for retrying requests
    else
    {
        // If the request to DynamoDB was throttled, we need to retry
        $need_to_retry_dynamodb_request = (
            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;
            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;
            stripos($response_body, 'ProvisionedThroughputExceededException') !== false
        );

        // If the CRC32 of the response does not match the expected value, we need to retry
        $response_headers = $request-&gt;get_response_header();
        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))
        {
            $crc32_expected = $response_headers['x-amz-crc32'];
            $crc32_actual = hexdec(hash('crc32b', $response_body));
            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);
        }

        // Perform retry if necessary using a more aggressive exponential backoff
        if ($need_to_retry_dynamodb_request)
        {
            if ($this-&gt;redirects === 0)
            {
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))
            {
                // Exponential backoff
                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);
                usleep($delay);
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
        }
    }

    $this-&gt;redirects = 0;
    return $data;
}";}i:13;a:8:{s:4:"name";s:31:"authorize_security_group_egress";s:8:"modifier";s:6:"public";s:11:"description";s:1109:"<p>This action applies only to security groups in a VPC; it&#8217;s not supported for EC2 security
groups. For information about Amazon Virtual Private Cloud and VPC security groups, go to the
Amazon Virtual Private Cloud User Guide.</p>

<p>The action adds one or more egress rules to a VPC security group. Specifically, this permits
instances in a security group to send traffic to either one or more destination CIDR IP address
ranges, or to one or more destination security groups in the same VPC.</p>

<p>Each rule consists of the protocol (e.g., TCP), plus either a CIDR range, or a source group.
For the TCP and UDP protocols, you must also specify the destination port or port range. For
the ICMP protocol, you must also specify the ICMP type and code. You can use <code>-1</code> as
a wildcard for the ICMP type or code.</p>

<p>Rule changes are propagated to instances within the security group as quickly as possible.
However, a small delay might occur.</p>

<p><strong>Important:</strong> For VPC security groups: You can have up to 50 rules total per
group (covering both ingress and egress).</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"group_id";s:4:"type";s:6:"string";s:11:"description";s:46:"<p>ID of the VPC security group to modify.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2421:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>IpPermissions</code> - <code>array</code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol</code> - <code>string</code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp</code>, <code>udp</code>, <code>icmp</code></li><li><code>FromPort</code> - <code>integer</code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1</code> indicates a wildcard (i.e., any ICMP type number).</li><li><code>ToPort</code> - <code>integer</code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1</code> indicates a wildcard (i.e., any ICMP code).</li><li><code>Groups</code> - <code>array</code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of an account.</li><li><code>GroupName</code> - <code>string</code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li></ul></li></ul></li><li><code>IpRanges</code> - <code>string|array</code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:461:"public function authorize_security_group_egress($group_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['GroupId'] = $group_id;
    
    // Optional list + map
    if (isset($opt['IpPermissions']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'IpPermissions' =&gt; $opt['IpPermissions']
        )));
        unset($opt['IpPermissions']);
    }

    return $this-&gt;authenticate('AuthorizeSecurityGroupEgress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:38:"<p>Authorize Security Group Egress</p>";s:4:"code";s:394:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;authorize_security_group_egress('sg-830d1eef', array(
	'IpPermissions' =&gt; array(
		array( // Set 0
			'IpProtocol' =&gt; 'tcp',
			'FromPort' =&gt; '80',
			'ToPort' =&gt; '80',
			'IpRanges' =&gt; array(
				array('CidrIp' =&gt; '205.192.0.0/16'), // Range 0
			)
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:1;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:2;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:3;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:4;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}}i:14;a:9:{s:4:"name";s:32:"authorize_security_group_ingress";s:8:"modifier";s:6:"public";s:11:"description";s:607:"<p>The AuthorizeSecurityGroupIngress operation adds permissions to a security group.</p>

<p>Permissions are specified by the IP protocol (TCP, UDP or ICMP), the source of the request (by
IP range or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and
UDP), and the ICMP codes and types (for ICMP). When authorizing ICMP, <code>-1</code> can be
used as a wildcard in the type and code fields.</p>

<p>Permission changes are propagated to instances within the security group as quickly as
possible. However, depending on the number of instances, a small delay might occur.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2910:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GroupName</code> - <code>string</code> - Optional - Name of the standard (EC2) security group to modify. The group must belong to your account. Can be used instead of GroupID for standard (EC2) security groups.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the standard (EC2) or VPC security group to modify. The group must belong to your account. Required for VPC security groups; can be used instead of GroupName for standard (EC2) security groups.</li><li><code>IpPermissions</code> - <code>array</code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol</code> - <code>string</code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp</code>, <code>udp</code>, <code>icmp</code></li><li><code>FromPort</code> - <code>integer</code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1</code> indicates a wildcard (i.e., any ICMP type number).</li><li><code>ToPort</code> - <code>integer</code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1</code> indicates a wildcard (i.e., any ICMP code).</li><li><code>Groups</code> - <code>array</code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of an account.</li><li><code>GroupName</code> - <code>string</code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li></ul></li></ul></li><li><code>IpRanges</code> - <code>string|array</code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:427:"public function authorize_security_group_ingress($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['IpPermissions']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'IpPermissions' =&gt; $opt['IpPermissions']
        )));
        unset($opt['IpPermissions']);
    }

    return $this-&gt;authenticate('AuthorizeSecurityGroupIngress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Authorize Security Group Ingress</p>";s:4:"code";s:410:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;authorize_security_group_ingress(array(
	'GroupName' =&gt; 'default',
	'IpPermissions' =&gt; array(
		array( // Set 0
			'IpProtocol' =&gt; 'tcp',
			'FromPort' =&gt; '80',
			'ToPort' =&gt; '80',
			'IpRanges' =&gt; array(
				array('CidrIp' =&gt; '205.192.0.0/16'), // Range 0
			)
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:2;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:3;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:4;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:412:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/index.html?ApiReference-query-AuthorizeSecurityGroupIngress.html">AuthorizeSecurityGroupIngress</a> operation introduced backwards-incompatible changes in the <code>2011-01-01</code> API release. The <code>GroupName</code> parameter is no longer required. Instead <code>GroupName</code> or <code>GroupId</code> are conditionally required.</p>";}}i:15;a:8:{s:4:"name";s:5:"batch";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:86:"<p>Specifies that the intended request should be queued for a later batch request.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"queue";s:4:"type";s:14:"CFBatchRequest";s:11:"description";s:327:"<p>The <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a> instance to use for managing batch requests. If not available, it generates a new instance of <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:477:"public function batch(CFBatchRequest &amp;$queue = null)
{
    if ($queue)
    {
        $this-&gt;batch_object = $queue;
    }
    elseif ($this-&gt;internal_batch_object)
    {
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }
    else
    {
        $this-&gt;internal_batch_object = new $this-&gt;batch_class();
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }

    $this-&gt;use_batch_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:16;a:8:{s:4:"name";s:15:"bundle_instance";s:8:"modifier";s:6:"public";s:11:"description";s:281:"<p>The BundleInstance operation request that an instance is bundled the next time it boots. The
bundling process creates a new image from a running instance and stores the AMI data in S3. Once
bundled, the image must be registered in the normal way using the RegisterImage API.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:40:"<p>The ID of the instance to bundle.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"policy";s:4:"type";s:5:"array";s:11:"description";s:1763:"<p>The details of S3 storage for bundling a Windows instance. Takes an associative array of parameters that can have the following keys:</p>

<ul><li><code>Bucket</code> - <code>string</code> - Optional - The bucket in which to store the AMI. You can specify a bucket that you already own or a new bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone else, Amazon EC2 returns an error.</li><li><code>Prefix</code> - <code>string</code> - Optional - The prefix to use when storing the AMI in S3.</li><li><code>AWSAccessKeyId</code> - <code>string</code> - Optional - The Access Key ID of the owner of the Amazon S3 bucket. Use the <a href="../cfpolicy/get_key.html" rel="../../index.html#m=cfpolicy/get_key"><code>CFPolicy::get_key()</code></a> method of a <a href="../cfpolicy/index.html" rel="../../index.html#i=cfpolicy"><code>CFPolicy</code></a> instance.</li><li><code>UploadPolicy</code> - <code>string</code> - Optional - A Base64-encoded Amazon S3 upload policy that gives Amazon EC2 permission to upload items into Amazon S3 on the user&#8217;s behalf. Use the <a href="../cfpolicy/get_policy.html" rel="../../index.html#m=cfpolicy/get_policy"><code>CFPolicy::get_policy()</code></a> method of a <a href="../cfpolicy/index.html" rel="../../index.html#i=cfpolicy"><code>CFPolicy</code></a> instance.</li><li><code>UploadPolicySignature</code> - <code>string</code> - Optional - The signature of the Base64 encoded JSON document. Use the <a href="../cfpolicy/get_policy_signature.html" rel="../../index.html#m=cfpolicy/get_policy_signature"><code>CFPolicy::get_policy_signature()</code></a> method of a <a href="../cfpolicy/index.html" rel="../../index.html#i=cfpolicy"><code>CFPolicy</code></a> instance.</li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:512:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:321:"public function bundle_instance($instance_id, $policy, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;

    $opt = array_merge($opt, CFComplexType::map(array(
        'Storage.S3' =&gt; $policy
    )));

    return $this-&gt;authenticate('BundleInstance', $opt, $this-&gt;hostname);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:47:"<p>Bundle a running Windows-based instance.</p>";s:4:"code";s:669:"// Instantiate the class
$ec2 = new AmazonEC2();

// Create the S3 policy
$policy = new CFPolicy($ec2, array(
	'expiration' =&gt; $ec2-&gt;util-&gt;convert_date_to_iso8601('+12 hours'), // Expire in 12 hours
	'conditions' =&gt; array(
		array('acl' =&gt; 'public-read'),
		array('bucket' =&gt; 'my-bucket')
	)
));

// Bundle the Windows instance
$response = $ec2-&gt;bundle_instance($instance_id, array(
	'Bucket' =&gt; 'my-bucket',
	'Prefix' =&gt; 'windows',
	'AWSAccessKeyId' =&gt; $policy-&gt;get_key(),
	'UploadPolicy' =&gt; $policy-&gt;get_policy(),
	'UploadPolicySignature' =&gt; $policy-&gt;get_policy_signature()
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:132:"<a href="../amazonec2/activate_license.html" rel="../../index.html#m=amazonec2/activate_license"><code>activate_license()</code></a>";i:1;s:138:"<a href="../amazonec2/cancel_bundle_task.html" rel="../../index.html#m=amazonec2/cancel_bundle_task"><code>cancel_bundle_task()</code></a>";i:2;s:138:"<a href="../amazonec2/deactivate_license.html" rel="../../index.html#m=amazonec2/deactivate_license"><code>deactivate_license()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_bundle_tasks.html" rel="../../index.html#m=amazonec2/describe_bundle_tasks"><code>describe_bundle_tasks()</code></a>";i:4;s:135:"<a href="../amazonec2/get_password_data.html" rel="../../index.html#m=amazonec2/get_password_data"><code>get_password_data()</code></a>";}}}i:17;a:8:{s:4:"name";s:5:"cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:323:"<p>Specifies that the resulting <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object should be cached according to the settings from
<a href="../amazonec2/set_cache_config.html" rel="../../index.html#m=amazonec2/set_cache_config"><code>set_cache_config()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"expires";s:4:"type";s:14:"string|integer";s:11:"description";s:232:"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href="http://php.net/strtotime"><code>strtotime()</code></a> (e.g. &#8220;1 hour&#8221;).</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:501:"public function cache($expires)
{
    // Die if they haven't used set_cache_config().
    if (!$this-&gt;cache_class)
    {
        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');
    }

    if (is_string($expires))
    {
        $expires = strtotime($expires);
        $this-&gt;cache_expires = $expires - time();
    }
    elseif (is_int($expires))
    {
        $this-&gt;cache_expires = $expires;
    }

    $this-&gt;use_cache_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:5:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:2;a:4:{s:5:"title";s:70:"<p>Fire a single request, and then cache the response to Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:338:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:3;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:4;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:18;a:7:{s:4:"name";s:34:"cache_instance_profile_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:139:"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to
be manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:2563:"public function cache_instance_profile_credentials($cache, $options)
{
    $instance_profile_url = 'http://169.254.169.254/latest/meta-data/iam/security-credentials/';
    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;

    try
    {
        // Make a call to the EC2 Metadata Service to find the available instance profile
        $request = new RequestCore($instance_profile_url);
        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
        $response = $request-&gt;send_request(true);

        if ($response-&gt;isOK())
        {
            // Get the instance profile name
            $profile = (string) $response-&gt;body;

            // Make a call to the EC2 Metadata Service to get the instance profile credentials
            $request = new RequestCore($instance_profile_url . $profile);
            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
            $response = $request-&gt;send_request(true);

            if ($response-&gt;isOK())
            {
                // Get the credentials
                $credentials = json_decode($response-&gt;body, true);

                if ($credentials['Code'] === 'Success')
                {
                    // Determine the expiration time
                    $expiration_time = strtotime((string) $credentials['Expiration']);
                    $expiration_duration = round(($expiration_time - time()) * 0.85);
                    $cache-&gt;expire_in($expiration_duration);

                    // Return the credential information
                    return array(
                        'key'     =&gt; $credentials['AccessKeyId'],
                        'secret'  =&gt; $credentials['SecretAccessKey'],
                        'token'   =&gt; $credentials['Token'],
                        'expires' =&gt; $credentials['Expiration'],
                    );
                }
            }
        }
    }
    catch (cURL_Exception $e)
    {
        // The EC2 Metadata Service does not exist or had timed out.
        // An exception will be thrown on the next line.
    }

    // @codeCoverageIgnoreStart
    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '
        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '
        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');
    // @codeCoverageIgnoreEnd
}";}i:19;a:7:{s:4:"name";s:21:"cache_sts_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:122:"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be
manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:1226:"public function cache_sts_credentials($cache, $options)
{
    $token = new AmazonSTS($options);
    $response = $token-&gt;get_session_token();

    if ($response-&gt;isOK())
    {
        // Update the expiration
        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);
        $expiration_duration = round(($expiration_time - time()) * 0.85);
        $cache-&gt;expire_in($expiration_duration);

        // Return the important data
        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;

        return array(
            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,
            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,
            'token'   =&gt; (string) $credentials-&gt;SessionToken,
            'expires' =&gt; (string) $credentials-&gt;Expiration,
        );
    }

    // @codeCoverageIgnoreStart
    throw new STS_Exception('Temporary credentials from the AWS Security '
        . 'Token Service could not be retrieved using the provided long '
        . 'term credentials. It\'s possible that the provided long term '
        . 'credentials were invalid.');
    // @codeCoverageIgnoreEnd
}";}i:20;a:8:{s:4:"name";s:18:"cancel_bundle_task";s:8:"modifier";s:6:"public";s:11:"description";s:324:"<p>CancelBundleTask operation cancels a pending or in-progress bundling task. This is an
asynchronous call and it make take a while for the task to be canceled. If a task is canceled
while it is storing items, there may be parts of the incomplete AMI stored in S3. It is up to
the caller to clean up these parts from S3.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"bundle_id";s:4:"type";s:6:"string";s:11:"description";s:43:"<p>The ID of the bundle task to cancel.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:195:"public function cancel_bundle_task($bundle_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['BundleId'] = $bundle_id;
    
    return $this-&gt;authenticate('CancelBundleTask', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:55:"<p>Cancel the bundling of a Windows-based instance.</p>";s:4:"code";s:174:"// Instantiate the class
$ec2 = new AmazonEC2();

// Cancel the bundle task
$response = $ec2-&gt;cancel_bundle_task($bundle_id); 

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:132:"<a href="../amazonec2/activate_license.html" rel="../../index.html#m=amazonec2/activate_license"><code>activate_license()</code></a>";i:1;s:129:"<a href="../amazonec2/bundle_instance.html" rel="../../index.html#m=amazonec2/bundle_instance"><code>bundle_instance()</code></a>";i:2;s:138:"<a href="../amazonec2/deactivate_license.html" rel="../../index.html#m=amazonec2/deactivate_license"><code>deactivate_license()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_bundle_tasks.html" rel="../../index.html#m=amazonec2/describe_bundle_tasks"><code>describe_bundle_tasks()</code></a>";i:4;s:135:"<a href="../amazonec2/get_password_data.html" rel="../../index.html#m=amazonec2/get_password_data"><code>get_password_data()</code></a>";}}}i:21;a:5:{s:4:"name";s:22:"cancel_conversion_task";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"conversion_task_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:590:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ReasonMessage</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:229:"public function cancel_conversion_task($conversion_task_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ConversionTaskId'] = $conversion_task_id;
    
    return $this-&gt;authenticate('CancelConversionTask', $opt);
}";}i:22;a:5:{s:4:"name";s:18:"cancel_export_task";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"export_task_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function cancel_export_task($export_task_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ExportTaskId'] = $export_task_id;
    
    return $this-&gt;authenticate('CancelExportTask', $opt);
}";}i:23;a:5:{s:4:"name";s:33:"cancel_reserved_instances_listing";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:29:"reserved_instances_listing_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:282:"public function cancel_reserved_instances_listing($reserved_instances_listing_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ReservedInstancesListingId'] = $reserved_instances_listing_id;
    
    return $this-&gt;authenticate('CancelReservedInstancesListing', $opt);
}";}i:24;a:8:{s:4:"name";s:29:"cancel_spot_instance_requests";s:8:"modifier";s:6:"public";s:11:"description";s:639:"<p>Cancels one or more Spot Instance requests.</p>

<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that
you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based
on available Spot Instance capacity and current spot instance requests.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:24:"spot_instance_request_id";s:4:"type";s:12:"string|array";s:11:"description";s:128:"<p>Specifies the ID of the Spot Instance request. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:439:"public function cancel_spot_instance_requests($spot_instance_request_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'SpotInstanceRequestId' =&gt; (is_array($spot_instance_request_id) ? $spot_instance_request_id : array($spot_instance_request_id))
    )));

    return $this-&gt;authenticate('CancelSpotInstanceRequests', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:36:"<p>Cancel spot instance requests</p>";s:4:"code";s:125:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;cancel_spot_instance_requests('sir-769afa02');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:1;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:2;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:3;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:25;a:7:{s:4:"name";s:24:"confirm_product_instance";s:8:"modifier";s:6:"public";s:11:"description";s:529:"<p>The ConfirmProductInstance operation returns true if the specified product code is attached to
the specified instance. The operation returns false if the product code is not attached to the
instance.</p>

<p>The ConfirmProductInstance operation can only be executed by the owner of the AMI. This feature
is useful when an AMI owner is providing support and wants to verify whether a user&#8217;s instance
is eligible.</p>
<p>This method is used in conjunction with AWS DevPay, which is not otherwise supported by this SDK.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"product_code";s:4:"type";s:6:"string";s:11:"description";s:35:"<p>The product code to confirm.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:41:"<p>The ID of the instance to confirm.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:269:"public function confirm_product_instance($product_code, $instance_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ProductCode'] = $product_code;
    $opt['InstanceId'] = $instance_id;
    
    return $this-&gt;authenticate('ConfirmProductInstance', $opt);
}";s:7:"related";a:0:{}}i:26;a:5:{s:4:"name";s:10:"copy_image";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"source_region";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"source_image_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"name";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:657:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>ClientToken</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:289:"public function copy_image($source_region, $source_image_id, $name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SourceRegion'] = $source_region;
    $opt['SourceImageId'] = $source_image_id;
    $opt['Name'] = $name;
    
    return $this-&gt;authenticate('CopyImage', $opt);
}";}i:27;a:5:{s:4:"name";s:13:"copy_snapshot";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"source_region";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"source_snapshot_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:588:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:271:"public function copy_snapshot($source_region, $source_snapshot_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SourceRegion'] = $source_region;
    $opt['SourceSnapshotId'] = $source_snapshot_id;
    
    return $this-&gt;authenticate('CopySnapshot', $opt);
}";}i:28;a:8:{s:4:"name";s:23:"create_customer_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:1098:"<p>Provides information to AWS about your customer gateway device. The customer gateway is the
appliance at your end of the VPN connection (compared to the VPN gateway, which is the device
at the AWS side of the VPN connection). You can have a single active customer gateway per AWS
account (active means that you&#8217;ve created a VPN connection to use with the customer gateway).
AWS might delete any customer gateway that you create with this operation if you leave it
inactive for an extended period of time.</p>

<p>You must provide the Internet-routable IP address of the customer gateway&#8217;s external interface.
The IP address must be static.</p>

<p>You must also provide the device&#8217;s Border Gateway Protocol (BGP) Autonomous System Number
(ASN). You can use an existing ASN assigned to your network. If you don&#8217;t have an ASN already,
you can use a private ASN (in the 64512 - 65534 range). For more information about ASNs, go to
<a href=
"http://en.wikipedia.org/wiki/Autonomous_system_%28Internet%29">http://en.wikipedia.org/wiki/Autonomous_system_%28Internet%29</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"type";s:4:"type";s:6:"string";s:11:"description";s:65:"<p>The type of VPN connection this customer gateway supports.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"ip_address";s:4:"type";s:6:"string";s:11:"description";s:118:"<p>The Internet-routable IP address for the customer gateway&#8217;s outside interface. The address must be static</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"bgp_asn";s:4:"type";s:7:"integer";s:11:"description";s:97:"<p>The customer gateway&#8217;s Border Gateway Protocol (BGP) Autonomous System Number (ASN).</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:282:"public function create_customer_gateway($type, $ip_address, $bgp_asn, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['Type'] = $type;
    $opt['IpAddress'] = $ip_address;
    $opt['BgpAsn'] = $bgp_asn;
    
    return $this-&gt;authenticate('CreateCustomerGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Create a new VPC customer gateway.</p>";s:4:"code";s:162:"$ec2 = new AmazonEC2();

// IP: 1.1.1.1; Port: 65534
$response = $ec2-&gt;create_customer_gateway('ipsec.1', '1.1.1.1', '65534');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:153:"<a href="../amazonec2/delete_customer_gateway.html" rel="../../index.html#m=amazonec2/delete_customer_gateway"><code>delete_customer_gateway()</code></a>";i:1;s:162:"<a href="../amazonec2/describe_customer_gateways.html" rel="../../index.html#m=amazonec2/describe_customer_gateways"><code>describe_customer_gateways()</code></a>";}}}i:29;a:8:{s:4:"name";s:19:"create_dhcp_options";s:8:"modifier";s:6:"public";s:11:"description";s:392:"<p>Creates a set of DHCP options that you can then associate with one or more VPCs, causing all
existing and new instances that you launch in those VPCs to use the set of DHCP options. The
following table lists the individual DHCP options you can specify. For more information about
the options, go to <a href=
"http://www.ietf.org/rfc/rfc2132.txt">http://www.ietf.org/rfc/rfc2132.txt</a></p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"dhcp_configuration";s:4:"type";s:5:"array";s:11:"description";s:447:"<p>A set of one or more DHCP configurations.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Key</code> - <code>string</code> - Optional - Contains the name of a DHCP option.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains a set of values for a DHCP option. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:388:"public function create_dhcp_options($dhcp_configuration, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'DhcpConfiguration' =&gt; (is_array($dhcp_configuration) ? $dhcp_configuration : array($dhcp_configuration))
    )));

    return $this-&gt;authenticate('CreateDhcpOptions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:40:"<p>Create a new set of DHCP options.</p>";s:4:"code";s:377:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_dhcp_options(array(
	array('Key' =&gt; 'domain-name',         'Value' =&gt; 'example.com'),
	array('Key' =&gt; 'ntp-servers',         'Value' =&gt; '140.142.16.34'),
	array('Key' =&gt; 'domain-name-servers', 'Value' =&gt; array('8.8.8.8', '8.8.4.4', '208.67.222.222', '208.67.222.220')),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:150:"<a href="../amazonec2/associate_dhcp_options.html" rel="../../index.html#m=amazonec2/associate_dhcp_options"><code>associate_dhcp_options()</code></a>";i:1;s:141:"<a href="../amazonec2/delete_dhcp_options.html" rel="../../index.html#m=amazonec2/delete_dhcp_options"><code>delete_dhcp_options()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_dhcp_options.html" rel="../../index.html#m=amazonec2/describe_dhcp_options"><code>describe_dhcp_options()</code></a>";}}}i:30;a:8:{s:4:"name";s:12:"create_image";s:8:"modifier";s:6:"public";s:11:"description";s:303:"<p>Creates an Amazon EBS-backed AMI from a &#8220;running&#8221; or &#8220;stopped&#8221; instance. AMIs that use an
Amazon EBS root device boot faster than AMIs that use instance stores. They can be up to 1 TiB
in size, use storage that persists on instance failure, and can be stopped and started.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:65:"<p>The ID of the instance from which to create the new image.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"name";s:4:"type";s:6:"string";s:11:"description";s:46:"<p>The name for the new AMI being created.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2494:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - The description for the new AMI being created.</li><li><code>NoReboot</code> - <code>boolean</code> - Optional - By default this property is set to <code>false</code>, which means Amazon EC2 attempts to cleanly shut down the instance before image creation and reboots the instance afterwards. When set to true, Amazon EC2 will not shut down the instance before creating the image. When this option is used, file system integrity on the created image cannot be guaranteed.</li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - The BlockDeviceMappingItemType data type. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VirtualName</code> - <code>string</code> - Optional - Specifies the virtual device name.</li><li><code>DeviceName</code> - <code>string</code> - Optional - Specifies the device name (e.g., <code>/dev/sdh</code>).</li><li><code>Ebs</code> - <code>array</code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which the volume will be created.</li><li><code>VolumeSize</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>NoDevice</code> - <code>string</code> - Optional - Specifies the device name to suppress during instance launch.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:487:"public function create_image($instance_id, $name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    $opt['Name'] = $name;
    
    // Optional list + map
    if (isset($opt['BlockDeviceMapping']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']
        )));
        unset($opt['BlockDeviceMapping']);
    }

    return $this-&gt;authenticate('CreateImage', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:75:"<p>Create and register a new image from a running, EBS-backed instance.</p>";s:11:"description";s:67:"<p><strong>Note:</strong> This will not work on S3-backed AMIs.</p>";s:4:"code";s:159:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_image('i-1d549377', 'my-ebs-image');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:1;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:2;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:3;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:4;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}}i:31;a:5:{s:4:"name";s:27:"create_instance_export_task";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1271:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>TargetEnvironment</code> - <code>string</code> - Optional -  [Allowed values: <code>citrix</code>, <code>vmware</code>]</li><li><code>ExportToS3</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>DiskImageFormat</code> - <code>string</code> - Optional -  [Allowed values: <code>vmdk</code>, <code>vhd</code>]</li><li><code>ContainerFormat</code> - <code>string</code> - Optional -  [Allowed values: <code>ova</code>]</li><li><code>S3Bucket</code> - <code>string</code> - Optional - </li><li><code>S3Prefix</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:454:"public function create_instance_export_task($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    
    // Optional map (non-list)
    if (isset($opt['ExportToS3']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ExportToS3' =&gt; $opt['ExportToS3']
        )));
        unset($opt['ExportToS3']);
    }

    return $this-&gt;authenticate('CreateInstanceExportTask', $opt);
}";}i:32;a:8:{s:4:"name";s:23:"create_internet_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:270:"<p>Creates a new Internet gateway in your AWS account. After creating the Internet gateway, you
then attach it to a VPC using <code>AttachInternetGateway</code>. For more information about
your VPC and Internet gateway, go to Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:166:"public function create_internet_gateway($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('CreateInternetGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:47:"<p>Create a new internet gateway for a VPC.</p>";s:11:"description";s:941:"<p>Here is the flow:</p>

<ol>
<li>Create a new VPC with <a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a> and a CIDR block.</li>
<li>Create a new Route Table with <a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>.</li>
<li>Create a new Internet Gateway with <a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>.</li>
<li>Attach the Internet Gateway to the VPC with <a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>.</li>
<li>Create a new Route with <a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>.</li>
</ol>";s:4:"code";s:105:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_internet_gateway();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:153:"<a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/delete_internet_gateway.html" rel="../../index.html#m=amazonec2/delete_internet_gateway"><code>delete_internet_gateway()</code></a>";i:2;s:162:"<a href="../amazonec2/describe_internet_gateways.html" rel="../../index.html#m=amazonec2/describe_internet_gateways"><code>describe_internet_gateways()</code></a>";i:3;s:153:"<a href="../amazonec2/detach_internet_gateway.html" rel="../../index.html#m=amazonec2/detach_internet_gateway"><code>detach_internet_gateway()</code></a>";}}}i:33;a:8:{s:4:"name";s:15:"create_key_pair";s:8:"modifier";s:6:"public";s:11:"description";s:208:"<p>The CreateKeyPair operation creates a new 2048 bit RSA key pair and returns a unique ID that
can be used to reference this key pair when launching new instances. For more information, see
RunInstances.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"key_name";s:4:"type";s:6:"string";s:11:"description";s:44:"<p>The unique name for the new key pair.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function create_key_pair($key_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['KeyName'] = $key_name;
    
    return $this-&gt;authenticate('CreateKeyPair', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Create a new key pair.</p>";s:4:"code";s:267:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_key_pair('my-keypair');

if (isset($response-&gt;body-&gt;keyMaterial))
{
	file_put_contents($response-&gt;body-&gt;keyName . '.pem', (string) $response-&gt;body-&gt;keyMaterial);
}

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:129:"<a href="../amazonec2/delete_key_pair.html" rel="../../index.html#m=amazonec2/delete_key_pair"><code>delete_key_pair()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_key_pairs.html" rel="../../index.html#m=amazonec2/describe_key_pairs"><code>describe_key_pairs()</code></a>";i:2;s:129:"<a href="../amazonec2/import_key_pair.html" rel="../../index.html#m=amazonec2/import_key_pair"><code>import_key_pair()</code></a>";}}}i:34;a:8:{s:4:"name";s:18:"create_network_acl";s:8:"modifier";s:6:"public";s:11:"description";s:260:"<p>Creates a new network ACL in a VPC. Network ACLs provide an optional layer of security (on top
of security groups) for the instances in your VPC. For more information about network ACLs, go
to Network ACLs in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The ID of the VPC where the network ACL will be created.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function create_network_acl($vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('CreateNetworkAcl', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:54:"<p>Create a new Network Access Control List (ACL).</p>";s:4:"code";s:114:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_network_acl('vpc-7e7dfc17');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:1;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:2;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:4;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:35;a:8:{s:4:"name";s:24:"create_network_acl_entry";s:8:"modifier";s:6:"public";s:11:"description";s:899:"<p>Creates an entry (i.e., rule) in a network ACL with a rule number you specify. Each network ACL
has a set of numbered ingress rules and a separate set of numbered egress rules. When
determining whether a packet should be allowed in or out of a subnet associated with the ACL,
Amazon VPC processes the entries in the ACL according to the rule numbers, in ascending order.</p>

<p><strong>Important:</strong> We recommend that you leave room between the rules (e.g., 100, 110,
120, etc.), and not number them sequentially (101, 102, 103, etc.). This allows you to easily
add a new rule between existing ones without having to renumber the rules.</p>

<p>After you add an entry, you can&#8217;t modify it; you must either replace it, or create a new entry
and delete the old one.</p>

<p>For more information about network ACLs, go to Network ACLs in the Amazon Virtual Private Cloud
User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:7:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"network_acl_id";s:4:"type";s:6:"string";s:11:"description";s:53:"<p>ID of the ACL where the entry will be created.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"rule_number";s:4:"type";s:7:"integer";s:11:"description";s:115:"<p>Rule number to assign to the entry (e.g., 100). ACL entries are processed in ascending order by rule number.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"protocol";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>IP protocol the rule applies to. Valid Values: <code>tcp</code>, <code>udp</code>, <code>icmp</code> or an IP protocol number.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"rule_action";s:4:"type";s:6:"string";s:11:"description";s:118:"<p>Whether to allow or deny traffic that matches the rule. [Allowed values: <code>allow</code>, <code>deny</code>]</p>";}i:4;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"egress";s:4:"type";s:7:"boolean";s:11:"description";s:141:"<p>Whether this rule applies to egress traffic from the subnet (<code>true</code>) or ingress traffic to the subnet (<code>false</code>).</p>";}i:5;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"cidr_block";s:4:"type";s:6:"string";s:11:"description";s:92:"<p>The CIDR range to allow or deny, in CIDR notation (e.g., <code>172.16.0.0/24</code>).</p>";}i:6;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1673:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Icmp</code> - <code>array</code> - Optional - ICMP values. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Type</code> - <code>integer</code> - Optional - For the ICMP protocol, the ICMP type. A value of <code>-1</code> is a wildcard meaning all types. Required if specifying <code>icmp</code> for the protocol.</li><li><code>Code</code> - <code>integer</code> - Optional - For the ICMP protocol, the ICMP code. A value of <code>-1</code> is a wildcard meaning all codes. Required if specifying <code>icmp</code> for the protocol.</li></ul></li></ul></li><li><code>PortRange</code> - <code>array</code> - Optional - Port ranges. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>From</code> - <code>integer</code> - Optional - The first port in the range. Required if specifying <code>tcp</code> or <code>udp</code> for the protocol.</li><li><code>To</code> - <code>integer</code> - Optional - The last port in the range. Required if specifying <code>tcp</code> or <code>udp</code> for the protocol.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:908:"public function create_network_acl_entry($network_acl_id, $rule_number, $protocol, $rule_action, $egress, $cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkAclId'] = $network_acl_id;
    $opt['RuleNumber'] = $rule_number;
    $opt['Protocol'] = $protocol;
    $opt['RuleAction'] = $rule_action;
    $opt['Egress'] = $egress;
    $opt['CidrBlock'] = $cidr_block;
    
    // Optional map (non-list)
    if (isset($opt['Icmp']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Icmp' =&gt; $opt['Icmp']
        )));
        unset($opt['Icmp']);
    }
    
    // Optional map (non-list)
    if (isset($opt['PortRange']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PortRange' =&gt; $opt['PortRange']
        )));
        unset($opt['PortRange']);
    }

    return $this-&gt;authenticate('CreateNetworkAclEntry', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:67:"<p>Create a new entry in the Network Access Control List (ACL).</p>";s:4:"code";s:247:"$ec2 = new AmazonEC2();

$tcp = 6;
$response = $ec2-&gt;create_network_acl_entry('acl-4abf3f23', 1, $tcp, 'allow', 'true', '172.16.0.0/24', array(
	'PortRange' =&gt; array(
		'From' =&gt; 80,
		'To' =&gt; 80
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:2;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:4;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:36;a:6:{s:4:"name";s:24:"create_network_interface";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"subnet_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1235:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - </li><li><code>SecurityGroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>PrivateIpAddresses</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress</code> - <code>string</code> - Required - </li><li><code>Primary</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>SecondaryPrivateIpAddressCount</code> - <code>integer</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:802:"public function create_network_interface($subnet_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SubnetId'] = $subnet_id;
    
    // Optional list (non-map)
    if (isset($opt['SecurityGroupId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))
        )));
        unset($opt['SecurityGroupId']);
    }
    
    // Optional list + map
    if (isset($opt['PrivateIpAddresses']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PrivateIpAddresses' =&gt; $opt['PrivateIpAddresses']
        )));
        unset($opt['PrivateIpAddresses']);
    }

    return $this-&gt;authenticate('CreateNetworkInterface', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:38:"<p>Create a new network interface.</p>";s:4:"code";s:116:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_network_interface($subnet_id);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:37;a:8:{s:4:"name";s:22:"create_placement_group";s:8:"modifier";s:6:"public";s:11:"description";s:180:"<p>Creates a <code>PlacementGroup</code> into which multiple Amazon EC2 instances can be launched.
Users must give the group a name unique within the scope of the user account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"group_name";s:4:"type";s:6:"string";s:11:"description";s:51:"<p>The name of the <code>PlacementGroup</code>.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"strategy";s:4:"type";s:6:"string";s:11:"description";s:87:"<p>The <code>PlacementGroup</code> strategy. [Allowed values: <code>cluster</code>]</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:251:"public function create_placement_group($group_name, $strategy, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['GroupName'] = $group_name;
    $opt['Strategy'] = $strategy;
    
    return $this-&gt;authenticate('CreatePlacementGroup', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:52:"<p>Create a new cluster-compute placement group.</p>";s:4:"code";s:128:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_placement_group('php-cluster', 'cluster');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:150:"<a href="../amazonec2/delete_placement_group.html" rel="../../index.html#m=amazonec2/delete_placement_group"><code>delete_placement_group()</code></a>";i:1;s:159:"<a href="../amazonec2/describe_placement_groups.html" rel="../../index.html#m=amazonec2/describe_placement_groups"><code>describe_placement_groups()</code></a>";}}}i:38;a:5:{s:4:"name";s:33:"create_reserved_instances_listing";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:5:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:21:"reserved_instances_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"instance_count";s:4:"type";s:7:"integer";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"price_schedules";s:4:"type";s:5:"array";s:11:"description";s:307:"<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Term</code> - <code>long</code> - Optional - </li><li><code>Price</code> - <code>double</code> - Optional - </li><li><code>CurrencyCode</code> - <code>string</code> - Optional - </li></ul></li></ul>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:12:"client_token";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:4;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:592:"public function create_reserved_instances_listing($reserved_instances_id, $instance_count, $price_schedules, $client_token, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ReservedInstancesId'] = $reserved_instances_id;
    $opt['InstanceCount'] = $instance_count;
    $opt['ClientToken'] = $client_token;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'PriceSchedules' =&gt; (is_array($price_schedules) ? $price_schedules : array($price_schedules))
    )));

    return $this-&gt;authenticate('CreateReservedInstancesListing', $opt);
}";}i:39;a:8:{s:4:"name";s:12:"create_route";s:8:"modifier";s:6:"public";s:11:"description";s:924:"<p>Creates a new route in a route table within a VPC. The route&#8217;s target can be either a gateway
attached to the VPC or a NAT instance in the VPC.</p>

<p>When determining how to route traffic, we use the route with the most specific match. For
example, let&#8217;s say the traffic is destined for <code>192.0.2.3</code>, and the route table
includes the following two routes:</p>

<ul><li><code>192.0.2.0/24</code> (goes to some target A)</li><li><code>192.0.2.0/28</code> (goes to some target B)</li></ul>

<p>Both routes apply to the traffic destined for <code>192.0.2.3</code>. However, the second route
in the list is more specific, so we use that route to determine where to target the traffic.</p>

<p>For more information about route tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The ID of the route table where the route will be added.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:22:"destination_cidr_block";s:4:"type";s:6:"string";s:11:"description";s:154:"<p>The CIDR address block used for the destination match. For example: <code>0.0.0.0/0</code>. Routing decisions are based on the most specific match.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1002:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GatewayId</code> - <code>string</code> - Optional - The ID of a VPN or Internet gateway attached to your VPC. You must provide either <code>GatewayId</code> or <code>InstanceId</code>, but not both.</li><li><code>InstanceId</code> - <code>string</code> - Optional - The ID of a NAT instance in your VPC. You must provide either <code>GatewayId</code> or <code>InstanceId</code>, but not both.</li><li><code>NetworkInterfaceId</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:283:"public function create_route($route_table_id, $destination_cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    $opt['DestinationCidrBlock'] = $destination_cidr_block;
    
    return $this-&gt;authenticate('CreateRoute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:30:"<p>Create a new VPC route.</p>";s:11:"description";s:941:"<p>Here is the flow:</p>

<ol>
<li>Create a new VPC with <a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a> and a CIDR block.</li>
<li>Create a new Route Table with <a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>.</li>
<li>Create a new Internet Gateway with <a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>.</li>
<li>Attach the Internet Gateway to the VPC with <a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>.</li>
<li>Create a new Route with <a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>.</li>
</ol>";s:4:"code";s:165:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_route('rtb-e68b0b8f', '0.0.0.0/0', array(
	'GatewayId' =&gt; 'igw-8c8e0ee5'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:2;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:3;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:40;a:8:{s:4:"name";s:18:"create_route_table";s:8:"modifier";s:6:"public";s:11:"description";s:346:"<p>Creates a new route table within a VPC. After you create a new route table, you can add routes
and associate the table with a subnet. For more information about route tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The ID of the VPC where the route table will be created.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function create_route_table($vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('CreateRouteTable', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:36:"<p>Create a new VPC route table.</p>";s:11:"description";s:941:"<p>Here is the flow:</p>

<ol>
<li>Create a new VPC with <a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a> and a CIDR block.</li>
<li>Create a new Route Table with <a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>.</li>
<li>Create a new Internet Gateway with <a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>.</li>
<li>Attach the Internet Gateway to the VPC with <a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>.</li>
<li>Create a new Route with <a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>.</li>
</ol>";s:4:"code";s:114:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_route_table('vpc-7e7dfc17');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:3;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:41;a:8:{s:4:"name";s:21:"create_security_group";s:8:"modifier";s:6:"public";s:11:"description";s:574:"<p>The CreateSecurityGroup operation creates a new security group.</p>

<p>Every instance is launched in a security group. If no security group is specified during
launch, the instances are launched in the default security group. Instances within the same
security group have unrestricted network access to each other. Instances will reject network
access attempts from other instances in a different security group. As the owner of instances
you can grant or revoke specific permissions using the AuthorizeSecurityGroupIngress and
RevokeSecurityGroupIngress operations.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"group_name";s:4:"type";s:6:"string";s:11:"description";s:34:"<p>Name of the security group.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:17:"group_description";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>Description of the group. This is informational only.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:596:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VpcId</code> - <code>string</code> - Optional - ID of the VPC.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:275:"public function create_security_group($group_name, $group_description, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['GroupName'] = $group_name;
    $opt['GroupDescription'] = $group_description;
    
    return $this-&gt;authenticate('CreateSecurityGroup', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:3:{s:5:"title";s:35:"<p>Create a new security group.</p>";s:4:"code";s:153:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_security_group('my-security-group', 'This is a test description.');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:4:{s:5:"title";s:56:"<p>Security groups only support US-ASCII characters.</p>";s:11:"description";s:49:"<p>The example below will fail with an error.</p>";s:4:"code";s:237:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_security_group('my-security-group', '&aring;&eacute;&icirc;&oslash;&uuml;&iexcl;&trade;&pound;&cent;&infin;&sect;&para;&bull;&ordf;&ordm;&ndash;&ne;');

var_dump($response-&gt;isOK());";s:6:"result";s:11:"bool(false)";}i:2;a:3:{s:5:"title";s:45:"<p>Create a new security group for a VPC.</p>";s:4:"code";s:200:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_security_group('my-vpc-security-group', 'This is a test VPC description', array(
	'VpcId' =&gt; 'vpc-fd7cd194'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:2;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:3;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:4;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}}i:42;a:9:{s:4:"name";s:15:"create_snapshot";s:8:"modifier";s:6:"public";s:11:"description";s:559:"<p>Create a snapshot of the volume identified by volume ID. A volume does not have to be detached
at the time the snapshot is taken.</p>

<p class="note">
Snapshot creation requires that the system is in a consistent state. For instance, this means
that if taking a snapshot of a database, the tables must be read-only locked to ensure that the
snapshot will not contain a corrupted version of the database. Therefore, be careful when using
this API to ensure that the system remains in the consistent state until the create snapshot
status has returned.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";s:62:"<p>The ID of the volume from which to create the snapshot.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:625:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - The description for the new snapshot.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:190:"public function create_snapshot($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('CreateSnapshot', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:44:"<p>Create a snapshot from an EBS volume.</p>";s:4:"code";s:216:"// Instantiate the class
$ec2 = new AmazonEC2();

// Create the snapshot
$response = $ec2-&gt;create_snapshot('vol-fc482995', array(
	'Description' =&gt; 'my-snapshot'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:2;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:3;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:290:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/ApiReference-query-CreateSnapshot.html">CreateSnapshot</a> operation introduced backwards-incompatible changes in the <code>2011-02-28</code> API release. The <code>Description</code> parameter is no longer required.</p>";}}i:43;a:8:{s:4:"name";s:33:"create_spot_datafeed_subscription";s:8:"modifier";s:6:"public";s:11:"description";s:457:"<p>Creates the data feed for Spot Instances, enabling you to view Spot Instance usage logs. You
can create one data feed per account.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"bucket";s:4:"type";s:6:"string";s:11:"description";s:73:"<p>The Amazon S3 bucket in which to store the Spot Instance datafeed.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:630:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Prefix</code> - <code>string</code> - Optional - The prefix that is prepended to datafeed files.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:216:"public function create_spot_datafeed_subscription($bucket, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['Bucket'] = $bucket;
    
    return $this-&gt;authenticate('CreateSpotDatafeedSubscription', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:47:"<p>Create a new spot datafeed subscription.</p>";s:4:"code";s:170:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_spot_datafeed_subscription('my-spot-bucket', array(
	'Prefix' =&gt; 'spot_data_'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:2;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:3;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:44;a:8:{s:4:"name";s:13:"create_subnet";s:8:"modifier";s:6:"public";s:11:"description";s:962:"<p>Creates a subnet in an existing VPC. You can create up to 20 subnets in a VPC. If you add more
than one subnet to a VPC, they&#8217;re set up in a star topology with a logical router in the
middle. When you create each subnet, you provide the VPC ID and the CIDR block you want for the
subnet. Once you create a subnet, you can&#8217;t change its CIDR block. The subnet&#8217;s CIDR block can
be the same as the VPC&#8217;s CIDR block (assuming you want only a single subnet in the VPC), or a
subset of the VPC&#8217;s CIDR block. If you create more than one subnet in a VPC, the subnets&#8217; CIDR
blocks must not overlap. The smallest subnet (and VPC) you can create uses a <code>/28</code>
netmask (16 IP addresses), and the largest uses a <code>/18</code> netmask (16,384 IP
addresses).</p>

<p class="important"></p>

<p>AWS reserves both the first four and the last IP address in each subnet&#8217;s CIDR block. They&#8217;re
not available for use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:49:"<p>The ID of the VPC to create the subnet in.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"cidr_block";s:4:"type";s:6:"string";s:11:"description";s:45:"<p>The CIDR block the subnet is to cover.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:639:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The Availability Zone to create the subnet in.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:227:"public function create_subnet($vpc_id, $cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    $opt['CidrBlock'] = $cidr_block;
    
    return $this-&gt;authenticate('CreateSubnet', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:27:"<p>Create a new subnet.</p>";s:4:"code";s:174:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_subnet('vpc-fd7cd194', '10.0.0.0/24', array(
	'AvailabilityZone' =&gt; 'us-east-1b',
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:123:"<a href="../amazonec2/delete_subnet.html" rel="../../index.html#m=amazonec2/delete_subnet"><code>delete_subnet()</code></a>";i:1;s:132:"<a href="../amazonec2/describe_subnets.html" rel="../../index.html#m=amazonec2/describe_subnets"><code>describe_subnets()</code></a>";}}}i:45;a:8:{s:4:"name";s:11:"create_tags";s:8:"modifier";s:6:"public";s:11:"description";s:181:"<p>Adds or overwrites tags for the specified resources. Each resource can have a maximum of 10
tags. Each tag consists of a key-value pair. Tag keys must be unique per resource.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"resource_id";s:4:"type";s:12:"string|array";s:11:"description";s:196:"<p>One or more IDs of resources to tag. This could be the ID of an AMI, an instance, an EBS volume, or snapshot, etc. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:3:"tag";s:4:"type";s:5:"array";s:11:"description";s:390:"<p>The tags to add or overwrite for the specified resources. Each tag item consists of a key-value pair.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Key</code> - <code>string</code> - Optional - The tag&#8217;s key.</li><li><code>Value</code> - <code>string</code> - Optional - The tag&#8217;s value.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:502:"public function create_tags($resource_id, $tag, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'ResourceId' =&gt; (is_array($resource_id) ? $resource_id : array($resource_id))
    )));
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'Tag' =&gt; (is_array($tag) ? $tag : array($tag))
    )));

    return $this-&gt;authenticate('CreateTags', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:47:"<p>Create new tags for a given resource ID.</p>";s:4:"code";s:266:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_tags('aki-00006369', array(
	array('Key' =&gt; 'alpha', 'Value' =&gt; 'abc'),
	array('Key' =&gt; 'alpha', 'Value' =&gt; 'def'),
	array('Key' =&gt; 'beta', 'Value' =&gt; 'ghi'),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:117:"<a href="../amazonec2/delete_tags.html" rel="../../index.html#m=amazonec2/delete_tags"><code>delete_tags()</code></a>";i:1;s:123:"<a href="../amazonec2/describe_tags.html" rel="../../index.html#m=amazonec2/describe_tags"><code>describe_tags()</code></a>";}}}i:46;a:8:{s:4:"name";s:13:"create_volume";s:8:"modifier";s:6:"public";s:11:"description";s:51:"<p>Initializes an empty volume of a given size.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:17:"availability_zone";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The Availability Zone in which to create the new volume.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:994:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Size</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes. Required if you are not creating a volume from a snapshot.</li><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which to create the new volume.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:210:"public function create_volume($availability_zone, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['AvailabilityZone'] = $availability_zone;
    
    return $this-&gt;authenticate('CreateVolume', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:79:"<p>Create a new volume in the same availability zone as a running instance.</p>";s:4:"code";s:495:"// Instantiate the class
$ec2 = new AmazonEC2();

// Describe the running instance to get the Availability Zone
$describe = $ec2-&gt;describe_instances(array(
	'InstanceId' =&gt; 'i-1f549375'
));

// Grab the Availability Zone
$avail_zone = (string) $describe-&gt;body-&gt;availabilityZone(0); // First result of the built-in XPath search.

// Create the volume
$response = $ec2-&gt;create_volume($avail_zone, array(
	'Size' =&gt; 10 // Gibibytes
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:3;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:47;a:8:{s:4:"name";s:10:"create_vpc";s:8:"modifier";s:6:"public";s:11:"description";s:538:"<p>Creates a VPC with the CIDR block you specify. The smallest VPC you can create uses a
<code>/28</code> netmask (16 IP addresses), and the largest uses a <code>/18</code> netmask
(16,384 IP addresses). To help you decide how big to make your VPC, go to the topic about
creating VPCs in the Amazon Virtual Private Cloud Developer Guide.</p>

<p>By default, each instance you launch in the VPC has the default DHCP options (the standard EC2
host name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type).</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"cidr_block";s:4:"type";s:6:"string";s:11:"description";s:26:"<p>A valid CIDR block.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:797:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceTenancy</code> - <code>string</code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means instances must be launched with tenancy as dedicated.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:183:"public function create_vpc($cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['CidrBlock'] = $cidr_block;
    
    return $this-&gt;authenticate('CreateVpc', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:42:"<p>Create a new virtual private cloud.</p>";s:11:"description";s:941:"<p>Here is the flow:</p>

<ol>
<li>Create a new VPC with <a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a> and a CIDR block.</li>
<li>Create a new Route Table with <a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>.</li>
<li>Create a new Internet Gateway with <a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>.</li>
<li>Attach the Internet Gateway to the VPC with <a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>.</li>
<li>Create a new Route with <a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>.</li>
</ol>";s:4:"code";s:105:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_vpc('10.0.0.0/20');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:114:"<a href="../amazonec2/delete_vpc.html" rel="../../index.html#m=amazonec2/delete_vpc"><code>delete_vpc()</code></a>";i:1;s:123:"<a href="../amazonec2/describe_vpcs.html" rel="../../index.html#m=amazonec2/describe_vpcs"><code>describe_vpcs()</code></a>";}}}i:48;a:8:{s:4:"name";s:21:"create_vpn_connection";s:8:"modifier";s:6:"public";s:11:"description";s:1064:"<p>Creates a new VPN connection between an existing VPN gateway and customer gateway. The only
supported connection type is ipsec.1.</p>

<p>The response includes information that you need to configure your customer gateway, in XML
format. We recommend you use the command line version of this operation
(<code>ec2-create-vpn-connection</code>), which takes an <code>-f</code> option (for format)
and returns configuration information formatted as expected by the vendor you specified, or in
a generic, human readable format. For information about the command, go to
<code>ec2-create-vpn-connection</code> in the Amazon Virtual Private Cloud Command Line
Reference.</p>

<p class="important"></p>

<p>We strongly recommend you use HTTPS when calling this operation because the response contains
sensitive cryptographic information for configuring your customer gateway.</p>

<p>If you decide to shut down your VPN connection for any reason and then create a new one, you
must re-configure your customer gateway with the new information returned from this call.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"type";s:4:"type";s:6:"string";s:11:"description";s:34:"<p>The type of VPN connection.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"customer_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:38:"<p>The ID of the customer gateway.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"vpn_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:33:"<p>The ID of the VPN gateway.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:773:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Options</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>StaticRoutesOnly</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:548:"public function create_vpn_connection($type, $customer_gateway_id, $vpn_gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['Type'] = $type;
    $opt['CustomerGatewayId'] = $customer_gateway_id;
    $opt['VpnGatewayId'] = $vpn_gateway_id;
    
    // Optional map (non-list)
    if (isset($opt['Options']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Options' =&gt; $opt['Options']
        )));
        unset($opt['Options']);
    }

    return $this-&gt;authenticate('CreateVpnConnection', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:35:"<p>Create a new VPN connection.</p>";s:4:"code";s:144:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_vpn_connection('ipsec.1', 'cgw-10a84c79', 'vgw-9aa347f3');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:147:"<a href="../amazonec2/delete_vpn_connection.html" rel="../../index.html#m=amazonec2/delete_vpn_connection"><code>delete_vpn_connection()</code></a>";i:1;s:156:"<a href="../amazonec2/describe_vpn_connections.html" rel="../../index.html#m=amazonec2/describe_vpn_connections"><code>describe_vpn_connections()</code></a>";}}}i:49;a:5:{s:4:"name";s:27:"create_vpn_connection_route";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:17:"vpn_connection_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:22:"destination_cidr_block";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:320:"public function create_vpn_connection_route($vpn_connection_id, $destination_cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnConnectionId'] = $vpn_connection_id;
    $opt['DestinationCidrBlock'] = $destination_cidr_block;
    
    return $this-&gt;authenticate('CreateVpnConnectionRoute', $opt);
}";}i:50;a:8:{s:4:"name";s:18:"create_vpn_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:158:"<p>Creates a new VPN gateway. A VPN gateway is the VPC-side endpoint for your VPN connection. You
can create a VPN gateway before creating the VPC itself.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:4:"type";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>The type of VPN connection this VPN gateway supports.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:650:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The Availability Zone in which to create the VPN gateway.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:181:"public function create_vpn_gateway($type, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['Type'] = $type;
    
    return $this-&gt;authenticate('CreateVpnGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:32:"<p>Create a new VPN gateway.</p>";s:4:"code";s:159:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;create_vpn_gateway('ipsec.1', array(
	'AvailabilityZone' =&gt; 'us-east-1b',
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:138:"<a href="../amazonec2/attach_vpn_gateway.html" rel="../../index.html#m=amazonec2/attach_vpn_gateway"><code>attach_vpn_gateway()</code></a>";i:1;s:138:"<a href="../amazonec2/delete_vpn_gateway.html" rel="../../index.html#m=amazonec2/delete_vpn_gateway"><code>delete_vpn_gateway()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_vpn_gateways.html" rel="../../index.html#m=amazonec2/describe_vpn_gateways"><code>describe_vpn_gateways()</code></a>";i:3;s:138:"<a href="../amazonec2/detach_vpn_gateway.html" rel="../../index.html#m=amazonec2/detach_vpn_gateway"><code>detach_vpn_gateway()</code></a>";}}}i:51;a:8:{s:4:"name";s:18:"deactivate_license";s:8:"modifier";s:6:"public";s:11:"description";s:161:"<p>Deactivates a specific number of licenses. Deactivations can be done against a specific license
ID after they have persisted for at least a 90-day period.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"license_id";s:4:"type";s:6:"string";s:11:"description";s:71:"<p>Specifies the ID for the specific license to deactivate against.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"capacity";s:4:"type";s:7:"integer";s:11:"description";s:74:"<p>Specifies the amount of capacity to deactivate against the license.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:244:"public function deactivate_license($license_id, $capacity, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['LicenseId'] = $license_id;
    $opt['Capacity'] = $capacity;
    
    return $this-&gt;authenticate('DeactivateLicense', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:50:"<p>Deactivate a Microsoft® Windows® license.</p>";s:4:"code";s:117:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;deactivate_license('lic-1234abcd', 1);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:132:"<a href="../amazonec2/activate_license.html" rel="../../index.html#m=amazonec2/activate_license"><code>activate_license()</code></a>";i:1;s:129:"<a href="../amazonec2/bundle_instance.html" rel="../../index.html#m=amazonec2/bundle_instance"><code>bundle_instance()</code></a>";i:2;s:138:"<a href="../amazonec2/cancel_bundle_task.html" rel="../../index.html#m=amazonec2/cancel_bundle_task"><code>cancel_bundle_task()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_bundle_tasks.html" rel="../../index.html#m=amazonec2/describe_bundle_tasks"><code>describe_bundle_tasks()</code></a>";i:4;s:135:"<a href="../amazonec2/get_password_data.html" rel="../../index.html#m=amazonec2/get_password_data"><code>get_password_data()</code></a>";}}}i:52;a:7:{s:4:"name";s:12:"delete_cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:169:"<p>Deletes a cached <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object using the specified cache storage type.</p>";s:11:"returnvalue";s:118:"<p>A value of <code>true</code> if cached object exists and is successfully deleted, otherwise <code>false</code>.</p>";s:6:"source";s:125:"public function delete_cache()
{
    $this-&gt;use_cache_flow = true;
    $this-&gt;delete_cache = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:4:{s:5:"title";s:41:"<p>Delete a cached response from APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:169:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:11:"bool(false)";}i:1;a:4:{s:5:"title";s:53:"<p>Delete a cached response from the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:173:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}i:2;a:4:{s:5:"title";s:46:"<p>Delete a cached response from Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:205:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}}}}i:53;a:8:{s:4:"name";s:23:"delete_customer_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:352:"<p>Deletes a customer gateway. You must delete the VPN connection before deleting the customer
gateway.</p>

<p>You can have a single active customer gateway per AWS account (active means that you&#8217;ve created
a VPN connection with that customer gateway). AWS might delete any customer gateway you leave
inactive for an extended period of time.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"customer_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:48:"<p>The ID of the customer gateway to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:234:"public function delete_customer_gateway($customer_gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['CustomerGatewayId'] = $customer_gateway_id;
    
    return $this-&gt;authenticate('DeleteCustomerGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:33:"<p>Delete a customer gateway.</p>";s:4:"code";s:187:"// Instantiate the class
$ec2 = new AmazonEC2();

// Delete the customer gateway
$response = $ec2-&gt;delete_customer_gateway('cgw-10a84c79');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:153:"<a href="../amazonec2/create_customer_gateway.html" rel="../../index.html#m=amazonec2/create_customer_gateway"><code>create_customer_gateway()</code></a>";i:1;s:162:"<a href="../amazonec2/describe_customer_gateways.html" rel="../../index.html#m=amazonec2/describe_customer_gateways"><code>describe_customer_gateways()</code></a>";}}}i:54;a:8:{s:4:"name";s:19:"delete_dhcp_options";s:8:"modifier";s:6:"public";s:11:"description";s:272:"<p>Deletes a set of DHCP options that you specify. Amazon VPC returns an error if the set of
options you specify is currently associated with a VPC. You can disassociate the set of options
by associating either a new set of options or the default options with the VPC.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"dhcp_options_id";s:4:"type";s:6:"string";s:11:"description";s:48:"<p>The ID of the DHCP options set to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:214:"public function delete_dhcp_options($dhcp_options_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['DhcpOptionsId'] = $dhcp_options_id;
    
    return $this-&gt;authenticate('DeleteDhcpOptions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:36:"<p>Delete a set of DHCP options.</p>";s:4:"code";s:204:"$ec2 = new AmazonEC2();

$response1 = $ec2-&gt;associate_dhcp_options('default', 'vpc-abcd1234');

sleep(10);

$response2 = $ec2-&gt;delete_dhcp_options('dopt-427bd62b');

var_dump($response2-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:150:"<a href="../amazonec2/associate_dhcp_options.html" rel="../../index.html#m=amazonec2/associate_dhcp_options"><code>associate_dhcp_options()</code></a>";i:1;s:141:"<a href="../amazonec2/create_dhcp_options.html" rel="../../index.html#m=amazonec2/create_dhcp_options"><code>create_dhcp_options()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_dhcp_options.html" rel="../../index.html#m=amazonec2/describe_dhcp_options"><code>describe_dhcp_options()</code></a>";}}}i:55;a:8:{s:4:"name";s:23:"delete_internet_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:205:"<p>Deletes an Internet gateway from your AWS account. The gateway must not be attached to a VPC.
For more information about your VPC and Internet gateway, go to Amazon Virtual Private Cloud
User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"internet_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:52:"<p>The ID of the Internet gateway to be deleted.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:234:"public function delete_internet_gateway($internet_gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InternetGatewayId'] = $internet_gateway_id;
    
    return $this-&gt;authenticate('DeleteInternetGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:34:"<p>Delete an internet gateway.</p>";s:4:"code";s:119:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_internet_gateway('igw-be7cfdd7');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:153:"<a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>";i:2;s:162:"<a href="../amazonec2/describe_internet_gateways.html" rel="../../index.html#m=amazonec2/describe_internet_gateways"><code>describe_internet_gateways()</code></a>";i:3;s:153:"<a href="../amazonec2/detach_internet_gateway.html" rel="../../index.html#m=amazonec2/detach_internet_gateway"><code>detach_internet_gateway()</code></a>";}}}i:56;a:8:{s:4:"name";s:15:"delete_key_pair";s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>The DeleteKeyPair operation deletes a key pair.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"key_name";s:4:"type";s:6:"string";s:11:"description";s:53:"<p>The name of the Amazon EC2 key pair to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function delete_key_pair($key_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['KeyName'] = $key_name;
    
    return $this-&gt;authenticate('DeleteKeyPair', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:25:"<p>Delete a key pair.</p>";s:4:"code";s:109:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_key_pair('my-keypair');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:129:"<a href="../amazonec2/create_key_pair.html" rel="../../index.html#m=amazonec2/create_key_pair"><code>create_key_pair()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_key_pairs.html" rel="../../index.html#m=amazonec2/describe_key_pairs"><code>describe_key_pairs()</code></a>";i:2;s:129:"<a href="../amazonec2/import_key_pair.html" rel="../../index.html#m=amazonec2/import_key_pair"><code>import_key_pair()</code></a>";}}}i:57;a:8:{s:4:"name";s:18:"delete_network_acl";s:8:"modifier";s:6:"public";s:11:"description";s:250:"<p>Deletes a network ACL from a VPC. The ACL must not have any subnets associated with it. You
can&#8217;t delete the default network ACL. For more information about network ACLs, go to Network
ACLs in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"network_acl_id";s:4:"type";s:6:"string";s:11:"description";s:47:"<p>The ID of the network ACL to be deleted.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function delete_network_acl($network_acl_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkAclId'] = $network_acl_id;
    
    return $this-&gt;authenticate('DeleteNetworkAcl', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:50:"<p>Delete a Network Access Control List (ACL).</p>";s:4:"code";s:114:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_network_acl('acl-4abf3f23');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:2;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:4;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:58;a:8:{s:4:"name";s:24:"delete_network_acl_entry";s:8:"modifier";s:6:"public";s:11:"description";s:182:"<p>Deletes an ingress or egress entry (i.e., rule) from a network ACL. For more information about
network ACLs, go to Network ACLs in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"network_acl_id";s:4:"type";s:6:"string";s:11:"description";s:29:"<p>ID of the network ACL.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"rule_number";s:4:"type";s:7:"integer";s:11:"description";s:43:"<p>Rule number for the entry to delete.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"egress";s:4:"type";s:7:"boolean";s:11:"description";s:109:"<p>Whether the rule to delete is an egress rule (<code>true</code>) or ingress rule (<code>false</code>).</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:312:"public function delete_network_acl_entry($network_acl_id, $rule_number, $egress, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkAclId'] = $network_acl_id;
    $opt['RuleNumber'] = $rule_number;
    $opt['Egress'] = $egress;
    
    return $this-&gt;authenticate('DeleteNetworkAclEntry', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:64:"<p>Delete an entry in the Network Access Control List (ACL).</p>";s:4:"code";s:131:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_network_acl_entry('acl-4abf3f23', 1, 'true');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:4;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:59;a:6:{s:4:"name";s:24:"delete_network_interface";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:239:"public function delete_network_interface($network_interface_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    return $this-&gt;authenticate('DeleteNetworkInterface', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:38:"<p>Create a new network interface.</p>";s:4:"code";s:127:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_network_interface($network_interface_id);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:60;a:8:{s:4:"name";s:22:"delete_placement_group";s:8:"modifier";s:6:"public";s:11:"description";s:148:"<p>Deletes a <code>PlacementGroup</code> from a user&#8217;s account. Terminate all Amazon EC2 instances
in the placement group before deletion.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"group_name";s:4:"type";s:6:"string";s:11:"description";s:61:"<p>The name of the <code>PlacementGroup</code> to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:206:"public function delete_placement_group($group_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['GroupName'] = $group_name;
    
    return $this-&gt;authenticate('DeletePlacementGroup', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:48:"<p>Delete a cluster-compute placement group.</p>";s:4:"code";s:117:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_placement_group('php-cluster');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:150:"<a href="../amazonec2/create_placement_group.html" rel="../../index.html#m=amazonec2/create_placement_group"><code>create_placement_group()</code></a>";i:1;s:159:"<a href="../amazonec2/describe_placement_groups.html" rel="../../index.html#m=amazonec2/describe_placement_groups"><code>describe_placement_groups()</code></a>";}}}i:61;a:8:{s:4:"name";s:12:"delete_route";s:8:"modifier";s:6:"public";s:11:"description";s:257:"<p>Deletes a route from a route table in a VPC. For more information about route tables, go to
<a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:65:"<p>The ID of the route table where the route will be deleted.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:22:"destination_cidr_block";s:4:"type";s:6:"string";s:11:"description";s:139:"<p>The CIDR range for the route you want to delete. The value you specify must exactly match the CIDR for the route you want to delete.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:283:"public function delete_route($route_table_id, $destination_cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    $opt['DestinationCidrBlock'] = $destination_cidr_block;
    
    return $this-&gt;authenticate('DeleteRoute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:26:"<p>Delete a VPC route.</p>";s:4:"code";s:121:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_route('rtb-e68b0b8f', '0.0.0.0/0');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:62;a:8:{s:4:"name";s:18:"delete_route_table";s:8:"modifier";s:6:"public";s:11:"description";s:345:"<p>Deletes a route table from a VPC. The route table must not be associated with a subnet. You
can&#8217;t delete the main route table. For more information about route tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:47:"<p>The ID of the route table to be deleted.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function delete_route_table($route_table_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    
    return $this-&gt;authenticate('DeleteRouteTable', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:32:"<p>Delete a VPC route table.</p>";s:4:"code";s:114:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_route_table('rtb-e68b0b8f');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:63;a:8:{s:4:"name";s:21:"delete_security_group";s:8:"modifier";s:6:"public";s:11:"description";s:455:"<p>The DeleteSecurityGroup operation deletes a security group.</p>

<p class="note"></p>

<p>If you attempt to delete a security group that contains instances, a fault is returned.</p>

<p>If you attempt to delete a security group that is referenced by another security group, a fault
is returned. For example, if security group B has a rule that allows access from security group
A, security group A cannot be deleted until the allow rule is removed.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:753:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GroupName</code> - <code>string</code> - Optional - The name of the Amazon EC2 security group to delete.</li><li><code>GroupId</code> - <code>string</code> - Optional - The ID of the Amazon EC2 security group to delete.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:162:"public function delete_security_group($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('DeleteSecurityGroup', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:31:"<p>Delete a security group.</p>";s:4:"code";s:147:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_security_group(array('GroupName' =&gt; 'my-security-group'));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:2;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:3;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:4;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}}i:64;a:8:{s:4:"name";s:15:"delete_snapshot";s:8:"modifier";s:6:"public";s:11:"description";s:66:"<p>Deletes the snapshot identified by <code>snapshotId</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"snapshot_id";s:4:"type";s:6:"string";s:11:"description";s:40:"<p>The ID of the snapshot to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:196:"public function delete_snapshot($snapshot_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SnapshotId'] = $snapshot_id;
    
    return $this-&gt;authenticate('DeleteSnapshot', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:25:"<p>Delete a snapshot.</p>";s:4:"code";s:149:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_snapshot('snap-a99b8bc1');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:65;a:8:{s:4:"name";s:33:"delete_spot_datafeed_subscription";s:8:"modifier";s:6:"public";s:11:"description";s:368:"<p>Deletes the data feed for Spot Instances.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:185:"public function delete_spot_datafeed_subscription($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('DeleteSpotDatafeedSubscription', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Delete a spot datafeed subscription.</p>";s:4:"code";s:115:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_spot_datafeed_subscription();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:2;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:3;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:66;a:8:{s:4:"name";s:13:"delete_subnet";s:8:"modifier";s:6:"public";s:11:"description";s:149:"<p>Deletes a subnet from a VPC. You must terminate all running instances in the subnet before
deleting it, otherwise Amazon VPC returns an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"subnet_id";s:4:"type";s:6:"string";s:11:"description";s:47:"<p>The ID of the subnet you want to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function delete_subnet($subnet_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SubnetId'] = $subnet_id;
    
    return $this-&gt;authenticate('DeleteSubnet', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:23:"<p>Delete a subnet.</p>";s:4:"code";s:124:"$ec2 = new AmazonEC2();

$response = $response = $ec2-&gt;delete_subnet('subnet-2d78d544');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:123:"<a href="../amazonec2/create_subnet.html" rel="../../index.html#m=amazonec2/create_subnet"><code>create_subnet()</code></a>";i:1;s:132:"<a href="../amazonec2/describe_subnets.html" rel="../../index.html#m=amazonec2/describe_subnets"><code>describe_subnets()</code></a>";}}}i:67;a:8:{s:4:"name";s:11:"delete_tags";s:8:"modifier";s:6:"public";s:11:"description";s:60:"<p>Deletes tags from the specified Amazon EC2 resources.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"resource_id";s:4:"type";s:12:"string|array";s:11:"description";s:195:"<p>A list of one or more resource IDs. This could be the ID of an AMI, an instance, an EBS volume, or snapshot, etc. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1034:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Tag</code> - <code>array</code> - Optional - The tags to delete from the specified resources. Each tag item consists of a key-value pair. If a tag is specified without a value, the tag and all of its values are deleted. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Key</code> - <code>string</code> - Optional - The tag&#8217;s key.</li><li><code>Value</code> - <code>string</code> - Optional - The tag&#8217;s value.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:546:"public function delete_tags($resource_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'ResourceId' =&gt; (is_array($resource_id) ? $resource_id : array($resource_id))
    )));

    // Optional list + map
    if (isset($opt['Tag']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Tag' =&gt; $opt['Tag']
        )));
        unset($opt['Tag']);
    }

    return $this-&gt;authenticate('DeleteTags', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:20:"<p>Delete a tag.</p>";s:4:"code";s:292:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_tags('aki-00006369', array(
	'Tag' =&gt; array(
		array('Key' =&gt; 'alpha', 'Value' =&gt; 'abc'),
		array('Key' =&gt; 'alpha', 'Value' =&gt; 'def'),
		array('Key' =&gt; 'beta', 'Value' =&gt; 'ghi'),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:117:"<a href="../amazonec2/create_tags.html" rel="../../index.html#m=amazonec2/create_tags"><code>create_tags()</code></a>";i:1;s:123:"<a href="../amazonec2/describe_tags.html" rel="../../index.html#m=amazonec2/describe_tags"><code>describe_tags()</code></a>";}}}i:68;a:8:{s:4:"name";s:13:"delete_volume";s:8:"modifier";s:6:"public";s:11:"description";s:118:"<p>Deletes a previously created volume. Once successfully deleted, a new volume can be created
with the same name.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>The ID of the EBS volume to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function delete_volume($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('DeleteVolume', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:28:"<p>Delete an EBS volume.</p>";s:4:"code";s:167:"// Instantiate the class
$ec2 = new AmazonEC2();

// Delete the volume
$response = $ec2-&gt;delete_volume('vol-fc482995');

// Success?
var_dump($response-&gt;isOK());";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:69;a:8:{s:4:"name";s:10:"delete_vpc";s:8:"modifier";s:6:"public";s:11:"description";s:277:"<p>Deletes a VPC. You must detach or delete all gateways or other objects that are dependent on
the VPC first. For example, you must terminate all running instances, delete all VPC security
groups (except the default), delete all the route tables (except the default), etc.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:44:"<p>The ID of the VPC you want to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:171:"public function delete_vpc($vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('DeleteVpc', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:20:"<p>Delete a VPC.</p>";s:4:"code";s:161:"// Instantiate the class
$ec2 = new AmazonEC2();

// Delete the VPC
$response = $ec2-&gt;delete_vpc('vpc-abcd1234');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:114:"<a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a>";i:1;s:123:"<a href="../amazonec2/describe_vpcs.html" rel="../../index.html#m=amazonec2/describe_vpcs"><code>describe_vpcs()</code></a>";}}}i:70;a:8:{s:4:"name";s:21:"delete_vpn_connection";s:8:"modifier";s:6:"public";s:11:"description";s:710:"<p>Deletes a VPN connection. Use this if you want to delete a VPC and all its associated
components. Another reason to use this operation is if you believe the tunnel credentials for
your VPN connection have been compromised. In that situation, you can delete the VPN connection
and create a new one that has new keys, without needing to delete the VPC or VPN gateway. If
you create a new VPN connection, you must reconfigure the customer gateway using the new
configuration information returned with the new VPN connection ID.</p>

<p>If you&#8217;re deleting the VPC and all its associated parts, we recommend you detach the VPN
gateway from the VPC and delete the VPC before deleting the VPN connection.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:17:"vpn_connection_id";s:4:"type";s:6:"string";s:11:"description";s:45:"<p>The ID of the VPN connection to delete</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:224:"public function delete_vpn_connection($vpn_connection_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnConnectionId'] = $vpn_connection_id;
    
    return $this-&gt;authenticate('DeleteVpnConnection', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:31:"<p>Delete a VPN connection.</p>";s:4:"code";s:117:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;delete_vpn_connection('vpn-44a8938f');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:147:"<a href="../amazonec2/create_vpn_connection.html" rel="../../index.html#m=amazonec2/create_vpn_connection"><code>create_vpn_connection()</code></a>";i:1;s:156:"<a href="../amazonec2/describe_vpn_connections.html" rel="../../index.html#m=amazonec2/describe_vpn_connections"><code>describe_vpn_connections()</code></a>";}}}i:71;a:5:{s:4:"name";s:27:"delete_vpn_connection_route";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:17:"vpn_connection_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:22:"destination_cidr_block";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:320:"public function delete_vpn_connection_route($vpn_connection_id, $destination_cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnConnectionId'] = $vpn_connection_id;
    $opt['DestinationCidrBlock'] = $destination_cidr_block;
    
    return $this-&gt;authenticate('DeleteVpnConnectionRoute', $opt);
}";}i:72;a:8:{s:4:"name";s:18:"delete_vpn_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:395:"<p>Deletes a VPN gateway. Use this when you want to delete a VPC and all its associated components
because you no longer need them. We recommend that before you delete a VPN gateway, you detach
it from the VPC and delete the VPN connection. Note that you don&#8217;t need to delete the VPN
gateway if you just want to delete and re-create the VPN connection between your VPC and data
center.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"vpn_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:43:"<p>The ID of the VPN gateway to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function delete_vpn_gateway($vpn_gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnGatewayId'] = $vpn_gateway_id;
    
    return $this-&gt;authenticate('DeleteVpnGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:28:"<p>Delete a VPN gateway.</p>";s:4:"code";s:177:"// Instantiate the class
$ec2 = new AmazonEC2();

// Delete the VPN gateway
$response = $ec2-&gt;delete_vpn_gateway('vgw-42ad482b');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:138:"<a href="../amazonec2/attach_vpn_gateway.html" rel="../../index.html#m=amazonec2/attach_vpn_gateway"><code>attach_vpn_gateway()</code></a>";i:1;s:138:"<a href="../amazonec2/create_vpn_gateway.html" rel="../../index.html#m=amazonec2/create_vpn_gateway"><code>create_vpn_gateway()</code></a>";i:2;s:147:"<a href="../amazonec2/describe_vpn_gateways.html" rel="../../index.html#m=amazonec2/describe_vpn_gateways"><code>describe_vpn_gateways()</code></a>";i:3;s:138:"<a href="../amazonec2/detach_vpn_gateway.html" rel="../../index.html#m=amazonec2/detach_vpn_gateway"><code>detach_vpn_gateway()</code></a>";}}}i:73;a:8:{s:4:"name";s:16:"deregister_image";s:8:"modifier";s:6:"public";s:11:"description";s:123:"<p>The DeregisterImage operation deregisters an AMI. Once deregistered, instances of the AMI can
no longer be launched.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"image_id";s:4:"type";s:6:"string";s:11:"description";s:39:"<p>The ID of the AMI to deregister.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:189:"public function deregister_image($image_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ImageId'] = $image_id;
    
    return $this-&gt;authenticate('DeregisterImage', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:27:"<p>Deregister an image.</p>";s:4:"code";s:173:"// Instantiate the class
$ec2 = new AmazonEC2();

// Deregister the image
$response = $ec2-&gt;deregister_image('ami-42ad462b');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:2;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:3;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:4;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}}i:74;a:5:{s:4:"name";s:27:"describe_account_attributes";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:671:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AttributeName</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:489:"public function describe_account_attributes($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['AttributeName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'AttributeName' =&gt; (is_array($opt['AttributeName']) ? $opt['AttributeName'] : array($opt['AttributeName']))
        )));
        unset($opt['AttributeName']);
    }

    return $this-&gt;authenticate('DescribeAccountAttributes', $opt);
}";}i:75;a:8:{s:4:"name";s:18:"describe_addresses";s:8:"modifier";s:6:"public";s:11:"description";s:91:"<p>The DescribeAddresses operation lists elastic IP addresses assigned to your account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1572:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PublicIp</code> - <code>string|array</code> - Optional - The optional list of Elastic IP addresses to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Addresses. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>AllocationId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:975:"public function describe_addresses($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['PublicIp']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PublicIp' =&gt; (is_array($opt['PublicIp']) ? $opt['PublicIp'] : array($opt['PublicIp']))
        )));
        unset($opt['PublicIp']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }
    
    // Optional list (non-map)
    if (isset($opt['AllocationId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'AllocationId' =&gt; (is_array($opt['AllocationId']) ? $opt['AllocationId'] : array($opt['AllocationId']))
        )));
        unset($opt['AllocationId']);
    }

    return $this-&gt;authenticate('DescribeAddresses', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:3:{s:5:"title";s:33:"<p>Describe all IP addresses.</p>";s:4:"code";s:100:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_addresses();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:49:"<p>Describe a specific group of IP addresses.</p>";s:4:"code";s:467:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_addresses();
$ip_addresses = array();

// Collect existing IP addresses to describe
if ($response-&gt;body-&gt;addressesSet-&gt;item)
{
	foreach ($response-&gt;body-&gt;addressesSet-&gt;item as $item)
	{
		$ip_addresses[] = (string) $item-&gt;publicIp;
	}
}

// Describe the group of IP addresses
$response = $ec2-&gt;describe_addresses(array(
	'PublicIp' =&gt; $ip_addresses
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:27:"<p>Filter IP addresses.</p>";s:4:"code";s:168:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_addresses(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'public-ip')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:132:"<a href="../amazonec2/allocate_address.html" rel="../../index.html#m=amazonec2/allocate_address"><code>allocate_address()</code></a>";i:1;s:135:"<a href="../amazonec2/associate_address.html" rel="../../index.html#m=amazonec2/associate_address"><code>associate_address()</code></a>";i:2;s:144:"<a href="../amazonec2/disassociate_address.html" rel="../../index.html#m=amazonec2/disassociate_address"><code>disassociate_address()</code></a>";i:3;s:129:"<a href="../amazonec2/release_address.html" rel="../../index.html#m=amazonec2/release_address"><code>release_address()</code></a>";}}}i:76;a:8:{s:4:"name";s:27:"describe_availability_zones";s:8:"modifier";s:6:"public";s:11:"description";s:388:"<p>The DescribeAvailabilityZones operation describes availability zones that are currently
available to the account and their states.</p>

<p>Availability zones are not the same across accounts. The availability zone
<code>us-east-1a</code> for account A is not necessarily the same as <code>us-east-1a</code>
for account B. Zone assignments are mapped independently for each account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1425:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ZoneName</code> - <code>string|array</code> - Optional - A list of the availability zone names to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for AvailabilityZones. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:679:"public function describe_availability_zones($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ZoneName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ZoneName' =&gt; (is_array($opt['ZoneName']) ? $opt['ZoneName'] : array($opt['ZoneName']))
        )));
        unset($opt['ZoneName']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeAvailabilityZones', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{i:0;a:3:{s:5:"title";s:39:"<p>Describe all availability zones.</p>";s:4:"code";s:109:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_availability_zones();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:43:"<p>Describe a single availability zone.</p>";s:4:"code";s:148:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_availability_zones(array(
	'ZoneName' =&gt; 'us-east-1a'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:44:"<p>Describe multiple availability zones.</p>";s:4:"code";s:192:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_availability_zones(array(
	'ZoneName' =&gt; array(
		'us-east-1a',
		'us-east-1b',
		'us-east-1c'
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:3;a:3:{s:5:"title";s:33:"<p>Filter availability zones.</p>";s:4:"code";s:200:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_availability_zones(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";s:132:"<a href="../amazonec2/describe_regions.html" rel="../../index.html#m=amazonec2/describe_regions"><code>describe_regions()</code></a>";}}i:77;a:8:{s:4:"name";s:21:"describe_bundle_tasks";s:8:"modifier";s:6:"public";s:11:"description";s:229:"<p>The DescribeBundleTasks operation describes in-progress and recent bundle tasks. Complete and
failed tasks are removed from the list a short time after completion. If no bundle ids are
given, all bundle tasks are returned.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1409:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>BundleId</code> - <code>string|array</code> - Optional - The list of bundle task IDs to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for BundleTasks. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:667:"public function describe_bundle_tasks($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['BundleId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'BundleId' =&gt; (is_array($opt['BundleId']) ? $opt['BundleId'] : array($opt['BundleId']))
        )));
        unset($opt['BundleId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeBundleTasks', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:41:"<p>Describe the current bundle tasks.</p>";s:4:"code";s:103:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_bundle_tasks();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:27:"<p>Filter bundle tasks.</p>";s:4:"code";s:194:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_bundle_tasks(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'completed')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:132:"<a href="../amazonec2/activate_license.html" rel="../../index.html#m=amazonec2/activate_license"><code>activate_license()</code></a>";i:1;s:129:"<a href="../amazonec2/bundle_instance.html" rel="../../index.html#m=amazonec2/bundle_instance"><code>bundle_instance()</code></a>";i:2;s:138:"<a href="../amazonec2/cancel_bundle_task.html" rel="../../index.html#m=amazonec2/cancel_bundle_task"><code>cancel_bundle_task()</code></a>";i:3;s:138:"<a href="../amazonec2/deactivate_license.html" rel="../../index.html#m=amazonec2/deactivate_license"><code>deactivate_license()</code></a>";i:4;s:135:"<a href="../amazonec2/get_password_data.html" rel="../../index.html#m=amazonec2/get_password_data"><code>get_password_data()</code></a>";}}}i:78;a:5:{s:4:"name";s:25:"describe_conversion_tasks";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1660:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Filter</code> - <code>array</code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*</code> specifies that zero or more characters must match, and <code>?</code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\*amazon\?\\</code> specifies the literal string <code>*amazon?\</code>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>ConversionTaskId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:723:"public function describe_conversion_tasks($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }
    
    // Optional list (non-map)
    if (isset($opt['ConversionTaskId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ConversionTaskId' =&gt; (is_array($opt['ConversionTaskId']) ? $opt['ConversionTaskId'] : array($opt['ConversionTaskId']))
        )));
        unset($opt['ConversionTaskId']);
    }

    return $this-&gt;authenticate('DescribeConversionTasks', $opt);
}";}i:79;a:8:{s:4:"name";s:26:"describe_customer_gateways";s:8:"modifier";s:6:"public";s:11:"description";s:760:"<p>Gives you information about your customer gateways. You can filter the results to return
information only about customer gateways that match criteria you specify. For example, you
could ask to get information about a particular customer gateway (or all) only if the gateway&#8217;s
state is pending or available. You can specify multiple filters (e.g., the customer gateway has
a particular IP address for the Internet-routable external interface, and the gateway&#8217;s state
is pending or available). The result includes information for a particular customer gateway
only if the gateway matches all your filters. If there&#8217;s no match, no special message is
returned; the response is simply empty. The following table shows the available filters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1426:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>CustomerGatewayId</code> - <code>string|array</code> - Optional - A set of one or more customer gateway IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Customer Gateways. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:731:"public function describe_customer_gateways($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['CustomerGatewayId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'CustomerGatewayId' =&gt; (is_array($opt['CustomerGatewayId']) ? $opt['CustomerGatewayId'] : array($opt['CustomerGatewayId']))
        )));
        unset($opt['CustomerGatewayId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeCustomerGateways', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:42:"<p>Describe all VPC customer gateways.</p>";s:4:"code";s:108:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_customer_gateways();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:36:"<p>Filter customer VPC gateways.</p>";s:4:"code";s:256:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_customer_gateways(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available'),
		array('Name' =&gt; 'type', 'Value' =&gt; 'ipsec.1'),
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:153:"<a href="../amazonec2/create_customer_gateway.html" rel="../../index.html#m=amazonec2/create_customer_gateway"><code>create_customer_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/delete_customer_gateway.html" rel="../../index.html#m=amazonec2/delete_customer_gateway"><code>delete_customer_gateway()</code></a>";}}}i:80;a:8:{s:4:"name";s:21:"describe_dhcp_options";s:8:"modifier";s:6:"public";s:11:"description";s:274:"<p>Gives you information about one or more sets of DHCP options. You can specify one or more DHCP
options set IDs, or no IDs (to describe all your sets of DHCP options). The returned
information consists of:</p>

<ul><li>The DHCP options set ID</li><li>The options</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1374:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>DhcpOptionsId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for DhcpOptions. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:697:"public function describe_dhcp_options($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['DhcpOptionsId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'DhcpOptionsId' =&gt; (is_array($opt['DhcpOptionsId']) ? $opt['DhcpOptionsId'] : array($opt['DhcpOptionsId']))
        )));
        unset($opt['DhcpOptionsId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeDhcpOptions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:37:"<p>Describe all VPC DHCP options.</p>";s:4:"code";s:103:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_dhcp_options();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:64:"<p>Filter VPC DHCP options by tags matching multiple values.</p>";s:4:"code";s:206:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_dhcp_options(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'tag:Purpose', 'Value' =&gt; array('X', 'Y')),
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:150:"<a href="../amazonec2/associate_dhcp_options.html" rel="../../index.html#m=amazonec2/associate_dhcp_options"><code>associate_dhcp_options()</code></a>";i:1;s:141:"<a href="../amazonec2/create_dhcp_options.html" rel="../../index.html#m=amazonec2/create_dhcp_options"><code>create_dhcp_options()</code></a>";i:2;s:141:"<a href="../amazonec2/delete_dhcp_options.html" rel="../../index.html#m=amazonec2/delete_dhcp_options"><code>delete_dhcp_options()</code></a>";}}}i:81;a:6:{s:4:"name";s:21:"describe_export_tasks";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:670:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ExportTaskId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:471:"public function describe_export_tasks($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ExportTaskId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ExportTaskId' =&gt; (is_array($opt['ExportTaskId']) ? $opt['ExportTaskId'] : array($opt['ExportTaskId']))
        )));
        unset($opt['ExportTaskId']);
    }

    return $this-&gt;authenticate('DescribeExportTasks', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:34:"<p>EC2 - Describe Export Tasks</p>";s:4:"code";s:259:"// Dependencies
require_once dirname(__FILE__) . '/../../sdk.class.php';
require_once dirname(__FILE__) . '/../testutil.inc.php';

// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_export_tasks();

var_dump($response-&gt;isOK());";}}}i:82;a:8:{s:4:"name";s:24:"describe_image_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:139:"<p>The DescribeImageAttribute operation returns information about an attribute of an AMI. Only one
attribute can be specified per call.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"image_id";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>The ID of the AMI whose attribute is to be described.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:204:"<p>The name of the attribute to describe. Available attribute names: <code>productCodes</code>, <code>kernel</code>, <code>ramdisk</code>, <code>launchPermisson</code>, <code>blockDeviceMapping</code></p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:252:"public function describe_image_attribute($image_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ImageId'] = $image_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('DescribeImageAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:48:"<p>Describe the attributes of a given image.</p>";s:4:"code";s:136:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_image_attribute('ami-42ad462b', 'productCodes');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:2;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:3;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:4;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}}i:83;a:8:{s:4:"name";s:15:"describe_images";s:8:"modifier";s:6:"public";s:11:"description";s:1988:"<p>The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the
user. Information returned includes image type, product codes, architecture, and kernel and RAM
disk IDs. Images available to the user include public images available for any user to launch,
private images owned by the user making the request, and private images owned by other users
for which the user has explicit launch permissions.</p>

<p>Launch permissions fall into three categories:</p>

<ul><li><strong>Public:</strong> The owner of the AMI granted launch permissions for the AMI to the
all group. All users have launch permissions for these AMIs.</li><li><strong>Explicit:</strong> The owner of the AMI granted launch permissions to a specific
user.</li><li><strong>Implicit:</strong> A user has implicit launch permissions for all AMIs he or she
owns.</li></ul>

<p>The list of AMIs returned can be modified by specifying AMI IDs, AMI owners, or users with
launch permissions. If no options are specified, Amazon EC2 returns all AMIs for which the user
has launch permissions.</p>

<p>If you specify one or more AMI IDs, only AMIs that have the specified IDs are returned. If you
specify an invalid AMI ID, a fault is returned. If you specify an AMI ID for which you do not
have access, it will not be included in the returned results.</p>

<p>If you specify one or more AMI owners, only AMIs from the specified owners and for which you
have access are returned. The results can include the account IDs of the specified owners,
amazon for AMIs owned by Amazon or self for AMIs that you own.</p>

<p>If you specify a list of executable users, only users that have launch permissions for the AMIs
are returned. You can specify account IDs (if you own the AMI(s)), self for AMIs for which you
own or have explicit permissions, or all for public AMIs.</p>

<p class="note">
Deregistered images are included in the returned results for an unspecified interval after
deregistration.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2278:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ImageId</code> - <code>string|array</code> - Optional - An optional list of the AMI IDs to describe. If not specified, all AMIs will be described. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Owner</code> - <code>string|array</code> - Optional - The optional list of owners for the described AMIs. The IDs amazon, self, and explicit can be used to include AMIs owned by Amazon, AMIs owned by the user, and AMIs for which the user has explicit launch permissions, respectively. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>ExecutableBy</code> - <code>string|array</code> - Optional - The optional list of users with explicit launch permissions for the described AMIs. The user ID can be a user&#8217;s account ID, &#8216;self&#8217; to return AMIs for which the sender of the request has explicit launch permissions, or &#8216;all&#8217; to return AMIs with public launch permissions. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Images. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1234:"public function describe_images($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ImageId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ImageId' =&gt; (is_array($opt['ImageId']) ? $opt['ImageId'] : array($opt['ImageId']))
        )));
        unset($opt['ImageId']);
    }
    
    // Optional list (non-map)
    if (isset($opt['Owner']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Owner' =&gt; (is_array($opt['Owner']) ? $opt['Owner'] : array($opt['Owner']))
        )));
        unset($opt['Owner']);
    }
    
    // Optional list (non-map)
    if (isset($opt['ExecutableBy']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ExecutableBy' =&gt; (is_array($opt['ExecutableBy']) ? $opt['ExecutableBy'] : array($opt['ExecutableBy']))
        )));
        unset($opt['ExecutableBy']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeImages', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{i:0;a:3:{s:5:"title";s:38:"<p>Describe all accessible images.</p>";s:4:"code";s:97:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_images();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:43:"<p>Describe all images owned by Amazon.</p>";s:4:"code";s:129:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_images(array(
	'Owner' =&gt; 'amazon'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:57:"<p>Describe all images that your account can execute.</p>";s:4:"code";s:134:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_images(array(
	'ExecutableBy' =&gt; 'self'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:3;a:3:{s:5:"title";s:32:"<p>Filter accessible images.</p>";s:4:"code";s:427:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_images(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'architecture',        'Value' =&gt; 'x86_64'     ),
		array('Name' =&gt; 'image-type',          'Value' =&gt; 'machine'    ),
		array('Name' =&gt; 'root-device-type',    'Value' =&gt; 'ebs'        ),
		array('Name' =&gt; 'virtualization-type', 'Value' =&gt; 'paravirtual'),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:2;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:3;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:4;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}}i:84;a:8:{s:4:"name";s:27:"describe_instance_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:107:"<p>Returns information about an attribute of an instance. Only one attribute can be specified per
call.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:74:"<p>The ID of the instance whose instance attribute is being described.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:673:"<p>The name of the attribute to describe. Available attribute names: <code>instanceType</code>, <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, <code>instanceInitiatedShutdownBehavior</code>, <code>rootDeviceName</code>, <code>blockDeviceMapping</code> [Allowed values: <code>instanceType</code>, <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, <code>instanceInitiatedShutdownBehavior</code>, <code>rootDeviceName</code>, <code>blockDeviceMapping</code>, <code>productCodes</code>, <code>sourceDestCheck</code>, <code>groupSet</code>, <code>ebsOptimized</code>]</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:267:"public function describe_instance_attribute($instance_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('DescribeInstanceAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:51:"<p>Describe the attributes of a given instance.</p>";s:4:"code";s:174:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_instance_attribute('i-1f549375', 'instanceType');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:1;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:2;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:3;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:4;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:85;a:6:{s:4:"name";s:24:"describe_instance_status";s:8:"modifier";s:6:"public";s:11:"description";s:2868:"<p>Describes the status of an Amazon Elastic Compute Cloud (Amazon EC2) instance. Instance status
provides information about two types of scheduled events for an instance that may require your
attention:</p>

<ul><li>Scheduled Reboot: When Amazon EC2 determines that an instance must be rebooted, the
instance&#8217;s status will return one of two event codes: <code>system-reboot</code> or
<code>instance-reboot</code>. System reboot commonly occurs if certain maintenance or upgrade
operations require a reboot of the underlying host that supports an instance. Instance reboot
commonly occurs if the instance must be rebooted, rather than the underlying host. Rebooting
events include a scheduled start and end time.</li><li>Scheduled Retirement: When Amazon EC2 determines that an instance must be shut down, the
instance&#8217;s status will return an event code called <code>instance-retirement</code>. Retirement
commonly occurs when the underlying host is degraded and must be replaced. Retirement events
include a scheduled start and end time. You&#8217;re also notified by email if one of your instances
is set to retiring. The email message indicates when your instance will be permanently retired.</li></ul>

<p>If your instance is permanently retired, it will not be restarted. You can avoid retirement by
manually restarting your instance when its event code is <code>instance-retirement</code>. This
ensures that your instance is started on a healthy host.</p>

<p><code>DescribeInstanceStatus</code> returns information only for instances in the running
state.</p>

<p>You can filter the results to return information only about instances that match criteria you
specify. For example, you could get information about instances in a specific Availability
Zone. You can specify multiple values for a filter (e.g., more than one Availability Zone). An
instance must match at least one of the specified values for it to be included in the results.</p>

<p>You can specify multiple filters. An instance must match all the filters for it to be included
in the results. If there&#8217;s no match, no special message is returned; the response is simply
empty.</p>

<p>You can use wildcards with the filter values: <code><em></code> matches zero or more characters,
and <code>?</code> matches exactly one character. You can escape special characters using a
backslash before the character. For example, a value of <code>&#42;amazon\?&#92;</code> searches for
the literal string <code></em>amazon?\</code>.</p>

<p>The following filters are available:</p>

<ul><li><code>availability-zone</code> - Filter on an instance&#8217;s availability zone.</li><li><code>instance-state-name</code> - Filter on the intended state of the instance, e.g.,
running.</li><li><code>instance-state-code</code> - Filter on the intended state code of the instance, e.g.,
16.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1584:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceId</code> - <code>string|array</code> - Optional - The list of instance IDs. If not specified, all instances are described. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - The list of filters to limit returned results. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>NextToken</code> - <code>string</code> - Optional - A string specifying the next paginated set of results to return.</li><li><code>MaxResults</code> - <code>integer</code> - Optional - The maximum number of paginated instance items per response.</li><li><code>IncludeAllInstances</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:685:"public function describe_instance_status($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['InstanceId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))
        )));
        unset($opt['InstanceId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeInstanceStatus', $opt);
}";}i:86;a:8:{s:4:"name";s:18:"describe_instances";s:8:"modifier";s:6:"public";s:11:"description";s:562:"<p>The DescribeInstances operation returns information about instances that you own.</p>

<p>If you specify one or more instance IDs, Amazon EC2 returns information for those instances. If
you do not specify instance IDs, Amazon EC2 returns information for all relevant instances. If
you specify an invalid instance ID, a fault is returned. If you specify an instance that you do
not own, it will not be included in the returned results.</p>

<p>Recently terminated instances might appear in the returned results. This interval is usually
less than one hour.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1467:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceId</code> - <code>string|array</code> - Optional - An optional list of the instances to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Instances. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/index.html?ApiReference-query-DescribeInstances.html">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:674:"public function describe_instances($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['InstanceId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))
        )));
        unset($opt['InstanceId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:30:"<p>Describe all instances.</p>";s:4:"code";s:100:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_instances();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:24:"<p>Filter instances.</p>";s:4:"code";s:333:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_instances(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'architecture', 'Value' =&gt; 'x86_64'),
		array('Name' =&gt; 'root-device-type', 'Value' =&gt; 'ebs'),
		array('Name' =&gt; 'virtualization-type', 'Value' =&gt; 'paravirtual'),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:2;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:3;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:4;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:87;a:8:{s:4:"name";s:26:"describe_internet_gateways";s:8:"modifier";s:6:"public";s:11:"description";s:1034:"<p>Gives you information about your Internet gateways. You can filter the results to return
information only about Internet gateways that match criteria you specify. For example, you
could get information only about gateways with particular tags. The Internet gateway must match
at least one of the specified values for it to be included in the results.</p>

<p>You can specify multiple filters (e.g., the Internet gateway is attached to a particular VPC
and is tagged with a particular value). The result includes information for a particular
Internet gateway only if the gateway matches all your filters. If there&#8217;s no match, no special
message is returned; the response is simply empty.</p>

<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and
<code>?</code> matches exactly one character. You can escape special characters using a
backslash before the character. For example, a value of <code>&#42;amazon\?&#92;</code> searches for
the literal string <code>*amazon?\</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1417:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InternetGatewayId</code> - <code>string|array</code> - Optional - One or more Internet gateway IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Internet Gateways. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:731:"public function describe_internet_gateways($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['InternetGatewayId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'InternetGatewayId' =&gt; (is_array($opt['InternetGatewayId']) ? $opt['InternetGatewayId'] : array($opt['InternetGatewayId']))
        )));
        unset($opt['InternetGatewayId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeInternetGateways', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:42:"<p>Describe all VPC internet gateways.</p>";s:4:"code";s:108:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_internet_gateways();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:48:"<p>Describe a specific VPC internet gateway.</p>";s:4:"code";s:158:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_internet_gateways(array(
	'InternetGatewayId' =&gt; 'igw-be7cfdd7'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:153:"<a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>";i:2;s:153:"<a href="../amazonec2/delete_internet_gateway.html" rel="../../index.html#m=amazonec2/delete_internet_gateway"><code>delete_internet_gateway()</code></a>";i:3;s:153:"<a href="../amazonec2/detach_internet_gateway.html" rel="../../index.html#m=amazonec2/detach_internet_gateway"><code>detach_internet_gateway()</code></a>";}}}i:88;a:8:{s:4:"name";s:18:"describe_key_pairs";s:8:"modifier";s:6:"public";s:11:"description";s:229:"<p>The DescribeKeyPairs operation returns information about key pairs available to you. If you
specify key pairs, information about those key pairs is returned. Otherwise, information for
all registered key pairs is returned.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1413:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>KeyName</code> - <code>string|array</code> - Optional - The optional list of key pair names to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for KeyPairs. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:655:"public function describe_key_pairs($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['KeyName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'KeyName' =&gt; (is_array($opt['KeyName']) ? $opt['KeyName'] : array($opt['KeyName']))
        )));
        unset($opt['KeyName']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeKeyPairs', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{i:0;a:3:{s:5:"title";s:46:"<p>Describe the key pairs in your account.</p>";s:4:"code";s:100:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_key_pairs();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:51:"<p>Describe specific key pairs in your account.</p>";s:4:"code";s:138:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_key_pairs(array(
	'KeyName' =&gt; 'my-keypair'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:51:"<p>Describe multiple key pairs in your account.</p>";s:4:"code";s:167:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_key_pairs(array(
	'KeyName' =&gt; array(
		'my-keypair',
		'my-keypair2'
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:3;a:3:{s:5:"title";s:24:"<p>Filter key pairs.</p>";s:4:"code";s:168:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_key_pairs(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'key-name'),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:129:"<a href="../amazonec2/create_key_pair.html" rel="../../index.html#m=amazonec2/create_key_pair"><code>create_key_pair()</code></a>";i:1;s:129:"<a href="../amazonec2/delete_key_pair.html" rel="../../index.html#m=amazonec2/delete_key_pair"><code>delete_key_pair()</code></a>";i:2;s:129:"<a href="../amazonec2/import_key_pair.html" rel="../../index.html#m=amazonec2/import_key_pair"><code>import_key_pair()</code></a>";}}}i:89;a:6:{s:4:"name";s:17:"describe_licenses";s:8:"modifier";s:6:"public";s:11:"description";s:199:"<p>Provides details of a user&#8217;s registered licenses. Zero or more IDs may be specified on the
call. When one or more license IDs are specified, only data for the specified IDs are returned.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1439:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>LicenseId</code> - <code>string|array</code> - Optional - Specifies the license registration for which details are to be returned. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Licenses. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:666:"public function describe_licenses($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['LicenseId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LicenseId' =&gt; (is_array($opt['LicenseId']) ? $opt['LicenseId'] : array($opt['LicenseId']))
        )));
        unset($opt['LicenseId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeLicenses', $opt);
}";}i:90;a:8:{s:4:"name";s:21:"describe_network_acls";s:8:"modifier";s:6:"public";s:11:"description";s:1021:"<p>Gives you information about the network ACLs in your VPC. You can filter the results to return
information only about ACLs that match criteria you specify. For example, you could get
information only the ACL associated with a particular subnet. The ACL must match at least one
of the specified values for it to be included in the results.</p>

<p>You can specify multiple filters (e.g., the ACL is associated with a particular subnet and has
an egress entry that denies traffic to a particular port). The result includes information for
a particular ACL only if it matches all your filters. If there&#8217;s no match, no special message
is returned; the response is simply empty.</p>

<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and
<code>?</code> matches exactly one character. You can escape special characters using a
backslash before the character. For example, a value of <code>&#42;amazon\?&#92;</code> searches for
the literal string <code>*amazon?\</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1402:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>NetworkAclId</code> - <code>string|array</code> - Optional - One or more network ACL IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Network ACLs. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:691:"public function describe_network_acls($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['NetworkAclId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'NetworkAclId' =&gt; (is_array($opt['NetworkAclId']) ? $opt['NetworkAclId'] : array($opt['NetworkAclId']))
        )));
        unset($opt['NetworkAclId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeNetworkAcls', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:56:"<p>Describe all Network Access Control Lists (ACLs).</p>";s:4:"code";s:103:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_network_acls();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:56:"<p>Describe all Network Access Control Lists (ACLs).</p>";s:4:"code";s:149:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_network_acls(array(
	'NetworkAclId' =&gt; 'acl-4abf3f23',
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:3;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:4;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:91;a:5:{s:4:"name";s:36:"describe_network_interface_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:795:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>SourceDestCheck</code> - <code>string</code> - Optional - </li><li><code>GroupSet</code> - <code>string</code> - Optional - </li><li><code>Attachment</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:262:"public function describe_network_interface_attribute($network_interface_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    return $this-&gt;authenticate('DescribeNetworkInterfaceAttribute', $opt);
}";}i:92;a:6:{s:4:"name";s:27:"describe_network_interfaces";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1662:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>NetworkInterfaceId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*</code> specifies that zero or more characters must match, and <code>?</code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\*amazon\?\\</code> specifies the literal string <code>*amazon?\</code>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:739:"public function describe_network_interfaces($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['NetworkInterfaceId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'NetworkInterfaceId' =&gt; (is_array($opt['NetworkInterfaceId']) ? $opt['NetworkInterfaceId'] : array($opt['NetworkInterfaceId']))
        )));
        unset($opt['NetworkInterfaceId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeNetworkInterfaces', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:35:"<p>List the network interfaces.</p>";s:4:"code";s:109:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_network_interfaces();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:93;a:8:{s:4:"name";s:25:"describe_placement_groups";s:8:"modifier";s:6:"public";s:11:"description";s:109:"<p>Returns information about one or more <code>PlacementGroup</code> instances in a user&#8217;s
account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1419:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GroupName</code> - <code>string|array</code> - Optional - The name of the <code>PlacementGroup</code>. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Placement Groups. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:681:"public function describe_placement_groups($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['GroupName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'GroupName' =&gt; (is_array($opt['GroupName']) ? $opt['GroupName'] : array($opt['GroupName']))
        )));
        unset($opt['GroupName']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribePlacementGroups', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:49:"<p>Describe cluster-compute placement groups.</p>";s:4:"code";s:107:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_placement_groups();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:57:"<p>Describe a single cluster-compute placement group.</p>";s:4:"code";s:148:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_placement_groups(array(
	'GroupName' =&gt; 'php-cluster'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:150:"<a href="../amazonec2/create_placement_group.html" rel="../../index.html#m=amazonec2/create_placement_group"><code>create_placement_group()</code></a>";i:1;s:150:"<a href="../amazonec2/delete_placement_group.html" rel="../../index.html#m=amazonec2/delete_placement_group"><code>delete_placement_group()</code></a>";}}}i:94;a:8:{s:4:"name";s:16:"describe_regions";s:8:"modifier";s:6:"public";s:11:"description";s:105:"<p>The DescribeRegions operation describes regions zones that are currently available to the
account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1408:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>RegionName</code> - <code>string|array</code> - Optional - The optional list of regions to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Regions. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:670:"public function describe_regions($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['RegionName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'RegionName' =&gt; (is_array($opt['RegionName']) ? $opt['RegionName'] : array($opt['RegionName']))
        )));
        unset($opt['RegionName']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeRegions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{i:0;a:3:{s:5:"title";s:34:"<p>Describe available regions.</p>";s:4:"code";s:98:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_regions();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:34:"<p>Describe a specific region.</p>";s:4:"code";s:138:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_regions(array(
	'RegionName' =&gt; 'us-west-1'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:33:"<p>Describe multiple regions.</p>";s:4:"code";s:200:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_regions(array(
	'RegionName' =&gt; array(
		'us-west-1',
		'us-east-1',
		'eu-west-1',
		'ap-southeast-1'
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:3;a:3:{s:5:"title";s:32:"<p>Filter available regions.</p>";s:4:"code";s:210:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_regions(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'endpoint', 'Value' =&gt; 'ec2.us-east-1.amazonaws.com')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";s:165:"<a href="../amazonec2/describe_availability_zones.html" rel="../../index.html#m=amazonec2/describe_availability_zones"><code>describe_availability_zones()</code></a>";}}i:95;a:8:{s:4:"name";s:27:"describe_reserved_instances";s:8:"modifier";s:6:"public";s:11:"description";s:122:"<p>The DescribeReservedInstances operation describes Reserved Instances that were purchased for
use with your account.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1547:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ReservedInstancesId</code> - <code>string|array</code> - Optional - The optional list of Reserved Instance IDs to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for ReservedInstances. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>OfferingType</code> - <code>string</code> - Optional - The Reserved Instance offering type.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:745:"public function describe_reserved_instances($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ReservedInstancesId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ReservedInstancesId' =&gt; (is_array($opt['ReservedInstancesId']) ? $opt['ReservedInstancesId'] : array($opt['ReservedInstancesId']))
        )));
        unset($opt['ReservedInstancesId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeReservedInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:35:"<p>Describe reserved instances.</p>";s:4:"code";s:109:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_reserved_instances();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:33:"<p>Filter reserved instances.</p>";s:4:"code";s:303:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_reserved_instances(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'duration',            'Value' =&gt; strtotime('1 year')),
		array('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux/UNIX'       ),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:195:"<a href="../amazonec2/describe_reserved_instances_offerings.html" rel="../../index.html#m=amazonec2/describe_reserved_instances_offerings"><code>describe_reserved_instances_offerings()</code></a>";i:1;s:192:"<a href="../amazonec2/purchase_reserved_instances_offering.html" rel="../../index.html#m=amazonec2/purchase_reserved_instances_offering"><code>purchase_reserved_instances_offering()</code></a>";}}}i:96;a:5:{s:4:"name";s:36:"describe_reserved_instances_listings";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1667:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ReservedInstancesId</code> - <code>string</code> - Optional - </li><li><code>ReservedInstancesListingId</code> - <code>string</code> - Optional - </li><li><code>Filters</code> - <code>array</code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*</code> specifies that zero or more characters must match, and <code>?</code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\*amazon\?\\</code> specifies the literal string <code>*amazon?\</code>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:411:"public function describe_reserved_instances_listings($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['Filters']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filters' =&gt; $opt['Filters']
        )));
        unset($opt['Filters']);
    }

    return $this-&gt;authenticate('DescribeReservedInstancesListings', $opt);
}";}i:97;a:8:{s:4:"name";s:37:"describe_reserved_instances_offerings";s:8:"modifier";s:6:"public";s:11:"description";s:337:"<p>The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are
available for purchase. With Amazon EC2 Reserved Instances, you purchase the right to launch
Amazon EC2 instances for a period of time (without getting insufficient capacity errors) and
pay a lower usage rate for the actual time used.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2789:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ReservedInstancesOfferingId</code> - <code>string|array</code> - Optional - An optional list of the unique IDs of the Reserved Instance offerings to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>InstanceType</code> - <code>string</code> - Optional - The instance type on which the Reserved Instance can be used. [Allowed values: <code>t1.micro</code>, <code>m1.small</code>, <code>m1.medium</code>, <code>m1.large</code>, <code>m1.xlarge</code>, <code>m2.xlarge</code>, <code>m2.2xlarge</code>, <code>m2.4xlarge</code>, <code>m3.xlarge</code>, <code>m3.2xlarge</code>, <code>c1.medium</code>, <code>c1.xlarge</code>, <code>hi1.4xlarge</code>, <code>hs1.8xlarge</code>, <code>cc1.4xlarge</code>, <code>cc2.8xlarge</code>, <code>cg1.4xlarge</code>]</li><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The Availability Zone in which the Reserved Instance can be used.</li><li><code>ProductDescription</code> - <code>string</code> - Optional - The Reserved Instance product description.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for ReservedInstancesOfferings. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>InstanceTenancy</code> - <code>string</code> - Optional - The tenancy of the Reserved Instance offering. A Reserved Instance with tenancy of dedicated will run on single-tenant hardware and can only be launched within a VPC.</li><li><code>OfferingType</code> - <code>string</code> - Optional - The Reserved Instance offering type.</li><li><code>NextToken</code> - <code>string</code> - Optional - </li><li><code>MaxResults</code> - <code>integer</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:812:"public function describe_reserved_instances_offerings($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ReservedInstancesOfferingId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ReservedInstancesOfferingId' =&gt; (is_array($opt['ReservedInstancesOfferingId']) ? $opt['ReservedInstancesOfferingId'] : array($opt['ReservedInstancesOfferingId']))
        )));
        unset($opt['ReservedInstancesOfferingId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeReservedInstancesOfferings', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:45:"<p>Describe reserved instances offerings.</p>";s:4:"code";s:201:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_reserved_instances_offerings(array(
	'AvailabilityZone' =&gt; 'us-east-1a',
	'InstanceType' =&gt; 'c1.medium'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:42:"<p>Filter Reserved Instances Offerings</p>";s:4:"code";s:313:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_reserved_instances_offerings(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'duration',            'Value' =&gt; strtotime('1 year')),
		array('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux/UNIX'       ),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:165:"<a href="../amazonec2/describe_reserved_instances.html" rel="../../index.html#m=amazonec2/describe_reserved_instances"><code>describe_reserved_instances()</code></a>";i:1;s:192:"<a href="../amazonec2/purchase_reserved_instances_offering.html" rel="../../index.html#m=amazonec2/purchase_reserved_instances_offering"><code>purchase_reserved_instances_offering()</code></a>";}}}i:98;a:8:{s:4:"name";s:21:"describe_route_tables";s:8:"modifier";s:6:"public";s:11:"description";s:1035:"<p>Gives you information about your route tables. You can filter the results to return information
only about tables that match criteria you specify. For example, you could get information only
about a table associated with a particular subnet. You can specify multiple values for the
filter. The table must match at least one of the specified values for it to be included in the
results.</p>

<p>You can specify multiple filters (e.g., the table has a particular route, and is associated
with a particular subnet). The result includes information for a particular table only if it
matches all your filters. If there&#8217;s no match, no special message is returned; the response is
simply empty.</p>

<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and
<code>?</code> matches exactly one character. You can escape special characters using a
backslash before the character. For example, a value of <code>&#42;amazon\?&#92;</code> searches for
the literal string <code>*amazon?\</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1402:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>RouteTableId</code> - <code>string|array</code> - Optional - One or more route table IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Route Tables. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:691:"public function describe_route_tables($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['RouteTableId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'RouteTableId' =&gt; (is_array($opt['RouteTableId']) ? $opt['RouteTableId'] : array($opt['RouteTableId']))
        )));
        unset($opt['RouteTableId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeRouteTables', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Describe all VPC route tables;</p>";s:4:"code";s:103:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_route_tables();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:4;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:5;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:99;a:8:{s:4:"name";s:24:"describe_security_groups";s:8:"modifier";s:6:"public";s:11:"description";s:320:"<p>The DescribeSecurityGroups operation returns information about security groups that you own.</p>

<p>If you specify security group names, information about those security group is returned.
Otherwise, information for all security group is returned. If you specify a group that does not
exist, a fault is returned.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1579:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GroupName</code> - <code>string|array</code> - Optional - The optional list of Amazon EC2 security groups to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>GroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for SecurityGroups. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:962:"public function describe_security_groups($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['GroupName']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'GroupName' =&gt; (is_array($opt['GroupName']) ? $opt['GroupName'] : array($opt['GroupName']))
        )));
        unset($opt['GroupName']);
    }
    
    // Optional list (non-map)
    if (isset($opt['GroupId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'GroupId' =&gt; (is_array($opt['GroupId']) ? $opt['GroupId'] : array($opt['GroupId']))
        )));
        unset($opt['GroupId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeSecurityGroups', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:4:{i:0;a:3:{s:5:"title";s:32:"<p>Describe security groups.</p>";s:4:"code";s:106:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_security_groups();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:56:"<p>Describe security groups with a given group name.</p>";s:4:"code";s:143:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_security_groups(array(
	'GroupName' =&gt; 'default'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:58:"<p>Describe security groups with multiple group names.</p>";s:4:"code";s:169:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_security_groups(array(
	'GroupName' =&gt; array(
		'default',
		'foo-test'
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:3;a:3:{s:5:"title";s:30:"<p>Filter security groups.</p>";s:4:"code";s:173:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_security_groups(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'owner-id')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:2;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:3;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:4;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}}i:100;a:8:{s:4:"name";s:27:"describe_snapshot_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:106:"<p>Returns information about an attribute of a snapshot. Only one attribute can be specified per
call.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"snapshot_id";s:4:"type";s:6:"string";s:11:"description";s:69:"<p>The ID of the EBS snapshot whose attribute is being described.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:180:"<p>The name of the EBS attribute to describe. Available attribute names: createVolumePermission [Allowed values: <code>productCodes</code>, <code>createVolumePermission</code>]</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:267:"public function describe_snapshot_attribute($snapshot_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SnapshotId'] = $snapshot_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('DescribeSnapshotAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:36:"<p>Describe snapshot attributes.</p>";s:4:"code";s:187:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_snapshot_attribute('snap-a99b8bc1', 'createVolumePermission');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:101;a:8:{s:4:"name";s:18:"describe_snapshots";s:8:"modifier";s:6:"public";s:11:"description";s:320:"<p>Returns information about the Amazon EBS snapshots available to you. Snapshots available to you
include public snapshots available for any AWS account to launch, private snapshots you own,
and private snapshots owned by another AWS account but for which you&#8217;ve been given explicit
create volume permissions.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1853:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SnapshotId</code> - <code>string|array</code> - Optional - The optional list of EBS snapshot IDs to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Owner</code> - <code>string|array</code> - Optional - The optional list of EBS snapshot owners. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>RestorableBy</code> - <code>string|array</code> - Optional - The optional list of users who have permission to create volumes from the described EBS snapshots. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Snapshots. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1258:"public function describe_snapshots($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['SnapshotId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SnapshotId' =&gt; (is_array($opt['SnapshotId']) ? $opt['SnapshotId'] : array($opt['SnapshotId']))
        )));
        unset($opt['SnapshotId']);
    }
    
    // Optional list (non-map)
    if (isset($opt['Owner']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Owner' =&gt; (is_array($opt['Owner']) ? $opt['Owner'] : array($opt['Owner']))
        )));
        unset($opt['Owner']);
    }
    
    // Optional list (non-map)
    if (isset($opt['RestorableBy']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'RestorableBy' =&gt; (is_array($opt['RestorableBy']) ? $opt['RestorableBy'] : array($opt['RestorableBy']))
        )));
        unset($opt['RestorableBy']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeSnapshots', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:3:{s:5:"title";s:48:"<p>Describe snapshots that are owned by you.</p>";s:4:"code";s:130:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_snapshots(array(
	'Owner' =&gt; 'self'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:83:"<p>Describe images that are owned by yourself or Amazon, and restorable by you.</p>";s:4:"code";s:223:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_snapshots(array(
	'Owner' =&gt; array(
		'self',
		'amazon'
	),
	'RestorableBy' =&gt; CFCredentials::get('@default')-&gt;account_id
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:24:"<p>Filter snapshots.</p>";s:4:"code";s:190:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_snapshots(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'status', 'Value' =&gt; 'pending')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:6;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:102;a:8:{s:4:"name";s:35:"describe_spot_datafeed_subscription";s:8:"modifier";s:6:"public";s:11:"description";s:370:"<p>Describes the data feed for Spot Instances.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:189:"public function describe_spot_datafeed_subscription($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('DescribeSpotDatafeedSubscription', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Describe spot datafeed subscription.</p>";s:4:"code";s:117:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_spot_datafeed_subscription();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:2;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:3;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:103;a:8:{s:4:"name";s:31:"describe_spot_instance_requests";s:8:"modifier";s:6:"public";s:11:"description";s:1784:"<p>Describes Spot Instance requests. Spot Instances are instances that Amazon EC2 starts on your
behalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2
periodically sets the Spot Price based on available Spot Instance capacity and current spot
instance requests. For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2010-08-31/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2010-08-31/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>

<p>You can filter the results to return information only about Spot Instance requests that match
criteria you specify. For example, you could get information about requests where the Spot
Price you specified is a certain value (you can&#8217;t use greater than or less than comparison, but
you can use <code>*</code> and <code>?</code> wildcards). You can specify multiple values for a
filter. A Spot Instance request must match at least one of the specified values for it to be
included in the results.</p>

<p>You can specify multiple filters (e.g., the Spot Price is equal to a particular value, and the
instance type is <code>m1.small</code>). The result includes information for a particular
request only if it matches all your filters. If there&#8217;s no match, no special message is
returned; the response is simply empty.</p>

<p>You can use wildcards with the filter values: an asterisk matches zero or more characters, and
<code>?</code> matches exactly one character. You can escape special characters using a
backslash before the character. For example, a value of <code>&#42;amazon\?&#92;</code> searches for
the literal string <code>*amazon?\</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1406:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SpotInstanceRequestId</code> - <code>string|array</code> - Optional - The ID of the request. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for SpotInstances. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:764:"public function describe_spot_instance_requests($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['SpotInstanceRequestId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SpotInstanceRequestId' =&gt; (is_array($opt['SpotInstanceRequestId']) ? $opt['SpotInstanceRequestId'] : array($opt['SpotInstanceRequestId']))
        )));
        unset($opt['SpotInstanceRequestId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeSpotInstanceRequests', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:39:"<p>Describe spot instance requests.</p>";s:4:"code";s:113:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_spot_instance_requests();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:39:"<p>Describe spot instance requests.</p>";s:4:"code";s:366:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_spot_instance_requests(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux/UNIX'),
		array('Name' =&gt; 'state',               'Value' =&gt; 'active'    ),
		array('Name' =&gt; 'type',                'Value' =&gt; 'one-time'  ),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:2;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:3;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:4;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:104;a:8:{s:4:"name";s:27:"describe_spot_price_history";s:8:"modifier";s:6:"public";s:11:"description";s:629:"<p>Describes the Spot Price history.</p>

<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that
you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based
on available Spot Instance capacity and current spot instance requests.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide</a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2520:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>StartTime</code> - <code>string</code> - Optional - The start date and time of the Spot Instance price history data. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>EndTime</code> - <code>string</code> - Optional - The end date and time of the Spot Instance price history data. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>InstanceType</code> - <code>string|array</code> - Optional - Specifies the instance type to return. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>ProductDescription</code> - <code>string|array</code> - Optional - The description of the AMI. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for SpotPriceHistory. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>AvailabilityZone</code> - <code>string</code> - Optional - Filters the results by availability zone (ex: &#8216;us-east-1a&#8217;).</li><li><code>MaxResults</code> - <code>integer</code> - Optional - Specifies the number of rows to return.</li><li><code>NextToken</code> - <code>string</code> - Optional - Specifies the next set of rows to return.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1375:"public function describe_spot_price_history($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional DateTime
    if (isset($opt['StartTime']))
    {
        $opt['StartTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['StartTime']);
    }
    
    // Optional DateTime
    if (isset($opt['EndTime']))
    {
        $opt['EndTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['EndTime']);
    }

    // Optional list (non-map)
    if (isset($opt['InstanceType']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'InstanceType' =&gt; (is_array($opt['InstanceType']) ? $opt['InstanceType'] : array($opt['InstanceType']))
        )));
        unset($opt['InstanceType']);
    }
    
    // Optional list (non-map)
    if (isset($opt['ProductDescription']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ProductDescription' =&gt; (is_array($opt['ProductDescription']) ? $opt['ProductDescription'] : array($opt['ProductDescription']))
        )));
        unset($opt['ProductDescription']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeSpotPriceHistory', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:35:"<p>Describe spot price history.</p>";s:4:"code";s:289:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_spot_price_history(array(
	'StartTime' =&gt; '3 months ago',
	'EndTime' =&gt; 'yesterday, 9am',
	'InstanceType' =&gt; array(
		'm1.small',
		'c1.medium'
	),
	'ProductDescription' =&gt; 'Linux/UNIX'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:33:"<p>Filter spot price history.</p>";s:4:"code";s:289:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_spot_price_history(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'product-description', 'Value' =&gt; 'Linux/UNIX'),
		array('Name' =&gt; 'instance-type',       'Value' =&gt; 't1.micro'  ),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:2;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:3;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:4;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:5;s:150:"<a href="../amazonec2/request_spot_instances.html" rel="../../index.html#m=amazonec2/request_spot_instances"><code>request_spot_instances()</code></a>";}}}i:105;a:8:{s:4:"name";s:16:"describe_subnets";s:8:"modifier";s:6:"public";s:11:"description";s:651:"<p>Gives you information about your subnets. You can filter the results to return information only
about subnets that match criteria you specify.</p>

<p>For example, you could ask to get information about a particular subnet (or all) only if the
subnet&#8217;s state is available. You can specify multiple filters (e.g., the subnet is in a
particular VPC, and the subnet&#8217;s state is available).</p>

<p>The result includes information for a particular subnet only if the subnet matches all your
filters. If there&#8217;s no match, no special message is returned; the response is simply empty. The
following table shows the available filters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1397:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SubnetId</code> - <code>string|array</code> - Optional - A set of one or more subnet IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Subnets. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:658:"public function describe_subnets($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['SubnetId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SubnetId' =&gt; (is_array($opt['SubnetId']) ? $opt['SubnetId'] : array($opt['SubnetId']))
        )));
        unset($opt['SubnetId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeSubnets', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:32:"<p>Describe all VPC subnets.</p>";s:4:"code";s:98:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_subnets();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:45:"<p>Filter VPC subnets by available state.</p>";s:4:"code";s:190:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_subnets(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available')
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:123:"<a href="../amazonec2/create_subnet.html" rel="../../index.html#m=amazonec2/create_subnet"><code>create_subnet()</code></a>";i:1;s:123:"<a href="../amazonec2/delete_subnet.html" rel="../../index.html#m=amazonec2/delete_subnet"><code>delete_subnet()</code></a>";}}}i:106;a:8:{s:4:"name";s:13:"describe_tags";s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>Describes the tags for the specified resources.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1031:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for tags. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:363:"public function describe_tags($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeTags', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:25:"<p>Describe all tags.</p>";s:4:"code";s:95:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_tags();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:45:"<p>Describe tags for a given resource ID.</p>";s:4:"code";s:195:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_tags(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'resource-id', 'Value' =&gt; 'aki-00006369')
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:117:"<a href="../amazonec2/create_tags.html" rel="../../index.html#m=amazonec2/create_tags"><code>create_tags()</code></a>";i:1;s:117:"<a href="../amazonec2/delete_tags.html" rel="../../index.html#m=amazonec2/delete_tags"><code>delete_tags()</code></a>";}}}i:107;a:5:{s:4:"name";s:25:"describe_volume_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:657:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Attribute</code> - <code>string</code> - Optional -  [Allowed values: <code>autoEnableIO</code>, <code>productCodes</code>]</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function describe_volume_attribute($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('DescribeVolumeAttribute', $opt);
}";}i:108;a:6:{s:4:"name";s:22:"describe_volume_status";s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Describes the status of a volume.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1788:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VolumeId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A filter used to limit results when describing tags. Multiple values can be specified per filter. A tag must match at least one of the specified values for it to be returned from an operation. Wildcards can be included in filter values; <code>*</code> specifies that zero or more characters must match, and <code>?</code> specifies that exactly one character must match. Use a backslash to escape special characters. For example, a filter value of <code>\*amazon\?\\</code> specifies the literal string <code>*amazon?\</code>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>NextToken</code> - <code>string</code> - Optional - </li><li><code>MaxResults</code> - <code>integer</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:669:"public function describe_volume_status($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VolumeId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VolumeId' =&gt; (is_array($opt['VolumeId']) ? $opt['VolumeId'] : array($opt['VolumeId']))
        )));
        unset($opt['VolumeId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeVolumeStatus', $opt);
}";}i:109;a:8:{s:4:"name";s:16:"describe_volumes";s:8:"modifier";s:6:"public";s:11:"description";s:168:"<p>Describes the status of the indicated volume or, in lieu of any specified, all volumes
belonging to the caller. Volumes that have been deleted are not described.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1410:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VolumeId</code> - <code>string|array</code> - Optional - The optional list of EBS volumes to describe. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for Volumes. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:658:"public function describe_volumes($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VolumeId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VolumeId' =&gt; (is_array($opt['VolumeId']) ? $opt['VolumeId'] : array($opt['VolumeId']))
        )));
        unset($opt['VolumeId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeVolumes', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:28:"<p>Describe EBS volumes.</p>";s:4:"code";s:98:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_volumes();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:26:"<p>Filter EBS volumes.</p>";s:4:"code";s:272:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_volumes(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'attachment.status', 'Value' =&gt; 'attached' ),
		array('Name' =&gt; 'status',            'Value' =&gt; 'available'),
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:6;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:7;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:110;a:5:{s:4:"name";s:22:"describe_vpc_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:667:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Attribute</code> - <code>string</code> - Optional -  [Allowed values: <code>enableDnsSupport</code>, <code>enableDnsHostnames</code>]</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:194:"public function describe_vpc_attribute($vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('DescribeVpcAttribute', $opt);
}";}i:111;a:8:{s:4:"name";s:13:"describe_vpcs";s:8:"modifier";s:6:"public";s:11:"description";s:663:"<p>Gives you information about your VPCs. You can filter the results to return information only
about VPCs that match criteria you specify.</p>

<p>For example, you could ask to get information about a particular VPC or VPCs (or all your VPCs)
only if the VPC&#8217;s state is available. You can specify multiple filters (e.g., the VPC uses one
of several sets of DHCP options, and the VPC&#8217;s state is available). The result includes
information for a particular VPC only if the VPC matches all your filters.</p>

<p>If there&#8217;s no match, no special message is returned; the response is simply empty. The
following table shows the available filters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1402:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VpcId</code> - <code>string|array</code> - Optional - The ID of a VPC you want information about. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for VPCs. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:634:"public function describe_vpcs($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VpcId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VpcId' =&gt; (is_array($opt['VpcId']) ? $opt['VpcId'] : array($opt['VpcId']))
        )));
        unset($opt['VpcId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeVpcs', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:25:"<p>Describe all VPCs.</p>";s:4:"code";s:95:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpcs();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:38:"<p>Filter VPCs by available state.</p>";s:4:"code";s:187:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpcs(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available')
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:114:"<a href="../amazonec2/create_vpc.html" rel="../../index.html#m=amazonec2/create_vpc"><code>create_vpc()</code></a>";i:1;s:114:"<a href="../amazonec2/delete_vpc.html" rel="../../index.html#m=amazonec2/delete_vpc"><code>delete_vpc()</code></a>";}}}i:112;a:8:{s:4:"name";s:24:"describe_vpn_connections";s:8:"modifier";s:6:"public";s:11:"description";s:936:"<p>Gives you information about your VPN connections.</p>

<p class="important"></p>

<p>We strongly recommend you use HTTPS when calling this operation because the response contains
sensitive cryptographic information for configuring your customer gateway.</p>

<p>You can filter the results to return information only about VPN connections that match criteria
you specify. For example, you could ask to get information about a particular VPN connection
(or all) only if the VPN&#8217;s state is pending or available. You can specify multiple filters
(e.g., the VPN connection is associated with a particular VPN gateway, and the gateway&#8217;s state
is pending or available). The result includes information for a particular VPN connection only
if the VPN connection matches all your filters. If there&#8217;s no match, no special message is
returned; the response is simply empty. The following table shows the available filters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1444:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VpnConnectionId</code> - <code>string|array</code> - Optional - A VPN connection ID. More than one may be specified per request. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for VPN Connections. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:715:"public function describe_vpn_connections($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VpnConnectionId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VpnConnectionId' =&gt; (is_array($opt['VpnConnectionId']) ? $opt['VpnConnectionId'] : array($opt['VpnConnectionId']))
        )));
        unset($opt['VpnConnectionId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeVpnConnections', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:36:"<p>Describe all VPN connections.</p>";s:4:"code";s:106:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpn_connections();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:49:"<p>Filter VPN connections by available state.</p>";s:4:"code";s:198:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpn_connections(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available')
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:147:"<a href="../amazonec2/create_vpn_connection.html" rel="../../index.html#m=amazonec2/create_vpn_connection"><code>create_vpn_connection()</code></a>";i:1;s:147:"<a href="../amazonec2/delete_vpn_connection.html" rel="../../index.html#m=amazonec2/delete_vpn_connection"><code>delete_vpn_connection()</code></a>";}}}i:113;a:8:{s:4:"name";s:21:"describe_vpn_gateways";s:8:"modifier";s:6:"public";s:11:"description";s:714:"<p>Gives you information about your VPN gateways. You can filter the results to return information
only about VPN gateways that match criteria you specify.</p>

<p>For example, you could ask to get information about a particular VPN gateway (or all) only if
the gateway&#8217;s state is pending or available. You can specify multiple filters (e.g., the VPN
gateway is in a particular Availability Zone and the gateway&#8217;s state is pending or available).</p>

<p>The result includes information for a particular VPN gateway only if the gateway matches all
your filters. If there&#8217;s no match, no special message is returned; the response is simply
empty. The following table shows the available filters.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1618:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VpnGatewayId</code> - <code>string|array</code> - Optional - A list of filters used to match properties for VPN Gateways. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Filter</code> - <code>array</code> - Optional - A list of filters used to match properties for VPN Gateways. For a complete reference to the available filter keys for this operation, see the <a href="http://docs.amazonwebservices.com/AWSEC2/latest/APIReference/">Amazon EC2 API reference</a>. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Name</code> - <code>string</code> - Optional - Specifies the name of the filter.</li><li><code>Value</code> - <code>string|array</code> - Optional - Contains one or more values for the filter. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:691:"public function describe_vpn_gateways($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VpnGatewayId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VpnGatewayId' =&gt; (is_array($opt['VpnGatewayId']) ? $opt['VpnGatewayId'] : array($opt['VpnGatewayId']))
        )));
        unset($opt['VpnGatewayId']);
    }
    
    // Optional list + map
    if (isset($opt['Filter']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Filter' =&gt; $opt['Filter']
        )));
        unset($opt['Filter']);
    }

    return $this-&gt;authenticate('DescribeVpnGateways', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:33:"<p>Describe all VPN gateways.</p>";s:4:"code";s:103:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpn_gateways();

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:33:"<p>Describe all VPN gateways.</p>";s:4:"code";s:195:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;describe_vpn_gateways(array(
	'Filter' =&gt; array(
		array('Name' =&gt; 'state', 'Value' =&gt; 'available')
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:138:"<a href="../amazonec2/attach_vpn_gateway.html" rel="../../index.html#m=amazonec2/attach_vpn_gateway"><code>attach_vpn_gateway()</code></a>";i:1;s:138:"<a href="../amazonec2/create_vpn_gateway.html" rel="../../index.html#m=amazonec2/create_vpn_gateway"><code>create_vpn_gateway()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_vpn_gateway.html" rel="../../index.html#m=amazonec2/delete_vpn_gateway"><code>delete_vpn_gateway()</code></a>";i:3;s:138:"<a href="../amazonec2/detach_vpn_gateway.html" rel="../../index.html#m=amazonec2/detach_vpn_gateway"><code>detach_vpn_gateway()</code></a>";}}}i:114;a:8:{s:4:"name";s:23:"detach_internet_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:421:"<p>Detaches an Internet gateway from a VPC, disabling connectivity between the Internet and the
VPC. The VPC must not contain any running instances with elastic IP addresses. For more
information about your VPC and Internet gateway, go to Amazon Virtual Private Cloud User Guide.</p>

<p>For more information about Amazon Virtual Private Cloud and Internet gateways, go to the Amazon
Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"internet_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:48:"<p>The ID of the Internet gateway to detach.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:25:"<p>The ID of the VPC.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:272:"public function detach_internet_gateway($internet_gateway_id, $vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InternetGatewayId'] = $internet_gateway_id;
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('DetachInternetGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:53:"<p>Detach an internet gateway from a running VPC.</p>";s:4:"code";s:135:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;detach_internet_gateway('igw-be7cfdd7', 'vpc-7e7dfc17');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:153:"<a href="../amazonec2/attach_internet_gateway.html" rel="../../index.html#m=amazonec2/attach_internet_gateway"><code>attach_internet_gateway()</code></a>";i:1;s:153:"<a href="../amazonec2/create_internet_gateway.html" rel="../../index.html#m=amazonec2/create_internet_gateway"><code>create_internet_gateway()</code></a>";i:2;s:153:"<a href="../amazonec2/delete_internet_gateway.html" rel="../../index.html#m=amazonec2/delete_internet_gateway"><code>delete_internet_gateway()</code></a>";i:3;s:162:"<a href="../amazonec2/describe_internet_gateways.html" rel="../../index.html#m=amazonec2/describe_internet_gateways"><code>describe_internet_gateways()</code></a>";}}}i:115;a:6:{s:4:"name";s:24:"detach_network_interface";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"attachment_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:583:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Force</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:219:"public function detach_network_interface($attachment_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['AttachmentId'] = $attachment_id;
    
    return $this-&gt;authenticate('DetachNetworkInterface', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Detach a network interface to a subnet.</p>";s:4:"code";s:138:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;detach_network_interface($network_interface_attachment_id);

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:116;a:8:{s:4:"name";s:13:"detach_volume";s:8:"modifier";s:6:"public";s:11:"description";s:67:"<p>Detach a previously attached volume from a running instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";s:38:"<p>The ID of the volume to detach.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1329:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceId</code> - <code>string</code> - Optional - The ID of the instance from which to detach the the specified volume.</li><li><code>Device</code> - <code>string</code> - Optional - The device name to which the volume is attached on the specified instance.</li><li><code>Force</code> - <code>boolean</code> - Optional - Forces detachment if the previous detachment attempt did not occur cleanly (logging into an instance, unmounting the volume, and detaching normally). This option can lead to data loss or a corrupted file system. Use this option only as a last resort to detach a volume from a failed instance. The instance will not have an opportunity to flush file system caches nor file system meta data. If you use this option, you must perform file system check and repair procedures.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:186:"public function detach_volume($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('DetachVolume', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:52:"<p>Detach an EBS volume from a running instance.</p>";s:4:"code";s:234:"// Instantiate the class
$ec2 = new AmazonEC2();

// Detach the volume
$response = $ec2-&gt;detach_volume($volume_id, array(
	'InstanceId' =&gt; 'i-1f549375',
	'Device' =&gt; '/dev/sdg'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:6;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:7;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:8;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}}i:117;a:8:{s:4:"name";s:18:"detach_vpn_gateway";s:8:"modifier";s:6:"public";s:11:"description";s:432:"<p>Detaches a VPN gateway from a VPC. You do this if you&#8217;re planning to turn off the VPC and not
use it anymore. You can confirm a VPN gateway has been completely detached from a VPC by
describing the VPN gateway (any attachments to the VPN gateway are also described).</p>

<p>You must wait for the attachment&#8217;s state to switch to detached before you can delete the VPC or
attach a different VPC to the VPN gateway.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"vpn_gateway_id";s:4:"type";s:6:"string";s:11:"description";s:56:"<p>The ID of the VPN gateway to detach from the VPC.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";s:56:"<p>The ID of the VPC to detach the VPN gateway from.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:247:"public function detach_vpn_gateway($vpn_gateway_id, $vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpnGatewayId'] = $vpn_gateway_id;
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('DetachVpnGateway', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:49:"<p>Detach a VPN gateway from an existing VPC.</p>";s:4:"code";s:130:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;detach_vpn_gateway('vgw-9aa347f3', 'vpc-fd7cd194');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:138:"<a href="../amazonec2/attach_vpn_gateway.html" rel="../../index.html#m=amazonec2/attach_vpn_gateway"><code>attach_vpn_gateway()</code></a>";i:1;s:138:"<a href="../amazonec2/create_vpn_gateway.html" rel="../../index.html#m=amazonec2/create_vpn_gateway"><code>create_vpn_gateway()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_vpn_gateway.html" rel="../../index.html#m=amazonec2/delete_vpn_gateway"><code>delete_vpn_gateway()</code></a>";i:3;s:147:"<a href="../amazonec2/describe_vpn_gateways.html" rel="../../index.html#m=amazonec2/describe_vpn_gateways"><code>describe_vpn_gateways()</code></a>";}}}i:118;a:7:{s:4:"name";s:11:"disable_ssl";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:312:"<p>Disables SSL/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still
require SSL support.</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:192:"public function disable_ssl()
{
    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;use_ssl = false;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:35:"<p>Disable SSL for the service.</p>";s:11:"description";s:170:"<ul>
<li><strong>Note:</strong> It is not recommended to disable SSL.</li>
<li><strong>Note:</strong> This method is inherited by all service-specific classes.</li>
</ul>";s:4:"code";s:175:"// Disable SSL (Using @ to suppress the warning from the output)
$sdb = new AmazonSDB();
@$sdb-&gt;disable_ssl(true);

// Test if the value was set
var_dump($sdb-&gt;use_ssl);";s:6:"result";s:11:"bool(false)";}}}i:119;a:7:{s:4:"name";s:24:"disable_ssl_verification";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:402:"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry
out a man-in-the-middle attack.</p>

<p>https://secure.wikimedia.org/wikipedia/en/wiki/Man-in-the-middle_attack</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"ssl_verification";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:314:"public function disable_ssl_verification($ssl_verification = false)
{
    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;ssl_verification = $ssl_verification;
    return $this;
}";}i:120;a:5:{s:4:"name";s:29:"disable_vgw_route_propagation";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"gateway_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:280:"public function disable_vgw_route_propagation($route_table_id, $gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    $opt['GatewayId'] = $gateway_id;
    
    return $this-&gt;authenticate('DisableVgwRoutePropagation', $opt);
}";}i:121;a:8:{s:4:"name";s:20:"disassociate_address";s:8:"modifier";s:6:"public";s:11:"description";s:232:"<p>The DisassociateAddress operation disassociates the specified elastic IP address from the
instance to which it is assigned. This is an idempotent operation. If you enter it more than
once, Amazon EC2 does not return an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:809:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PublicIp</code> - <code>string</code> - Optional - The elastic IP address that you are disassociating from the instance.</li><li><code>AssociationId</code> - <code>string</code> - Optional - Association ID corresponding to the VPC elastic IP address you want to disassociate.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:161:"public function disassociate_address($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('DisassociateAddress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>AmazonEC2 - Disassociate Address</p>";s:4:"code";s:154:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;disassociate_address('184.73.247.11');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:132:"<a href="../amazonec2/allocate_address.html" rel="../../index.html#m=amazonec2/allocate_address"><code>allocate_address()</code></a>";i:1;s:135:"<a href="../amazonec2/associate_address.html" rel="../../index.html#m=amazonec2/associate_address"><code>associate_address()</code></a>";i:2;s:138:"<a href="../amazonec2/describe_addresses.html" rel="../../index.html#m=amazonec2/describe_addresses"><code>describe_addresses()</code></a>";i:3;s:129:"<a href="../amazonec2/release_address.html" rel="../../index.html#m=amazonec2/release_address"><code>release_address()</code></a>";}}}i:122;a:8:{s:4:"name";s:24:"disassociate_route_table";s:8:"modifier";s:6:"public";s:11:"description";s:415:"<p>Disassociates a subnet from a route table.</p>

<p>After you perform this action, the subnet no longer uses the routes in the route table. Instead
it uses the routes in the VPC&#8217;s main route table. For more information about route tables, go
to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"association_id";s:4:"type";s:6:"string";s:11:"description";s:98:"<p>The association ID representing the current association between the route table and subnet.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:222:"public function disassociate_route_table($association_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['AssociationId'] = $association_id;
    
    return $this-&gt;authenticate('DisassociateRouteTable', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:64:"<p>Disassociate a VPC route table association from a subnet.</p>";s:4:"code";s:125:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;disassociate_route_table('rtbassoc-ac8a0ac5');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:4;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:5;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:6;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:123;a:8:{s:4:"name";s:17:"enable_debug_mode";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:75:"<p>Enables HTTP request/response header logging to <code>STDERR</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"enabled";s:4:"type";s:7:"boolean";s:11:"description";s:74:"<p>Whether or not to enable debug mode. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:109:"public function enable_debug_mode($enabled = true)
{
    $this-&gt;debug_mode = $enabled;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:82:"<p>Enable the logging of HTTP request/response headers to <code>STDERR</code>.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;enable_debug_mode();

// Test if the value was set
var_dump($sdb-&gt;debug_mode);";s:6:"result";s:10:"bool(true)";}}}i:124;a:5:{s:4:"name";s:28:"enable_vgw_route_propagation";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"gateway_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:278:"public function enable_vgw_route_propagation($route_table_id, $gateway_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    $opt['GatewayId'] = $gateway_id;
    
    return $this-&gt;authenticate('EnableVgwRoutePropagation', $opt);
}";}i:125;a:6:{s:4:"name";s:16:"enable_volume_io";s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>Enable IO on the volume after an event has occured.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:191:"public function enable_volume_io($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('EnableVolumeIO', $opt);
}";}i:126;a:7:{s:4:"name";s:7:"factory";s:8:"modifier";s:13:"public static";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:76:"<p>Alternate approach to constructing a new instance. Supports chaining.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1569:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonec2/set_cache_config.html" rel="../../index.html#m=amazonec2/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:303:"public static function factory(array $options = array())
{
    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))
    {
        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');
    }

    $self = get_called_class();
    return new $self($options);
}";}i:127;a:7:{s:4:"name";s:18:"get_console_output";s:8:"modifier";s:6:"public";s:11:"description";s:323:"<p>The GetConsoleOutput operation retrieves console output for the specified instance.</p>

<p>Instance console output is buffered and posted shortly after instance boot, reboot, and
termination. Amazon EC2 preserves the most recent 64 KB output which will be available for at least
one hour after the most recent post.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:64:"<p>The ID of the instance for which you want console output.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:512:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:215:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response. The value of <code>output</code> is automatically Base64-decoded.</p>";s:6:"source";s:483:"public function get_console_output($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;

    $response = $this-&gt;authenticate('GetConsoleOutput', $opt, $this-&gt;hostname);

    // Automatically Base64-decode the &lt;output&gt; value.
    if ($this-&gt;util-&gt;is_base64((string) $response-&gt;body-&gt;output))
    {
        $response-&gt;body-&gt;output = base64_decode($response-&gt;body-&gt;output);
    }

    return $response;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:34:"<p>Get the EC2 console output.</p>";s:4:"code";s:171:"// Instantiate the class
$ec2 = new AmazonEC2();

// Get console output
$response = $ec2-&gt;get_console_output('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:128;a:8:{s:4:"name";s:17:"get_password_data";s:8:"modifier";s:6:"public";s:11:"description";s:322:"<p>Retrieves the encrypted administrator password for the instances running Windows.</p>

<p>The Windows password is only generated the first time an AMI is launched. It is not generated for
rebundled AMIs or after the password is changed on an instance. The password is encrypted using the
key pair that you provided.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:84:"<p>The ID of the instance for which you want the Windows administrator password.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:812:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>DecryptPasswordWithKey</code> - <code>string</code> - Optional - Enables the decryption of the Administrator password for the given Microsoft Windows instance. Specifies the RSA private key that is associated with the keypair ID which was used to launch the Microsoft Windows instance.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1264:"public function get_password_data($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;

    // Unless DecryptPasswordWithKey is set, simply return the response.
    if (!isset($opt['DecryptPasswordWithKey']))
    {
        return $this-&gt;authenticate('GetPasswordData', $opt, $this-&gt;hostname);
    }

    // Otherwise, decrypt the password.
    else
    {
        // Get a resource representing the private key.
        $private_key = openssl_pkey_get_private($opt['DecryptPasswordWithKey']);
        unset($opt['DecryptPasswordWithKey']);

        // Fetch the encrypted password.
        $response = $this-&gt;authenticate('GetPasswordData', $opt, $this-&gt;hostname);
        $data = trim((string) $response-&gt;body-&gt;passwordData);

        // If it's Base64-encoded...
        if ($this-&gt;util-&gt;is_base64($data))
        {
            // Base64-decode it, and decrypt it with the private key.
            if (openssl_private_decrypt(base64_decode($data), $decrypted, $private_key))
            {
                // Replace the previous password data with the decrypted value.
                $response-&gt;body-&gt;passwordData = $decrypted;
            }
        }

        return $response;
    }
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:36:"<p>Get encoded Windows password.</p>";s:4:"code";s:170:"// Instantiate the class
$ec2 = new AmazonEC2();

// Get console output
$response = $ec2-&gt;get_password_data('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:2:{s:5:"title";s:57:"<p>Get the decrypted version of the Windows password.</p>";s:4:"code";s:338:"// Instantiate the class
$ec2 = new AmazonEC2();

// Get console output
$response = $ec2-&gt;get_password_data('i-1f549375', array(
	'DecryptPasswordWithKey' =&gt; file_get_contents('my-keypair.pem')
));

// Success?
var_dump($response-&gt;isOK());
var_dump(strlen((string) $response-&gt;body-&gt;passwordData)); // Length of the password";}}}s:7:"related";a:1:{s:6:"method";a:5:{i:0;s:132:"<a href="../amazonec2/activate_license.html" rel="../../index.html#m=amazonec2/activate_license"><code>activate_license()</code></a>";i:1;s:129:"<a href="../amazonec2/bundle_instance.html" rel="../../index.html#m=amazonec2/bundle_instance"><code>bundle_instance()</code></a>";i:2;s:138:"<a href="../amazonec2/cancel_bundle_task.html" rel="../../index.html#m=amazonec2/cancel_bundle_task"><code>cancel_bundle_task()</code></a>";i:3;s:138:"<a href="../amazonec2/deactivate_license.html" rel="../../index.html#m=amazonec2/deactivate_license"><code>deactivate_license()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_bundle_tasks.html" rel="../../index.html#m=amazonec2/describe_bundle_tasks"><code>describe_bundle_tasks()</code></a>";}}}i:129;a:5:{s:4:"name";s:15:"import_instance";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"platform";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:5355:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>LaunchSpecification</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Architecture</code> - <code>string</code> - Optional - </li><li><code>SecurityGroup</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>AdditionalInfo</code> - <code>string</code> - Optional - </li><li><code>UserData</code> - <code>string</code> - Optional - </li><li><code>InstanceType</code> - <code>string</code> - Optional -  [Allowed values: <code>t1.micro</code>, <code>m1.small</code>, <code>m1.medium</code>, <code>m1.large</code>, <code>m1.xlarge</code>, <code>m2.xlarge</code>, <code>m2.2xlarge</code>, <code>m2.4xlarge</code>, <code>m3.xlarge</code>, <code>m3.2xlarge</code>, <code>c1.medium</code>, <code>c1.xlarge</code>, <code>hi1.4xlarge</code>, <code>hs1.8xlarge</code>, <code>cc1.4xlarge</code>, <code>cc2.8xlarge</code>, <code>cg1.4xlarge</code>]</li><li><code>Placement</code> - <code>array</code> - Optional - Describes where an Amazon EC2 instance is running within an Amazon EC2 region. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The availability zone in which an Amazon EC2 instance runs.</li><li><code>GroupName</code> - <code>string</code> - Optional - The name of the <code>PlacementGroup</code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.</li><li><code>Tenancy</code> - <code>string</code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means all instances launched into the VPC will be launched as dedicated tenancy regardless of the tenancy assigned to the instance at launch.</li></ul></li></ul></li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - The BlockDeviceMappingItemType data type. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VirtualName</code> - <code>string</code> - Optional - Specifies the virtual device name.</li><li><code>DeviceName</code> - <code>string</code> - Optional - Specifies the device name (e.g., <code>/dev/sdh</code>).</li><li><code>Ebs</code> - <code>array</code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which the volume will be created.</li><li><code>VolumeSize</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>NoDevice</code> - <code>string</code> - Optional - Specifies the device name to suppress during instance launch.</li></ul></li></ul></li><li><code>Monitoring</code> - <code>boolean</code> - Optional - </li><li><code>SubnetId</code> - <code>string</code> - Optional - </li><li><code>DisableApiTermination</code> - <code>boolean</code> - Optional - </li><li><code>InstanceInitiatedShutdownBehavior</code> - <code>string</code> - Optional - </li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>DiskImage</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Image</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Format</code> - <code>string</code> - Required - </li><li><code>Bytes</code> - <code>long</code> - Required - </li><li><code>ImportManifestUrl</code> - <code>string</code> - Required - </li></ul></li></ul></li><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>Volume</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Size</code> - <code>long</code> - Required - </li></ul></li></ul></li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:692:"public function import_instance($platform, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['Platform'] = $platform;
    
    // Optional map (non-list)
    if (isset($opt['LaunchSpecification']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LaunchSpecification' =&gt; $opt['LaunchSpecification']
        )));
        unset($opt['LaunchSpecification']);
    }
    
    // Optional list + map
    if (isset($opt['DiskImage']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'DiskImage' =&gt; $opt['DiskImage']
        )));
        unset($opt['DiskImage']);
    }

    return $this-&gt;authenticate('ImportInstance', $opt);
}";}i:130;a:7:{s:4:"name";s:15:"import_key_pair";s:8:"modifier";s:6:"public";s:11:"description";s:752:"<p>Imports the public key from an RSA key pair created with a third-party tool. This operation differs
from CreateKeyPair as the private key is never transferred between the caller and AWS servers.</p>

<p>RSA key pairs are easily created on Microsoft Windows and Linux OS systems using the <code>ssh-keygen</code>
command line tool provided with the standard OpenSSH installation. Standard library support for RSA
key pair creation is also available for Java, Ruby, Python, and many other programming languages.</p>

<p>The following formats are supported:</p>

<ul><li>OpenSSH public key format.</li><li>Base64 encoded DER format.</li><li>SSH public key file format as specified in <a href="http://tools.ietf.org/html/rfc4716">RFC 4716</a>.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"key_name";s:4:"type";s:6:"string";s:11:"description";s:40:"<p>The unique name for the key pair.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:19:"public_key_material";s:4:"type";s:6:"string";s:11:"description";s:61:"<p>The public key portion of the key pair being imported.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:512:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This is useful for manually-managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:369:"public function import_key_pair($key_name, $public_key_material, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['KeyName'] = $key_name;
    $opt['PublicKeyMaterial'] = $this-&gt;util-&gt;is_base64($public_key_material) ? $public_key_material : base64_encode($public_key_material);

    return $this-&gt;authenticate('ImportKeyPair', $opt, $this-&gt;hostname);
}";s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:129:"<a href="../amazonec2/create_key_pair.html" rel="../../index.html#m=amazonec2/create_key_pair"><code>create_key_pair()</code></a>";i:1;s:129:"<a href="../amazonec2/delete_key_pair.html" rel="../../index.html#m=amazonec2/delete_key_pair"><code>delete_key_pair()</code></a>";i:2;s:138:"<a href="../amazonec2/describe_key_pairs.html" rel="../../index.html#m=amazonec2/describe_key_pairs"><code>describe_key_pairs()</code></a>";}}}i:131;a:5:{s:4:"name";s:13:"import_volume";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1277:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - </li><li><code>Image</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Format</code> - <code>string</code> - Required - </li><li><code>Bytes</code> - <code>long</code> - Required - </li><li><code>ImportManifestUrl</code> - <code>string</code> - Required - </li></ul></li></ul></li><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>Volume</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Size</code> - <code>long</code> - Required - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:587:"public function import_volume($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional map (non-list)
    if (isset($opt['Image']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Image' =&gt; $opt['Image']
        )));
        unset($opt['Image']);
    }
    
    // Optional map (non-list)
    if (isset($opt['Volume']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Volume' =&gt; $opt['Volume']
        )));
        unset($opt['Volume']);
    }

    return $this-&gt;authenticate('ImportVolume', $opt);
}";}i:132;a:9:{s:4:"name";s:22:"modify_image_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:74:"<p>The ModifyImageAttribute operation modifies an attribute of an AMI.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"image_id";s:4:"type";s:6:"string";s:11:"description";s:60:"<p>The ID of the AMI whose attribute you want to modify.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3341:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Attribute</code> - <code>string</code> - Optional - The name of the AMI attribute you want to modify. Available attributes: <code>launchPermission</code>, <code>productCodes</code></li><li><code>OperationType</code> - <code>string</code> - Optional - The type of operation being requested. Available operation types: <code>add</code>, <code>remove</code></li><li><code>UserId</code> - <code>string|array</code> - Optional - The AWS user ID being added to or removed from the list of users with launch permissions for this AMI. Only valid when the launchPermission attribute is being modified. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>UserGroup</code> - <code>string|array</code> - Optional - The user group being added to or removed from the list of user groups with launch permissions for this AMI. Only valid when the launchPermission attribute is being modified. Available user groups: <code>all</code> Pass a string for a single value, or an indexed array for multiple values.</li><li><code>ProductCode</code> - <code>string|array</code> - Optional - The list of product codes being added to or removed from the specified AMI. Only valid when the productCodes attribute is being modified. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Value</code> - <code>string</code> - Optional - The value of the attribute being modified. Only valid when the description attribute is being modified.</li><li><code>LaunchPermission</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Add</code> - <code>array</code> - Optional - Describes a permission to launch an Amazon Machine Image (AMI). <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of the user involved in this launch permission.</li><li><code>Group</code> - <code>string</code> - Optional - The AWS group of the user involved in this launch permission. Available groups: <code>all</code></li></ul></li></ul></li><li><code>Remove</code> - <code>array</code> - Optional - Describes a permission to launch an Amazon Machine Image (AMI). <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of the user involved in this launch permission.</li><li><code>Group</code> - <code>string</code> - Optional - The AWS group of the user involved in this launch permission. Available groups: <code>all</code></li></ul></li></ul></li></ul></li></ul></li><li><code>Description.Value</code> - <code>string</code> - Optional - String value</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1339:"public function modify_image_attribute($image_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ImageId'] = $image_id;
    
    // Optional list (non-map)
    if (isset($opt['UserId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'UserId' =&gt; (is_array($opt['UserId']) ? $opt['UserId'] : array($opt['UserId']))
        )));
        unset($opt['UserId']);
    }
    
    // Optional list (non-map)
    if (isset($opt['UserGroup']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'UserGroup' =&gt; (is_array($opt['UserGroup']) ? $opt['UserGroup'] : array($opt['UserGroup']))
        )));
        unset($opt['UserGroup']);
    }
    
    // Optional list (non-map)
    if (isset($opt['ProductCode']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ProductCode' =&gt; (is_array($opt['ProductCode']) ? $opt['ProductCode'] : array($opt['ProductCode']))
        )));
        unset($opt['ProductCode']);
    }
    
    // Optional map (non-list)
    if (isset($opt['LaunchPermission']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LaunchPermission' =&gt; $opt['LaunchPermission']
        )));
        unset($opt['LaunchPermission']);
    }

    return $this-&gt;authenticate('ModifyImageAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Modify an attribute of an image.</p>";s:4:"code";s:212:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;modify_image_attribute('ami-42ad462b', array(
	'LaunchPermission' =&gt; array(
		'Add' =&gt; array(array('Group' =&gt; 'all'))
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:2;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:3;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:4;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:300:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/ApiReference-query-ModifyImageAttribute.html">ModifyImageAttribute</a> operation introduced backwards-incompatible changes in the <code>2011-02-28</code> API release. The <code>Attribute</code> parameter is no longer required.</p>";}}i:133;a:9:{s:4:"name";s:25:"modify_instance_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:44:"<p>Modifies an attribute of an instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:64:"<p>The ID of the instance whose attribute is being modified.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3871:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Attribute</code> - <code>string</code> - Optional - The name of the attribute being modified. Available attribute names: <code>instanceType</code>, <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, <code>instanceInitiatedShutdownBehavior</code>, <code>rootDevice</code>, <code>blockDeviceMapping</code> [Allowed values: <code>instanceType</code>, <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, <code>instanceInitiatedShutdownBehavior</code>, <code>rootDeviceName</code>, <code>blockDeviceMapping</code>, <code>productCodes</code>, <code>sourceDestCheck</code>, <code>groupSet</code>, <code>ebsOptimized</code>]</li><li><code>Value</code> - <code>string</code> - Optional - The new value of the instance attribute being modified. Only valid when <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code> or <code>instanceInitiateShutdownBehavior</code> is specified as the attribute being modified.</li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - The new block device mappings for the instance whose attributes are being modified. Only valid when blockDeviceMapping is specified as the attribute being modified. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>DeviceName</code> - <code>string</code> - Optional - The device name (e.g., <code>/dev/sdh</code>) at which the block device is exposed on the instance.</li><li><code>Ebs</code> - <code>array</code> - Optional - The EBS instance block device specification describing the EBS block device to map to the specified device name on a running instance. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VolumeId</code> - <code>string</code> - Optional - The ID of the EBS volume that should be mounted as a block device on an Amazon EC2 instance.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li></ul></li></ul></li><li><code>VirtualName</code> - <code>string</code> - Optional - The virtual device name.</li><li><code>NoDevice</code> - <code>string</code> - Optional - When set to the empty string, specifies that the device name in this object should not be mapped to any real device.</li></ul></li></ul></li><li><code>SourceDestCheck.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>DisableApiTermination.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>InstanceType.Value</code> - <code>string</code> - Optional - String value</li><li><code>Kernel.Value</code> - <code>string</code> - Optional - String value</li><li><code>Ramdisk.Value</code> - <code>string</code> - Optional - String value</li><li><code>UserData.Value</code> - <code>string</code> - Optional - String value</li><li><code>InstanceInitiatedShutdownBehavior.Value</code> - <code>string</code> - Optional - String value</li><li><code>GroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>EbsOptimized.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:762:"public function modify_instance_attribute($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    
    // Optional list + map
    if (isset($opt['BlockDeviceMapping']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']
        )));
        unset($opt['BlockDeviceMapping']);
    }
    
    // Optional list (non-map)
    if (isset($opt['GroupId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'GroupId' =&gt; (is_array($opt['GroupId']) ? $opt['GroupId'] : array($opt['GroupId']))
        )));
        unset($opt['GroupId']);
    }

    return $this-&gt;authenticate('ModifyInstanceAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:60:"<p>Modify an attribute on a stopped EBS-backed instance.</p>";s:4:"code";s:206:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;modify_instance_attribute('i-1f549375', array(
	'InstanceType.Value' =&gt; 'c1.medium'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:3;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:4;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:306:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/ApiReference-query-ModifyInstanceAttribute.html">ModifyInstanceAttribute</a> operation introduced backwards-incompatible changes in the <code>2011-02-28</code> API release. The <code>Attribute</code> parameter is no longer required.</p>";}}i:134;a:6:{s:4:"name";s:34:"modify_network_interface_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1183:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description.Value</code> - <code>string</code> - Optional - String value</li><li><code>SourceDestCheck.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>SecurityGroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Attachment</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>AttachmentId</code> - <code>string</code> - Optional - </li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:825:"public function modify_network_interface_attribute($network_interface_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    // Optional list (non-map)
    if (isset($opt['SecurityGroupId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))
        )));
        unset($opt['SecurityGroupId']);
    }
    
    // Optional map (non-list)
    if (isset($opt['Attachment']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Attachment' =&gt; $opt['Attachment']
        )));
        unset($opt['Attachment']);
    }

    return $this-&gt;authenticate('ModifyNetworkInterfaceAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:64:"<p>Modify, describe, and reset network interface attributes.</p>";s:4:"code";s:874:"$ec2 = new AmazonEC2();

###########################################################################
# Modify Network Interface Attribute

$response = $ec2-&gt;modify_network_interface_attribute($network_interface_id, array(
	'SourceDestCheck.Value' =&gt; 'false',
));

var_dump($response-&gt;isOK());

###########################################################################
# Describe Network Interface Attributes

$response = $ec2-&gt;describe_network_interface_attribute($network_interface_id, array(
        'Attribute' =&gt; 'sourceDestCheck',
));

var_dump($response-&gt;isOK());

###########################################################################
# Reset Network Interface Attribute

$response = $ec2-&gt;reset_network_interface_attribute($network_interface_id, array(
	'Attribute' =&gt; 'sourceDestCheck',
));

var_dump($response-&gt;isOK());

sleep(5);";s:6:"result";s:32:"bool(true)
bool(true)
bool(true)";}}}i:135;a:9:{s:4:"name";s:25:"modify_snapshot_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:69:"<p>Adds or remove permission settings for the specified snapshot.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"snapshot_id";s:4:"type";s:6:"string";s:11:"description";s:70:"<p>The ID of the EBS snapshot whose attributes are being modified.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3125:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Attribute</code> - <code>string</code> - Optional - The name of the attribute being modified. Available attribute names: <code>createVolumePermission</code> [Allowed values: <code>productCodes</code>, <code>createVolumePermission</code>]</li><li><code>OperationType</code> - <code>string</code> - Optional - The operation to perform on the attribute. Available operation names: <code>add</code>, <code>remove</code></li><li><code>UserId</code> - <code>string|array</code> - Optional - The AWS user IDs to add to or remove from the list of users that have permission to create EBS volumes from the specified snapshot. Currently supports &#8220;all&#8221;. <p class="note">Only valid when the <code>createVolumePermission</code> attribute is being modified.</p> Pass a string for a single value, or an indexed array for multiple values.</li><li><code>UserGroup</code> - <code>string|array</code> - Optional - The AWS group names to add to or remove from the list of groups that have permission to create EBS volumes from the specified snapshot. Currently supports &#8220;all&#8221;. <p class="note">Only valid when the <code>createVolumePermission</code> attribute is being modified.</p> Pass a string for a single value, or an indexed array for multiple values.</li><li><code>CreateVolumePermission</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Add</code> - <code>array</code> - Optional - Describes a permission allowing either a user or group to create a new EBS volume from a snapshot. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The user ID of the user that can create volumes from the snapshot.</li><li><code>Group</code> - <code>string</code> - Optional - The group that is allowed to create volumes from the snapshot (currently supports &#8220;all&#8221;).</li></ul></li></ul></li><li><code>Remove</code> - <code>array</code> - Optional - Describes a permission allowing either a user or group to create a new EBS volume from a snapshot. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The user ID of the user that can create volumes from the snapshot.</li><li><code>Group</code> - <code>string</code> - Optional - The group that is allowed to create volumes from the snapshot (currently supports &#8220;all&#8221;).</li></ul></li></ul></li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1071:"public function modify_snapshot_attribute($snapshot_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SnapshotId'] = $snapshot_id;
    
    // Optional list (non-map)
    if (isset($opt['UserId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'UserId' =&gt; (is_array($opt['UserId']) ? $opt['UserId'] : array($opt['UserId']))
        )));
        unset($opt['UserId']);
    }
    
    // Optional list (non-map)
    if (isset($opt['UserGroup']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'UserGroup' =&gt; (is_array($opt['UserGroup']) ? $opt['UserGroup'] : array($opt['UserGroup']))
        )));
        unset($opt['UserGroup']);
    }
    
    // Optional map (non-list)
    if (isset($opt['CreateVolumePermission']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'CreateVolumePermission' =&gt; $opt['CreateVolumePermission']
        )));
        unset($opt['CreateVolumePermission']);
    }

    return $this-&gt;authenticate('ModifySnapshotAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:42:"<p>Modify an attribute for a snapshot.</p>";s:4:"code";s:266:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;modify_snapshot_attribute($snapshot_id, array(
	'CreateVolumePermission' =&gt; array(
		'Add' =&gt; array(array('UserId' =&gt; '960747153117'))
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:6;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:7;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:8;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:9;s:156:"<a href="../amazonec2/reset_snapshot_attribute.html" rel="../../index.html#m=amazonec2/reset_snapshot_attribute"><code>reset_snapshot_attribute()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:340:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/ApiReference-query-ModifySnapshotAttribute.html">ModifySnapshotAttribute</a> operation introduced backwards-incompatible changes in the <code>2011-11-01</code> API release. Parameters that used to be optional are now required, and the function signature has changed.</p>";}}i:136;a:5:{s:4:"name";s:23:"modify_volume_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"volume_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:596:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>AutoEnableIO.Value</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:205:"public function modify_volume_attribute($volume_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VolumeId'] = $volume_id;
    
    return $this-&gt;authenticate('ModifyVolumeAttribute', $opt);
}";}i:137;a:5:{s:4:"name";s:20:"modify_vpc_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"vpc_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:709:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnableDnsSupport.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>EnableDnsHostnames.Value</code> - <code>boolean</code> - Optional - Boolean value</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:190:"public function modify_vpc_attribute($vpc_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['VpcId'] = $vpc_id;
    
    return $this-&gt;authenticate('ModifyVpcAttribute', $opt);
}";}i:138;a:8:{s:4:"name";s:17:"monitor_instances";s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>Enables monitoring for a running instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:145:"<p>The list of Amazon EC2 instances on which to enable monitoring. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:354:"public function monitor_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('MonitorInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Enable monitoring for an instance.</p>";s:4:"code";s:171:"// Instantiate the class
$ec2 = new AmazonEC2();

// Terminate instances
$response = $ec2-&gt;monitor_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:141:"<a href="../amazonec2/unmonitor_instances.html" rel="../../index.html#m=amazonec2/unmonitor_instances"><code>unmonitor_instances()</code></a>";}}i:139;a:8:{s:4:"name";s:36:"purchase_reserved_instances_offering";s:8:"modifier";s:6:"public";s:11:"description";s:322:"<p>The PurchaseReservedInstancesOffering operation purchases a Reserved Instance for use with your
account. With Amazon EC2 Reserved Instances, you purchase the right to launch Amazon EC2
instances for a period of time (without getting insufficient capacity errors) and pay a lower
usage rate for the actual time used.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:30:"reserved_instances_offering_id";s:4:"type";s:6:"string";s:11:"description";s:72:"<p>The unique ID of the Reserved Instances offering being purchased.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"instance_count";s:4:"type";s:7:"integer";s:11:"description";s:52:"<p>The number of Reserved Instances to purchase.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:835:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>LimitPrice</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Amount</code> - <code>double</code> - Optional - </li><li><code>CurrencyCode</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:589:"public function purchase_reserved_instances_offering($reserved_instances_offering_id, $instance_count, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ReservedInstancesOfferingId'] = $reserved_instances_offering_id;
    $opt['InstanceCount'] = $instance_count;
    
    // Optional map (non-list)
    if (isset($opt['LimitPrice']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LimitPrice' =&gt; $opt['LimitPrice']
        )));
        unset($opt['LimitPrice']);
    }

    return $this-&gt;authenticate('PurchaseReservedInstancesOffering', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Purchase a reserved instances offering.</p>";s:4:"code";s:196:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;purchase_reserved_instances_offering('438012d3-352b-4361-9d2e-a3166db861b1', 1);

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:165:"<a href="../amazonec2/describe_reserved_instances.html" rel="../../index.html#m=amazonec2/describe_reserved_instances"><code>describe_reserved_instances()</code></a>";i:1;s:195:"<a href="../amazonec2/describe_reserved_instances_offerings.html" rel="../../index.html#m=amazonec2/describe_reserved_instances_offerings"><code>describe_reserved_instances_offerings()</code></a>";}}}i:140;a:8:{s:4:"name";s:16:"reboot_instances";s:8:"modifier";s:6:"public";s:11:"description";s:305:"<p>The RebootInstances operation requests a reboot of one or more instances. This operation is
asynchronous; it only queues a request to reboot the specified instance(s). The operation will
succeed if the instances are valid and belong to the user. Requests to reboot terminated
instances are ignored.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:117:"<p>The list of instances to terminate. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:352:"public function reboot_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('RebootInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:26:"<p>Reboot an instance.</p>";s:4:"code";s:147:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;reboot_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:4;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:141;a:9:{s:4:"name";s:14:"register_image";s:8:"modifier";s:6:"public";s:11:"description";s:738:"<p>The RegisterImage operation registers an AMI with Amazon EC2. Images must be registered before
they can be launched. For more information, see RunInstances.</p>

<p>Each AMI is associated with an unique ID which is provided by the Amazon EC2 service through
the RegisterImage operation. During registration, Amazon EC2 retrieves the specified image
manifest from Amazon S3 and verifies that the image is owned by the user registering the image.</p>

<p>The image manifest is retrieved once and stored within the Amazon EC2. Any modifications to an
image in Amazon S3 invalidates this registration. If you make changes to an image, deregister
the previous image and register the new image. For more information, see DeregisterImage.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3302:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ImageLocation</code> - <code>string</code> - Optional - The full path to your AMI manifest in Amazon S3 storage.</li><li><code>Name</code> - <code>string</code> - Optional - The name to give the new Amazon Machine Image. Constraints: 3-128 alphanumeric characters, parenthesis (<code>()</code>), commas (<code>,</code>), slashes (<code>/</code>), dashes (<code>-</code>), or underscores(<code>_</code>)</li><li><code>Description</code> - <code>string</code> - Optional - The description describing the new AMI.</li><li><code>Architecture</code> - <code>string</code> - Optional - The architecture of the image. Valid Values: <code>i386</code>, <code>x86_64</code></li><li><code>KernelId</code> - <code>string</code> - Optional - The optional ID of a specific kernel to register with the new AMI.</li><li><code>RamdiskId</code> - <code>string</code> - Optional - The optional ID of a specific ramdisk to register with the new AMI. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether you need to specify a RAM disk.</li><li><code>RootDeviceName</code> - <code>string</code> - Optional - The root device name (e.g., <code>/dev/sda1</code>).</li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - The block device mappings for the new AMI, which specify how different block devices (ex: EBS volumes and ephemeral drives) will be exposed on instances launched from the new image. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VirtualName</code> - <code>string</code> - Optional - Specifies the virtual device name.</li><li><code>DeviceName</code> - <code>string</code> - Optional - Specifies the device name (e.g., <code>/dev/sdh</code>).</li><li><code>Ebs</code> - <code>array</code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which the volume will be created.</li><li><code>VolumeSize</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>NoDevice</code> - <code>string</code> - Optional - Specifies the device name to suppress during instance launch.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:413:"public function register_image($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['BlockDeviceMapping']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']
        )));
        unset($opt['BlockDeviceMapping']);
    }

    return $this-&gt;authenticate('RegisterImage', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:33:"<p>Register an S3-backed AMI.</p>";s:4:"code";s:919:"// Instantiate the class
$ec2 = new AmazonEC2();

// Register the image
$response = $ec2-&gt;register_image(array(
	'ImageLocation' =&gt; 'my-image-bucket/image01.manifest.xml',
	'Name' =&gt; 'my-image',
	'Description' =&gt; 'This is a sample description.',
	'BlockDeviceMapping' =&gt; array(
		array( // BlockDeviceMapping.0.{key}={value}
			&quot;DeviceName&quot; =&gt; &quot;/dev/sdg&quot;,
			&quot;VirtualName&quot; =&gt; &quot;sdg&quot;,
			&quot;Ebs&quot; =&gt; array(
				&quot;VolumeSize&quot; =&gt; 5,
				&quot;DeleteOnTermination&quot; =&gt; &quot;true&quot;
			)
		),
		array( // BlockDeviceMapping.1.{key}={value}
			&quot;DeviceName&quot; =&gt; &quot;/dev/sdh&quot;,
			&quot;VirtualName&quot; =&gt; &quot;sdh&quot;,
			&quot;Ebs&quot; =&gt; array(
				&quot;VolumeSize&quot; =&gt; 5,
				&quot;DeleteOnTermination&quot; =&gt; &quot;true&quot;
			)
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:2;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:3;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:4;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:5;s:147:"<a href="../amazonec2/reset_image_attribute.html" rel="../../index.html#m=amazonec2/reset_image_attribute"><code>reset_image_attribute()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:189:"<p>The <code>$image_location</code> parameter is no longer required. To specify the image location for S3-backed AMIs, pass a value to the <code>ImageLocation</code> optional parameter.</p>";}}i:142;a:8:{s:4:"name";s:32:"register_streaming_read_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:753:"<p>Register a callback function to execute whenever a data stream is read from using
<a href="../cfrequest/streaming_read_callback.html" rel="../../index.html#m=cfrequest/streaming_read_callback"><code>CFRequest::streaming_read_callback()</code></a>.</p>

<p>The user-defined callback function should accept three arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$file_handle</code> - <code>resource</code> - Required - The file handle resource that represents the file on the local file system.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:143:"public function register_streaming_read_callback($callback)
{
    $this-&gt;registered_streaming_read_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:85:"<p>Register a callback function to execute when data is read from an open stream.</p>";s:4:"code";s:694:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $file_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is read locally.
$s3-&gt;register_streaming_read_callback('callback');

// Download a public object.
$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(
	'fileUpload' =&gt; './uploads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:143;a:8:{s:4:"name";s:33:"register_streaming_write_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:608:"<p>Register a callback function to execute whenever a data stream is written to using
<a href="../cfrequest/streaming_write_callback.html" rel="../../index.html#m=cfrequest/streaming_write_callback"><code>CFRequest::streaming_write_callback()</code></a>.</p>

<p>The user-defined callback function should accept two arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:145:"public function register_streaming_write_callback($callback)
{
    $this-&gt;registered_streaming_write_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:86:"<p>Register a callback function to execute when data is written to an open stream.</p>";s:4:"code";s:685:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is written locally.
$s3-&gt;register_streaming_write_callback('callback');

// Download a public object.
$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(
	'fileDownload' =&gt; './downloads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:144;a:8:{s:4:"name";s:15:"release_address";s:8:"modifier";s:6:"public";s:11:"description";s:711:"<p>The ReleaseAddress operation releases an elastic IP address associated with your account.</p>

<p class="note">
Releasing an IP address automatically disassociates it from any instance with which it is
associated. For more information, see DisassociateAddress.
</p>

<p class="important"></p>

<p>After releasing an elastic IP address, it is released to the IP address pool and might no
longer be available to your account. Make sure to update your DNS records and any servers or
devices that communicate with the address.</p>

<p>If you run this operation on an elastic IP address that is already released, the address might
be assigned to another account which will cause Amazon EC2 to return an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:810:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>PublicIp</code> - <code>string</code> - Optional - The elastic IP address that you are releasing from your account.</li><li><code>AllocationId</code> - <code>string</code> - Optional - The allocation ID that AWS provided when you allocated the address for use with Amazon VPC.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:151:"public function release_address($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('ReleaseAddress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Release an Elastic IP address.</p>";s:4:"code";s:176:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;release_address(array(
	'PublicIp' =&gt; '184.73.247.11'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:4:{i:0;s:132:"<a href="../amazonec2/allocate_address.html" rel="../../index.html#m=amazonec2/allocate_address"><code>allocate_address()</code></a>";i:1;s:135:"<a href="../amazonec2/associate_address.html" rel="../../index.html#m=amazonec2/associate_address"><code>associate_address()</code></a>";i:2;s:138:"<a href="../amazonec2/describe_addresses.html" rel="../../index.html#m=amazonec2/describe_addresses"><code>describe_addresses()</code></a>";i:3;s:144:"<a href="../amazonec2/disassociate_address.html" rel="../../index.html#m=amazonec2/disassociate_address"><code>disassociate_address()</code></a>";}}}i:145;a:8:{s:4:"name";s:31:"replace_network_acl_association";s:8:"modifier";s:6:"public";s:11:"description";s:272:"<p>Changes which network ACL a subnet is associated with. By default when you create a subnet,
it&#8217;s automatically associated with the default network ACL. For more information about network
ACLs, go to Network ACLs in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"association_id";s:4:"type";s:6:"string";s:11:"description";s:99:"<p>The ID representing the current association between the original network ACL and the subnet.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"network_acl_id";s:4:"type";s:6:"string";s:11:"description";s:58:"<p>The ID of the new ACL to associate with the subnet.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:296:"public function replace_network_acl_association($association_id, $network_acl_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['AssociationId'] = $association_id;
    $opt['NetworkAclId'] = $network_acl_id;
    
    return $this-&gt;authenticate('ReplaceNetworkAclAssociation', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:73:"<p>Replace an existing Network Access Control List (ACL) association.</p>";s:4:"code";s:148:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;replace_network_acl_association('rtbassoc-babe3ed3', 'acl-4abf3f23');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:3;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:5;s:159:"<a href="../amazonec2/replace_network_acl_entry.html" rel="../../index.html#m=amazonec2/replace_network_acl_entry"><code>replace_network_acl_entry()</code></a>";}}}i:146;a:8:{s:4:"name";s:25:"replace_network_acl_entry";s:8:"modifier";s:6:"public";s:11:"description";s:163:"<p>Replaces an entry (i.e., rule) in a network ACL. For more information about network ACLs, go to
Network ACLs in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:7:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"network_acl_id";s:4:"type";s:6:"string";s:11:"description";s:54:"<p>ID of the ACL where the entry will be replaced.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"rule_number";s:4:"type";s:7:"integer";s:11:"description";s:43:"<p>Rule number of the entry to replace.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"protocol";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>IP protocol the rule applies to. Valid Values: <code>tcp</code>, <code>udp</code>, <code>icmp</code> or an IP protocol number.</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"rule_action";s:4:"type";s:6:"string";s:11:"description";s:118:"<p>Whether to allow or deny traffic that matches the rule. [Allowed values: <code>allow</code>, <code>deny</code>]</p>";}i:4;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"egress";s:4:"type";s:7:"boolean";s:11:"description";s:127:"<p>Whether this rule applies to egress traffic from the subnet (<code>true</code>) or ingress traffic (<code>false</code>).</p>";}i:5;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"cidr_block";s:4:"type";s:6:"string";s:11:"description";s:92:"<p>The CIDR range to allow or deny, in CIDR notation (e.g., <code>172.16.0.0/24</code>).</p>";}i:6;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1673:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Icmp</code> - <code>array</code> - Optional - ICMP values. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Type</code> - <code>integer</code> - Optional - For the ICMP protocol, the ICMP type. A value of <code>-1</code> is a wildcard meaning all types. Required if specifying <code>icmp</code> for the protocol.</li><li><code>Code</code> - <code>integer</code> - Optional - For the ICMP protocol, the ICMP code. A value of <code>-1</code> is a wildcard meaning all codes. Required if specifying <code>icmp</code> for the protocol.</li></ul></li></ul></li><li><code>PortRange</code> - <code>array</code> - Optional - Port ranges. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>From</code> - <code>integer</code> - Optional - The first port in the range. Required if specifying <code>tcp</code> or <code>udp</code> for the protocol.</li><li><code>To</code> - <code>integer</code> - Optional - The last port in the range. Required if specifying <code>tcp</code> or <code>udp</code> for the protocol.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:910:"public function replace_network_acl_entry($network_acl_id, $rule_number, $protocol, $rule_action, $egress, $cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkAclId'] = $network_acl_id;
    $opt['RuleNumber'] = $rule_number;
    $opt['Protocol'] = $protocol;
    $opt['RuleAction'] = $rule_action;
    $opt['Egress'] = $egress;
    $opt['CidrBlock'] = $cidr_block;
    
    // Optional map (non-list)
    if (isset($opt['Icmp']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Icmp' =&gt; $opt['Icmp']
        )));
        unset($opt['Icmp']);
    }
    
    // Optional map (non-list)
    if (isset($opt['PortRange']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'PortRange' =&gt; $opt['PortRange']
        )));
        unset($opt['PortRange']);
    }

    return $this-&gt;authenticate('ReplaceNetworkAclEntry', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:74:"<p>Replace an existing entry in the Network Access Control List (ACL).</p>";s:4:"code";s:250:"$ec2 = new AmazonEC2();

$tcp = 6;
$response = $ec2-&gt;replace_network_acl_entry('acl-4abf3f23', 1, $tcp, 'allow', 'true', '172.16.0.0/24', array(
	'PortRange' =&gt; array(
		'From' =&gt; 443,
		'To' =&gt; 443
	)
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:138:"<a href="../amazonec2/create_network_acl.html" rel="../../index.html#m=amazonec2/create_network_acl"><code>create_network_acl()</code></a>";i:1;s:156:"<a href="../amazonec2/create_network_acl_entry.html" rel="../../index.html#m=amazonec2/create_network_acl_entry"><code>create_network_acl_entry()</code></a>";i:2;s:138:"<a href="../amazonec2/delete_network_acl.html" rel="../../index.html#m=amazonec2/delete_network_acl"><code>delete_network_acl()</code></a>";i:3;s:156:"<a href="../amazonec2/delete_network_acl_entry.html" rel="../../index.html#m=amazonec2/delete_network_acl_entry"><code>delete_network_acl_entry()</code></a>";i:4;s:147:"<a href="../amazonec2/describe_network_acls.html" rel="../../index.html#m=amazonec2/describe_network_acls"><code>describe_network_acls()</code></a>";i:5;s:177:"<a href="../amazonec2/replace_network_acl_association.html" rel="../../index.html#m=amazonec2/replace_network_acl_association"><code>replace_network_acl_association()</code></a>";}}}i:147;a:8:{s:4:"name";s:13:"replace_route";s:8:"modifier";s:6:"public";s:11:"description";s:270:"<p>Replaces an existing route within a route table in a VPC. For more information about route
tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:66:"<p>The ID of the route table where the route will be replaced.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:22:"destination_cidr_block";s:4:"type";s:6:"string";s:11:"description";s:175:"<p>The CIDR address block used for the destination match. For example: <code>0.0.0.0/0</code>. The value you provide must match the CIDR of an existing route in the table.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:824:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GatewayId</code> - <code>string</code> - Optional - The ID of a VPN or Internet gateway attached to your VPC.</li><li><code>InstanceId</code> - <code>string</code> - Optional - The ID of a NAT instance in your VPC.</li><li><code>NetworkInterfaceId</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:285:"public function replace_route($route_table_id, $destination_cidr_block, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['RouteTableId'] = $route_table_id;
    $opt['DestinationCidrBlock'] = $destination_cidr_block;
    
    return $this-&gt;authenticate('ReplaceRoute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Replace an existing VPC route.</p>";s:4:"code";s:166:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;replace_route('rtb-e68b0b8f', '0.0.0.0/0', array(
	'GatewayId' =&gt; 'igw-8c8e0ee5'
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:4;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:5;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:6;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:7;s:177:"<a href="../amazonec2/replace_route_table_association.html" rel="../../index.html#m=amazonec2/replace_route_table_association"><code>replace_route_table_association()</code></a>";}}}i:148;a:8:{s:4:"name";s:31:"replace_route_table_association";s:8:"modifier";s:6:"public";s:11:"description";s:601:"<p>Changes the route table associated with a given subnet in a VPC. After you execute this action,
the subnet uses the routes in the new route table it&#8217;s associated with. For more information
about route tables, go to <a href=
"http://docs.amazonwebservices.com/AmazonVPC/latest/UserGuide/VPC_Route_Tables.html">Route
Tables</a> in the Amazon Virtual Private Cloud User Guide.</p>

<p>You can also use this to change which table is the main route table in the VPC. You just
specify the main route table&#8217;s association ID and the route table that you want to be the new
main route table.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"association_id";s:4:"type";s:6:"string";s:11:"description";s:99:"<p>The ID representing the current association between the original route table and the subnet.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:14:"route_table_id";s:4:"type";s:6:"string";s:11:"description";s:66:"<p>The ID of the new route table to associate with the subnet.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:296:"public function replace_route_table_association($association_id, $route_table_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['AssociationId'] = $association_id;
    $opt['RouteTableId'] = $route_table_id;
    
    return $this-&gt;authenticate('ReplaceRouteTableAssociation', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:69:"<p>Replace an existing VPC route table association with a subnet.</p>";s:4:"code";s:148:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;replace_route_table_association('rtbassoc-ac8a0ac5', 'rtb-e68b0b8f');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:147:"<a href="../amazonec2/associate_route_table.html" rel="../../index.html#m=amazonec2/associate_route_table"><code>associate_route_table()</code></a>";i:1;s:120:"<a href="../amazonec2/create_route.html" rel="../../index.html#m=amazonec2/create_route"><code>create_route()</code></a>";i:2;s:138:"<a href="../amazonec2/create_route_table.html" rel="../../index.html#m=amazonec2/create_route_table"><code>create_route_table()</code></a>";i:3;s:120:"<a href="../amazonec2/delete_route.html" rel="../../index.html#m=amazonec2/delete_route"><code>delete_route()</code></a>";i:4;s:138:"<a href="../amazonec2/delete_route_table.html" rel="../../index.html#m=amazonec2/delete_route_table"><code>delete_route_table()</code></a>";i:5;s:147:"<a href="../amazonec2/describe_route_tables.html" rel="../../index.html#m=amazonec2/describe_route_tables"><code>describe_route_tables()</code></a>";i:6;s:156:"<a href="../amazonec2/disassociate_route_table.html" rel="../../index.html#m=amazonec2/disassociate_route_table"><code>disassociate_route_table()</code></a>";i:7;s:123:"<a href="../amazonec2/replace_route.html" rel="../../index.html#m=amazonec2/replace_route"><code>replace_route()</code></a>";}}}i:149;a:5:{s:4:"name";s:22:"report_instance_status";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1382:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Status</code> - <code>string</code> - Optional - </li><li><code>StartTime</code> - <code>string</code> - Optional -  May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>EndTime</code> - <code>string</code> - Optional -  May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>ReasonCode</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1086:"public function report_instance_status($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional DateTime
    if (isset($opt['StartTime']))
    {
        $opt['StartTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['StartTime']);
    }
    
    // Optional DateTime
    if (isset($opt['EndTime']))
    {
        $opt['EndTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['EndTime']);
    }

    // Optional list (non-map)
    if (isset($opt['InstanceId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'InstanceId' =&gt; (is_array($opt['InstanceId']) ? $opt['InstanceId'] : array($opt['InstanceId']))
        )));
        unset($opt['InstanceId']);
    }
    
    // Optional list (non-map)
    if (isset($opt['ReasonCode']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ReasonCode' =&gt; (is_array($opt['ReasonCode']) ? $opt['ReasonCode'] : array($opt['ReasonCode']))
        )));
        unset($opt['ReasonCode']);
    }

    return $this-&gt;authenticate('ReportInstanceStatus', $opt);
}";}i:150;a:8:{s:4:"name";s:22:"request_spot_instances";s:8:"modifier";s:6:"public";s:11:"description";s:628:"<p>Creates a Spot Instance request.</p>

<p>Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that
you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based
on available Spot Instance capacity and current spot instance requests.</p>

<p>For conceptual information about Spot Instances, refer to the <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/DeveloperGuide/">Amazon Elastic Compute
Cloud Developer Guide</a> or <a href=
"http://docs.amazonwebservices.com/AWSEC2/2009-11-30/UserGuide/">Amazon Elastic Compute Cloud
User Guide.</a></p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:10:"spot_price";s:4:"type";s:6:"string";s:11:"description";s:96:"<p>Specifies the maximum hourly price for any Spot Instance launched to fulfill the request.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:8458:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>InstanceCount</code> - <code>integer</code> - Optional - Specifies the maximum number of Spot Instances to launch.</li><li><code>Type</code> - <code>string</code> - Optional - Specifies the Spot Instance type. [Allowed values: <code>one-time</code>, <code>persistent</code>]</li><li><code>ValidFrom</code> - <code>string</code> - Optional - Defines the start date of the request. If this is a one-time request, the request becomes active at this date and time and remains active until all instances launch, the request expires, or the request is canceled. If the request is persistent, the request becomes active at this date and time and remains active until it expires or is canceled. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>ValidUntil</code> - <code>string</code> - Optional - End date of the request. If this is a one-time request, the request remains active until all instances launch, the request is canceled, or this date is reached. If the request is persistent, it remains active until it is canceled or this date and time is reached. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>LaunchGroup</code> - <code>string</code> - Optional - Specifies the instance launch group. Launch groups are Spot Instances that launch and terminate together.</li><li><code>AvailabilityZoneGroup</code> - <code>string</code> - Optional - Specifies the Availability Zone group. When specifying the same Availability Zone group for all Spot Instance requests, all Spot Instances are launched in the same Availability Zone.</li><li><code>LaunchSpecification</code> - <code>array</code> - Optional - Specifies additional launch instance information. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>ImageId</code> - <code>string</code> - Optional - The AMI ID.</li><li><code>KeyName</code> - <code>string</code> - Optional - The name of the key pair.</li><li><code>GroupSet</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>GroupName</code> - <code>string</code> - Optional - </li><li><code>GroupId</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>SecurityGroup</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>UserData</code> - <code>string</code> - Optional - Optional data, specific to a user&#8217;s application, to provide in the launch request. All instances that collectively comprise the launch request have access to this data. User data is never returned through API responses.</li><li><code>AddressingType</code> - <code>string</code> - Optional - Deprecated.</li><li><code>InstanceType</code> - <code>string</code> - Optional - Specifies the instance type. [Allowed values: <code>t1.micro</code>, <code>m1.small</code>, <code>m1.medium</code>, <code>m1.large</code>, <code>m1.xlarge</code>, <code>m2.xlarge</code>, <code>m2.2xlarge</code>, <code>m2.4xlarge</code>, <code>m3.xlarge</code>, <code>m3.2xlarge</code>, <code>c1.medium</code>, <code>c1.xlarge</code>, <code>hi1.4xlarge</code>, <code>hs1.8xlarge</code>, <code>cc1.4xlarge</code>, <code>cc2.8xlarge</code>, <code>cg1.4xlarge</code>]</li><li><code>Placement</code> - <code>array</code> - Optional - Defines a placement item. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The availability zone in which an Amazon EC2 instance runs.</li><li><code>GroupName</code> - <code>string</code> - Optional - The name of the <code>PlacementGroup</code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.</li></ul></li></ul></li><li><code>KernelId</code> - <code>string</code> - Optional - Specifies the ID of the kernel to select.</li><li><code>RamdiskId</code> - <code>string</code> - Optional - Specifies the ID of the RAM disk to select. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether or not you need to specify a RAM disk and search for the kernel ID.</li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - Specifies how block devices are exposed to the instance. Each mapping is made up of a virtualName and a deviceName. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VirtualName</code> - <code>string</code> - Optional - Specifies the virtual device name.</li><li><code>DeviceName</code> - <code>string</code> - Optional - Specifies the device name (e.g., <code>/dev/sdh</code>).</li><li><code>Ebs</code> - <code>array</code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which the volume will be created.</li><li><code>VolumeSize</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>NoDevice</code> - <code>string</code> - Optional - Specifies the device name to suppress during instance launch.</li></ul></li></ul></li><li><code>Monitoring.Enabled</code> - <code>boolean</code> - Optional - Enables monitoring for the instance.</li><li><code>SubnetId</code> - <code>string</code> - Optional - Specifies the Amazon VPC subnet ID within which to launch the instance(s) for Amazon Virtual Private Cloud.</li><li><code>NetworkInterfaceSet</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>NetworkInterfaceId</code> - <code>string</code> - Optional - </li><li><code>DeviceIndex</code> - <code>integer</code> - Optional - </li><li><code>SubnetId</code> - <code>string</code> - Optional - </li><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - </li><li><code>SecurityGroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - </li><li><code>PrivateIpAddresses</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress</code> - <code>string</code> - Required - </li><li><code>Primary</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>SecondaryPrivateIpAddressCount</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>IamInstanceProfile</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Arn</code> - <code>string</code> - Optional - </li><li><code>Name</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>EbsOptimized</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:811:"public function request_spot_instances($spot_price, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SpotPrice'] = $spot_price;
    
    // Optional DateTime
    if (isset($opt['ValidFrom']))
    {
        $opt['ValidFrom'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['ValidFrom']);
    }
    
    // Optional DateTime
    if (isset($opt['ValidUntil']))
    {
        $opt['ValidUntil'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['ValidUntil']);
    }

    // Optional map (non-list)
    if (isset($opt['LaunchSpecification']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'LaunchSpecification' =&gt; $opt['LaunchSpecification']
        )));
        unset($opt['LaunchSpecification']);
    }

    return $this-&gt;authenticate('RequestSpotInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:59:"<p>Request a spot instance up to a certain price point.</p>";s:4:"code";s:286:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;request_spot_instances('0.05', array(
	'Type' =&gt; 'one-time',
	'ValidUntil' =&gt; 'tomorrow',
	'LaunchSpecification' =&gt; array(
		'ImageId' =&gt; 'ami-42ad462b',
		'InstanceType' =&gt; 'm1.small'
	),
));

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:171:"<a href="../amazonec2/cancel_spot_instance_requests.html" rel="../../index.html#m=amazonec2/cancel_spot_instance_requests"><code>cancel_spot_instance_requests()</code></a>";i:1;s:183:"<a href="../amazonec2/create_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/create_spot_datafeed_subscription"><code>create_spot_datafeed_subscription()</code></a>";i:2;s:183:"<a href="../amazonec2/delete_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/delete_spot_datafeed_subscription"><code>delete_spot_datafeed_subscription()</code></a>";i:3;s:189:"<a href="../amazonec2/describe_spot_datafeed_subscription.html" rel="../../index.html#m=amazonec2/describe_spot_datafeed_subscription"><code>describe_spot_datafeed_subscription()</code></a>";i:4;s:177:"<a href="../amazonec2/describe_spot_instance_requests.html" rel="../../index.html#m=amazonec2/describe_spot_instance_requests"><code>describe_spot_instance_requests()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_spot_price_history.html" rel="../../index.html#m=amazonec2/describe_spot_price_history"><code>describe_spot_price_history()</code></a>";}}}i:151;a:8:{s:4:"name";s:21:"reset_image_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:159:"<p>The ResetImageAttribute operation resets an attribute of an AMI to its default value.</p>

<p class="note">
The productCodes attribute cannot be reset.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"image_id";s:4:"type";s:6:"string";s:11:"description";s:56:"<p>The ID of the AMI whose attribute is being reset.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:102:"<p>The name of the attribute being reset. Available attribute names: <code>launchPermission</code></p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:246:"public function reset_image_attribute($image_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ImageId'] = $image_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('ResetImageAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:50:"<p>Reset image attributes to default settings.</p>";s:4:"code";s:137:"$ec2 = new AmazonEC2();

$response = $ec2-&gt;reset_image_attribute('ami-42ad462b', 'launchPermission');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:120:"<a href="../amazonec2/create_image.html" rel="../../index.html#m=amazonec2/create_image"><code>create_image()</code></a>";i:1;s:132:"<a href="../amazonec2/deregister_image.html" rel="../../index.html#m=amazonec2/deregister_image"><code>deregister_image()</code></a>";i:2;s:156:"<a href="../amazonec2/describe_image_attribute.html" rel="../../index.html#m=amazonec2/describe_image_attribute"><code>describe_image_attribute()</code></a>";i:3;s:129:"<a href="../amazonec2/describe_images.html" rel="../../index.html#m=amazonec2/describe_images"><code>describe_images()</code></a>";i:4;s:150:"<a href="../amazonec2/modify_image_attribute.html" rel="../../index.html#m=amazonec2/modify_image_attribute"><code>modify_image_attribute()</code></a>";i:5;s:126:"<a href="../amazonec2/register_image.html" rel="../../index.html#m=amazonec2/register_image"><code>register_image()</code></a>";}}}i:152;a:8:{s:4:"name";s:24:"reset_instance_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:63:"<p>Resets an attribute of an instance to its default value.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:6:"string";s:11:"description";s:72:"<p>The ID of the Amazon EC2 instance whose attribute is being reset.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:477:"<p>The name of the attribute being reset. Available attribute names: <code>kernel</code>, <code>ramdisk</code> [Allowed values: <code>instanceType</code>, <code>kernel</code>, <code>ramdisk</code>, <code>userData</code>, <code>disableApiTermination</code>, <code>instanceInitiatedShutdownBehavior</code>, <code>rootDeviceName</code>, <code>blockDeviceMapping</code>, <code>productCodes</code>, <code>sourceDestCheck</code>, <code>groupSet</code>, <code>ebsOptimized</code>]</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:261:"public function reset_instance_attribute($instance_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InstanceId'] = $instance_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('ResetInstanceAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:70:"<p>Reset the attributes of a stopped instance to default settings.</p>";s:4:"code";s:127:"$ec2 = new AmazonEC2();
$response = $ec2-&gt;reset_instance_attribute('i-1f549375', 'kernel');

var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:4;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:153;a:5:{s:4:"name";s:33:"reset_network_interface_attribute";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:592:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SourceDestCheck</code> - <code>string</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:256:"public function reset_network_interface_attribute($network_interface_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    return $this-&gt;authenticate('ResetNetworkInterfaceAttribute', $opt);
}";}i:154;a:8:{s:4:"name";s:24:"reset_snapshot_attribute";s:8:"modifier";s:6:"public";s:11:"description";s:61:"<p>Resets permission settings for the specified snapshot.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"snapshot_id";s:4:"type";s:6:"string";s:11:"description";s:61:"<p>The ID of the snapshot whose attribute is being reset.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"attribute";s:4:"type";s:6:"string";s:11:"description";s:189:"<p>The name of the attribute being reset. Available attribute names: <code>createVolumePermission</code> [Allowed values: <code>productCodes</code>, <code>createVolumePermission</code>]</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:261:"public function reset_snapshot_attribute($snapshot_id, $attribute, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['SnapshotId'] = $snapshot_id;
    $opt['Attribute'] = $attribute;
    
    return $this-&gt;authenticate('ResetSnapshotAttribute', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:63:"<p>Reset the attributes for a snapshot to default settings.</p>";s:4:"code";s:184:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;reset_snapshot_attribute('snap-a99b8bc1', 'createVolumePermission');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:10:{i:0;s:123:"<a href="../amazonec2/attach_volume.html" rel="../../index.html#m=amazonec2/attach_volume"><code>attach_volume()</code></a>";i:1;s:129:"<a href="../amazonec2/create_snapshot.html" rel="../../index.html#m=amazonec2/create_snapshot"><code>create_snapshot()</code></a>";i:2;s:123:"<a href="../amazonec2/create_volume.html" rel="../../index.html#m=amazonec2/create_volume"><code>create_volume()</code></a>";i:3;s:129:"<a href="../amazonec2/delete_snapshot.html" rel="../../index.html#m=amazonec2/delete_snapshot"><code>delete_snapshot()</code></a>";i:4;s:123:"<a href="../amazonec2/delete_volume.html" rel="../../index.html#m=amazonec2/delete_volume"><code>delete_volume()</code></a>";i:5;s:165:"<a href="../amazonec2/describe_snapshot_attribute.html" rel="../../index.html#m=amazonec2/describe_snapshot_attribute"><code>describe_snapshot_attribute()</code></a>";i:6;s:138:"<a href="../amazonec2/describe_snapshots.html" rel="../../index.html#m=amazonec2/describe_snapshots"><code>describe_snapshots()</code></a>";i:7;s:132:"<a href="../amazonec2/describe_volumes.html" rel="../../index.html#m=amazonec2/describe_volumes"><code>describe_volumes()</code></a>";i:8;s:123:"<a href="../amazonec2/detach_volume.html" rel="../../index.html#m=amazonec2/detach_volume"><code>detach_volume()</code></a>";i:9;s:159:"<a href="../amazonec2/modify_snapshot_attribute.html" rel="../../index.html#m=amazonec2/modify_snapshot_attribute"><code>modify_snapshot_attribute()</code></a>";}}}i:155;a:8:{s:4:"name";s:28:"revoke_security_group_egress";s:8:"modifier";s:6:"public";s:11:"description";s:856:"<p>This action applies only to security groups in a VPC. It doesn&#8217;t work with EC2 security groups.
For information about Amazon Virtual Private Cloud and VPC security groups, go to the Amazon
Virtual Private Cloud User Guide.</p>

<p>The action removes one or more egress rules from a VPC security group. The values that you
specify in the revoke request (e.g., ports, etc.) must match the existing rule&#8217;s values in
order for the rule to be revoked.</p>

<p>Each rule consists of the protocol, and the CIDR range or destination security group. For the
TCP and UDP protocols, you must also specify the destination port or range of ports. For the
ICMP protocol, you must also specify the ICMP type and code.</p>

<p>Rule changes are propagated to instances within the security group as quickly as possible.
However, a small delay might occur.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"group_id";s:4:"type";s:6:"string";s:11:"description";s:46:"<p>ID of the VPC security group to modify.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2421:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>IpPermissions</code> - <code>array</code> - Optional - List of IP permissions to authorize on the specified security group. Specifying permissions through IP permissions is the preferred way of authorizing permissions since it offers more flexibility and control. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol</code> - <code>string</code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp</code>, <code>udp</code>, <code>icmp</code></li><li><code>FromPort</code> - <code>integer</code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1</code> indicates a wildcard (i.e., any ICMP type number).</li><li><code>ToPort</code> - <code>integer</code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1</code> indicates a wildcard (i.e., any ICMP code).</li><li><code>Groups</code> - <code>array</code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of an account.</li><li><code>GroupName</code> - <code>string</code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li></ul></li></ul></li><li><code>IpRanges</code> - <code>string|array</code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:455:"public function revoke_security_group_egress($group_id, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['GroupId'] = $group_id;
    
    // Optional list + map
    if (isset($opt['IpPermissions']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'IpPermissions' =&gt; $opt['IpPermissions']
        )));
        unset($opt['IpPermissions']);
    }

    return $this-&gt;authenticate('RevokeSecurityGroupEgress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:35:"<p>Revoke Security Group Egress</p>";s:4:"code";s:391:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;revoke_security_group_egress('sg-830d1eef', array(
	'IpPermissions' =&gt; array(
		array( // Set 0
			'IpProtocol' =&gt; 'tcp',
			'FromPort' =&gt; '80',
			'ToPort' =&gt; '80',
			'IpRanges' =&gt; array(
				array('CidrIp' =&gt; '205.192.0.0/16'), // Range 0
			)
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:2;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:3;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:4;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:5;s:171:"<a href="../amazonec2/revoke_security_group_ingress.html" rel="../../index.html#m=amazonec2/revoke_security_group_ingress"><code>revoke_security_group_ingress()</code></a>";}}}i:156;a:9:{s:4:"name";s:29:"revoke_security_group_ingress";s:8:"modifier";s:6:"public";s:11:"description";s:612:"<p>The RevokeSecurityGroupIngress operation revokes permissions from a security group. The
permissions used to revoke must be specified using the same values used to grant the
permissions.</p>

<p>Permissions are specified by IP protocol (TCP, UDP, or ICMP), the source of the request (by IP
range or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and
UDP), and the ICMP codes and types (for ICMP).</p>

<p>Permission changes are quickly propagated to instances within the security group. However,
depending on the number of instances in the group, a small delay might occur.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3014:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>GroupName</code> - <code>string</code> - Optional - Name of the standard (EC2) security group to modify. The group must belong to your account. Can be used instead of GroupID for standard (EC2) security groups.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the standard (EC2) or VPC security group to modify. The group must belong to your account. Required for VPC security groups; can be used instead of GroupName for standard (EC2) security groups.</li><li><code>IpPermissions</code> - <code>array</code> - Optional - List of IP permissions to revoke on the specified security group. For an IP permission to be removed, it must exactly match one of the IP permissions you specify in this list. Specifying permissions through IP permissions is the preferred way of revoking permissions since it offers more flexibility and control. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>IpProtocol</code> - <code>string</code> - Optional - The IP protocol of this permission. Valid protocol values: <code>tcp</code>, <code>udp</code>, <code>icmp</code></li><li><code>FromPort</code> - <code>integer</code> - Optional - Start of port range for the TCP and UDP protocols, or an ICMP type number. An ICMP type number of <code>-1</code> indicates a wildcard (i.e., any ICMP type number).</li><li><code>ToPort</code> - <code>integer</code> - Optional - End of port range for the TCP and UDP protocols, or an ICMP code. An ICMP code of <code>-1</code> indicates a wildcard (i.e., any ICMP code).</li><li><code>Groups</code> - <code>array</code> - Optional - The list of AWS user IDs and groups included in this permission. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>UserId</code> - <code>string</code> - Optional - The AWS user ID of an account.</li><li><code>GroupName</code> - <code>string</code> - Optional - Name of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li><li><code>GroupId</code> - <code>string</code> - Optional - ID of the security group in the specified AWS account. Cannot be used when specifying a CIDR IP address range.</li></ul></li></ul></li><li><code>IpRanges</code> - <code>string|array</code> - Optional - The list of CIDR IP ranges included in this permission. Pass a string for a single value, or an indexed array for multiple values.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:421:"public function revoke_security_group_ingress($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['IpPermissions']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'IpPermissions' =&gt; $opt['IpPermissions']
        )));
        unset($opt['IpPermissions']);
    }

    return $this-&gt;authenticate('RevokeSecurityGroupIngress', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Revoke security group ingress.</p>";s:4:"code";s:407:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;revoke_security_group_ingress(array(
	'GroupName' =&gt; 'default',
	'IpPermissions' =&gt; array(
		array( // Set 0
			'IpProtocol' =&gt; 'tcp',
			'FromPort' =&gt; '80',
			'ToPort' =&gt; '80',
			'IpRanges' =&gt; array(
				array('CidrIp' =&gt; '205.192.0.0/16'), // Range 0
			)
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:177:"<a href="../amazonec2/authorize_security_group_egress.html" rel="../../index.html#m=amazonec2/authorize_security_group_egress"><code>authorize_security_group_egress()</code></a>";i:1;s:180:"<a href="../amazonec2/authorize_security_group_ingress.html" rel="../../index.html#m=amazonec2/authorize_security_group_ingress"><code>authorize_security_group_ingress()</code></a>";i:2;s:147:"<a href="../amazonec2/create_security_group.html" rel="../../index.html#m=amazonec2/create_security_group"><code>create_security_group()</code></a>";i:3;s:147:"<a href="../amazonec2/delete_security_group.html" rel="../../index.html#m=amazonec2/delete_security_group"><code>delete_security_group()</code></a>";i:4;s:156:"<a href="../amazonec2/describe_security_groups.html" rel="../../index.html#m=amazonec2/describe_security_groups"><code>describe_security_groups()</code></a>";i:5;s:168:"<a href="../amazonec2/revoke_security_group_egress.html" rel="../../index.html#m=amazonec2/revoke_security_group_egress"><code>revoke_security_group_egress()</code></a>";}}s:9:"changelog";a:1:{s:6:"change";s:406:"<p>The <a href="http://docs.aws.amazon.com/AWSEC2/latest/APIReference/index.html?ApiReference-query-RevokeSecurityGroupIngress.html">RevokeSecurityGroupIngress</a> operation introduced backwards-incompatible changes in the <code>2011-01-01</code> API release. The <code>GroupName</code> parameter is no longer required. Instead <code>GroupName</code> or <code>GroupId</code> are conditionally required.</p>";}}i:157;a:8:{s:4:"name";s:13:"run_instances";s:8:"modifier";s:6:"public";s:11:"description";s:2410:"<p>The RunInstances operation launches a specified number of instances.</p>

<p>If Amazon EC2 cannot launch the minimum number AMIs you request, no instances launch. If there
is insufficient capacity to launch the maximum number of AMIs you request, Amazon EC2 launches
as many as possible to satisfy the requested maximum values.</p>

<p>Every instance is launched in a security group. If you do not specify a security group at
launch, the instances start in your default security group. For more information on creating
security groups, see CreateSecurityGroup.</p>

<p>An optional instance type can be specified. For information about instance types, see Instance
Types.</p>

<p>You can provide an optional key pair ID for each image in the launch request (for more
information, see CreateKeyPair). All instances that are created from images that use this key
pair will have access to the associated public key at boot. You can use this key to provide
secure access to an instance of an image on a per-instance basis. Amazon EC2 public images use
this feature to provide secure access without passwords.</p>

<p class="important"></p>

<p>Launching public images without a key pair ID will leave them inaccessible.</p>

<p>The public key material is made available to the instance at boot time by placing it in the
<code>openssh_id.pub</code> file on a logical device that is exposed to the instance as
<code>/dev/sda2</code> (the ephemeral store). The format of this file is suitable for use as an
entry within <code>~/.ssh/authorized_keys</code> (the OpenSSH format). This can be done at boot
(e.g., as part of <code>rc.local</code>) allowing for secure access without passwords.</p>

<p>Optional user data can be provided in the launch request. All instances that collectively
comprise the launch request have access to this data For more information, see Instance
Metadata.</p>

<p class="note">
If any of the AMIs have a product code attached for which the user has not subscribed, the
RunInstances call will fail.
</p>

<p class="important"></p>

<p>We strongly recommend using the 2.6.18 Xen stock kernel with the <code>c1.medium</code> and
<code>c1.xlarge</code> instances. Although the default Amazon EC2 kernels will work, the new
kernels provide greater stability and performance for these instance types. For more
information about kernels, see Kernels, RAM Disks, and Block Device Mappings.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"image_id";s:4:"type";s:6:"string";s:11:"description";s:74:"<p>Unique ID of a machine image, returned by a call to DescribeImages.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"min_count";s:4:"type";s:7:"integer";s:11:"description";s:128:"<p>Minimum number of instances to launch. If the value is more than Amazon EC2 can launch, no instances are launched at all.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"max_count";s:4:"type";s:7:"integer";s:11:"description";s:236:"<p>Maximum number of instances to launch. If the value is more than Amazon EC2 can launch, the largest possible number above minCount will be launched instead. Between 1 and the maximum number allowed for your account (default: 20).</p>";}i:3;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:7947:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>KeyName</code> - <code>string</code> - Optional - The name of the key pair.</li><li><code>SecurityGroup</code> - <code>string|array</code> - Optional - The names of the security groups into which the instances will be launched. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>SecurityGroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>UserData</code> - <code>string</code> - Optional - Specifies additional information to make available to the instance(s).</li><li><code>InstanceType</code> - <code>string</code> - Optional - Specifies the instance type for the launched instances. [Allowed values: <code>t1.micro</code>, <code>m1.small</code>, <code>m1.medium</code>, <code>m1.large</code>, <code>m1.xlarge</code>, <code>m2.xlarge</code>, <code>m2.2xlarge</code>, <code>m2.4xlarge</code>, <code>m3.xlarge</code>, <code>m3.2xlarge</code>, <code>c1.medium</code>, <code>c1.xlarge</code>, <code>hi1.4xlarge</code>, <code>hs1.8xlarge</code>, <code>cc1.4xlarge</code>, <code>cc2.8xlarge</code>, <code>cg1.4xlarge</code>]</li><li><code>Placement</code> - <code>array</code> - Optional - Specifies the placement constraints (Availability Zones) for launching the instances. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>AvailabilityZone</code> - <code>string</code> - Optional - The availability zone in which an Amazon EC2 instance runs.</li><li><code>GroupName</code> - <code>string</code> - Optional - The name of the <code>PlacementGroup</code> in which an Amazon EC2 instance runs. Placement groups are primarily used for launching High Performance Computing instances in the same group to ensure fast connection speeds.</li><li><code>Tenancy</code> - <code>string</code> - Optional - The allowed tenancy of instances launched into the VPC. A value of default means instances can be launched with any tenancy; a value of dedicated means all instances launched into the VPC will be launched as dedicated tenancy regardless of the tenancy assigned to the instance at launch.</li></ul></li></ul></li><li><code>KernelId</code> - <code>string</code> - Optional - The ID of the kernel with which to launch the instance.</li><li><code>RamdiskId</code> - <code>string</code> - Optional - The ID of the RAM disk with which to launch the instance. Some kernels require additional drivers at launch. Check the kernel requirements for information on whether you need to specify a RAM disk. To find kernel requirements, go to the Resource Center and search for the kernel ID.</li><li><code>BlockDeviceMapping</code> - <code>array</code> - Optional - Specifies how block devices are exposed to the instance. Each mapping is made up of a virtualName and a deviceName. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>VirtualName</code> - <code>string</code> - Optional - Specifies the virtual device name.</li><li><code>DeviceName</code> - <code>string</code> - Optional - Specifies the device name (e.g., <code>/dev/sdh</code>).</li><li><code>Ebs</code> - <code>array</code> - Optional - Specifies parameters used to automatically setup Amazon EBS volumes when the instance is launched. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>SnapshotId</code> - <code>string</code> - Optional - The ID of the snapshot from which the volume will be created.</li><li><code>VolumeSize</code> - <code>integer</code> - Optional - The size of the volume, in gigabytes.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - Specifies whether the Amazon EBS volume is deleted on instance termination.</li><li><code>VolumeType</code> - <code>string</code> - Optional -  [Allowed values: <code>standard</code>, <code>io1</code>]</li><li><code>Iops</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>NoDevice</code> - <code>string</code> - Optional - Specifies the device name to suppress during instance launch.</li></ul></li></ul></li><li><code>Monitoring.Enabled</code> - <code>boolean</code> - Optional - Enables monitoring for the instance.</li><li><code>SubnetId</code> - <code>string</code> - Optional - Specifies the subnet ID within which to launch the instance(s) for Amazon Virtual Private Cloud.</li><li><code>DisableApiTermination</code> - <code>boolean</code> - Optional - Specifies whether the instance can be terminated using the APIs. You must modify this attribute before you can terminate any &#8220;locked&#8221; instances from the APIs.</li><li><code>InstanceInitiatedShutdownBehavior</code> - <code>string</code> - Optional - Specifies whether the instance&#8217;s Amazon EBS volumes are stopped or terminated when the instance is shut down.</li><li><code>License</code> - <code>array</code> - Optional - Specifies active licenses in use and attached to an Amazon EC2 instance. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Pool</code> - <code>string</code> - Optional - The license pool from which to take a license when starting Amazon EC2 instances in the associated <code>RunInstances</code> request.</li></ul></li></ul></li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - If you&#8217;re using Amazon Virtual Private Cloud, you can optionally use this parameter to assign the instance a specific available IP address from the subnet.</li><li><code>ClientToken</code> - <code>string</code> - Optional - Unique, case-sensitive identifier you provide to ensure idempotency of the request. For more information, go to How to Ensure Idempotency in the Amazon Elastic Compute Cloud User Guide.</li><li><code>NetworkInterface</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>NetworkInterfaceId</code> - <code>string</code> - Optional - </li><li><code>DeviceIndex</code> - <code>integer</code> - Optional - </li><li><code>SubnetId</code> - <code>string</code> - Optional - </li><li><code>Description</code> - <code>string</code> - Optional - </li><li><code>PrivateIpAddress</code> - <code>string</code> - Optional - </li><li><code>SecurityGroupId</code> - <code>string|array</code> - Optional -  Pass a string for a single value, or an indexed array for multiple values.</li><li><code>DeleteOnTermination</code> - <code>boolean</code> - Optional - </li><li><code>PrivateIpAddresses</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>PrivateIpAddress</code> - <code>string</code> - Required - </li><li><code>Primary</code> - <code>boolean</code> - Optional - </li></ul></li></ul></li><li><code>SecondaryPrivateIpAddressCount</code> - <code>integer</code> - Optional - </li></ul></li></ul></li><li><code>IamInstanceProfile</code> - <code>array</code> - Optional -  <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Arn</code> - <code>string</code> - Optional - </li><li><code>Name</code> - <code>string</code> - Optional - </li></ul></li></ul></li><li><code>EbsOptimized</code> - <code>boolean</code> - Optional - </li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:2187:"public function run_instances($image_id, $min_count, $max_count, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ImageId'] = $image_id;
    $opt['MinCount'] = $min_count;
    $opt['MaxCount'] = $max_count;
    
    // Optional list (non-map)
    if (isset($opt['SecurityGroup']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SecurityGroup' =&gt; (is_array($opt['SecurityGroup']) ? $opt['SecurityGroup'] : array($opt['SecurityGroup']))
        )));
        unset($opt['SecurityGroup']);
    }
    
    // Optional list (non-map)
    if (isset($opt['SecurityGroupId']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SecurityGroupId' =&gt; (is_array($opt['SecurityGroupId']) ? $opt['SecurityGroupId'] : array($opt['SecurityGroupId']))
        )));
        unset($opt['SecurityGroupId']);
    }
    
    // Optional map (non-list)
    if (isset($opt['Placement']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Placement' =&gt; $opt['Placement']
        )));
        unset($opt['Placement']);
    }
    
    // Optional list + map
    if (isset($opt['BlockDeviceMapping']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'BlockDeviceMapping' =&gt; $opt['BlockDeviceMapping']
        )));
        unset($opt['BlockDeviceMapping']);
    }
    
    // Optional map (non-list)
    if (isset($opt['License']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'License' =&gt; $opt['License']
        )));
        unset($opt['License']);
    }
    
    // Optional list + map
    if (isset($opt['NetworkInterface']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'NetworkInterface' =&gt; $opt['NetworkInterface']
        )));
        unset($opt['NetworkInterface']);
    }
    
    // Optional map (non-list)
    if (isset($opt['IamInstanceProfile']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'IamInstanceProfile' =&gt; $opt['IamInstanceProfile']
        )));
        unset($opt['IamInstanceProfile']);
    }

    return $this-&gt;authenticate('RunInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:30:"<p>Launch an EC2 instance.</p>";s:4:"code";s:228:"// Instantiate the class
$ec2 = new AmazonEC2();

// Boot an instance of the image
$response = $ec2-&gt;run_instances('ami-84db39ed', 1, 1, array(
	'InstanceType' =&gt; 'm1.small'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:2:{s:5:"title";s:48:"<p>Run an instance in the VPC under a subnet</p>";s:4:"code";s:1404:"// Dependencies
require_once dirname(__FILE__) . '/../../sdk.class.php';
require_once dirname(__FILE__) . '/../testutil.inc.php';

// Instantiate the class
$ec2 = new AmazonEC2();

// Boot an instance of the image into the subnet in the VPC
$response = $ec2-&gt;run_instances($image_id, 1, 1, array(
	'InstanceType' =&gt; 'm1.small',
        'SubnetId' =&gt; $subnet_id,
));

// Temporarily cache the InstanceID
if ($response-&gt;isOK() &amp;&amp; isset($response-&gt;body-&gt;instancesSet-&gt;item-&gt;instanceId))
{
        $instance_id = (string) $response-&gt;body-&gt;instancesSet-&gt;item-&gt;instanceId;
	file_put_contents(dirname(__FILE__) . '/cache/instance_id_subnet.cache', $instance_id);
}

// Success?
var_dump($response-&gt;isOK());

    // Block until it's available
    if (isset($instance_id))
    {
        // If it's not running yet, sleep for 20 seconds and check again
        do
        {
            echo '.'; // Output something so we don't get a processing timeout from the test runner
            sleep(10);

            // Update the status of the instance
            $status_check = $ec2-&gt;describe_instances(array(
                'InstanceId' =&gt; $instance_id
            ));
        }
        while ((int) $status_check-&gt;body-&gt;reservationSet-&gt;item-&gt;instancesSet-&gt;item-&gt;instanceState-&gt;code !== AmazonEC2::STATE_RUNNING);

        echo 'done';
    }";}}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:4;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:5;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:158;a:7:{s:4:"name";s:4:"send";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:71:"<p>Executes the batch request queue by sending all queued requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"clear_after_send";s:4:"type";s:7:"boolean";s:11:"description";s:204:"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true</code>. Set this to <code>false</code> if you are caching batch responses and want to retrieve results later.</p>";}}s:11:"returnvalue";s:126:"<p>An array of <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> objects.</p>";s:6:"source";s:2018:"public function send($clear_after_send = true)
{
    if ($this-&gt;use_batch_flow)
    {
        // When we send the request, disable batch flow.
        $this-&gt;use_batch_flow = false;

        // If we're not caching, simply send the request.
        if (!$this-&gt;use_cache_flow)
        {
            $response = $this-&gt;batch_object-&gt;send();
            $parsed_data = array_map(array($this, 'parse_callback'), $response);
            $parsed_data = new CFArray($parsed_data);

            // Clear the queue
            if ($clear_after_send)
            {
                $this-&gt;batch_object-&gt;queue = array();
            }

            return $parsed_data;
        }

        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));
        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);
        $parsed_data = new CFArray($parsed_data);

        // Clear the queue
        if ($clear_after_send)
        {
            $this-&gt;batch_object-&gt;queue = array();
        }

        // End!
        return $parsed_data;
    }

    // Load the class
    $null = new CFBatchRequest();
    unset($null);

    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');
}";}i:159;a:7:{s:4:"name";s:15:"set_batch_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:291:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:116:"public function set_batch_class($class = 'CFBatchRequest')
{
    $this-&gt;batch_class = $class;
    return $this;
}";}i:160;a:8:{s:4:"name";s:16:"set_cache_config";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Set the caching configuration to use for response caching.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:1095:"<p>The location to store the cache object in. This may vary by cache method.</p><ul><li>File - The local file system paths such as <code>./cache</code> (relative) or <code>/tmp/cache/</code> (absolute). The location must be server-writable.</li><li>APC - Pass in <code>apc</code> to use this lightweight cache. You must have the <a href="http://php.net/apc">APC extension</a> installed.</li><li>XCache - Pass in <code>xcache</code> to use this lightweight cache. You must have the <a href="http://xcache.lighttpd.net">XCache</a> extension installed.</li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host</code> and a <code>port</code> value representing a <a href="http://php.net/memcached">Memcached</a> server to connect to.</li><li>PDO - A URL-style string (e.g. <code>pdo.mysql://user:pass@localhost/cache</code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:/sqlite/cache.db</code>). MUST be prefixed with <code>pdo.</code>. See <code>CachePDO</code> and <a href="http://php.net/pdo">PDO</a> for more details.</li></ul>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:241:"<p>Whether or not data should be gzipped before being stored. A value of <code>true</code> will compress the contents before caching them. A value of <code>false</code> will leave the contents uncompressed. Defaults to <code>true</code>.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:1210:"public function set_cache_config($location, $gzip = true)
{
    // If location is empty, don't do anything.
    if (empty($location))
    {
        return $this;
    }

    // If we have an array, we're probably passing in Memcached servers and ports.
    if (is_array($location))
    {
        $this-&gt;cache_class = 'CacheMC';
    }
    else
    {
        // I would expect locations like `/tmp/cache`, `pdo.mysql://user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.
        $type = strtolower(substr($location, 0, 3));
        switch ($type)
        {
            case 'apc':
                $this-&gt;cache_class = 'CacheAPC';
                break;

            case 'xca': // First three letters of `xcache`
                $this-&gt;cache_class = 'CacheXCache';
                break;

            case 'pdo':
                $this-&gt;cache_class = 'CachePDO';
                $location = substr($location, 4);
                break;

            default:
                $this-&gt;cache_class = 'CacheFile';
                break;
        }
    }

    // Set the remaining cache information.
    $this-&gt;cache_location = $location;
    $this-&gt;cache_compress = $gzip;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}}}}i:161;a:8:{s:4:"name";s:12:"set_hostname";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:145:"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with
AWS, but run from a different hostname.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"hostname";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"port_number";s:4:"type";s:7:"integer";s:11:"description";s:139:"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:341:"public function set_hostname($hostname, $port_number = null)
{
    if ($this-&gt;override_hostname)
    {
        $this-&gt;hostname = $hostname;

        if ($port_number)
        {
            $this-&gt;port_number = $port_number;
            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;
        }
    }

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:162;a:8:{s:4:"name";s:15:"set_max_retries";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"retries";s:4:"type";s:7:"integer";s:11:"description";s:88:"<p>The maximum number of times to retry failed requests. Defaults to <code>3</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:105:"public function set_max_retries($retries = 3)
{
    $this-&gt;max_retries = $retries;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_max_retries(3);

// Test if the value was set
var_dump($sdb-&gt;max_retries);";s:6:"result";s:6:"int(3)";}}}i:163;a:7:{s:4:"name";s:16:"set_parser_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:115:"public function set_parser_class($class = 'CFSimpleXML')
{
    $this-&gt;parser_class = $class;
    return $this;
}";}i:164;a:8:{s:4:"name";s:9:"set_proxy";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:37:"<p>Set the proxy settings to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"proxy";s:4:"type";s:6:"string";s:11:"description";s:102:"<p>Accepts proxy credentials in the following format: <code>proxy://user:pass@hostname:port</code></p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:85:"public function set_proxy($proxy)
{
    $this-&gt;proxy = $proxy;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>Set the proxy server to use for requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:151:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_proxy('proxy://user:pass@hostname:port');

// Test if the value was set
var_dump($sdb-&gt;proxy);";s:6:"result";s:44:"string(31) "proxy://user:pass@hostname:port"";}}}i:165;a:7:{s:4:"name";s:10:"set_region";s:8:"modifier";s:6:"public";s:11:"description";s:76:"<p>This allows you to explicitly sets the region for the service to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"region";s:4:"type";s:6:"string";s:11:"description";s:1261:"<p>The region to explicitly set. Available options are <a href="../amazonec2/constants.html#region_us_e1" rel="../../index.html#c=amazonec2/region_us_e1"><code>REGION_US_E1</code></a>, <a href="../amazonec2/constants.html#region_us_w1" rel="../../index.html#c=amazonec2/region_us_w1"><code>REGION_US_W1</code></a>, <a href="../amazonec2/constants.html#region_us_w2" rel="../../index.html#c=amazonec2/region_us_w2"><code>REGION_US_W2</code></a>, <a href="../amazonec2/constants.html#region_eu_w1" rel="../../index.html#c=amazonec2/region_eu_w1"><code>REGION_EU_W1</code></a>, <a href="../amazonec2/constants.html#region_apac_se1" rel="../../index.html#c=amazonec2/region_apac_se1"><code>REGION_APAC_SE1</code></a>, <a href="../amazonec2/constants.html#region_apac_se2" rel="../../index.html#c=amazonec2/region_apac_se2"><code>REGION_APAC_SE2</code></a>, <a href="../amazonec2/constants.html#region_apac_ne1" rel="../../index.html#c=amazonec2/region_apac_ne1"><code>REGION_APAC_NE1</code></a>, <a href="../amazonec2/constants.html#region_us_gov1" rel="../../index.html#c=amazonec2/region_us_gov1"><code>REGION_US_GOV1</code></a>, <a href="../amazonec2/constants.html#region_sa_e1" rel="../../index.html#c=amazonec2/region_sa_e1"><code>REGION_SA_E1</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:156:"public function set_region($region)
{
    // @codeCoverageIgnoreStart
    $this-&gt;set_hostname($region);
    return $this;
    // @codeCoverageIgnoreEnd
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Set the region to use.</p>";s:4:"code";s:230:"$ec2 = new AmazonEC2();

// Set the region to US-East (Northern Virginia)
$ec2-&gt;set_region(AmazonEC2::REGION_US_E1);

// Describe instances
$response = $ec2-&gt;describe_instances();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:166;a:8:{s:4:"name";s:17:"set_request_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:276:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";a:0:{}s:6:"source";s:115:"public function set_request_class($class = 'CFRequest')
{
    $this-&gt;request_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Set the request class to use in the toolkit.</p>";s:11:"description";s:158:"<p>The new request class must extend from <code>CFRequest</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:310:"// Custom class to extend RequestCore
class TestRequestCore extends RequestCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_request_class('TestRequestCore');

// Test if the value was set
var_dump($sdb-&gt;request_class);";s:6:"result";s:28:"string(15) "TestRequestCore"";}}}i:167;a:8:{s:4:"name";s:19:"set_resource_prefix";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:117:"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible
with AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"prefix";s:4:"type";s:6:"string";s:11:"description";s:97:"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:107:"public function set_resource_prefix($prefix)
{
    $this-&gt;resource_prefix = $prefix;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:168;a:8:{s:4:"name";s:18:"set_response_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:279:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:118:"public function set_response_class($class = 'CFResponse')
{
    $this-&gt;response_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:52:"<p>Set the response class to use in the toolkit.</p>";s:11:"description";s:160:"<p>The new response class must extend from <code>CFResponse</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:316:"// Custom class to extend ResponseCore
class TestResponseCore extends ResponseCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_response_class('TestResponseCore');

// Test if the value was set
var_dump($sdb-&gt;response_class);";s:6:"result";s:29:"string(16) "TestResponseCore"";}}}i:169;a:8:{s:4:"name";s:19:"set_utilities_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:175:"public function set_utilities_class($class = 'CFUtilities')
{
    $this-&gt;utilities_class = $class;
    $this-&gt;util = new $this-&gt;utilities_class();
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:53:"<p>Set the utilities class to use in the toolkit.</p>";s:11:"description";s:162:"<p>The new utilities class must extend from <code>CFUtilities</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:317:"// Custom class to extend CFUtilities
class TestUtilities extends CFUtilities
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_utilities_class('TestUtilities');

// Test if the value was set
var_dump($sdb-&gt;util-&gt;test_method());";s:6:"result";s:10:"bool(true)";}}}i:170;a:8:{s:4:"name";s:15:"start_instances";s:8:"modifier";s:6:"public";s:11:"description";s:602:"<p>Starts an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon
EBS volumes as their root devices can be quickly stopped and started. When an instance is
stopped, the compute resources are released and you are not billed for hourly instance usage.
However, your root partition Amazon EBS volume remains, continues to persist your data, and you
are charged for Amazon EBS volume usage. You can restart your instance at any time.</p>

<p class="note"></p>

<p>Performing this operation on an instance that uses an instance store as its root device returns
an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:124:"<p>The list of Amazon EC2 instances to start. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:350:"public function start_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('StartInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:43:"<p>Start a stopped EBS-backed instance.</p>";s:4:"code";s:146:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;start_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:4;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:5;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:6;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:171;a:8:{s:4:"name";s:14:"stop_instances";s:8:"modifier";s:6:"public";s:11:"description";s:756:"<p>Stops an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon
EBS volumes as their root devices can be quickly stopped and started. When an instance is
stopped, the compute resources are released and you are not billed for hourly instance usage.
However, your root partition Amazon EBS volume remains, continues to persist your data, and you
are charged for Amazon EBS volume usage. You can restart your instance at any time.</p>

<p class="note"></p>

<p>Before stopping an instance, make sure it is in a state from which it can be restarted.
Stopping an instance does not preserve data stored in RAM.</p>

<p>Performing this operation on an instance that uses an instance store as its root device returns
an error.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:123:"<p>The list of Amazon EC2 instances to stop. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:844:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Force</code> - <code>boolean</code> - Optional - Forces the instance to stop. The instance will not have an opportunity to flush file system caches nor file system meta data. If you use this option, you must perform file system check and repair procedures. This option is not recommended for Windows instances.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:348:"public function stop_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('StopInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:42:"<p>Stop a running EBS-backed instance.</p>";s:4:"code";s:145:"// Instantiate the class
$ec2 = new AmazonEC2();

$response = $ec2-&gt;stop_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:4;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:5;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:6;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:7;s:141:"<a href="../amazonec2/terminate_instances.html" rel="../../index.html#m=amazonec2/terminate_instances"><code>terminate_instances()</code></a>";}}}i:172;a:8:{s:4:"name";s:19:"terminate_instances";s:8:"modifier";s:6:"public";s:11:"description";s:265:"<p>The TerminateInstances operation shuts down one or more instances. This operation is
idempotent; if you terminate an instance more than once, each call will succeed.</p>

<p>Terminated instances will remain visible after termination (approximately one hour).</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:117:"<p>The list of instances to terminate. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:358:"public function terminate_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('TerminateInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:46:"<p>Terminate an instance in the VPC subnet</p>";s:4:"code";s:173:"// Instantiate the class
$ec2 = new AmazonEC2();

// Terminate instances
$response = $ec2-&gt;terminate_instances($instance_id);

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:29:"<p>Terminate an instance.</p>";s:4:"code";s:173:"// Instantiate the class
$ec2 = new AmazonEC2();

// Terminate instances
$response = $ec2-&gt;terminate_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:165:"<a href="../amazonec2/describe_instance_attribute.html" rel="../../index.html#m=amazonec2/describe_instance_attribute"><code>describe_instance_attribute()</code></a>";i:1;s:138:"<a href="../amazonec2/describe_instances.html" rel="../../index.html#m=amazonec2/describe_instances"><code>describe_instances()</code></a>";i:2;s:159:"<a href="../amazonec2/modify_instance_attribute.html" rel="../../index.html#m=amazonec2/modify_instance_attribute"><code>modify_instance_attribute()</code></a>";i:3;s:132:"<a href="../amazonec2/reboot_instances.html" rel="../../index.html#m=amazonec2/reboot_instances"><code>reboot_instances()</code></a>";i:4;s:156:"<a href="../amazonec2/reset_instance_attribute.html" rel="../../index.html#m=amazonec2/reset_instance_attribute"><code>reset_instance_attribute()</code></a>";i:5;s:123:"<a href="../amazonec2/run_instances.html" rel="../../index.html#m=amazonec2/run_instances"><code>run_instances()</code></a>";i:6;s:129:"<a href="../amazonec2/start_instances.html" rel="../../index.html#m=amazonec2/start_instances"><code>start_instances()</code></a>";i:7;s:126:"<a href="../amazonec2/stop_instances.html" rel="../../index.html#m=amazonec2/stop_instances"><code>stop_instances()</code></a>";}}}i:173;a:5:{s:4:"name";s:29:"unassign_private_ip_addresses";s:8:"modifier";s:6:"public";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:20:"network_interface_id";s:4:"type";s:6:"string";s:11:"description";a:0:{}}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:18:"private_ip_address";s:4:"type";s:12:"string|array";s:11:"description";s:81:"<p>Pass a string for a single value, or an indexed array for multiple values.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:481:"public function unassign_private_ip_addresses($network_interface_id, $private_ip_address, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['NetworkInterfaceId'] = $network_interface_id;
    
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'PrivateIpAddress' =&gt; (is_array($private_ip_address) ? $private_ip_address : array($private_ip_address))
    )));

    return $this-&gt;authenticate('UnassignPrivateIpAddresses', $opt);
}";}i:174;a:8:{s:4:"name";s:19:"unmonitor_instances";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Disables monitoring for a running instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"instance_id";s:4:"type";s:12:"string|array";s:11:"description";s:146:"<p>The list of Amazon EC2 instances on which to disable monitoring. Pass a string for a single value, or an indexed array for multiple values.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:358:"public function unmonitor_instances($instance_id, $opt = null)
{
    if (!$opt) $opt = array();
            
    // Required list (non-map)
    $opt = array_merge($opt, CFComplexType::map(array(
        'InstanceId' =&gt; (is_array($instance_id) ? $instance_id : array($instance_id))
    )));

    return $this-&gt;authenticate('UnmonitorInstances', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Disable monitoring on an instance.</p>";s:4:"code";s:173:"// Instantiate the class
$ec2 = new AmazonEC2();

// Terminate instances
$response = $ec2-&gt;unmonitor_instances('i-1f549375');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";s:135:"<a href="../amazonec2/monitor_instances.html" rel="../../index.html#m=amazonec2/monitor_instances"><code>monitor_instances()</code></a>";}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"45";}s:8:"constant";a:45:{i:0;a:2:{s:4:"name";s:5:"BUILD";s:5:"value";s:14:"20130314130000";}i:1;a:2:{s:4:"name";s:11:"DEFAULT_URL";s:5:"value";s:27:"ec2.us-east-1.amazonaws.com";}i:2;a:2:{s:4:"name";s:24:"INSTANCE_CLUSTER_4XLARGE";s:5:"value";s:11:"cc1.4xlarge";}i:3;a:2:{s:4:"name";s:24:"INSTANCE_CLUSTER_8XLARGE";s:5:"value";s:11:"cc2.8xlarge";}i:4;a:2:{s:4:"name";s:27:"INSTANCE_CLUSTER_GPU_XLARGE";s:5:"value";s:11:"cg1.4xlarge";}i:5;a:2:{s:4:"name";s:24:"INSTANCE_HIGH_CPU_MEDIUM";s:5:"value";s:9:"c1.medium";}i:6;a:2:{s:4:"name";s:24:"INSTANCE_HIGH_CPU_XLARGE";s:5:"value";s:9:"c1.xlarge";}i:7;a:2:{s:4:"name";s:24:"INSTANCE_HIGH_IO_4XLARGE";s:5:"value";s:11:"hi1.4xlarge";}i:8;a:2:{s:4:"name";s:25:"INSTANCE_HIGH_MEM_2XLARGE";s:5:"value";s:10:"m2.2xlarge";}i:9;a:2:{s:4:"name";s:25:"INSTANCE_HIGH_MEM_4XLARGE";s:5:"value";s:10:"m2.4xlarge";}i:10;a:2:{s:4:"name";s:24:"INSTANCE_HIGH_MEM_XLARGE";s:5:"value";s:9:"m2.xlarge";}i:11;a:2:{s:4:"name";s:14:"INSTANCE_LARGE";s:5:"value";s:8:"m1.large";}i:12;a:2:{s:4:"name";s:19:"INSTANCE_M3_4XLARGE";s:5:"value";s:10:"m3.4xlarge";}i:13;a:2:{s:4:"name";s:18:"INSTANCE_M3_XLARGE";s:5:"value";s:9:"m3.xlarge";}i:14;a:2:{s:4:"name";s:15:"INSTANCE_MEDIUM";s:5:"value";s:9:"m1.medium";}i:15;a:2:{s:4:"name";s:14:"INSTANCE_MICRO";s:5:"value";s:8:"t1.micro";}i:16;a:2:{s:4:"name";s:14:"INSTANCE_SMALL";s:5:"value";s:8:"m1.small";}i:17;a:2:{s:4:"name";s:24:"INSTANCE_STORAGE_8XLARGE";s:5:"value";s:11:"hs1.8xlarge";}i:18;a:2:{s:4:"name";s:15:"INSTANCE_XLARGE";s:5:"value";s:9:"m1.xlarge";}i:19;a:2:{s:4:"name";s:4:"NAME";s:5:"value";s:11:"aws-sdk-php";}i:20;a:2:{s:4:"name";s:15:"REGION_APAC_NE1";s:5:"value";s:32:"ec2.ap-northeast-1.amazonaws.com";}i:21;a:2:{s:4:"name";s:15:"REGION_APAC_SE1";s:5:"value";s:32:"ec2.ap-southeast-1.amazonaws.com";}i:22;a:2:{s:4:"name";s:15:"REGION_APAC_SE2";s:5:"value";s:32:"ec2.ap-southeast-2.amazonaws.com";}i:23;a:2:{s:4:"name";s:17:"REGION_CALIFORNIA";s:5:"value";s:27:"ec2.us-west-1.amazonaws.com";}i:24;a:2:{s:4:"name";s:12:"REGION_EU_W1";s:5:"value";s:27:"ec2.eu-west-1.amazonaws.com";}i:25;a:2:{s:4:"name";s:14:"REGION_IRELAND";s:5:"value";s:27:"ec2.eu-west-1.amazonaws.com";}i:26;a:2:{s:4:"name";s:13:"REGION_OREGON";s:5:"value";s:27:"ec2.us-west-2.amazonaws.com";}i:27;a:2:{s:4:"name";s:16:"REGION_SAO_PAULO";s:5:"value";s:27:"ec2.sa-east-1.amazonaws.com";}i:28;a:2:{s:4:"name";s:12:"REGION_SA_E1";s:5:"value";s:27:"ec2.sa-east-1.amazonaws.com";}i:29;a:2:{s:4:"name";s:16:"REGION_SINGAPORE";s:5:"value";s:32:"ec2.ap-southeast-1.amazonaws.com";}i:30;a:2:{s:4:"name";s:13:"REGION_SYDNEY";s:5:"value";s:32:"ec2.ap-southeast-2.amazonaws.com";}i:31;a:2:{s:4:"name";s:12:"REGION_TOKYO";s:5:"value";s:32:"ec2.ap-northeast-1.amazonaws.com";}i:32;a:2:{s:4:"name";s:12:"REGION_US_E1";s:5:"value";s:27:"ec2.us-east-1.amazonaws.com";}i:33;a:2:{s:4:"name";s:14:"REGION_US_GOV1";s:5:"value";s:31:"ec2.us-gov-west-1.amazonaws.com";}i:34;a:2:{s:4:"name";s:12:"REGION_US_W1";s:5:"value";s:27:"ec2.us-west-1.amazonaws.com";}i:35;a:2:{s:4:"name";s:12:"REGION_US_W2";s:5:"value";s:27:"ec2.us-west-2.amazonaws.com";}i:36;a:2:{s:4:"name";s:15:"REGION_VIRGINIA";s:5:"value";s:27:"ec2.us-east-1.amazonaws.com";}i:37;a:2:{s:4:"name";s:13:"STATE_PENDING";s:5:"value";s:1:"0";}i:38;a:2:{s:4:"name";s:13:"STATE_RUNNING";s:5:"value";s:2:"16";}i:39;a:2:{s:4:"name";s:19:"STATE_SHUTTING_DOWN";s:5:"value";s:2:"32";}i:40;a:2:{s:4:"name";s:13:"STATE_STOPPED";s:5:"value";s:2:"80";}i:41;a:2:{s:4:"name";s:14:"STATE_STOPPING";s:5:"value";s:2:"64";}i:42;a:2:{s:4:"name";s:16:"STATE_TERMINATED";s:5:"value";s:2:"48";}i:43;a:2:{s:4:"name";s:9:"USERAGENT";s:5:"value";s:65:"aws-sdk-php/1.6.2 PHP/5.4.9 curl/7.15.5 openssl/0.9.8e-fips-rhel5";}i:44;a:2:{s:4:"name";s:7:"VERSION";s:5:"value";s:5:"1.6.2";}}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"40";}s:8:"property";a:40:{i:0;a:4:{s:4:"name";s:11:"api_version";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The supported API version.</p>";}i:1;a:4:{s:4:"name";s:10:"auth_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The authentication class to use.</p>";}i:2;a:4:{s:4:"name";s:10:"auth_token";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The Amazon Authentication Token.</p>";}i:3;a:5:{s:4:"name";s:11:"batch_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:14:"CFBatchRequest";}}s:11:"description";s:185:"<p>The default class to use for handling batch requests (defaults to <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>).</p>";}i:4;a:4:{s:4:"name";s:12:"batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:53:"<p>The current instantiated batch request object.</p>";}i:5;a:4:{s:4:"name";s:11:"cache_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The caching class to use.</p>";}i:6;a:4:{s:4:"name";s:14:"cache_compress";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:38:"<p>The state of cache compression.</p>";}i:7;a:4:{s:4:"name";s:13:"cache_expires";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>When the cache should be considered stale.</p>";}i:8;a:4:{s:4:"name";s:14:"cache_location";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:35:"<p>The caching location to use.</p>";}i:9;a:4:{s:4:"name";s:12:"cache_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The current instantiated cache object.</p>";}i:10;a:4:{s:4:"name";s:11:"credentials";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>The credentials to use for authentication.</p>";}i:11;a:4:{s:4:"name";s:10:"debug_mode";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:43:"<p>The state of the debug mode setting.</p>";}i:12;a:4:{s:4:"name";s:12:"delete_cache";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>The state of the cache deletion setting.</p>";}i:13;a:4:{s:4:"name";s:8:"hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The alternate hostname to use, if any.</p>";}i:14;a:4:{s:4:"name";s:21:"internal_batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:56:"<p>The internally instantiated batch request object.</p>";}i:15;a:4:{s:4:"name";s:3:"key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:26:"<p>The Amazon API Key.</p>";}i:16;a:5:{s:4:"name";s:11:"max_retries";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:1:"3";}}s:11:"description";s:52:"<p>The number of times to retry failed requests.</p>";}i:17;a:4:{s:4:"name";s:9:"operation";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The operation to execute.</p>";}i:18;a:4:{s:4:"name";s:16:"operation_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>The string prefix to prepend to the operation name.</p>";}i:19;a:5:{s:4:"name";s:17:"override_hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:186:"<p>The state of the capability to override the hostname with <a href="../amazonec2/set_hostname.html" rel="../../index.html#m=amazonec2/set_hostname"><code>set_hostname()</code></a>.</p>";}i:20;a:5:{s:4:"name";s:18:"parse_the_response";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:65:"<p>The state of whether the response should be parsed or not.</p>";}i:21;a:5:{s:4:"name";s:12:"parser_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFSimpleXML";}}s:11:"description";s:164:"<p>The default class to use for parsing XML (defaults to <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>).</p>";}i:22;a:4:{s:4:"name";s:7:"payload";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:27:"<p>The payload to send.</p>";}i:23;a:4:{s:4:"name";s:11:"port_number";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:48:"<p>The alternate port number to use, if any.</p>";}i:24;a:4:{s:4:"name";s:5:"proxy";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The proxy to use for connecting.</p>";}i:25;a:4:{s:4:"name";s:9:"redirects";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>The number of times a request has been retried.</p>";}i:26;a:4:{s:4:"name";s:34:"registered_streaming_read_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:77:"<p>The user-defined callback function to call when a stream is read from.</p>";}i:27;a:4:{s:4:"name";s:35:"registered_streaming_write_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:78:"<p>The user-defined callback function to call when a stream is written to.</p>";}i:28;a:5:{s:4:"name";s:13:"request_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:9:"CFRequest";}}s:11:"description";s:160:"<p>The default class to use for HTTP requests (defaults to <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>).</p>";}i:29;a:4:{s:4:"name";s:15:"resource_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:52:"<p>The alternate resource prefix to use, if any.</p>";}i:30;a:5:{s:4:"name";s:14:"response_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:10:"CFResponse";}}s:11:"description";s:164:"<p>The default class to use for HTTP responses (defaults to <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>).</p>";}i:31;a:4:{s:4:"name";s:10:"secret_key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The Amazon API Secret Key.</p>";}i:32;a:4:{s:4:"name";s:7:"service";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>An identifier for the current AWS service.</p>";}i:33;a:5:{s:4:"name";s:16:"ssl_verification";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:49:"<p>The state of SSL certificate verification.</p>";}i:34;a:5:{s:4:"name";s:13:"use_aws_query";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:64:"<p>The state of whether auth should be handled as AWS Query.</p>";}i:35;a:4:{s:4:"name";s:14:"use_batch_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of batch flow usage.</p>";}i:36;a:4:{s:4:"name";s:14:"use_cache_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of cache flow usage.</p>";}i:37;a:5:{s:4:"name";s:7:"use_ssl";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:34:"<p>The state of SSL/HTTPS use.</p>";}i:38;a:4:{s:4:"name";s:4:"util";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Handle for the utility functions.</p>";}i:39;a:5:{s:4:"name";s:15:"utilities_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFUtilities";}}s:11:"description";s:162:"<p>The default class to use for utilities (defaults to <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>).</p>";}}}}}