a:2:{s:4:"file";a:0:{}s:5:"class";a:9:{s:4:"name";s:22:"AmazonElasticBeanstalk";s:4:"file";s:35:"services/elasticbeanstalk.class.php";s:3:"url";s:36:"../amazonelasticbeanstalk/index.html";s:11:"description";s:1034:"<p>This is the AWS Elastic Beanstalk API Reference. This guide provides detailed information about
AWS Elastic Beanstalk actions, data types, parameters, and errors.</p>

<p>AWS Elastic Beanstalk is a tool that makes it easy for you to create, deploy, and manage
scalable, fault-tolerant applications running on Amazon Web Services cloud resources.</p>

<p>For more information about this product, go to the <a href=
"http://aws.amazon.com/elasticbeanstalk/">AWS Elastic Beanstalk</a> details page. The location
of the lastest AWS Elastic Beanstalk WSDL is <a href=
"http://elasticbeanstalk.s3.amazonaws.com/doc/2010-12-01/AWSElasticBeanstalk.wsdl">http://elasticbeanstalk.s3.amazonaws.com/doc/2010-12-01/AWSElasticBeanstalk.wsdl</a>.</p>

<p><strong>Endpoints</strong></p>

<p>For a list of region-specific endpoints that AWS Elastic Beanstalk supports, go to <a href=
"http://docs.amazonwebservices.com/general/latest/gr/rande.html#elasticbeanstalk_region">Regions
and Endpoints</a> in the <em>Amazon Web Services Glossary</em>.</p>";s:8:"metadata";a:4:{s:7:"version";s:10:"2013.01.14";s:7:"license";s:57:"See the included NOTICE.md file for complete information.";s:9:"copyright";s:57:"See the included NOTICE.md file for complete information.";s:4:"link";a:2:{i:0;s:60:"http://aws.amazon.com/elasticbeanstalk/ AWS ElasticBeanstalk";i:1;s:88:"http://aws.amazon.com/elasticbeanstalk/documentation/ AWS ElasticBeanstalk documentation";}}s:11:"inheritance";a:1:{s:5:"class";a:3:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";s:3:"url";s:23:"../cfruntime/index.html";}}s:7:"methods";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"59";}s:6:"method";a:55:{i:0;a:6:{s:4:"name";s:11:"__construct";s:8:"modifier";s:6:"public";s:11:"description";s:171:"<p>Constructs a new instance of <a href="../amazonelasticbeanstalk/index.html" rel="../../index.html#i=amazonelasticbeanstalk"><code>AmazonElasticBeanstalk</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1595:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonelasticbeanstalk/set_cache_config.html" rel="../../index.html#m=amazonelasticbeanstalk/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:228:"public function __construct(array $options = array())
{
    $this-&gt;api_version = '2010-12-01';
    $this-&gt;hostname = self::DEFAULT_URL;
    $this-&gt;auth_class = 'AuthV4Query';

    return parent::__construct($options);
}";}i:1;a:8:{s:4:"name";s:23:"allow_hostname_override";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:196:"<p>Disables any subsequent use of the <a href="../amazonelasticbeanstalk/set_hostname.html" rel="../../index.html#m=amazonelasticbeanstalk/set_hostname"><code>set_hostname()</code></a> method.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:8:"override";s:4:"type";s:7:"boolean";s:11:"description";s:450:"<p>Whether or not subsequent calls to <a href="../amazonelasticbeanstalk/set_hostname.html" rel="../../index.html#m=amazonelasticbeanstalk/set_hostname"><code>set_hostname()</code></a> should be obeyed. A <code>false</code> value disables the further effectiveness of <a href="../amazonelasticbeanstalk/set_hostname.html" rel="../../index.html#m=amazonelasticbeanstalk/set_hostname"><code>set_hostname()</code></a>. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:124:"public function allow_hostname_override($override = true)
{
    $this-&gt;override_hostname = $override;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:2;a:7:{s:4:"name";s:12:"authenticate";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:69:"<p>Default, shared method for authenticating a connection to AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"operation";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>Indicates the operation to perform.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"payload";s:4:"type";s:5:"array";s:11:"description";s:106:"<p>An associative array of parameters for authenticating. See the individual methods for allowed keys.</p>";}}}s:11:"returnvalue";s:48:"<p>Object containing a parsed HTTP response.</p>";s:6:"source";s:6988:"public function authenticate($operation, $payload)
{
    $original_payload = $payload;
    $method_arguments = func_get_args();
    $curlopts = array();
    $return_curl_handle = false;

    if (substr($operation, 0, strlen($this-&gt;operation_prefix)) !== $this-&gt;operation_prefix)
    {
        $operation = $this-&gt;operation_prefix . $operation;
    }

    // Extract the custom CURLOPT settings from the payload
    if (is_array($payload) &amp;&amp; isset($payload['curlopts']))
    {
        $curlopts = $payload['curlopts'];
        unset($payload['curlopts']);
    }

    // Determine whether the response or curl handle should be returned
    if (is_array($payload) &amp;&amp; isset($payload['returnCurlHandle']))
    {
        $return_curl_handle = isset($payload['returnCurlHandle']) ? $payload['returnCurlHandle'] : false;
        unset($payload['returnCurlHandle']);
    }

    // Use the caching flow to determine if we need to do a round-trip to the server.
    if ($this-&gt;use_cache_flow)
    {
        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . $operation . '_' . sha1(serialize($method_arguments));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback'), $method_arguments);

        // Parse the XML body
        $data = $this-&gt;parse_callback($data);

        // End!
        return $data;
    }

    /*%******************************************************************************************%*/

    // Signer
    $signer = new $this-&gt;auth_class($this-&gt;hostname, $operation, $payload, $this-&gt;credentials);
    $signer-&gt;key = $this-&gt;key;
    $signer-&gt;secret_key = $this-&gt;secret_key;
    $signer-&gt;auth_token = $this-&gt;auth_token;
    $signer-&gt;api_version = $this-&gt;api_version;
    $signer-&gt;utilities_class = $this-&gt;utilities_class;
    $signer-&gt;request_class = $this-&gt;request_class;
    $signer-&gt;response_class = $this-&gt;response_class;
    $signer-&gt;use_ssl = $this-&gt;use_ssl;
    $signer-&gt;proxy = $this-&gt;proxy;
    $signer-&gt;util = $this-&gt;util;
    $signer-&gt;registered_streaming_read_callback = $this-&gt;registered_streaming_read_callback;
    $signer-&gt;registered_streaming_write_callback = $this-&gt;registered_streaming_write_callback;
    $request = $signer-&gt;authenticate();

    // Update RequestCore settings
    $request-&gt;request_class = $this-&gt;request_class;
    $request-&gt;response_class = $this-&gt;response_class;
    $request-&gt;ssl_verification = $this-&gt;ssl_verification;

    /*%******************************************************************************************%*/

    // Debug mode
    if ($this-&gt;debug_mode)
    {
        $request-&gt;debug_mode = $this-&gt;debug_mode;
    }

    // Set custom CURLOPT settings
    if (count($curlopts))
    {
        $request-&gt;set_curlopts($curlopts);
    }

    // Manage the (newer) batch request API or the (older) returnCurlHandle setting.
    if ($this-&gt;use_batch_flow)
    {
        $handle = $request-&gt;prep_request();
        $this-&gt;batch_object-&gt;add($handle);
        $this-&gt;use_batch_flow = false;

        return $handle;
    }
    elseif ($return_curl_handle)
    {
        return $request-&gt;prep_request();
    }

    // Send!
    $request-&gt;send_request();

    // Prepare the response.
    $headers = $request-&gt;get_response_header();
    $headers['x-aws-stringtosign'] = $signer-&gt;string_to_sign;

    if (isset($signer-&gt;canonical_request))
    {
        $headers['x-aws-canonicalrequest'] = $signer-&gt;canonical_request;
    }

    $headers['x-aws-request-headers'] = $request-&gt;request_headers;
    $headers['x-aws-body'] = $signer-&gt;querystring;

    $data = new $this-&gt;response_class($headers, ($this-&gt;parse_the_response === true) ? $this-&gt;parse_callback($request-&gt;get_response_body()) : $request-&gt;get_response_body(), $request-&gt;get_response_code());

    $response_body = (string) $request-&gt;get_response_body();

    // Was it Amazon's fault the request failed? Retry the request until we reach $max_retries.
    if (
        (integer) $request-&gt;get_response_code() === 500 || // Internal Error (presumably transient)
        (integer) $request-&gt;get_response_code() === 503)   // Service Unavailable (presumably transient)
    {
        if ($this-&gt;redirects &lt;= $this-&gt;max_retries)
        {
            // Exponential backoff
            $delay = (integer) (pow(4, $this-&gt;redirects) * 100000);
            usleep($delay);
            $this-&gt;redirects++;
            $data = $this-&gt;authenticate($operation, $original_payload);
        }
    }

    // DynamoDB has additional, custom logic for retrying requests
    else
    {
        // If the request to DynamoDB was throttled, we need to retry
        $need_to_retry_dynamodb_request = (
            (integer) $request-&gt;get_response_code() === 400 &amp;&amp;
            stripos($response_body, 'com.amazonaws.dynamodb.') !== false &amp;&amp;
            stripos($response_body, 'ProvisionedThroughputExceededException') !== false
        );

        // If the CRC32 of the response does not match the expected value, we need to retry
        $response_headers = $request-&gt;get_response_header();
        if (!$need_to_retry_dynamodb_request &amp;&amp; isset($response_headers['x-amz-crc32']))
        {
            $crc32_expected = $response_headers['x-amz-crc32'];
            $crc32_actual = hexdec(hash('crc32b', $response_body));
            $need_to_retry_dynamodb_request = ($crc32_expected != $crc32_actual);
        }

        // Perform retry if necessary using a more aggressive exponential backoff
        if ($need_to_retry_dynamodb_request)
        {
            if ($this-&gt;redirects === 0)
            {
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
            elseif ($this-&gt;redirects &lt;= max($this-&gt;max_retries, 10))
            {
                // Exponential backoff
                $delay = (integer) (pow(2, ($this-&gt;redirects - 1)) * 50000);
                usleep($delay);
                $this-&gt;redirects++;
                $data = $this-&gt;authenticate($operation, $original_payload);
            }
        }
    }

    $this-&gt;redirects = 0;
    return $data;
}";}i:3;a:8:{s:4:"name";s:5:"batch";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:86:"<p>Specifies that the intended request should be queued for a later batch request.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"queue";s:4:"type";s:14:"CFBatchRequest";s:11:"description";s:327:"<p>The <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a> instance to use for managing batch requests. If not available, it generates a new instance of <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:477:"public function batch(CFBatchRequest &amp;$queue = null)
{
    if ($queue)
    {
        $this-&gt;batch_object = $queue;
    }
    elseif ($this-&gt;internal_batch_object)
    {
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }
    else
    {
        $this-&gt;internal_batch_object = new $this-&gt;batch_class();
        $this-&gt;batch_object = &amp;$this-&gt;internal_batch_object;
    }

    $this-&gt;use_batch_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:4;a:8:{s:4:"name";s:5:"cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:349:"<p>Specifies that the resulting <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object should be cached according to the settings from
<a href="../amazonelasticbeanstalk/set_cache_config.html" rel="../../index.html#m=amazonelasticbeanstalk/set_cache_config"><code>set_cache_config()</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"expires";s:4:"type";s:14:"string|integer";s:11:"description";s:232:"<p>The time the cache is to expire. Accepts a number of seconds as an integer, or an amount of time, as a string, that is understood by <a href="http://php.net/strtotime"><code>strtotime()</code></a> (e.g. &#8220;1 hour&#8221;).</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:501:"public function cache($expires)
{
    // Die if they haven't used set_cache_config().
    if (!$this-&gt;cache_class)
    {
        throw new CFRuntime_Exception('Must call set_cache_config() before using cache()');
    }

    if (is_string($expires))
    {
        $expires = strtotime($expires);
        $this-&gt;cache_expires = $expires - time();
    }
    elseif (is_int($expires))
    {
        $this-&gt;cache_expires = $expires;
    }

    $this-&gt;use_cache_flow = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:5:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:2;a:4:{s:5:"title";s:70:"<p>Fire a single request, and then cache the response to Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:338:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:3;a:4:{s:5:"title";s:76:"<p>Batch several requests together, and then cache the responses to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:520:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}i:4;a:4:{s:5:"title";s:88:"<p>Batch several requests together, and then cache the responses to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:524:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Prepare for parallel requests
$sdb-&gt;batch()-&gt;list_domains();
$sdb-&gt;batch()-&gt;list_domains();

// First time pulls live data
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;batch()-&gt;cache('1 minute')-&gt;send(false);
var_dump($response[0]-&gt;isOK());
var_dump($response[1]-&gt;isOK());";s:6:"result";s:43:"bool(true)
bool(true)
bool(true)
bool(true)";}}}}i:5;a:7:{s:4:"name";s:34:"cache_instance_profile_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:139:"<p>Fetches and caches EC2 instance profile credentials. This is meant to be used by the constructor, and is not to
be manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:2563:"public function cache_instance_profile_credentials($cache, $options)
{
    $instance_profile_url = 'http://169.254.169.254/latest/meta-data/iam/security-credentials/';
    $connect_timeout = isset($options['instance_profile_timeout']) ? $options['instance_profile_timeout'] : 2;

    try
    {
        // Make a call to the EC2 Metadata Service to find the available instance profile
        $request = new RequestCore($instance_profile_url);
        $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
        $response = $request-&gt;send_request(true);

        if ($response-&gt;isOK())
        {
            // Get the instance profile name
            $profile = (string) $response-&gt;body;

            // Make a call to the EC2 Metadata Service to get the instance profile credentials
            $request = new RequestCore($instance_profile_url . $profile);
            $request-&gt;set_curlopts(array(CURLOPT_CONNECTTIMEOUT =&gt; $connect_timeout));
            $response = $request-&gt;send_request(true);

            if ($response-&gt;isOK())
            {
                // Get the credentials
                $credentials = json_decode($response-&gt;body, true);

                if ($credentials['Code'] === 'Success')
                {
                    // Determine the expiration time
                    $expiration_time = strtotime((string) $credentials['Expiration']);
                    $expiration_duration = round(($expiration_time - time()) * 0.85);
                    $cache-&gt;expire_in($expiration_duration);

                    // Return the credential information
                    return array(
                        'key'     =&gt; $credentials['AccessKeyId'],
                        'secret'  =&gt; $credentials['SecretAccessKey'],
                        'token'   =&gt; $credentials['Token'],
                        'expires' =&gt; $credentials['Expiration'],
                    );
                }
            }
        }
    }
    catch (cURL_Exception $e)
    {
        // The EC2 Metadata Service does not exist or had timed out.
        // An exception will be thrown on the next line.
    }

    // @codeCoverageIgnoreStart
    throw new CFCredentials_Exception('No credentials were provided. The SDK attempted to retrieve Instance '
        . 'Profile credentials from the EC2 Instance Metadata Service, but failed to do so. Instance profile '
        . 'credentials are only accessible on EC2 instances configured with a specific IAM role.');
    // @codeCoverageIgnoreEnd
}";}i:6;a:7:{s:4:"name";s:21:"cache_sts_credentials";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:122:"<p>Fetches and caches STS credentials. This is meant to be used by the constructor, and is not to be
manually invoked.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"cache";s:4:"type";s:9:"CacheCore";s:11:"description";s:84:"<p>The a reference to the cache object that is being used to handle the caching.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:57:"<p>The options that were passed into the constructor.</p>";}}}s:11:"returnvalue";s:38:"<p>The data to be cached, or NULL.</p>";s:6:"source";s:1226:"public function cache_sts_credentials($cache, $options)
{
    $token = new AmazonSTS($options);
    $response = $token-&gt;get_session_token();

    if ($response-&gt;isOK())
    {
        // Update the expiration
        $expiration_time = strtotime((string) $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials-&gt;Expiration);
        $expiration_duration = round(($expiration_time - time()) * 0.85);
        $cache-&gt;expire_in($expiration_duration);

        // Return the important data
        $credentials = $response-&gt;body-&gt;GetSessionTokenResult-&gt;Credentials;

        return array(
            'key'     =&gt; (string) $credentials-&gt;AccessKeyId,
            'secret'  =&gt; (string) $credentials-&gt;SecretAccessKey,
            'token'   =&gt; (string) $credentials-&gt;SessionToken,
            'expires' =&gt; (string) $credentials-&gt;Expiration,
        );
    }

    // @codeCoverageIgnoreStart
    throw new STS_Exception('Temporary credentials from the AWS Security '
        . 'Token Service could not be retrieved using the provided long '
        . 'term credentials. It\'s possible that the provided long term '
        . 'credentials were invalid.');
    // @codeCoverageIgnoreEnd
}";}i:7;a:8:{s:4:"name";s:22:"check_dns_availability";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Checks if the specified CNAME is available.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:11:"cnameprefix";s:4:"type";s:6:"string";s:11:"description";s:51:"<p>The prefix used when this CNAME is reserved.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:210:"public function check_dns_availability($cnameprefix, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['CNAMEPrefix'] = $cnameprefix;
    
    return $this-&gt;authenticate('CheckDNSAvailability', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Creates a new running environment.</p>";s:4:"code";s:541:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

// Check that preferred DNS is available
$dns = $bean-&gt;check_dns_availability('my-app');

if ((string) $dns-&gt;body-&gt;CheckDNSAvailabilityResult-&gt;Available === 'true')
{
	$response = $bean-&gt;create_environment('my-application', 'my-environment', array(
		'VersionLabel' =&gt; '1.0',
		'TemplateName' =&gt; 'my-template',
		'CNAMEPrefix' =&gt; 'my-app',
		'Description' =&gt; 'This is the production environment.'
	));

	// Success?
	var_dump($response-&gt;isOK());
}";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:1;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:2;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:3;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:4;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:8;a:8:{s:4:"name";s:18:"create_application";s:8:"modifier";s:6:"public";s:11:"description";s:297:"<p>Creates an application that has one configuration template named <code>default</code> and no
application versions.</p>

<p class="note">
The <code>default</code> configuration template is for a 32-bit version of the Amazon Linux
operating system running the Tomcat 6 application container.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:195:"<p>The name of the application. Constraint: This name must be unique within your account. If the specified name already exists, the action returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:614:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - Describes the application.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:217:"public function create_application($application_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    
    return $this-&gt;authenticate('CreateApplication', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:33:"<p>Creates a new application.</p>";s:4:"code";s:225:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;create_application('my-application', array(
	'Description' =&gt; 'This is my application!'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazonelasticbeanstalk/delete_application.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application"><code>delete_application()</code></a>";i:1;s:173:"<a href="../amazonelasticbeanstalk/describe_applications.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_applications"><code>describe_applications()</code></a>";i:2;s:164:"<a href="../amazonelasticbeanstalk/update_application.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application"><code>update_application()</code></a>";}}}i:9;a:8:{s:4:"name";s:26:"create_application_version";s:8:"modifier";s:6:"public";s:11:"description";s:360:"<p>Creates an application version for the specified application.</p>

<p class="note">
Once you create an application version with a specified Amazon S3 bucket and key location, you
cannot change that Amazon S3 location. If you change the Amazon S3 location, you receive an
exception when you attempt to launch an environment from the application version.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:193:"<p>The name of the application. If no application is found with this name, and <code>AutoCreateApplication</code> is <code>false</code>, returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"version_label";s:4:"type";s:6:"string";s:11:"description";s:247:"<p>A label identifying this version. Constraint: Must be unique per application. If an application version already exists with this label for the specified application, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2428:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - Describes this version.</li><li><code>SourceBundle</code> - <code>array</code> - Optional - The Amazon S3 bucket and key that identify the location of the source bundle for this version. If data found at the Amazon S3 location exceeds the maximum allowed source bundle size, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error. Default: If not specified, AWS Elastic Beanstalk uses a sample application. If only partially specified (for example, a bucket is provided but not the key) or if no data is found at the Amazon S3 location, AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>S3Bucket</code> - <code>string</code> - Optional - The Amazon S3 bucket where the data is located.</li><li><code>S3Key</code> - <code>string</code> - Optional - The Amazon S3 key where the data is located.</li></ul></li></ul></li><li><code>AutoCreateApplication</code> - <code>boolean</code> - Optional - Determines how the system behaves if the specified application for this version does not already exist:<enumValues><value name="true"> <code>true</code>: Automatically creates the specified application for this version if it does not already exist.</value><value name="false"> <code>false</code>: Returns an <code>InvalidParameterValue</code> if the specified application for this version does not already exist.</value></enumValues><ul><li> <code>true</code>: Automatically creates the specified application for this release if it does not already exist.</li><li> <code>false</code>: Throws an <code>InvalidParameterValue</code> if the specified application for this release does not already exist.</li></ul>Default: <code>false</code> Valid Values: <code>true</code> | <code>false</code></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:545:"public function create_application_version($application_name, $version_label, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['VersionLabel'] = $version_label;
    
    // Optional map (non-list)
    if (isset($opt['SourceBundle']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SourceBundle' =&gt; $opt['SourceBundle']
        ), 'member'));
        unset($opt['SourceBundle']);
    }

    return $this-&gt;authenticate('CreateApplicationVersion', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Creates a new application version.</p>";s:4:"code";s:575:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

// Create a new S3 storage location for use with Elastic Beanstalk.
$s3_bucket = (string) $bean-&gt;create_storage_location()-&gt;body-&gt;S3Bucket()-&gt;first();

$response = $bean-&gt;create_application_version('my-application', '1.0', array(
	'Description' =&gt; 'Version 1.0 of the application.',
	'SourceBundle' =&gt; array(
		'S3Bucket' =&gt; 'elasticbeanstalk-us-east-1',
		'S3Key' =&gt; 'resources/sampleapp.war'
	),
	'AutoCreateApplication' =&gt; 'true'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:188:"<a href="../amazonelasticbeanstalk/delete_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application_version"><code>delete_application_version()</code></a>";i:1;s:197:"<a href="../amazonelasticbeanstalk/describe_application_versions.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_application_versions"><code>describe_application_versions()</code></a>";i:2;s:188:"<a href="../amazonelasticbeanstalk/update_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application_version"><code>update_application_version()</code></a>";}}}i:10;a:8:{s:4:"name";s:29:"create_configuration_template";s:8:"modifier";s:6:"public";s:11:"description";s:376:"<p>Creates a configuration template. Templates are associated with a specific application and are
used to deploy different versions of the application with the same configuration settings.</p>

<p>Related Topics</p>

<ul><li><code>DescribeConfigurationOptions</code></li><li><code>DescribeConfigurationSettings</code></li><li><code>ListAvailableSolutionStacks</code></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:199:"<p>The name of the application to associate with this configuration template. If no application is found with this name, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"template_name";s:4:"type";s:6:"string";s:11:"description";s:243:"<p>The name of the configuration template. Constraint: This name must be unique per application. Default: If a configuration template already exists with this name, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3371:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SolutionStackName</code> - <code>string</code> - Optional - The name of the solution stack used by this configuration. The solution stack specifies the operating system, architecture, and application server for a configuration template. It determines the set of configuration options as well as the possible and default values. Use <code>ListAvailableSolutionStacks</code> to obtain a list of available solution stacks. Default: If the <code>SolutionStackName</code> is not specified and the source configuration parameter is blank, AWS Elastic Beanstalk uses the default solution stack. If not specified and the source configuration parameter is specified, AWS Elastic Beanstalk uses the same solution stack as the source configuration template.</li><li><code>SourceConfiguration</code> - <code>array</code> - Optional - If specified, AWS Elastic Beanstalk uses the configuration values from the specified configuration template to create a new configuration. Values specified in the <code>OptionSettings</code> parameter of this call overrides any values obtained from the <code>SourceConfiguration</code>. If no configuration template is found, returns an <code>InvalidParameterValue</code> error. Constraint: If both the solution stack name parameter and the source configuration parameters are specified, the solution stack of the source configuration template must match the specified solution stack name or else AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>ApplicationName</code> - <code>string</code> - Optional - The name of the application associated with the configuration.</li><li><code>TemplateName</code> - <code>string</code> - Optional - The name of the configuration template.</li></ul></li></ul></li><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment used with this configuration template.</li><li><code>Description</code> - <code>string</code> - Optional - Describes this configuration.</li><li><code>OptionSettings</code> - <code>array</code> - Optional - If specified, AWS Elastic Beanstalk sets the specified configuration option to the requested value. The new value overrides the value obtained from the solution stack or the source configuration template. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li><li><code>Value</code> - <code>string</code> - Optional - The current value for the configuration option.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:841:"public function create_configuration_template($application_name, $template_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['TemplateName'] = $template_name;
    
    // Optional map (non-list)
    if (isset($opt['SourceConfiguration']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'SourceConfiguration' =&gt; $opt['SourceConfiguration']
        ), 'member'));
        unset($opt['SourceConfiguration']);
    }
    
    // Optional list + map
    if (isset($opt['OptionSettings']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionSettings' =&gt; $opt['OptionSettings']
        ), 'member'));
        unset($opt['OptionSettings']);
    }

    return $this-&gt;authenticate('CreateConfigurationTemplate', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:44:"<p>Creates a new configuration template.</p>";s:4:"code";s:865:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;create_configuration_template('my-application', 'my-template', array(
	'SolutionStackName' =&gt; '32bit Amazon Linux running Tomcat 6',
	'Description' =&gt; 'This is my default template.',
	'OptionSettings' =&gt; array(
		array(
			'Namespace' =&gt; 'aws:elasticbeanstalk:sns:topics',
			'OptionName' =&gt; 'Notification Topic Name',
			'Value' =&gt; 'elasticbeanstalk-event-topic'
		),
		array(
			'Namespace' =&gt; 'aws:elasticbeanstalk:sns:topics',
			'OptionName' =&gt; 'Notification Protocol',
			'Value' =&gt; 'sqs'
		),
		array(
			'Namespace' =&gt; 'aws:elasticbeanstalk:sns:topics',
			'OptionName' =&gt; 'Notification Topic ARN',
			'Value' =&gt; 'arn:aws:sqs:us-east-1:0123456789012:elasticbeanstalk-event-queue'
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:197:"<a href="../amazonelasticbeanstalk/delete_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_configuration_template"><code>delete_configuration_template()</code></a>";i:1;s:197:"<a href="../amazonelasticbeanstalk/update_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/update_configuration_template"><code>update_configuration_template()</code></a>";}}}i:11;a:8:{s:4:"name";s:18:"create_environment";s:8:"modifier";s:6:"public";s:11:"description";s:95:"<p>Launches an environment for the specified application using the specified configuration.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:203:"<p>The name of the application that contains the version to be deployed. If no application is found with this name, <code>CreateEnvironment</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"environment_name";s:4:"type";s:6:"string";s:11:"description";s:544:"<p>A unique name for the deployment environment. Used in the application URL. Constraint: Must be from 4 to 23 characters in length. The name can contain only letters, numbers, and hyphens. It cannot start or end with a hyphen. This name must be unique in your account. If the specified name already exists, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error. Default: If the CNAME parameter is not specified, the environment name becomes part of the CNAME, and therefore part of the visible URL for your application.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3695:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>VersionLabel</code> - <code>string</code> - Optional - The name of the application version to deploy. If the specified application has no associated application versions, AWS Elastic Beanstalk <code>UpdateEnvironment</code> returns an <code>InvalidParameterValue</code> error. Default: If not specified, AWS Elastic Beanstalk attempts to launch the most recently created application version.</li><li><code>TemplateName</code> - <code>string</code> - Optional - The name of the configuration template to use in deployment. If no configuration template is found with this name, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this parameter or a <code>SolutionStackName</code>, but not both. If you specify both, AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. If you do not specify either, AWS Elastic Beanstalk returns a <code>MissingRequiredParameter</code> error.</li><li><code>SolutionStackName</code> - <code>string</code> - Optional - This is an alternative to specifying a configuration name. If specified, AWS Elastic Beanstalk sets the configuration values to the default values associated with the specified solution stack. Condition: You must specify either this or a <code>TemplateName</code>, but not both. If you specify both, AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. If you do not specify either, AWS Elastic Beanstalk returns a <code>MissingRequiredParameter</code> error.</li><li><code>CNAMEPrefix</code> - <code>string</code> - Optional - If specified, the environment attempts to use this value as the prefix for the CNAME. If not specified, the environment uses the environment name.</li><li><code>Description</code> - <code>string</code> - Optional - Describes this environment.</li><li><code>OptionSettings</code> - <code>array</code> - Optional - If specified, AWS Elastic Beanstalk sets the specified configuration options to the requested value in the configuration set for the new environment. These override the values obtained from the solution stack or the configuration template. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li><li><code>Value</code> - <code>string</code> - Optional - The current value for the configuration option.</li></ul></li></ul></li><li><code>OptionsToRemove</code> - <code>array</code> - Optional - A list of custom user-defined configuration options to remove from the configuration set for this new environment. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:809:"public function create_environment($application_name, $environment_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['EnvironmentName'] = $environment_name;
    
    // Optional list + map
    if (isset($opt['OptionSettings']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionSettings' =&gt; $opt['OptionSettings']
        ), 'member'));
        unset($opt['OptionSettings']);
    }
    
    // Optional list + map
    if (isset($opt['OptionsToRemove']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionsToRemove' =&gt; $opt['OptionsToRemove']
        ), 'member'));
        unset($opt['OptionsToRemove']);
    }

    return $this-&gt;authenticate('CreateEnvironment', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Creates a new running environment.</p>";s:4:"code";s:541:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

// Check that preferred DNS is available
$dns = $bean-&gt;check_dns_availability('my-app');

if ((string) $dns-&gt;body-&gt;CheckDNSAvailabilityResult-&gt;Available === 'true')
{
	$response = $bean-&gt;create_environment('my-application', 'my-environment', array(
		'VersionLabel' =&gt; '1.0',
		'TemplateName' =&gt; 'my-template',
		'CNAMEPrefix' =&gt; 'my-app',
		'Description' =&gt; 'This is the production environment.'
	));

	// Success?
	var_dump($response-&gt;isOK());
}";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:1;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:2;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:3;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:4;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:12;a:8:{s:4:"name";s:23:"create_storage_location";s:8:"modifier";s:6:"public";s:11:"description";s:117:"<p>Creates the Amazon S3 storage location for the account.</p>

<p>This location is used to store user log files.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:166:"public function create_storage_location($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('CreateStorageLocation', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:41:"<p>Creates a new application version.</p>";s:4:"code";s:575:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

// Create a new S3 storage location for use with Elastic Beanstalk.
$s3_bucket = (string) $bean-&gt;create_storage_location()-&gt;body-&gt;S3Bucket()-&gt;first();

$response = $bean-&gt;create_application_version('my-application', '1.0', array(
	'Description' =&gt; 'Version 1.0 of the application.',
	'SourceBundle' =&gt; array(
		'S3Bucket' =&gt; 'elasticbeanstalk-us-east-1',
		'S3Key' =&gt; 'resources/sampleapp.war'
	),
	'AutoCreateApplication' =&gt; 'true'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:2;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:3;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:4;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:13;a:8:{s:4:"name";s:18:"delete_application";s:8:"modifier";s:6:"public";s:11:"description";s:256:"<p>Deletes the specified application along with all associated versions and configurations. The
application versions will not be deleted from your Amazon S3 bucket.</p>

<p class="note">
You cannot delete an application that has a running environment.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:45:"<p>The name of the application to delete.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:687:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>TerminateEnvByForce</code> - <code>boolean</code> - Optional - When set to true, running environments will be terminated before deleting the application.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:217:"public function delete_application($application_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    
    return $this-&gt;authenticate('DeleteApplication', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Delete an application.</p>";s:4:"code";s:168:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;delete_application('my-application');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_application.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application"><code>create_application()</code></a>";i:1;s:173:"<a href="../amazonelasticbeanstalk/describe_applications.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_applications"><code>describe_applications()</code></a>";i:2;s:164:"<a href="../amazonelasticbeanstalk/update_application.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application"><code>update_application()</code></a>";}}}i:14;a:8:{s:4:"name";s:26:"delete_application_version";s:8:"modifier";s:6:"public";s:11:"description";s:179:"<p>Deletes the specified version from the specified application.</p>

<p class="note">
You cannot delete an application version that is associated with a running environment.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:59:"<p>The name of the application to delete releases from.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"version_label";s:4:"type";s:6:"string";s:11:"description";s:42:"<p>The label of the version to delete.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:966:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>DeleteSourceBundle</code> - <code>boolean</code> - Optional - Indicates whether to delete the associated source bundle from Amazon S3:<ul><li> <code>true</code>: An attempt is made to delete the associated Amazon S3 source bundle specified at time of creation.</li><li> <code>false</code>: No action is taken on the Amazon S3 source bundle specified at time of creation.</li></ul>Valid Values: <code>true</code> | <code>false</code></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:291:"public function delete_application_version($application_name, $version_label, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['VersionLabel'] = $version_label;
    
    return $this-&gt;authenticate('DeleteApplicationVersion', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:38:"<p>Deletes an application version.</p>";s:4:"code";s:228:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;delete_application_version('my-application', '1.0', array(
	'DeleteSourceBundle' =&gt; 'true'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:188:"<a href="../amazonelasticbeanstalk/create_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application_version"><code>create_application_version()</code></a>";i:1;s:197:"<a href="../amazonelasticbeanstalk/describe_application_versions.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_application_versions"><code>describe_application_versions()</code></a>";i:2;s:188:"<a href="../amazonelasticbeanstalk/update_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application_version"><code>update_application_version()</code></a>";}}}i:15;a:7:{s:4:"name";s:12:"delete_cache";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:169:"<p>Deletes a cached <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object using the specified cache storage type.</p>";s:11:"returnvalue";s:118:"<p>A value of <code>true</code> if cached object exists and is successfully deleted, otherwise <code>false</code>.</p>";s:6:"source";s:125:"public function delete_cache()
{
    $this-&gt;use_cache_flow = true;
    $this-&gt;delete_cache = true;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:4:{s:5:"title";s:41:"<p>Delete a cached response from APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:169:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:11:"bool(false)";}i:1;a:4:{s:5:"title";s:53:"<p>Delete a cached response from the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:173:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}i:2;a:4:{s:5:"title";s:46:"<p>Delete a cached response from Memcache.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:205:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config(array(
	array('host' =&gt; '127.0.0.1')
));

// Delete the data
$response = $sdb-&gt;delete_cache()-&gt;list_domains();
var_dump($response);";s:6:"result";s:10:"bool(true)";}}}}i:16;a:8:{s:4:"name";s:29:"delete_configuration_template";s:8:"modifier";s:6:"public";s:11:"description";s:296:"<p>Deletes the specified configuration template.</p>

<p class="note">
When you launch an environment using a configuration template, the environment gets a copy of
the template. You can delete or modify the environment&#8217;s copy of the template without affecting
the running environment.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:77:"<p>The name of the application to delete the configuration template from.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"template_name";s:4:"type";s:6:"string";s:11:"description";s:56:"<p>The name of the configuration template to delete.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:297:"public function delete_configuration_template($application_name, $template_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['TemplateName'] = $template_name;
    
    return $this-&gt;authenticate('DeleteConfigurationTemplate', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Delete a configuration template.</p>";s:4:"code";s:194:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;delete_configuration_template('my-application', 'my-template');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:197:"<a href="../amazonelasticbeanstalk/create_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/create_configuration_template"><code>create_configuration_template()</code></a>";i:1;s:197:"<a href="../amazonelasticbeanstalk/update_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/update_configuration_template"><code>update_configuration_template()</code></a>";}}}i:17;a:8:{s:4:"name";s:32:"delete_environment_configuration";s:8:"modifier";s:6:"public";s:11:"description";s:532:"<p>Deletes the draft configuration associated with the running environment.</p>

<p>Updating a running environment with any configuration changes creates a draft configuration
set. You can get the draft configuration using <code>DescribeConfigurationSettings</code> while
the update is in progress or if the update fails. The <code>DeploymentStatus</code> for the
draft configuration indicates whether the deployment is in process or has failed. The draft
configuration remains in existence until it is deleted with this action.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:70:"<p>The name of the application the environment is associated with.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"environment_name";s:4:"type";s:6:"string";s:11:"description";s:74:"<p>The name of the environment to delete the draft configuration from.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:312:"public function delete_environment_configuration($application_name, $environment_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['EnvironmentName'] = $environment_name;
    
    return $this-&gt;authenticate('DeleteEnvironmentConfiguration', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:43:"<p>Delete an environment configuration.</p>";s:4:"code";s:200:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;delete_environment_configuration('my-application', 'my-environment');

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:2;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:3;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:4;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:18;a:8:{s:4:"name";s:29:"describe_application_versions";s:8:"modifier";s:6:"public";s:11:"description";s:62:"<p>Returns descriptions for existing application versions.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:998:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ApplicationName</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to only include ones that are associated with the specified application.</li><li><code>VersionLabels</code> - <code>string|array</code> - Optional - If specified, restricts the returned descriptions to only include ones that have the specified version labels. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:503:"public function describe_application_versions($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['VersionLabels']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'VersionLabels' =&gt; (is_array($opt['VersionLabels']) ? $opt['VersionLabels'] : array($opt['VersionLabels']))
        ), 'member'));
        unset($opt['VersionLabels']);
    }

    return $this-&gt;authenticate('DescribeApplicationVersions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:41:"<p>Describe all application versions.</p>";s:4:"code";s:163:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_application_versions();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:51:"<p>Describe versions for specific applications.</p>";s:4:"code";s:243:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_application_versions(array(
	'ApplicationName' =&gt; 'my-application',
	'VersionLabels' =&gt; '1.0'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:188:"<a href="../amazonelasticbeanstalk/create_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application_version"><code>create_application_version()</code></a>";i:1;s:188:"<a href="../amazonelasticbeanstalk/delete_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application_version"><code>delete_application_version()</code></a>";i:2;s:188:"<a href="../amazonelasticbeanstalk/update_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application_version"><code>update_application_version()</code></a>";}}}i:19;a:8:{s:4:"name";s:21:"describe_applications";s:8:"modifier";s:6:"public";s:11:"description";s:57:"<p>Returns the descriptions of existing applications.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:793:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ApplicationNames</code> - <code>string|array</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to only include those with the specified names. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:506:"public function describe_applications($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list (non-map)
    if (isset($opt['ApplicationNames']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'ApplicationNames' =&gt; (is_array($opt['ApplicationNames']) ? $opt['ApplicationNames'] : array($opt['ApplicationNames']))
        ), 'member'));
        unset($opt['ApplicationNames']);
    }

    return $this-&gt;authenticate('DescribeApplications', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:42:"<p>Describe all existing applications.</p>";s:4:"code";s:155:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_applications();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:39:"<p>Describe a specific application.</p>";s:4:"code";s:206:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_applications(array(
	'ApplicationNames' =&gt; 'my-application'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_application.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application"><code>create_application()</code></a>";i:1;s:164:"<a href="../amazonelasticbeanstalk/delete_application.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application"><code>delete_application()</code></a>";i:2;s:164:"<a href="../amazonelasticbeanstalk/update_application.html" rel="../../index.html#m=amazonelasticbeanstalk/update_application"><code>update_application()</code></a>";}}}i:20;a:8:{s:4:"name";s:30:"describe_configuration_options";s:8:"modifier";s:6:"public";s:11:"description";s:323:"<p>Describes the configuration options that are used in a particular configuration template or
environment, or that a specified solution stack defines. The description includes the values
the options, their default values, and an indication of the required action on a running
environment if an option value is changed.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1765:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ApplicationName</code> - <code>string</code> - Optional - The name of the application associated with the configuration template or environment. Only needed if you want to describe the configuration options associated with either the configuration template or environment.</li><li><code>TemplateName</code> - <code>string</code> - Optional - The name of the configuration template whose configuration options you want to describe.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment whose configuration options you want to describe.</li><li><code>SolutionStackName</code> - <code>string</code> - Optional - The name of the solution stack whose configuration options you want to describe.</li><li><code>Options</code> - <code>array</code> - Optional - If specified, restricts the descriptions to only the specified options. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:410:"public function describe_configuration_options($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['Options']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'Options' =&gt; $opt['Options']
        ), 'member'));
        unset($opt['Options']);
    }

    return $this-&gt;authenticate('DescribeConfigurationOptions', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{i:0;a:3:{s:5:"title";s:42:"<p>Describe all configuration options.</p>";s:4:"code";s:164:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_configuration_options();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:81:"<p>Describe configuration options for a specific application and environment.</p>";s:4:"code";s:257:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_configuration_options(array(
	'ApplicationName' =&gt; 'my-application',
	'EnvironmentName' =&gt; 'my-environment'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:2;a:3:{s:5:"title";s:81:"<p>Describe all possible configuration options for a specific solution stack.</p>";s:4:"code";s:237:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_configuration_options(array(
	'SolutionStackName' =&gt; '32bit Amazon Linux running Tomcat 6'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:2;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:3;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:4;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:21;a:8:{s:4:"name";s:31:"describe_configuration_settings";s:8:"modifier";s:6:"public";s:11:"description";s:600:"<p>Returns a description of the settings for the specified configuration set, that is, either a
configuration template or the configuration set associated with a running environment.</p>

<p>When describing the settings for the configuration set associated with a running environment,
it is possible to receive two sets of setting descriptions. One is the deployed configuration
set, and the other is a draft configuration of an environment that is either in the process of
deployment or that failed to deploy.</p>

<p>Related Topics</p>

<ul><li><code>DeleteEnvironmentConfiguration</code></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:69:"<p>The application for the environment or configuration template.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1331:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>TemplateName</code> - <code>string</code> - Optional - The name of the configuration template to describe. Conditional: You must specify either this parameter or an EnvironmentName, but not both. If you specify both, AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. If you do not specify either, AWS Elastic Beanstalk returns a <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to describe. Condition: You must specify either this or a TemplateName, but not both. If you specify both, AWS Elastic Beanstalk returns an <code>InvalidParameterCombination</code> error. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:242:"public function describe_configuration_settings($application_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    
    return $this-&gt;authenticate('DescribeConfigurationSettings', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:66:"<p>Describe configuration settings for a specific application.</p>";s:4:"code";s:234:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_configuration_settings('my-application', array(
	'EnvironmentName' =&gt; 'my-environment',
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:2;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:3;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:4;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:22;a:8:{s:4:"name";s:30:"describe_environment_resources";s:8:"modifier";s:6:"public";s:11:"description";s:50:"<p>Returns AWS resources for this environment.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1141:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment to retrieve AWS resource usage data. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to retrieve AWS resource usage data. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:180:"public function describe_environment_resources($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('DescribeEnvironmentResources', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:66:"<p>Describe configuration settings for a specific application.</p>";s:4:"code";s:214:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_environment_resources(array(
	'EnvironmentName' =&gt; 'my-environment'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:2;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:3;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:4;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:23;a:8:{s:4:"name";s:21:"describe_environments";s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>Returns descriptions for existing environments.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2147:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ApplicationName</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to include only those that are associated with this application.</li><li><code>VersionLabel</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to include only those that are associated with this application version.</li><li><code>EnvironmentIds</code> - <code>string|array</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to include only those that have the specified IDs. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>EnvironmentNames</code> - <code>string|array</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to include only those that have the specified names. Pass a string for a single value, or an indexed array for multiple values.</li><li><code>IncludeDeleted</code> - <code>boolean</code> - Optional - Indicates whether to include deleted environments: <code>true</code>: Environments that have been deleted after <code>IncludedDeletedBackTo</code> are displayed. <code>false</code>: Do not include deleted environments.</li><li><code>IncludedDeletedBackTo</code> - <code>string</code> - Optional - If specified when <code>IncludeDeleted</code> is set to <code>true</code>, then environments deleted after this date are displayed. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:1040:"public function describe_environments($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional DateTime
    if (isset($opt['IncludedDeletedBackTo']))
    {
        $opt['IncludedDeletedBackTo'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['IncludedDeletedBackTo']);
    }

    // Optional list (non-map)
    if (isset($opt['EnvironmentIds']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'EnvironmentIds' =&gt; (is_array($opt['EnvironmentIds']) ? $opt['EnvironmentIds'] : array($opt['EnvironmentIds']))
        ), 'member'));
        unset($opt['EnvironmentIds']);
    }
    
    // Optional list (non-map)
    if (isset($opt['EnvironmentNames']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'EnvironmentNames' =&gt; (is_array($opt['EnvironmentNames']) ? $opt['EnvironmentNames'] : array($opt['EnvironmentNames']))
        ), 'member'));
        unset($opt['EnvironmentNames']);
    }

    return $this-&gt;authenticate('DescribeEnvironments', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:33:"<p>Describe all environments.</p>";s:4:"code";s:155:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_environments();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:56:"<p>Describe environments for a specific application.</p>";s:4:"code";s:205:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_environments(array(
	'ApplicationName' =&gt; 'my-application'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:3;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:4;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:24;a:7:{s:4:"name";s:15:"describe_events";s:8:"modifier";s:6:"public";s:11:"description";s:198:"<p>Returns list of event descriptions matching criteria up to the last 6 weeks.</p>

<p class="note">
This action returns the most recent 1,000 events from the specified <code>NextToken</code>.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2994:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>ApplicationName</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to include only those associated with this application.</li><li><code>VersionLabel</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those associated with this application version.</li><li><code>TemplateName</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those that are associated with this environment configuration.</li><li><code>EnvironmentId</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those associated with this environment.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those associated with this environment.</li><li><code>RequestId</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the described events to include only those associated with this request ID.</li><li><code>Severity</code> - <code>string</code> - Optional - If specified, limits the events returned from this call to include only those with the specified severity or higher. [Allowed values: <code>TRACE</code>, <code>DEBUG</code>, <code>INFO</code>, <code>WARN</code>, <code>ERROR</code>, <code>FATAL</code>]</li><li><code>StartTime</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those that occur on or after this time. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>EndTime</code> - <code>string</code> - Optional - If specified, AWS Elastic Beanstalk restricts the returned descriptions to those that occur up to, but not including, the <code>EndTime</code>. May be passed as a number of seconds since UNIX Epoch, or any string compatible with <a href="http://php.net/strtotime"><code>strtotime()</code></a>.</li><li><code>MaxRecords</code> - <code>integer</code> - Optional - Specifies the maximum number of events that can be returned, beginning with the most recent event.</li><li><code>NextToken</code> - <code>string</code> - Optional - Pagination token. If specified, the events return the next batch of results.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:475:"public function describe_events($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional DateTime
    if (isset($opt['StartTime']))
    {
        $opt['StartTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['StartTime']);
    }
    
    // Optional DateTime
    if (isset($opt['EndTime']))
    {
        $opt['EndTime'] = $this-&gt;util-&gt;convert_date_to_iso8601($opt['EndTime']);
    }

    return $this-&gt;authenticate('DescribeEvents', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:3:{s:5:"title";s:52:"<p>Describe events that match specific criteria.</p>";s:4:"code";s:287:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_events(array(
	'SourceType' =&gt; 'db-instance',
	'StartTime' =&gt; '1 August 2010',
	'EndTime' =&gt; '2 August 2010',
	'MaxRecords' =&gt; 100,
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}i:1;a:3:{s:5:"title";s:35:"<p>Describe very recent events.</p>";s:4:"code";s:217:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;describe_events(array(
	'StartTime' =&gt; '10 minutes ago',
	'EndTime' =&gt; 'now'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}}i:25;a:7:{s:4:"name";s:11:"disable_ssl";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:312:"<p>Disables SSL/HTTPS connections for hosts that don&#8217;t support them. Some services, however, still
require SSL support.</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:192:"public function disable_ssl()
{
    trigger_error('Disabling SSL connections is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;use_ssl = false;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:35:"<p>Disable SSL for the service.</p>";s:11:"description";s:170:"<ul>
<li><strong>Note:</strong> It is not recommended to disable SSL.</li>
<li><strong>Note:</strong> This method is inherited by all service-specific classes.</li>
</ul>";s:4:"code";s:175:"// Disable SSL (Using @ to suppress the warning from the output)
$sdb = new AmazonSDB();
@$sdb-&gt;disable_ssl(true);

// Test if the value was set
var_dump($sdb-&gt;use_ssl);";s:6:"result";s:11:"bool(false)";}}}i:26;a:7:{s:4:"name";s:24:"disable_ssl_verification";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:402:"<p>Disables the verification of the SSL Certificate Authority. Doing so can enable an attacker to carry
out a man-in-the-middle attack.</p>

<p>https://secure.wikimedia.org/wikipedia/en/wiki/Man-in-the-middle_attack</p>

<p>This method will throw a user warning when invoked, which can be hidden by changing your
<a href="http://php.net/error_reporting"><code>error_reporting()</code></a> settings.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"ssl_verification";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:314:"public function disable_ssl_verification($ssl_verification = false)
{
    trigger_error('Disabling the verification of SSL certificates can lead to man-in-the-middle attacks. It is potentially unsafe and highly discouraged.', E_USER_WARNING);
    $this-&gt;ssl_verification = $ssl_verification;
    return $this;
}";}i:27;a:8:{s:4:"name";s:17:"enable_debug_mode";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:75:"<p>Enables HTTP request/response header logging to <code>STDERR</code>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"enabled";s:4:"type";s:7:"boolean";s:11:"description";s:74:"<p>Whether or not to enable debug mode. Defaults to <code>true</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:109:"public function enable_debug_mode($enabled = true)
{
    $this-&gt;debug_mode = $enabled;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:82:"<p>Enable the logging of HTTP request/response headers to <code>STDERR</code>.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;enable_debug_mode();

// Test if the value was set
var_dump($sdb-&gt;debug_mode);";s:6:"result";s:10:"bool(true)";}}}i:28;a:7:{s:4:"name";s:7:"factory";s:8:"modifier";s:13:"public static";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:76:"<p>Alternate approach to constructing a new instance. Supports chaining.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"options";s:4:"type";s:5:"array";s:11:"description";s:1595:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>certificate_authority</code> - <code>boolean</code> - Optional - Determines which Cerificate Authority file to use. A value of boolean <code>false</code> will use the Certificate Authority file available on the system. A value of boolean <code>true</code> will use the Certificate Authority provided by the SDK. Passing a file system path to a Certificate Authority file (chmodded to <code>0755</code>) will use that. Leave this set to <code>false</code> if you&#8217;re not sure.</li><li><code>credentials</code> - <code>string</code> - Optional - The name of the credential set to use for authentication.</li><li><code>default_cache_config</code> - <code>string</code> - Optional - This option allows a preferred storage type to be configured for long-term caching. This can be changed later using the <a href="../amazonelasticbeanstalk/set_cache_config.html" rel="../../index.html#m=amazonelasticbeanstalk/set_cache_config"><code>set_cache_config()</code></a> method. Valid values are: <code>apc</code>, <code>xcache</code>, or a file system path such as <code>./cache</code> or <code>/tmp/cache/</code>.</li><li><code>key</code> - <code>string</code> - Optional - Your AWS key, or a session key. If blank, the default credential set will be used.</li><li><code>secret</code> - <code>string</code> - Optional - Your AWS secret key, or a session secret key. If blank, the default credential set will be used.</li><li><code>token</code> - <code>string</code> - Optional - An AWS session token.</li></ul>";}}s:11:"returnvalue";a:1:{s:11:"@attributes";a:1:{s:4:"type";s:4:"void";}}s:6:"source";s:303:"public static function factory(array $options = array())
{
    if (version_compare(PHP_VERSION, '5.3.0', '&lt;'))
    {
        throw new Exception('PHP 5.3 or newer is required to instantiate a new class with CLASS::factory().');
    }

    $self = get_called_class();
    return new $self($options);
}";}i:29;a:8:{s:4:"name";s:30:"list_available_solution_stacks";s:8:"modifier";s:6:"public";s:11:"description";s:60:"<p>Returns a list of the available solution stack names.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:519:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:179:"public function list_available_solution_stacks($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('ListAvailableSolutionStacks', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:42:"<p>List all available solution stacks.</p>";s:4:"code";s:164:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;list_available_solution_stacks();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:2;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:3;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:4;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:5;s:203:"<a href="../amazonelasticbeanstalk/validate_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/validate_configuration_settings"><code>validate_configuration_settings()</code></a>";}}}i:30;a:8:{s:4:"name";s:19:"rebuild_environment";s:8:"modifier";s:6:"public";s:11:"description";s:162:"<p>Deletes and recreates all of the AWS resources (for example: the Auto Scaling group, load
balancer, etc.) for a specified environment and forces a restart.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1091:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment to rebuild. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to rebuild. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:159:"public function rebuild_environment($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('RebuildEnvironment', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:30:"<p>Rebuild an environment.</p>";s:4:"code";s:203:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;rebuild_environment(array(
	'EnvironmentName' =&gt; 'my-environment'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:4;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:31;a:8:{s:4:"name";s:32:"register_streaming_read_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:753:"<p>Register a callback function to execute whenever a data stream is read from using
<a href="../cfrequest/streaming_read_callback.html" rel="../../index.html#m=cfrequest/streaming_read_callback"><code>CFRequest::streaming_read_callback()</code></a>.</p>

<p>The user-defined callback function should accept three arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$file_handle</code> - <code>resource</code> - Required - The file handle resource that represents the file on the local file system.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:143:"public function register_streaming_read_callback($callback)
{
    $this-&gt;registered_streaming_read_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:85:"<p>Register a callback function to execute when data is read from an open stream.</p>";s:4:"code";s:694:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $file_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is read locally.
$s3-&gt;register_streaming_read_callback('callback');

// Download a public object.
$response = $s3-&gt;create_object('my-bucket', 'my-large-file.mp4', array(
	'fileUpload' =&gt; './uploads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:32;a:8:{s:4:"name";s:33:"register_streaming_write_callback";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:608:"<p>Register a callback function to execute whenever a data stream is written to using
<a href="../cfrequest/streaming_write_callback.html" rel="../../index.html#m=cfrequest/streaming_write_callback"><code>CFRequest::streaming_write_callback()</code></a>.</p>

<p>The user-defined callback function should accept two arguments:</p>

<ul><li><code>$curl_handle</code> - <code>resource</code> - Required - The cURL handle resource that represents the in-progress transfer.</li><li><code>$length</code> - <code>integer</code> - Required - The length in kilobytes of the data chunk that was transferred.</li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"callback";s:4:"type";s:21:"string|array|function";s:11:"description";s:363:"<p>The callback function is called by <a href="http://php.net/call_user_func"><code>call_user_func()</code></a>, so you can pass the following values:</p>

<ul><li>The name of a global function to execute, passed as a string.</li><li>A method to execute, passed as <code>array('ClassName', 'MethodName')</code>.</li><li>An anonymous function (PHP 5.3+).</li></ul>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:145:"public function register_streaming_write_callback($callback)
{
    $this-&gt;registered_streaming_write_callback = $callback;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:86:"<p>Register a callback function to execute when data is written to an open stream.</p>";s:4:"code";s:685:"$s3 = new AmazonS3();

// Define callback function
function callback($curl_handle, $length)
{
	$total = curl_getinfo($curl_handle, CURLINFO_CONTENT_LENGTH_DOWNLOAD);
	$transferred = curl_getinfo($curl_handle, CURLINFO_SIZE_DOWNLOAD);
	$percentage = floor(($transferred / $total) * 100);

	echo 'Transferred ' . $transferred . ' KB out of ' . $total . ' KB (' . $percentage . '%)' . PHP_EOL;
}

// Register a callback function to execute when a stream is written locally.
$s3-&gt;register_streaming_write_callback('callback');

// Download a public object.
$response = $s3-&gt;get_object('my-bucket', 'my-large-file.mp4', array(
	'fileDownload' =&gt; './downloads/my-large-file.mp4'
));";s:6:"result";s:94:"Transferred 7200 bytes out of 9000000 (0%)
...
Transferred 9000000 bytes out of 9000000 (100%)";}}}i:33;a:8:{s:4:"name";s:24:"request_environment_info";s:8:"modifier";s:6:"public";s:11:"description";s:431:"<p>Initiates a request to compile the specified type of information of the deployed environment.</p>

<p>Setting the <code>InfoType</code> to <code>tail</code> compiles the last lines from the
application server log files of every Amazon EC2 instance in your environment. Use
<code>RetrieveEnvironmentInfo</code> to access the compiled information.</p>

<p>Related Topics</p>

<ul><li><code>RetrieveEnvironmentInfo</code></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"info_type";s:4:"type";s:6:"string";s:11:"description";s:78:"<p>The type of information to request. [Allowed values: <code>tail</code>]</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1357:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment of the requested data. If no such environment is found, <code>RequestEnvironmentInfo</code> returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment of the requested data. If no such environment is found, <code>RequestEnvironmentInfo</code> returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:207:"public function request_environment_info($info_type, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InfoType'] = $info_type;
    
    return $this-&gt;authenticate('RequestEnvironmentInfo', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:71:"<p>Request and retrieve the information for a specific environment.</p>";s:4:"code";s:381:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$info_request = $bean-&gt;request_environment_info('tail', array(
	'EnvironmentName' =&gt; 'my-environment'
));

if ($info_request-&gt;isOK())
{
	sleep(20);

	$response = $bean-&gt;retrieve_environment_info('tail', array(
		'EnvironmentName' =&gt; 'my-environment'
	));

}

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:4;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:34;a:8:{s:4:"name";s:18:"restart_app_server";s:8:"modifier";s:6:"public";s:11:"description";s:110:"<p>Causes the environment to restart the application container server running on each Amazon EC2
instance.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1121:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment to restart the server for. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to restart the server for. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:156:"public function restart_app_server($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('RestartAppServer', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Restart an application server.</p>";s:4:"code";s:202:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;restart_app_server(array(
	'EnvironmentName' =&gt; 'my-environment'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:4;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:5;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:35;a:8:{s:4:"name";s:25:"retrieve_environment_info";s:8:"modifier";s:6:"public";s:11:"description";s:171:"<p>Retrieves the compiled information from a <code>RequestEnvironmentInfo</code> request.</p>

<p>Related Topics</p>

<ul><li><code>RequestEnvironmentInfo</code></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:9:"info_type";s:4:"type";s:6:"string";s:11:"description";s:79:"<p>The type of information to retrieve. [Allowed values: <code>tail</code>]</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1267:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the data&#8217;s environment. If no such environment is found, returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the data&#8217;s environment. If no such environment is found, returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:209:"public function retrieve_environment_info($info_type, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['InfoType'] = $info_type;
    
    return $this-&gt;authenticate('RetrieveEnvironmentInfo', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:71:"<p>Request and retrieve the information for a specific environment.</p>";s:4:"code";s:381:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$info_request = $bean-&gt;request_environment_info('tail', array(
	'EnvironmentName' =&gt; 'my-environment'
));

if ($info_request-&gt;isOK())
{
	sleep(20);

	$response = $bean-&gt;retrieve_environment_info('tail', array(
		'EnvironmentName' =&gt; 'my-environment'
	));

}

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:4;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:5;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:6;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:36;a:7:{s:4:"name";s:4:"send";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:71:"<p>Executes the batch request queue by sending all queued requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:16:"clear_after_send";s:4:"type";s:7:"boolean";s:11:"description";s:204:"<p>Whether or not to clear the batch queue after sending a request. Defaults to <code>true</code>. Set this to <code>false</code> if you are caching batch responses and want to retrieve results later.</p>";}}s:11:"returnvalue";s:126:"<p>An array of <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> objects.</p>";s:6:"source";s:2018:"public function send($clear_after_send = true)
{
    if ($this-&gt;use_batch_flow)
    {
        // When we send the request, disable batch flow.
        $this-&gt;use_batch_flow = false;

        // If we're not caching, simply send the request.
        if (!$this-&gt;use_cache_flow)
        {
            $response = $this-&gt;batch_object-&gt;send();
            $parsed_data = array_map(array($this, 'parse_callback'), $response);
            $parsed_data = new CFArray($parsed_data);

            // Clear the queue
            if ($clear_after_send)
            {
                $this-&gt;batch_object-&gt;queue = array();
            }

            return $parsed_data;
        }

        // Generate an identifier specific to this particular set of arguments.
        $cache_id = $this-&gt;key . '_' . get_class($this) . '_' . sha1(serialize($this-&gt;batch_object));

        // Instantiate the appropriate caching object.
        $this-&gt;cache_object = new $this-&gt;cache_class($cache_id, $this-&gt;cache_location, $this-&gt;cache_expires, $this-&gt;cache_compress);

        if ($this-&gt;delete_cache)
        {
            $this-&gt;use_cache_flow = false;
            $this-&gt;delete_cache = false;
            return $this-&gt;cache_object-&gt;delete();
        }

        // Invoke the cache callback function to determine whether to pull data from the cache or make a fresh request.
        $data_set = $this-&gt;cache_object-&gt;response_manager(array($this, 'cache_callback_batch'), array($this-&gt;batch_object));
        $parsed_data = array_map(array($this, 'parse_callback'), $data_set);
        $parsed_data = new CFArray($parsed_data);

        // Clear the queue
        if ($clear_after_send)
        {
            $this-&gt;batch_object-&gt;queue = array();
        }

        // End!
        return $parsed_data;
    }

    // Load the class
    $null = new CFBatchRequest();
    unset($null);

    throw new CFBatchRequest_Exception('You must use $object-&gt;batch()-&gt;send()');
}";}i:37;a:7:{s:4:"name";s:15:"set_batch_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:291:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:116:"public function set_batch_class($class = 'CFBatchRequest')
{
    $this-&gt;batch_class = $class;
    return $this;
}";}i:38;a:8:{s:4:"name";s:16:"set_cache_config";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Set the caching configuration to use for response caching.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"location";s:4:"type";s:6:"string";s:11:"description";s:1095:"<p>The location to store the cache object in. This may vary by cache method.</p><ul><li>File - The local file system paths such as <code>./cache</code> (relative) or <code>/tmp/cache/</code> (absolute). The location must be server-writable.</li><li>APC - Pass in <code>apc</code> to use this lightweight cache. You must have the <a href="http://php.net/apc">APC extension</a> installed.</li><li>XCache - Pass in <code>xcache</code> to use this lightweight cache. You must have the <a href="http://xcache.lighttpd.net">XCache</a> extension installed.</li><li>Memcached - Pass in an indexed array of associative arrays. Each associative array should have a <code>host</code> and a <code>port</code> value representing a <a href="http://php.net/memcached">Memcached</a> server to connect to.</li><li>PDO - A URL-style string (e.g. <code>pdo.mysql://user:pass@localhost/cache</code>) or a standard DSN-style string (e.g. <code>pdo.sqlite:/sqlite/cache.db</code>). MUST be prefixed with <code>pdo.</code>. See <code>CachePDO</code> and <a href="http://php.net/pdo">PDO</a> for more details.</li></ul>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:4:"gzip";s:4:"type";s:7:"boolean";s:11:"description";s:241:"<p>Whether or not data should be gzipped before being stored. A value of <code>true</code> will compress the contents before caching them. A value of <code>false</code> will leave the contents uncompressed. Defaults to <code>true</code>.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:1210:"public function set_cache_config($location, $gzip = true)
{
    // If location is empty, don't do anything.
    if (empty($location))
    {
        return $this;
    }

    // If we have an array, we're probably passing in Memcached servers and ports.
    if (is_array($location))
    {
        $this-&gt;cache_class = 'CacheMC';
    }
    else
    {
        // I would expect locations like `/tmp/cache`, `pdo.mysql://user:pass@hostname:port`, `pdo.sqlite:memory:`, and `apc`.
        $type = strtolower(substr($location, 0, 3));
        switch ($type)
        {
            case 'apc':
                $this-&gt;cache_class = 'CacheAPC';
                break;

            case 'xca': // First three letters of `xcache`
                $this-&gt;cache_class = 'CacheXCache';
                break;

            case 'pdo':
                $this-&gt;cache_class = 'CachePDO';
                $location = substr($location, 4);
                break;

            default:
                $this-&gt;cache_class = 'CacheFile';
                break;
        }
    }

    // Set the remaining cache information.
    $this-&gt;cache_location = $location;
    $this-&gt;cache_compress = $gzip;

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:2:{i:0;a:4:{s:5:"title";s:65:"<p>Fire a single request, and then cache the response to APC.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:302:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('apc');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}i:1;a:4:{s:5:"title";s:77:"<p>Fire a single request, and then cache the response to the file system.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:306:"// Instantiate
$sdb = new AmazonSDB();
$sdb-&gt;set_cache_config('./cache');

// First time pulls live data
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());

// Second time pulls from cache
$response = $sdb-&gt;cache(10)-&gt;list_domains();
var_dump($response-&gt;isOK());";s:6:"result";s:21:"bool(true)
bool(true)";}}}}i:39;a:8:{s:4:"name";s:12:"set_hostname";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:145:"<p>Set the hostname to connect to. This is useful for alternate services that are API-compatible with
AWS, but run from a different hostname.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:8:"hostname";s:4:"type";s:6:"string";s:11:"description";s:133:"<p>The alternate hostname to use in place of the default one. Useful for mock or test applications living on different hostnames.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:11:"port_number";s:4:"type";s:7:"integer";s:11:"description";s:139:"<p>The alternate port number to use in place of the default one. Useful for mock or test applications living on different port numbers.</p>";}}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:341:"public function set_hostname($hostname, $port_number = null)
{
    if ($this-&gt;override_hostname)
    {
        $this-&gt;hostname = $hostname;

        if ($port_number)
        {
            $this-&gt;port_number = $port_number;
            $this-&gt;hostname .= ':' . (string) $this-&gt;port_number;
        }
    }

    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:40;a:8:{s:4:"name";s:15:"set_max_retries";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:7:"retries";s:4:"type";s:7:"integer";s:11:"description";s:88:"<p>The maximum number of times to retry failed requests. Defaults to <code>3</code>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:105:"public function set_max_retries($retries = 3)
{
    $this-&gt;max_retries = $retries;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:65:"<p>Sets the maximum number of times to retry failed requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:131:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_max_retries(3);

// Test if the value was set
var_dump($sdb-&gt;max_retries);";s:6:"result";s:6:"int(3)";}}}i:41;a:7:{s:4:"name";s:16:"set_parser_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:115:"public function set_parser_class($class = 'CFSimpleXML')
{
    $this-&gt;parser_class = $class;
    return $this;
}";}i:42;a:8:{s:4:"name";s:9:"set_proxy";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:37:"<p>Set the proxy settings to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:5:"proxy";s:4:"type";s:6:"string";s:11:"description";s:102:"<p>Accepts proxy credentials in the following format: <code>proxy://user:pass@hostname:port</code></p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:85:"public function set_proxy($proxy)
{
    $this-&gt;proxy = $proxy;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:48:"<p>Set the proxy server to use for requests.</p>";s:11:"description";s:87:"<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:151:"// Adjust offset
$sdb = new AmazonSDB();
$sdb-&gt;set_proxy('proxy://user:pass@hostname:port');

// Test if the value was set
var_dump($sdb-&gt;proxy);";s:6:"result";s:44:"string(31) "proxy://user:pass@hostname:port"";}}}i:43;a:6:{s:4:"name";s:10:"set_region";s:8:"modifier";s:6:"public";s:11:"description";s:76:"<p>This allows you to explicitly sets the region for the service to use.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"region";s:4:"type";s:6:"string";s:11:"description";s:1333:"<p>The region to explicitly set. Available options are <a href="../amazonelasticbeanstalk/constants.html#region_us_e1" rel="../../index.html#c=amazonelasticbeanstalk/region_us_e1"><code>REGION_US_E1</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_us_w1" rel="../../index.html#c=amazonelasticbeanstalk/region_us_w1"><code>REGION_US_W1</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_us_w2" rel="../../index.html#c=amazonelasticbeanstalk/region_us_w2"><code>REGION_US_W2</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_eu_w1" rel="../../index.html#c=amazonelasticbeanstalk/region_eu_w1"><code>REGION_EU_W1</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_apac_se1" rel="../../index.html#c=amazonelasticbeanstalk/region_apac_se1"><code>REGION_APAC_SE1</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_apac_se2" rel="../../index.html#c=amazonelasticbeanstalk/region_apac_se2"><code>REGION_APAC_SE2</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_apac_ne1" rel="../../index.html#c=amazonelasticbeanstalk/region_apac_ne1"><code>REGION_APAC_NE1</code></a>, <a href="../amazonelasticbeanstalk/constants.html#region_sa_e1" rel="../../index.html#c=amazonelasticbeanstalk/region_sa_e1"><code>REGION_SA_E1</code></a>.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:156:"public function set_region($region)
{
    // @codeCoverageIgnoreStart
    $this-&gt;set_hostname($region);
    return $this;
    // @codeCoverageIgnoreEnd
}";}i:44;a:8:{s:4:"name";s:17:"set_request_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:276:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";a:0:{}s:6:"source";s:115:"public function set_request_class($class = 'CFRequest')
{
    $this-&gt;request_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:51:"<p>Set the request class to use in the toolkit.</p>";s:11:"description";s:158:"<p>The new request class must extend from <code>CFRequest</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:310:"// Custom class to extend RequestCore
class TestRequestCore extends RequestCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_request_class('TestRequestCore');

// Test if the value was set
var_dump($sdb-&gt;request_class);";s:6:"result";s:28:"string(15) "TestRequestCore"";}}}i:45;a:8:{s:4:"name";s:19:"set_resource_prefix";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:117:"<p>Set the resource prefix to use. This method is useful for alternate services that are API-compatible
with AWS.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:6:"prefix";s:4:"type";s:6:"string";s:11:"description";s:97:"<p>An alternate prefix to prepend to the resource path. Useful for mock or test applications.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:107:"public function set_resource_prefix($prefix)
{
    $this-&gt;resource_prefix = $prefix;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:46:"<p>Configure hostname and resource prefix.</p>";s:4:"code";s:316:"// Instantiate the class
$ec2 = new AmazonEC2();

// Point to the new endpoint
$ec2-&gt;set_hostname('localhost', '3000');
$ec2-&gt;set_resource_prefix('/services/mock');
$ec2-&gt;allow_hostname_override(false);

// Describe images
$response = $ec2-&gt;describe_images();

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}}i:46;a:8:{s:4:"name";s:18:"set_response_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:279:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:118:"public function set_response_class($class = 'CFResponse')
{
    $this-&gt;response_class = $class;
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:52:"<p>Set the response class to use in the toolkit.</p>";s:11:"description";s:160:"<p>The new response class must extend from <code>CFResponse</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:316:"// Custom class to extend ResponseCore
class TestResponseCore extends ResponseCore
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_response_class('TestResponseCore');

// Test if the value was set
var_dump($sdb-&gt;response_class);";s:6:"result";s:29:"string(16) "TestResponseCore"";}}}i:47;a:8:{s:4:"name";s:19:"set_utilities_class";s:8:"modifier";s:6:"public";s:11:"inheritance";a:1:{s:5:"class";a:1:{s:4:"name";s:9:"CFRuntime";}}s:11:"description";s:282:"<p>Set a custom class for this functionality. Use this method when extending/overriding existing classes
with new functionality.</p>

<p>The replacement class must extend from <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:5:"class";s:4:"type";s:6:"string";s:11:"description";s:63:"<p>The name of the new class to use for this functionality.</p>";}}s:11:"returnvalue";s:43:"<p>A reference to the current instance.</p>";s:6:"source";s:175:"public function set_utilities_class($class = 'CFUtilities')
{
    $this-&gt;utilities_class = $class;
    $this-&gt;util = new $this-&gt;utilities_class();
    return $this;
}";s:8:"examples";a:1:{s:7:"example";a:4:{s:5:"title";s:53:"<p>Set the utilities class to use in the toolkit.</p>";s:11:"description";s:162:"<p>The new utilities class must extend from <code>CFUtilities</code>.</p>

<p><strong>Note:</strong> This method is inherited by all service-specific classes.</p>";s:4:"code";s:317:"// Custom class to extend CFUtilities
class TestUtilities extends CFUtilities
{
	public function test_method()
	{
		return true;
	}
}

// Instantiate class and set new class
$sdb = new AmazonSDB();
$sdb-&gt;set_utilities_class('TestUtilities');

// Test if the value was set
var_dump($sdb-&gt;util-&gt;test_method());";s:6:"result";s:10:"bool(true)";}}}i:48;a:6:{s:4:"name";s:23:"swap_environment_cnames";s:8:"modifier";s:6:"public";s:11:"description";s:44:"<p>Swaps the CNAMEs of two environments.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2021:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>SourceEnvironmentId</code> - <code>string</code> - Optional - The ID of the source environment. Condition: You must specify at least the <code>SourceEnvironmentID</code> or the <code>SourceEnvironmentName</code>. You may also specify both. If you specify the <code>SourceEnvironmentId</code>, you must specify the <code>DestinationEnvironmentId</code>.</li><li><code>SourceEnvironmentName</code> - <code>string</code> - Optional - The name of the source environment. Condition: You must specify at least the <code>SourceEnvironmentID</code> or the <code>SourceEnvironmentName</code>. You may also specify both. If you specify the <code>SourceEnvironmentName</code>, you must specify the <code>DestinationEnvironmentName</code>.</li><li><code>DestinationEnvironmentId</code> - <code>string</code> - Optional - The ID of the destination environment. Condition: You must specify at least the <code>DestinationEnvironmentID</code> or the <code>DestinationEnvironmentName</code>. You may also specify both. You must specify the <code>SourceEnvironmentId</code> with the <code>DestinationEnvironmentId</code>.</li><li><code>DestinationEnvironmentName</code> - <code>string</code> - Optional - The name of the destination environment. Condition: You must specify at least the <code>DestinationEnvironmentID</code> or the <code>DestinationEnvironmentName</code>. You may also specify both. You must specify the <code>SourceEnvironmentName</code> with the <code>DestinationEnvironmentName</code>.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:166:"public function swap_environment_cnames($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('SwapEnvironmentCNAMEs', $opt);
}";}i:49;a:8:{s:4:"name";s:21:"terminate_environment";s:8:"modifier";s:6:"public";s:11:"description";s:44:"<p>Terminates the specified environment.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:2156:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment to terminate. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to terminate. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>TerminateResources</code> - <code>boolean</code> - Optional - Indicates whether the associated AWS resources should shut down when the environment is terminated:<enumValues><value name="true"> <code>true</code>: (default) The user AWS resources (for example, the Auto Scaling group, LoadBalancer, etc.) are terminated along with the environment.</value><value name="false"> <code>false</code>: The environment is removed from the AWS Elastic Beanstalk but the AWS resources continue to operate.</value></enumValues><ul><li> <code>true</code>: The specified environment as well as the associated AWS resources, such as Auto Scaling group and LoadBalancer, are terminated.</li><li> <code>false</code>: AWS Elastic Beanstalk resource management is removed from the environment, but the AWS resources continue to operate.</li></ul>For more information, see the <a href="http://docs.amazonwebservices.com/elasticbeanstalk/latest/ug/">AWS Elastic Beanstalk User Guide.</a> Default: <code>true</code> Valid Values: <code>true</code> | <code>false</code></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:163:"public function terminate_environment($opt = null)
{
    if (!$opt) $opt = array();
            
    return $this-&gt;authenticate('TerminateEnvironment', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:2:{s:5:"title";s:32:"<p>Terminate an environment.</p>";s:4:"code";s:242:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;terminate_environment(array(
	'EnvironmentName' =&gt; 'my-environment',
	'TerminateResources' =&gt; 'true',
));

// Success?
var_dump($response-&gt;isOK());";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:4;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:5;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:6;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:7;s:164:"<a href="../amazonelasticbeanstalk/update_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/update_environment"><code>update_environment()</code></a>";}}}i:50;a:8:{s:4:"name";s:18:"update_application";s:8:"modifier";s:6:"public";s:11:"description";s:249:"<p>Updates the specified application to have the specified properties.</p>

<p class="note">
If a property (for example, <code>description</code>) is not provided, the value remains
unchanged. To clear these properties, specify an empty string.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:2:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:162:"<p>The name of the application to update. If no such application is found, <code>UpdateApplication</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:708:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - A new description for the application. Default: If not specified, AWS Elastic Beanstalk does not update the description.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:217:"public function update_application($application_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    
    return $this-&gt;authenticate('UpdateApplication', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Update an application.</p>";s:4:"code";s:244:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;update_application('my-application', array(
	'Description' =&gt; 'This is an updated description of the app.'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_application.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application"><code>create_application()</code></a>";i:1;s:164:"<a href="../amazonelasticbeanstalk/delete_application.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application"><code>delete_application()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_applications.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_applications"><code>describe_applications()</code></a>";}}}i:51;a:8:{s:4:"name";s:26:"update_application_version";s:8:"modifier";s:6:"public";s:11:"description";s:251:"<p>Updates the specified application version to have the specified properties.</p>

<p class="note">
If a property (for example, <code>description</code>) is not provided, the value remains
unchanged. To clear properties, specify an empty string.
</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:191:"<p>The name of the application associated with this version. If no application is found with this name, <code>UpdateApplication</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"version_label";s:4:"type";s:6:"string";s:11:"description";s:177:"<p>The name of the version to update. If no application version is found with this label, <code>UpdateApplication</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:623:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - A new description for this release.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:291:"public function update_application_version($application_name, $version_label, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['VersionLabel'] = $version_label;
    
    return $this-&gt;authenticate('UpdateApplicationVersion', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:37:"<p>Update an application version.</p>";s:4:"code";s:268:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;update_application_version('my-application', '1.0', array(
	'Description' =&gt; 'This is an updated application version description.'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:3:{i:0;s:188:"<a href="../amazonelasticbeanstalk/create_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/create_application_version"><code>create_application_version()</code></a>";i:1;s:188:"<a href="../amazonelasticbeanstalk/delete_application_version.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_application_version"><code>delete_application_version()</code></a>";i:2;s:197:"<a href="../amazonelasticbeanstalk/describe_application_versions.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_application_versions"><code>describe_application_versions()</code></a>";}}}i:52;a:8:{s:4:"name";s:29:"update_configuration_template";s:8:"modifier";s:6:"public";s:11:"description";s:378:"<p>Updates the specified configuration template to have the specified properties or configuration
option values.</p>

<p class="note">
If a property (for example, <code>ApplicationName</code>) is not provided, its value remains
unchanged. To clear such properties, specify an empty string.
</p>

<p>Related Topics</p>

<ul><li><code>DescribeConfigurationOptions</code></li></ul>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:225:"<p>The name of the application associated with the configuration template to update. If no application is found with this name, <code>UpdateConfigurationTemplate</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:13:"template_name";s:4:"type";s:6:"string";s:11:"description";s:204:"<p>The name of the configuration template to update. If no configuration template is found with this name, <code>UpdateConfigurationTemplate</code> returns an <code>InvalidParameterValue</code> error.</p>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:1838:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>Description</code> - <code>string</code> - Optional - A new description for the configuration.</li><li><code>OptionSettings</code> - <code>array</code> - Optional - A list of configuration option settings to update with the new specified option value. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li><li><code>Value</code> - <code>string</code> - Optional - The current value for the configuration option.</li></ul></li></ul></li><li><code>OptionsToRemove</code> - <code>array</code> - Optional - A list of configuration options to remove from the configuration set. Constraint: You can remove only <code>UserDefined</code> configuration options. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:821:"public function update_configuration_template($application_name, $template_name, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    $opt['TemplateName'] = $template_name;
    
    // Optional list + map
    if (isset($opt['OptionSettings']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionSettings' =&gt; $opt['OptionSettings']
        ), 'member'));
        unset($opt['OptionSettings']);
    }
    
    // Optional list + map
    if (isset($opt['OptionsToRemove']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionsToRemove' =&gt; $opt['OptionsToRemove']
        ), 'member'));
        unset($opt['OptionsToRemove']);
    }

    return $this-&gt;authenticate('UpdateConfigurationTemplate', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:39:"<p>Update a configuration template.</p>";s:4:"code";s:282:"// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;update_configuration_template('my-application', 'my-template', array(
	'Description' =&gt; 'This is an updated configuration template description.'
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:2:{i:0;s:197:"<a href="../amazonelasticbeanstalk/create_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/create_configuration_template"><code>create_configuration_template()</code></a>";i:1;s:197:"<a href="../amazonelasticbeanstalk/delete_configuration_template.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_configuration_template"><code>delete_configuration_template()</code></a>";}}}i:53;a:8:{s:4:"name";s:18:"update_environment";s:8:"modifier";s:6:"public";s:11:"description";s:672:"<p>Updates the environment description, deploys a new application version, updates the
configuration settings to an entirely new configuration template, or updates select
configuration option values in the running environment.</p>

<p>Attempting to update both the release and configuration is not allowed and AWS Elastic
Beanstalk returns an <code>InvalidParameterCombination</code> error.</p>

<p>When updating the configuration settings to a new template or individual settings, a draft
configuration is created and <code>DescribeConfigurationSettings</code> for this environment
returns two setting descriptions with different <code>DeploymentStatus</code> values.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:3318:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>EnvironmentId</code> - <code>string</code> - Optional - The ID of the environment to update. If no environment with this ID exists, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to update. If no environment with this name exists, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error. Condition: You must specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns <code>MissingRequiredParameter</code> error.</li><li><code>VersionLabel</code> - <code>string</code> - Optional - If this parameter is specified, AWS Elastic Beanstalk deploys the named application version to the environment. If no such application version is found, returns an <code>InvalidParameterValue</code> error.</li><li><code>TemplateName</code> - <code>string</code> - Optional - If this parameter is specified, AWS Elastic Beanstalk deploys this configuration template to the environment. If no such configuration template is found, AWS Elastic Beanstalk returns an <code>InvalidParameterValue</code> error.</li><li><code>Description</code> - <code>string</code> - Optional - If this parameter is specified, AWS Elastic Beanstalk updates the description of this environment.</li><li><code>OptionSettings</code> - <code>array</code> - Optional - If specified, AWS Elastic Beanstalk updates the configuration set associated with the running environment and sets the specified configuration options to the requested value. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li><li><code>Value</code> - <code>string</code> - Optional - The current value for the configuration option.</li></ul></li></ul></li><li><code>OptionsToRemove</code> - <code>array</code> - Optional - A list of custom user-defined configuration options to remove from the configuration set for this environment. <ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li></ul></li></ul></li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:681:"public function update_environment($opt = null)
{
    if (!$opt) $opt = array();
            
    // Optional list + map
    if (isset($opt['OptionSettings']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionSettings' =&gt; $opt['OptionSettings']
        ), 'member'));
        unset($opt['OptionSettings']);
    }
    
    // Optional list + map
    if (isset($opt['OptionsToRemove']))
    {
        $opt = array_merge($opt, CFComplexType::map(array(
            'OptionsToRemove' =&gt; $opt['OptionsToRemove']
        ), 'member'));
        unset($opt['OptionsToRemove']);
    }

    return $this-&gt;authenticate('UpdateEnvironment', $opt);
}";s:8:"examples";a:1:{s:7:"example";a:3:{s:5:"title";s:29:"<p>Update an environment.</p>";s:4:"code";s:713:"sleep(5);

// Instantiate the class
$bean = new AmazonElasticBeanstalk();

$response = $bean-&gt;update_environment(array(
	'EnvironmentName' =&gt; 'my-environment',
	'Description' =&gt; 'This is an updated environment description.',
	'OptionSettings' =&gt; array(
		array(
			'Namespace' =&gt; 'aws:elasticbeanstalk:sns:topics',
			'OptionName' =&gt; 'Notification Protocol',
			'Value' =&gt; 'sqs'
		),
		array(
			'Namespace' =&gt; 'aws:autoscaling:trigger',
			'OptionName' =&gt; 'MeasureName',
			'Value' =&gt; 'CPUUtilization'
		)
	),
	'OptionsToRemove' =&gt; array(
		array(
			'Namespace' =&gt; 'aws:autoscaling:asg',
			'OptionName' =&gt; 'MinSize'
		)
	)
));

// Success?
var_dump($response-&gt;isOK());";s:6:"result";s:10:"bool(true)";}}s:7:"related";a:1:{s:6:"method";a:8:{i:0;s:164:"<a href="../amazonelasticbeanstalk/create_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/create_environment"><code>create_environment()</code></a>";i:1;s:200:"<a href="../amazonelasticbeanstalk/describe_environment_resources.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environment_resources"><code>describe_environment_resources()</code></a>";i:2;s:173:"<a href="../amazonelasticbeanstalk/describe_environments.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_environments"><code>describe_environments()</code></a>";i:3;s:167:"<a href="../amazonelasticbeanstalk/rebuild_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/rebuild_environment"><code>rebuild_environment()</code></a>";i:4;s:182:"<a href="../amazonelasticbeanstalk/request_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/request_environment_info"><code>request_environment_info()</code></a>";i:5;s:164:"<a href="../amazonelasticbeanstalk/restart_app_server.html" rel="../../index.html#m=amazonelasticbeanstalk/restart_app_server"><code>restart_app_server()</code></a>";i:6;s:185:"<a href="../amazonelasticbeanstalk/retrieve_environment_info.html" rel="../../index.html#m=amazonelasticbeanstalk/retrieve_environment_info"><code>retrieve_environment_info()</code></a>";i:7;s:173:"<a href="../amazonelasticbeanstalk/terminate_environment.html" rel="../../index.html#m=amazonelasticbeanstalk/terminate_environment"><code>terminate_environment()</code></a>";}}}i:54;a:7:{s:4:"name";s:31:"validate_configuration_settings";s:8:"modifier";s:6:"public";s:11:"description";s:272:"<p>Takes a set of configuration settings and either a configuration template or environment, and
determines whether those values are valid.</p>

<p>This action returns a list of messages indicating any errors or warnings associated with the
selection of option values.</p>";s:10:"parameters";a:1:{s:9:"parameter";a:3:{i:0;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:16:"application_name";s:4:"type";s:6:"string";s:11:"description";s:93:"<p>The name of the application that the configuration template or environment belongs to.</p>";}i:1;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"req";}s:4:"name";s:15:"option_settings";s:4:"type";s:5:"array";s:11:"description";s:532:"<p>A list of the options and desired values to evaluate.</p>

<ul><li><code>x</code> - <code>array</code> - Optional - This represents a simple array index. <ul><li><code>Namespace</code> - <code>string</code> - Optional - A unique namespace identifying the option&#8217;s associated AWS resource.</li><li><code>OptionName</code> - <code>string</code> - Optional - The name of the configuration option.</li><li><code>Value</code> - <code>string</code> - Optional - The current value for the configuration option.</li></ul></li></ul>";}i:2;a:4:{s:11:"@attributes";a:1:{s:6:"choice";s:3:"opt";}s:4:"name";s:3:"opt";s:4:"type";s:5:"array";s:11:"description";s:935:"<p>An associative array of parameters that can have the following keys:</p>

<ul><li><code>TemplateName</code> - <code>string</code> - Optional - The name of the configuration template to validate the settings against. Condition: You cannot specify both this and an environment name.</li><li><code>EnvironmentName</code> - <code>string</code> - Optional - The name of the environment to validate the settings against. Condition: You cannot specify both this and a configuration template name.</li><li><code>curlopts</code> - <code>array</code> - Optional - A set of values to pass directly into <code>curl_setopt()</code>, where the key is a pre-defined <code>CURLOPT_*</code> constant.</li><li><code>returnCurlHandle</code> - <code>boolean</code> - Optional - A private toggle specifying that the cURL handle be returned rather than actually completing the request. This toggle is useful for manually managed batch requests.</li></ul>";}}}s:11:"returnvalue";s:149:"<p>A <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a> object containing a parsed HTTP response.</p>";s:6:"source";s:467:"public function validate_configuration_settings($application_name, $option_settings, $opt = null)
{
    if (!$opt) $opt = array();
    $opt['ApplicationName'] = $application_name;
    
    // Required list + map
    $opt = array_merge($opt, CFComplexType::map(array(
        'OptionSettings' =&gt; (is_array($option_settings) ? $option_settings : array($option_settings))
    ), 'member'));

    return $this-&gt;authenticate('ValidateConfigurationSettings', $opt);
}";s:7:"related";a:1:{s:6:"method";a:6:{i:0;s:176:"<a href="../amazonelasticbeanstalk/check_dns_availability.html" rel="../../index.html#m=amazonelasticbeanstalk/check_dns_availability"><code>check_dns_availability()</code></a>";i:1;s:179:"<a href="../amazonelasticbeanstalk/create_storage_location.html" rel="../../index.html#m=amazonelasticbeanstalk/create_storage_location"><code>create_storage_location()</code></a>";i:2;s:206:"<a href="../amazonelasticbeanstalk/delete_environment_configuration.html" rel="../../index.html#m=amazonelasticbeanstalk/delete_environment_configuration"><code>delete_environment_configuration()</code></a>";i:3;s:200:"<a href="../amazonelasticbeanstalk/describe_configuration_options.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_options"><code>describe_configuration_options()</code></a>";i:4;s:203:"<a href="../amazonelasticbeanstalk/describe_configuration_settings.html" rel="../../index.html#m=amazonelasticbeanstalk/describe_configuration_settings"><code>describe_configuration_settings()</code></a>";i:5;s:200:"<a href="../amazonelasticbeanstalk/list_available_solution_stacks.html" rel="../../index.html#m=amazonelasticbeanstalk/list_available_solution_stacks"><code>list_available_solution_stacks()</code></a>";}}}}}s:9:"constants";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"21";}s:8:"constant";a:21:{i:0;a:2:{s:4:"name";s:5:"BUILD";s:5:"value";s:14:"20130314130000";}i:1;a:2:{s:4:"name";s:11:"DEFAULT_URL";s:5:"value";s:40:"elasticbeanstalk.us-east-1.amazonaws.com";}i:2;a:2:{s:4:"name";s:4:"NAME";s:5:"value";s:11:"aws-sdk-php";}i:3;a:2:{s:4:"name";s:15:"REGION_APAC_NE1";s:5:"value";s:45:"elasticbeanstalk.ap-northeast-1.amazonaws.com";}i:4;a:2:{s:4:"name";s:15:"REGION_APAC_SE1";s:5:"value";s:45:"elasticbeanstalk.ap-southeast-1.amazonaws.com";}i:5;a:2:{s:4:"name";s:15:"REGION_APAC_SE2";s:5:"value";s:45:"elasticbeanstalk.ap-southeast-2.amazonaws.com";}i:6;a:2:{s:4:"name";s:17:"REGION_CALIFORNIA";s:5:"value";s:40:"elasticbeanstalk.us-west-1.amazonaws.com";}i:7;a:2:{s:4:"name";s:12:"REGION_EU_W1";s:5:"value";s:40:"elasticbeanstalk.eu-west-1.amazonaws.com";}i:8;a:2:{s:4:"name";s:14:"REGION_IRELAND";s:5:"value";s:40:"elasticbeanstalk.eu-west-1.amazonaws.com";}i:9;a:2:{s:4:"name";s:13:"REGION_OREGON";s:5:"value";s:40:"elasticbeanstalk.us-west-2.amazonaws.com";}i:10;a:2:{s:4:"name";s:16:"REGION_SAO_PAULO";s:5:"value";s:40:"elasticbeanstalk.sa-east-1.amazonaws.com";}i:11;a:2:{s:4:"name";s:12:"REGION_SA_E1";s:5:"value";s:40:"elasticbeanstalk.sa-east-1.amazonaws.com";}i:12;a:2:{s:4:"name";s:16:"REGION_SINGAPORE";s:5:"value";s:45:"elasticbeanstalk.ap-southeast-1.amazonaws.com";}i:13;a:2:{s:4:"name";s:13:"REGION_SYDNEY";s:5:"value";s:45:"elasticbeanstalk.ap-southeast-2.amazonaws.com";}i:14;a:2:{s:4:"name";s:12:"REGION_TOKYO";s:5:"value";s:45:"elasticbeanstalk.ap-northeast-1.amazonaws.com";}i:15;a:2:{s:4:"name";s:12:"REGION_US_E1";s:5:"value";s:40:"elasticbeanstalk.us-east-1.amazonaws.com";}i:16;a:2:{s:4:"name";s:12:"REGION_US_W1";s:5:"value";s:40:"elasticbeanstalk.us-west-1.amazonaws.com";}i:17;a:2:{s:4:"name";s:12:"REGION_US_W2";s:5:"value";s:40:"elasticbeanstalk.us-west-2.amazonaws.com";}i:18;a:2:{s:4:"name";s:15:"REGION_VIRGINIA";s:5:"value";s:40:"elasticbeanstalk.us-east-1.amazonaws.com";}i:19;a:2:{s:4:"name";s:9:"USERAGENT";s:5:"value";s:65:"aws-sdk-php/1.6.2 PHP/5.4.9 curl/7.15.5 openssl/0.9.8e-fips-rhel5";}i:20;a:2:{s:4:"name";s:7:"VERSION";s:5:"value";s:5:"1.6.2";}}}s:10:"properties";a:2:{s:11:"@attributes";a:1:{s:5:"count";s:2:"40";}s:8:"property";a:40:{i:0;a:4:{s:4:"name";s:11:"api_version";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The supported API version.</p>";}i:1;a:4:{s:4:"name";s:10:"auth_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The authentication class to use.</p>";}i:2;a:4:{s:4:"name";s:10:"auth_token";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The Amazon Authentication Token.</p>";}i:3;a:5:{s:4:"name";s:11:"batch_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:14:"CFBatchRequest";}}s:11:"description";s:185:"<p>The default class to use for handling batch requests (defaults to <a href="../cfbatchrequest/index.html" rel="../../index.html#i=cfbatchrequest"><code>CFBatchRequest</code></a>).</p>";}i:4;a:4:{s:4:"name";s:12:"batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:53:"<p>The current instantiated batch request object.</p>";}i:5;a:4:{s:4:"name";s:11:"cache_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The caching class to use.</p>";}i:6;a:4:{s:4:"name";s:14:"cache_compress";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:38:"<p>The state of cache compression.</p>";}i:7;a:4:{s:4:"name";s:13:"cache_expires";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>When the cache should be considered stale.</p>";}i:8;a:4:{s:4:"name";s:14:"cache_location";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:35:"<p>The caching location to use.</p>";}i:9;a:4:{s:4:"name";s:12:"cache_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The current instantiated cache object.</p>";}i:10;a:4:{s:4:"name";s:11:"credentials";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>The credentials to use for authentication.</p>";}i:11;a:4:{s:4:"name";s:10:"debug_mode";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:43:"<p>The state of the debug mode setting.</p>";}i:12;a:4:{s:4:"name";s:12:"delete_cache";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:47:"<p>The state of the cache deletion setting.</p>";}i:13;a:4:{s:4:"name";s:8:"hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:45:"<p>The alternate hostname to use, if any.</p>";}i:14;a:4:{s:4:"name";s:21:"internal_batch_object";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:56:"<p>The internally instantiated batch request object.</p>";}i:15;a:4:{s:4:"name";s:3:"key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:26:"<p>The Amazon API Key.</p>";}i:16;a:5:{s:4:"name";s:11:"max_retries";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"integer";s:5:"value";s:1:"3";}}s:11:"description";s:52:"<p>The number of times to retry failed requests.</p>";}i:17;a:4:{s:4:"name";s:9:"operation";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:32:"<p>The operation to execute.</p>";}i:18;a:4:{s:4:"name";s:16:"operation_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:58:"<p>The string prefix to prepend to the operation name.</p>";}i:19;a:5:{s:4:"name";s:17:"override_hostname";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:212:"<p>The state of the capability to override the hostname with <a href="../amazonelasticbeanstalk/set_hostname.html" rel="../../index.html#m=amazonelasticbeanstalk/set_hostname"><code>set_hostname()</code></a>.</p>";}i:20;a:5:{s:4:"name";s:18:"parse_the_response";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:65:"<p>The state of whether the response should be parsed or not.</p>";}i:21;a:5:{s:4:"name";s:12:"parser_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFSimpleXML";}}s:11:"description";s:164:"<p>The default class to use for parsing XML (defaults to <a href="../cfsimplexml/index.html" rel="../../index.html#i=cfsimplexml"><code>CFSimpleXML</code></a>).</p>";}i:22;a:4:{s:4:"name";s:7:"payload";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:27:"<p>The payload to send.</p>";}i:23;a:4:{s:4:"name";s:11:"port_number";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:48:"<p>The alternate port number to use, if any.</p>";}i:24;a:4:{s:4:"name";s:5:"proxy";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:39:"<p>The proxy to use for connecting.</p>";}i:25;a:4:{s:4:"name";s:9:"redirects";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:54:"<p>The number of times a request has been retried.</p>";}i:26;a:4:{s:4:"name";s:34:"registered_streaming_read_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:77:"<p>The user-defined callback function to call when a stream is read from.</p>";}i:27;a:4:{s:4:"name";s:35:"registered_streaming_write_callback";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:78:"<p>The user-defined callback function to call when a stream is written to.</p>";}i:28;a:5:{s:4:"name";s:13:"request_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:9:"CFRequest";}}s:11:"description";s:160:"<p>The default class to use for HTTP requests (defaults to <a href="../cfrequest/index.html" rel="../../index.html#i=cfrequest"><code>CFRequest</code></a>).</p>";}i:29;a:4:{s:4:"name";s:15:"resource_prefix";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:52:"<p>The alternate resource prefix to use, if any.</p>";}i:30;a:5:{s:4:"name";s:14:"response_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:10:"CFResponse";}}s:11:"description";s:164:"<p>The default class to use for HTTP responses (defaults to <a href="../cfresponse/index.html" rel="../../index.html#i=cfresponse"><code>CFResponse</code></a>).</p>";}i:31;a:4:{s:4:"name";s:10:"secret_key";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:33:"<p>The Amazon API Secret Key.</p>";}i:32;a:4:{s:4:"name";s:7:"service";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:49:"<p>An identifier for the current AWS service.</p>";}i:33;a:5:{s:4:"name";s:16:"ssl_verification";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:49:"<p>The state of SSL certificate verification.</p>";}i:34;a:5:{s:4:"name";s:13:"use_aws_query";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:64:"<p>The state of whether auth should be handled as AWS Query.</p>";}i:35;a:4:{s:4:"name";s:14:"use_batch_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of batch flow usage.</p>";}i:36;a:4:{s:4:"name";s:14:"use_cache_flow";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:37:"<p>The state of cache flow usage.</p>";}i:37;a:5:{s:4:"name";s:7:"use_ssl";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:7:"boolean";s:5:"value";s:4:"true";}}s:11:"description";s:34:"<p>The state of SSL/HTTPS use.</p>";}i:38;a:4:{s:4:"name";s:4:"util";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"description";s:40:"<p>Handle for the utility functions.</p>";}i:39;a:5:{s:4:"name";s:15:"utilities_class";s:11:"inheritance";a:1:{s:5:"class";a:2:{s:4:"name";s:9:"CFRuntime";s:4:"file";s:13:"sdk.class.php";}}s:8:"modifier";s:6:"public";s:11:"initializer";a:1:{s:11:"@attributes";a:2:{s:4:"type";s:6:"string";s:5:"value";s:11:"CFUtilities";}}s:11:"description";s:162:"<p>The default class to use for utilities (defaults to <a href="../cfutilities/index.html" rel="../../index.html#i=cfutilities"><code>CFUtilities</code></a>).</p>";}}}}}